/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A summary of the recommendation.
 *
 */
class ShortDescription {
  /**
   * Create a ShortDescription.
   * @member {string} [problem] The issue or opportunity identified by the
   * recommendation.
   * @member {string} [solution] The remediation action suggested by the
   * recommendation.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ShortDescription
   *
   * @returns {object} metadata of ShortDescription
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ShortDescription',
      type: {
        name: 'Composite',
        className: 'ShortDescription',
        modelProperties: {
          problem: {
            required: false,
            serializedName: 'problem',
            type: {
              name: 'String'
            }
          },
          solution: {
            required: false,
            serializedName: 'solution',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ShortDescription;
