/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Status of gateway is error.
 *
 */
class GatewayListStatusError {
  /**
   * Create a GatewayListStatusError.
   * @member {object} [error] Error of the list gateway status.
   * @member {string} [error.code] Error code of list gateway.
   * @member {string} [error.message] Error message of list gateway.
   */
  constructor() {
  }

  /**
   * Defines the metadata of GatewayListStatusError
   *
   * @returns {object} metadata of GatewayListStatusError
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GatewayListStatusError',
      type: {
        name: 'Composite',
        className: 'GatewayListStatusError',
        modelProperties: {
          error: {
            required: false,
            serializedName: 'error',
            type: {
              name: 'Composite',
              className: 'GatewayError'
            }
          }
        }
      }
    };
  }
}

module.exports = GatewayListStatusError;
