/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents the SKU name and Azure pricing tier for Analysis Services
 * resource.
 *
 */
class ResourceSku {
  /**
   * Create a ResourceSku.
   * @member {string} name Name of the SKU level.
   * @member {string} [tier] The name of the Azure pricing tier to which the
   * SKU applies. Possible values include: 'Development', 'Basic', 'Standard'
   * @member {number} [capacity] The number of instances in the read only query
   * pool. Default value: 1 .
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResourceSku
   *
   * @returns {object} metadata of ResourceSku
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceSku',
      type: {
        name: 'Composite',
        className: 'ResourceSku',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          tier: {
            required: false,
            serializedName: 'tier',
            type: {
              name: 'String'
            }
          },
          capacity: {
            required: false,
            serializedName: 'capacity',
            defaultValue: 1,
            constraints: {
              InclusiveMaximum: 8,
              InclusiveMinimum: 1
            },
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceSku;
