/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * An object that represents enumerating SKUs for new resources.
 *
 */
class SkuEnumerationForNewResourceResult {
  /**
   * Create a SkuEnumerationForNewResourceResult.
   * @member {array} [value] The collection of available SKUs for new
   * resources.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SkuEnumerationForNewResourceResult
   *
   * @returns {object} metadata of SkuEnumerationForNewResourceResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SkuEnumerationForNewResourceResult',
      type: {
        name: 'Composite',
        className: 'SkuEnumerationForNewResourceResult',
        modelProperties: {
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ResourceSkuElementType',
                  type: {
                    name: 'Composite',
                    className: 'ResourceSku'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = SkuEnumerationForNewResourceResult;
