/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Parameters supplied to the Backup/Restore of an API Management service
 * operation.
 *
 */
class ApiManagementServiceBackupRestoreParameters {
  /**
   * Create a ApiManagementServiceBackupRestoreParameters.
   * @member {string} storageAccount Azure Cloud Storage account (used to
   * place/retrieve the backup) name.
   * @member {string} accessKey Azure Cloud Storage account (used to
   * place/retrieve the backup) access key.
   * @member {string} containerName Azure Cloud Storage blob container name
   * used to place/retrieve the backup.
   * @member {string} backupName The name of the backup file to create.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApiManagementServiceBackupRestoreParameters
   *
   * @returns {object} metadata of ApiManagementServiceBackupRestoreParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApiManagementServiceBackupRestoreParameters',
      type: {
        name: 'Composite',
        className: 'ApiManagementServiceBackupRestoreParameters',
        modelProperties: {
          storageAccount: {
            required: true,
            serializedName: 'storageAccount',
            type: {
              name: 'String'
            }
          },
          accessKey: {
            required: true,
            serializedName: 'accessKey',
            type: {
              name: 'String'
            }
          },
          containerName: {
            required: true,
            serializedName: 'containerName',
            type: {
              name: 'String'
            }
          },
          backupName: {
            required: true,
            serializedName: 'backupName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ApiManagementServiceBackupRestoreParameters;
