/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Authorization header information.
 *
 */
class BackendAuthorizationHeaderCredentials {
  /**
   * Create a BackendAuthorizationHeaderCredentials.
   * @member {string} scheme Authentication Scheme name.
   * @member {string} parameter Authentication Parameter value.
   */
  constructor() {
  }

  /**
   * Defines the metadata of BackendAuthorizationHeaderCredentials
   *
   * @returns {object} metadata of BackendAuthorizationHeaderCredentials
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BackendAuthorizationHeaderCredentials',
      type: {
        name: 'Composite',
        className: 'BackendAuthorizationHeaderCredentials',
        modelProperties: {
          scheme: {
            required: true,
            serializedName: 'scheme',
            constraints: {
              MaxLength: 100,
              MinLength: 1
            },
            type: {
              name: 'String'
            }
          },
          parameter: {
            required: true,
            serializedName: 'parameter',
            constraints: {
              MaxLength: 300,
              MinLength: 1
            },
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = BackendAuthorizationHeaderCredentials;
