/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Certificate configuration which consist of non-trusted intermediates and
 * root certificates.
 *
 */
class CertificateConfiguration {
  /**
   * Create a CertificateConfiguration.
   * @member {string} [encodedCertificate] Base64 Encoded certificate.
   * @member {string} [certificatePassword] Certificate Password.
   * @member {string} storeName The local certificate store location. Only Root
   * and CertificateAuthority are valid locations. Possible values include:
   * 'CertificateAuthority', 'Root'
   * @member {object} [certificate] Certificate information.
   * @member {date} [certificate.expiry] Expiration date of the certificate.
   * The date conforms to the following format: `yyyy-MM-ddTHH:mm:ssZ` as
   * specified by the ISO 8601 standard.
   * @member {string} [certificate.thumbprint] Thumbprint of the certificate.
   * @member {string} [certificate.subject] Subject of the certificate.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CertificateConfiguration
   *
   * @returns {object} metadata of CertificateConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CertificateConfiguration',
      type: {
        name: 'Composite',
        className: 'CertificateConfiguration',
        modelProperties: {
          encodedCertificate: {
            required: false,
            serializedName: 'encodedCertificate',
            type: {
              name: 'String'
            }
          },
          certificatePassword: {
            required: false,
            serializedName: 'certificatePassword',
            type: {
              name: 'String'
            }
          },
          storeName: {
            required: true,
            serializedName: 'storeName',
            type: {
              name: 'String'
            }
          },
          certificate: {
            required: false,
            readOnly: true,
            serializedName: 'certificate',
            type: {
              name: 'Composite',
              className: 'CertificateInformation'
            }
          }
        }
      }
    };
  }
}

module.exports = CertificateConfiguration;
