/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Parameters supplied to the Deploy Configuration operation.
 *
 */
class DeployConfigurationParameters {
  /**
   * Create a DeployConfigurationParameters.
   * @member {string} branch The name of the Git branch from which the
   * configuration is to be deployed to the configuration database.
   * @member {boolean} [force] The value enforcing deleting subscriptions to
   * products that are deleted in this update.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DeployConfigurationParameters
   *
   * @returns {object} metadata of DeployConfigurationParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DeployConfigurationParameters',
      type: {
        name: 'Composite',
        className: 'DeployConfigurationParameters',
        modelProperties: {
          branch: {
            required: true,
            serializedName: 'branch',
            type: {
              name: 'String'
            }
          },
          force: {
            required: false,
            serializedName: 'force',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = DeployConfigurationParameters;
