/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Email Template details.
 *
 * @extends models['Resource']
 */
class EmailTemplateContract extends models['Resource'] {
  /**
   * Create a EmailTemplateContract.
   * @member {string} subject Subject of the Template.
   * @member {string} body Email Template Body. This should be a valid
   * XDocument
   * @member {string} [title] Title of the Template.
   * @member {string} [description] Description of the Email Template.
   * @member {boolean} [isDefault] Whether the template is the default template
   * provided by Api Management or has been edited.
   * @member {array} [parameters] Email Template Parameter values.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of EmailTemplateContract
   *
   * @returns {object} metadata of EmailTemplateContract
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EmailTemplateContract',
      type: {
        name: 'Composite',
        className: 'EmailTemplateContract',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          subject: {
            required: true,
            serializedName: 'properties.subject',
            constraints: {
              MaxLength: 1000,
              MinLength: 1
            },
            type: {
              name: 'String'
            }
          },
          body: {
            required: true,
            serializedName: 'properties.body',
            constraints: {
              MinLength: 1
            },
            type: {
              name: 'String'
            }
          },
          title: {
            required: false,
            serializedName: 'properties.title',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'properties.description',
            type: {
              name: 'String'
            }
          },
          isDefault: {
            required: false,
            readOnly: true,
            serializedName: 'properties.isDefault',
            type: {
              name: 'Boolean'
            }
          },
          parameters: {
            required: false,
            serializedName: 'properties.parameters',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'EmailTemplateParametersContractPropertiesElementType',
                  type: {
                    name: 'Composite',
                    className: 'EmailTemplateParametersContractProperties'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = EmailTemplateContract;
