/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Paged Logger list representation.
 */
class LoggerCollection extends Array {
  /**
   * Create a LoggerCollection.
   * @member {number} [count] Total record count number across all pages.
   * @member {string} [nextLink] Next page link if any.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of LoggerCollection
   *
   * @returns {object} metadata of LoggerCollection
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LoggerCollection',
      type: {
        name: 'Composite',
        className: 'LoggerCollection',
        modelProperties: {
          value: {
            required: false,
            serializedName: '',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'LoggerContractElementType',
                  type: {
                    name: 'Composite',
                    className: 'LoggerContract'
                  }
              }
            }
          },
          count: {
            required: false,
            serializedName: 'count',
            type: {
              name: 'Number'
            }
          },
          nextLink: {
            required: false,
            serializedName: 'nextLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = LoggerCollection;
