/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Network Status details.
 *
 */
class NetworkStatusContract {
  /**
   * Create a NetworkStatusContract.
   * @member {array} dnsServers Gets the list of DNS servers IPV4 addresses.
   * @member {array} connectivityStatus Gets the list of Connectivity Status to
   * the Resources on which the service depends upon.
   */
  constructor() {
  }

  /**
   * Defines the metadata of NetworkStatusContract
   *
   * @returns {object} metadata of NetworkStatusContract
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NetworkStatusContract',
      type: {
        name: 'Composite',
        className: 'NetworkStatusContract',
        modelProperties: {
          dnsServers: {
            required: true,
            serializedName: 'dnsServers',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          connectivityStatus: {
            required: true,
            serializedName: 'connectivityStatus',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ConnectivityStatusContractElementType',
                  type: {
                    name: 'Composite',
                    className: 'ConnectivityStatusContract'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = NetworkStatusContract;
