/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Api Operation Entity Base Contract details.
 *
 */
class OperationEntityBaseContract {
  /**
   * Create a OperationEntityBaseContract.
   * @member {array} [templateParameters] Collection of URL template
   * parameters.
   * @member {string} [description] Description of the operation. May include
   * HTML formatting tags.
   * @member {object} [request] An entity containing request details.
   * @member {string} [request.description] Operation request description.
   * @member {array} [request.queryParameters] Collection of operation request
   * query parameters.
   * @member {array} [request.headers] Collection of operation request headers.
   * @member {array} [request.representations] Collection of operation request
   * representations.
   * @member {array} [responses] Array of Operation responses.
   * @member {string} [policies] Operation Policies
   */
  constructor() {
  }

  /**
   * Defines the metadata of OperationEntityBaseContract
   *
   * @returns {object} metadata of OperationEntityBaseContract
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OperationEntityBaseContract',
      type: {
        name: 'Composite',
        className: 'OperationEntityBaseContract',
        modelProperties: {
          templateParameters: {
            required: false,
            serializedName: 'templateParameters',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ParameterContractElementType',
                  type: {
                    name: 'Composite',
                    className: 'ParameterContract'
                  }
              }
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            constraints: {
              MaxLength: 1000
            },
            type: {
              name: 'String'
            }
          },
          request: {
            required: false,
            serializedName: 'request',
            type: {
              name: 'Composite',
              className: 'RequestContract'
            }
          },
          responses: {
            required: false,
            serializedName: 'responses',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ResponseContractElementType',
                  type: {
                    name: 'Composite',
                    className: 'ResponseContract'
                  }
              }
            }
          },
          policies: {
            required: false,
            serializedName: 'policies',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = OperationEntityBaseContract;
