/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Operation parameters details.
 *
 */
class ParameterContract {
  /**
   * Create a ParameterContract.
   * @member {string} name Parameter name.
   * @member {string} [description] Parameter description.
   * @member {string} type Parameter type.
   * @member {string} [defaultValue] Default parameter value.
   * @member {boolean} [required] whether parameter is required or not.
   * @member {array} [values] Parameter values.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ParameterContract
   *
   * @returns {object} metadata of ParameterContract
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ParameterContract',
      type: {
        name: 'Composite',
        className: 'ParameterContract',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          defaultValue: {
            required: false,
            serializedName: 'defaultValue',
            type: {
              name: 'String'
            }
          },
          required: {
            required: false,
            serializedName: 'required',
            type: {
              name: 'Boolean'
            }
          },
          values: {
            required: false,
            serializedName: 'values',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ParameterContract;
