/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Sign-In settings for the Developer Portal.
 *
 * @extends models['Resource']
 */
class PortalSigninSettings extends models['Resource'] {
  /**
   * Create a PortalSigninSettings.
   * @member {boolean} [enabled] Redirect Anonymous users to the Sign-In page.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of PortalSigninSettings
   *
   * @returns {object} metadata of PortalSigninSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PortalSigninSettings',
      type: {
        name: 'Composite',
        className: 'PortalSigninSettings',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          enabled: {
            required: false,
            serializedName: 'properties.enabled',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = PortalSigninSettings;
