/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Operation response details.
 *
 */
class ResponseContract {
  /**
   * Create a ResponseContract.
   * @member {number} statusCode Operation response HTTP status code.
   * @member {string} [description] Operation response description.
   * @member {array} [representations] Collection of operation response
   * representations.
   * @member {array} [headers] Collection of operation response headers.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResponseContract
   *
   * @returns {object} metadata of ResponseContract
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResponseContract',
      type: {
        name: 'Composite',
        className: 'ResponseContract',
        modelProperties: {
          statusCode: {
            required: true,
            serializedName: 'statusCode',
            type: {
              name: 'Number'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          representations: {
            required: false,
            serializedName: 'representations',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'RepresentationContractElementType',
                  type: {
                    name: 'Composite',
                    className: 'RepresentationContract'
                  }
              }
            }
          },
          headers: {
            required: false,
            serializedName: 'headers',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ParameterContractElementType',
                  type: {
                    name: 'Composite',
                    className: 'ParameterContract'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ResponseContract;
