/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * List of Users Identity list representation.
 *
 */
class UserIdentityCollection {
  /**
   * Create a UserIdentityCollection.
   * @member {array} [value] User Identity values.
   * @member {number} [count] Total record count number across all pages.
   * @member {string} [nextLink] Next page link if any.
   */
  constructor() {
  }

  /**
   * Defines the metadata of UserIdentityCollection
   *
   * @returns {object} metadata of UserIdentityCollection
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UserIdentityCollection',
      type: {
        name: 'Composite',
        className: 'UserIdentityCollection',
        modelProperties: {
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'UserIdentityContractElementType',
                  type: {
                    name: 'Composite',
                    className: 'UserIdentityContract'
                  }
              }
            }
          },
          count: {
            required: false,
            serializedName: 'count',
            type: {
              name: 'Number'
            }
          },
          nextLink: {
            required: false,
            serializedName: 'nextLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = UserIdentityCollection;
