/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Provider Operations metadata
 *
 */
class ProviderOperationsMetadata {
  /**
   * Create a ProviderOperationsMetadata.
   * @member {string} [id] The provider id.
   * @member {string} [name] The provider name.
   * @member {string} [type] The provider type.
   * @member {string} [displayName] The provider display name.
   * @member {array} [resourceTypes] The provider resource types
   * @member {array} [operations] The provider operations.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ProviderOperationsMetadata
   *
   * @returns {object} metadata of ProviderOperationsMetadata
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ProviderOperationsMetadata',
      type: {
        name: 'Composite',
        className: 'ProviderOperationsMetadata',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            serializedName: 'displayName',
            type: {
              name: 'String'
            }
          },
          resourceTypes: {
            required: false,
            serializedName: 'resourceTypes',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ResourceTypeElementType',
                  type: {
                    name: 'Composite',
                    className: 'ResourceType'
                  }
              }
            }
          },
          operations: {
            required: false,
            serializedName: 'operations',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ProviderOperationElementType',
                  type: {
                    name: 'Composite',
                    className: 'ProviderOperation'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ProviderOperationsMetadata;
