/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Resource Type
 *
 */
class ResourceType {
  /**
   * Create a ResourceType.
   * @member {string} [name] The resource type name.
   * @member {string} [displayName] The resource type display name.
   * @member {array} [operations] The resource type operations.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResourceType
   *
   * @returns {object} metadata of ResourceType
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceType',
      type: {
        name: 'Composite',
        className: 'ResourceType',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            serializedName: 'displayName',
            type: {
              name: 'String'
            }
          },
          operations: {
            required: false,
            serializedName: 'operations',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ProviderOperationElementType',
                  type: {
                    name: 'Composite',
                    className: 'ProviderOperation'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceType;
