/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Role Assignments
 *
 */
class RoleAssignment {
  /**
   * Create a RoleAssignment.
   * @member {string} [id] The role assignment ID.
   * @member {string} [name] The role assignment name.
   * @member {string} [type] The role assignment type.
   * @member {object} [properties] Role assignment properties.
   * @member {string} [properties.scope] The role assignment scope.
   * @member {string} [properties.roleDefinitionId] The role definition ID.
   * @member {string} [properties.principalId] The principal ID.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RoleAssignment
   *
   * @returns {object} metadata of RoleAssignment
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RoleAssignment',
      type: {
        name: 'Composite',
        className: 'RoleAssignment',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'RoleAssignmentPropertiesWithScope'
            }
          }
        }
      }
    };
  }
}

module.exports = RoleAssignment;
