/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Definition of the activity parameter set.
 *
 */
class ActivityParameterSet {
  /**
   * Create a ActivityParameterSet.
   * @member {string} [name] Gets or sets the name of the activity parameter
   * set.
   * @member {array} [parameters] Gets or sets the parameters of the activity
   * parameter set.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ActivityParameterSet
   *
   * @returns {object} metadata of ActivityParameterSet
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ActivityParameterSet',
      type: {
        name: 'Composite',
        className: 'ActivityParameterSet',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          parameters: {
            required: false,
            serializedName: 'parameters',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ActivityParameterElementType',
                  type: {
                    name: 'Composite',
                    className: 'ActivityParameter'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ActivityParameterSet;
