/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The parameters supplied to the update automation account operation.
 *
 */
class AutomationAccountUpdateParameters {
  /**
   * Create a AutomationAccountUpdateParameters.
   * @member {object} [sku] Gets or sets account SKU.
   * @member {string} [sku.name] Gets or sets the SKU name of the account.
   * Possible values include: 'Free', 'Basic'
   * @member {string} [sku.family] Gets or sets the SKU family.
   * @member {number} [sku.capacity] Gets or sets the SKU capacity.
   * @member {string} [name] Gets or sets the name of the resource.
   * @member {string} [location] Gets or sets the location of the resource.
   * @member {object} [tags] Gets or sets the tags attached to the resource.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AutomationAccountUpdateParameters
   *
   * @returns {object} metadata of AutomationAccountUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AutomationAccountUpdateParameters',
      type: {
        name: 'Composite',
        className: 'AutomationAccountUpdateParameters',
        modelProperties: {
          sku: {
            required: false,
            serializedName: 'properties.sku',
            type: {
              name: 'Composite',
              className: 'Sku'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = AutomationAccountUpdateParameters;
