/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Definition of the certificate.
 *
 */
class Certificate {
  /**
   * Create a Certificate.
   * @member {string} [id] Gets the id of the resource.
   * @member {string} [name] Gets the name of the certificate.
   * @member {string} [thumbprint] Gets the thumbprint of the certificate.
   * @member {date} [expiryTime] Gets the expiry time of the certificate.
   * @member {boolean} [isExportable] Gets the is exportable flag of the
   * certificate.
   * @member {date} [creationTime] Gets the creation time.
   * @member {date} [lastModifiedTime] Gets the last modified time.
   * @member {string} [description] Gets or sets the description.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Certificate
   *
   * @returns {object} metadata of Certificate
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Certificate',
      type: {
        name: 'Composite',
        className: 'Certificate',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          thumbprint: {
            required: false,
            readOnly: true,
            serializedName: 'properties.thumbprint',
            type: {
              name: 'String'
            }
          },
          expiryTime: {
            required: false,
            readOnly: true,
            serializedName: 'properties.expiryTime',
            type: {
              name: 'DateTime'
            }
          },
          isExportable: {
            required: false,
            readOnly: true,
            serializedName: 'properties.isExportable',
            type: {
              name: 'Boolean'
            }
          },
          creationTime: {
            required: false,
            readOnly: true,
            serializedName: 'properties.creationTime',
            type: {
              name: 'DateTime'
            }
          },
          lastModifiedTime: {
            required: false,
            readOnly: true,
            serializedName: 'properties.lastModifiedTime',
            type: {
              name: 'DateTime'
            }
          },
          description: {
            required: false,
            serializedName: 'properties.description',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Certificate;
