/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The parameters supplied to the create or update or replace certificate
 * operation.
 *
 */
class CertificateCreateOrUpdateParameters {
  /**
   * Create a CertificateCreateOrUpdateParameters.
   * @member {string} name Gets or sets the name of the certificate.
   * @member {string} base64Value Gets or sets the base64 encoded value of the
   * certificate.
   * @member {string} [description] Gets or sets the description of the
   * certificate.
   * @member {string} [thumbprint] Gets or sets the thumbprint of the
   * certificate.
   * @member {boolean} [isExportable] Gets or sets the is exportable flag of
   * the certificate.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CertificateCreateOrUpdateParameters
   *
   * @returns {object} metadata of CertificateCreateOrUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CertificateCreateOrUpdateParameters',
      type: {
        name: 'Composite',
        className: 'CertificateCreateOrUpdateParameters',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          base64Value: {
            required: true,
            serializedName: 'properties.base64Value',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'properties.description',
            type: {
              name: 'String'
            }
          },
          thumbprint: {
            required: false,
            serializedName: 'properties.thumbprint',
            type: {
              name: 'String'
            }
          },
          isExportable: {
            required: false,
            serializedName: 'properties.isExportable',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = CertificateCreateOrUpdateParameters;
