/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Definition of the content link.
 *
 */
class ContentLink {
  /**
   * Create a ContentLink.
   * @member {string} [uri] Gets or sets the uri of the runbook content.
   * @member {object} [contentHash] Gets or sets the hash.
   * @member {string} [contentHash.algorithm] Gets or sets the content hash
   * algorithm used to hash the content.
   * @member {string} [contentHash.value] Gets or sets expected hash value of
   * the content.
   * @member {string} [version] Gets or sets the version of the content.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ContentLink
   *
   * @returns {object} metadata of ContentLink
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContentLink',
      type: {
        name: 'Composite',
        className: 'ContentLink',
        modelProperties: {
          uri: {
            required: false,
            serializedName: 'uri',
            type: {
              name: 'String'
            }
          },
          contentHash: {
            required: false,
            serializedName: 'contentHash',
            type: {
              name: 'Composite',
              className: 'ContentHash'
            }
          },
          version: {
            required: false,
            serializedName: 'version',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ContentLink;
