/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Definition of the dsc node configuration.
 *
 */
class DscNodeConfiguration {
  /**
   * Create a DscNodeConfiguration.
   * @member {string} [name] Gets or sets the node configuration name.
   * @member {date} [lastModifiedTime] Gets or sets the last modified time.
   * @member {date} [creationTime] Gets or sets creation time.
   * @member {object} [configuration] Gets or sets the configuration of the
   * node.
   * @member {string} [configuration.name] Gets or sets the name of the Dsc
   * configuration.
   * @member {string} [id] Gets or sets the id of the resource.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DscNodeConfiguration
   *
   * @returns {object} metadata of DscNodeConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DscNodeConfiguration',
      type: {
        name: 'Composite',
        className: 'DscNodeConfiguration',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          lastModifiedTime: {
            required: false,
            serializedName: 'lastModifiedTime',
            type: {
              name: 'DateTime'
            }
          },
          creationTime: {
            required: false,
            serializedName: 'creationTime',
            type: {
              name: 'DateTime'
            }
          },
          configuration: {
            required: false,
            serializedName: 'configuration',
            type: {
              name: 'Composite',
              className: 'DscConfigurationAssociationProperty'
            }
          },
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DscNodeConfiguration;
