/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Definition of the DSC Report Resource.
 *
 */
class DscReportResource {
  /**
   * Create a DscReportResource.
   * @member {string} [resourceId] Gets or sets the ID of the resource.
   * @member {string} [sourceInfo] Gets or sets the source info of the
   * resource.
   * @member {array} [dependsOn] Gets or sets the Resource Navigation values
   * for resources the resource depends on.
   * @member {string} [moduleName] Gets or sets the module name of the
   * resource.
   * @member {string} [moduleVersion] Gets or sets the module version of the
   * resource.
   * @member {string} [resourceName] Gets or sets the name of the resource.
   * @member {string} [error] Gets or sets the error of the resource.
   * @member {string} [status] Gets or sets the status of the resource.
   * @member {number} [durationInSeconds] Gets or sets the duration in seconds
   * for the resource.
   * @member {date} [startDate] Gets or sets the start date of the resource.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DscReportResource
   *
   * @returns {object} metadata of DscReportResource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DscReportResource',
      type: {
        name: 'Composite',
        className: 'DscReportResource',
        modelProperties: {
          resourceId: {
            required: false,
            serializedName: 'resourceId',
            type: {
              name: 'String'
            }
          },
          sourceInfo: {
            required: false,
            serializedName: 'sourceInfo',
            type: {
              name: 'String'
            }
          },
          dependsOn: {
            required: false,
            serializedName: 'dependsOn',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'DscReportResourceNavigationElementType',
                  type: {
                    name: 'Composite',
                    className: 'DscReportResourceNavigation'
                  }
              }
            }
          },
          moduleName: {
            required: false,
            serializedName: 'moduleName',
            type: {
              name: 'String'
            }
          },
          moduleVersion: {
            required: false,
            serializedName: 'moduleVersion',
            type: {
              name: 'String'
            }
          },
          resourceName: {
            required: false,
            serializedName: 'resourceName',
            type: {
              name: 'String'
            }
          },
          error: {
            required: false,
            serializedName: 'error',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          },
          durationInSeconds: {
            required: false,
            serializedName: 'durationInSeconds',
            type: {
              name: 'Number'
            }
          },
          startDate: {
            required: false,
            serializedName: 'startDate',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = DscReportResource;
