/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Definition of hybrid runbook worker group.
 *
 */
class HybridRunbookWorkerGroup {
  /**
   * Create a HybridRunbookWorkerGroup.
   * @member {string} [id] Gets or sets the id of the resource.
   * @member {string} [name] Gets or sets the name of the group.
   * @member {array} [hybridRunbookWorkers] Gets or sets the list of hybrid
   * runbook workers.
   * @member {object} [credential] Sets the credential of a worker group.
   * @member {string} [credential.name] Gets or sets the name of the
   * credential.
   */
  constructor() {
  }

  /**
   * Defines the metadata of HybridRunbookWorkerGroup
   *
   * @returns {object} metadata of HybridRunbookWorkerGroup
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HybridRunbookWorkerGroup',
      type: {
        name: 'Composite',
        className: 'HybridRunbookWorkerGroup',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          hybridRunbookWorkers: {
            required: false,
            serializedName: 'hybridRunbookWorkers',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'HybridRunbookWorkerElementType',
                  type: {
                    name: 'Composite',
                    className: 'HybridRunbookWorker'
                  }
              }
            }
          },
          credential: {
            required: false,
            serializedName: 'credential',
            type: {
              name: 'Composite',
              className: 'RunAsCredentialAssociationProperty'
            }
          }
        }
      }
    };
  }
}

module.exports = HybridRunbookWorkerGroup;
