/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

var msRestAzure = require('ms-rest-azure');

exports.BaseResource = msRestAzure.BaseResource;
exports.CloudError = msRestAzure.CloudError;
exports.ErrorResponse = require('./errorResponse');
exports.UsageCounterName = require('./usageCounterName');
exports.Usage = require('./usage');
exports.Statistics = require('./statistics');
exports.RunbookParameter = require('./runbookParameter');
exports.ContentHash = require('./contentHash');
exports.ContentLink = require('./contentLink');
exports.RunbookDraft = require('./runbookDraft');
exports.Resource = require('./resource');
exports.Runbook = require('./runbook');
exports.ModuleErrorInfo = require('./moduleErrorInfo');
exports.Module = require('./module');
exports.DscNodeConfigurationAssociationProperty = require('./dscNodeConfigurationAssociationProperty');
exports.DscNode = require('./dscNode');
exports.ContentSource = require('./contentSource');
exports.DscConfigurationParameter = require('./dscConfigurationParameter');
exports.DscConfiguration = require('./dscConfiguration');
exports.Sku = require('./sku');
exports.AutomationAccount = require('./automationAccount');
exports.OperationDisplay = require('./operationDisplay');
exports.Operation = require('./operation');
exports.AutomationAccountCreateOrUpdateParameters = require('./automationAccountCreateOrUpdateParameters');
exports.AutomationAccountUpdateParameters = require('./automationAccountUpdateParameters');
exports.Certificate = require('./certificate');
exports.CertificateUpdateParameters = require('./certificateUpdateParameters');
exports.CertificateCreateOrUpdateParameters = require('./certificateCreateOrUpdateParameters');
exports.ConnectionTypeAssociationProperty = require('./connectionTypeAssociationProperty');
exports.Connection = require('./connection');
exports.ConnectionUpdateParameters = require('./connectionUpdateParameters');
exports.ConnectionCreateOrUpdateParameters = require('./connectionCreateOrUpdateParameters');
exports.FieldDefinition = require('./fieldDefinition');
exports.ConnectionType = require('./connectionType');
exports.ConnectionTypeCreateOrUpdateParameters = require('./connectionTypeCreateOrUpdateParameters');
exports.Credential = require('./credential');
exports.CredentialUpdateParameters = require('./credentialUpdateParameters');
exports.CredentialCreateOrUpdateParameters = require('./credentialCreateOrUpdateParameters');
exports.ActivityParameter = require('./activityParameter');
exports.ActivityParameterSet = require('./activityParameterSet');
exports.ActivityOutputType = require('./activityOutputType');
exports.Activity = require('./activity');
exports.AdvancedScheduleMonthlyOccurrence = require('./advancedScheduleMonthlyOccurrence');
exports.AdvancedSchedule = require('./advancedSchedule');
exports.AgentRegistrationKeys = require('./agentRegistrationKeys');
exports.AgentRegistration = require('./agentRegistration');
exports.AgentRegistrationRegenerateKeyParameter = require('./agentRegistrationRegenerateKeyParameter');
exports.DscConfigurationAssociationProperty = require('./dscConfigurationAssociationProperty');
exports.DscCompilationJobCreateParameters = require('./dscCompilationJobCreateParameters');
exports.DscCompilationJob = require('./dscCompilationJob');
exports.DscConfigurationCreateOrUpdateParameters = require('./dscConfigurationCreateOrUpdateParameters');
exports.DscMetaConfiguration = require('./dscMetaConfiguration');
exports.DscNodeConfigurationCreateOrUpdateParameters = require('./dscNodeConfigurationCreateOrUpdateParameters');
exports.DscNodeConfiguration = require('./dscNodeConfiguration');
exports.DscNodeUpdateParameters = require('./dscNodeUpdateParameters');
exports.DscReportError = require('./dscReportError');
exports.DscReportResourceNavigation = require('./dscReportResourceNavigation');
exports.DscReportResource = require('./dscReportResource');
exports.DscNodeReport = require('./dscNodeReport');
exports.HybridRunbookWorker = require('./hybridRunbookWorker');
exports.RunAsCredentialAssociationProperty = require('./runAsCredentialAssociationProperty');
exports.HybridRunbookWorkerGroup = require('./hybridRunbookWorkerGroup');
exports.HybridRunbookWorkerGroupUpdateParameters = require('./hybridRunbookWorkerGroupUpdateParameters');
exports.RunbookAssociationProperty = require('./runbookAssociationProperty');
exports.Job = require('./job');
exports.JobCreateParameters = require('./jobCreateParameters');
exports.ScheduleAssociationProperty = require('./scheduleAssociationProperty');
exports.JobScheduleCreateParameters = require('./jobScheduleCreateParameters');
exports.JobSchedule = require('./jobSchedule');
exports.JobStream = require('./jobStream');
exports.ModuleCreateOrUpdateParameters = require('./moduleCreateOrUpdateParameters');
exports.ModuleUpdateParameters = require('./moduleUpdateParameters');
exports.RunbookDraftUndoEditResult = require('./runbookDraftUndoEditResult');
exports.RunbookCreateOrUpdateParameters = require('./runbookCreateOrUpdateParameters');
exports.RunbookCreateOrUpdateDraftProperties = require('./runbookCreateOrUpdateDraftProperties');
exports.RunbookCreateOrUpdateDraftParameters = require('./runbookCreateOrUpdateDraftParameters');
exports.RunbookUpdateParameters = require('./runbookUpdateParameters');
exports.ScheduleCreateOrUpdateParameters = require('./scheduleCreateOrUpdateParameters');
exports.Schedule = require('./schedule');
exports.ScheduleUpdateParameters = require('./scheduleUpdateParameters');
exports.SubResource = require('./subResource');
exports.TestJobCreateParameters = require('./testJobCreateParameters');
exports.TestJob = require('./testJob');
exports.TypeField = require('./typeField');
exports.VariableCreateOrUpdateParameters = require('./variableCreateOrUpdateParameters');
exports.Variable = require('./variable');
exports.VariableUpdateParameters = require('./variableUpdateParameters');
exports.WebhookCreateOrUpdateParameters = require('./webhookCreateOrUpdateParameters');
exports.Webhook = require('./webhook');
exports.WebhookUpdateParameters = require('./webhookUpdateParameters');
exports.AutomationAccountListResult = require('./automationAccountListResult');
exports.OperationListResult = require('./operationListResult');
exports.StatisticsListResult = require('./statisticsListResult');
exports.UsageListResult = require('./usageListResult');
exports.CertificateListResult = require('./certificateListResult');
exports.ConnectionListResult = require('./connectionListResult');
exports.ConnectionTypeListResult = require('./connectionTypeListResult');
exports.CredentialListResult = require('./credentialListResult');
exports.DscCompilationJobListResult = require('./dscCompilationJobListResult');
exports.DscConfigurationListResult = require('./dscConfigurationListResult');
exports.DscNodeListResult = require('./dscNodeListResult');
exports.DscNodeReportListResult = require('./dscNodeReportListResult');
exports.DscNodeConfigurationListResult = require('./dscNodeConfigurationListResult');
exports.HybridRunbookWorkerGroupsListResult = require('./hybridRunbookWorkerGroupsListResult');
exports.JobListResult = require('./jobListResult');
exports.JobStreamListResult = require('./jobStreamListResult');
exports.JobScheduleListResult = require('./jobScheduleListResult');
exports.ActivityListResult = require('./activityListResult');
exports.ModuleListResult = require('./moduleListResult');
exports.TypeFieldListResult = require('./typeFieldListResult');
exports.RunbookListResult = require('./runbookListResult');
exports.ScheduleListResult = require('./scheduleListResult');
exports.VariableListResult = require('./variableListResult');
exports.WebhookListResult = require('./webhookListResult');
