/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Definition of the statistic.
 *
 */
class Statistics {
  /**
   * Create a Statistics.
   * @member {string} [counterProperty] Gets the property value of the
   * statistic.
   * @member {number} [counterValue] Gets the value of the statistic.
   * @member {date} [startTime] Gets the startTime of the statistic.
   * @member {date} [endTime] Gets the endTime of the statistic.
   * @member {string} [id] Gets the id.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Statistics
   *
   * @returns {object} metadata of Statistics
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Statistics',
      type: {
        name: 'Composite',
        className: 'Statistics',
        modelProperties: {
          counterProperty: {
            required: false,
            readOnly: true,
            serializedName: 'counterProperty',
            type: {
              name: 'String'
            }
          },
          counterValue: {
            required: false,
            readOnly: true,
            serializedName: 'counterValue',
            type: {
              name: 'Number'
            }
          },
          startTime: {
            required: false,
            readOnly: true,
            serializedName: 'startTime',
            type: {
              name: 'DateTime'
            }
          },
          endTime: {
            required: false,
            readOnly: true,
            serializedName: 'endTime',
            type: {
              name: 'DateTime'
            }
          },
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Statistics;
