/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The parameters supplied to the create or update variable operation.
 *
 */
class VariableCreateOrUpdateParameters {
  /**
   * Create a VariableCreateOrUpdateParameters.
   * @member {string} name Gets or sets the name of the variable.
   * @member {string} [value] Gets or sets the value of the variable.
   * @member {string} [description] Gets or sets the description of the
   * variable.
   * @member {boolean} [isEncrypted] Gets or sets the encrypted flag of the
   * variable.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VariableCreateOrUpdateParameters
   *
   * @returns {object} metadata of VariableCreateOrUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VariableCreateOrUpdateParameters',
      type: {
        name: 'Composite',
        className: 'VariableCreateOrUpdateParameters',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          value: {
            required: false,
            serializedName: 'properties.value',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'properties.description',
            type: {
              name: 'String'
            }
          },
          isEncrypted: {
            required: false,
            serializedName: 'properties.isEncrypted',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = VariableCreateOrUpdateParameters;
