/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary A reference to an application package to be deployed to compute
 * nodes.
  *
 */
class ApplicationPackageReference {
  /**
   * Create a ApplicationPackageReference.
   * @member {string} applicationId The ID of the application to deploy.
   * @member {string} [version] The version of the application to deploy. If
   * omitted, the default version is deployed. If this is omitted on a pool,
   * and no default version is specified for this application, the request
   * fails with the error code InvalidApplicationPackageReferences and HTTP
   * status code 409. If this is omitted on a task, and no default version is
   * specified for this application, the task fails with a pre-processing
   * error.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApplicationPackageReference
   *
   * @returns {object} metadata of ApplicationPackageReference
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplicationPackageReference',
      type: {
        name: 'Composite',
        className: 'ApplicationPackageReference',
        modelProperties: {
          applicationId: {
            required: true,
            serializedName: 'applicationId',
            type: {
              name: 'String'
            }
          },
          version: {
            required: false,
            serializedName: 'version',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ApplicationPackageReference;
