/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary A name-value pair associated with a Batch service resource.
  *
 * The Batch service does not assign any meaning to this metadata; it is solely
 * for the use of user code.
 *
 */
class MetadataItem {
  /**
   * Create a MetadataItem.
   * @member {string} name The name of the metadata item.
   * @member {string} value The value of the metadata item.
   */
  constructor() {
  }

  /**
   * Defines the metadata of MetadataItem
   *
   * @returns {object} metadata of MetadataItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MetadataItem',
      type: {
        name: 'Composite',
        className: 'MetadataItem',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          value: {
            required: true,
            serializedName: 'value',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = MetadataItem;
