/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary Options for disabling scheduling on a compute node.
  *
 */
class NodeDisableSchedulingParameter {
  /**
   * Create a NodeDisableSchedulingParameter.
   * @member {string} [nodeDisableSchedulingOption] What to do with currently
   * running tasks when disabling task scheduling on the compute node. Values
   * are:
   *
   * requeue - Terminate running task processes and requeue the tasks. The
   * tasks may run again on other compute nodes, or when task scheduling is
   * re-enabled on this node. Enter offline state as soon as tasks have been
   * terminated.
   * terminate - Terminate running tasks. The tasks will not run again. Enter
   * offline state as soon as tasks have been terminated.
   * taskcompletion - Allow currently running tasks to complete. Schedule no
   * new tasks while waiting. Enter offline state when all tasks have
   * completed.
   *
   * The default value is requeue. Possible values include: 'requeue',
   * 'terminate', 'taskCompletion'
   */
  constructor() {
  }

  /**
   * Defines the metadata of NodeDisableSchedulingParameter
   *
   * @returns {object} metadata of NodeDisableSchedulingParameter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NodeDisableSchedulingParameter',
      type: {
        name: 'Composite',
        className: 'NodeDisableSchedulingParameter',
        modelProperties: {
          nodeDisableSchedulingOption: {
            required: false,
            serializedName: 'nodeDisableSchedulingOption',
            type: {
              name: 'Enum',
              allowedValues: [ 'requeue', 'terminate', 'taskCompletion' ]
            }
          }
        }
      }
    };
  }
}

module.exports = NodeDisableSchedulingParameter;
