/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary The set of changes to be made to a user account on a node.
  *
 */
class NodeUpdateUserParameter {
  /**
   * Create a NodeUpdateUserParameter.
   * @member {string} [password] The password of the account. The password is
   * required for Windows nodes (those created with
   * 'cloudServiceConfiguration', or created with 'virtualMachineConfiguration'
   * using a Windows image reference). For Linux compute nodes, the password
   * can optionally be specified along with the sshPublicKey property. If
   * omitted, any existing password is removed.
   * @member {date} [expiryTime] The time at which the account should expire.
   * If omitted, the default is 1 day from the current time. For Linux compute
   * nodes, the expiryTime has a precision up to a day.
   * @member {string} [sshPublicKey] The SSH public key that can be used for
   * remote login to the compute node. The public key should be compatible with
   * OpenSSH encoding and should be base 64 encoded. This property can be
   * specified only for Linux nodes. If this is specified for a Windows node,
   * then the Batch service rejects the request; if you are calling the REST
   * API directly, the HTTP status code is 400 (Bad Request). If omitted, any
   * existing SSH public key is removed.
   */
  constructor() {
  }

  /**
   * Defines the metadata of NodeUpdateUserParameter
   *
   * @returns {object} metadata of NodeUpdateUserParameter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NodeUpdateUserParameter',
      type: {
        name: 'Composite',
        className: 'NodeUpdateUserParameter',
        modelProperties: {
          password: {
            required: false,
            serializedName: 'password',
            type: {
              name: 'String'
            }
          },
          expiryTime: {
            required: false,
            serializedName: 'expiryTime',
            type: {
              name: 'DateTime'
            }
          },
          sshPublicKey: {
            required: false,
            serializedName: 'sshPublicKey',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = NodeUpdateUserParameter;
