/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary Details about an output file upload operation, including under what
 * conditions to perform the upload.
  *
 */
class OutputFileUploadOptions {
  /**
   * Create a OutputFileUploadOptions.
   * @member {string} uploadCondition The conditions under which the task
   * output file or set of files should be uploaded. The default is
   * taskCompletion. Possible values include: 'taskSuccess', 'taskFailure',
   * 'taskCompletion'
   */
  constructor() {
  }

  /**
   * Defines the metadata of OutputFileUploadOptions
   *
   * @returns {object} metadata of OutputFileUploadOptions
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OutputFileUploadOptions',
      type: {
        name: 'Composite',
        className: 'OutputFileUploadOptions',
        modelProperties: {
          uploadCondition: {
            required: true,
            serializedName: 'uploadCondition',
            type: {
              name: 'Enum',
              allowedValues: [ 'taskSuccess', 'taskFailure', 'taskCompletion' ]
            }
          }
        }
      }
    };
  }
}

module.exports = OutputFileUploadOptions;
