/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary Options for evaluating an automatic scaling formula on a pool.
  *
 */
class PoolEvaluateAutoScaleParameter {
  /**
   * Create a PoolEvaluateAutoScaleParameter.
   * @member {string} autoScaleFormula The formula for the desired number of
   * compute nodes in the pool. The formula is validated and its results
   * calculated, but it is not applied to the pool. To apply the formula to the
   * pool, 'Enable automatic scaling on a pool'. For more information about
   * specifying this formula, see Automatically scale compute nodes in an Azure
   * Batch pool
   * (https://azure.microsoft.com/en-us/documentation/articles/batch-automatic-scaling).
   */
  constructor() {
  }

  /**
   * Defines the metadata of PoolEvaluateAutoScaleParameter
   *
   * @returns {object} metadata of PoolEvaluateAutoScaleParameter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PoolEvaluateAutoScaleParameter',
      type: {
        name: 'Composite',
        className: 'PoolEvaluateAutoScaleParameter',
        modelProperties: {
          autoScaleFormula: {
            required: true,
            serializedName: 'autoScaleFormula',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = PoolEvaluateAutoScaleParameter;
