/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary Contains information about the container which a task is executing.
  *
 */
class TaskContainerExecutionInformation {
  /**
   * Create a TaskContainerExecutionInformation.
   * @member {string} [containerId] The ID of the container.
   * @member {string} [state] The state of the container. This is the state of
   * the container according to the Docker service. It is equivalent to the
   * status field returned by "docker inspect".
   * @member {string} [error] Detailed error information about the container.
   * This is the detailed error string from the Docker service, if available.
   * It is equivalent to the error field returned by "docker inspect".
   */
  constructor() {
  }

  /**
   * Defines the metadata of TaskContainerExecutionInformation
   *
   * @returns {object} metadata of TaskContainerExecutionInformation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TaskContainerExecutionInformation',
      type: {
        name: 'Composite',
        className: 'TaskContainerExecutionInformation',
        modelProperties: {
          containerId: {
            required: false,
            serializedName: 'containerId',
            type: {
              name: 'String'
            }
          },
          state: {
            required: false,
            serializedName: 'state',
            type: {
              name: 'String'
            }
          },
          error: {
            required: false,
            serializedName: 'error',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = TaskContainerExecutionInformation;
