/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * @summary The definition of the user identity under which the task is run.
  *
 * Specify either the userName or autoUser property, but not both.
 *
 */
class UserIdentity {
  /**
   * Create a UserIdentity.
   * @member {string} [userName] The name of the user identity under which the
   * task is run. The userName and autoUser properties are mutually exclusive;
   * you must specify one but not both.
   * @member {object} [autoUser] The auto user under which the task is run. The
   * userName and autoUser properties are mutually exclusive; you must specify
   * one but not both.
   * @member {string} [autoUser.scope] Values are:
   *
   * pool - specifies that the task runs as the common auto user account which
   * is created on every node in a pool.
   * task - specifies that the service should create a new user for the task.
   * The default value is task. Possible values include: 'task', 'pool'
   * @member {string} [autoUser.elevationLevel] nonAdmin - The auto user is a
   * standard user without elevated access. admin - The auto user is a user
   * with elevated access and operates with full Administrator permissions. The
   * default value is nonAdmin. Possible values include: 'nonAdmin', 'admin'
   */
  constructor() {
  }

  /**
   * Defines the metadata of UserIdentity
   *
   * @returns {object} metadata of UserIdentity
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UserIdentity',
      type: {
        name: 'Composite',
        className: 'UserIdentity',
        modelProperties: {
          userName: {
            required: false,
            serializedName: 'username',
            type: {
              name: 'String'
            }
          },
          autoUser: {
            required: false,
            serializedName: 'autoUser',
            type: {
              name: 'Composite',
              className: 'AutoUserSpecification'
            }
          }
        }
      }
    };
  }
}

module.exports = UserIdentity;
