/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An application package which represents a particular version of an
 * application.
 *
 */
class ApplicationPackage {
  /**
   * Create a ApplicationPackage.
   * @member {string} [id] The ID of the application.
   * @member {string} [version] The version of the application package.
   * @member {string} [state] The current state of the application package.
   * Possible values include: 'pending', 'active', 'unmapped'
   * @member {string} [format] The format of the application package, if the
   * package is active.
   * @member {string} [storageUrl] The URL for the application package in Azure
   * Storage.
   * @member {date} [storageUrlExpiry] The UTC time at which the Azure Storage
   * URL will expire.
   * @member {date} [lastActivationTime] The time at which the package was last
   * activated, if the package is active.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApplicationPackage
   *
   * @returns {object} metadata of ApplicationPackage
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplicationPackage',
      type: {
        name: 'Composite',
        className: 'ApplicationPackage',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          version: {
            required: false,
            readOnly: true,
            serializedName: 'version',
            type: {
              name: 'String'
            }
          },
          state: {
            required: false,
            readOnly: true,
            serializedName: 'state',
            type: {
              name: 'Enum',
              allowedValues: [ 'pending', 'active', 'unmapped' ]
            }
          },
          format: {
            required: false,
            readOnly: true,
            serializedName: 'format',
            type: {
              name: 'String'
            }
          },
          storageUrl: {
            required: false,
            readOnly: true,
            serializedName: 'storageUrl',
            type: {
              name: 'String'
            }
          },
          storageUrlExpiry: {
            required: false,
            readOnly: true,
            serializedName: 'storageUrlExpiry',
            type: {
              name: 'DateTime'
            }
          },
          lastActivationTime: {
            required: false,
            readOnly: true,
            serializedName: 'lastActivationTime',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = ApplicationPackage;
