/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Parameters for an update application request.
 *
 */
class ApplicationUpdateParameters {
  /**
   * Create a ApplicationUpdateParameters.
   * @member {boolean} [allowUpdates] A value indicating whether packages
   * within the application may be overwritten using the same version string.
   * @member {string} [defaultVersion] The package to use if a client requests
   * the application but does not specify a version.
   * @member {string} [displayName] The display name for the application.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApplicationUpdateParameters
   *
   * @returns {object} metadata of ApplicationUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplicationUpdateParameters',
      type: {
        name: 'Composite',
        className: 'ApplicationUpdateParameters',
        modelProperties: {
          allowUpdates: {
            required: false,
            serializedName: 'allowUpdates',
            type: {
              name: 'Boolean'
            }
          },
          defaultVersion: {
            required: false,
            serializedName: 'defaultVersion',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            serializedName: 'displayName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ApplicationUpdateParameters;
