/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Parameters for updating an Azure Batch account.
 *
 */
class BatchAccountUpdateParameters {
  /**
   * Create a BatchAccountUpdateParameters.
   * @member {object} [tags] The user-specified tags associated with the
   * account.
   * @member {object} [autoStorage] The properties related to the auto-storage
   * account.
   * @member {string} [autoStorage.storageAccountId] The resource ID of the
   * storage account to be used for auto-storage account.
   */
  constructor() {
  }

  /**
   * Defines the metadata of BatchAccountUpdateParameters
   *
   * @returns {object} metadata of BatchAccountUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BatchAccountUpdateParameters',
      type: {
        name: 'Composite',
        className: 'BatchAccountUpdateParameters',
        modelProperties: {
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          autoStorage: {
            required: false,
            serializedName: 'properties.autoStorage',
            type: {
              name: 'Composite',
              className: 'AutoStorageBaseProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = BatchAccountUpdateParameters;
