/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Identifies the Azure key vault associated with a Batch account.
 *
 */
class KeyVaultReference {
  /**
   * Create a KeyVaultReference.
   * @member {string} id The resource ID of the Azure key vault associated with
   * the Batch account.
   * @member {string} url The URL of the Azure key vault associated with the
   * Batch account.
   */
  constructor() {
  }

  /**
   * Defines the metadata of KeyVaultReference
   *
   * @returns {object} metadata of KeyVaultReference
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'KeyVaultReference',
      type: {
        name: 'Composite',
        className: 'KeyVaultReference',
        modelProperties: {
          id: {
            required: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          url: {
            required: true,
            serializedName: 'url',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = KeyVaultReference;
