/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary The object that describes the operation.
  *
 */
class OperationDisplay {
  /**
   * Create a OperationDisplay.
   * @member {string} [provider] Friendly name of the resource provider.
   * @member {string} [operation] The operation type. For example: read, write,
   * delete, or listKeys/action
   * @member {string} [resource] The resource type on which the operation is
   * performed.
   * @member {string} [description] The friendly name of the operation.
   */
  constructor() {
  }

  /**
   * Defines the metadata of OperationDisplay
   *
   * @returns {object} metadata of OperationDisplay
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Operation_display',
      type: {
        name: 'Composite',
        className: 'OperationDisplay',
        modelProperties: {
          provider: {
            required: false,
            serializedName: 'provider',
            type: {
              name: 'String'
            }
          },
          operation: {
            required: false,
            serializedName: 'operation',
            type: {
              name: 'String'
            }
          },
          resource: {
            required: false,
            serializedName: 'resource',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = OperationDisplay;
