/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A billing period resource.
 *
 * @extends models['Resource']
 */
class BillingPeriod extends models['Resource'] {
  /**
   * Create a BillingPeriod.
   * @member {date} [billingPeriodStartDate] The start of the date range
   * covered by the billing period.
   * @member {date} [billingPeriodEndDate] The end of the date range covered by
   * the billing period.
   * @member {array} [invoiceIds] Array of invoice ids that associated with.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of BillingPeriod
   *
   * @returns {object} metadata of BillingPeriod
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BillingPeriod',
      type: {
        name: 'Composite',
        className: 'BillingPeriod',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          billingPeriodStartDate: {
            required: false,
            readOnly: true,
            serializedName: 'properties.billingPeriodStartDate',
            type: {
              name: 'Date'
            }
          },
          billingPeriodEndDate: {
            required: false,
            readOnly: true,
            serializedName: 'properties.billingPeriodEndDate',
            type: {
              name: 'Date'
            }
          },
          invoiceIds: {
            required: false,
            readOnly: true,
            serializedName: 'properties.invoiceIds',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = BillingPeriod;
