/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * CDN profile is a logical grouping of endpoints that share the same settings,
 * such as CDN provider and pricing tier.
 *
 * @extends models['Resource']
 */
class Profile extends models['Resource'] {
  /**
   * Create a Profile.
   * @member {object} sku The pricing tier (defines a CDN provider, feature
   * list and rate) of the CDN profile.
   * @member {string} [sku.name] Name of the pricing tier. Possible values
   * include: 'Standard_Verizon', 'Premium_Verizon', 'Custom_Verizon',
   * 'Standard_Akamai', 'Standard_ChinaCdn'
   * @member {string} [resourceState] Resource status of the profile. Possible
   * values include: 'Creating', 'Active', 'Deleting', 'Disabled'
   * @member {string} [provisioningState] Provisioning status of the profile.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of Profile
   *
   * @returns {object} metadata of Profile
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Profile',
      type: {
        name: 'Composite',
        className: 'Profile',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          sku: {
            required: true,
            serializedName: 'sku',
            type: {
              name: 'Composite',
              className: 'Sku'
            }
          },
          resourceState: {
            required: false,
            readOnly: true,
            serializedName: 'properties.resourceState',
            type: {
              name: 'String'
            }
          },
          provisioningState: {
            required: false,
            readOnly: true,
            serializedName: 'properties.provisioningState',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Profile;
