/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Output of check resource usage API.
 *
 */
class ResourceUsage {
  /**
   * Create a ResourceUsage.
   * @member {string} [resourceType] Resource type for which the usage is
   * provided.
   * @member {string} [unit] Unit of the usage. e.g. Count.
   * @member {number} [currentValue] Actual value of usage on the specified
   * resource type.
   * @member {number} [limit] Quota of the specified resource type.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResourceUsage
   *
   * @returns {object} metadata of ResourceUsage
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceUsage',
      type: {
        name: 'Composite',
        className: 'ResourceUsage',
        modelProperties: {
          resourceType: {
            required: false,
            readOnly: true,
            serializedName: 'resourceType',
            type: {
              name: 'String'
            }
          },
          unit: {
            required: false,
            readOnly: true,
            serializedName: 'unit',
            type: {
              name: 'String'
            }
          },
          currentValue: {
            required: false,
            readOnly: true,
            serializedName: 'currentValue',
            type: {
              name: 'Number'
            }
          },
          limit: {
            required: false,
            readOnly: true,
            serializedName: 'limit',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceUsage;
