/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The pricing tier (defines a CDN provider, feature list and rate) of the CDN
 * profile.
 *
 */
class Sku {
  /**
   * Create a Sku.
   * @member {string} [name] Name of the pricing tier. Possible values include:
   * 'Standard_Verizon', 'Premium_Verizon', 'Custom_Verizon',
   * 'Standard_Akamai', 'Standard_ChinaCdn'
   */
  constructor() {
  }

  /**
   * Defines the metadata of Sku
   *
   * @returns {object} metadata of Sku
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Sku',
      type: {
        name: 'Composite',
        className: 'Sku',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Sku;
