/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Check SKU availability parameter.
 *
 */
class CheckSkuAvailabilityParameter {
  /**
   * Create a CheckSkuAvailabilityParameter.
   * @member {array} skus The SKU of the resource.
   * @member {string} kind The Kind of the resource. Possible values include:
   * 'Academic', 'Bing.Autosuggest', 'Bing.Search', 'Bing.Speech',
   * 'Bing.SpellCheck', 'ComputerVision', 'ContentModerator', 'CustomSpeech',
   * 'Emotion', 'Face', 'LUIS', 'Recommendations', 'SpeakerRecognition',
   * 'Speech', 'SpeechTranslation', 'TextAnalytics', 'TextTranslation', 'WebLM'
   * @member {string} type The Type of the resource.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CheckSkuAvailabilityParameter
   *
   * @returns {object} metadata of CheckSkuAvailabilityParameter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CheckSkuAvailabilityParameter',
      type: {
        name: 'Composite',
        className: 'CheckSkuAvailabilityParameter',
        modelProperties: {
          skus: {
            required: true,
            serializedName: 'skus',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          kind: {
            required: true,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CheckSkuAvailabilityParameter;
