/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Check SKU availability result.
 *
 */
class CheckSkuAvailabilityResult {
  /**
   * Create a CheckSkuAvailabilityResult.
   * @member {string} [kind] The Kind of the resource. Possible values include:
   * 'Academic', 'Bing.Autosuggest', 'Bing.Search', 'Bing.Speech',
   * 'Bing.SpellCheck', 'ComputerVision', 'ContentModerator', 'CustomSpeech',
   * 'Emotion', 'Face', 'LUIS', 'Recommendations', 'SpeakerRecognition',
   * 'Speech', 'SpeechTranslation', 'TextAnalytics', 'TextTranslation', 'WebLM'
   * @member {string} [type] The Type of the resource.
   * @member {string} [skuName] The SKU of Cognitive Services account. Possible
   * values include: 'F0', 'P0', 'P1', 'P2', 'S0', 'S1', 'S2', 'S3', 'S4',
   * 'S5', 'S6'
   * @member {boolean} [skuAvailable] Indicates the given SKU is available or
   * not.
   * @member {string} [reason] Reason why the SKU is not available.
   * @member {string} [message] Additional error message.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CheckSkuAvailabilityResult
   *
   * @returns {object} metadata of CheckSkuAvailabilityResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CheckSkuAvailabilityResult',
      type: {
        name: 'Composite',
        className: 'CheckSkuAvailabilityResult',
        modelProperties: {
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          skuName: {
            required: false,
            serializedName: 'skuName',
            type: {
              name: 'String'
            }
          },
          skuAvailable: {
            required: false,
            serializedName: 'skuAvailable',
            type: {
              name: 'Boolean'
            }
          },
          reason: {
            required: false,
            serializedName: 'reason',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CheckSkuAvailabilityResult;
