/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The parameters to provide for the account.
 *
 */
class CognitiveServicesAccountCreateParameters {
  /**
   * Create a CognitiveServicesAccountCreateParameters.
   * @member {object} sku Required. Gets or sets the SKU of the resource.
   * @member {string} [sku.name] Gets or sets the sku name. Required for
   * account creation, optional for update. Possible values include: 'F0',
   * 'P0', 'P1', 'P2', 'S0', 'S1', 'S2', 'S3', 'S4', 'S5', 'S6'
   * @member {string} [sku.tier] Gets the sku tier. This is based on the SKU
   * name. Possible values include: 'Free', 'Standard', 'Premium'
   * @member {string} kind Required. Gets or sets the Kind of the resource.
   * Possible values include: 'Academic', 'Bing.Autosuggest', 'Bing.Search',
   * 'Bing.Speech', 'Bing.SpellCheck', 'ComputerVision', 'ContentModerator',
   * 'CustomSpeech', 'Emotion', 'Face', 'LUIS', 'Recommendations',
   * 'SpeakerRecognition', 'Speech', 'SpeechTranslation', 'TextAnalytics',
   * 'TextTranslation', 'WebLM'
   * @member {string} location Required. Gets or sets the location of the
   * resource. This will be one of the supported and registered Azure Geo
   * Regions (e.g. West US, East US, Southeast Asia, etc.). The geo region of a
   * resource cannot be changed once it is created, but if an identical geo
   * region is specified on update the request will succeed.
   * @member {object} [tags] Gets or sets a list of key value pairs that
   * describe the resource. These tags can be used in viewing and grouping this
   * resource (across resource groups). A maximum of 15 tags can be provided
   * for a resource. Each tag must have a key no greater than 128 characters
   * and value no greater than 256 characters.
   * @member {object} properties Must exist in the request. Must be an empty
   * object. Must not be null.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CognitiveServicesAccountCreateParameters
   *
   * @returns {object} metadata of CognitiveServicesAccountCreateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CognitiveServicesAccountCreateParameters',
      type: {
        name: 'Composite',
        className: 'CognitiveServicesAccountCreateParameters',
        modelProperties: {
          sku: {
            required: true,
            serializedName: 'sku',
            type: {
              name: 'Composite',
              className: 'Sku'
            }
          },
          kind: {
            required: true,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          location: {
            required: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          properties: {
            required: true,
            serializedName: 'properties',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = CognitiveServicesAccountCreateParameters;
