/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The parameters to provide for the account.
 *
 */
class CognitiveServicesAccountUpdateParameters {
  /**
   * Create a CognitiveServicesAccountUpdateParameters.
   * @member {object} [sku] Gets or sets the SKU of the resource.
   * @member {string} [sku.name] Gets or sets the sku name. Required for
   * account creation, optional for update. Possible values include: 'F0',
   * 'P0', 'P1', 'P2', 'S0', 'S1', 'S2', 'S3', 'S4', 'S5', 'S6'
   * @member {string} [sku.tier] Gets the sku tier. This is based on the SKU
   * name. Possible values include: 'Free', 'Standard', 'Premium'
   * @member {object} [tags] Gets or sets a list of key value pairs that
   * describe the resource. These tags can be used in viewing and grouping this
   * resource (across resource groups). A maximum of 15 tags can be provided
   * for a resource. Each tag must have a key no greater than 128 characters
   * and value no greater than 256 characters.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CognitiveServicesAccountUpdateParameters
   *
   * @returns {object} metadata of CognitiveServicesAccountUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CognitiveServicesAccountUpdateParameters',
      type: {
        name: 'Composite',
        className: 'CognitiveServicesAccountUpdateParameters',
        modelProperties: {
          sku: {
            required: false,
            serializedName: 'sku',
            type: {
              name: 'Composite',
              className: 'Sku'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = CognitiveServicesAccountUpdateParameters;
