/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Cognitive Services resource type and SKU.
 *
 */
class CognitiveServicesResourceAndSku {
  /**
   * Create a CognitiveServicesResourceAndSku.
   * @member {string} [resourceType] Resource Namespace and Type
   * @member {object} [sku] The SKU of Cognitive Services account.
   * @member {string} [sku.name] Gets or sets the sku name. Required for
   * account creation, optional for update. Possible values include: 'F0',
   * 'P0', 'P1', 'P2', 'S0', 'S1', 'S2', 'S3', 'S4', 'S5', 'S6'
   * @member {string} [sku.tier] Gets the sku tier. This is based on the SKU
   * name. Possible values include: 'Free', 'Standard', 'Premium'
   */
  constructor() {
  }

  /**
   * Defines the metadata of CognitiveServicesResourceAndSku
   *
   * @returns {object} metadata of CognitiveServicesResourceAndSku
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CognitiveServicesResourceAndSku',
      type: {
        name: 'Composite',
        className: 'CognitiveServicesResourceAndSku',
        modelProperties: {
          resourceType: {
            required: false,
            serializedName: 'resourceType',
            type: {
              name: 'String'
            }
          },
          sku: {
            required: false,
            serializedName: 'sku',
            type: {
              name: 'Composite',
              className: 'Sku'
            }
          }
        }
      }
    };
  }
}

module.exports = CognitiveServicesResourceAndSku;
