/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the offer term.
 *
 */
class OfferTermInfo {
  /**
   * Create a OfferTermInfo.
   * @member {date} [effectiveDate] Indicates the date from which the offer
   * term is effective.
   * @member {string} name Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of OfferTermInfo
   *
   * @returns {object} metadata of OfferTermInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OfferTermInfo',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'Name',
          clientName: 'name'
        },
        uberParent: 'OfferTermInfo',
        className: 'OfferTermInfo',
        modelProperties: {
          effectiveDate: {
            required: false,
            serializedName: 'EffectiveDate',
            type: {
              name: 'DateTime'
            }
          },
          name: {
            required: true,
            serializedName: 'Name',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = OfferTermInfo;
