/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Parameters that are used in the odata $filter query parameter for providing
 * RateCard information.
 *
 */
class RateCardQueryParameters {
  /**
   * Create a RateCardQueryParameters.
   * @member {string} offerDurableId The Offer ID parameter consists of the
   * 'MS-AZR-' prefix, plus the Offer ID number (e.g., MS-AZR-0026P). See
   * https://azure.microsoft.com/en-us/support/legal/offer-details/ for more
   * information on the list of available Offer IDs, country/region
   * availability, and billing currency.
   * @member {string} currency The currency in which the rates need to be
   * provided.
   * @member {string} locale The culture in which the resource metadata needs
   * to be localized.
   * @member {string} regionInfo 2 letter ISO code where the offer was
   * purchased.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RateCardQueryParameters
   *
   * @returns {object} metadata of RateCardQueryParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RateCardQueryParameters',
      type: {
        name: 'Composite',
        className: 'RateCardQueryParameters',
        modelProperties: {
          offerDurableId: {
            required: true,
            serializedName: 'OfferDurableId',
            constraints: {
              Pattern: '^MS-AZR-\d{4}P(-\d{4}P)*$'
            },
            type: {
              name: 'String'
            }
          },
          currency: {
            required: true,
            serializedName: 'Currency',
            type: {
              name: 'String'
            }
          },
          locale: {
            required: true,
            serializedName: 'Locale',
            type: {
              name: 'String'
            }
          },
          regionInfo: {
            required: true,
            serializedName: 'RegionInfo',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = RateCardQueryParameters;
