/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Indicates a recurring charge is present for this offer.
 *
 * @extends models['OfferTermInfo']
 */
class RecurringCharge extends models['OfferTermInfo'] {
  /**
   * Create a RecurringCharge.
   * @member {number} [recurringCharge] The amount of recurring charge as per
   * the offer term.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of RecurringCharge
   *
   * @returns {object} metadata of RecurringCharge
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Recurring Charge',
      type: {
        name: 'Composite',
        className: 'RecurringCharge',
        modelProperties: {
          effectiveDate: {
            required: false,
            serializedName: 'EffectiveDate',
            type: {
              name: 'DateTime'
            }
          },
          name: {
            required: true,
            serializedName: 'Name',
            type: {
              name: 'String'
            }
          },
          recurringCharge: {
            required: false,
            serializedName: 'RecurringCharge',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = RecurringCharge;
