/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The login password for the container registry.
 *
 */
class RegistryPassword {
  /**
   * Create a RegistryPassword.
   * @member {string} [name] The password name. Possible values include:
   * 'password', 'password2'
   * @member {string} [value] The password value.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RegistryPassword
   *
   * @returns {object} metadata of RegistryPassword
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RegistryPassword',
      type: {
        name: 'Composite',
        className: 'RegistryPassword',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'Enum',
              allowedValues: [ 'password', 'password2' ]
            }
          },
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = RegistryPassword;
