/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The parameters for updating a container registry.
 *
 */
class RegistryUpdateParameters {
  /**
   * Create a RegistryUpdateParameters.
   * @member {object} [tags] The tags for the container registry.
   * @member {object} [sku] The SKU of the container registry.
   * @member {string} [sku.name] The SKU name of the container registry.
   * Required for registry creation. Possible values include: 'Classic',
   * 'Managed_Basic', 'Managed_Standard', 'Managed_Premium'
   * @member {string} [sku.tier] The SKU tier based on the SKU name. Possible
   * values include: 'Classic', 'Managed'
   * @member {boolean} [adminUserEnabled] The value that indicates whether the
   * admin user is enabled.
   * @member {object} [storageAccount] The parameters of a storage account for
   * the container registry. Only applicable to Classic SKU. If specified, the
   * storage account must be in the same physical location as the container
   * registry.
   * @member {string} [storageAccount.id] The resource ID of the storage
   * account.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RegistryUpdateParameters
   *
   * @returns {object} metadata of RegistryUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RegistryUpdateParameters',
      type: {
        name: 'Composite',
        className: 'RegistryUpdateParameters',
        modelProperties: {
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          sku: {
            required: false,
            serializedName: 'sku',
            type: {
              name: 'Composite',
              className: 'Sku'
            }
          },
          adminUserEnabled: {
            required: false,
            serializedName: 'properties.adminUserEnabled',
            type: {
              name: 'Boolean'
            }
          },
          storageAccount: {
            required: false,
            serializedName: 'properties.storageAccount',
            type: {
              name: 'Composite',
              className: 'StorageAccountProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = RegistryUpdateParameters;
