/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The quota usage for a container registry.
 *
 */
class RegistryUsage {
  /**
   * Create a RegistryUsage.
   * @member {string} [name] The name of the usage.
   * @member {number} [limit] The limit of the usage.
   * @member {number} [currentValue] The current value of the usage.
   * @member {string} [unit] The unit of measurement. Possible values include:
   * 'Count', 'Bytes'
   */
  constructor() {
  }

  /**
   * Defines the metadata of RegistryUsage
   *
   * @returns {object} metadata of RegistryUsage
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RegistryUsage',
      type: {
        name: 'Composite',
        className: 'RegistryUsage',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          limit: {
            required: false,
            serializedName: 'limit',
            type: {
              name: 'Number'
            }
          },
          currentValue: {
            required: false,
            serializedName: 'currentValue',
            type: {
              name: 'Number'
            }
          },
          unit: {
            required: false,
            serializedName: 'unit',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = RegistryUsage;
