/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * An object that represents a replication for a container registry.
 *
 * @extends models['Resource']
 */
class Replication extends models['Resource'] {
  /**
   * Create a Replication.
   * @member {string} [provisioningState] The provisioning state of the
   * replication at the time the operation was called. Possible values include:
   * 'Creating', 'Updating', 'Deleting', 'Succeeded', 'Failed', 'Canceled'
   * @member {object} [status] The status of the replication at the time the
   * operation was called.
   * @member {string} [status.displayStatus] The short label for the status.
   * @member {string} [status.message] The detailed message for the status,
   * including alerts and error messages.
   * @member {date} [status.timestamp] The timestamp when the status was
   * changed to the current value.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of Replication
   *
   * @returns {object} metadata of Replication
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Replication',
      type: {
        name: 'Composite',
        className: 'Replication',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          provisioningState: {
            required: false,
            readOnly: true,
            serializedName: 'properties.provisioningState',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            readOnly: true,
            serializedName: 'properties.status',
            type: {
              name: 'Composite',
              className: 'Status'
            }
          }
        }
      }
    };
  }
}

module.exports = Replication;
