/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Image registry credential.
 *
 */
class ImageRegistryCredential {
  /**
   * Create a ImageRegistryCredential.
   * @member {string} server The Docker image registry server without a
   * protocol such as "http" and "https".
   * @member {string} username The username for the private registry.
   * @member {string} [password] The password for the private registry.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ImageRegistryCredential
   *
   * @returns {object} metadata of ImageRegistryCredential
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ImageRegistryCredential',
      type: {
        name: 'Composite',
        className: 'ImageRegistryCredential',
        modelProperties: {
          server: {
            required: true,
            serializedName: 'server',
            type: {
              name: 'String'
            }
          },
          username: {
            required: true,
            serializedName: 'username',
            type: {
              name: 'String'
            }
          },
          password: {
            required: false,
            serializedName: 'password',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ImageRegistryCredential;
