/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * IP address for the container group.
 *
 */
class IpAddress {
  /**
   * Create a IpAddress.
   * @member {array} ports The list of ports exposed on the container group.
   * @member {string} [ip] The IP exposed to the public internet.
   */
  constructor() {
  }

  /**
   * Defines the metadata of IpAddress
   *
   * @returns {object} metadata of IpAddress
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IpAddress',
      type: {
        name: 'Composite',
        className: 'IpAddress',
        modelProperties: {
          ports: {
            required: true,
            serializedName: 'ports',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'PortElementType',
                  type: {
                    name: 'Composite',
                    className: 'Port'
                  }
              }
            }
          },
          type: {
            required: true,
            isConstant: true,
            serializedName: 'type',
            defaultValue: 'Public',
            type: {
              name: 'String'
            }
          },
          ip: {
            required: false,
            serializedName: 'ip',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = IpAddress;
