/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The properties of the volume mount.
 *
 */
class VolumeMount {
  /**
   * Create a VolumeMount.
   * @member {string} name The name of the volume mount.
   * @member {string} mountPath The path within the container where the volume
   * should be mounted. Must not contain colon (:).
   * @member {boolean} [readOnly] The flag indicating whether the volume mount
   * is read-only.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VolumeMount
   *
   * @returns {object} metadata of VolumeMount
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VolumeMount',
      type: {
        name: 'Composite',
        className: 'VolumeMount',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          mountPath: {
            required: true,
            serializedName: 'mountPath',
            type: {
              name: 'String'
            }
          },
          readOnly: {
            required: false,
            serializedName: 'readOnly',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = VolumeMount;
