/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Definition of canonical profile.
 *
 */
class CanonicalProfileDefinition {
  /**
   * Create a CanonicalProfileDefinition.
   * @member {number} [canonicalProfileId] Canonical profile ID.
   * @member {array} [properties] Properties of the canonical profile.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CanonicalProfileDefinition
   *
   * @returns {object} metadata of CanonicalProfileDefinition
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CanonicalProfileDefinition',
      type: {
        name: 'Composite',
        className: 'CanonicalProfileDefinition',
        modelProperties: {
          canonicalProfileId: {
            required: false,
            serializedName: 'canonicalProfileId',
            type: {
              name: 'Number'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'CanonicalProfileDefinitionPropertiesItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'CanonicalProfileDefinitionPropertiesItem'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = CanonicalProfileDefinition;
