/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The definition of a canonical profile property.
 *
 */
class CanonicalProfileDefinitionPropertiesItem {
  /**
   * Create a CanonicalProfileDefinitionPropertiesItem.
   * @member {string} [profileName] Profile name.
   * @member {string} [profilePropertyName] Property name of profile.
   * @member {number} [rank] The rank.
   * @member {string} [type] Type of canonical property value. Possible values
   * include: 'Numeric', 'Categorical', 'DerivedCategorical', 'DerivedNumeric'
   * @member {string} [value] Value of the canonical property.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CanonicalProfileDefinitionPropertiesItem
   *
   * @returns {object} metadata of CanonicalProfileDefinitionPropertiesItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CanonicalProfileDefinition_propertiesItem',
      type: {
        name: 'Composite',
        className: 'CanonicalProfileDefinitionPropertiesItem',
        modelProperties: {
          profileName: {
            required: false,
            serializedName: 'profileName',
            type: {
              name: 'String'
            }
          },
          profilePropertyName: {
            required: false,
            serializedName: 'profilePropertyName',
            type: {
              name: 'String'
            }
          },
          rank: {
            required: false,
            serializedName: 'rank',
            type: {
              name: 'Number'
            }
          },
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CanonicalProfileDefinitionPropertiesItem;
