/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The complete operation.
 *
 */
class ConnectorMappingCompleteOperation {
  /**
   * Create a ConnectorMappingCompleteOperation.
   * @member {string} [completionOperationType] The type of completion
   * operation. Possible values include: 'DoNothing', 'DeleteFile', 'MoveFile'
   * @member {string} [destinationFolder] The destination folder where files
   * will be moved to once the import is done.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ConnectorMappingCompleteOperation
   *
   * @returns {object} metadata of ConnectorMappingCompleteOperation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ConnectorMappingCompleteOperation',
      type: {
        name: 'Composite',
        className: 'ConnectorMappingCompleteOperation',
        modelProperties: {
          completionOperationType: {
            required: false,
            serializedName: 'completionOperationType',
            type: {
              name: 'Enum',
              allowedValues: [ 'DoNothing', 'DeleteFile', 'MoveFile' ]
            }
          },
          destinationFolder: {
            required: false,
            serializedName: 'destinationFolder',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ConnectorMappingCompleteOperation;
