/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The Metadata definition base.
 *
 */
class MetadataDefinitionBase {
  /**
   * Create a MetadataDefinitionBase.
   * @member {object} [attributes] The attributes for the Type.
   * @member {object} [description] Localized descriptions for the property.
   * @member {object} [displayName] Localized display names for the property.
   * @member {object} [localizedAttributes] Any custom localized attributes for
   * the Type.
   * @member {string} [smallImage] Small Image associated with the Property or
   * EntityType.
   * @member {string} [mediumImage] Medium Image associated with the Property
   * or EntityType.
   * @member {string} [largeImage] Large Image associated with the Property or
   * EntityType.
   */
  constructor() {
  }

  /**
   * Defines the metadata of MetadataDefinitionBase
   *
   * @returns {object} metadata of MetadataDefinitionBase
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MetadataDefinitionBase',
      type: {
        name: 'Composite',
        className: 'MetadataDefinitionBase',
        modelProperties: {
          attributes: {
            required: false,
            serializedName: 'attributes',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'ArrayElementType',
                  type: {
                    name: 'Sequence',
                    element: {
                        required: false,
                        serializedName: 'StringElementType',
                        type: {
                          name: 'String'
                        }
                    }
                  }
              }
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          displayName: {
            required: false,
            serializedName: 'displayName',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          localizedAttributes: {
            required: false,
            serializedName: 'localizedAttributes',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'ObjectElementType',
                  type: {
                    name: 'Dictionary',
                    value: {
                        required: false,
                        serializedName: 'StringElementType',
                        type: {
                          name: 'String'
                        }
                    }
                  }
              }
            }
          },
          smallImage: {
            required: false,
            serializedName: 'smallImage',
            type: {
              name: 'String'
            }
          },
          mediumImage: {
            required: false,
            serializedName: 'mediumImage',
            type: {
              name: 'String'
            }
          },
          largeImage: {
            required: false,
            serializedName: 'largeImage',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = MetadataDefinitionBase;
