/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The participant property reference.
 *
 */
class ParticipantPropertyReference {
  /**
   * Create a ParticipantPropertyReference.
   * @member {string} sourcePropertyName The source property that maps to the
   * target property.
   * @member {string} targetPropertyName The target property that maps to the
   * source property.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ParticipantPropertyReference
   *
   * @returns {object} metadata of ParticipantPropertyReference
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ParticipantPropertyReference',
      type: {
        name: 'Composite',
        className: 'ParticipantPropertyReference',
        modelProperties: {
          sourcePropertyName: {
            required: true,
            serializedName: 'sourcePropertyName',
            type: {
              name: 'String'
            }
          },
          targetPropertyName: {
            required: true,
            serializedName: 'targetPropertyName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ParticipantPropertyReference;
