/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The definition of the prediction distribution.
 *
 */
class PredictionDistributionDefinition {
  /**
   * Create a PredictionDistributionDefinition.
   * @member {number} [totalPositives] Total positive in the distribution.
   * @member {number} [totalNegatives] Total negatives in the distribution.
   * @member {array} [distributions] Distributions of the prediction.
   */
  constructor() {
  }

  /**
   * Defines the metadata of PredictionDistributionDefinition
   *
   * @returns {object} metadata of PredictionDistributionDefinition
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PredictionDistributionDefinition',
      type: {
        name: 'Composite',
        className: 'PredictionDistributionDefinition',
        modelProperties: {
          totalPositives: {
            required: false,
            serializedName: 'totalPositives',
            type: {
              name: 'Number'
            }
          },
          totalNegatives: {
            required: false,
            serializedName: 'totalNegatives',
            type: {
              name: 'Number'
            }
          },
          distributions: {
            required: false,
            serializedName: 'distributions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'PredictionDistributionDefinitionDistributionsItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'PredictionDistributionDefinitionDistributionsItem'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = PredictionDistributionDefinition;
