/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The fields mapping for Relationships.
 *
 */
class RelationshipLinkFieldMapping {
  /**
   * Create a RelationshipLinkFieldMapping.
   * @member {string} interactionFieldName The field name on the Interaction
   * Type.
   * @member {string} [linkType] Link type. Possible values include:
   * 'UpdateAlways', 'CopyIfNull'
   * @member {string} relationshipFieldName The field name on the Relationship
   * metadata.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RelationshipLinkFieldMapping
   *
   * @returns {object} metadata of RelationshipLinkFieldMapping
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RelationshipLinkFieldMapping',
      type: {
        name: 'Composite',
        className: 'RelationshipLinkFieldMapping',
        modelProperties: {
          interactionFieldName: {
            required: true,
            serializedName: 'interactionFieldName',
            type: {
              name: 'String'
            }
          },
          linkType: {
            required: false,
            serializedName: 'linkType',
            type: {
              name: 'Enum',
              allowedValues: [ 'UpdateAlways', 'CopyIfNull' ]
            }
          },
          relationshipFieldName: {
            required: true,
            serializedName: 'relationshipFieldName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = RelationshipLinkFieldMapping;
