/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Maps fields in Profile to their corresponding StrongIds in Related Profile.
 *
 */
class RelationshipTypeMapping {
  /**
   * Create a RelationshipTypeMapping.
   * @member {array} fieldMappings Maps a profile property with the StrongId of
   * related profile. This is an array to support StrongIds that are composite
   * key as well.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RelationshipTypeMapping
   *
   * @returns {object} metadata of RelationshipTypeMapping
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RelationshipTypeMapping',
      type: {
        name: 'Composite',
        className: 'RelationshipTypeMapping',
        modelProperties: {
          fieldMappings: {
            required: true,
            serializedName: 'fieldMappings',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'RelationshipTypeFieldMappingElementType',
                  type: {
                    name: 'Composite',
                    className: 'RelationshipTypeFieldMapping'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = RelationshipTypeMapping;
