/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The view resource format.
 *
 * @extends models['ProxyResource']
 */
class ViewResourceFormat extends models['ProxyResource'] {
  /**
   * Create a ViewResourceFormat.
   * @member {string} [viewName] Name of the view.
   * @member {string} [userId] the user ID.
   * @member {string} [tenantId] the hub name.
   * @member {object} [displayName] Localized display name for the view.
   * @member {string} definition View definition.
   * @member {date} [changed] Date time when view was last modified.
   * @member {date} [created] Date time when view was created.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ViewResourceFormat
   *
   * @returns {object} metadata of ViewResourceFormat
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ViewResourceFormat',
      type: {
        name: 'Composite',
        className: 'ViewResourceFormat',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          viewName: {
            required: false,
            readOnly: true,
            serializedName: 'properties.viewName',
            type: {
              name: 'String'
            }
          },
          userId: {
            required: false,
            serializedName: 'properties.userId',
            type: {
              name: 'String'
            }
          },
          tenantId: {
            required: false,
            readOnly: true,
            serializedName: 'properties.tenantId',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            serializedName: 'properties.displayName',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          definition: {
            required: true,
            serializedName: 'properties.definition',
            type: {
              name: 'String'
            }
          },
          changed: {
            required: false,
            readOnly: true,
            serializedName: 'properties.changed',
            type: {
              name: 'DateTime'
            }
          },
          created: {
            required: false,
            readOnly: true,
            serializedName: 'properties.created',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = ViewResourceFormat;
