/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The basic account specific properties that are associated with an underlying
 * Data Lake Analytics account.
 *
 */
class DataLakeAnalyticsAccountPropertiesBasic {
  /**
   * Create a DataLakeAnalyticsAccountPropertiesBasic.
   * @member {string} [provisioningState] the provisioning status of the Data
   * Lake Analytics account. Possible values include: 'Failed', 'Creating',
   * 'Running', 'Succeeded', 'Patching', 'Suspending', 'Resuming', 'Deleting',
   * 'Deleted', 'Undeleting', 'Canceled'
   * @member {string} [state] the state of the Data Lake Analytics account.
   * Possible values include: 'Active', 'Suspended'
   * @member {date} [creationTime] the account creation time.
   * @member {date} [lastModifiedTime] the account last modified time.
   * @member {string} [endpoint] the full CName endpoint for this account.
   * @member {uuid} [accountId] The unique identifier associated with this Data
   * Lake Analytics account.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DataLakeAnalyticsAccountPropertiesBasic
   *
   * @returns {object} metadata of DataLakeAnalyticsAccountPropertiesBasic
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DataLakeAnalyticsAccountPropertiesBasic',
      type: {
        name: 'Composite',
        className: 'DataLakeAnalyticsAccountPropertiesBasic',
        modelProperties: {
          provisioningState: {
            required: false,
            readOnly: true,
            serializedName: 'provisioningState',
            type: {
              name: 'Enum',
              allowedValues: [ 'Failed', 'Creating', 'Running', 'Succeeded', 'Patching', 'Suspending', 'Resuming', 'Deleting', 'Deleted', 'Undeleting', 'Canceled' ]
            }
          },
          state: {
            required: false,
            readOnly: true,
            serializedName: 'state',
            type: {
              name: 'Enum',
              allowedValues: [ 'Active', 'Suspended' ]
            }
          },
          creationTime: {
            required: false,
            readOnly: true,
            serializedName: 'creationTime',
            type: {
              name: 'DateTime'
            }
          },
          lastModifiedTime: {
            required: false,
            readOnly: true,
            serializedName: 'lastModifiedTime',
            type: {
              name: 'DateTime'
            }
          },
          endpoint: {
            required: false,
            readOnly: true,
            serializedName: 'endpoint',
            type: {
              name: 'String'
            }
          },
          accountId: {
            required: false,
            readOnly: true,
            serializedName: 'accountId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DataLakeAnalyticsAccountPropertiesBasic;
