/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Azure Storage account information.
 *
 * @extends models['SubResource']
 */
class StorageAccountInfo extends models['SubResource'] {
  /**
   * Create a StorageAccountInfo.
   * @member {string} accessKey the access key associated with this Azure
   * Storage account that will be used to connect to it.
   * @member {string} [suffix] the optional suffix for the storage account.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of StorageAccountInfo
   *
   * @returns {object} metadata of StorageAccountInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'StorageAccountInfo',
      type: {
        name: 'Composite',
        className: 'StorageAccountInfo',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          accessKey: {
            required: true,
            serializedName: 'properties.accessKey',
            type: {
              name: 'String'
            }
          },
          suffix: {
            required: false,
            serializedName: 'properties.suffix',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = StorageAccountInfo;
