/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Storage account parameters for a storage account being updated in a Data
 * Lake Analytics account.
 *
 */
class UpdateStorageAccountParameters {
  /**
   * Create a UpdateStorageAccountParameters.
   * @member {string} [accessKey] the updated access key associated with this
   * Azure Storage account that will be used to connect to it.
   * @member {string} [suffix] the optional suffix for the storage account.
   */
  constructor() {
  }

  /**
   * Defines the metadata of UpdateStorageAccountParameters
   *
   * @returns {object} metadata of UpdateStorageAccountParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UpdateStorageAccountParameters',
      type: {
        name: 'Composite',
        className: 'UpdateStorageAccountParameters',
        modelProperties: {
          accessKey: {
            required: false,
            serializedName: 'properties.accessKey',
            type: {
              name: 'String'
            }
          },
          suffix: {
            required: false,
            serializedName: 'properties.suffix',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = UpdateStorageAccountParameters;
