/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A Data Lake Analytics catalog external table item.
 *
 */
class ExternalTable {
  /**
   * Create a ExternalTable.
   * @member {string} [tableName] the name of the table associated with this
   * database and schema.
   * @member {object} [dataSource] the data source associated with this
   * external table.
   * @member {object} [dataSource.name] the name of the external table
   * associated with this database, schema and table.
   * @member {string} [dataSource.name.firstPart] the name of the table
   * associated with this database and schema.
   * @member {string} [dataSource.name.secondPart] the name of the table
   * associated with this database and schema.
   * @member {string} [dataSource.name.thirdPart] the name of the table
   * associated with this database and schema.
   * @member {string} [dataSource.name.server] the name of the table associated
   * with this database and schema.
   * @member {uuid} [dataSource.version] the version of the external data
   * source.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ExternalTable
   *
   * @returns {object} metadata of ExternalTable
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ExternalTable',
      type: {
        name: 'Composite',
        className: 'ExternalTable',
        modelProperties: {
          tableName: {
            required: false,
            serializedName: 'tableName',
            type: {
              name: 'String'
            }
          },
          dataSource: {
            required: false,
            serializedName: 'dataSource',
            type: {
              name: 'Composite',
              className: 'EntityId'
            }
          }
        }
      }
    };
  }
}

module.exports = ExternalTable;
