/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A Data Lake Analytics catalog U-SQL credential item.
 *
 * @extends models['CatalogItem']
 */
class USqlCredential extends models['CatalogItem'] {
  /**
   * Create a USqlCredential.
   * @member {string} [name] the name of the credential.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of USqlCredential
   *
   * @returns {object} metadata of USqlCredential
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'USqlCredential',
      type: {
        name: 'Composite',
        className: 'USqlCredential',
        modelProperties: {
          computeAccountName: {
            required: false,
            serializedName: 'computeAccountName',
            type: {
              name: 'String'
            }
          },
          version: {
            required: false,
            serializedName: 'version',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'credentialName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = USqlCredential;
