/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The parameters used to build a new Data Lake Analytics job.
 *
 * @extends models['BaseJobParameters']
 */
class BuildJobParameters extends models['BaseJobParameters'] {
  /**
   * Create a BuildJobParameters.
   * @member {string} [name] the friendly name of the job to build.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of BuildJobParameters
   *
   * @returns {object} metadata of BuildJobParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BuildJobParameters',
      type: {
        name: 'Composite',
        className: 'BuildJobParameters',
        modelProperties: {
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'Enum',
              allowedValues: [ 'USql', 'Hive' ]
            }
          },
          properties: {
            required: true,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'type',
                clientName: 'type'
              },
              uberParent: 'CreateJobProperties',
              className: 'CreateJobProperties'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = BuildJobParameters;
