/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The common Data Lake Analytics job properties for job submission.
 *
 */
class CreateJobProperties {
  /**
   * Create a CreateJobProperties.
   * @member {string} [runtimeVersion] the runtime version of the Data Lake
   * Analytics engine to use for the specific type of job being run.
   * @member {string} script the script to run. Please note that the maximum
   * script size is 3 MB.
   * @member {string} type Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of CreateJobProperties
   *
   * @returns {object} metadata of CreateJobProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CreateJobProperties',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'type',
          clientName: 'type'
        },
        uberParent: 'CreateJobProperties',
        className: 'CreateJobProperties',
        modelProperties: {
          runtimeVersion: {
            required: false,
            serializedName: 'runtimeVersion',
            type: {
              name: 'String'
            }
          },
          script: {
            required: true,
            serializedName: 'script',
            type: {
              name: 'String'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CreateJobProperties;
