/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * U-SQL job properties used when submitting U-SQL jobs.
 *
 * @extends models['CreateJobProperties']
 */
class CreateUSqlJobProperties extends models['CreateJobProperties'] {
  /**
   * Create a CreateUSqlJobProperties.
   * @member {string} [compileMode] the specific compilation mode for the job
   * used during execution. If this is not specified during submission, the
   * server will determine the optimal compilation mode. Possible values
   * include: 'Semantic', 'Full', 'SingleBox'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of CreateUSqlJobProperties
   *
   * @returns {object} metadata of CreateUSqlJobProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'USql',
      type: {
        name: 'Composite',
        className: 'CreateUSqlJobProperties',
        modelProperties: {
          runtimeVersion: {
            required: false,
            serializedName: 'runtimeVersion',
            type: {
              name: 'String'
            }
          },
          script: {
            required: true,
            serializedName: 'script',
            type: {
              name: 'String'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          compileMode: {
            required: false,
            serializedName: 'compileMode',
            type: {
              name: 'Enum',
              allowedValues: [ 'Semantic', 'Full', 'SingleBox' ]
            }
          }
        }
      }
    };
  }
}

module.exports = CreateUSqlJobProperties;
