/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Hive job properties used when retrieving Hive jobs.
 *
 * @extends models['JobProperties']
 */
class HiveJobProperties extends models['JobProperties'] {
  /**
   * Create a HiveJobProperties.
   * @member {string} [logsLocation] the Hive logs location
   * @member {string} [outputLocation] the location of Hive job output files
   * (both execution output and results)
   * @member {number} [statementCount] the number of statements that will be
   * run based on the script
   * @member {number} [executedStatementCount] the number of statements that
   * have been run based on the script
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of HiveJobProperties
   *
   * @returns {object} metadata of HiveJobProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Hive',
      type: {
        name: 'Composite',
        className: 'HiveJobProperties',
        modelProperties: {
          runtimeVersion: {
            required: false,
            serializedName: 'runtimeVersion',
            type: {
              name: 'String'
            }
          },
          script: {
            required: true,
            serializedName: 'script',
            type: {
              name: 'String'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          logsLocation: {
            required: false,
            readOnly: true,
            serializedName: 'logsLocation',
            type: {
              name: 'String'
            }
          },
          outputLocation: {
            required: false,
            readOnly: true,
            serializedName: 'outputLocation',
            type: {
              name: 'String'
            }
          },
          statementCount: {
            required: false,
            readOnly: true,
            serializedName: 'statementCount',
            type: {
              name: 'Number'
            }
          },
          executedStatementCount: {
            required: false,
            readOnly: true,
            serializedName: 'executedStatementCount',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = HiveJobProperties;
