/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Job relationship information properties including pipeline information,
 * correlation information, etc.
 *
 */
class JobRelationshipProperties {
  /**
   * Create a JobRelationshipProperties.
   * @member {uuid} [pipelineId] the job relationship pipeline identifier (a
   * GUID).
   * @member {string} [pipelineName] the friendly name of the job relationship
   * pipeline, which does not need to be unique.
   * @member {string} [pipelineUri] the pipeline uri, unique, links to the
   * originating service for this pipeline.
   * @member {uuid} [runId] the run identifier (a GUID), unique identifier of
   * the iteration of this pipeline.
   * @member {uuid} recurrenceId the recurrence identifier (a GUID), unique per
   * activity/script, regardless of iterations. This is something to link
   * different occurrences of the same job together.
   * @member {string} [recurrenceName] the recurrence name, user friendly name
   * for the correlation between jobs.
   */
  constructor() {
  }

  /**
   * Defines the metadata of JobRelationshipProperties
   *
   * @returns {object} metadata of JobRelationshipProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'JobRelationshipProperties',
      type: {
        name: 'Composite',
        className: 'JobRelationshipProperties',
        modelProperties: {
          pipelineId: {
            required: false,
            serializedName: 'pipelineId',
            type: {
              name: 'String'
            }
          },
          pipelineName: {
            required: false,
            serializedName: 'pipelineName',
            constraints: {
              MaxLength: 260
            },
            type: {
              name: 'String'
            }
          },
          pipelineUri: {
            required: false,
            serializedName: 'pipelineUri',
            type: {
              name: 'String'
            }
          },
          runId: {
            required: false,
            serializedName: 'runId',
            type: {
              name: 'String'
            }
          },
          recurrenceId: {
            required: true,
            serializedName: 'recurrenceId',
            type: {
              name: 'String'
            }
          },
          recurrenceName: {
            required: false,
            serializedName: 'recurrenceName',
            constraints: {
              MaxLength: 260
            },
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = JobRelationshipProperties;
