/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The encryption configuration used to update a user managed Key Vault key.
 *
 */
class UpdateEncryptionConfig {
  /**
   * Create a UpdateEncryptionConfig.
   * @member {object} [keyVaultMetaInfo] The updated Key Vault key to use in
   * user managed key rotation.
   * @member {string} [keyVaultMetaInfo.encryptionKeyVersion] The version of
   * the user managed encryption key to update through a key rotation.
   */
  constructor() {
  }

  /**
   * Defines the metadata of UpdateEncryptionConfig
   *
   * @returns {object} metadata of UpdateEncryptionConfig
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UpdateEncryptionConfig',
      type: {
        name: 'Composite',
        className: 'UpdateEncryptionConfig',
        modelProperties: {
          keyVaultMetaInfo: {
            required: false,
            serializedName: 'keyVaultMetaInfo',
            type: {
              name: 'Composite',
              className: 'UpdateKeyVaultMetaInfo'
            }
          }
        }
      }
    };
  }
}

module.exports = UpdateEncryptionConfig;
