/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Data Lake Store file or directory Access Control List information.
 *
 */
class AclStatus {
  /**
   * Create a AclStatus.
   * @member {array} [entries] the list of ACLSpec entries on a file or
   * directory.
   * @member {string} [group] the group owner, an AAD Object ID.
   * @member {string} [owner] the user owner, an AAD Object ID.
   * @member {number} [permission] The octal representation of the unnamed
   * user, mask and other permissions.
   * @member {boolean} [stickyBit] the indicator of whether the sticky bit is
   * on or off.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AclStatus
   *
   * @returns {object} metadata of AclStatus
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AclStatus',
      type: {
        name: 'Composite',
        className: 'AclStatus',
        modelProperties: {
          entries: {
            required: false,
            serializedName: 'entries',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          group: {
            required: false,
            serializedName: 'group',
            type: {
              name: 'String'
            }
          },
          owner: {
            required: false,
            serializedName: 'owner',
            type: {
              name: 'String'
            }
          },
          permission: {
            required: false,
            serializedName: 'permission',
            type: {
              name: 'Number'
            }
          },
          stickyBit: {
            required: false,
            readOnly: true,
            serializedName: 'stickyBit',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = AclStatus;
