/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A WebHDFS exception thrown indicating the append or read is from a bad
 * offset. Thrown when a 400 error response code is returned for append and
 * open operations (Bad request).
 *
 * @extends models['AdlsRemoteException']
 */
class AdlsBadOffsetException extends models['AdlsRemoteException'] {
  /**
   * Create a AdlsBadOffsetException.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AdlsBadOffsetException
   *
   * @returns {object} metadata of AdlsBadOffsetException
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BadOffsetException',
      type: {
        name: 'Composite',
        className: 'AdlsBadOffsetException',
        modelProperties: {
          javaClassName: {
            required: false,
            readOnly: true,
            serializedName: 'javaClassName',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            readOnly: true,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          },
          exception: {
            required: true,
            serializedName: 'exception',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AdlsBadOffsetException;
