/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A WebHDFS exception thrown indicating that the requested operation is not
 * supported. Thrown when a 400 error response code is returned (bad request).
 *
 * @extends models['AdlsRemoteException']
 */
class AdlsUnsupportedOperationException extends models['AdlsRemoteException'] {
  /**
   * Create a AdlsUnsupportedOperationException.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AdlsUnsupportedOperationException
   *
   * @returns {object} metadata of AdlsUnsupportedOperationException
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UnsupportedOperationException',
      type: {
        name: 'Composite',
        className: 'AdlsUnsupportedOperationException',
        modelProperties: {
          javaClassName: {
            required: false,
            readOnly: true,
            serializedName: 'javaClassName',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            readOnly: true,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          },
          exception: {
            required: true,
            serializedName: 'exception',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AdlsUnsupportedOperationException;
