/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Data Lake Store content summary information
 *
 */
class ContentSummary {
  /**
   * Create a ContentSummary.
   * @member {number} [directoryCount] the number of directories.
   * @member {number} [fileCount] the number of files.
   * @member {number} [length] the number of bytes used by the content.
   * @member {number} [spaceConsumed] the disk space consumed by the content.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ContentSummary
   *
   * @returns {object} metadata of ContentSummary
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContentSummary',
      type: {
        name: 'Composite',
        className: 'ContentSummary',
        modelProperties: {
          directoryCount: {
            required: false,
            readOnly: true,
            serializedName: 'directoryCount',
            type: {
              name: 'Number'
            }
          },
          fileCount: {
            required: false,
            readOnly: true,
            serializedName: 'fileCount',
            type: {
              name: 'Number'
            }
          },
          length: {
            required: false,
            readOnly: true,
            serializedName: 'length',
            type: {
              name: 'Number'
            }
          },
          spaceConsumed: {
            required: false,
            readOnly: true,
            serializedName: 'spaceConsumed',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = ContentSummary;
