/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Linked service for Amazon S3.
 *
 * @extends models['LinkedService']
 */
class AmazonS3LinkedService extends models['LinkedService'] {
  /**
   * Create a AmazonS3LinkedService.
   * @member {object} [accessKeyId] The access key identifier of the Amazon S3
   * Identity and Access Management (IAM) user. Type: string (or Expression
   * with resultType string).
   * @member {object} [secretAccessKey] The secret access key of the Amazon S3
   * Identity and Access Management (IAM) user.
   * @member {string} [secretAccessKey.value] Value of secure string.
   * @member {object} [encryptedCredential] The encrypted credential used for
   * authentication. Credentials are encrypted using the integration runtime
   * credential manager. Type: string (or Expression with resultType string).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AmazonS3LinkedService
   *
   * @returns {object} metadata of AmazonS3LinkedService
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AmazonS3',
      type: {
        name: 'Composite',
        className: 'AmazonS3LinkedService',
        modelProperties: {
          connectVia: {
            required: false,
            serializedName: 'connectVia',
            type: {
              name: 'Composite',
              className: 'IntegrationRuntimeReference'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          accessKeyId: {
            required: false,
            serializedName: 'typeProperties.accessKeyId',
            type: {
              name: 'Object'
            }
          },
          secretAccessKey: {
            required: false,
            serializedName: 'typeProperties.secretAccessKey',
            type: {
              name: 'Composite',
              className: 'SecureString'
            }
          },
          encryptedCredential: {
            required: false,
            serializedName: 'typeProperties.encryptedCredential',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = AmazonS3LinkedService;
