/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Azure Key Vault linked service.
 *
 * @extends models['LinkedService']
 */
class AzureKeyVaultLinkedService extends models['LinkedService'] {
  /**
   * Create a AzureKeyVaultLinkedService.
   * @member {object} baseUrl The base URL of the Azure Key Vault. e.g.
   * https://myakv.vault.azure.net Type: string (or Expression with resultType
   * string).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureKeyVaultLinkedService
   *
   * @returns {object} metadata of AzureKeyVaultLinkedService
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureKeyVault',
      type: {
        name: 'Composite',
        className: 'AzureKeyVaultLinkedService',
        modelProperties: {
          connectVia: {
            required: false,
            serializedName: 'connectVia',
            type: {
              name: 'Composite',
              className: 'IntegrationRuntimeReference'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          baseUrl: {
            required: true,
            serializedName: 'typeProperties.baseUrl',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureKeyVaultLinkedService;
