/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Linked service for Windows Azure Search Service.
 *
 * @extends models['LinkedService']
 */
class AzureSearchLinkedService extends models['LinkedService'] {
  /**
   * Create a AzureSearchLinkedService.
   * @member {object} url URL for Azure Search service. Type: string (or
   * Expression with resultType string).
   * @member {object} [key] Admin Key for Azure Search service
   * @member {string} [key.value] Value of secure string.
   * @member {object} [encryptedCredential] The encrypted credential used for
   * authentication. Credentials are encrypted using the integration runtime
   * credential manager. Type: string (or Expression with resultType string).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureSearchLinkedService
   *
   * @returns {object} metadata of AzureSearchLinkedService
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureSearch',
      type: {
        name: 'Composite',
        className: 'AzureSearchLinkedService',
        modelProperties: {
          connectVia: {
            required: false,
            serializedName: 'connectVia',
            type: {
              name: 'Composite',
              className: 'IntegrationRuntimeReference'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          url: {
            required: true,
            serializedName: 'typeProperties.url',
            type: {
              name: 'Object'
            }
          },
          key: {
            required: false,
            serializedName: 'typeProperties.key',
            type: {
              name: 'Composite',
              className: 'SecureString'
            }
          },
          encryptedCredential: {
            required: false,
            serializedName: 'typeProperties.encryptedCredential',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureSearchLinkedService;
