/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A copy activity Azure Table source.
 *
 * @extends models['CopySource']
 */
class AzureTableSource extends models['CopySource'] {
  /**
   * Create a AzureTableSource.
   * @member {object} [azureTableSourceQuery] Azure Table source query. Type:
   * string (or Expression with resultType string).
   * @member {object} [azureTableSourceIgnoreTableNotFound] Azure Table source
   * ignore table not found. Type: boolean (or Expression with resultType
   * boolean).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureTableSource
   *
   * @returns {object} metadata of AzureTableSource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureTableSource',
      type: {
        name: 'Composite',
        className: 'AzureTableSource',
        modelProperties: {
          sourceRetryCount: {
            required: false,
            serializedName: 'sourceRetryCount',
            type: {
              name: 'Object'
            }
          },
          sourceRetryWait: {
            required: false,
            serializedName: 'sourceRetryWait',
            type: {
              name: 'Object'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          azureTableSourceQuery: {
            required: false,
            serializedName: 'azureTableSourceQuery',
            type: {
              name: 'Object'
            }
          },
          azureTableSourceIgnoreTableNotFound: {
            required: false,
            serializedName: 'azureTableSourceIgnoreTableNotFound',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureTableSource;
