/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A copy activity Azure Blob sink.
 *
 * @extends models['CopySink']
 */
class BlobSink extends models['CopySink'] {
  /**
   * Create a BlobSink.
   * @member {object} [blobWriterOverwriteFiles] Blob writer overwrite files.
   * Type: boolean (or Expression with resultType boolean).
   * @member {object} [blobWriterDateTimeFormat] Blob writer date time format.
   * Type: string (or Expression with resultType string).
   * @member {object} [blobWriterAddHeader] Blob writer add header. Type:
   * boolean (or Expression with resultType boolean).
   * @member {string} [copyBehavior] The type of copy behavior for copy sink.
   * Possible values include: 'PreserveHierarchy', 'FlattenHierarchy',
   * 'MergeFiles'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of BlobSink
   *
   * @returns {object} metadata of BlobSink
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BlobSink',
      type: {
        name: 'Composite',
        className: 'BlobSink',
        modelProperties: {
          writeBatchSize: {
            required: false,
            serializedName: 'writeBatchSize',
            type: {
              name: 'Object'
            }
          },
          writeBatchTimeout: {
            required: false,
            serializedName: 'writeBatchTimeout',
            type: {
              name: 'Object'
            }
          },
          sinkRetryCount: {
            required: false,
            serializedName: 'sinkRetryCount',
            type: {
              name: 'Object'
            }
          },
          sinkRetryWait: {
            required: false,
            serializedName: 'sinkRetryWait',
            type: {
              name: 'Object'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          blobWriterOverwriteFiles: {
            required: false,
            serializedName: 'blobWriterOverwriteFiles',
            type: {
              name: 'Object'
            }
          },
          blobWriterDateTimeFormat: {
            required: false,
            serializedName: 'blobWriterDateTimeFormat',
            type: {
              name: 'Object'
            }
          },
          blobWriterAddHeader: {
            required: false,
            serializedName: 'blobWriterAddHeader',
            type: {
              name: 'Object'
            }
          },
          copyBehavior: {
            required: false,
            serializedName: 'copyBehavior',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = BlobSink;
