/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Linked service for Cassandra data source.
 *
 * @extends models['LinkedService']
 */
class CassandraLinkedService extends models['LinkedService'] {
  /**
   * Create a CassandraLinkedService.
   * @member {object} host Host name for connection. Type: string (or
   * Expression with resultType string).
   * @member {object} [authenticationType] AuthenticationType to be used for
   * connection. Type: string (or Expression with resultType string).
   * @member {object} [port] The port for the connection. Type: integer (or
   * Expression with resultType integer).
   * @member {object} [username] Username for authentication. Type: string (or
   * Expression with resultType string).
   * @member {object} [password] Password for authentication.
   * @member {string} [password.value] Value of secure string.
   * @member {object} [encryptedCredential] The encrypted credential used for
   * authentication. Credentials are encrypted using the integration runtime
   * credential manager. Type: string (or Expression with resultType string).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of CassandraLinkedService
   *
   * @returns {object} metadata of CassandraLinkedService
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Cassandra',
      type: {
        name: 'Composite',
        className: 'CassandraLinkedService',
        modelProperties: {
          connectVia: {
            required: false,
            serializedName: 'connectVia',
            type: {
              name: 'Composite',
              className: 'IntegrationRuntimeReference'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          host: {
            required: true,
            serializedName: 'typeProperties.host',
            type: {
              name: 'Object'
            }
          },
          authenticationType: {
            required: false,
            serializedName: 'typeProperties.authenticationType',
            type: {
              name: 'Object'
            }
          },
          port: {
            required: false,
            serializedName: 'typeProperties.port',
            type: {
              name: 'Object'
            }
          },
          username: {
            required: false,
            serializedName: 'typeProperties.username',
            type: {
              name: 'Object'
            }
          },
          password: {
            required: false,
            serializedName: 'typeProperties.password',
            type: {
              name: 'Composite',
              className: 'SecureString'
            }
          },
          encryptedCredential: {
            required: false,
            serializedName: 'typeProperties.encryptedCredential',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = CassandraLinkedService;
