/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The partition definition.
 *
 */
class DatasetPartition {
  /**
   * Create a DatasetPartition.
   * @member {object} [name] Name of the partition. Type: string (or Expression
   * with resultType string).
   * @member {object} [value] Value of the partition.
   * @member {string} [value.type] Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of DatasetPartition
   *
   * @returns {object} metadata of DatasetPartition
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DatasetPartition',
      type: {
        name: 'Composite',
        className: 'DatasetPartition',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'Object'
            }
          },
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'type',
                clientName: 'type'
              },
              uberParent: 'DatasetPartitionValue',
              className: 'DatasetPartitionValue'
            }
          }
        }
      }
    };
  }
}

module.exports = DatasetPartition;
