/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Distcp settings.
 *
 */
class DistcpSettings {
  /**
   * Create a DistcpSettings.
   * @member {object} resourceManagerEndpoint Specifies the Yarn
   * ResourceManager endpoint. Type: string (or Expression with resultType
   * string).
   * @member {object} tempScriptPath Specifies an existing folder path which
   * will be used to store temp Distcp command script. The script file is
   * generated by ADF and will be removed after Copy job finished. Type: string
   * (or Expression with resultType string).
   * @member {object} [distcpOptions] Specifies the Distcp options. Type:
   * string (or Expression with resultType string).
   */
  constructor() {
  }

  /**
   * Defines the metadata of DistcpSettings
   *
   * @returns {object} metadata of DistcpSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DistcpSettings',
      type: {
        name: 'Composite',
        className: 'DistcpSettings',
        modelProperties: {
          resourceManagerEndpoint: {
            required: true,
            serializedName: 'resourceManagerEndpoint',
            type: {
              name: 'Object'
            }
          },
          tempScriptPath: {
            required: true,
            serializedName: 'tempScriptPath',
            type: {
              name: 'Object'
            }
          },
          distcpOptions: {
            required: false,
            serializedName: 'distcpOptions',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = DistcpSettings;
