/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A copy activity Document Database Collection source.
 *
 * @extends models['CopySource']
 */
class DocumentDbCollectionSource extends models['CopySource'] {
  /**
   * Create a DocumentDbCollectionSource.
   * @member {object} [query] Documents query. Type: string (or Expression with
   * resultType string).
   * @member {object} [nestingSeparator] Nested properties separator. Type:
   * string (or Expression with resultType string).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of DocumentDbCollectionSource
   *
   * @returns {object} metadata of DocumentDbCollectionSource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DocumentDbCollectionSource',
      type: {
        name: 'Composite',
        className: 'DocumentDbCollectionSource',
        modelProperties: {
          sourceRetryCount: {
            required: false,
            serializedName: 'sourceRetryCount',
            type: {
              name: 'Object'
            }
          },
          sourceRetryWait: {
            required: false,
            serializedName: 'sourceRetryWait',
            type: {
              name: 'Object'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          query: {
            required: false,
            serializedName: 'query',
            type: {
              name: 'Object'
            }
          },
          nestingSeparator: {
            required: false,
            serializedName: 'nestingSeparator',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = DocumentDbCollectionSource;
