/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The object that defines the structure of an Azure Data Factory response.
 *
 */
class ErrorResponse {
  /**
   * Create a ErrorResponse.
   * @member {string} code Error code.
   * @member {string} message Error message.
   * @member {string} [target] Property name/path in request associated with
   * error.
   * @member {array} [details] Array with additional error details.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ErrorResponse
   *
   * @returns {object} metadata of ErrorResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ErrorResponse',
      type: {
        name: 'Composite',
        className: 'ErrorResponse',
        modelProperties: {
          code: {
            required: true,
            serializedName: 'code',
            type: {
              name: 'String'
            }
          },
          message: {
            required: true,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          },
          target: {
            required: false,
            serializedName: 'target',
            type: {
              name: 'String'
            }
          },
          details: {
            required: false,
            serializedName: 'details',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ErrorResponseElementType',
                  type: {
                    name: 'Composite',
                    className: 'ErrorResponse'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ErrorResponse;
