/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Parameters for updating a factory resource.
 *
 */
class FactoryUpdateParameters {
  /**
   * Create a FactoryUpdateParameters.
   * @member {object} [tags] The resource tags.
   * @member {object} [identity] Managed service identity of the factory.
   * @member {uuid} [identity.principalId] The principal id of the identity.
   * @member {uuid} [identity.tenantId] The client tenant id of the identity.
   */
  constructor() {
  }

  /**
   * Defines the metadata of FactoryUpdateParameters
   *
   * @returns {object} metadata of FactoryUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FactoryUpdateParameters',
      type: {
        name: 'Composite',
        className: 'FactoryUpdateParameters',
        modelProperties: {
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          identity: {
            required: false,
            serializedName: 'identity',
            type: {
              name: 'Composite',
              className: 'FactoryIdentity'
            }
          }
        }
      }
    };
  }
}

module.exports = FactoryUpdateParameters;
