/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A copy activity file system sink.
 *
 * @extends models['CopySink']
 */
class FileSystemSink extends models['CopySink'] {
  /**
   * Create a FileSystemSink.
   * @member {string} [copyBehavior] The type of copy behavior for copy sink.
   * Possible values include: 'PreserveHierarchy', 'FlattenHierarchy',
   * 'MergeFiles'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of FileSystemSink
   *
   * @returns {object} metadata of FileSystemSink
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FileSystemSink',
      type: {
        name: 'Composite',
        className: 'FileSystemSink',
        modelProperties: {
          writeBatchSize: {
            required: false,
            serializedName: 'writeBatchSize',
            type: {
              name: 'Object'
            }
          },
          writeBatchTimeout: {
            required: false,
            serializedName: 'writeBatchTimeout',
            type: {
              name: 'Object'
            }
          },
          sinkRetryCount: {
            required: false,
            serializedName: 'sinkRetryCount',
            type: {
              name: 'Object'
            }
          },
          sinkRetryWait: {
            required: false,
            serializedName: 'sinkRetryWait',
            type: {
              name: 'Object'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          copyBehavior: {
            required: false,
            serializedName: 'copyBehavior',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = FileSystemSink;
