/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A copy activity source for HDFS source.
 *
 * @extends models['CopySource']
 */
class HdfsSource extends models['CopySource'] {
  /**
   * Create a HdfsSource.
   * @member {object} [recursive] If true, files under the folder path will be
   * read recursively. Default is true. Type: boolean (or Expression with
   * resultType boolean).
   * @member {object} [distcpSettings] Specifies Distcp-related settings.
   * @member {object} [distcpSettings.resourceManagerEndpoint] Specifies the
   * Yarn ResourceManager endpoint. Type: string (or Expression with resultType
   * string).
   * @member {object} [distcpSettings.tempScriptPath] Specifies an existing
   * folder path which will be used to store temp Distcp command script. The
   * script file is generated by ADF and will be removed after Copy job
   * finished. Type: string (or Expression with resultType string).
   * @member {object} [distcpSettings.distcpOptions] Specifies the Distcp
   * options. Type: string (or Expression with resultType string).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of HdfsSource
   *
   * @returns {object} metadata of HdfsSource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HdfsSource',
      type: {
        name: 'Composite',
        className: 'HdfsSource',
        modelProperties: {
          sourceRetryCount: {
            required: false,
            serializedName: 'sourceRetryCount',
            type: {
              name: 'Object'
            }
          },
          sourceRetryWait: {
            required: false,
            serializedName: 'sourceRetryWait',
            type: {
              name: 'Object'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          recursive: {
            required: false,
            serializedName: 'recursive',
            type: {
              name: 'Object'
            }
          },
          distcpSettings: {
            required: false,
            serializedName: 'distcpSettings',
            type: {
              name: 'Composite',
              className: 'DistcpSettings'
            }
          }
        }
      }
    };
  }
}

module.exports = HdfsSource;
