/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A copy activity source for an HTTP file.
 *
 * @extends models['CopySource']
 */
class HttpSource extends models['CopySource'] {
  /**
   * Create a HttpSource.
   * @member {object} [httpRequestTimeout] Specifies the timeout for a HTTP
   * client to get HTTP response from HTTP server. The default value is
   * equivalent to System.Net.HttpWebRequest.Timeout. Type: string (or
   * Expression with resultType string), pattern:
   * ((\d+)\.)?(\d\d):(60|([0-5][0-9])):(60|([0-5][0-9])).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of HttpSource
   *
   * @returns {object} metadata of HttpSource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HttpSource',
      type: {
        name: 'Composite',
        className: 'HttpSource',
        modelProperties: {
          sourceRetryCount: {
            required: false,
            serializedName: 'sourceRetryCount',
            type: {
              name: 'Object'
            }
          },
          sourceRetryWait: {
            required: false,
            serializedName: 'sourceRetryWait',
            type: {
              name: 'Object'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          httpRequestTimeout: {
            required: false,
            serializedName: 'httpRequestTimeout',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = HttpSource;
