/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Azure Data Factory nested object which serves as a compute resource for
 * activities.
 *
 */
class IntegrationRuntime {
  /**
   * Create a IntegrationRuntime.
   * @member {string} [description] Integration runtime description.
   * @member {string} type Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of IntegrationRuntime
   *
   * @returns {object} metadata of IntegrationRuntime
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IntegrationRuntime',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'type',
          clientName: 'type'
        },
        uberParent: 'IntegrationRuntime',
        className: 'IntegrationRuntime',
        modelProperties: {
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = IntegrationRuntime;
