/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Get monitoring data response.
 *
 */
class IntegrationRuntimeMonitoringData {
  /**
   * Create a IntegrationRuntimeMonitoringData.
   * @member {string} [name] Integration runtime name.
   * @member {array} [nodes] Integration runtime node monitoring data.
   */
  constructor() {
  }

  /**
   * Defines the metadata of IntegrationRuntimeMonitoringData
   *
   * @returns {object} metadata of IntegrationRuntimeMonitoringData
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IntegrationRuntimeMonitoringData',
      type: {
        name: 'Composite',
        className: 'IntegrationRuntimeMonitoringData',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          nodes: {
            required: false,
            serializedName: 'nodes',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'IntegrationRuntimeNodeMonitoringDataElementType',
                  type: {
                    name: 'Composite',
                    className: 'IntegrationRuntimeNodeMonitoringData'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = IntegrationRuntimeMonitoringData;
