/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Catalog information for managed dedicated integration runtime.
 *
 */
class IntegrationRuntimeSsisCatalogInfo {
  /**
   * Create a IntegrationRuntimeSsisCatalogInfo.
   * @member {string} [catalogServerEndpoint] The catalog database server URL.
   * @member {string} [catalogAdminUserName] The administrator user name of
   * catalog database.
   * @member {object} [catalogAdminPassword] The password of the administrator
   * user account of the catalog database.
   * @member {string} [catalogAdminPassword.value] Value of secure string.
   * @member {string} [catalogPricingTier] The pricing tier for the catalog
   * database. The valid values could be found in
   * https://azure.microsoft.com/en-us/pricing/details/sql-database/. Possible
   * values include: 'Basic', 'Standard', 'Premium', 'PremiumRS'
   */
  constructor() {
  }

  /**
   * Defines the metadata of IntegrationRuntimeSsisCatalogInfo
   *
   * @returns {object} metadata of IntegrationRuntimeSsisCatalogInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IntegrationRuntimeSsisCatalogInfo',
      type: {
        name: 'Composite',
        className: 'IntegrationRuntimeSsisCatalogInfo',
        modelProperties: {
          catalogServerEndpoint: {
            required: false,
            serializedName: 'catalogServerEndpoint',
            type: {
              name: 'String'
            }
          },
          catalogAdminUserName: {
            required: false,
            serializedName: 'catalogAdminUserName',
            type: {
              name: 'String'
            }
          },
          catalogAdminPassword: {
            required: false,
            serializedName: 'catalogAdminPassword',
            type: {
              name: 'Composite',
              className: 'SecureString'
            }
          },
          catalogPricingTier: {
            required: false,
            serializedName: 'catalogPricingTier',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = IntegrationRuntimeSsisCatalogInfo;
