/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * SSIS properties for managed integration runtime.
 *
 */
class IntegrationRuntimeSsisProperties {
  /**
   * Create a IntegrationRuntimeSsisProperties.
   * @member {object} [catalogInfo] Catalog information for managed dedicated
   * integration runtime.
   * @member {string} [catalogInfo.catalogServerEndpoint] The catalog database
   * server URL.
   * @member {string} [catalogInfo.catalogAdminUserName] The administrator user
   * name of catalog database.
   * @member {object} [catalogInfo.catalogAdminPassword] The password of the
   * administrator user account of the catalog database.
   * @member {string} [catalogInfo.catalogAdminPassword.value] Value of secure
   * string.
   * @member {string} [catalogInfo.catalogPricingTier] The pricing tier for the
   * catalog database. The valid values could be found in
   * https://azure.microsoft.com/en-us/pricing/details/sql-database/. Possible
   * values include: 'Basic', 'Standard', 'Premium', 'PremiumRS'
   */
  constructor() {
  }

  /**
   * Defines the metadata of IntegrationRuntimeSsisProperties
   *
   * @returns {object} metadata of IntegrationRuntimeSsisProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IntegrationRuntimeSsisProperties',
      type: {
        name: 'Composite',
        className: 'IntegrationRuntimeSsisProperties',
        modelProperties: {
          catalogInfo: {
            required: false,
            serializedName: 'catalogInfo',
            type: {
              name: 'Composite',
              className: 'IntegrationRuntimeSsisCatalogInfo'
            }
          }
        }
      }
    };
  }
}

module.exports = IntegrationRuntimeSsisProperties;
