/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Open Data Protocol (OData) linked service.
 *
 * @extends models['LinkedService']
 */
class ODataLinkedService extends models['LinkedService'] {
  /**
   * Create a ODataLinkedService.
   * @member {object} url The URL of the OData service endpoint. Type: string
   * (or Expression with resultType string).
   * @member {string} [authenticationType] Type of authentication used to
   * connect to the OData service. Possible values include: 'Basic',
   * 'Anonymous'
   * @member {object} [userName] User name of the OData service. Type: string
   * (or Expression with resultType string).
   * @member {object} [password] Password of the OData service.
   * @member {string} [password.value] Value of secure string.
   * @member {object} [encryptedCredential] The encrypted credential used for
   * authentication. Credentials are encrypted using the integration runtime
   * credential manager. Type: string (or Expression with resultType string).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ODataLinkedService
   *
   * @returns {object} metadata of ODataLinkedService
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OData',
      type: {
        name: 'Composite',
        className: 'ODataLinkedService',
        modelProperties: {
          connectVia: {
            required: false,
            serializedName: 'connectVia',
            type: {
              name: 'Composite',
              className: 'IntegrationRuntimeReference'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          url: {
            required: true,
            serializedName: 'typeProperties.url',
            type: {
              name: 'Object'
            }
          },
          authenticationType: {
            required: false,
            serializedName: 'typeProperties.authenticationType',
            type: {
              name: 'String'
            }
          },
          userName: {
            required: false,
            serializedName: 'typeProperties.userName',
            type: {
              name: 'Object'
            }
          },
          password: {
            required: false,
            serializedName: 'typeProperties.password',
            type: {
              name: 'Composite',
              className: 'SecureString'
            }
          },
          encryptedCredential: {
            required: false,
            serializedName: 'typeProperties.encryptedCredential',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = ODataLinkedService;
