/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A list of operations that can be performed by the Data Factory service.
 *
 */
class OperationListResponse {
  /**
   * Create a OperationListResponse.
   * @member {array} [value] List of Data Factory operations supported by the
   * Data Factory resource provider.
   * @member {string} [nextLink] The link to the next page of results, if any
   * remaining results exist.
   */
  constructor() {
  }

  /**
   * Defines the metadata of OperationListResponse
   *
   * @returns {object} metadata of OperationListResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OperationListResponse',
      type: {
        name: 'Composite',
        className: 'OperationListResponse',
        modelProperties: {
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'OperationElementType',
                  type: {
                    name: 'Composite',
                    className: 'Operation'
                  }
              }
            }
          },
          nextLink: {
            required: false,
            serializedName: 'nextLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = OperationListResponse;
