/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Details about a service operation.
 *
 */
class OperationServiceSpecification {
  /**
   * Create a OperationServiceSpecification.
   * @member {array} [logSpecifications] Details about operations related to
   * logs.
   * @member {array} [metricSpecifications] Details about operations related to
   * metrics.
   */
  constructor() {
  }

  /**
   * Defines the metadata of OperationServiceSpecification
   *
   * @returns {object} metadata of OperationServiceSpecification
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OperationServiceSpecification',
      type: {
        name: 'Composite',
        className: 'OperationServiceSpecification',
        modelProperties: {
          logSpecifications: {
            required: false,
            serializedName: 'logSpecifications',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'OperationLogSpecificationElementType',
                  type: {
                    name: 'Composite',
                    className: 'OperationLogSpecification'
                  }
              }
            }
          },
          metricSpecifications: {
            required: false,
            serializedName: 'metricSpecifications',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'OperationMetricSpecificationElementType',
                  type: {
                    name: 'Composite',
                    className: 'OperationMetricSpecification'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = OperationServiceSpecification;
