/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A copy activity Oracle source.
 *
 * @extends models['CopySource']
 */
class OracleSource extends models['CopySource'] {
  /**
   * Create a OracleSource.
   * @member {object} [oracleReaderQuery] Oracle reader query. Type: string (or
   * Expression with resultType string).
   * @member {object} [queryTimeout] Query timeout. Type: string (or Expression
   * with resultType string), pattern:
   * ((\d+)\.)?(\d\d):(60|([0-5][0-9])):(60|([0-5][0-9])).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of OracleSource
   *
   * @returns {object} metadata of OracleSource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OracleSource',
      type: {
        name: 'Composite',
        className: 'OracleSource',
        modelProperties: {
          sourceRetryCount: {
            required: false,
            serializedName: 'sourceRetryCount',
            type: {
              name: 'Object'
            }
          },
          sourceRetryWait: {
            required: false,
            serializedName: 'sourceRetryWait',
            type: {
              name: 'Object'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          oracleReaderQuery: {
            required: false,
            serializedName: 'oracleReaderQuery',
            type: {
              name: 'Object'
            }
          },
          queryTimeout: {
            required: false,
            serializedName: 'queryTimeout',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = OracleSource;
