/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The relational table dataset.
 *
 * @extends models['Dataset']
 */
class RelationalTableDataset extends models['Dataset'] {
  /**
   * Create a RelationalTableDataset.
   * @member {object} [tableName] The relational table name. Type: string (or
   * Expression with resultType string).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of RelationalTableDataset
   *
   * @returns {object} metadata of RelationalTableDataset
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RelationalTable',
      type: {
        name: 'Composite',
        className: 'RelationalTableDataset',
        modelProperties: {
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          structure: {
            required: false,
            serializedName: 'structure',
            type: {
              name: 'Object'
            }
          },
          linkedServiceName: {
            required: true,
            serializedName: 'linkedServiceName',
            defaultValue: {},
            type: {
              name: 'Composite',
              className: 'LinkedServiceReference'
            }
          },
          parameters: {
            required: false,
            serializedName: 'parameters',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'ParameterSpecificationElementType',
                  type: {
                    name: 'Composite',
                    className: 'ParameterSpecification'
                  }
              }
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          tableName: {
            required: false,
            serializedName: 'typeProperties.tableName',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = RelationalTableDataset;
