/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * SAP HANA Linked Service.
 *
 * @extends models['LinkedService']
 */
class SapHanaLinkedService extends models['LinkedService'] {
  /**
   * Create a SapHanaLinkedService.
   * @member {object} server Host name of the SAP HANA server. Type: string (or
   * Expression with resultType string).
   * @member {string} [authenticationType] The authentication type to be used
   * to connect to the SAP HANA server. Possible values include: 'Basic',
   * 'Windows'
   * @member {object} [userName] Username to access the SAP HANA server. Type:
   * string (or Expression with resultType string).
   * @member {object} [password] Password to access the SAP HANA server.
   * @member {string} [password.value] Value of secure string.
   * @member {object} [encryptedCredential] The encrypted credential used for
   * authentication. Credentials are encrypted using the integration runtime
   * credential manager. Type: string (or Expression with resultType string).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SapHanaLinkedService
   *
   * @returns {object} metadata of SapHanaLinkedService
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SapHana',
      type: {
        name: 'Composite',
        className: 'SapHanaLinkedService',
        modelProperties: {
          connectVia: {
            required: false,
            serializedName: 'connectVia',
            type: {
              name: 'Composite',
              className: 'IntegrationRuntimeReference'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          server: {
            required: true,
            serializedName: 'typeProperties.server',
            type: {
              name: 'Object'
            }
          },
          authenticationType: {
            required: false,
            serializedName: 'typeProperties.authenticationType',
            type: {
              name: 'String'
            }
          },
          userName: {
            required: false,
            serializedName: 'typeProperties.userName',
            type: {
              name: 'Object'
            }
          },
          password: {
            required: false,
            serializedName: 'typeProperties.password',
            type: {
              name: 'Composite',
              className: 'SecureString'
            }
          },
          encryptedCredential: {
            required: false,
            serializedName: 'typeProperties.encryptedCredential',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = SapHanaLinkedService;
