/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A copy activity SQL sink.
 *
 * @extends models['CopySink']
 */
class SqlSink extends models['CopySink'] {
  /**
   * Create a SqlSink.
   * @member {object} [sqlWriterStoredProcedureName] SQL writer stored
   * procedure name. Type: string (or Expression with resultType string).
   * @member {object} [sqlWriterTableType] SQL writer table type. Type: string
   * (or Expression with resultType string).
   * @member {object} [preCopyScript] SQL pre-copy script. Type: string (or
   * Expression with resultType string).
   * @member {object} [storedProcedureParameters] SQL stored procedure
   * parameters.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SqlSink
   *
   * @returns {object} metadata of SqlSink
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SqlSink',
      type: {
        name: 'Composite',
        className: 'SqlSink',
        modelProperties: {
          writeBatchSize: {
            required: false,
            serializedName: 'writeBatchSize',
            type: {
              name: 'Object'
            }
          },
          writeBatchTimeout: {
            required: false,
            serializedName: 'writeBatchTimeout',
            type: {
              name: 'Object'
            }
          },
          sinkRetryCount: {
            required: false,
            serializedName: 'sinkRetryCount',
            type: {
              name: 'Object'
            }
          },
          sinkRetryWait: {
            required: false,
            serializedName: 'sinkRetryWait',
            type: {
              name: 'Object'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          sqlWriterStoredProcedureName: {
            required: false,
            serializedName: 'sqlWriterStoredProcedureName',
            type: {
              name: 'Object'
            }
          },
          sqlWriterTableType: {
            required: false,
            serializedName: 'sqlWriterTableType',
            type: {
              name: 'Object'
            }
          },
          preCopyScript: {
            required: false,
            serializedName: 'preCopyScript',
            type: {
              name: 'Object'
            }
          },
          storedProcedureParameters: {
            required: false,
            serializedName: 'storedProcedureParameters',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StoredProcedureParameterElementType',
                  type: {
                    name: 'Composite',
                    className: 'StoredProcedureParameter'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = SqlSink;
