/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Staging settings.
 *
 */
class StagingSettings {
  /**
   * Create a StagingSettings.
   * @member {object} linkedServiceName Staging linked service reference.
   * @member {string} [linkedServiceName.referenceName] Reference LinkedService
   * name.
   * @member {object} [path] The path to storage for storing the interim data.
   * Type: string (or Expression with resultType string).
   * @member {object} [enableCompression] Specifies whether to use compression
   * when copying data via an interim staging. Default value is false. Type:
   * boolean (or Expression with resultType boolean).
   */
  constructor() {
  }

  /**
   * Defines the metadata of StagingSettings
   *
   * @returns {object} metadata of StagingSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'StagingSettings',
      type: {
        name: 'Composite',
        className: 'StagingSettings',
        modelProperties: {
          linkedServiceName: {
            required: true,
            serializedName: 'linkedServiceName',
            defaultValue: {},
            type: {
              name: 'Composite',
              className: 'LinkedServiceReference'
            }
          },
          path: {
            required: false,
            serializedName: 'path',
            type: {
              name: 'Object'
            }
          },
          enableCompression: {
            required: false,
            serializedName: 'enableCompression',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = StagingSettings;
