/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A WebLinkedService that uses anonymous authentication to communicate with an
 * HTTP endpoint.
 *
 * @extends models['WebLinkedServiceTypeProperties']
 */
class WebAnonymousAuthentication extends models['WebLinkedServiceTypeProperties'] {
  /**
   * Create a WebAnonymousAuthentication.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of WebAnonymousAuthentication
   *
   * @returns {object} metadata of WebAnonymousAuthentication
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Anonymous',
      type: {
        name: 'Composite',
        className: 'WebAnonymousAuthentication',
        modelProperties: {
          url: {
            required: true,
            serializedName: 'url',
            type: {
              name: 'Object'
            }
          },
          authenticationType: {
            required: true,
            serializedName: 'authenticationType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = WebAnonymousAuthentication;
