/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A copy activity source for web page table.
 *
 * @extends models['CopySource']
 */
class WebSource extends models['CopySource'] {
  /**
   * Create a WebSource.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of WebSource
   *
   * @returns {object} metadata of WebSource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'WebSource',
      type: {
        name: 'Composite',
        className: 'WebSource',
        modelProperties: {
          sourceRetryCount: {
            required: false,
            serializedName: 'sourceRetryCount',
            type: {
              name: 'Object'
            }
          },
          sourceRetryWait: {
            required: false,
            serializedName: 'sourceRetryWait',
            type: {
              name: 'Object'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = WebSource;
