/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * An artifact.
 *
 * @extends models['Resource']
 */
class Artifact extends models['Resource'] {
  /**
   * Create a Artifact.
   * @member {string} [title] The artifact's title.
   * @member {string} [description] The artifact's description.
   * @member {string} [publisher] The artifact's publisher.
   * @member {string} [filePath] The file path to the artifact.
   * @member {string} [icon] The URI to the artifact icon.
   * @member {string} [targetOsType] The artifact's target OS.
   * @member {object} [parameters] The artifact's parameters.
   * @member {date} [createdDate] The artifact's creation date.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of Artifact
   *
   * @returns {object} metadata of Artifact
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Artifact',
      type: {
        name: 'Composite',
        className: 'Artifact',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          title: {
            required: false,
            readOnly: true,
            serializedName: 'properties.title',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            readOnly: true,
            serializedName: 'properties.description',
            type: {
              name: 'String'
            }
          },
          publisher: {
            required: false,
            readOnly: true,
            serializedName: 'properties.publisher',
            type: {
              name: 'String'
            }
          },
          filePath: {
            required: false,
            readOnly: true,
            serializedName: 'properties.filePath',
            type: {
              name: 'String'
            }
          },
          icon: {
            required: false,
            readOnly: true,
            serializedName: 'properties.icon',
            type: {
              name: 'String'
            }
          },
          targetOsType: {
            required: false,
            readOnly: true,
            serializedName: 'properties.targetOsType',
            type: {
              name: 'String'
            }
          },
          parameters: {
            required: false,
            readOnly: true,
            serializedName: 'properties.parameters',
            type: {
              name: 'Object'
            }
          },
          createdDate: {
            required: false,
            readOnly: true,
            serializedName: 'properties.createdDate',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = Artifact;
