/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties of an artifact deployment.
 *
 */
class ArtifactDeploymentStatusPropertiesFragment {
  /**
   * Create a ArtifactDeploymentStatusPropertiesFragment.
   * @member {string} [deploymentStatus] The deployment status of the artifact.
   * @member {number} [artifactsApplied] The total count of the artifacts that
   * were successfully applied.
   * @member {number} [totalArtifacts] The total count of the artifacts that
   * were tentatively applied.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ArtifactDeploymentStatusPropertiesFragment
   *
   * @returns {object} metadata of ArtifactDeploymentStatusPropertiesFragment
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ArtifactDeploymentStatusPropertiesFragment',
      type: {
        name: 'Composite',
        className: 'ArtifactDeploymentStatusPropertiesFragment',
        modelProperties: {
          deploymentStatus: {
            required: false,
            serializedName: 'deploymentStatus',
            type: {
              name: 'String'
            }
          },
          artifactsApplied: {
            required: false,
            serializedName: 'artifactsApplied',
            type: {
              name: 'Number'
            }
          },
          totalArtifacts: {
            required: false,
            serializedName: 'totalArtifacts',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = ArtifactDeploymentStatusPropertiesFragment;
