/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Properties for creating a custom image from a virtual machine.
 *
 */
class CustomImagePropertiesFromVm {
  /**
   * Create a CustomImagePropertiesFromVm.
   * @member {string} [sourceVmId] The source vm identifier.
   * @member {object} [windowsOsInfo] The Windows OS information of the VM.
   * @member {string} [windowsOsInfo.windowsOsState] The state of the Windows
   * OS (i.e. NonSysprepped, SysprepRequested, SysprepApplied). Possible values
   * include: 'NonSysprepped', 'SysprepRequested', 'SysprepApplied'
   * @member {object} [linuxOsInfo] The Linux OS information of the VM.
   * @member {string} [linuxOsInfo.linuxOsState] The state of the Linux OS
   * (i.e. NonDeprovisioned, DeprovisionRequested, DeprovisionApplied).
   * Possible values include: 'NonDeprovisioned', 'DeprovisionRequested',
   * 'DeprovisionApplied'
   */
  constructor() {
  }

  /**
   * Defines the metadata of CustomImagePropertiesFromVm
   *
   * @returns {object} metadata of CustomImagePropertiesFromVm
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CustomImagePropertiesFromVm',
      type: {
        name: 'Composite',
        className: 'CustomImagePropertiesFromVm',
        modelProperties: {
          sourceVmId: {
            required: false,
            serializedName: 'sourceVmId',
            type: {
              name: 'String'
            }
          },
          windowsOsInfo: {
            required: false,
            serializedName: 'windowsOsInfo',
            type: {
              name: 'Composite',
              className: 'WindowsOsInfo'
            }
          },
          linuxOsInfo: {
            required: false,
            serializedName: 'linuxOsInfo',
            type: {
              name: 'Composite',
              className: 'LinuxOsInfo'
            }
          }
        }
      }
    };
  }
}

module.exports = CustomImagePropertiesFromVm;
