/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The reference information for an Azure Marketplace image.
 *
 */
class GalleryImageReferenceFragment {
  /**
   * Create a GalleryImageReferenceFragment.
   * @member {string} [offer] The offer of the gallery image.
   * @member {string} [publisher] The publisher of the gallery image.
   * @member {string} [sku] The SKU of the gallery image.
   * @member {string} [osType] The OS type of the gallery image.
   * @member {string} [version] The version of the gallery image.
   */
  constructor() {
  }

  /**
   * Defines the metadata of GalleryImageReferenceFragment
   *
   * @returns {object} metadata of GalleryImageReferenceFragment
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GalleryImageReferenceFragment',
      type: {
        name: 'Composite',
        className: 'GalleryImageReferenceFragment',
        modelProperties: {
          offer: {
            required: false,
            serializedName: 'offer',
            type: {
              name: 'String'
            }
          },
          publisher: {
            required: false,
            serializedName: 'publisher',
            type: {
              name: 'String'
            }
          },
          sku: {
            required: false,
            serializedName: 'sku',
            type: {
              name: 'String'
            }
          },
          osType: {
            required: false,
            serializedName: 'osType',
            type: {
              name: 'String'
            }
          },
          version: {
            required: false,
            serializedName: 'version',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = GalleryImageReferenceFragment;
