/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Parameters for generating an ARM template for deploying artifacts.
 *
 */
class GenerateArmTemplateRequest {
  /**
   * Create a GenerateArmTemplateRequest.
   * @member {string} [virtualMachineName] The resource name of the virtual
   * machine.
   * @member {array} [parameters] The parameters of the ARM template.
   * @member {string} [location] The location of the virtual machine.
   * @member {string} [fileUploadOptions] Options for uploading the files for
   * the artifact. UploadFilesAndGenerateSasTokens is the default value.
   * Possible values include: 'UploadFilesAndGenerateSasTokens', 'None'
   */
  constructor() {
  }

  /**
   * Defines the metadata of GenerateArmTemplateRequest
   *
   * @returns {object} metadata of GenerateArmTemplateRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GenerateArmTemplateRequest',
      type: {
        name: 'Composite',
        className: 'GenerateArmTemplateRequest',
        modelProperties: {
          virtualMachineName: {
            required: false,
            serializedName: 'virtualMachineName',
            type: {
              name: 'String'
            }
          },
          parameters: {
            required: false,
            serializedName: 'parameters',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ParameterInfoElementType',
                  type: {
                    name: 'Composite',
                    className: 'ParameterInfo'
                  }
              }
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          fileUploadOptions: {
            required: false,
            serializedName: 'fileUploadOptions',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = GenerateArmTemplateRequest;
