/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A container for a managed identity to execute DevTest lab services.
 *
 * @extends models['Resource']
 */
class ServiceRunner extends models['Resource'] {
  /**
   * Create a ServiceRunner.
   * @member {object} [identity] The identity of the resource.
   * @member {string} [identity.type] Managed identity.
   * @member {string} [identity.principalId] The principal id of resource
   * identity.
   * @member {string} [identity.tenantId] The tenant identifier of resource.
   * @member {string} [identity.clientSecretUrl] The client secret URL of the
   * identity.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ServiceRunner
   *
   * @returns {object} metadata of ServiceRunner
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ServiceRunner',
      type: {
        name: 'Composite',
        className: 'ServiceRunner',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          identity: {
            required: false,
            serializedName: 'identity',
            type: {
              name: 'Composite',
              className: 'IdentityProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = ServiceRunner;
