/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Properties of a virtual machine that determine how it is connected to a load
 * balancer.
 *
 */
class SharedPublicIpAddressConfigurationFragment {
  /**
   * Create a SharedPublicIpAddressConfigurationFragment.
   * @member {array} [inboundNatRules] The incoming NAT rules
   */
  constructor() {
  }

  /**
   * Defines the metadata of SharedPublicIpAddressConfigurationFragment
   *
   * @returns {object} metadata of SharedPublicIpAddressConfigurationFragment
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SharedPublicIpAddressConfigurationFragment',
      type: {
        name: 'Composite',
        className: 'SharedPublicIpAddressConfigurationFragment',
        modelProperties: {
          inboundNatRules: {
            required: false,
            serializedName: 'inboundNatRules',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'InboundNatRuleFragmentElementType',
                  type: {
                    name: 'Composite',
                    className: 'InboundNatRuleFragment'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = SharedPublicIpAddressConfigurationFragment;
