/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Subnet information.
 *
 */
class Subnet {
  /**
   * Create a Subnet.
   * @member {string} [resourceId] The resource ID of the subnet.
   * @member {string} [labSubnetName] The name of the subnet as seen in the
   * lab.
   * @member {string} [allowPublicIp] The permission policy of the subnet for
   * allowing public IP addresses (i.e. Allow, Deny)). Possible values include:
   * 'Default', 'Deny', 'Allow'
   */
  constructor() {
  }

  /**
   * Defines the metadata of Subnet
   *
   * @returns {object} metadata of Subnet
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Subnet',
      type: {
        name: 'Composite',
        className: 'Subnet',
        modelProperties: {
          resourceId: {
            required: false,
            serializedName: 'resourceId',
            type: {
              name: 'String'
            }
          },
          labSubnetName: {
            required: false,
            serializedName: 'labSubnetName',
            type: {
              name: 'String'
            }
          },
          allowPublicIp: {
            required: false,
            serializedName: 'allowPublicIp',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Subnet;
