/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Configuration for public IP address sharing.
 *
 */
class SubnetSharedPublicIpAddressConfiguration {
  /**
   * Create a SubnetSharedPublicIpAddressConfiguration.
   * @member {array} [allowedPorts] Backend ports that virtual machines on this
   * subnet are allowed to expose
   */
  constructor() {
  }

  /**
   * Defines the metadata of SubnetSharedPublicIpAddressConfiguration
   *
   * @returns {object} metadata of SubnetSharedPublicIpAddressConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SubnetSharedPublicIpAddressConfiguration',
      type: {
        name: 'Composite',
        className: 'SubnetSharedPublicIpAddressConfiguration',
        modelProperties: {
          allowedPorts: {
            required: false,
            serializedName: 'allowedPorts',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'PortElementType',
                  type: {
                    name: 'Composite',
                    className: 'Port'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = SubnetSharedPublicIpAddressConfiguration;
