/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties of a weekly schedule.
 *
 */
class WeekDetails {
  /**
   * Create a WeekDetails.
   * @member {array} [weekdays] The days of the week for which the schedule is
   * set (e.g. Sunday, Monday, Tuesday, etc.).
   * @member {string} [time] The time of the day the schedule will occur.
   */
  constructor() {
  }

  /**
   * Defines the metadata of WeekDetails
   *
   * @returns {object} metadata of WeekDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'WeekDetails',
      type: {
        name: 'Composite',
        className: 'WeekDetails',
        modelProperties: {
          weekdays: {
            required: false,
            serializedName: 'weekdays',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          time: {
            required: false,
            serializedName: 'time',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = WeekDetails;
