/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * @class
 * Initializes a new instance of the DatabaseAccountListConnectionStringsResult class.
 * @constructor
 * The connection strings for the given database account.
 *
 * @member {array} [connectionStrings] An array that contains the connection
 * strings for the DocumentDB account.
 *
 */
class DatabaseAccountListConnectionStringsResult {
  constructor() {
  }

  /**
   * Defines the metadata of DatabaseAccountListConnectionStringsResult
   *
   * @returns {object} metadata of DatabaseAccountListConnectionStringsResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DatabaseAccountListConnectionStringsResult',
      type: {
        name: 'Composite',
        className: 'DatabaseAccountListConnectionStringsResult',
        modelProperties: {
          connectionStrings: {
            required: false,
            serializedName: 'connectionStrings',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'DatabaseAccountConnectionStringElementType',
                  type: {
                    name: 'Composite',
                    className: 'DatabaseAccountConnectionString'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = DatabaseAccountListConnectionStringsResult;
