/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * @class
 * Initializes a new instance of the FailoverPolicies class.
 * @constructor
 * The list of new failover policies for the failover priority change.
 *
 * @member {array} [failoverPolicies] List of failover policies.
 *
 */
class FailoverPolicies {
  constructor() {
  }

  /**
   * Defines the metadata of FailoverPolicies
   *
   * @returns {object} metadata of FailoverPolicies
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FailoverPolicies',
      type: {
        name: 'Composite',
        className: 'FailoverPolicies',
        modelProperties: {
          failoverPolicies: {
            required: false,
            serializedName: 'failoverPolicies',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'FailoverPolicyElementType',
                  type: {
                    name: 'Composite',
                    className: 'FailoverPolicy'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = FailoverPolicies;
