/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the FailoverPolicy class.
 * @constructor
 * The failover policy for a given region of a database account.
 *
 * @member {string} [id] The unique identifier of the region in which the
 * database account replicates to. Example:
 * &lt;accountName&gt;-&lt;locationName&gt;.
 *
 * @member {string} [locationName] The name of the region in which the database
 * account exists.
 *
 * @member {number} [failoverPriority] The failover priority of the region. A
 * failover priority of 0 indicates a write region. The maximum value for a
 * failover priority = (total number of regions - 1). Failover priority values
 * must be unique for each of the regions in which the database account exists.
 *
 */
class FailoverPolicy {
  constructor() {
  }

  /**
   * Defines the metadata of FailoverPolicy
   *
   * @returns {object} metadata of FailoverPolicy
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FailoverPolicy',
      type: {
        name: 'Composite',
        className: 'FailoverPolicy',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          locationName: {
            required: false,
            serializedName: 'locationName',
            type: {
              name: 'String'
            }
          },
          failoverPriority: {
            required: false,
            serializedName: 'failoverPriority',
            constraints: {
              InclusiveMinimum: 0
            },
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = FailoverPolicy;
