/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Information about the event hub destination for an event subscription
 *
 * @extends models['EventSubscriptionDestination']
 */
class EventHubEventSubscriptionDestination extends models['EventSubscriptionDestination'] {
  /**
   * Create a EventHubEventSubscriptionDestination.
   * @member {string} [resourceId] The Azure Resource Id that represents the
   * endpoint of an Event Hub destination of an event subscription.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of EventHubEventSubscriptionDestination
   *
   * @returns {object} metadata of EventHubEventSubscriptionDestination
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EventHub',
      type: {
        name: 'Composite',
        className: 'EventHubEventSubscriptionDestination',
        modelProperties: {
          endpointType: {
            required: true,
            serializedName: 'endpointType',
            type: {
              name: 'String'
            }
          },
          resourceId: {
            required: false,
            serializedName: 'properties.resourceId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = EventHubEventSubscriptionDestination;
