/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Active Directory group information.
 *
 */
class ADGroup {
  /**
   * Create a ADGroup.
   * @member {string} [objectId] The object ID.
   * @member {string} [objectType] The object type.
   * @member {string} [displayName] The display name of the group.
   * @member {boolean} [securityEnabled] Whether the group is security-enable.
   * @member {string} [mail] The primary email address of the group.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ADGroup
   *
   * @returns {object} metadata of ADGroup
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ADGroup',
      type: {
        name: 'Composite',
        className: 'ADGroup',
        modelProperties: {
          objectId: {
            required: false,
            serializedName: 'objectId',
            type: {
              name: 'String'
            }
          },
          objectType: {
            required: false,
            serializedName: 'objectType',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            serializedName: 'displayName',
            type: {
              name: 'String'
            }
          },
          securityEnabled: {
            required: false,
            serializedName: 'securityEnabled',
            type: {
              name: 'Boolean'
            }
          },
          mail: {
            required: false,
            serializedName: 'mail',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ADGroup;
