/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Active Directory Domain information.
 *
 */
class Domain {
  /**
   * Create a Domain.
   * @member {string} [authenticationType] the type of the authentication into
   * the domain.
   * @member {boolean} [isDefault] if this is the default domain in the tenant.
   * @member {boolean} [isVerified] if this domain's ownership is verified.
   * @member {string} name the domain name.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Domain
   *
   * @returns {object} metadata of Domain
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Domain',
      type: {
        name: 'Composite',
        className: 'Domain',
        modelProperties: {
          authenticationType: {
            required: false,
            readOnly: true,
            serializedName: 'authenticationType',
            type: {
              name: 'String'
            }
          },
          isDefault: {
            required: false,
            readOnly: true,
            serializedName: 'isDefault',
            type: {
              name: 'Boolean'
            }
          },
          isVerified: {
            required: false,
            readOnly: true,
            serializedName: 'isVerified',
            type: {
              name: 'Boolean'
            }
          },
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Domain;
