/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Request parameters for the GetObjectsByObjectIds API.
 *
 */
class GetObjectsParameters {
  /**
   * Create a GetObjectsParameters.
   * @member {array} [objectIds] The requested object IDs.
   * @member {array} [types] The requested object types.
   * @member {boolean} includeDirectoryObjectReferences If true, also searches
   * for object IDs in the partner tenant.
   */
  constructor() {
  }

  /**
   * Defines the metadata of GetObjectsParameters
   *
   * @returns {object} metadata of GetObjectsParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GetObjectsParameters',
      type: {
        name: 'Composite',
        className: 'GetObjectsParameters',
        modelProperties: {
          objectIds: {
            required: false,
            serializedName: 'objectIds',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          types: {
            required: false,
            serializedName: 'types',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          includeDirectoryObjectReferences: {
            required: true,
            serializedName: 'includeDirectoryObjectReferences',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = GetObjectsParameters;
