/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Active Directory service principal information.
 *
 */
class ServicePrincipal {
  /**
   * Create a ServicePrincipal.
   * @member {string} [objectId] The object ID.
   * @member {string} [objectType] The object type.
   * @member {string} [displayName] The display name of the service principal.
   * @member {string} [appId] The application ID.
   * @member {array} [servicePrincipalNames] A collection of service principal
   * names.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ServicePrincipal
   *
   * @returns {object} metadata of ServicePrincipal
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ServicePrincipal',
      type: {
        name: 'Composite',
        className: 'ServicePrincipal',
        modelProperties: {
          objectId: {
            required: false,
            serializedName: 'objectId',
            type: {
              name: 'String'
            }
          },
          objectType: {
            required: false,
            serializedName: 'objectType',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            serializedName: 'displayName',
            type: {
              name: 'String'
            }
          },
          appId: {
            required: false,
            serializedName: 'appId',
            type: {
              name: 'String'
            }
          },
          servicePrincipalNames: {
            required: false,
            serializedName: 'servicePrincipalNames',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ServicePrincipal;
