/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Request parameters for creating a new service principal.
 *
 */
class ServicePrincipalCreateParameters {
  /**
   * Create a ServicePrincipalCreateParameters.
   * @member {string} appId application Id
   * @member {boolean} accountEnabled Whether the account is enabled
   * @member {array} [keyCredentials] A collection of KeyCredential objects.
   * @member {array} [passwordCredentials] A collection of PasswordCredential
   * objects
   */
  constructor() {
  }

  /**
   * Defines the metadata of ServicePrincipalCreateParameters
   *
   * @returns {object} metadata of ServicePrincipalCreateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ServicePrincipalCreateParameters',
      type: {
        name: 'Composite',
        className: 'ServicePrincipalCreateParameters',
        modelProperties: {
          appId: {
            required: true,
            serializedName: 'appId',
            type: {
              name: 'String'
            }
          },
          accountEnabled: {
            required: true,
            serializedName: 'accountEnabled',
            type: {
              name: 'Boolean'
            }
          },
          keyCredentials: {
            required: false,
            serializedName: 'keyCredentials',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'KeyCredentialElementType',
                  type: {
                    name: 'Composite',
                    className: 'KeyCredential'
                  }
              }
            }
          },
          passwordCredentials: {
            required: false,
            serializedName: 'passwordCredentials',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'PasswordCredentialElementType',
                  type: {
                    name: 'Composite',
                    className: 'PasswordCredential'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ServicePrincipalCreateParameters;
