/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * HDInsight cluster application
 *
 */
class Application {
  /**
   * Create a Application.
   * @member {object} [id] The resource id for the application
   * @member {string} [id.id] Resource Id
   * @member {string} [name] The name of the application.
   * @member {string} [type] The type of application.
   * @member {string} [etag] The ETag for the application
   * @member {object} [tags] The tags for the application.
   * @member {object} [properties] Gets or sets the properties of the
   * application.
   * @member {object} [properties.computeProfile] The list of roles in the
   * cluster.
   * @member {array} [properties.computeProfile.roles] The list of roles in the
   * cluster.
   * @member {array} [properties.installScriptActions] The list of install
   * script actions.
   * @member {array} [properties.uninstallScriptActions] The list of uninstall
   * script actions.
   * @member {array} [properties.httpsEndpoints] The list of application Https
   * endpoints.
   * @member {array} [properties.sshEndpoints] The list of application ssh
   * endpoints.
   * @member {string} [properties.provisioningState] The provisioning state of
   * the application
   * @member {string} [properties.applicationType] The Application type.
   * @member {string} [properties.applicationState] The Application state.
   * @member {array} [properties.errors] The list of errors.
   * @member {string} [properties.createdDate] The application create date
   * time.
   * @member {string} [properties.marketplaceIdentifier] The Marketplace
   * identifier.
   * @member {string} [properties.additionalProperties] The additional
   * properties for application.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Application
   *
   * @returns {object} metadata of Application
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Application',
      type: {
        name: 'Composite',
        className: 'Application',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'Composite',
              className: 'SubResource'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          etag: {
            required: false,
            serializedName: 'etag',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'ApplicationGetProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = Application;
