/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Gets application Http endpoints.
 *
 */
class ApplicationGetHttpsEndpoint {
  /**
   * Create a ApplicationGetHttpsEndpoint.
   * @member {object} [additionalProperties] Unmatched properties from the
   * message are deserialized this collection
   * @member {array} [accessModes] The list of access modes for the
   * application.
   * @member {string} [location] The location of the endpoint.
   * @member {number} [destinationPort] The destinationPort to connect to.
   * @member {number} [publicPort] The publicPort to connect to.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApplicationGetHttpsEndpoint
   *
   * @returns {object} metadata of ApplicationGetHttpsEndpoint
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplicationGetHttpsEndpoint',
      type: {
        name: 'Composite',
        className: 'ApplicationGetHttpsEndpoint',
        modelProperties: {
          additionalProperties: {
            required: false,
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          accessModes: {
            required: false,
            serializedName: 'accessModes',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          destinationPort: {
            required: false,
            serializedName: 'destinationPort',
            type: {
              name: 'Number'
            }
          },
          publicPort: {
            required: false,
            serializedName: 'publicPort',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = ApplicationGetHttpsEndpoint;
