/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The CreateCluster request parameters.
 *
 */
class ClusterCreateParametersExtended {
  /**
   * Create a ClusterCreateParametersExtended.
   * @member {string} [location] The location of the cluster.
   * @member {object} [tags] The resource tags.
   * @member {object} [properties] The cluster create parameters.
   * @member {string} [properties.clusterVersion] The version of the cluster.
   * @member {string} [properties.osType] The type of operating system.
   * Possible values include: 'Windows', 'Linux'
   * @member {string} [properties.tier] The cluster tier. Possible values
   * include: 'Standard', 'Premium'
   * @member {object} [properties.clusterDefinition] The cluster definition.
   * @member {string} [properties.clusterDefinition.blueprint] The link to the
   * blueprint.
   * @member {string} [properties.clusterDefinition.kind] The type of cluster.
   * @member {object} [properties.clusterDefinition.componentVersion] The
   * versions of different services in the cluster.
   * @member {object} [properties.clusterDefinition.configurations] The cluster
   * configurations.
   * @member {object} [properties.securityProfile] The security profile.
   * @member {string} [properties.securityProfile.directoryType] The directory
   * type. Possible values include: 'ActiveDirectory'
   * @member {string} [properties.securityProfile.domain] domain.
   * @member {string} [properties.securityProfile.organizationalUnitDN]
   * Distinguished Name for organizational unit.
   * @member {array} [properties.securityProfile.ldapsUrls] The LDAP URLs.
   * @member {string} [properties.securityProfile.domainUsername] The domain
   * admin user name.
   * @member {string} [properties.securityProfile.domainUserPassword] The
   * domain admin password.
   * @member {array} [properties.securityProfile.clusterUsersGroupDNs]
   * Optional. The Distinguished Names for cluster user groups
   * @member {object} [properties.computeProfile] The compute profile.
   * @member {array} [properties.computeProfile.roles] The list of roles in the
   * cluster.
   * @member {object} [properties.storageProfile] The storage profile.
   * @member {array} [properties.storageProfile.storageaccounts] The list of
   * storage accounts in the cluster.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ClusterCreateParametersExtended
   *
   * @returns {object} metadata of ClusterCreateParametersExtended
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ClusterCreateParametersExtended',
      type: {
        name: 'Composite',
        className: 'ClusterCreateParametersExtended',
        modelProperties: {
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'ClusterCreateProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = ClusterCreateParametersExtended;
