/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The cluste definition.
 *
 */
class ClusterDefinition {
  /**
   * Create a ClusterDefinition.
   * @member {string} [blueprint] The link to the blueprint.
   * @member {string} [kind] The type of cluster.
   * @member {object} [componentVersion] The versions of different services in
   * the cluster.
   * @member {object} [configurations] The cluster configurations.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ClusterDefinition
   *
   * @returns {object} metadata of ClusterDefinition
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ClusterDefinition',
      type: {
        name: 'Composite',
        className: 'ClusterDefinition',
        modelProperties: {
          blueprint: {
            required: false,
            serializedName: 'blueprint',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          componentVersion: {
            required: false,
            serializedName: 'componentVersion',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          configurations: {
            required: false,
            serializedName: 'configurations',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = ClusterDefinition;
