/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * List PersistedScriptActions operations response.
 *
 */
class ClusterListPersistedScriptActionsResult {
  /**
   * Create a ClusterListPersistedScriptActionsResult.
   * @member {array} [value] The list of Persisted Script Actions.
   * @member {string} [nextLink] The link (url) to the next page of results.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ClusterListPersistedScriptActionsResult
   *
   * @returns {object} metadata of ClusterListPersistedScriptActionsResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ClusterListPersistedScriptActionsResult',
      type: {
        name: 'Composite',
        className: 'ClusterListPersistedScriptActionsResult',
        modelProperties: {
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'RuntimeScriptActionElementType',
                  type: {
                    name: 'Composite',
                    className: 'RuntimeScriptAction'
                  }
              }
            }
          },
          nextLink: {
            required: false,
            readOnly: true,
            serializedName: 'nextLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ClusterListPersistedScriptActionsResult;
