/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The connectivity properties
 *
 */
class ConnectivityEndpoint {
  /**
   * Create a ConnectivityEndpoint.
   * @member {string} [name] The name of the endpoint.
   * @member {string} [protocol] The protocol of the endpoint.
   * @member {string} [location] The location of the endpoint.
   * @member {number} [port] The port to connect to.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ConnectivityEndpoint
   *
   * @returns {object} metadata of ConnectivityEndpoint
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ConnectivityEndpoint',
      type: {
        name: 'Composite',
        className: 'ConnectivityEndpoint',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          protocol: {
            required: false,
            serializedName: 'protocol',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          port: {
            required: false,
            serializedName: 'port',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = ConnectivityEndpoint;
