/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Describes the script actions on a running cluster.
 *
 */
class ExecuteScriptActionParameters {
  /**
   * Create a ExecuteScriptActionParameters.
   * @member {array} [scriptActions] The list of run time script actions.
   * @member {string} persistOnSuccess Gets or sets if the scripts needs to be
   * persisted.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ExecuteScriptActionParameters
   *
   * @returns {object} metadata of ExecuteScriptActionParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ExecuteScriptActionParameters',
      type: {
        name: 'Composite',
        className: 'ExecuteScriptActionParameters',
        modelProperties: {
          scriptActions: {
            required: false,
            serializedName: 'scriptActions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'RuntimeScriptActionElementType',
                  type: {
                    name: 'Composite',
                    className: 'RuntimeScriptAction'
                  }
              }
            }
          },
          persistOnSuccess: {
            required: true,
            serializedName: 'persistOnSuccess',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ExecuteScriptActionParameters;
