/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The payload for a Configure HTTP settings request.
 *
 */
class HttpConnectivitySettings {
  /**
   * Create a HttpConnectivitySettings.
   * @member {string} [enabledCredential] Describes whether HTTP based
   * authorization is enabled or not.
   * @member {string} [username] The http username.
   * @member {string} [password] The http user password.
   */
  constructor() {
  }

  /**
   * Defines the metadata of HttpConnectivitySettings
   *
   * @returns {object} metadata of HttpConnectivitySettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HttpConnectivitySettings',
      type: {
        name: 'Composite',
        className: 'HttpConnectivitySettings',
        modelProperties: {
          enabledCredential: {
            required: false,
            serializedName: 'restAuthCredential\\.isEnabled',
            type: {
              name: 'String'
            }
          },
          username: {
            required: false,
            serializedName: 'restAuthCredential\\.username',
            type: {
              name: 'String'
            }
          },
          password: {
            required: false,
            serializedName: 'restAuthCredential\\.password',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = HttpConnectivitySettings;
