/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The payload for a Configure HTTP settings request.
 *
 */
class HttpSettingsParameters {
  /**
   * Create a HttpSettingsParameters.
   * @member {string} restAuthCredentialisEnabled Whether HTTP auth is enabled
   * or disabled.
   * @member {string} [restAuthCredentialusername] Http username.
   * @member {string} [restAuthCredentialpassword] Http user password.
   */
  constructor() {
  }

  /**
   * Defines the metadata of HttpSettingsParameters
   *
   * @returns {object} metadata of HttpSettingsParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HttpSettingsParameters',
      type: {
        name: 'Composite',
        className: 'HttpSettingsParameters',
        modelProperties: {
          restAuthCredentialisEnabled: {
            required: true,
            serializedName: 'restAuthCredential\\.isEnabled',
            type: {
              name: 'String'
            }
          },
          restAuthCredentialusername: {
            required: false,
            serializedName: 'restAuthCredential\\.username',
            type: {
              name: 'String'
            }
          },
          restAuthCredentialpassword: {
            required: false,
            serializedName: 'restAuthCredential\\.password',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = HttpSettingsParameters;
