/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The regional quota capability.
 *
 */
class QuotaCapability {
  /**
   * Create a QuotaCapability.
   * @member {array} [regionalQuotas] The list of region quota capabilities.
   */
  constructor() {
  }

  /**
   * Defines the metadata of QuotaCapability
   *
   * @returns {object} metadata of QuotaCapability
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'quotaCapability',
      type: {
        name: 'Composite',
        className: 'QuotaCapability',
        modelProperties: {
          regionalQuotas: {
            required: false,
            serializedName: 'regionalQuotas',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'RegionalQuotaCapabilityElementType',
                  type: {
                    name: 'Composite',
                    className: 'RegionalQuotaCapability'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = QuotaCapability;
