/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Parameters specifying the data factory gateway definition for a create or
 * update operation.
 *
 */
class RDPSettingsParameters {
  /**
   * Create a RDPSettingsParameters.
   * @member {object} osProfile The definition of a data factory gateway to be
   * created or updated.
   * @member {object} [osProfile.windowsOperatingSystemProfile] The Windows OS
   * profile.
   * @member {object} [osProfile.windowsOperatingSystemProfile.rdpSettings] The
   * RDP settings.
   * @member {string}
   * [osProfile.windowsOperatingSystemProfile.rdpSettings.username] The
   * username for the RDP user.
   * @member {string}
   * [osProfile.windowsOperatingSystemProfile.rdpSettings.password] The
   * password for the RDP user.
   * @member {date}
   * [osProfile.windowsOperatingSystemProfile.rdpSettings.expiryDate] The RDP
   * expiry date(YYYY-MM-DD).
   * @member {object} [osProfile.linuxOperatingSystemProfile] The Linux OS
   * profile.
   * @member {string} [osProfile.linuxOperatingSystemProfile.username] The
   * username.
   * @member {string} [osProfile.linuxOperatingSystemProfile.password] The
   * password.
   * @member {object} [osProfile.linuxOperatingSystemProfile.sshProfile] The
   * SSH profile.
   * @member {array}
   * [osProfile.linuxOperatingSystemProfile.sshProfile.publicKeys] The list of
   * SSH public keys.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RDPSettingsParameters
   *
   * @returns {object} metadata of RDPSettingsParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RDPSettingsParameters',
      type: {
        name: 'Composite',
        className: 'RDPSettingsParameters',
        modelProperties: {
          osProfile: {
            required: true,
            serializedName: 'osProfile',
            type: {
              name: 'Composite',
              className: 'OsProfile'
            }
          }
        }
      }
    };
  }
}

module.exports = RDPSettingsParameters;
