/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The RDP settings for the windows cluster.
 *
 */
class RdpSettings {
  /**
   * Create a RdpSettings.
   * @member {string} [username] The username for the RDP user.
   * @member {string} [password] The password for the RDP user.
   * @member {date} [expiryDate] The RDP expiry date(YYYY-MM-DD).
   */
  constructor() {
  }

  /**
   * Defines the metadata of RdpSettings
   *
   * @returns {object} metadata of RdpSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RdpSettings',
      type: {
        name: 'Composite',
        className: 'RdpSettings',
        modelProperties: {
          username: {
            required: false,
            serializedName: 'username',
            type: {
              name: 'String'
            }
          },
          password: {
            required: false,
            serializedName: 'password',
            type: {
              name: 'String'
            }
          },
          expiryDate: {
            required: false,
            serializedName: 'expiryDate',
            type: {
              name: 'Date'
            }
          }
        }
      }
    };
  }
}

module.exports = RdpSettings;
