/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The regional quota capacity.
 *
 */
class RegionalQuotaCapability {
  /**
   * Create a RegionalQuotaCapability.
   * @member {string} [regionName] Gets the region name.
   * @member {number} [coresUsed] The number of cores used in the region.
   * @member {number} [coresAvailable] The number of courses available in the
   * region.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RegionalQuotaCapability
   *
   * @returns {object} metadata of RegionalQuotaCapability
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'regionalQuotaCapability',
      type: {
        name: 'Composite',
        className: 'RegionalQuotaCapability',
        modelProperties: {
          regionName: {
            required: false,
            serializedName: 'region_name',
            type: {
              name: 'String'
            }
          },
          coresUsed: {
            required: false,
            serializedName: 'cores_used',
            type: {
              name: 'Number'
            }
          },
          coresAvailable: {
            required: false,
            serializedName: 'cores_available',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = RegionalQuotaCapability;
