/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the execution summary of a script action.
 *
 */
class ScriptActionExecutionSummary {
  /**
   * Create a ScriptActionExecutionSummary.
   * @member {string} [status] The status of script action execution.
   * @member {number} [instanceCount] The instance count for a given script
   * action execution status.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ScriptActionExecutionSummary
   *
   * @returns {object} metadata of ScriptActionExecutionSummary
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ScriptActionExecutionSummary',
      type: {
        name: 'Composite',
        className: 'ScriptActionExecutionSummary',
        modelProperties: {
          status: {
            required: false,
            readOnly: true,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          },
          instanceCount: {
            required: false,
            readOnly: true,
            serializedName: 'instanceCount',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = ScriptActionExecutionSummary;
