/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The persisted script action for cluster
 *
 */
class ScriptActionPersistedGetResponseSpec {
  /**
   * Create a ScriptActionPersistedGetResponseSpec.
   * @member {string} [name] The name of script action.
   * @member {string} [uri] The URI to the script.
   * @member {string} [parameters] The parameters for the script provided.
   * @member {array} [roles] The list of roles where script will be executed.
   * @member {string} [applicationName] The application name for the script
   * action.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ScriptActionPersistedGetResponseSpec
   *
   * @returns {object} metadata of ScriptActionPersistedGetResponseSpec
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ScriptActionPersistedGetResponseSpec',
      type: {
        name: 'Composite',
        className: 'ScriptActionPersistedGetResponseSpec',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          uri: {
            required: false,
            serializedName: 'uri',
            type: {
              name: 'String'
            }
          },
          parameters: {
            required: false,
            serializedName: 'parameters',
            type: {
              name: 'String'
            }
          },
          roles: {
            required: false,
            serializedName: 'roles',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          applicationName: {
            required: false,
            serializedName: 'applicationName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ScriptActionPersistedGetResponseSpec;
