/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The list of Ssh public keys.
 *
 */
class SshProfile {
  /**
   * Create a SshProfile.
   * @member {array} [publicKeys] The list of SSH public keys.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SshProfile
   *
   * @returns {object} metadata of SshProfile
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SshProfile',
      type: {
        name: 'Composite',
        className: 'SshProfile',
        modelProperties: {
          publicKeys: {
            required: false,
            serializedName: 'publicKeys',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'SshPublicKeyElementType',
                  type: {
                    name: 'Composite',
                    className: 'SshPublicKey'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = SshProfile;
