/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Gets or sets Version spec properties.
 *
 */
class VersionSpec {
  /**
   * Create a VersionSpec.
   * @member {string} [friendlyName] Friendly Name
   * @member {string} [displayName] Display Name
   * @member {string} [isDefault] Value true if the version is the default
   * version.
   * @member {object} [componentVersions] The component version property.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VersionSpec
   *
   * @returns {object} metadata of VersionSpec
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'versionSpec',
      type: {
        name: 'Composite',
        className: 'VersionSpec',
        modelProperties: {
          friendlyName: {
            required: false,
            serializedName: 'friendlyName',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            serializedName: 'displayName',
            type: {
              name: 'String'
            }
          },
          isDefault: {
            required: false,
            serializedName: 'isDefault',
            type: {
              name: 'String'
            }
          },
          componentVersions: {
            required: false,
            serializedName: 'componentVersions',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = VersionSpec;
