/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The Windows operation system settings.
 *
 */
class WindowsOperatingSystemProfile {
  /**
   * Create a WindowsOperatingSystemProfile.
   * @member {object} [rdpSettings] The RDP settings.
   * @member {string} [rdpSettings.username] The username for the RDP user.
   * @member {string} [rdpSettings.password] The password for the RDP user.
   * @member {date} [rdpSettings.expiryDate] The RDP expiry date(YYYY-MM-DD).
   */
  constructor() {
  }

  /**
   * Defines the metadata of WindowsOperatingSystemProfile
   *
   * @returns {object} metadata of WindowsOperatingSystemProfile
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'WindowsOperatingSystemProfile',
      type: {
        name: 'Composite',
        className: 'WindowsOperatingSystemProfile',
        modelProperties: {
          rdpSettings: {
            required: false,
            serializedName: 'rdpSettings',
            type: {
              name: 'Composite',
              className: 'RdpSettings'
            }
          }
        }
      }
    };
  }
}

module.exports = WindowsOperatingSystemProfile;
