/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the EventDataCollection class.
 * @constructor
 * Represents collection of events.
 *
 * @member {string} [nextLink] Provides the link to retrive the next set of
 * events.
 *
 */
class EventDataCollection extends Array {
  constructor() {
    super();
  }

  /**
   * Defines the metadata of EventDataCollection
   *
   * @returns {object} metadata of EventDataCollection
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EventDataCollection',
      type: {
        name: 'Composite',
        className: 'EventDataCollection',
        modelProperties: {
          value: {
            required: true,
            serializedName: '',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'EventDataElementType',
                  type: {
                    name: 'Composite',
                    className: 'EventData'
                  }
              }
            }
          },
          nextLink: {
            required: false,
            serializedName: 'nextLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = EventDataCollection;
