/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the EmailNotification class.
 * @constructor
 * Email notification of an autoscale event.
 *
 * @member {boolean} [sendToSubscriptionAdministrator] a value indicating
 * whether to send email to subscription administrator.
 *
 * @member {boolean} [sendToSubscriptionCoAdministrators] a value indicating
 * whether to send email to subscription co-administrators.
 *
 * @member {array} [customEmails] the custom e-mails list. This value can be
 * null or empty, in which case this attribute will be ignored.
 *
 */
class EmailNotification {
  constructor() {
  }

  /**
   * Defines the metadata of EmailNotification
   *
   * @returns {object} metadata of EmailNotification
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EmailNotification',
      type: {
        name: 'Composite',
        className: 'EmailNotification',
        modelProperties: {
          sendToSubscriptionAdministrator: {
            required: false,
            serializedName: 'sendToSubscriptionAdministrator',
            type: {
              name: 'Boolean'
            }
          },
          sendToSubscriptionCoAdministrators: {
            required: false,
            serializedName: 'sendToSubscriptionCoAdministrators',
            type: {
              name: 'Boolean'
            }
          },
          customEmails: {
            required: false,
            serializedName: 'customEmails',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = EmailNotification;
