/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * @class
 * Initializes a new instance of the Device class.
 * @constructor
 * Device entity for Intune.
 *
 * @member {string} userId
 *
 * @member {string} friendlyName
 *
 * @member {string} platform
 *
 * @member {string} platformVersion
 *
 * @member {string} deviceType
 *
 */
class Device extends models['Resource'] {
  constructor() {
    super();
  }

  /**
   * Defines the metadata of Device
   *
   * @returns {object} metadata of Device
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Device',
      type: {
        name: 'Composite',
        className: 'Device',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          userId: {
            required: true,
            serializedName: 'properties.userId',
            type: {
              name: 'String'
            }
          },
          friendlyName: {
            required: true,
            serializedName: 'properties.friendlyName',
            type: {
              name: 'String'
            }
          },
          platform: {
            required: true,
            serializedName: 'properties.platform',
            type: {
              name: 'String'
            }
          },
          platformVersion: {
            required: true,
            serializedName: 'properties.platformVersion',
            type: {
              name: 'String'
            }
          },
          deviceType: {
            required: true,
            serializedName: 'properties.deviceType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Device;
