/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * @class
 * Initializes a new instance of the FlaggedEnrolledApp class.
 * @constructor
 * Flagged Enrolled App for the given tenant.
 *
 * @member {string} [deviceType]
 *
 * @member {string} [friendlyName]
 *
 * @member {string} [lastModifiedTime]
 *
 * @member {string} [platform]
 *
 * @member {array} [errors]
 *
 */
class FlaggedEnrolledApp extends models['Resource'] {
  constructor() {
    super();
  }

  /**
   * Defines the metadata of FlaggedEnrolledApp
   *
   * @returns {object} metadata of FlaggedEnrolledApp
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FlaggedEnrolledApp',
      type: {
        name: 'Composite',
        className: 'FlaggedEnrolledApp',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          deviceType: {
            required: false,
            readOnly: true,
            serializedName: 'properties.deviceType',
            type: {
              name: 'String'
            }
          },
          friendlyName: {
            required: false,
            readOnly: true,
            serializedName: 'properties.friendlyName',
            type: {
              name: 'String'
            }
          },
          lastModifiedTime: {
            required: false,
            readOnly: true,
            serializedName: 'properties.lastModifiedTime',
            type: {
              name: 'String'
            }
          },
          platform: {
            required: false,
            readOnly: true,
            serializedName: 'properties.platform',
            type: {
              name: 'String'
            }
          },
          errors: {
            required: false,
            serializedName: 'properties.errors',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'FlaggedEnrolledAppErrorElementType',
                  type: {
                    name: 'Composite',
                    className: 'FlaggedEnrolledAppError'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = FlaggedEnrolledApp;
