/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * @class
 * Initializes a new instance of the FlaggedUser class.
 * @constructor
 * Flagged user for the given tenant.
 *
 * @member {number} [errorCount]
 *
 * @member {string} [friendlyName]
 *
 */
class FlaggedUser extends models['Resource'] {
  constructor() {
    super();
  }

  /**
   * Defines the metadata of FlaggedUser
   *
   * @returns {object} metadata of FlaggedUser
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FlaggedUser',
      type: {
        name: 'Composite',
        className: 'FlaggedUser',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          errorCount: {
            required: false,
            readOnly: true,
            serializedName: 'properties.errorCount',
            type: {
              name: 'Number'
            }
          },
          friendlyName: {
            required: false,
            readOnly: true,
            serializedName: 'properties.friendlyName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = FlaggedUser;
