/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The properties of the provisioned Event Hub-compatible endpoint used by the
 * IoT hub.
 *
 */
class EventHubProperties {
  /**
   * Create a EventHubProperties.
   * @member {number} [retentionTimeInDays] The retention time for
   * device-to-cloud messages in days. See:
   * https://docs.microsoft.com/azure/iot-hub/iot-hub-devguide-messaging#device-to-cloud-messages
   * @member {number} [partitionCount] The number of paritions for receiving
   * device-to-cloud messages in the Event Hub-compatible endpoint. See:
   * https://docs.microsoft.com/azure/iot-hub/iot-hub-devguide-messaging#device-to-cloud-messages.
   * @member {array} [partitionIds] The partition ids in the Event
   * Hub-compatible endpoint.
   * @member {string} [path] The Event Hub-compatible name.
   * @member {string} [endpoint] The Event Hub-compatible endpoint.
   */
  constructor() {
  }

  /**
   * Defines the metadata of EventHubProperties
   *
   * @returns {object} metadata of EventHubProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EventHubProperties',
      type: {
        name: 'Composite',
        className: 'EventHubProperties',
        modelProperties: {
          retentionTimeInDays: {
            required: false,
            serializedName: 'retentionTimeInDays',
            type: {
              name: 'Number'
            }
          },
          partitionCount: {
            required: false,
            serializedName: 'partitionCount',
            type: {
              name: 'Number'
            }
          },
          partitionIds: {
            required: false,
            readOnly: true,
            serializedName: 'partitionIds',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          path: {
            required: false,
            readOnly: true,
            serializedName: 'path',
            type: {
              name: 'String'
            }
          },
          endpoint: {
            required: false,
            readOnly: true,
            serializedName: 'endpoint',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = EventHubProperties;
