/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Use to provide parameters when requesting an import of all devices in the
 * hub.
 *
 */
class ImportDevicesRequest {
  /**
   * Create a ImportDevicesRequest.
   * @member {string} inputBlobContainerUri The input blob container URI.
   * @member {string} outputBlobContainerUri The output blob container URI.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ImportDevicesRequest
   *
   * @returns {object} metadata of ImportDevicesRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ImportDevicesRequest',
      type: {
        name: 'Composite',
        className: 'ImportDevicesRequest',
        modelProperties: {
          inputBlobContainerUri: {
            required: true,
            serializedName: 'InputBlobContainerUri',
            type: {
              name: 'String'
            }
          },
          outputBlobContainerUri: {
            required: true,
            serializedName: 'OutputBlobContainerUri',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ImportDevicesRequest;
