/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * SKU properties.
 *
 */
class IotHubSkuDescription {
  /**
   * Create a IotHubSkuDescription.
   * @member {string} [resourceType] The type of the resource.
   * @member {object} sku
   * @member {string} [sku.name] The name of the SKU. Possible values include:
   * 'F1', 'S1', 'S2', 'S3'
   * @member {string} [sku.tier] The billing tier for the IoT hub. Possible
   * values include: 'Free', 'Standard'
   * @member {number} [sku.capacity] The number of provisioned IoT Hub units.
   * See:
   * https://docs.microsoft.com/azure/azure-subscription-service-limits#iot-hub-limits.
   * @member {object} capacity
   * @member {number} [capacity.minimum] The minimum number of units.
   * @member {number} [capacity.maximum] The maximum number of units.
   * @member {number} [capacity.default] The default number of units.
   * @member {string} [capacity.scaleType] The type of the scaling enabled.
   * Possible values include: 'Automatic', 'Manual', 'None'
   */
  constructor() {
  }

  /**
   * Defines the metadata of IotHubSkuDescription
   *
   * @returns {object} metadata of IotHubSkuDescription
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IotHubSkuDescription',
      type: {
        name: 'Composite',
        className: 'IotHubSkuDescription',
        modelProperties: {
          resourceType: {
            required: false,
            readOnly: true,
            serializedName: 'resourceType',
            type: {
              name: 'String'
            }
          },
          sku: {
            required: true,
            serializedName: 'sku',
            type: {
              name: 'Composite',
              className: 'IotHubSkuInfo'
            }
          },
          capacity: {
            required: true,
            serializedName: 'capacity',
            type: {
              name: 'Composite',
              className: 'IotHubCapacity'
            }
          }
        }
      }
    };
  }
}

module.exports = IotHubSkuDescription;
