/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Information about the SKU of the IoT hub.
 *
 */
class IotHubSkuInfo {
  /**
   * Create a IotHubSkuInfo.
   * @member {string} name The name of the SKU. Possible values include: 'F1',
   * 'S1', 'S2', 'S3'
   * @member {string} [tier] The billing tier for the IoT hub. Possible values
   * include: 'Free', 'Standard'
   * @member {number} capacity The number of provisioned IoT Hub units. See:
   * https://docs.microsoft.com/azure/azure-subscription-service-limits#iot-hub-limits.
   */
  constructor() {
  }

  /**
   * Defines the metadata of IotHubSkuInfo
   *
   * @returns {object} metadata of IotHubSkuInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IotHubSkuInfo',
      type: {
        name: 'Composite',
        className: 'IotHubSkuInfo',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          tier: {
            required: false,
            readOnly: true,
            serializedName: 'tier',
            type: {
              name: 'Enum',
              allowedValues: [ 'Free', 'Standard' ]
            }
          },
          capacity: {
            required: true,
            serializedName: 'capacity',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = IotHubSkuInfo;
