/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The IP filter rules for the IoT hub.
 *
 */
class IpFilterRule {
  /**
   * Create a IpFilterRule.
   * @member {string} filterName The name of the IP filter rule.
   * @member {string} action The desired action for requests captured by this
   * rule. Possible values include: 'Accept', 'Reject'
   * @member {string} ipMask A string that contains the IP address range in
   * CIDR notation for the rule.
   */
  constructor() {
  }

  /**
   * Defines the metadata of IpFilterRule
   *
   * @returns {object} metadata of IpFilterRule
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IpFilterRule',
      type: {
        name: 'Composite',
        className: 'IpFilterRule',
        modelProperties: {
          filterName: {
            required: true,
            serializedName: 'filterName',
            type: {
              name: 'String'
            }
          },
          action: {
            required: true,
            serializedName: 'action',
            type: {
              name: 'Enum',
              allowedValues: [ 'Accept', 'Reject' ]
            }
          },
          ipMask: {
            required: true,
            serializedName: 'ipMask',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = IpFilterRule;
