/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The properties of the Job Response object.
 *
 */
class JobResponse {
  /**
   * Create a JobResponse.
   * @member {string} [jobId] The job identifier.
   * @member {date} [startTimeUtc] The start time of the job.
   * @member {date} [endTimeUtc] The time the job stopped processing.
   * @member {string} [type] The type of the job. Possible values include:
   * 'unknown', 'export', 'import', 'backup', 'readDeviceProperties',
   * 'writeDeviceProperties', 'updateDeviceConfiguration', 'rebootDevice',
   * 'factoryResetDevice', 'firmwareUpdate'
   * @member {string} [status] The status of the job. Possible values include:
   * 'unknown', 'enqueued', 'running', 'completed', 'failed', 'cancelled'
   * @member {string} [failureReason] If status == failed, this string
   * containing the reason for the failure.
   * @member {string} [statusMessage] The status message for the job.
   * @member {string} [parentJobId] The job identifier of the parent job, if
   * any.
   */
  constructor() {
  }

  /**
   * Defines the metadata of JobResponse
   *
   * @returns {object} metadata of JobResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'JobResponse',
      type: {
        name: 'Composite',
        className: 'JobResponse',
        modelProperties: {
          jobId: {
            required: false,
            readOnly: true,
            serializedName: 'jobId',
            type: {
              name: 'String'
            }
          },
          startTimeUtc: {
            required: false,
            readOnly: true,
            serializedName: 'startTimeUtc',
            type: {
              name: 'DateTimeRfc1123'
            }
          },
          endTimeUtc: {
            required: false,
            readOnly: true,
            serializedName: 'endTimeUtc',
            type: {
              name: 'DateTimeRfc1123'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            readOnly: true,
            serializedName: 'status',
            type: {
              name: 'Enum',
              allowedValues: [ 'unknown', 'enqueued', 'running', 'completed', 'failed', 'cancelled' ]
            }
          },
          failureReason: {
            required: false,
            readOnly: true,
            serializedName: 'failureReason',
            type: {
              name: 'String'
            }
          },
          statusMessage: {
            required: false,
            readOnly: true,
            serializedName: 'statusMessage',
            type: {
              name: 'String'
            }
          },
          parentJobId: {
            required: false,
            readOnly: true,
            serializedName: 'parentJobId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = JobResponse;
