/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Deleted vault information with extended details.
 *
 */
class DeletedVault {
  /**
   * Create a DeletedVault.
   * @member {string} [id] The resource ID for the deleted key vault.
   * @member {string} [name] The name of the key vault.
   * @member {string} [type] The resource type of the key vault.
   * @member {object} [properties] Properties of the vault
   * @member {string} [properties.vaultId] The resource id of the original
   * vault.
   * @member {string} [properties.location] The location of the original vault.
   * @member {date} [properties.deletionDate] The deleted date.
   * @member {date} [properties.scheduledPurgeDate] The scheduled purged date.
   * @member {object} [properties.tags] Tags of the original vault.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DeletedVault
   *
   * @returns {object} metadata of DeletedVault
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DeletedVault',
      type: {
        name: 'Composite',
        className: 'DeletedVault',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'DeletedVaultProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = DeletedVault;
