/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties of the deleted vault.
 *
 */
class DeletedVaultProperties {
  /**
   * Create a DeletedVaultProperties.
   * @member {string} [vaultId] The resource id of the original vault.
   * @member {string} [location] The location of the original vault.
   * @member {date} [deletionDate] The deleted date.
   * @member {date} [scheduledPurgeDate] The scheduled purged date.
   * @member {object} [tags] Tags of the original vault.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DeletedVaultProperties
   *
   * @returns {object} metadata of DeletedVaultProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DeletedVaultProperties',
      type: {
        name: 'Composite',
        className: 'DeletedVaultProperties',
        modelProperties: {
          vaultId: {
            required: false,
            readOnly: true,
            serializedName: 'vaultId',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            readOnly: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          deletionDate: {
            required: false,
            readOnly: true,
            serializedName: 'deletionDate',
            type: {
              name: 'DateTime'
            }
          },
          scheduledPurgeDate: {
            required: false,
            readOnly: true,
            serializedName: 'scheduledPurgeDate',
            type: {
              name: 'DateTime'
            }
          },
          tags: {
            required: false,
            readOnly: true,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = DeletedVaultProperties;
