/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The integration account AS2 agreement content.
 *
 */
class AS2AgreementContent {
  /**
   * Create a AS2AgreementContent.
   * @member {object} receiveAgreement The AS2 one-way receive agreement.
   * @member {object} [receiveAgreement.senderBusinessIdentity] The sender
   * business identity
   * @member {string} [receiveAgreement.senderBusinessIdentity.qualifier] The
   * business identity qualifier e.g. as2identity, ZZ, ZZZ, 31, 32
   * @member {string} [receiveAgreement.senderBusinessIdentity.value] The user
   * defined business identity value.
   * @member {object} [receiveAgreement.receiverBusinessIdentity] The receiver
   * business identity
   * @member {string} [receiveAgreement.receiverBusinessIdentity.qualifier] The
   * business identity qualifier e.g. as2identity, ZZ, ZZZ, 31, 32
   * @member {string} [receiveAgreement.receiverBusinessIdentity.value] The
   * user defined business identity value.
   * @member {object} [receiveAgreement.protocolSettings] The AS2 protocol
   * settings.
   * @member {object}
   * [receiveAgreement.protocolSettings.messageConnectionSettings] The message
   * connection settings.
   * @member {boolean}
   * [receiveAgreement.protocolSettings.messageConnectionSettings.ignoreCertificateNameMismatch]
   * The value indicating whether to ignore mismatch in certificate name.
   * @member {boolean}
   * [receiveAgreement.protocolSettings.messageConnectionSettings.supportHttpStatusCodeContinue]
   * The value indicating whether to support HTTP status code 'CONTINUE'.
   * @member {boolean}
   * [receiveAgreement.protocolSettings.messageConnectionSettings.keepHttpConnectionAlive]
   * The value indicating whether to keep the connection alive.
   * @member {boolean}
   * [receiveAgreement.protocolSettings.messageConnectionSettings.unfoldHttpHeaders]
   * The value indicating whether to unfold the HTTP headers.
   * @member {object}
   * [receiveAgreement.protocolSettings.acknowledgementConnectionSettings] The
   * acknowledgement connection settings.
   * @member {boolean}
   * [receiveAgreement.protocolSettings.acknowledgementConnectionSettings.ignoreCertificateNameMismatch]
   * The value indicating whether to ignore mismatch in certificate name.
   * @member {boolean}
   * [receiveAgreement.protocolSettings.acknowledgementConnectionSettings.supportHttpStatusCodeContinue]
   * The value indicating whether to support HTTP status code 'CONTINUE'.
   * @member {boolean}
   * [receiveAgreement.protocolSettings.acknowledgementConnectionSettings.keepHttpConnectionAlive]
   * The value indicating whether to keep the connection alive.
   * @member {boolean}
   * [receiveAgreement.protocolSettings.acknowledgementConnectionSettings.unfoldHttpHeaders]
   * The value indicating whether to unfold the HTTP headers.
   * @member {object} [receiveAgreement.protocolSettings.mdnSettings] The MDN
   * settings.
   * @member {boolean} [receiveAgreement.protocolSettings.mdnSettings.needMdn]
   * The value indicating whether to send or request a MDN.
   * @member {boolean} [receiveAgreement.protocolSettings.mdnSettings.signMdn]
   * The value indicating whether the MDN needs to be signed or not.
   * @member {boolean}
   * [receiveAgreement.protocolSettings.mdnSettings.sendMdnAsynchronously] The
   * value indicating whether to send the asynchronous MDN.
   * @member {string}
   * [receiveAgreement.protocolSettings.mdnSettings.receiptDeliveryUrl] The
   * receipt delivery URL.
   * @member {string}
   * [receiveAgreement.protocolSettings.mdnSettings.dispositionNotificationTo]
   * The disposition notification to header value.
   * @member {boolean}
   * [receiveAgreement.protocolSettings.mdnSettings.signOutboundMdnIfOptional]
   * The value indicating whether to sign the outbound MDN if optional.
   * @member {string} [receiveAgreement.protocolSettings.mdnSettings.mdnText]
   * The MDN text.
   * @member {boolean}
   * [receiveAgreement.protocolSettings.mdnSettings.sendInboundMdnToMessageBox]
   * The value indicating whether to send inbound MDN to message box.
   * @member {string}
   * [receiveAgreement.protocolSettings.mdnSettings.micHashingAlgorithm] The
   * signing or hashing algorithm. Possible values include: 'NotSpecified',
   * 'None', 'MD5', 'SHA1', 'SHA2256', 'SHA2384', 'SHA2512'
   * @member {object} [receiveAgreement.protocolSettings.securitySettings] The
   * security settings.
   * @member {boolean}
   * [receiveAgreement.protocolSettings.securitySettings.overrideGroupSigningCertificate]
   * The value indicating whether to send or request a MDN.
   * @member {string}
   * [receiveAgreement.protocolSettings.securitySettings.signingCertificateName]
   * The name of the signing certificate.
   * @member {string}
   * [receiveAgreement.protocolSettings.securitySettings.encryptionCertificateName]
   * The name of the encryption certificate.
   * @member {boolean}
   * [receiveAgreement.protocolSettings.securitySettings.enableNrrForInboundEncodedMessages]
   * The value indicating whether to enable NRR for inbound encoded messages.
   * @member {boolean}
   * [receiveAgreement.protocolSettings.securitySettings.enableNrrForInboundDecodedMessages]
   * The value indicating whether to enable NRR for inbound decoded messages.
   * @member {boolean}
   * [receiveAgreement.protocolSettings.securitySettings.enableNrrForOutboundMdn]
   * The value indicating whether to enable NRR for outbound MDN.
   * @member {boolean}
   * [receiveAgreement.protocolSettings.securitySettings.enableNrrForOutboundEncodedMessages]
   * The value indicating whether to enable NRR for outbound encoded messages.
   * @member {boolean}
   * [receiveAgreement.protocolSettings.securitySettings.enableNrrForOutboundDecodedMessages]
   * The value indicating whether to enable NRR for outbound decoded messages.
   * @member {boolean}
   * [receiveAgreement.protocolSettings.securitySettings.enableNrrForInboundMdn]
   * The value indicating whether to enable NRR for inbound MDN.
   * @member {string}
   * [receiveAgreement.protocolSettings.securitySettings.sha2AlgorithmFormat]
   * The Sha2 algorithm format. Valid values are Sha2, ShaHashSize,
   * ShaHyphenHashSize, Sha2UnderscoreHashSize.
   * @member {object} [receiveAgreement.protocolSettings.validationSettings]
   * The validation settings.
   * @member {boolean}
   * [receiveAgreement.protocolSettings.validationSettings.overrideMessageProperties]
   * The value indicating whether to override incoming message properties with
   * those in agreement.
   * @member {boolean}
   * [receiveAgreement.protocolSettings.validationSettings.encryptMessage] The
   * value indicating whether the message has to be encrypted.
   * @member {boolean}
   * [receiveAgreement.protocolSettings.validationSettings.signMessage] The
   * value indicating whether the message has to be signed.
   * @member {boolean}
   * [receiveAgreement.protocolSettings.validationSettings.compressMessage] The
   * value indicating whether the message has to be compressed.
   * @member {boolean}
   * [receiveAgreement.protocolSettings.validationSettings.checkDuplicateMessage]
   * The value indicating whether to check for duplicate message.
   * @member {number}
   * [receiveAgreement.protocolSettings.validationSettings.interchangeDuplicatesValidityDays]
   * The number of days to look back for duplicate interchange.
   * @member {boolean}
   * [receiveAgreement.protocolSettings.validationSettings.checkCertificateRevocationListOnSend]
   * The value indicating whether to check for certificate revocation list on
   * send.
   * @member {boolean}
   * [receiveAgreement.protocolSettings.validationSettings.checkCertificateRevocationListOnReceive]
   * The value indicating whether to check for certificate revocation list on
   * receive.
   * @member {string}
   * [receiveAgreement.protocolSettings.validationSettings.encryptionAlgorithm]
   * The encryption algorithm. Possible values include: 'NotSpecified', 'None',
   * 'DES3', 'RC2', 'AES128', 'AES192', 'AES256'
   * @member {string}
   * [receiveAgreement.protocolSettings.validationSettings.signingAlgorithm]
   * The signing algorithm. Possible values include: 'NotSpecified', 'Default',
   * 'SHA1', 'SHA2256', 'SHA2384', 'SHA2512'
   * @member {object} [receiveAgreement.protocolSettings.envelopeSettings] The
   * envelope settings.
   * @member {string}
   * [receiveAgreement.protocolSettings.envelopeSettings.messageContentType]
   * The message content type.
   * @member {boolean}
   * [receiveAgreement.protocolSettings.envelopeSettings.transmitFileNameInMimeHeader]
   * The value indicating whether to transmit file name in mime header.
   * @member {string}
   * [receiveAgreement.protocolSettings.envelopeSettings.fileNameTemplate] The
   * template for file name.
   * @member {boolean}
   * [receiveAgreement.protocolSettings.envelopeSettings.suspendMessageOnFileNameGenerationError]
   * The value indicating whether to suspend message on file name generation
   * error.
   * @member {boolean}
   * [receiveAgreement.protocolSettings.envelopeSettings.autogenerateFileName]
   * The value indicating whether to auto generate file name.
   * @member {object} [receiveAgreement.protocolSettings.errorSettings] The
   * error settings.
   * @member {boolean}
   * [receiveAgreement.protocolSettings.errorSettings.suspendDuplicateMessage]
   * The value indicating whether to suspend duplicate message.
   * @member {boolean}
   * [receiveAgreement.protocolSettings.errorSettings.resendIfMdnNotReceived]
   * The value indicating whether to resend message If MDN is not received.
   * @member {object} sendAgreement The AS2 one-way send agreement.
   * @member {object} [sendAgreement.senderBusinessIdentity] The sender
   * business identity
   * @member {string} [sendAgreement.senderBusinessIdentity.qualifier] The
   * business identity qualifier e.g. as2identity, ZZ, ZZZ, 31, 32
   * @member {string} [sendAgreement.senderBusinessIdentity.value] The user
   * defined business identity value.
   * @member {object} [sendAgreement.receiverBusinessIdentity] The receiver
   * business identity
   * @member {string} [sendAgreement.receiverBusinessIdentity.qualifier] The
   * business identity qualifier e.g. as2identity, ZZ, ZZZ, 31, 32
   * @member {string} [sendAgreement.receiverBusinessIdentity.value] The user
   * defined business identity value.
   * @member {object} [sendAgreement.protocolSettings] The AS2 protocol
   * settings.
   * @member {object}
   * [sendAgreement.protocolSettings.messageConnectionSettings] The message
   * connection settings.
   * @member {boolean}
   * [sendAgreement.protocolSettings.messageConnectionSettings.ignoreCertificateNameMismatch]
   * The value indicating whether to ignore mismatch in certificate name.
   * @member {boolean}
   * [sendAgreement.protocolSettings.messageConnectionSettings.supportHttpStatusCodeContinue]
   * The value indicating whether to support HTTP status code 'CONTINUE'.
   * @member {boolean}
   * [sendAgreement.protocolSettings.messageConnectionSettings.keepHttpConnectionAlive]
   * The value indicating whether to keep the connection alive.
   * @member {boolean}
   * [sendAgreement.protocolSettings.messageConnectionSettings.unfoldHttpHeaders]
   * The value indicating whether to unfold the HTTP headers.
   * @member {object}
   * [sendAgreement.protocolSettings.acknowledgementConnectionSettings] The
   * acknowledgement connection settings.
   * @member {boolean}
   * [sendAgreement.protocolSettings.acknowledgementConnectionSettings.ignoreCertificateNameMismatch]
   * The value indicating whether to ignore mismatch in certificate name.
   * @member {boolean}
   * [sendAgreement.protocolSettings.acknowledgementConnectionSettings.supportHttpStatusCodeContinue]
   * The value indicating whether to support HTTP status code 'CONTINUE'.
   * @member {boolean}
   * [sendAgreement.protocolSettings.acknowledgementConnectionSettings.keepHttpConnectionAlive]
   * The value indicating whether to keep the connection alive.
   * @member {boolean}
   * [sendAgreement.protocolSettings.acknowledgementConnectionSettings.unfoldHttpHeaders]
   * The value indicating whether to unfold the HTTP headers.
   * @member {object} [sendAgreement.protocolSettings.mdnSettings] The MDN
   * settings.
   * @member {boolean} [sendAgreement.protocolSettings.mdnSettings.needMdn] The
   * value indicating whether to send or request a MDN.
   * @member {boolean} [sendAgreement.protocolSettings.mdnSettings.signMdn] The
   * value indicating whether the MDN needs to be signed or not.
   * @member {boolean}
   * [sendAgreement.protocolSettings.mdnSettings.sendMdnAsynchronously] The
   * value indicating whether to send the asynchronous MDN.
   * @member {string}
   * [sendAgreement.protocolSettings.mdnSettings.receiptDeliveryUrl] The
   * receipt delivery URL.
   * @member {string}
   * [sendAgreement.protocolSettings.mdnSettings.dispositionNotificationTo] The
   * disposition notification to header value.
   * @member {boolean}
   * [sendAgreement.protocolSettings.mdnSettings.signOutboundMdnIfOptional] The
   * value indicating whether to sign the outbound MDN if optional.
   * @member {string} [sendAgreement.protocolSettings.mdnSettings.mdnText] The
   * MDN text.
   * @member {boolean}
   * [sendAgreement.protocolSettings.mdnSettings.sendInboundMdnToMessageBox]
   * The value indicating whether to send inbound MDN to message box.
   * @member {string}
   * [sendAgreement.protocolSettings.mdnSettings.micHashingAlgorithm] The
   * signing or hashing algorithm. Possible values include: 'NotSpecified',
   * 'None', 'MD5', 'SHA1', 'SHA2256', 'SHA2384', 'SHA2512'
   * @member {object} [sendAgreement.protocolSettings.securitySettings] The
   * security settings.
   * @member {boolean}
   * [sendAgreement.protocolSettings.securitySettings.overrideGroupSigningCertificate]
   * The value indicating whether to send or request a MDN.
   * @member {string}
   * [sendAgreement.protocolSettings.securitySettings.signingCertificateName]
   * The name of the signing certificate.
   * @member {string}
   * [sendAgreement.protocolSettings.securitySettings.encryptionCertificateName]
   * The name of the encryption certificate.
   * @member {boolean}
   * [sendAgreement.protocolSettings.securitySettings.enableNrrForInboundEncodedMessages]
   * The value indicating whether to enable NRR for inbound encoded messages.
   * @member {boolean}
   * [sendAgreement.protocolSettings.securitySettings.enableNrrForInboundDecodedMessages]
   * The value indicating whether to enable NRR for inbound decoded messages.
   * @member {boolean}
   * [sendAgreement.protocolSettings.securitySettings.enableNrrForOutboundMdn]
   * The value indicating whether to enable NRR for outbound MDN.
   * @member {boolean}
   * [sendAgreement.protocolSettings.securitySettings.enableNrrForOutboundEncodedMessages]
   * The value indicating whether to enable NRR for outbound encoded messages.
   * @member {boolean}
   * [sendAgreement.protocolSettings.securitySettings.enableNrrForOutboundDecodedMessages]
   * The value indicating whether to enable NRR for outbound decoded messages.
   * @member {boolean}
   * [sendAgreement.protocolSettings.securitySettings.enableNrrForInboundMdn]
   * The value indicating whether to enable NRR for inbound MDN.
   * @member {string}
   * [sendAgreement.protocolSettings.securitySettings.sha2AlgorithmFormat] The
   * Sha2 algorithm format. Valid values are Sha2, ShaHashSize,
   * ShaHyphenHashSize, Sha2UnderscoreHashSize.
   * @member {object} [sendAgreement.protocolSettings.validationSettings] The
   * validation settings.
   * @member {boolean}
   * [sendAgreement.protocolSettings.validationSettings.overrideMessageProperties]
   * The value indicating whether to override incoming message properties with
   * those in agreement.
   * @member {boolean}
   * [sendAgreement.protocolSettings.validationSettings.encryptMessage] The
   * value indicating whether the message has to be encrypted.
   * @member {boolean}
   * [sendAgreement.protocolSettings.validationSettings.signMessage] The value
   * indicating whether the message has to be signed.
   * @member {boolean}
   * [sendAgreement.protocolSettings.validationSettings.compressMessage] The
   * value indicating whether the message has to be compressed.
   * @member {boolean}
   * [sendAgreement.protocolSettings.validationSettings.checkDuplicateMessage]
   * The value indicating whether to check for duplicate message.
   * @member {number}
   * [sendAgreement.protocolSettings.validationSettings.interchangeDuplicatesValidityDays]
   * The number of days to look back for duplicate interchange.
   * @member {boolean}
   * [sendAgreement.protocolSettings.validationSettings.checkCertificateRevocationListOnSend]
   * The value indicating whether to check for certificate revocation list on
   * send.
   * @member {boolean}
   * [sendAgreement.protocolSettings.validationSettings.checkCertificateRevocationListOnReceive]
   * The value indicating whether to check for certificate revocation list on
   * receive.
   * @member {string}
   * [sendAgreement.protocolSettings.validationSettings.encryptionAlgorithm]
   * The encryption algorithm. Possible values include: 'NotSpecified', 'None',
   * 'DES3', 'RC2', 'AES128', 'AES192', 'AES256'
   * @member {string}
   * [sendAgreement.protocolSettings.validationSettings.signingAlgorithm] The
   * signing algorithm. Possible values include: 'NotSpecified', 'Default',
   * 'SHA1', 'SHA2256', 'SHA2384', 'SHA2512'
   * @member {object} [sendAgreement.protocolSettings.envelopeSettings] The
   * envelope settings.
   * @member {string}
   * [sendAgreement.protocolSettings.envelopeSettings.messageContentType] The
   * message content type.
   * @member {boolean}
   * [sendAgreement.protocolSettings.envelopeSettings.transmitFileNameInMimeHeader]
   * The value indicating whether to transmit file name in mime header.
   * @member {string}
   * [sendAgreement.protocolSettings.envelopeSettings.fileNameTemplate] The
   * template for file name.
   * @member {boolean}
   * [sendAgreement.protocolSettings.envelopeSettings.suspendMessageOnFileNameGenerationError]
   * The value indicating whether to suspend message on file name generation
   * error.
   * @member {boolean}
   * [sendAgreement.protocolSettings.envelopeSettings.autogenerateFileName] The
   * value indicating whether to auto generate file name.
   * @member {object} [sendAgreement.protocolSettings.errorSettings] The error
   * settings.
   * @member {boolean}
   * [sendAgreement.protocolSettings.errorSettings.suspendDuplicateMessage] The
   * value indicating whether to suspend duplicate message.
   * @member {boolean}
   * [sendAgreement.protocolSettings.errorSettings.resendIfMdnNotReceived] The
   * value indicating whether to resend message If MDN is not received.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AS2AgreementContent
   *
   * @returns {object} metadata of AS2AgreementContent
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AS2AgreementContent',
      type: {
        name: 'Composite',
        className: 'AS2AgreementContent',
        modelProperties: {
          receiveAgreement: {
            required: true,
            serializedName: 'receiveAgreement',
            type: {
              name: 'Composite',
              className: 'AS2OneWayAgreement'
            }
          },
          sendAgreement: {
            required: true,
            serializedName: 'sendAgreement',
            type: {
              name: 'Composite',
              className: 'AS2OneWayAgreement'
            }
          }
        }
      }
    };
  }
}

module.exports = AS2AgreementContent;
