/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The AS2 agreement error settings.
 *
 */
class AS2ErrorSettings {
  /**
   * Create a AS2ErrorSettings.
   * @member {boolean} suspendDuplicateMessage The value indicating whether to
   * suspend duplicate message.
   * @member {boolean} resendIfMdnNotReceived The value indicating whether to
   * resend message If MDN is not received.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AS2ErrorSettings
   *
   * @returns {object} metadata of AS2ErrorSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AS2ErrorSettings',
      type: {
        name: 'Composite',
        className: 'AS2ErrorSettings',
        modelProperties: {
          suspendDuplicateMessage: {
            required: true,
            serializedName: 'suspendDuplicateMessage',
            type: {
              name: 'Boolean'
            }
          },
          resendIfMdnNotReceived: {
            required: true,
            serializedName: 'resendIfMdnNotReceived',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = AS2ErrorSettings;
