/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The integration account agreement content.
 *
 */
class AgreementContent {
  /**
   * Create a AgreementContent.
   * @member {object} [aS2] The AS2 agreement content.
   * @member {object} [aS2.receiveAgreement] The AS2 one-way receive agreement.
   * @member {object} [aS2.receiveAgreement.senderBusinessIdentity] The sender
   * business identity
   * @member {string} [aS2.receiveAgreement.senderBusinessIdentity.qualifier]
   * The business identity qualifier e.g. as2identity, ZZ, ZZZ, 31, 32
   * @member {string} [aS2.receiveAgreement.senderBusinessIdentity.value] The
   * user defined business identity value.
   * @member {object} [aS2.receiveAgreement.receiverBusinessIdentity] The
   * receiver business identity
   * @member {string} [aS2.receiveAgreement.receiverBusinessIdentity.qualifier]
   * The business identity qualifier e.g. as2identity, ZZ, ZZZ, 31, 32
   * @member {string} [aS2.receiveAgreement.receiverBusinessIdentity.value] The
   * user defined business identity value.
   * @member {object} [aS2.receiveAgreement.protocolSettings] The AS2 protocol
   * settings.
   * @member {object}
   * [aS2.receiveAgreement.protocolSettings.messageConnectionSettings] The
   * message connection settings.
   * @member {boolean}
   * [aS2.receiveAgreement.protocolSettings.messageConnectionSettings.ignoreCertificateNameMismatch]
   * The value indicating whether to ignore mismatch in certificate name.
   * @member {boolean}
   * [aS2.receiveAgreement.protocolSettings.messageConnectionSettings.supportHttpStatusCodeContinue]
   * The value indicating whether to support HTTP status code 'CONTINUE'.
   * @member {boolean}
   * [aS2.receiveAgreement.protocolSettings.messageConnectionSettings.keepHttpConnectionAlive]
   * The value indicating whether to keep the connection alive.
   * @member {boolean}
   * [aS2.receiveAgreement.protocolSettings.messageConnectionSettings.unfoldHttpHeaders]
   * The value indicating whether to unfold the HTTP headers.
   * @member {object}
   * [aS2.receiveAgreement.protocolSettings.acknowledgementConnectionSettings]
   * The acknowledgement connection settings.
   * @member {boolean}
   * [aS2.receiveAgreement.protocolSettings.acknowledgementConnectionSettings.ignoreCertificateNameMismatch]
   * The value indicating whether to ignore mismatch in certificate name.
   * @member {boolean}
   * [aS2.receiveAgreement.protocolSettings.acknowledgementConnectionSettings.supportHttpStatusCodeContinue]
   * The value indicating whether to support HTTP status code 'CONTINUE'.
   * @member {boolean}
   * [aS2.receiveAgreement.protocolSettings.acknowledgementConnectionSettings.keepHttpConnectionAlive]
   * The value indicating whether to keep the connection alive.
   * @member {boolean}
   * [aS2.receiveAgreement.protocolSettings.acknowledgementConnectionSettings.unfoldHttpHeaders]
   * The value indicating whether to unfold the HTTP headers.
   * @member {object} [aS2.receiveAgreement.protocolSettings.mdnSettings] The
   * MDN settings.
   * @member {boolean}
   * [aS2.receiveAgreement.protocolSettings.mdnSettings.needMdn] The value
   * indicating whether to send or request a MDN.
   * @member {boolean}
   * [aS2.receiveAgreement.protocolSettings.mdnSettings.signMdn] The value
   * indicating whether the MDN needs to be signed or not.
   * @member {boolean}
   * [aS2.receiveAgreement.protocolSettings.mdnSettings.sendMdnAsynchronously]
   * The value indicating whether to send the asynchronous MDN.
   * @member {string}
   * [aS2.receiveAgreement.protocolSettings.mdnSettings.receiptDeliveryUrl] The
   * receipt delivery URL.
   * @member {string}
   * [aS2.receiveAgreement.protocolSettings.mdnSettings.dispositionNotificationTo]
   * The disposition notification to header value.
   * @member {boolean}
   * [aS2.receiveAgreement.protocolSettings.mdnSettings.signOutboundMdnIfOptional]
   * The value indicating whether to sign the outbound MDN if optional.
   * @member {string}
   * [aS2.receiveAgreement.protocolSettings.mdnSettings.mdnText] The MDN text.
   * @member {boolean}
   * [aS2.receiveAgreement.protocolSettings.mdnSettings.sendInboundMdnToMessageBox]
   * The value indicating whether to send inbound MDN to message box.
   * @member {string}
   * [aS2.receiveAgreement.protocolSettings.mdnSettings.micHashingAlgorithm]
   * The signing or hashing algorithm. Possible values include: 'NotSpecified',
   * 'None', 'MD5', 'SHA1', 'SHA2256', 'SHA2384', 'SHA2512'
   * @member {object} [aS2.receiveAgreement.protocolSettings.securitySettings]
   * The security settings.
   * @member {boolean}
   * [aS2.receiveAgreement.protocolSettings.securitySettings.overrideGroupSigningCertificate]
   * The value indicating whether to send or request a MDN.
   * @member {string}
   * [aS2.receiveAgreement.protocolSettings.securitySettings.signingCertificateName]
   * The name of the signing certificate.
   * @member {string}
   * [aS2.receiveAgreement.protocolSettings.securitySettings.encryptionCertificateName]
   * The name of the encryption certificate.
   * @member {boolean}
   * [aS2.receiveAgreement.protocolSettings.securitySettings.enableNrrForInboundEncodedMessages]
   * The value indicating whether to enable NRR for inbound encoded messages.
   * @member {boolean}
   * [aS2.receiveAgreement.protocolSettings.securitySettings.enableNrrForInboundDecodedMessages]
   * The value indicating whether to enable NRR for inbound decoded messages.
   * @member {boolean}
   * [aS2.receiveAgreement.protocolSettings.securitySettings.enableNrrForOutboundMdn]
   * The value indicating whether to enable NRR for outbound MDN.
   * @member {boolean}
   * [aS2.receiveAgreement.protocolSettings.securitySettings.enableNrrForOutboundEncodedMessages]
   * The value indicating whether to enable NRR for outbound encoded messages.
   * @member {boolean}
   * [aS2.receiveAgreement.protocolSettings.securitySettings.enableNrrForOutboundDecodedMessages]
   * The value indicating whether to enable NRR for outbound decoded messages.
   * @member {boolean}
   * [aS2.receiveAgreement.protocolSettings.securitySettings.enableNrrForInboundMdn]
   * The value indicating whether to enable NRR for inbound MDN.
   * @member {string}
   * [aS2.receiveAgreement.protocolSettings.securitySettings.sha2AlgorithmFormat]
   * The Sha2 algorithm format. Valid values are Sha2, ShaHashSize,
   * ShaHyphenHashSize, Sha2UnderscoreHashSize.
   * @member {object}
   * [aS2.receiveAgreement.protocolSettings.validationSettings] The validation
   * settings.
   * @member {boolean}
   * [aS2.receiveAgreement.protocolSettings.validationSettings.overrideMessageProperties]
   * The value indicating whether to override incoming message properties with
   * those in agreement.
   * @member {boolean}
   * [aS2.receiveAgreement.protocolSettings.validationSettings.encryptMessage]
   * The value indicating whether the message has to be encrypted.
   * @member {boolean}
   * [aS2.receiveAgreement.protocolSettings.validationSettings.signMessage] The
   * value indicating whether the message has to be signed.
   * @member {boolean}
   * [aS2.receiveAgreement.protocolSettings.validationSettings.compressMessage]
   * The value indicating whether the message has to be compressed.
   * @member {boolean}
   * [aS2.receiveAgreement.protocolSettings.validationSettings.checkDuplicateMessage]
   * The value indicating whether to check for duplicate message.
   * @member {number}
   * [aS2.receiveAgreement.protocolSettings.validationSettings.interchangeDuplicatesValidityDays]
   * The number of days to look back for duplicate interchange.
   * @member {boolean}
   * [aS2.receiveAgreement.protocolSettings.validationSettings.checkCertificateRevocationListOnSend]
   * The value indicating whether to check for certificate revocation list on
   * send.
   * @member {boolean}
   * [aS2.receiveAgreement.protocolSettings.validationSettings.checkCertificateRevocationListOnReceive]
   * The value indicating whether to check for certificate revocation list on
   * receive.
   * @member {string}
   * [aS2.receiveAgreement.protocolSettings.validationSettings.encryptionAlgorithm]
   * The encryption algorithm. Possible values include: 'NotSpecified', 'None',
   * 'DES3', 'RC2', 'AES128', 'AES192', 'AES256'
   * @member {string}
   * [aS2.receiveAgreement.protocolSettings.validationSettings.signingAlgorithm]
   * The signing algorithm. Possible values include: 'NotSpecified', 'Default',
   * 'SHA1', 'SHA2256', 'SHA2384', 'SHA2512'
   * @member {object} [aS2.receiveAgreement.protocolSettings.envelopeSettings]
   * The envelope settings.
   * @member {string}
   * [aS2.receiveAgreement.protocolSettings.envelopeSettings.messageContentType]
   * The message content type.
   * @member {boolean}
   * [aS2.receiveAgreement.protocolSettings.envelopeSettings.transmitFileNameInMimeHeader]
   * The value indicating whether to transmit file name in mime header.
   * @member {string}
   * [aS2.receiveAgreement.protocolSettings.envelopeSettings.fileNameTemplate]
   * The template for file name.
   * @member {boolean}
   * [aS2.receiveAgreement.protocolSettings.envelopeSettings.suspendMessageOnFileNameGenerationError]
   * The value indicating whether to suspend message on file name generation
   * error.
   * @member {boolean}
   * [aS2.receiveAgreement.protocolSettings.envelopeSettings.autogenerateFileName]
   * The value indicating whether to auto generate file name.
   * @member {object} [aS2.receiveAgreement.protocolSettings.errorSettings] The
   * error settings.
   * @member {boolean}
   * [aS2.receiveAgreement.protocolSettings.errorSettings.suspendDuplicateMessage]
   * The value indicating whether to suspend duplicate message.
   * @member {boolean}
   * [aS2.receiveAgreement.protocolSettings.errorSettings.resendIfMdnNotReceived]
   * The value indicating whether to resend message If MDN is not received.
   * @member {object} [aS2.sendAgreement] The AS2 one-way send agreement.
   * @member {object} [aS2.sendAgreement.senderBusinessIdentity] The sender
   * business identity
   * @member {string} [aS2.sendAgreement.senderBusinessIdentity.qualifier] The
   * business identity qualifier e.g. as2identity, ZZ, ZZZ, 31, 32
   * @member {string} [aS2.sendAgreement.senderBusinessIdentity.value] The user
   * defined business identity value.
   * @member {object} [aS2.sendAgreement.receiverBusinessIdentity] The receiver
   * business identity
   * @member {string} [aS2.sendAgreement.receiverBusinessIdentity.qualifier]
   * The business identity qualifier e.g. as2identity, ZZ, ZZZ, 31, 32
   * @member {string} [aS2.sendAgreement.receiverBusinessIdentity.value] The
   * user defined business identity value.
   * @member {object} [aS2.sendAgreement.protocolSettings] The AS2 protocol
   * settings.
   * @member {object}
   * [aS2.sendAgreement.protocolSettings.messageConnectionSettings] The message
   * connection settings.
   * @member {boolean}
   * [aS2.sendAgreement.protocolSettings.messageConnectionSettings.ignoreCertificateNameMismatch]
   * The value indicating whether to ignore mismatch in certificate name.
   * @member {boolean}
   * [aS2.sendAgreement.protocolSettings.messageConnectionSettings.supportHttpStatusCodeContinue]
   * The value indicating whether to support HTTP status code 'CONTINUE'.
   * @member {boolean}
   * [aS2.sendAgreement.protocolSettings.messageConnectionSettings.keepHttpConnectionAlive]
   * The value indicating whether to keep the connection alive.
   * @member {boolean}
   * [aS2.sendAgreement.protocolSettings.messageConnectionSettings.unfoldHttpHeaders]
   * The value indicating whether to unfold the HTTP headers.
   * @member {object}
   * [aS2.sendAgreement.protocolSettings.acknowledgementConnectionSettings] The
   * acknowledgement connection settings.
   * @member {boolean}
   * [aS2.sendAgreement.protocolSettings.acknowledgementConnectionSettings.ignoreCertificateNameMismatch]
   * The value indicating whether to ignore mismatch in certificate name.
   * @member {boolean}
   * [aS2.sendAgreement.protocolSettings.acknowledgementConnectionSettings.supportHttpStatusCodeContinue]
   * The value indicating whether to support HTTP status code 'CONTINUE'.
   * @member {boolean}
   * [aS2.sendAgreement.protocolSettings.acknowledgementConnectionSettings.keepHttpConnectionAlive]
   * The value indicating whether to keep the connection alive.
   * @member {boolean}
   * [aS2.sendAgreement.protocolSettings.acknowledgementConnectionSettings.unfoldHttpHeaders]
   * The value indicating whether to unfold the HTTP headers.
   * @member {object} [aS2.sendAgreement.protocolSettings.mdnSettings] The MDN
   * settings.
   * @member {boolean} [aS2.sendAgreement.protocolSettings.mdnSettings.needMdn]
   * The value indicating whether to send or request a MDN.
   * @member {boolean} [aS2.sendAgreement.protocolSettings.mdnSettings.signMdn]
   * The value indicating whether the MDN needs to be signed or not.
   * @member {boolean}
   * [aS2.sendAgreement.protocolSettings.mdnSettings.sendMdnAsynchronously] The
   * value indicating whether to send the asynchronous MDN.
   * @member {string}
   * [aS2.sendAgreement.protocolSettings.mdnSettings.receiptDeliveryUrl] The
   * receipt delivery URL.
   * @member {string}
   * [aS2.sendAgreement.protocolSettings.mdnSettings.dispositionNotificationTo]
   * The disposition notification to header value.
   * @member {boolean}
   * [aS2.sendAgreement.protocolSettings.mdnSettings.signOutboundMdnIfOptional]
   * The value indicating whether to sign the outbound MDN if optional.
   * @member {string} [aS2.sendAgreement.protocolSettings.mdnSettings.mdnText]
   * The MDN text.
   * @member {boolean}
   * [aS2.sendAgreement.protocolSettings.mdnSettings.sendInboundMdnToMessageBox]
   * The value indicating whether to send inbound MDN to message box.
   * @member {string}
   * [aS2.sendAgreement.protocolSettings.mdnSettings.micHashingAlgorithm] The
   * signing or hashing algorithm. Possible values include: 'NotSpecified',
   * 'None', 'MD5', 'SHA1', 'SHA2256', 'SHA2384', 'SHA2512'
   * @member {object} [aS2.sendAgreement.protocolSettings.securitySettings] The
   * security settings.
   * @member {boolean}
   * [aS2.sendAgreement.protocolSettings.securitySettings.overrideGroupSigningCertificate]
   * The value indicating whether to send or request a MDN.
   * @member {string}
   * [aS2.sendAgreement.protocolSettings.securitySettings.signingCertificateName]
   * The name of the signing certificate.
   * @member {string}
   * [aS2.sendAgreement.protocolSettings.securitySettings.encryptionCertificateName]
   * The name of the encryption certificate.
   * @member {boolean}
   * [aS2.sendAgreement.protocolSettings.securitySettings.enableNrrForInboundEncodedMessages]
   * The value indicating whether to enable NRR for inbound encoded messages.
   * @member {boolean}
   * [aS2.sendAgreement.protocolSettings.securitySettings.enableNrrForInboundDecodedMessages]
   * The value indicating whether to enable NRR for inbound decoded messages.
   * @member {boolean}
   * [aS2.sendAgreement.protocolSettings.securitySettings.enableNrrForOutboundMdn]
   * The value indicating whether to enable NRR for outbound MDN.
   * @member {boolean}
   * [aS2.sendAgreement.protocolSettings.securitySettings.enableNrrForOutboundEncodedMessages]
   * The value indicating whether to enable NRR for outbound encoded messages.
   * @member {boolean}
   * [aS2.sendAgreement.protocolSettings.securitySettings.enableNrrForOutboundDecodedMessages]
   * The value indicating whether to enable NRR for outbound decoded messages.
   * @member {boolean}
   * [aS2.sendAgreement.protocolSettings.securitySettings.enableNrrForInboundMdn]
   * The value indicating whether to enable NRR for inbound MDN.
   * @member {string}
   * [aS2.sendAgreement.protocolSettings.securitySettings.sha2AlgorithmFormat]
   * The Sha2 algorithm format. Valid values are Sha2, ShaHashSize,
   * ShaHyphenHashSize, Sha2UnderscoreHashSize.
   * @member {object} [aS2.sendAgreement.protocolSettings.validationSettings]
   * The validation settings.
   * @member {boolean}
   * [aS2.sendAgreement.protocolSettings.validationSettings.overrideMessageProperties]
   * The value indicating whether to override incoming message properties with
   * those in agreement.
   * @member {boolean}
   * [aS2.sendAgreement.protocolSettings.validationSettings.encryptMessage] The
   * value indicating whether the message has to be encrypted.
   * @member {boolean}
   * [aS2.sendAgreement.protocolSettings.validationSettings.signMessage] The
   * value indicating whether the message has to be signed.
   * @member {boolean}
   * [aS2.sendAgreement.protocolSettings.validationSettings.compressMessage]
   * The value indicating whether the message has to be compressed.
   * @member {boolean}
   * [aS2.sendAgreement.protocolSettings.validationSettings.checkDuplicateMessage]
   * The value indicating whether to check for duplicate message.
   * @member {number}
   * [aS2.sendAgreement.protocolSettings.validationSettings.interchangeDuplicatesValidityDays]
   * The number of days to look back for duplicate interchange.
   * @member {boolean}
   * [aS2.sendAgreement.protocolSettings.validationSettings.checkCertificateRevocationListOnSend]
   * The value indicating whether to check for certificate revocation list on
   * send.
   * @member {boolean}
   * [aS2.sendAgreement.protocolSettings.validationSettings.checkCertificateRevocationListOnReceive]
   * The value indicating whether to check for certificate revocation list on
   * receive.
   * @member {string}
   * [aS2.sendAgreement.protocolSettings.validationSettings.encryptionAlgorithm]
   * The encryption algorithm. Possible values include: 'NotSpecified', 'None',
   * 'DES3', 'RC2', 'AES128', 'AES192', 'AES256'
   * @member {string}
   * [aS2.sendAgreement.protocolSettings.validationSettings.signingAlgorithm]
   * The signing algorithm. Possible values include: 'NotSpecified', 'Default',
   * 'SHA1', 'SHA2256', 'SHA2384', 'SHA2512'
   * @member {object} [aS2.sendAgreement.protocolSettings.envelopeSettings] The
   * envelope settings.
   * @member {string}
   * [aS2.sendAgreement.protocolSettings.envelopeSettings.messageContentType]
   * The message content type.
   * @member {boolean}
   * [aS2.sendAgreement.protocolSettings.envelopeSettings.transmitFileNameInMimeHeader]
   * The value indicating whether to transmit file name in mime header.
   * @member {string}
   * [aS2.sendAgreement.protocolSettings.envelopeSettings.fileNameTemplate] The
   * template for file name.
   * @member {boolean}
   * [aS2.sendAgreement.protocolSettings.envelopeSettings.suspendMessageOnFileNameGenerationError]
   * The value indicating whether to suspend message on file name generation
   * error.
   * @member {boolean}
   * [aS2.sendAgreement.protocolSettings.envelopeSettings.autogenerateFileName]
   * The value indicating whether to auto generate file name.
   * @member {object} [aS2.sendAgreement.protocolSettings.errorSettings] The
   * error settings.
   * @member {boolean}
   * [aS2.sendAgreement.protocolSettings.errorSettings.suspendDuplicateMessage]
   * The value indicating whether to suspend duplicate message.
   * @member {boolean}
   * [aS2.sendAgreement.protocolSettings.errorSettings.resendIfMdnNotReceived]
   * The value indicating whether to resend message If MDN is not received.
   * @member {object} [x12] The X12 agreement content.
   * @member {object} [x12.receiveAgreement] The X12 one-way receive agreement.
   * @member {object} [x12.receiveAgreement.senderBusinessIdentity] The sender
   * business identity
   * @member {string} [x12.receiveAgreement.senderBusinessIdentity.qualifier]
   * The business identity qualifier e.g. as2identity, ZZ, ZZZ, 31, 32
   * @member {string} [x12.receiveAgreement.senderBusinessIdentity.value] The
   * user defined business identity value.
   * @member {object} [x12.receiveAgreement.receiverBusinessIdentity] The
   * receiver business identity
   * @member {string} [x12.receiveAgreement.receiverBusinessIdentity.qualifier]
   * The business identity qualifier e.g. as2identity, ZZ, ZZZ, 31, 32
   * @member {string} [x12.receiveAgreement.receiverBusinessIdentity.value] The
   * user defined business identity value.
   * @member {object} [x12.receiveAgreement.protocolSettings] The X12 protocol
   * settings.
   * @member {object}
   * [x12.receiveAgreement.protocolSettings.validationSettings] The X12
   * validation settings.
   * @member {boolean}
   * [x12.receiveAgreement.protocolSettings.validationSettings.validateCharacterSet]
   * The value indicating whether to validate character set in the message.
   * @member {boolean}
   * [x12.receiveAgreement.protocolSettings.validationSettings.checkDuplicateInterchangeControlNumber]
   * The value indicating whether to check for duplicate interchange control
   * number.
   * @member {number}
   * [x12.receiveAgreement.protocolSettings.validationSettings.interchangeControlNumberValidityDays]
   * The validity period of interchange control number.
   * @member {boolean}
   * [x12.receiveAgreement.protocolSettings.validationSettings.checkDuplicateGroupControlNumber]
   * The value indicating whether to check for duplicate group control number.
   * @member {boolean}
   * [x12.receiveAgreement.protocolSettings.validationSettings.checkDuplicateTransactionSetControlNumber]
   * The value indicating whether to check for duplicate transaction set
   * control number.
   * @member {boolean}
   * [x12.receiveAgreement.protocolSettings.validationSettings.validateEdiTypes]
   * The value indicating whether to Whether to validate EDI types.
   * @member {boolean}
   * [x12.receiveAgreement.protocolSettings.validationSettings.validateXsdTypes]
   * The value indicating whether to Whether to validate XSD types.
   * @member {boolean}
   * [x12.receiveAgreement.protocolSettings.validationSettings.allowLeadingAndTrailingSpacesAndZeroes]
   * The value indicating whether to allow leading and trailing spaces and
   * zeroes.
   * @member {boolean}
   * [x12.receiveAgreement.protocolSettings.validationSettings.trimLeadingAndTrailingSpacesAndZeroes]
   * The value indicating whether to trim leading and trailing spaces and
   * zeroes.
   * @member {string}
   * [x12.receiveAgreement.protocolSettings.validationSettings.trailingSeparatorPolicy]
   * The trailing separator policy. Possible values include: 'NotSpecified',
   * 'NotAllowed', 'Optional', 'Mandatory'
   * @member {object} [x12.receiveAgreement.protocolSettings.framingSettings]
   * The X12 framing settings.
   * @member {number}
   * [x12.receiveAgreement.protocolSettings.framingSettings.dataElementSeparator]
   * The data element separator.
   * @member {number}
   * [x12.receiveAgreement.protocolSettings.framingSettings.componentSeparator]
   * The component separator.
   * @member {boolean}
   * [x12.receiveAgreement.protocolSettings.framingSettings.replaceSeparatorsInPayload]
   * The value indicating whether to replace separators in payload.
   * @member {number}
   * [x12.receiveAgreement.protocolSettings.framingSettings.replaceCharacter]
   * The replacement character.
   * @member {number}
   * [x12.receiveAgreement.protocolSettings.framingSettings.segmentTerminator]
   * The segment terminator.
   * @member {string}
   * [x12.receiveAgreement.protocolSettings.framingSettings.characterSet] The
   * X12 character set. Possible values include: 'NotSpecified', 'Basic',
   * 'Extended', 'UTF8'
   * @member {string}
   * [x12.receiveAgreement.protocolSettings.framingSettings.segmentTerminatorSuffix]
   * The segment terminator suffix. Possible values include: 'NotSpecified',
   * 'None', 'CR', 'LF', 'CRLF'
   * @member {object} [x12.receiveAgreement.protocolSettings.envelopeSettings]
   * The X12 envelope settings.
   * @member {number}
   * [x12.receiveAgreement.protocolSettings.envelopeSettings.controlStandardsId]
   * The controls standards id.
   * @member {boolean}
   * [x12.receiveAgreement.protocolSettings.envelopeSettings.useControlStandardsIdAsRepetitionCharacter]
   * The value indicating whether to use control standards id as repetition
   * character.
   * @member {string}
   * [x12.receiveAgreement.protocolSettings.envelopeSettings.senderApplicationId]
   * The sender application id.
   * @member {string}
   * [x12.receiveAgreement.protocolSettings.envelopeSettings.receiverApplicationId]
   * The receiver application id.
   * @member {string}
   * [x12.receiveAgreement.protocolSettings.envelopeSettings.controlVersionNumber]
   * The control version number.
   * @member {number}
   * [x12.receiveAgreement.protocolSettings.envelopeSettings.interchangeControlNumberLowerBound]
   * The interchange  control number lower bound.
   * @member {number}
   * [x12.receiveAgreement.protocolSettings.envelopeSettings.interchangeControlNumberUpperBound]
   * The interchange  control number upper bound.
   * @member {boolean}
   * [x12.receiveAgreement.protocolSettings.envelopeSettings.rolloverInterchangeControlNumber]
   * The value indicating whether to rollover interchange control number.
   * @member {boolean}
   * [x12.receiveAgreement.protocolSettings.envelopeSettings.enableDefaultGroupHeaders]
   * The value indicating whether to enable default group headers.
   * @member {string}
   * [x12.receiveAgreement.protocolSettings.envelopeSettings.functionalGroupId]
   * The functional group id.
   * @member {number}
   * [x12.receiveAgreement.protocolSettings.envelopeSettings.groupControlNumberLowerBound]
   * The group control number lower bound.
   * @member {number}
   * [x12.receiveAgreement.protocolSettings.envelopeSettings.groupControlNumberUpperBound]
   * The group control number upper bound.
   * @member {boolean}
   * [x12.receiveAgreement.protocolSettings.envelopeSettings.rolloverGroupControlNumber]
   * The value indicating whether to rollover group control number.
   * @member {string}
   * [x12.receiveAgreement.protocolSettings.envelopeSettings.groupHeaderAgencyCode]
   * The group header agency code.
   * @member {string}
   * [x12.receiveAgreement.protocolSettings.envelopeSettings.groupHeaderVersion]
   * The group header version.
   * @member {number}
   * [x12.receiveAgreement.protocolSettings.envelopeSettings.transactionSetControlNumberLowerBound]
   * The transaction set control number lower bound.
   * @member {number}
   * [x12.receiveAgreement.protocolSettings.envelopeSettings.transactionSetControlNumberUpperBound]
   * The transaction set control number upper bound.
   * @member {boolean}
   * [x12.receiveAgreement.protocolSettings.envelopeSettings.rolloverTransactionSetControlNumber]
   * The value indicating whether to rollover transaction set control number.
   * @member {string}
   * [x12.receiveAgreement.protocolSettings.envelopeSettings.transactionSetControlNumberPrefix]
   * The transaction set control number prefix.
   * @member {string}
   * [x12.receiveAgreement.protocolSettings.envelopeSettings.transactionSetControlNumberSuffix]
   * The transaction set control number suffix.
   * @member {boolean}
   * [x12.receiveAgreement.protocolSettings.envelopeSettings.overwriteExistingTransactionSetControlNumber]
   * The value indicating whether to overwrite existing transaction set control
   * number.
   * @member {string}
   * [x12.receiveAgreement.protocolSettings.envelopeSettings.groupHeaderDateFormat]
   * The group header date format. Possible values include: 'NotSpecified',
   * 'CCYYMMDD', 'YYMMDD'
   * @member {string}
   * [x12.receiveAgreement.protocolSettings.envelopeSettings.groupHeaderTimeFormat]
   * The group header time format. Possible values include: 'NotSpecified',
   * 'HHMM', 'HHMMSS', 'HHMMSSdd', 'HHMMSSd'
   * @member {string}
   * [x12.receiveAgreement.protocolSettings.envelopeSettings.usageIndicator]
   * The usage indicator. Possible values include: 'NotSpecified', 'Test',
   * 'Information', 'Production'
   * @member {object}
   * [x12.receiveAgreement.protocolSettings.acknowledgementSettings] The X12
   * acknowledgment settings.
   * @member {boolean}
   * [x12.receiveAgreement.protocolSettings.acknowledgementSettings.needTechnicalAcknowledgement]
   * The value indicating whether technical acknowledgement is needed.
   * @member {boolean}
   * [x12.receiveAgreement.protocolSettings.acknowledgementSettings.batchTechnicalAcknowledgements]
   * The value indicating whether to batch the technical acknowledgements.
   * @member {boolean}
   * [x12.receiveAgreement.protocolSettings.acknowledgementSettings.needFunctionalAcknowledgement]
   * The value indicating whether functional acknowledgement is needed.
   * @member {string}
   * [x12.receiveAgreement.protocolSettings.acknowledgementSettings.functionalAcknowledgementVersion]
   * The functional acknowledgement version.
   * @member {boolean}
   * [x12.receiveAgreement.protocolSettings.acknowledgementSettings.batchFunctionalAcknowledgements]
   * The value indicating whether to batch functional acknowledgements.
   * @member {boolean}
   * [x12.receiveAgreement.protocolSettings.acknowledgementSettings.needImplementationAcknowledgement]
   * The value indicating whether implementation acknowledgement is needed.
   * @member {string}
   * [x12.receiveAgreement.protocolSettings.acknowledgementSettings.implementationAcknowledgementVersion]
   * The implementation acknowledgement version.
   * @member {boolean}
   * [x12.receiveAgreement.protocolSettings.acknowledgementSettings.batchImplementationAcknowledgements]
   * The value indicating whether to batch implementation acknowledgements.
   * @member {boolean}
   * [x12.receiveAgreement.protocolSettings.acknowledgementSettings.needLoopForValidMessages]
   * The value indicating whether a loop is needed for valid messages.
   * @member {boolean}
   * [x12.receiveAgreement.protocolSettings.acknowledgementSettings.sendSynchronousAcknowledgement]
   * The value indicating whether to send synchronous acknowledgement.
   * @member {string}
   * [x12.receiveAgreement.protocolSettings.acknowledgementSettings.acknowledgementControlNumberPrefix]
   * The acknowledgement control number prefix.
   * @member {string}
   * [x12.receiveAgreement.protocolSettings.acknowledgementSettings.acknowledgementControlNumberSuffix]
   * The acknowledgement control number suffix.
   * @member {number}
   * [x12.receiveAgreement.protocolSettings.acknowledgementSettings.acknowledgementControlNumberLowerBound]
   * The acknowledgement control number lower bound.
   * @member {number}
   * [x12.receiveAgreement.protocolSettings.acknowledgementSettings.acknowledgementControlNumberUpperBound]
   * The acknowledgement control number upper bound.
   * @member {boolean}
   * [x12.receiveAgreement.protocolSettings.acknowledgementSettings.rolloverAcknowledgementControlNumber]
   * The value indicating whether to rollover acknowledgement control number.
   * @member {object} [x12.receiveAgreement.protocolSettings.messageFilter] The
   * X12 message filter.
   * @member {string}
   * [x12.receiveAgreement.protocolSettings.messageFilter.messageFilterType]
   * The message filter type. Possible values include: 'NotSpecified',
   * 'Include', 'Exclude'
   * @member {object} [x12.receiveAgreement.protocolSettings.securitySettings]
   * The X12 security settings.
   * @member {string}
   * [x12.receiveAgreement.protocolSettings.securitySettings.authorizationQualifier]
   * The authorization qualifier.
   * @member {string}
   * [x12.receiveAgreement.protocolSettings.securitySettings.authorizationValue]
   * The authorization value.
   * @member {string}
   * [x12.receiveAgreement.protocolSettings.securitySettings.securityQualifier]
   * The security qualifier.
   * @member {string}
   * [x12.receiveAgreement.protocolSettings.securitySettings.passwordValue] The
   * password value.
   * @member {object}
   * [x12.receiveAgreement.protocolSettings.processingSettings] The X12
   * processing settings.
   * @member {boolean}
   * [x12.receiveAgreement.protocolSettings.processingSettings.maskSecurityInfo]
   * The value indicating whether to mask security information.
   * @member {boolean}
   * [x12.receiveAgreement.protocolSettings.processingSettings.convertImpliedDecimal]
   * The value indicating whether to convert numerical type to implied decimal.
   * @member {boolean}
   * [x12.receiveAgreement.protocolSettings.processingSettings.preserveInterchange]
   * The value indicating whether to preserve interchange.
   * @member {boolean}
   * [x12.receiveAgreement.protocolSettings.processingSettings.suspendInterchangeOnError]
   * The value indicating whether to suspend interchange on error.
   * @member {boolean}
   * [x12.receiveAgreement.protocolSettings.processingSettings.createEmptyXmlTagsForTrailingSeparators]
   * The value indicating whether to create empty xml tags for trailing
   * separators.
   * @member {boolean}
   * [x12.receiveAgreement.protocolSettings.processingSettings.useDotAsDecimalSeparator]
   * The value indicating whether to use dot as decimal separator.
   * @member {array} [x12.receiveAgreement.protocolSettings.envelopeOverrides]
   * The X12 envelope override settings.
   * @member {array}
   * [x12.receiveAgreement.protocolSettings.validationOverrides] The X12
   * validation override settings.
   * @member {array} [x12.receiveAgreement.protocolSettings.messageFilterList]
   * The X12 message filter list.
   * @member {array} [x12.receiveAgreement.protocolSettings.schemaReferences]
   * The X12 schema references.
   * @member {array}
   * [x12.receiveAgreement.protocolSettings.x12DelimiterOverrides] The X12
   * delimiter override settings.
   * @member {object} [x12.sendAgreement] The X12 one-way send agreement.
   * @member {object} [x12.sendAgreement.senderBusinessIdentity] The sender
   * business identity
   * @member {string} [x12.sendAgreement.senderBusinessIdentity.qualifier] The
   * business identity qualifier e.g. as2identity, ZZ, ZZZ, 31, 32
   * @member {string} [x12.sendAgreement.senderBusinessIdentity.value] The user
   * defined business identity value.
   * @member {object} [x12.sendAgreement.receiverBusinessIdentity] The receiver
   * business identity
   * @member {string} [x12.sendAgreement.receiverBusinessIdentity.qualifier]
   * The business identity qualifier e.g. as2identity, ZZ, ZZZ, 31, 32
   * @member {string} [x12.sendAgreement.receiverBusinessIdentity.value] The
   * user defined business identity value.
   * @member {object} [x12.sendAgreement.protocolSettings] The X12 protocol
   * settings.
   * @member {object} [x12.sendAgreement.protocolSettings.validationSettings]
   * The X12 validation settings.
   * @member {boolean}
   * [x12.sendAgreement.protocolSettings.validationSettings.validateCharacterSet]
   * The value indicating whether to validate character set in the message.
   * @member {boolean}
   * [x12.sendAgreement.protocolSettings.validationSettings.checkDuplicateInterchangeControlNumber]
   * The value indicating whether to check for duplicate interchange control
   * number.
   * @member {number}
   * [x12.sendAgreement.protocolSettings.validationSettings.interchangeControlNumberValidityDays]
   * The validity period of interchange control number.
   * @member {boolean}
   * [x12.sendAgreement.protocolSettings.validationSettings.checkDuplicateGroupControlNumber]
   * The value indicating whether to check for duplicate group control number.
   * @member {boolean}
   * [x12.sendAgreement.protocolSettings.validationSettings.checkDuplicateTransactionSetControlNumber]
   * The value indicating whether to check for duplicate transaction set
   * control number.
   * @member {boolean}
   * [x12.sendAgreement.protocolSettings.validationSettings.validateEdiTypes]
   * The value indicating whether to Whether to validate EDI types.
   * @member {boolean}
   * [x12.sendAgreement.protocolSettings.validationSettings.validateXsdTypes]
   * The value indicating whether to Whether to validate XSD types.
   * @member {boolean}
   * [x12.sendAgreement.protocolSettings.validationSettings.allowLeadingAndTrailingSpacesAndZeroes]
   * The value indicating whether to allow leading and trailing spaces and
   * zeroes.
   * @member {boolean}
   * [x12.sendAgreement.protocolSettings.validationSettings.trimLeadingAndTrailingSpacesAndZeroes]
   * The value indicating whether to trim leading and trailing spaces and
   * zeroes.
   * @member {string}
   * [x12.sendAgreement.protocolSettings.validationSettings.trailingSeparatorPolicy]
   * The trailing separator policy. Possible values include: 'NotSpecified',
   * 'NotAllowed', 'Optional', 'Mandatory'
   * @member {object} [x12.sendAgreement.protocolSettings.framingSettings] The
   * X12 framing settings.
   * @member {number}
   * [x12.sendAgreement.protocolSettings.framingSettings.dataElementSeparator]
   * The data element separator.
   * @member {number}
   * [x12.sendAgreement.protocolSettings.framingSettings.componentSeparator]
   * The component separator.
   * @member {boolean}
   * [x12.sendAgreement.protocolSettings.framingSettings.replaceSeparatorsInPayload]
   * The value indicating whether to replace separators in payload.
   * @member {number}
   * [x12.sendAgreement.protocolSettings.framingSettings.replaceCharacter] The
   * replacement character.
   * @member {number}
   * [x12.sendAgreement.protocolSettings.framingSettings.segmentTerminator] The
   * segment terminator.
   * @member {string}
   * [x12.sendAgreement.protocolSettings.framingSettings.characterSet] The X12
   * character set. Possible values include: 'NotSpecified', 'Basic',
   * 'Extended', 'UTF8'
   * @member {string}
   * [x12.sendAgreement.protocolSettings.framingSettings.segmentTerminatorSuffix]
   * The segment terminator suffix. Possible values include: 'NotSpecified',
   * 'None', 'CR', 'LF', 'CRLF'
   * @member {object} [x12.sendAgreement.protocolSettings.envelopeSettings] The
   * X12 envelope settings.
   * @member {number}
   * [x12.sendAgreement.protocolSettings.envelopeSettings.controlStandardsId]
   * The controls standards id.
   * @member {boolean}
   * [x12.sendAgreement.protocolSettings.envelopeSettings.useControlStandardsIdAsRepetitionCharacter]
   * The value indicating whether to use control standards id as repetition
   * character.
   * @member {string}
   * [x12.sendAgreement.protocolSettings.envelopeSettings.senderApplicationId]
   * The sender application id.
   * @member {string}
   * [x12.sendAgreement.protocolSettings.envelopeSettings.receiverApplicationId]
   * The receiver application id.
   * @member {string}
   * [x12.sendAgreement.protocolSettings.envelopeSettings.controlVersionNumber]
   * The control version number.
   * @member {number}
   * [x12.sendAgreement.protocolSettings.envelopeSettings.interchangeControlNumberLowerBound]
   * The interchange  control number lower bound.
   * @member {number}
   * [x12.sendAgreement.protocolSettings.envelopeSettings.interchangeControlNumberUpperBound]
   * The interchange  control number upper bound.
   * @member {boolean}
   * [x12.sendAgreement.protocolSettings.envelopeSettings.rolloverInterchangeControlNumber]
   * The value indicating whether to rollover interchange control number.
   * @member {boolean}
   * [x12.sendAgreement.protocolSettings.envelopeSettings.enableDefaultGroupHeaders]
   * The value indicating whether to enable default group headers.
   * @member {string}
   * [x12.sendAgreement.protocolSettings.envelopeSettings.functionalGroupId]
   * The functional group id.
   * @member {number}
   * [x12.sendAgreement.protocolSettings.envelopeSettings.groupControlNumberLowerBound]
   * The group control number lower bound.
   * @member {number}
   * [x12.sendAgreement.protocolSettings.envelopeSettings.groupControlNumberUpperBound]
   * The group control number upper bound.
   * @member {boolean}
   * [x12.sendAgreement.protocolSettings.envelopeSettings.rolloverGroupControlNumber]
   * The value indicating whether to rollover group control number.
   * @member {string}
   * [x12.sendAgreement.protocolSettings.envelopeSettings.groupHeaderAgencyCode]
   * The group header agency code.
   * @member {string}
   * [x12.sendAgreement.protocolSettings.envelopeSettings.groupHeaderVersion]
   * The group header version.
   * @member {number}
   * [x12.sendAgreement.protocolSettings.envelopeSettings.transactionSetControlNumberLowerBound]
   * The transaction set control number lower bound.
   * @member {number}
   * [x12.sendAgreement.protocolSettings.envelopeSettings.transactionSetControlNumberUpperBound]
   * The transaction set control number upper bound.
   * @member {boolean}
   * [x12.sendAgreement.protocolSettings.envelopeSettings.rolloverTransactionSetControlNumber]
   * The value indicating whether to rollover transaction set control number.
   * @member {string}
   * [x12.sendAgreement.protocolSettings.envelopeSettings.transactionSetControlNumberPrefix]
   * The transaction set control number prefix.
   * @member {string}
   * [x12.sendAgreement.protocolSettings.envelopeSettings.transactionSetControlNumberSuffix]
   * The transaction set control number suffix.
   * @member {boolean}
   * [x12.sendAgreement.protocolSettings.envelopeSettings.overwriteExistingTransactionSetControlNumber]
   * The value indicating whether to overwrite existing transaction set control
   * number.
   * @member {string}
   * [x12.sendAgreement.protocolSettings.envelopeSettings.groupHeaderDateFormat]
   * The group header date format. Possible values include: 'NotSpecified',
   * 'CCYYMMDD', 'YYMMDD'
   * @member {string}
   * [x12.sendAgreement.protocolSettings.envelopeSettings.groupHeaderTimeFormat]
   * The group header time format. Possible values include: 'NotSpecified',
   * 'HHMM', 'HHMMSS', 'HHMMSSdd', 'HHMMSSd'
   * @member {string}
   * [x12.sendAgreement.protocolSettings.envelopeSettings.usageIndicator] The
   * usage indicator. Possible values include: 'NotSpecified', 'Test',
   * 'Information', 'Production'
   * @member {object}
   * [x12.sendAgreement.protocolSettings.acknowledgementSettings] The X12
   * acknowledgment settings.
   * @member {boolean}
   * [x12.sendAgreement.protocolSettings.acknowledgementSettings.needTechnicalAcknowledgement]
   * The value indicating whether technical acknowledgement is needed.
   * @member {boolean}
   * [x12.sendAgreement.protocolSettings.acknowledgementSettings.batchTechnicalAcknowledgements]
   * The value indicating whether to batch the technical acknowledgements.
   * @member {boolean}
   * [x12.sendAgreement.protocolSettings.acknowledgementSettings.needFunctionalAcknowledgement]
   * The value indicating whether functional acknowledgement is needed.
   * @member {string}
   * [x12.sendAgreement.protocolSettings.acknowledgementSettings.functionalAcknowledgementVersion]
   * The functional acknowledgement version.
   * @member {boolean}
   * [x12.sendAgreement.protocolSettings.acknowledgementSettings.batchFunctionalAcknowledgements]
   * The value indicating whether to batch functional acknowledgements.
   * @member {boolean}
   * [x12.sendAgreement.protocolSettings.acknowledgementSettings.needImplementationAcknowledgement]
   * The value indicating whether implementation acknowledgement is needed.
   * @member {string}
   * [x12.sendAgreement.protocolSettings.acknowledgementSettings.implementationAcknowledgementVersion]
   * The implementation acknowledgement version.
   * @member {boolean}
   * [x12.sendAgreement.protocolSettings.acknowledgementSettings.batchImplementationAcknowledgements]
   * The value indicating whether to batch implementation acknowledgements.
   * @member {boolean}
   * [x12.sendAgreement.protocolSettings.acknowledgementSettings.needLoopForValidMessages]
   * The value indicating whether a loop is needed for valid messages.
   * @member {boolean}
   * [x12.sendAgreement.protocolSettings.acknowledgementSettings.sendSynchronousAcknowledgement]
   * The value indicating whether to send synchronous acknowledgement.
   * @member {string}
   * [x12.sendAgreement.protocolSettings.acknowledgementSettings.acknowledgementControlNumberPrefix]
   * The acknowledgement control number prefix.
   * @member {string}
   * [x12.sendAgreement.protocolSettings.acknowledgementSettings.acknowledgementControlNumberSuffix]
   * The acknowledgement control number suffix.
   * @member {number}
   * [x12.sendAgreement.protocolSettings.acknowledgementSettings.acknowledgementControlNumberLowerBound]
   * The acknowledgement control number lower bound.
   * @member {number}
   * [x12.sendAgreement.protocolSettings.acknowledgementSettings.acknowledgementControlNumberUpperBound]
   * The acknowledgement control number upper bound.
   * @member {boolean}
   * [x12.sendAgreement.protocolSettings.acknowledgementSettings.rolloverAcknowledgementControlNumber]
   * The value indicating whether to rollover acknowledgement control number.
   * @member {object} [x12.sendAgreement.protocolSettings.messageFilter] The
   * X12 message filter.
   * @member {string}
   * [x12.sendAgreement.protocolSettings.messageFilter.messageFilterType] The
   * message filter type. Possible values include: 'NotSpecified', 'Include',
   * 'Exclude'
   * @member {object} [x12.sendAgreement.protocolSettings.securitySettings] The
   * X12 security settings.
   * @member {string}
   * [x12.sendAgreement.protocolSettings.securitySettings.authorizationQualifier]
   * The authorization qualifier.
   * @member {string}
   * [x12.sendAgreement.protocolSettings.securitySettings.authorizationValue]
   * The authorization value.
   * @member {string}
   * [x12.sendAgreement.protocolSettings.securitySettings.securityQualifier]
   * The security qualifier.
   * @member {string}
   * [x12.sendAgreement.protocolSettings.securitySettings.passwordValue] The
   * password value.
   * @member {object} [x12.sendAgreement.protocolSettings.processingSettings]
   * The X12 processing settings.
   * @member {boolean}
   * [x12.sendAgreement.protocolSettings.processingSettings.maskSecurityInfo]
   * The value indicating whether to mask security information.
   * @member {boolean}
   * [x12.sendAgreement.protocolSettings.processingSettings.convertImpliedDecimal]
   * The value indicating whether to convert numerical type to implied decimal.
   * @member {boolean}
   * [x12.sendAgreement.protocolSettings.processingSettings.preserveInterchange]
   * The value indicating whether to preserve interchange.
   * @member {boolean}
   * [x12.sendAgreement.protocolSettings.processingSettings.suspendInterchangeOnError]
   * The value indicating whether to suspend interchange on error.
   * @member {boolean}
   * [x12.sendAgreement.protocolSettings.processingSettings.createEmptyXmlTagsForTrailingSeparators]
   * The value indicating whether to create empty xml tags for trailing
   * separators.
   * @member {boolean}
   * [x12.sendAgreement.protocolSettings.processingSettings.useDotAsDecimalSeparator]
   * The value indicating whether to use dot as decimal separator.
   * @member {array} [x12.sendAgreement.protocolSettings.envelopeOverrides] The
   * X12 envelope override settings.
   * @member {array} [x12.sendAgreement.protocolSettings.validationOverrides]
   * The X12 validation override settings.
   * @member {array} [x12.sendAgreement.protocolSettings.messageFilterList] The
   * X12 message filter list.
   * @member {array} [x12.sendAgreement.protocolSettings.schemaReferences] The
   * X12 schema references.
   * @member {array} [x12.sendAgreement.protocolSettings.x12DelimiterOverrides]
   * The X12 delimiter override settings.
   * @member {object} [edifact] The EDIFACT agreement content.
   * @member {object} [edifact.receiveAgreement] The EDIFACT one-way receive
   * agreement.
   * @member {object} [edifact.receiveAgreement.senderBusinessIdentity] The
   * sender business identity
   * @member {string}
   * [edifact.receiveAgreement.senderBusinessIdentity.qualifier] The business
   * identity qualifier e.g. as2identity, ZZ, ZZZ, 31, 32
   * @member {string} [edifact.receiveAgreement.senderBusinessIdentity.value]
   * The user defined business identity value.
   * @member {object} [edifact.receiveAgreement.receiverBusinessIdentity] The
   * receiver business identity
   * @member {string}
   * [edifact.receiveAgreement.receiverBusinessIdentity.qualifier] The business
   * identity qualifier e.g. as2identity, ZZ, ZZZ, 31, 32
   * @member {string} [edifact.receiveAgreement.receiverBusinessIdentity.value]
   * The user defined business identity value.
   * @member {object} [edifact.receiveAgreement.protocolSettings] The EDIFACT
   * protocol settings.
   * @member {object}
   * [edifact.receiveAgreement.protocolSettings.validationSettings] The EDIFACT
   * validation settings.
   * @member {boolean}
   * [edifact.receiveAgreement.protocolSettings.validationSettings.validateCharacterSet]
   * The value indicating whether to validate character set in the message.
   * @member {boolean}
   * [edifact.receiveAgreement.protocolSettings.validationSettings.checkDuplicateInterchangeControlNumber]
   * The value indicating whether to check for duplicate interchange control
   * number.
   * @member {number}
   * [edifact.receiveAgreement.protocolSettings.validationSettings.interchangeControlNumberValidityDays]
   * The validity period of interchange control number.
   * @member {boolean}
   * [edifact.receiveAgreement.protocolSettings.validationSettings.checkDuplicateGroupControlNumber]
   * The value indicating whether to check for duplicate group control number.
   * @member {boolean}
   * [edifact.receiveAgreement.protocolSettings.validationSettings.checkDuplicateTransactionSetControlNumber]
   * The value indicating whether to check for duplicate transaction set
   * control number.
   * @member {boolean}
   * [edifact.receiveAgreement.protocolSettings.validationSettings.validateEdiTypes]
   * The value indicating whether to Whether to validate EDI types.
   * @member {boolean}
   * [edifact.receiveAgreement.protocolSettings.validationSettings.validateXsdTypes]
   * The value indicating whether to Whether to validate XSD types.
   * @member {boolean}
   * [edifact.receiveAgreement.protocolSettings.validationSettings.allowLeadingAndTrailingSpacesAndZeroes]
   * The value indicating whether to allow leading and trailing spaces and
   * zeroes.
   * @member {boolean}
   * [edifact.receiveAgreement.protocolSettings.validationSettings.trimLeadingAndTrailingSpacesAndZeroes]
   * The value indicating whether to trim leading and trailing spaces and
   * zeroes.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.validationSettings.trailingSeparatorPolicy]
   * The trailing separator policy. Possible values include: 'NotSpecified',
   * 'NotAllowed', 'Optional', 'Mandatory'
   * @member {object}
   * [edifact.receiveAgreement.protocolSettings.framingSettings] The EDIFACT
   * framing settings.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.framingSettings.serviceCodeListDirectoryVersion]
   * The service code list directory version.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.framingSettings.characterEncoding]
   * The character encoding.
   * @member {number}
   * [edifact.receiveAgreement.protocolSettings.framingSettings.protocolVersion]
   * The protocol version.
   * @member {number}
   * [edifact.receiveAgreement.protocolSettings.framingSettings.dataElementSeparator]
   * The data element separator.
   * @member {number}
   * [edifact.receiveAgreement.protocolSettings.framingSettings.componentSeparator]
   * The component separator.
   * @member {number}
   * [edifact.receiveAgreement.protocolSettings.framingSettings.segmentTerminator]
   * The segment terminator.
   * @member {number}
   * [edifact.receiveAgreement.protocolSettings.framingSettings.releaseIndicator]
   * The release indicator.
   * @member {number}
   * [edifact.receiveAgreement.protocolSettings.framingSettings.repetitionSeparator]
   * The repetition separator.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.framingSettings.characterSet]
   * The EDIFACT frame setting characterSet. Possible values include:
   * 'NotSpecified', 'UNOB', 'UNOA', 'UNOC', 'UNOD', 'UNOE', 'UNOF', 'UNOG',
   * 'UNOH', 'UNOI', 'UNOJ', 'UNOK', 'UNOX', 'UNOY', 'KECA'
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.framingSettings.decimalPointIndicator]
   * The EDIFACT frame setting decimal indicator. Possible values include:
   * 'NotSpecified', 'Comma', 'Decimal'
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.framingSettings.segmentTerminatorSuffix]
   * The EDIFACT frame setting segment terminator suffix. Possible values
   * include: 'NotSpecified', 'None', 'CR', 'LF', 'CRLF'
   * @member {object}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings] The EDIFACT
   * envelope settings.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.groupAssociationAssignedCode]
   * The group association assigned code.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.communicationAgreementId]
   * The communication agreement id.
   * @member {boolean}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.applyDelimiterStringAdvice]
   * The value indicating whether to apply delimiter string advice.
   * @member {boolean}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.createGroupingSegments]
   * The value indicating whether to create grouping segments.
   * @member {boolean}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.enableDefaultGroupHeaders]
   * The value indicating whether to enable default group headers.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.recipientReferencePasswordValue]
   * The recipient reference password value.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.recipientReferencePasswordQualifier]
   * The recipient reference password qualifier.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.applicationReferenceId]
   * The application reference id.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.processingPriorityCode]
   * The processing priority code.
   * @member {number}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.interchangeControlNumberLowerBound]
   * The interchange control number lower bound.
   * @member {number}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.interchangeControlNumberUpperBound]
   * The interchange control number upper bound.
   * @member {boolean}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.rolloverInterchangeControlNumber]
   * The value indicating whether to rollover interchange control number.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.interchangeControlNumberPrefix]
   * The interchange control number prefix.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.interchangeControlNumberSuffix]
   * The interchange control number suffix.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.senderReverseRoutingAddress]
   * The sender reverse routing address.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.receiverReverseRoutingAddress]
   * The receiver reverse routing address.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.functionalGroupId]
   * The functional group id.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.groupControllingAgencyCode]
   * The group controlling agency code.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.groupMessageVersion]
   * The group message version.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.groupMessageRelease]
   * The group message release.
   * @member {number}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.groupControlNumberLowerBound]
   * The group control number lower bound.
   * @member {number}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.groupControlNumberUpperBound]
   * The group control number upper bound.
   * @member {boolean}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.rolloverGroupControlNumber]
   * The value indicating whether to rollover group control number.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.groupControlNumberPrefix]
   * The group control number prefix.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.groupControlNumberSuffix]
   * The group control number suffix.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.groupApplicationReceiverQualifier]
   * The group application receiver qualifier.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.groupApplicationReceiverId]
   * The group application receiver id.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.groupApplicationSenderQualifier]
   * The group application sender qualifier.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.groupApplicationSenderId]
   * The group application sender id.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.groupApplicationPassword]
   * The group application password.
   * @member {boolean}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.overwriteExistingTransactionSetControlNumber]
   * The value indicating whether to overwrite existing transaction set control
   * number.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.transactionSetControlNumberPrefix]
   * The transaction set control number prefix.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.transactionSetControlNumberSuffix]
   * The transaction set control number suffix.
   * @member {number}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.transactionSetControlNumberLowerBound]
   * The transaction set control number lower bound.
   * @member {number}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.transactionSetControlNumberUpperBound]
   * The transaction set control number upper bound.
   * @member {boolean}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.rolloverTransactionSetControlNumber]
   * The value indicating whether to rollover transaction set control number.
   * @member {boolean}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.isTestInterchange]
   * The value indicating whether the message is a test interchange.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.senderInternalIdentification]
   * The sender internal identification.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.senderInternalSubIdentification]
   * The sender internal sub identification.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.receiverInternalIdentification]
   * The receiver internal identification.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.envelopeSettings.receiverInternalSubIdentification]
   * The receiver internal sub identification.
   * @member {object}
   * [edifact.receiveAgreement.protocolSettings.acknowledgementSettings] The
   * EDIFACT acknowledgement settings.
   * @member {boolean}
   * [edifact.receiveAgreement.protocolSettings.acknowledgementSettings.needTechnicalAcknowledgement]
   * The value indicating whether technical acknowledgement is needed.
   * @member {boolean}
   * [edifact.receiveAgreement.protocolSettings.acknowledgementSettings.batchTechnicalAcknowledgements]
   * The value indicating whether to batch the technical acknowledgements.
   * @member {boolean}
   * [edifact.receiveAgreement.protocolSettings.acknowledgementSettings.needFunctionalAcknowledgement]
   * The value indicating whether functional acknowledgement is needed.
   * @member {boolean}
   * [edifact.receiveAgreement.protocolSettings.acknowledgementSettings.batchFunctionalAcknowledgements]
   * The value indicating whether to batch functional acknowledgements.
   * @member {boolean}
   * [edifact.receiveAgreement.protocolSettings.acknowledgementSettings.needLoopForValidMessages]
   * The value indicating whether a loop is needed for valid messages.
   * @member {boolean}
   * [edifact.receiveAgreement.protocolSettings.acknowledgementSettings.sendSynchronousAcknowledgement]
   * The value indicating whether to send synchronous acknowledgement.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.acknowledgementSettings.acknowledgementControlNumberPrefix]
   * The acknowledgement control number prefix.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.acknowledgementSettings.acknowledgementControlNumberSuffix]
   * The acknowledgement control number suffix.
   * @member {number}
   * [edifact.receiveAgreement.protocolSettings.acknowledgementSettings.acknowledgementControlNumberLowerBound]
   * The acknowledgement control number lower bound.
   * @member {number}
   * [edifact.receiveAgreement.protocolSettings.acknowledgementSettings.acknowledgementControlNumberUpperBound]
   * The acknowledgement control number upper bound.
   * @member {boolean}
   * [edifact.receiveAgreement.protocolSettings.acknowledgementSettings.rolloverAcknowledgementControlNumber]
   * The value indicating whether to rollover acknowledgement control number.
   * @member {object} [edifact.receiveAgreement.protocolSettings.messageFilter]
   * The EDIFACT message filter.
   * @member {string}
   * [edifact.receiveAgreement.protocolSettings.messageFilter.messageFilterType]
   * The message filter type. Possible values include: 'NotSpecified',
   * 'Include', 'Exclude'
   * @member {object}
   * [edifact.receiveAgreement.protocolSettings.processingSettings] The EDIFACT
   * processing Settings.
   * @member {boolean}
   * [edifact.receiveAgreement.protocolSettings.processingSettings.maskSecurityInfo]
   * The value indicating whether to mask security information.
   * @member {boolean}
   * [edifact.receiveAgreement.protocolSettings.processingSettings.preserveInterchange]
   * The value indicating whether to preserve interchange.
   * @member {boolean}
   * [edifact.receiveAgreement.protocolSettings.processingSettings.suspendInterchangeOnError]
   * The value indicating whether to suspend interchange on error.
   * @member {boolean}
   * [edifact.receiveAgreement.protocolSettings.processingSettings.createEmptyXmlTagsForTrailingSeparators]
   * The value indicating whether to create empty xml tags for trailing
   * separators.
   * @member {boolean}
   * [edifact.receiveAgreement.protocolSettings.processingSettings.useDotAsDecimalSeparator]
   * The value indicating whether to use dot as decimal separator.
   * @member {array}
   * [edifact.receiveAgreement.protocolSettings.envelopeOverrides] The EDIFACT
   * envelope override settings.
   * @member {array}
   * [edifact.receiveAgreement.protocolSettings.messageFilterList] The EDIFACT
   * message filter list.
   * @member {array}
   * [edifact.receiveAgreement.protocolSettings.schemaReferences] The EDIFACT
   * schema references.
   * @member {array}
   * [edifact.receiveAgreement.protocolSettings.validationOverrides] The
   * EDIFACT validation override settings.
   * @member {array}
   * [edifact.receiveAgreement.protocolSettings.edifactDelimiterOverrides] The
   * EDIFACT delimiter override settings.
   * @member {object} [edifact.sendAgreement] The EDIFACT one-way send
   * agreement.
   * @member {object} [edifact.sendAgreement.senderBusinessIdentity] The sender
   * business identity
   * @member {string} [edifact.sendAgreement.senderBusinessIdentity.qualifier]
   * The business identity qualifier e.g. as2identity, ZZ, ZZZ, 31, 32
   * @member {string} [edifact.sendAgreement.senderBusinessIdentity.value] The
   * user defined business identity value.
   * @member {object} [edifact.sendAgreement.receiverBusinessIdentity] The
   * receiver business identity
   * @member {string}
   * [edifact.sendAgreement.receiverBusinessIdentity.qualifier] The business
   * identity qualifier e.g. as2identity, ZZ, ZZZ, 31, 32
   * @member {string} [edifact.sendAgreement.receiverBusinessIdentity.value]
   * The user defined business identity value.
   * @member {object} [edifact.sendAgreement.protocolSettings] The EDIFACT
   * protocol settings.
   * @member {object}
   * [edifact.sendAgreement.protocolSettings.validationSettings] The EDIFACT
   * validation settings.
   * @member {boolean}
   * [edifact.sendAgreement.protocolSettings.validationSettings.validateCharacterSet]
   * The value indicating whether to validate character set in the message.
   * @member {boolean}
   * [edifact.sendAgreement.protocolSettings.validationSettings.checkDuplicateInterchangeControlNumber]
   * The value indicating whether to check for duplicate interchange control
   * number.
   * @member {number}
   * [edifact.sendAgreement.protocolSettings.validationSettings.interchangeControlNumberValidityDays]
   * The validity period of interchange control number.
   * @member {boolean}
   * [edifact.sendAgreement.protocolSettings.validationSettings.checkDuplicateGroupControlNumber]
   * The value indicating whether to check for duplicate group control number.
   * @member {boolean}
   * [edifact.sendAgreement.protocolSettings.validationSettings.checkDuplicateTransactionSetControlNumber]
   * The value indicating whether to check for duplicate transaction set
   * control number.
   * @member {boolean}
   * [edifact.sendAgreement.protocolSettings.validationSettings.validateEdiTypes]
   * The value indicating whether to Whether to validate EDI types.
   * @member {boolean}
   * [edifact.sendAgreement.protocolSettings.validationSettings.validateXsdTypes]
   * The value indicating whether to Whether to validate XSD types.
   * @member {boolean}
   * [edifact.sendAgreement.protocolSettings.validationSettings.allowLeadingAndTrailingSpacesAndZeroes]
   * The value indicating whether to allow leading and trailing spaces and
   * zeroes.
   * @member {boolean}
   * [edifact.sendAgreement.protocolSettings.validationSettings.trimLeadingAndTrailingSpacesAndZeroes]
   * The value indicating whether to trim leading and trailing spaces and
   * zeroes.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.validationSettings.trailingSeparatorPolicy]
   * The trailing separator policy. Possible values include: 'NotSpecified',
   * 'NotAllowed', 'Optional', 'Mandatory'
   * @member {object} [edifact.sendAgreement.protocolSettings.framingSettings]
   * The EDIFACT framing settings.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.framingSettings.serviceCodeListDirectoryVersion]
   * The service code list directory version.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.framingSettings.characterEncoding]
   * The character encoding.
   * @member {number}
   * [edifact.sendAgreement.protocolSettings.framingSettings.protocolVersion]
   * The protocol version.
   * @member {number}
   * [edifact.sendAgreement.protocolSettings.framingSettings.dataElementSeparator]
   * The data element separator.
   * @member {number}
   * [edifact.sendAgreement.protocolSettings.framingSettings.componentSeparator]
   * The component separator.
   * @member {number}
   * [edifact.sendAgreement.protocolSettings.framingSettings.segmentTerminator]
   * The segment terminator.
   * @member {number}
   * [edifact.sendAgreement.protocolSettings.framingSettings.releaseIndicator]
   * The release indicator.
   * @member {number}
   * [edifact.sendAgreement.protocolSettings.framingSettings.repetitionSeparator]
   * The repetition separator.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.framingSettings.characterSet] The
   * EDIFACT frame setting characterSet. Possible values include:
   * 'NotSpecified', 'UNOB', 'UNOA', 'UNOC', 'UNOD', 'UNOE', 'UNOF', 'UNOG',
   * 'UNOH', 'UNOI', 'UNOJ', 'UNOK', 'UNOX', 'UNOY', 'KECA'
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.framingSettings.decimalPointIndicator]
   * The EDIFACT frame setting decimal indicator. Possible values include:
   * 'NotSpecified', 'Comma', 'Decimal'
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.framingSettings.segmentTerminatorSuffix]
   * The EDIFACT frame setting segment terminator suffix. Possible values
   * include: 'NotSpecified', 'None', 'CR', 'LF', 'CRLF'
   * @member {object} [edifact.sendAgreement.protocolSettings.envelopeSettings]
   * The EDIFACT envelope settings.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.groupAssociationAssignedCode]
   * The group association assigned code.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.communicationAgreementId]
   * The communication agreement id.
   * @member {boolean}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.applyDelimiterStringAdvice]
   * The value indicating whether to apply delimiter string advice.
   * @member {boolean}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.createGroupingSegments]
   * The value indicating whether to create grouping segments.
   * @member {boolean}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.enableDefaultGroupHeaders]
   * The value indicating whether to enable default group headers.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.recipientReferencePasswordValue]
   * The recipient reference password value.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.recipientReferencePasswordQualifier]
   * The recipient reference password qualifier.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.applicationReferenceId]
   * The application reference id.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.processingPriorityCode]
   * The processing priority code.
   * @member {number}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.interchangeControlNumberLowerBound]
   * The interchange control number lower bound.
   * @member {number}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.interchangeControlNumberUpperBound]
   * The interchange control number upper bound.
   * @member {boolean}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.rolloverInterchangeControlNumber]
   * The value indicating whether to rollover interchange control number.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.interchangeControlNumberPrefix]
   * The interchange control number prefix.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.interchangeControlNumberSuffix]
   * The interchange control number suffix.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.senderReverseRoutingAddress]
   * The sender reverse routing address.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.receiverReverseRoutingAddress]
   * The receiver reverse routing address.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.functionalGroupId]
   * The functional group id.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.groupControllingAgencyCode]
   * The group controlling agency code.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.groupMessageVersion]
   * The group message version.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.groupMessageRelease]
   * The group message release.
   * @member {number}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.groupControlNumberLowerBound]
   * The group control number lower bound.
   * @member {number}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.groupControlNumberUpperBound]
   * The group control number upper bound.
   * @member {boolean}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.rolloverGroupControlNumber]
   * The value indicating whether to rollover group control number.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.groupControlNumberPrefix]
   * The group control number prefix.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.groupControlNumberSuffix]
   * The group control number suffix.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.groupApplicationReceiverQualifier]
   * The group application receiver qualifier.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.groupApplicationReceiverId]
   * The group application receiver id.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.groupApplicationSenderQualifier]
   * The group application sender qualifier.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.groupApplicationSenderId]
   * The group application sender id.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.groupApplicationPassword]
   * The group application password.
   * @member {boolean}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.overwriteExistingTransactionSetControlNumber]
   * The value indicating whether to overwrite existing transaction set control
   * number.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.transactionSetControlNumberPrefix]
   * The transaction set control number prefix.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.transactionSetControlNumberSuffix]
   * The transaction set control number suffix.
   * @member {number}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.transactionSetControlNumberLowerBound]
   * The transaction set control number lower bound.
   * @member {number}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.transactionSetControlNumberUpperBound]
   * The transaction set control number upper bound.
   * @member {boolean}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.rolloverTransactionSetControlNumber]
   * The value indicating whether to rollover transaction set control number.
   * @member {boolean}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.isTestInterchange]
   * The value indicating whether the message is a test interchange.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.senderInternalIdentification]
   * The sender internal identification.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.senderInternalSubIdentification]
   * The sender internal sub identification.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.receiverInternalIdentification]
   * The receiver internal identification.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.envelopeSettings.receiverInternalSubIdentification]
   * The receiver internal sub identification.
   * @member {object}
   * [edifact.sendAgreement.protocolSettings.acknowledgementSettings] The
   * EDIFACT acknowledgement settings.
   * @member {boolean}
   * [edifact.sendAgreement.protocolSettings.acknowledgementSettings.needTechnicalAcknowledgement]
   * The value indicating whether technical acknowledgement is needed.
   * @member {boolean}
   * [edifact.sendAgreement.protocolSettings.acknowledgementSettings.batchTechnicalAcknowledgements]
   * The value indicating whether to batch the technical acknowledgements.
   * @member {boolean}
   * [edifact.sendAgreement.protocolSettings.acknowledgementSettings.needFunctionalAcknowledgement]
   * The value indicating whether functional acknowledgement is needed.
   * @member {boolean}
   * [edifact.sendAgreement.protocolSettings.acknowledgementSettings.batchFunctionalAcknowledgements]
   * The value indicating whether to batch functional acknowledgements.
   * @member {boolean}
   * [edifact.sendAgreement.protocolSettings.acknowledgementSettings.needLoopForValidMessages]
   * The value indicating whether a loop is needed for valid messages.
   * @member {boolean}
   * [edifact.sendAgreement.protocolSettings.acknowledgementSettings.sendSynchronousAcknowledgement]
   * The value indicating whether to send synchronous acknowledgement.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.acknowledgementSettings.acknowledgementControlNumberPrefix]
   * The acknowledgement control number prefix.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.acknowledgementSettings.acknowledgementControlNumberSuffix]
   * The acknowledgement control number suffix.
   * @member {number}
   * [edifact.sendAgreement.protocolSettings.acknowledgementSettings.acknowledgementControlNumberLowerBound]
   * The acknowledgement control number lower bound.
   * @member {number}
   * [edifact.sendAgreement.protocolSettings.acknowledgementSettings.acknowledgementControlNumberUpperBound]
   * The acknowledgement control number upper bound.
   * @member {boolean}
   * [edifact.sendAgreement.protocolSettings.acknowledgementSettings.rolloverAcknowledgementControlNumber]
   * The value indicating whether to rollover acknowledgement control number.
   * @member {object} [edifact.sendAgreement.protocolSettings.messageFilter]
   * The EDIFACT message filter.
   * @member {string}
   * [edifact.sendAgreement.protocolSettings.messageFilter.messageFilterType]
   * The message filter type. Possible values include: 'NotSpecified',
   * 'Include', 'Exclude'
   * @member {object}
   * [edifact.sendAgreement.protocolSettings.processingSettings] The EDIFACT
   * processing Settings.
   * @member {boolean}
   * [edifact.sendAgreement.protocolSettings.processingSettings.maskSecurityInfo]
   * The value indicating whether to mask security information.
   * @member {boolean}
   * [edifact.sendAgreement.protocolSettings.processingSettings.preserveInterchange]
   * The value indicating whether to preserve interchange.
   * @member {boolean}
   * [edifact.sendAgreement.protocolSettings.processingSettings.suspendInterchangeOnError]
   * The value indicating whether to suspend interchange on error.
   * @member {boolean}
   * [edifact.sendAgreement.protocolSettings.processingSettings.createEmptyXmlTagsForTrailingSeparators]
   * The value indicating whether to create empty xml tags for trailing
   * separators.
   * @member {boolean}
   * [edifact.sendAgreement.protocolSettings.processingSettings.useDotAsDecimalSeparator]
   * The value indicating whether to use dot as decimal separator.
   * @member {array} [edifact.sendAgreement.protocolSettings.envelopeOverrides]
   * The EDIFACT envelope override settings.
   * @member {array} [edifact.sendAgreement.protocolSettings.messageFilterList]
   * The EDIFACT message filter list.
   * @member {array} [edifact.sendAgreement.protocolSettings.schemaReferences]
   * The EDIFACT schema references.
   * @member {array}
   * [edifact.sendAgreement.protocolSettings.validationOverrides] The EDIFACT
   * validation override settings.
   * @member {array}
   * [edifact.sendAgreement.protocolSettings.edifactDelimiterOverrides] The
   * EDIFACT delimiter override settings.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AgreementContent
   *
   * @returns {object} metadata of AgreementContent
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AgreementContent',
      type: {
        name: 'Composite',
        className: 'AgreementContent',
        modelProperties: {
          aS2: {
            required: false,
            serializedName: 'aS2',
            type: {
              name: 'Composite',
              className: 'AS2AgreementContent'
            }
          },
          x12: {
            required: false,
            serializedName: 'x12',
            type: {
              name: 'Composite',
              className: 'X12AgreementContent'
            }
          },
          edifact: {
            required: false,
            serializedName: 'edifact',
            type: {
              name: 'Composite',
              className: 'EdifactAgreementContent'
            }
          }
        }
      }
    };
  }
}

module.exports = AgreementContent;
