/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The Edifact agreement protocol settings.
 *
 */
class EdifactProcessingSettings {
  /**
   * Create a EdifactProcessingSettings.
   * @member {boolean} maskSecurityInfo The value indicating whether to mask
   * security information.
   * @member {boolean} preserveInterchange The value indicating whether to
   * preserve interchange.
   * @member {boolean} suspendInterchangeOnError The value indicating whether
   * to suspend interchange on error.
   * @member {boolean} createEmptyXmlTagsForTrailingSeparators The value
   * indicating whether to create empty xml tags for trailing separators.
   * @member {boolean} useDotAsDecimalSeparator The value indicating whether to
   * use dot as decimal separator.
   */
  constructor() {
  }

  /**
   * Defines the metadata of EdifactProcessingSettings
   *
   * @returns {object} metadata of EdifactProcessingSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EdifactProcessingSettings',
      type: {
        name: 'Composite',
        className: 'EdifactProcessingSettings',
        modelProperties: {
          maskSecurityInfo: {
            required: true,
            serializedName: 'maskSecurityInfo',
            type: {
              name: 'Boolean'
            }
          },
          preserveInterchange: {
            required: true,
            serializedName: 'preserveInterchange',
            type: {
              name: 'Boolean'
            }
          },
          suspendInterchangeOnError: {
            required: true,
            serializedName: 'suspendInterchangeOnError',
            type: {
              name: 'Boolean'
            }
          },
          createEmptyXmlTagsForTrailingSeparators: {
            required: true,
            serializedName: 'createEmptyXmlTagsForTrailingSeparators',
            type: {
              name: 'Boolean'
            }
          },
          useDotAsDecimalSeparator: {
            required: true,
            serializedName: 'useDotAsDecimalSeparator',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = EdifactProcessingSettings;
