/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Error properties indicate why the Logic service was not able to process the
 * incoming request. The reason is provided in the error message.
 *
 */
class ErrorProperties {
  /**
   * Create a ErrorProperties.
   * @member {string} [code] Error code.
   * @member {string} [message] Error message indicating why the operation
   * failed.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ErrorProperties
   *
   * @returns {object} metadata of ErrorProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ErrorProperties',
      type: {
        name: 'Composite',
        className: 'ErrorProperties',
        modelProperties: {
          code: {
            required: false,
            serializedName: 'code',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ErrorProperties;
