/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Error reponse indicates Logic service is not able to process the incoming
 * request. The error property contains the error details.
 *
 */
class ErrorResponse {
  /**
   * Create a ErrorResponse.
   * @member {object} [error] The error properties.
   * @member {string} [error.code] Error code.
   * @member {string} [error.message] Error message indicating why the
   * operation failed.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ErrorResponse
   *
   * @returns {object} metadata of ErrorResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ErrorResponse',
      type: {
        name: 'Composite',
        className: 'ErrorResponse',
        modelProperties: {
          error: {
            required: false,
            serializedName: 'error',
            type: {
              name: 'Composite',
              className: 'ErrorProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = ErrorResponse;
