/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The callback url parameters.
 *
 */
class GetCallbackUrlParameters {
  /**
   * Create a GetCallbackUrlParameters.
   * @member {date} [notAfter] The expiry time.
   * @member {string} [keyType] The key type. Possible values include:
   * 'NotSpecified', 'Primary', 'Secondary'
   */
  constructor() {
  }

  /**
   * Defines the metadata of GetCallbackUrlParameters
   *
   * @returns {object} metadata of GetCallbackUrlParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GetCallbackUrlParameters',
      type: {
        name: 'Composite',
        className: 'GetCallbackUrlParameters',
        modelProperties: {
          notAfter: {
            required: false,
            serializedName: 'notAfter',
            type: {
              name: 'DateTime'
            }
          },
          keyType: {
            required: false,
            serializedName: 'keyType',
            type: {
              name: 'Enum',
              allowedValues: [ 'NotSpecified', 'Primary', 'Secondary' ]
            }
          }
        }
      }
    };
  }
}

module.exports = GetCallbackUrlParameters;
