/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The sku type.
 *
 */
class Sku {
  /**
   * Create a Sku.
   * @member {string} name The name. Possible values include: 'NotSpecified',
   * 'Free', 'Shared', 'Basic', 'Standard', 'Premium'
   * @member {object} [plan] The reference to plan.
   * @member {string} [plan.id] The resource id.
   * @member {string} [plan.name] Gets the resource name.
   * @member {string} [plan.type] Gets the resource type.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Sku
   *
   * @returns {object} metadata of Sku
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Sku',
      type: {
        name: 'Composite',
        className: 'Sku',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'Enum',
              allowedValues: [ 'NotSpecified', 'Free', 'Shared', 'Basic', 'Standard', 'Premium' ]
            }
          },
          plan: {
            required: false,
            serializedName: 'plan',
            type: {
              name: 'Composite',
              className: 'ResourceReference'
            }
          }
        }
      }
    };
  }
}

module.exports = Sku;
