/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The workflow parameters.
 *
 */
class WorkflowParameter {
  /**
   * Create a WorkflowParameter.
   * @member {string} [type] The type. Possible values include: 'NotSpecified',
   * 'String', 'SecureString', 'Int', 'Float', 'Bool', 'Array', 'Object',
   * 'SecureObject'
   * @member {object} [value] The value.
   * @member {object} [metadata] The metadata.
   * @member {string} [description] The description.
   */
  constructor() {
  }

  /**
   * Defines the metadata of WorkflowParameter
   *
   * @returns {object} metadata of WorkflowParameter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'WorkflowParameter',
      type: {
        name: 'Composite',
        className: 'WorkflowParameter',
        modelProperties: {
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'Enum',
              allowedValues: [ 'NotSpecified', 'String', 'SecureString', 'Int', 'Float', 'Bool', 'Array', 'Object', 'SecureObject' ]
            }
          },
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'Object'
            }
          },
          metadata: {
            required: false,
            serializedName: 'metadata',
            type: {
              name: 'Object'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = WorkflowParameter;
