/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The X12 message filter for odata query.
 *
 */
class X12MessageFilter {
  /**
   * Create a X12MessageFilter.
   * @member {string} messageFilterType The message filter type. Possible
   * values include: 'NotSpecified', 'Include', 'Exclude'
   */
  constructor() {
  }

  /**
   * Defines the metadata of X12MessageFilter
   *
   * @returns {object} metadata of X12MessageFilter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'X12MessageFilter',
      type: {
        name: 'Composite',
        className: 'X12MessageFilter',
        modelProperties: {
          messageFilterType: {
            required: true,
            serializedName: 'messageFilterType',
            type: {
              name: 'Enum',
              allowedValues: [ 'NotSpecified', 'Include', 'Exclude' ]
            }
          }
        }
      }
    };
  }
}

module.exports = X12MessageFilter;
