/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The X12 agreement security settings.
 *
 */
class X12SecuritySettings {
  /**
   * Create a X12SecuritySettings.
   * @member {string} authorizationQualifier The authorization qualifier.
   * @member {string} [authorizationValue] The authorization value.
   * @member {string} securityQualifier The security qualifier.
   * @member {string} [passwordValue] The password value.
   */
  constructor() {
  }

  /**
   * Defines the metadata of X12SecuritySettings
   *
   * @returns {object} metadata of X12SecuritySettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'X12SecuritySettings',
      type: {
        name: 'Composite',
        className: 'X12SecuritySettings',
        modelProperties: {
          authorizationQualifier: {
            required: true,
            serializedName: 'authorizationQualifier',
            type: {
              name: 'String'
            }
          },
          authorizationValue: {
            required: false,
            serializedName: 'authorizationValue',
            type: {
              name: 'String'
            }
          },
          securityQualifier: {
            required: true,
            serializedName: 'securityQualifier',
            type: {
              name: 'String'
            }
          },
          passwordValue: {
            required: false,
            serializedName: 'passwordValue',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = X12SecuritySettings;
