/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The X12 validation override settings.
 *
 */
class X12ValidationOverride {
  /**
   * Create a X12ValidationOverride.
   * @member {string} messageId The message id on which the validation settings
   * has to be applied.
   * @member {boolean} validateEdiTypes The value indicating whether to
   * validate EDI types.
   * @member {boolean} validateXsdTypes The value indicating whether to
   * validate XSD types.
   * @member {boolean} allowLeadingAndTrailingSpacesAndZeroes The value
   * indicating whether to allow leading and trailing spaces and zeroes.
   * @member {boolean} validateCharacterSet The value indicating whether to
   * validate character Set.
   * @member {boolean} trimLeadingAndTrailingSpacesAndZeroes The value
   * indicating whether to trim leading and trailing spaces and zeroes.
   * @member {string} trailingSeparatorPolicy The trailing separator policy.
   * Possible values include: 'NotSpecified', 'NotAllowed', 'Optional',
   * 'Mandatory'
   */
  constructor() {
  }

  /**
   * Defines the metadata of X12ValidationOverride
   *
   * @returns {object} metadata of X12ValidationOverride
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'X12ValidationOverride',
      type: {
        name: 'Composite',
        className: 'X12ValidationOverride',
        modelProperties: {
          messageId: {
            required: true,
            serializedName: 'messageId',
            type: {
              name: 'String'
            }
          },
          validateEdiTypes: {
            required: true,
            serializedName: 'validateEdiTypes',
            type: {
              name: 'Boolean'
            }
          },
          validateXsdTypes: {
            required: true,
            serializedName: 'validateXsdTypes',
            type: {
              name: 'Boolean'
            }
          },
          allowLeadingAndTrailingSpacesAndZeroes: {
            required: true,
            serializedName: 'allowLeadingAndTrailingSpacesAndZeroes',
            type: {
              name: 'Boolean'
            }
          },
          validateCharacterSet: {
            required: true,
            serializedName: 'validateCharacterSet',
            type: {
              name: 'Boolean'
            }
          },
          trimLeadingAndTrailingSpacesAndZeroes: {
            required: true,
            serializedName: 'trimLeadingAndTrailingSpacesAndZeroes',
            type: {
              name: 'Boolean'
            }
          },
          trailingSeparatorPolicy: {
            required: true,
            serializedName: 'trailingSeparatorPolicy',
            type: {
              name: 'Enum',
              allowedValues: [ 'NotSpecified', 'NotAllowed', 'Optional', 'Mandatory' ]
            }
          }
        }
      }
    };
  }
}

module.exports = X12ValidationOverride;
