/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the access location for a blob.
 *
 */
class BlobLocation {
  /**
   * Create a BlobLocation.
   * @member {string} uri The URI from which the blob is accessible from. For
   * example, aml://abc for system assets or https://xyz for user assets or
   * payload.
   * @member {string} [credentials] Access credentials for the blob, if
   * applicable (e.g. blob specified by storage account connection string +
   * blob URI)
   */
  constructor() {
  }

  /**
   * Defines the metadata of BlobLocation
   *
   * @returns {object} metadata of BlobLocation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BlobLocation',
      type: {
        name: 'Composite',
        className: 'BlobLocation',
        modelProperties: {
          uri: {
            required: true,
            serializedName: 'uri',
            type: {
              name: 'String'
            }
          },
          credentials: {
            required: false,
            serializedName: 'credentials',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = BlobLocation;
