/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Diagnostics settings for an Azure ML web service.
 *
 */
class DiagnosticsConfiguration {
  /**
   * Create a DiagnosticsConfiguration.
   * @member {string} level Specifies the verbosity of the diagnostic output.
   * Valid values are: None - disables tracing; Error - collects only error
   * (stderr) traces; All - collects all traces (stdout and stderr). Possible
   * values include: 'None', 'Error', 'All'
   * @member {date} [expiry] Specifies the date and time when the logging will
   * cease. If null, diagnostic collection is not time limited.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DiagnosticsConfiguration
   *
   * @returns {object} metadata of DiagnosticsConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DiagnosticsConfiguration',
      type: {
        name: 'Composite',
        className: 'DiagnosticsConfiguration',
        modelProperties: {
          level: {
            required: true,
            serializedName: 'level',
            type: {
              name: 'String'
            }
          },
          expiry: {
            required: false,
            serializedName: 'expiry',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = DiagnosticsConfiguration;
