/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Association link for a graph global parameter to a node in the graph.
 *
 */
class GraphParameterLink {
  /**
   * Create a GraphParameterLink.
   * @member {string} nodeId The graph node's identifier
   * @member {string} parameterKey The identifier of the node parameter that
   * the global parameter maps to.
   */
  constructor() {
  }

  /**
   * Defines the metadata of GraphParameterLink
   *
   * @returns {object} metadata of GraphParameterLink
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GraphParameterLink',
      type: {
        name: 'Composite',
        className: 'GraphParameterLink',
        modelProperties: {
          nodeId: {
            required: true,
            serializedName: 'nodeId',
            type: {
              name: 'String'
            }
          },
          parameterKey: {
            required: true,
            serializedName: 'parameterKey',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = GraphParameterLink;
