/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Nested parameter definition.
 *
 */
class ModeValueInfo {
  /**
   * Create a ModeValueInfo.
   * @member {string} [interfaceString] The interface string name for the
   * nested parameter.
   * @member {array} [parameters] The definition of the parameter.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ModeValueInfo
   *
   * @returns {object} metadata of ModeValueInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ModeValueInfo',
      type: {
        name: 'Composite',
        className: 'ModeValueInfo',
        modelProperties: {
          interfaceString: {
            required: false,
            serializedName: 'interfaceString',
            type: {
              name: 'String'
            }
          },
          parameters: {
            required: false,
            serializedName: 'parameters',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ModuleAssetParameterElementType',
                  type: {
                    name: 'Composite',
                    className: 'ModuleAssetParameter'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ModeValueInfo;
