/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Holds the available configuration options for an Azure ML web service
 * endpoint.
 *
 */
class RealtimeConfiguration {
  /**
   * Create a RealtimeConfiguration.
   * @member {number} [maxConcurrentCalls] Specifies the maximum concurrent
   * calls that can be made to the web service. Minimum value: 4, Maximum
   * value: 200.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RealtimeConfiguration
   *
   * @returns {object} metadata of RealtimeConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RealtimeConfiguration',
      type: {
        name: 'Composite',
        className: 'RealtimeConfiguration',
        modelProperties: {
          maxConcurrentCalls: {
            required: false,
            serializedName: 'maxConcurrentCalls',
            constraints: {
              InclusiveMaximum: 200,
              InclusiveMinimum: 4
            },
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = RealtimeConfiguration;
