/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties of Azure Container Registry.
 *
 */
class ContainerRegistryProperties {
  /**
   * Create a ContainerRegistryProperties.
   * @member {string} [resourceId] ARM resource ID of the Azure Container
   * Registry used to store Docker images for web services in the cluster. If
   * not provided one will be created. This cannot be changed once the cluster
   * is created.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ContainerRegistryProperties
   *
   * @returns {object} metadata of ContainerRegistryProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContainerRegistryProperties',
      type: {
        name: 'Composite',
        className: 'ContainerRegistryProperties',
        modelProperties: {
          resourceId: {
            required: false,
            serializedName: 'resourceId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ContainerRegistryProperties;
