/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Access information for the storage account.
 *
 */
class StorageAccountCredentials {
  /**
   * Create a StorageAccountCredentials.
   * @member {string} [resourceId] The ARM resource ID of the storage account.
   * @member {string} [primaryKey] The primary key of the storage account.
   * @member {string} [secondaryKey] The secondary key of the storage account.
   */
  constructor() {
  }

  /**
   * Defines the metadata of StorageAccountCredentials
   *
   * @returns {object} metadata of StorageAccountCredentials
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'StorageAccountCredentials',
      type: {
        name: 'Composite',
        className: 'StorageAccountCredentials',
        modelProperties: {
          resourceId: {
            required: false,
            readOnly: true,
            serializedName: 'resourceId',
            type: {
              name: 'String'
            }
          },
          primaryKey: {
            required: false,
            readOnly: true,
            serializedName: 'primaryKey',
            type: {
              name: 'String'
            }
          },
          secondaryKey: {
            required: false,
            readOnly: true,
            serializedName: 'secondaryKey',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = StorageAccountCredentials;
