/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties of Storage Account.
 *
 */
class StorageAccountProperties {
  /**
   * Create a StorageAccountProperties.
   * @member {string} [resourceId] ARM resource ID of the Azure Storage Account
   * to store CLI specific files. If not provided one will be created. This
   * cannot be changed once the cluster is created.
   */
  constructor() {
  }

  /**
   * Defines the metadata of StorageAccountProperties
   *
   * @returns {object} metadata of StorageAccountProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'StorageAccountProperties',
      type: {
        name: 'Composite',
        className: 'StorageAccountProperties',
        modelProperties: {
          resourceId: {
            required: false,
            serializedName: 'resourceId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = StorageAccountProperties;
