/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The response body for CheckNameAvailability API.
 *
 */
class CheckNameAvailabilityOutput {
  /**
   * Create a CheckNameAvailabilityOutput.
   * @member {boolean} [nameAvailable] Specifies if the name is available.
   * @member {string} [reason] Specifies the reason if the name is not
   * available. Possible values include: 'None', 'Invalid', 'AlreadyExists'
   * @member {string} [message] Specifies the detailed reason if the name is
   * not available.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CheckNameAvailabilityOutput
   *
   * @returns {object} metadata of CheckNameAvailabilityOutput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CheckNameAvailabilityOutput',
      type: {
        name: 'Composite',
        className: 'CheckNameAvailabilityOutput',
        modelProperties: {
          nameAvailable: {
            required: false,
            serializedName: 'nameAvailable',
            type: {
              name: 'Boolean'
            }
          },
          reason: {
            required: false,
            serializedName: 'reason',
            type: {
              name: 'Enum',
              allowedValues: [ 'None', 'Invalid', 'AlreadyExists' ]
            }
          },
          message: {
            required: false,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CheckNameAvailabilityOutput;
