/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The properties of a Media Service resource.
 *
 * @extends models['Resource']
 */
class MediaService extends models['Resource'] {
  /**
   * Create a MediaService.
   * @member {array} [apiEndpoints] Read-only property that lists the Media
   * Services REST API endpoints for this resource. If supplied on a PUT or
   * PATCH, the value will be ignored.
   * @member {array} [storageAccounts] The storage accounts for this resource.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of MediaService
   *
   * @returns {object} metadata of MediaService
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MediaService',
      type: {
        name: 'Composite',
        className: 'MediaService',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          apiEndpoints: {
            required: false,
            readOnly: true,
            serializedName: 'properties.apiEndpoints',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ApiEndpointElementType',
                  type: {
                    name: 'Composite',
                    className: 'ApiEndpoint'
                  }
              }
            }
          },
          storageAccounts: {
            required: false,
            serializedName: 'properties.storageAccounts',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StorageAccountElementType',
                  type: {
                    name: 'Composite',
                    className: 'StorageAccount'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = MediaService;
