/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The Mobile Engagement App resource.
 *
 * @extends models['Resource']
 */
class App extends models['Resource'] {
  /**
   * Create a App.
   * @member {string} [backendId] The application unique identifier.
   * @member {string} [platform] The platform of the app.
   * @member {string} [appState] The state of the application.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of App
   *
   * @returns {object} metadata of App
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'App',
      type: {
        name: 'Composite',
        className: 'App',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          backendId: {
            required: false,
            serializedName: 'properties.backendId',
            type: {
              name: 'String'
            }
          },
          platform: {
            required: false,
            serializedName: 'properties.platform',
            type: {
              name: 'String'
            }
          },
          appState: {
            required: false,
            serializedName: 'properties.appState',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = App;
