/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Send only to users who have some app info set. This is a special filter that
 * is automatically added if your campaign contains appInfo parameters. It is
 * not intended to be public and should not be used as it could be removed or
 * replaced by the API.
 *
 *
 * @extends models['Filter']
 */
class AppInfoFilter extends models['Filter'] {
  /**
   * Create a AppInfoFilter.
   * @member {array} [appInfo] An array containing all the required appInfo.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AppInfoFilter
   *
   * @returns {object} metadata of AppInfoFilter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'app-info',
      type: {
        name: 'Composite',
        className: 'AppInfoFilter',
        modelProperties: {
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          appInfo: {
            required: false,
            serializedName: 'appInfo',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = AppInfoFilter;
