/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a DeviceInfo.
 */
class DeviceInfo {
  /**
   * Create a DeviceInfo.
   * @member {string} [phoneModel] Phone model.
   * @member {string} [phoneManufacturer] Phone manufacturer
   * @member {string} [firmwareVersion] Firmware version.
   * @member {string} [firmwareName] Firmware name.
   * @member {number} [androidAPILevel] Android API level.
   * @member {string} [carrierCountry] Carrier country.
   * @member {string} [locale] Locale code.
   * @member {string} [carrierName] Carrier name.
   * @member {string} [networkType] Network type.
   * @member {string} [networkSubtype] Network sub-type.
   * @member {string} [applicationVersionName] Application version name.
   * @member {number} [applicationVersionCode] Application version code.
   * @member {number} [timeZoneOffset] The offset in minutes from UTC for the
   * device time zone, including daylight savings time.
   * @member {string} [serviceVersion] SDK version.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DeviceInfo
   *
   * @returns {object} metadata of DeviceInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DeviceInfo',
      type: {
        name: 'Composite',
        className: 'DeviceInfo',
        modelProperties: {
          phoneModel: {
            required: false,
            serializedName: 'phoneModel',
            type: {
              name: 'String'
            }
          },
          phoneManufacturer: {
            required: false,
            serializedName: 'phoneManufacturer',
            type: {
              name: 'String'
            }
          },
          firmwareVersion: {
            required: false,
            serializedName: 'firmwareVersion',
            type: {
              name: 'String'
            }
          },
          firmwareName: {
            required: false,
            serializedName: 'firmwareName',
            type: {
              name: 'String'
            }
          },
          androidAPILevel: {
            required: false,
            serializedName: 'androidAPILevel',
            type: {
              name: 'Number'
            }
          },
          carrierCountry: {
            required: false,
            serializedName: 'carrierCountry',
            type: {
              name: 'String'
            }
          },
          locale: {
            required: false,
            serializedName: 'locale',
            type: {
              name: 'String'
            }
          },
          carrierName: {
            required: false,
            serializedName: 'carrierName',
            type: {
              name: 'String'
            }
          },
          networkType: {
            required: false,
            serializedName: 'networkType',
            type: {
              name: 'String'
            }
          },
          networkSubtype: {
            required: false,
            serializedName: 'networkSubtype',
            type: {
              name: 'String'
            }
          },
          applicationVersionName: {
            required: false,
            serializedName: 'applicationVersionName',
            type: {
              name: 'String'
            }
          },
          applicationVersionCode: {
            required: false,
            serializedName: 'applicationVersionCode',
            type: {
              name: 'Number'
            }
          },
          timeZoneOffset: {
            required: false,
            serializedName: 'timeZoneOffset',
            type: {
              name: 'Number'
            }
          },
          serviceVersion: {
            required: false,
            serializedName: 'serviceVersion',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DeviceInfo;
