/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a DeviceTagsParameters.
 */
class DeviceTagsParameters {
  /**
   * Create a DeviceTagsParameters.
   * @member {object} tags A JSON object describing the set of tags to record
   * for a set of users. Each key is a device/user identifier, each value is
   * itself a key/value set: the tags to set for the specified device/user
   * identifier.
   * @member {boolean} [deleteOnNull] If this parameter is `true`, tags with a
   * null value will be deleted. Default value: false .
   */
  constructor() {
  }

  /**
   * Defines the metadata of DeviceTagsParameters
   *
   * @returns {object} metadata of DeviceTagsParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DeviceTagsParameters',
      type: {
        name: 'Composite',
        className: 'DeviceTagsParameters',
        modelProperties: {
          tags: {
            required: true,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'ObjectElementType',
                  type: {
                    name: 'Dictionary',
                    value: {
                        required: false,
                        serializedName: 'StringElementType',
                        type: {
                          name: 'String'
                        }
                    }
                  }
              }
            }
          },
          deleteOnNull: {
            required: false,
            serializedName: 'deleteOnNull',
            defaultValue: false,
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = DeviceTagsParameters;
