/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Send only to a maximum of max users.
 *
 * @extends models['Filter']
 */
class EngageSubsetFilter extends models['Filter'] {
  /**
   * Create a EngageSubsetFilter.
   * @member {number} [max] An integer value representing the maximum users
   * that should be pushed.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of EngageSubsetFilter
   *
   * @returns {object} metadata of EngageSubsetFilter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'engage-subset',
      type: {
        name: 'Composite',
        className: 'EngageSubsetFilter',
        modelProperties: {
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          max: {
            required: false,
            serializedName: 'max',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = EngageSubsetFilter;
