/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Gets a paged list of ExportTasks.
 */
class ExportTaskListResult extends Array {
  /**
   * Create a ExportTaskListResult.
   * @member {string} [nextLink] When the results are paged, the nextLink is
   * the URI for the next page of results. This property is empty when there
   * are no additional pages.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ExportTaskListResult
   *
   * @returns {object} metadata of ExportTaskListResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'exportTaskListResult',
      type: {
        name: 'Composite',
        className: 'ExportTaskListResult',
        modelProperties: {
          value: {
            required: true,
            serializedName: '',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ExportTaskResultElementType',
                  type: {
                    name: 'Composite',
                    className: 'ExportTaskResult'
                  }
              }
            }
          },
          nextLink: {
            required: false,
            serializedName: 'nextLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ExportTaskListResult;
