/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a ExportTaskParameter.
 */
class ExportTaskParameter {
  /**
   * Create a ExportTaskParameter.
   * @member {string} containerUrl
   * @member {string} [description] A description of the export task.
   * @member {string} exportFormat The format of the exported data. Possible
   * values include: 'JsonBlob', 'CsvBlob'
   */
  constructor() {
  }

  /**
   * Defines the metadata of ExportTaskParameter
   *
   * @returns {object} metadata of ExportTaskParameter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'exportTaskParameter',
      type: {
        name: 'Composite',
        className: 'ExportTaskParameter',
        modelProperties: {
          containerUrl: {
            required: true,
            serializedName: 'containerUrl',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          exportFormat: {
            required: true,
            serializedName: 'exportFormat',
            type: {
              name: 'Enum',
              allowedValues: [ 'JsonBlob', 'CsvBlob' ]
            }
          }
        }
      }
    };
  }
}

module.exports = ExportTaskParameter;
