/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

var msRestAzure = require('ms-rest-azure');

exports.BaseResource = msRestAzure.BaseResource;
exports.CloudError = msRestAzure.CloudError;
exports.ApiErrorError = require('./apiErrorError');
exports.ApiError = require('./apiError');
exports.Resource = require('./resource');
exports.App = require('./app');
exports.AppCollection = require('./appCollection');
exports.AppCollectionNameAvailability = require('./appCollectionNameAvailability');
exports.SupportedPlatformsListResult = require('./supportedPlatformsListResult');
exports.CampaignTestSavedParameters = require('./campaignTestSavedParameters');
exports.Criterion = require('./criterion');
exports.Filter = require('./filter');
exports.CampaignAudience = require('./campaignAudience');
exports.NotificationOptions = require('./notificationOptions');
exports.CampaignLocalization = require('./campaignLocalization');
exports.PollQuestionLocalization = require('./pollQuestionLocalization');
exports.PollQuestionChoiceLocalization = require('./pollQuestionChoiceLocalization');
exports.PollQuestionChoice = require('./pollQuestionChoice');
exports.PollQuestion = require('./pollQuestion');
exports.Campaign = require('./campaign');
exports.CampaignTestNewParameters = require('./campaignTestNewParameters');
exports.CampaignPushParameters = require('./campaignPushParameters');
exports.CampaignState = require('./campaignState');
exports.CampaignStateResult = require('./campaignStateResult');
exports.CarrierNameCriterion = require('./carrierNameCriterion');
exports.CarrierCountryCriterion = require('./carrierCountryCriterion');
exports.FirmwareVersionCriterion = require('./firmwareVersionCriterion');
exports.DeviceManufacturerCriterion = require('./deviceManufacturerCriterion');
exports.DeviceModelCriterion = require('./deviceModelCriterion');
exports.ApplicationVersionCriterion = require('./applicationVersionCriterion');
exports.NetworkTypeCriterion = require('./networkTypeCriterion');
exports.LanguageCriterion = require('./languageCriterion');
exports.ScreenSizeCriterion = require('./screenSizeCriterion');
exports.LocationCriterion = require('./locationCriterion');
exports.GeoFencingCriterion = require('./geoFencingCriterion');
exports.AnnouncementFeedbackCriterion = require('./announcementFeedbackCriterion');
exports.PollFeedbackCriterion = require('./pollFeedbackCriterion');
exports.PollAnswerFeedbackCriterion = require('./pollAnswerFeedbackCriterion');
exports.DatapushFeedbackCriterion = require('./datapushFeedbackCriterion');
exports.SegmentCriterion = require('./segmentCriterion');
exports.StringTagCriterion = require('./stringTagCriterion');
exports.DateTagCriterion = require('./dateTagCriterion');
exports.IntegerTagCriterion = require('./integerTagCriterion');
exports.BooleanTagCriterion = require('./booleanTagCriterion');
exports.EngageSubsetFilter = require('./engageSubsetFilter');
exports.EngageOldUsersFilter = require('./engageOldUsersFilter');
exports.EngageNewUsersFilter = require('./engageNewUsersFilter');
exports.EngageActiveUsersFilter = require('./engageActiveUsersFilter');
exports.EngageIdleUsersFilter = require('./engageIdleUsersFilter');
exports.NativePushEnabledFilter = require('./nativePushEnabledFilter');
exports.PushQuotaFilter = require('./pushQuotaFilter');
exports.AppInfoFilter = require('./appInfoFilter');
exports.CampaignListResult = require('./campaignListResult');
exports.CampaignResult = require('./campaignResult');
exports.CampaignPushResult = require('./campaignPushResult');
exports.CampaignStatisticsResult = require('./campaignStatisticsResult');
exports.DeviceMeta = require('./deviceMeta');
exports.DeviceQueryResult = require('./deviceQueryResult');
exports.DeviceInfo = require('./deviceInfo');
exports.DeviceLocation = require('./deviceLocation');
exports.Device = require('./device');
exports.DeviceTagsParameters = require('./deviceTagsParameters');
exports.DeviceTagsResult = require('./deviceTagsResult');
exports.ExportOptions = require('./exportOptions');
exports.DateRangeExportTaskParameter = require('./dateRangeExportTaskParameter');
exports.ExportTaskParameter = require('./exportTaskParameter');
exports.FeedbackByCampaignParameter = require('./feedbackByCampaignParameter');
exports.FeedbackByDateRangeParameter = require('./feedbackByDateRangeParameter');
exports.ExportTaskResult = require('./exportTaskResult');
exports.ImportTask = require('./importTask');
exports.ImportTaskResult = require('./importTaskResult');
exports.AppCollectionListResult = require('./appCollectionListResult');
exports.AppListResult = require('./appListResult');
exports.CampaignsListResult = require('./campaignsListResult');
exports.DevicesQueryResult = require('./devicesQueryResult');
exports.ExportTaskListResult = require('./exportTaskListResult');
exports.ImportTaskListResult = require('./importTaskListResult');
exports.discriminators = {
  'Criterion' : exports.Criterion,
  'Filter' : exports.Filter,
  'Criterion.carrier-name' : exports.CarrierNameCriterion,
  'Criterion.carrier-country' : exports.CarrierCountryCriterion,
  'Criterion.firmware-version' : exports.FirmwareVersionCriterion,
  'Criterion.device-manufacturer' : exports.DeviceManufacturerCriterion,
  'Criterion.device-model' : exports.DeviceModelCriterion,
  'Criterion.application-version' : exports.ApplicationVersionCriterion,
  'Criterion.network-type' : exports.NetworkTypeCriterion,
  'Criterion.language' : exports.LanguageCriterion,
  'Criterion.screen-size' : exports.ScreenSizeCriterion,
  'Criterion.location' : exports.LocationCriterion,
  'Criterion.geo-fencing' : exports.GeoFencingCriterion,
  'Criterion.announcement-feedback' : exports.AnnouncementFeedbackCriterion,
  'Criterion.poll-feedback' : exports.PollFeedbackCriterion,
  'Criterion.poll-answer-feedback' : exports.PollAnswerFeedbackCriterion,
  'Criterion.datapush-feedback' : exports.DatapushFeedbackCriterion,
  'Criterion.segment' : exports.SegmentCriterion,
  'Criterion.string-tag' : exports.StringTagCriterion,
  'Criterion.date-tag' : exports.DateTagCriterion,
  'Criterion.integer-tag' : exports.IntegerTagCriterion,
  'Criterion.boolean-tag' : exports.BooleanTagCriterion,
  'Filter.engage-subset' : exports.EngageSubsetFilter,
  'Filter.engage-old-users' : exports.EngageOldUsersFilter,
  'Filter.engage-new-users' : exports.EngageNewUsersFilter,
  'Filter.engage-active-users' : exports.EngageActiveUsersFilter,
  'Filter.engage-idle-users' : exports.EngageIdleUsersFilter,
  'Filter.native-push-enabled' : exports.NativePushEnabledFilter,
  'Filter.push-quota' : exports.PushQuotaFilter,
  'Filter.app-info' : exports.AppInfoFilter
};
