/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Used to target devices based on their last know area.
 *
 * @extends models['Criterion']
 */
class LocationCriterion extends models['Criterion'] {
  /**
   * Create a LocationCriterion.
   * @member {string} [country] Two character country code where the user is
   * located (ISO 3166-1).
   * @member {string} [region] An administrative region of the country, such as
   * a state or province.
   * @member {string} [locality] A locality within the administrative region,
   * such as a town or city.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of LocationCriterion
   *
   * @returns {object} metadata of LocationCriterion
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'location',
      type: {
        name: 'Composite',
        className: 'LocationCriterion',
        modelProperties: {
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          country: {
            required: false,
            serializedName: 'country',
            type: {
              name: 'String'
            }
          },
          region: {
            required: false,
            serializedName: 'region',
            type: {
              name: 'String'
            }
          },
          locality: {
            required: false,
            serializedName: 'locality',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = LocationCriterion;
