/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Used to target devices who answered X to a given question.
 *
 * @extends models['Criterion']
 */
class PollAnswerFeedbackCriterion extends models['Criterion'] {
  /**
   * Create a PollAnswerFeedbackCriterion.
   * @member {number} [contentId] The unique identifier of the poll.
   * @member {number} [choiceId] The unique identifier of the choice.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of PollAnswerFeedbackCriterion
   *
   * @returns {object} metadata of PollAnswerFeedbackCriterion
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'poll-answer-feedback',
      type: {
        name: 'Composite',
        className: 'PollAnswerFeedbackCriterion',
        modelProperties: {
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          contentId: {
            required: false,
            serializedName: 'content-id',
            type: {
              name: 'Number'
            }
          },
          choiceId: {
            required: false,
            serializedName: 'choice-id',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = PollAnswerFeedbackCriterion;
