/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Class representing a PollQuestionChoice.
 * @extends models['PollQuestionChoiceLocalization']
 */
class PollQuestionChoice extends models['PollQuestionChoiceLocalization'] {
  /**
   * Create a PollQuestionChoice.
   * @member {number} [id] Unique identifier of the choice.
   * @member {object} [localization] Poll choices can be localized using an
   * optional JSON object. The JSON key is a two-character language code as
   * specified by the ISO 639-1 standard. The corresponding value is an object
   * containing the localizable property title.
   * @member {boolean} [isDefault] A flag indicating if this choice is the
   * default choice for the associated question. Only one choice in the array
   * can have this value set to true. Default value: false .
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of PollQuestionChoice
   *
   * @returns {object} metadata of PollQuestionChoice
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PollQuestionChoice',
      type: {
        name: 'Composite',
        className: 'PollQuestionChoice',
        modelProperties: {
          title: {
            required: false,
            serializedName: 'title',
            constraints: {
              MaxLength: 256
            },
            type: {
              name: 'String'
            }
          },
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'Number'
            }
          },
          localization: {
            required: false,
            serializedName: 'localization',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'PollQuestionChoiceLocalizationElementType',
                  type: {
                    name: 'Composite',
                    className: 'PollQuestionChoiceLocalization'
                  }
              }
            }
          },
          isDefault: {
            required: false,
            serializedName: 'isDefault',
            defaultValue: false,
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = PollQuestionChoice;
