/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Target devices based on an existing segment.
 *
 * @extends models['Criterion']
 */
class SegmentCriterion extends models['Criterion'] {
  /**
   * Create a SegmentCriterion.
   * @member {number} [id] Segment identifier.
   * @member {boolean} [exclude] If value is true, the criterion will target
   * users that are NOT part of the segment.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SegmentCriterion
   *
   * @returns {object} metadata of SegmentCriterion
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'segment',
      type: {
        name: 'Composite',
        className: 'SegmentCriterion',
        modelProperties: {
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'Number'
            }
          },
          exclude: {
            required: false,
            serializedName: 'exclude',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = SegmentCriterion;
