/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The Http request info.
 *
 */
class HttpRequestInfo {
  /**
   * Create a HttpRequestInfo.
   * @member {string} [clientRequestId] the client request id.
   * @member {string} [clientIpAddress] the client Ip Address
   * @member {string} [method] the Http request method.
   * @member {string} [uri] the Uri.
   */
  constructor() {
  }

  /**
   * Defines the metadata of HttpRequestInfo
   *
   * @returns {object} metadata of HttpRequestInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HttpRequestInfo',
      type: {
        name: 'Composite',
        className: 'HttpRequestInfo',
        modelProperties: {
          clientRequestId: {
            required: false,
            serializedName: 'clientRequestId',
            type: {
              name: 'String'
            }
          },
          clientIpAddress: {
            required: false,
            serializedName: 'clientIpAddress',
            type: {
              name: 'String'
            }
          },
          method: {
            required: false,
            serializedName: 'method',
            type: {
              name: 'String'
            }
          },
          uri: {
            required: false,
            serializedName: 'uri',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = HttpRequestInfo;
