/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A time series result type. The discriminator value is always TimeSeries in
 * this case.
 *
 */
class TimeSeriesElement {
  /**
   * Create a TimeSeriesElement.
   * @member {array} [metadatavalues] the metadata values returned if $filter
   * was specified in the call.
   * @member {array} [data] An array of data points representing the metric
   * values.  This is only returned if a result type of data is specified.
   */
  constructor() {
  }

  /**
   * Defines the metadata of TimeSeriesElement
   *
   * @returns {object} metadata of TimeSeriesElement
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TimeSeriesElement',
      type: {
        name: 'Composite',
        className: 'TimeSeriesElement',
        modelProperties: {
          metadatavalues: {
            required: false,
            serializedName: 'metadatavalues',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'MetadataValueElementType',
                  type: {
                    name: 'Composite',
                    className: 'MetadataValue'
                  }
              }
            }
          },
          data: {
            required: false,
            serializedName: 'data',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'MetricValueElementType',
                  type: {
                    name: 'Composite',
                    className: 'MetricValue'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = TimeSeriesElement;
