/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A pointer to an Azure Action Group.
 *
 */
class ActivityLogAlertActionGroup {
  /**
   * Create a ActivityLogAlertActionGroup.
   * @member {string} actionGroupId The resourceId of the action group. This
   * cannot be null or empty.
   * @member {object} [webhookProperties] the dictionary of custom properties
   * to include with the post operation. These data are appended to the webhook
   * payload.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ActivityLogAlertActionGroup
   *
   * @returns {object} metadata of ActivityLogAlertActionGroup
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ActivityLogAlertActionGroup',
      type: {
        name: 'Composite',
        className: 'ActivityLogAlertActionGroup',
        modelProperties: {
          actionGroupId: {
            required: true,
            serializedName: 'actionGroupId',
            type: {
              name: 'String'
            }
          },
          webhookProperties: {
            required: false,
            serializedName: 'webhookProperties',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ActivityLogAlertActionGroup;
