/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The autoscale setting object for patch operations.
 *
 */
class AutoscaleSettingResourcePatch {
  /**
   * Create a AutoscaleSettingResourcePatch.
   * @member {object} [tags] Resource tags
   * @member {array} profiles the collection of automatic scaling profiles that
   * specify different scaling parameters for different time periods. A maximum
   * of 20 profiles can be specified.
   * @member {array} [notifications] the collection of notifications.
   * @member {boolean} [enabled] the enabled flag. Specifies whether automatic
   * scaling is enabled for the resource. The default value is 'true'. Default
   * value: true .
   * @member {string} [name] the name of the autoscale setting.
   * @member {string} [targetResourceUri] the resource identifier of the
   * resource that the autoscale setting should be added to.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AutoscaleSettingResourcePatch
   *
   * @returns {object} metadata of AutoscaleSettingResourcePatch
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AutoscaleSettingResourcePatch',
      type: {
        name: 'Composite',
        className: 'AutoscaleSettingResourcePatch',
        modelProperties: {
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          profiles: {
            required: true,
            serializedName: 'properties.profiles',
            constraints: {
              MaxItems: 20
            },
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'AutoscaleProfileElementType',
                  type: {
                    name: 'Composite',
                    className: 'AutoscaleProfile'
                  }
              }
            }
          },
          notifications: {
            required: false,
            serializedName: 'properties.notifications',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'AutoscaleNotificationElementType',
                  type: {
                    name: 'Composite',
                    className: 'AutoscaleNotification'
                  }
              }
            }
          },
          enabled: {
            required: false,
            serializedName: 'properties.enabled',
            defaultValue: true,
            type: {
              name: 'Boolean'
            }
          },
          name: {
            required: false,
            serializedName: 'properties.name',
            type: {
              name: 'String'
            }
          },
          targetResourceUri: {
            required: false,
            serializedName: 'properties.targetResourceUri',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AutoscaleSettingResourcePatch;
