/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A proxy only azure resource object
 *
 * @extends models['BaseResource']
 */
class ProxyOnlyResource extends models['BaseResource'] {
  /**
   * Create a ProxyOnlyResource.
   * @member {string} [id] Azure resource Id
   * @member {string} [name] Azure resource name
   * @member {string} [type] Azure resource type
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ProxyOnlyResource
   *
   * @returns {object} metadata of ProxyOnlyResource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ProxyOnlyResource',
      type: {
        name: 'Composite',
        className: 'ProxyOnlyResource',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ProxyOnlyResource;
