/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Specifies the retention policy for the log.
 *
 */
class RetentionPolicy {
  /**
   * Create a RetentionPolicy.
   * @member {boolean} enabled a value indicating whether the retention policy
   * is enabled.
   * @member {number} days the number of days for the retention in days. A
   * value of 0 will retain the events indefinitely.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RetentionPolicy
   *
   * @returns {object} metadata of RetentionPolicy
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RetentionPolicy',
      type: {
        name: 'Composite',
        className: 'RetentionPolicy',
        modelProperties: {
          enabled: {
            required: true,
            serializedName: 'enabled',
            type: {
              name: 'Boolean'
            }
          },
          days: {
            required: true,
            serializedName: 'days',
            constraints: {
              InclusiveMinimum: 0
            },
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = RetentionPolicy;
