/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The number of instances that can be used during this profile.
 *
 */
class ScaleCapacity {
  /**
   * Create a ScaleCapacity.
   * @member {string} minimum the minimum number of instances for the resource.
   * @member {string} maximum the maximum number of instances for the resource.
   * The actual maximum number of instances is limited by the cores that are
   * available in the subscription.
   * @member {string} default the number of instances that will be set if
   * metrics are not available for evaluation. The default is only used if the
   * current instance count is lower than the default.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ScaleCapacity
   *
   * @returns {object} metadata of ScaleCapacity
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ScaleCapacity',
      type: {
        name: 'Composite',
        className: 'ScaleCapacity',
        modelProperties: {
          minimum: {
            required: true,
            serializedName: 'minimum',
            type: {
              name: 'String'
            }
          },
          maximum: {
            required: true,
            serializedName: 'maximum',
            type: {
              name: 'String'
            }
          },
          default: {
            required: true,
            serializedName: 'default',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ScaleCapacity;
