/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An SMS receiver.
 *
 */
class SmsReceiver {
  /**
   * Create a SmsReceiver.
   * @member {string} name The name of the SMS receiver. Names must be unique
   * across all receivers within an action group.
   * @member {string} countryCode The country code of the SMS receiver.
   * @member {string} phoneNumber The phone number of the SMS receiver.
   * @member {string} [status] The status of the receiver. Possible values
   * include: 'NotSpecified', 'Enabled', 'Disabled'
   */
  constructor() {
  }

  /**
   * Defines the metadata of SmsReceiver
   *
   * @returns {object} metadata of SmsReceiver
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SmsReceiver',
      type: {
        name: 'Composite',
        className: 'SmsReceiver',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          countryCode: {
            required: true,
            serializedName: 'countryCode',
            type: {
              name: 'String'
            }
          },
          phoneNumber: {
            required: true,
            serializedName: 'phoneNumber',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            readOnly: true,
            serializedName: 'status',
            type: {
              name: 'Enum',
              allowedValues: [ 'NotSpecified', 'Enabled', 'Disabled' ]
            }
          }
        }
      }
    };
  }
}

module.exports = SmsReceiver;
