/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Represents a server firewall rule.
 *
 * @extends models['ProxyResource']
 */
class FirewallRule extends models['ProxyResource'] {
  /**
   * Create a FirewallRule.
   * @member {string} startIpAddress The start IP address of the server
   * firewall rule. Must be IPv4 format.
   * @member {string} endIpAddress The end IP address of the server firewall
   * rule. Must be IPv4 format.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of FirewallRule
   *
   * @returns {object} metadata of FirewallRule
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FirewallRule',
      type: {
        name: 'Composite',
        className: 'FirewallRule',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          startIpAddress: {
            required: true,
            serializedName: 'properties.startIpAddress',
            constraints: {
              Pattern: '^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])$'
            },
            type: {
              name: 'String'
            }
          },
          endIpAddress: {
            required: true,
            serializedName: 'properties.endIpAddress',
            constraints: {
              Pattern: '^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])$'
            },
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = FirewallRule;
