/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Application gateway BackendHealth pool.
 *
 */
class ApplicationGatewayBackendHealthPool {
  /**
   * Create a ApplicationGatewayBackendHealthPool.
   * @member {object} [backendAddressPool] Reference of an
   * ApplicationGatewayBackendAddressPool resource.
   * @member {array} [backendAddressPool.backendIPConfigurations] Collection of
   * references to IPs defined in network interfaces.
   * @member {array} [backendAddressPool.backendAddresses] Backend addresses
   * @member {string} [backendAddressPool.provisioningState] Provisioning state
   * of the backend address pool resource. Possible values are: 'Updating',
   * 'Deleting', and 'Failed'.
   * @member {string} [backendAddressPool.name] Resource that is unique within
   * a resource group. This name can be used to access the resource.
   * @member {string} [backendAddressPool.etag] A unique read-only string that
   * changes whenever the resource is updated.
   * @member {string} [backendAddressPool.type] Type of the resource.
   * @member {array} [backendHttpSettingsCollection] List of
   * ApplicationGatewayBackendHealthHttpSettings resources.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApplicationGatewayBackendHealthPool
   *
   * @returns {object} metadata of ApplicationGatewayBackendHealthPool
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplicationGatewayBackendHealthPool',
      type: {
        name: 'Composite',
        className: 'ApplicationGatewayBackendHealthPool',
        modelProperties: {
          backendAddressPool: {
            required: false,
            serializedName: 'backendAddressPool',
            type: {
              name: 'Composite',
              className: 'ApplicationGatewayBackendAddressPool'
            }
          },
          backendHttpSettingsCollection: {
            required: false,
            serializedName: 'backendHttpSettingsCollection',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ApplicationGatewayBackendHealthHttpSettingsElementType',
                  type: {
                    name: 'Composite',
                    className: 'ApplicationGatewayBackendHealthHttpSettings'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ApplicationGatewayBackendHealthPool;
