/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Application gateway web application firewall configuration.
 *
 */
class ApplicationGatewayWebApplicationFirewallConfiguration {
  /**
   * Create a ApplicationGatewayWebApplicationFirewallConfiguration.
   * @member {boolean} enabled Whether the web application firewall is enabled
   * or not.
   * @member {string} firewallMode Web application firewall mode. Possible
   * values include: 'Detection', 'Prevention'
   * @member {string} ruleSetType The type of the web application firewall rule
   * set. Possible values are: 'OWASP'.
   * @member {string} ruleSetVersion The version of the rule set type.
   * @member {array} [disabledRuleGroups] The disabled rule groups.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApplicationGatewayWebApplicationFirewallConfiguration
   *
   * @returns {object} metadata of ApplicationGatewayWebApplicationFirewallConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplicationGatewayWebApplicationFirewallConfiguration',
      type: {
        name: 'Composite',
        className: 'ApplicationGatewayWebApplicationFirewallConfiguration',
        modelProperties: {
          enabled: {
            required: true,
            serializedName: 'enabled',
            type: {
              name: 'Boolean'
            }
          },
          firewallMode: {
            required: true,
            serializedName: 'firewallMode',
            type: {
              name: 'String'
            }
          },
          ruleSetType: {
            required: true,
            serializedName: 'ruleSetType',
            type: {
              name: 'String'
            }
          },
          ruleSetVersion: {
            required: true,
            serializedName: 'ruleSetVersion',
            type: {
              name: 'String'
            }
          },
          disabledRuleGroups: {
            required: false,
            serializedName: 'disabledRuleGroups',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ApplicationGatewayFirewallDisabledRuleGroupElementType',
                  type: {
                    name: 'Composite',
                    className: 'ApplicationGatewayFirewallDisabledRuleGroup'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ApplicationGatewayWebApplicationFirewallConfiguration;
