/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Information on the configuration of flow log.
 *
 */
class FlowLogInformation {
  /**
   * Create a FlowLogInformation.
   * @member {string} targetResourceId The ID of the resource to configure for
   * flow logging.
   * @member {string} storageId ID of the storage account which is used to
   * store the flow log.
   * @member {boolean} enabled Flag to enable/disable flow logging.
   * @member {object} [retentionPolicy]
   * @member {number} [retentionPolicy.days] Number of days to retain flow log
   * records.
   * @member {boolean} [retentionPolicy.enabled] Flag to enable/disable
   * retention.
   */
  constructor() {
  }

  /**
   * Defines the metadata of FlowLogInformation
   *
   * @returns {object} metadata of FlowLogInformation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FlowLogInformation',
      type: {
        name: 'Composite',
        className: 'FlowLogInformation',
        modelProperties: {
          targetResourceId: {
            required: true,
            serializedName: 'targetResourceId',
            type: {
              name: 'String'
            }
          },
          storageId: {
            required: true,
            serializedName: 'properties.storageId',
            type: {
              name: 'String'
            }
          },
          enabled: {
            required: true,
            serializedName: 'properties.enabled',
            type: {
              name: 'Boolean'
            }
          },
          retentionPolicy: {
            required: false,
            serializedName: 'properties.retentionPolicy',
            type: {
              name: 'Composite',
              className: 'RetentionPolicyParameters'
            }
          }
        }
      }
    };
  }
}

module.exports = FlowLogInformation;
