/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

var msRestAzure = require('ms-rest-azure');

exports.BaseResource = msRestAzure.BaseResource;
exports.CloudError = msRestAzure.CloudError;
exports.SubResource = require('./subResource');
exports.BackendAddressPool = require('./backendAddressPool');
exports.InboundNatRule = require('./inboundNatRule');
exports.Resource = require('./resource');
exports.ApplicationSecurityGroup = require('./applicationSecurityGroup');
exports.SecurityRule = require('./securityRule');
exports.NetworkInterfaceDnsSettings = require('./networkInterfaceDnsSettings');
exports.NetworkInterface = require('./networkInterface');
exports.NetworkSecurityGroup = require('./networkSecurityGroup');
exports.Route = require('./route');
exports.RouteTable = require('./routeTable');
exports.ServiceEndpointPropertiesFormat = require('./serviceEndpointPropertiesFormat');
exports.PublicIPAddressSku = require('./publicIPAddressSku');
exports.PublicIPAddressDnsSettings = require('./publicIPAddressDnsSettings');
exports.PublicIPAddress = require('./publicIPAddress');
exports.IPConfiguration = require('./iPConfiguration');
exports.ResourceNavigationLink = require('./resourceNavigationLink');
exports.Subnet = require('./subnet');
exports.NetworkInterfaceIPConfiguration = require('./networkInterfaceIPConfiguration');
exports.ApplicationGatewayBackendAddress = require('./applicationGatewayBackendAddress');
exports.ApplicationGatewayBackendAddressPool = require('./applicationGatewayBackendAddressPool');
exports.ApplicationGatewayConnectionDraining = require('./applicationGatewayConnectionDraining');
exports.ApplicationGatewayBackendHttpSettings = require('./applicationGatewayBackendHttpSettings');
exports.ApplicationGatewayBackendHealthServer = require('./applicationGatewayBackendHealthServer');
exports.ApplicationGatewayBackendHealthHttpSettings = require('./applicationGatewayBackendHealthHttpSettings');
exports.ApplicationGatewayBackendHealthPool = require('./applicationGatewayBackendHealthPool');
exports.ApplicationGatewayBackendHealth = require('./applicationGatewayBackendHealth');
exports.ApplicationGatewaySku = require('./applicationGatewaySku');
exports.ApplicationGatewaySslPolicy = require('./applicationGatewaySslPolicy');
exports.ApplicationGatewayIPConfiguration = require('./applicationGatewayIPConfiguration');
exports.ApplicationGatewayAuthenticationCertificate = require('./applicationGatewayAuthenticationCertificate');
exports.ApplicationGatewaySslCertificate = require('./applicationGatewaySslCertificate');
exports.ApplicationGatewayFrontendIPConfiguration = require('./applicationGatewayFrontendIPConfiguration');
exports.ApplicationGatewayFrontendPort = require('./applicationGatewayFrontendPort');
exports.ApplicationGatewayHttpListener = require('./applicationGatewayHttpListener');
exports.ApplicationGatewayPathRule = require('./applicationGatewayPathRule');
exports.ApplicationGatewayProbeHealthResponseMatch = require('./applicationGatewayProbeHealthResponseMatch');
exports.ApplicationGatewayProbe = require('./applicationGatewayProbe');
exports.ApplicationGatewayRequestRoutingRule = require('./applicationGatewayRequestRoutingRule');
exports.ApplicationGatewayRedirectConfiguration = require('./applicationGatewayRedirectConfiguration');
exports.ApplicationGatewayUrlPathMap = require('./applicationGatewayUrlPathMap');
exports.ApplicationGatewayFirewallDisabledRuleGroup = require('./applicationGatewayFirewallDisabledRuleGroup');
exports.ApplicationGatewayWebApplicationFirewallConfiguration = require('./applicationGatewayWebApplicationFirewallConfiguration');
exports.ApplicationGateway = require('./applicationGateway');
exports.ApplicationGatewayFirewallRule = require('./applicationGatewayFirewallRule');
exports.ApplicationGatewayFirewallRuleGroup = require('./applicationGatewayFirewallRuleGroup');
exports.ApplicationGatewayFirewallRuleSet = require('./applicationGatewayFirewallRuleSet');
exports.ApplicationGatewayAvailableWafRuleSetsResult = require('./applicationGatewayAvailableWafRuleSetsResult');
exports.ApplicationGatewayAvailableSslOptions = require('./applicationGatewayAvailableSslOptions');
exports.ApplicationGatewaySslPredefinedPolicy = require('./applicationGatewaySslPredefinedPolicy');
exports.DnsNameAvailabilityResult = require('./dnsNameAvailabilityResult');
exports.EndpointServiceResult = require('./endpointServiceResult');
exports.ExpressRouteCircuitAuthorization = require('./expressRouteCircuitAuthorization');
exports.ExpressRouteCircuitPeeringConfig = require('./expressRouteCircuitPeeringConfig');
exports.RouteFilterRule = require('./routeFilterRule');
exports.ExpressRouteCircuitStats = require('./expressRouteCircuitStats');
exports.ExpressRouteCircuitPeering = require('./expressRouteCircuitPeering');
exports.RouteFilter = require('./routeFilter');
exports.Ipv6ExpressRouteCircuitPeeringConfig = require('./ipv6ExpressRouteCircuitPeeringConfig');
exports.ExpressRouteCircuitSku = require('./expressRouteCircuitSku');
exports.ExpressRouteCircuitServiceProviderProperties = require('./expressRouteCircuitServiceProviderProperties');
exports.ExpressRouteCircuit = require('./expressRouteCircuit');
exports.ExpressRouteCircuitArpTable = require('./expressRouteCircuitArpTable');
exports.ExpressRouteCircuitsArpTableListResult = require('./expressRouteCircuitsArpTableListResult');
exports.ExpressRouteCircuitRoutesTable = require('./expressRouteCircuitRoutesTable');
exports.ExpressRouteCircuitsRoutesTableListResult = require('./expressRouteCircuitsRoutesTableListResult');
exports.ExpressRouteCircuitRoutesTableSummary = require('./expressRouteCircuitRoutesTableSummary');
exports.ExpressRouteCircuitsRoutesTableSummaryListResult = require('./expressRouteCircuitsRoutesTableSummaryListResult');
exports.ExpressRouteServiceProviderBandwidthsOffered = require('./expressRouteServiceProviderBandwidthsOffered');
exports.ExpressRouteServiceProvider = require('./expressRouteServiceProvider');
exports.LoadBalancerSku = require('./loadBalancerSku');
exports.FrontendIPConfiguration = require('./frontendIPConfiguration');
exports.LoadBalancingRule = require('./loadBalancingRule');
exports.Probe = require('./probe');
exports.InboundNatPool = require('./inboundNatPool');
exports.OutboundNatRule = require('./outboundNatRule');
exports.LoadBalancer = require('./loadBalancer');
exports.ErrorDetails = require('./errorDetails');
exports.ErrorModel = require('./errorModel');
exports.AzureAsyncOperationResult = require('./azureAsyncOperationResult');
exports.EffectiveNetworkSecurityGroupAssociation = require('./effectiveNetworkSecurityGroupAssociation');
exports.EffectiveNetworkSecurityRule = require('./effectiveNetworkSecurityRule');
exports.EffectiveNetworkSecurityGroup = require('./effectiveNetworkSecurityGroup');
exports.EffectiveNetworkSecurityGroupListResult = require('./effectiveNetworkSecurityGroupListResult');
exports.EffectiveRoute = require('./effectiveRoute');
exports.EffectiveRouteListResult = require('./effectiveRouteListResult');
exports.NetworkWatcher = require('./networkWatcher');
exports.TopologyParameters = require('./topologyParameters');
exports.TopologyAssociation = require('./topologyAssociation');
exports.TopologyResource = require('./topologyResource');
exports.Topology = require('./topology');
exports.VerificationIPFlowParameters = require('./verificationIPFlowParameters');
exports.VerificationIPFlowResult = require('./verificationIPFlowResult');
exports.NextHopParameters = require('./nextHopParameters');
exports.NextHopResult = require('./nextHopResult');
exports.SecurityGroupViewParameters = require('./securityGroupViewParameters');
exports.NetworkInterfaceAssociation = require('./networkInterfaceAssociation');
exports.SubnetAssociation = require('./subnetAssociation');
exports.SecurityRuleAssociations = require('./securityRuleAssociations');
exports.SecurityGroupNetworkInterface = require('./securityGroupNetworkInterface');
exports.SecurityGroupViewResult = require('./securityGroupViewResult');
exports.PacketCaptureStorageLocation = require('./packetCaptureStorageLocation');
exports.PacketCaptureFilter = require('./packetCaptureFilter');
exports.PacketCaptureParameters = require('./packetCaptureParameters');
exports.PacketCapture = require('./packetCapture');
exports.PacketCaptureResult = require('./packetCaptureResult');
exports.PacketCaptureQueryStatusResult = require('./packetCaptureQueryStatusResult');
exports.TroubleshootingParameters = require('./troubleshootingParameters');
exports.QueryTroubleshootingParameters = require('./queryTroubleshootingParameters');
exports.TroubleshootingRecommendedActions = require('./troubleshootingRecommendedActions');
exports.TroubleshootingDetails = require('./troubleshootingDetails');
exports.TroubleshootingResult = require('./troubleshootingResult');
exports.RetentionPolicyParameters = require('./retentionPolicyParameters');
exports.FlowLogStatusParameters = require('./flowLogStatusParameters');
exports.FlowLogInformation = require('./flowLogInformation');
exports.ConnectivitySource = require('./connectivitySource');
exports.ConnectivityDestination = require('./connectivityDestination');
exports.ConnectivityParameters = require('./connectivityParameters');
exports.ConnectivityIssue = require('./connectivityIssue');
exports.ConnectivityHop = require('./connectivityHop');
exports.ConnectivityInformation = require('./connectivityInformation');
exports.AzureReachabilityReportLocation = require('./azureReachabilityReportLocation');
exports.AzureReachabilityReportParameters = require('./azureReachabilityReportParameters');
exports.AzureReachabilityReportLatencyInfo = require('./azureReachabilityReportLatencyInfo');
exports.AzureReachabilityReportItem = require('./azureReachabilityReportItem');
exports.AzureReachabilityReport = require('./azureReachabilityReport');
exports.AvailableProvidersListParameters = require('./availableProvidersListParameters');
exports.AvailableProvidersListCity = require('./availableProvidersListCity');
exports.AvailableProvidersListState = require('./availableProvidersListState');
exports.AvailableProvidersListCountry = require('./availableProvidersListCountry');
exports.AvailableProvidersList = require('./availableProvidersList');
exports.PatchRouteFilterRule = require('./patchRouteFilterRule');
exports.PatchRouteFilter = require('./patchRouteFilter');
exports.BGPCommunity = require('./bGPCommunity');
exports.BgpServiceCommunity = require('./bgpServiceCommunity');
exports.UsageName = require('./usageName');
exports.Usage = require('./usage');
exports.VirtualNetworkPeering = require('./virtualNetworkPeering');
exports.AddressSpace = require('./addressSpace');
exports.DhcpOptions = require('./dhcpOptions');
exports.VirtualNetwork = require('./virtualNetwork');
exports.IPAddressAvailabilityResult = require('./iPAddressAvailabilityResult');
exports.VirtualNetworkUsageName = require('./virtualNetworkUsageName');
exports.VirtualNetworkUsage = require('./virtualNetworkUsage');
exports.VirtualNetworkGatewayIPConfiguration = require('./virtualNetworkGatewayIPConfiguration');
exports.VirtualNetworkGatewaySku = require('./virtualNetworkGatewaySku');
exports.VpnClientRootCertificate = require('./vpnClientRootCertificate');
exports.VpnClientRevokedCertificate = require('./vpnClientRevokedCertificate');
exports.VpnClientConfiguration = require('./vpnClientConfiguration');
exports.BgpSettings = require('./bgpSettings');
exports.BgpPeerStatus = require('./bgpPeerStatus');
exports.GatewayRoute = require('./gatewayRoute');
exports.VirtualNetworkGateway = require('./virtualNetworkGateway');
exports.VpnClientParameters = require('./vpnClientParameters');
exports.BgpPeerStatusListResult = require('./bgpPeerStatusListResult');
exports.GatewayRouteListResult = require('./gatewayRouteListResult');
exports.TunnelConnectionHealth = require('./tunnelConnectionHealth');
exports.LocalNetworkGateway = require('./localNetworkGateway');
exports.IpsecPolicy = require('./ipsecPolicy');
exports.VirtualNetworkGatewayConnection = require('./virtualNetworkGatewayConnection');
exports.ConnectionResetSharedKey = require('./connectionResetSharedKey');
exports.ConnectionSharedKey = require('./connectionSharedKey');
exports.VirtualNetworkConnectionGatewayReference = require('./virtualNetworkConnectionGatewayReference');
exports.VirtualNetworkGatewayConnectionListEntity = require('./virtualNetworkGatewayConnectionListEntity');
exports.VpnDeviceScriptParameters = require('./vpnDeviceScriptParameters');
exports.ApplicationGatewayListResult = require('./applicationGatewayListResult');
exports.ApplicationGatewayAvailableSslPredefinedPolicies = require('./applicationGatewayAvailableSslPredefinedPolicies');
exports.ApplicationSecurityGroupListResult = require('./applicationSecurityGroupListResult');
exports.EndpointServicesListResult = require('./endpointServicesListResult');
exports.AuthorizationListResult = require('./authorizationListResult');
exports.ExpressRouteCircuitPeeringListResult = require('./expressRouteCircuitPeeringListResult');
exports.ExpressRouteCircuitListResult = require('./expressRouteCircuitListResult');
exports.ExpressRouteServiceProviderListResult = require('./expressRouteServiceProviderListResult');
exports.LoadBalancerListResult = require('./loadBalancerListResult');
exports.LoadBalancerBackendAddressPoolListResult = require('./loadBalancerBackendAddressPoolListResult');
exports.LoadBalancerFrontendIPConfigurationListResult = require('./loadBalancerFrontendIPConfigurationListResult');
exports.InboundNatRuleListResult = require('./inboundNatRuleListResult');
exports.LoadBalancerLoadBalancingRuleListResult = require('./loadBalancerLoadBalancingRuleListResult');
exports.NetworkInterfaceListResult = require('./networkInterfaceListResult');
exports.LoadBalancerProbeListResult = require('./loadBalancerProbeListResult');
exports.NetworkInterfaceIPConfigurationListResult = require('./networkInterfaceIPConfigurationListResult');
exports.NetworkInterfaceLoadBalancerListResult = require('./networkInterfaceLoadBalancerListResult');
exports.NetworkSecurityGroupListResult = require('./networkSecurityGroupListResult');
exports.SecurityRuleListResult = require('./securityRuleListResult');
exports.NetworkWatcherListResult = require('./networkWatcherListResult');
exports.PacketCaptureListResult = require('./packetCaptureListResult');
exports.PublicIPAddressListResult = require('./publicIPAddressListResult');
exports.RouteFilterListResult = require('./routeFilterListResult');
exports.RouteFilterRuleListResult = require('./routeFilterRuleListResult');
exports.RouteTableListResult = require('./routeTableListResult');
exports.RouteListResult = require('./routeListResult');
exports.BgpServiceCommunityListResult = require('./bgpServiceCommunityListResult');
exports.UsagesListResult = require('./usagesListResult');
exports.VirtualNetworkListResult = require('./virtualNetworkListResult');
exports.VirtualNetworkListUsageResult = require('./virtualNetworkListUsageResult');
exports.SubnetListResult = require('./subnetListResult');
exports.VirtualNetworkPeeringListResult = require('./virtualNetworkPeeringListResult');
exports.VirtualNetworkGatewayListResult = require('./virtualNetworkGatewayListResult');
exports.VirtualNetworkGatewayListConnectionsResult = require('./virtualNetworkGatewayListConnectionsResult');
exports.VirtualNetworkGatewayConnectionListResult = require('./virtualNetworkGatewayConnectionListResult');
exports.LocalNetworkGatewayListResult = require('./localNetworkGatewayListResult');
