/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Description of a NotificationHub BaiduCredential.
 *
 */
class BaiduCredential {
  /**
   * Create a BaiduCredential.
   * @member {string} [baiduApiKey] Baidu Api Key.
   * @member {string} [baiduEndPoint] Baidu Endpoint.
   * @member {string} [baiduSecretKey] Baidu Secret Key
   */
  constructor() {
  }

  /**
   * Defines the metadata of BaiduCredential
   *
   * @returns {object} metadata of BaiduCredential
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BaiduCredential',
      type: {
        name: 'Composite',
        className: 'BaiduCredential',
        modelProperties: {
          baiduApiKey: {
            required: false,
            serializedName: 'properties.baiduApiKey',
            type: {
              name: 'String'
            }
          },
          baiduEndPoint: {
            required: false,
            serializedName: 'properties.baiduEndPoint',
            type: {
              name: 'String'
            }
          },
          baiduSecretKey: {
            required: false,
            serializedName: 'properties.baiduSecretKey',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = BaiduCredential;
