/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Description of a NotificationHub GcmCredential.
 *
 */
class GcmCredential {
  /**
   * Create a GcmCredential.
   * @member {string} [gcmEndpoint] The GCM endpoint.
   * @member {string} [googleApiKey] The Google API key.
   */
  constructor() {
  }

  /**
   * Defines the metadata of GcmCredential
   *
   * @returns {object} metadata of GcmCredential
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GcmCredential',
      type: {
        name: 'Composite',
        className: 'GcmCredential',
        modelProperties: {
          gcmEndpoint: {
            required: false,
            serializedName: 'properties.gcmEndpoint',
            type: {
              name: 'String'
            }
          },
          googleApiKey: {
            required: false,
            serializedName: 'properties.googleApiKey',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = GcmCredential;
