/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Namespace/NotificationHub Connection String
 *
 */
class ResourceListKeys {
  /**
   * Create a ResourceListKeys.
   * @member {string} [primaryConnectionString] PrimaryConnectionString of the
   * AuthorizationRule.
   * @member {string} [secondaryConnectionString] SecondaryConnectionString of
   * the created AuthorizationRule
   * @member {string} [primaryKey] PrimaryKey of the created AuthorizationRule.
   * @member {string} [secondaryKey] SecondaryKey of the created
   * AuthorizationRule
   * @member {string} [keyName] KeyName of the created AuthorizationRule
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResourceListKeys
   *
   * @returns {object} metadata of ResourceListKeys
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceListKeys',
      type: {
        name: 'Composite',
        className: 'ResourceListKeys',
        modelProperties: {
          primaryConnectionString: {
            required: false,
            serializedName: 'primaryConnectionString',
            type: {
              name: 'String'
            }
          },
          secondaryConnectionString: {
            required: false,
            serializedName: 'secondaryConnectionString',
            type: {
              name: 'String'
            }
          },
          primaryKey: {
            required: false,
            serializedName: 'primaryKey',
            type: {
              name: 'String'
            }
          },
          secondaryKey: {
            required: false,
            serializedName: 'secondaryKey',
            type: {
              name: 'String'
            }
          },
          keyName: {
            required: false,
            serializedName: 'keyName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceListKeys;
