/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Value object for saved search results.
 *
 */
class SavedSearch {
  /**
   * Create a SavedSearch.
   * @member {string} [id] The id of the saved search.
   * @member {string} [etag] The etag of the saved search.
   * @member {string} category The category of the saved search. This helps the
   * user to find a saved search faster.
   * @member {string} displayName Saved search display name.
   * @member {string} query The query expression for the saved search. Please
   * see
   * https://docs.microsoft.com/en-us/azure/log-analytics/log-analytics-search-reference
   * for reference.
   * @member {number} version The version number of the query lanuage. Only
   * verion 1 is allowed here.
   * @member {array} [tags] The tags attached to the saved search.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SavedSearch
   *
   * @returns {object} metadata of SavedSearch
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SavedSearch',
      type: {
        name: 'Composite',
        className: 'SavedSearch',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          etag: {
            required: false,
            serializedName: 'etag',
            type: {
              name: 'String'
            }
          },
          category: {
            required: true,
            serializedName: 'properties.Category',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: true,
            serializedName: 'properties.DisplayName',
            type: {
              name: 'String'
            }
          },
          query: {
            required: true,
            serializedName: 'properties.Query',
            type: {
              name: 'String'
            }
          },
          version: {
            required: true,
            serializedName: 'properties.Version',
            constraints: {
              InclusiveMaximum: 1,
              InclusiveMinimum: 1
            },
            type: {
              name: 'Number'
            }
          },
          tags: {
            required: false,
            serializedName: 'properties.Tags',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'TagElementType',
                  type: {
                    name: 'Composite',
                    className: 'Tag'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = SavedSearch;
