/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Represents a Database.
 *
 * @extends models['ProxyResource']
 */
class Database extends models['ProxyResource'] {
  /**
   * Create a Database.
   * @member {string} [charset] The charset of the database.
   * @member {string} [collation] The collation of the database.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of Database
   *
   * @returns {object} metadata of Database
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Database',
      type: {
        name: 'Composite',
        className: 'Database',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          charset: {
            required: false,
            serializedName: 'properties.charset',
            type: {
              name: 'String'
            }
          },
          collation: {
            required: false,
            serializedName: 'properties.collation',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Database;
