/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Service level objectives for performance tier.
 *
 */
class PerformanceTierServiceLevelObjectives {
  /**
   * Create a PerformanceTierServiceLevelObjectives.
   * @member {string} [id] ID for the service level objective.
   * @member {string} [edition] Edition of the performance tier.
   * @member {number} [dtu] Database throughput unit associated with the
   * service level objective
   * @member {number} [storageMB] Maximum storage in MB associated with the
   * service level objective
   */
  constructor() {
  }

  /**
   * Defines the metadata of PerformanceTierServiceLevelObjectives
   *
   * @returns {object} metadata of PerformanceTierServiceLevelObjectives
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PerformanceTierServiceLevelObjectives',
      type: {
        name: 'Composite',
        className: 'PerformanceTierServiceLevelObjectives',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          edition: {
            required: false,
            serializedName: 'edition',
            type: {
              name: 'String'
            }
          },
          dtu: {
            required: false,
            serializedName: 'dtu',
            type: {
              name: 'Number'
            }
          },
          storageMB: {
            required: false,
            serializedName: 'storageMB',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = PerformanceTierServiceLevelObjectives;
