/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Resource properties including location and tags for track resources.
 *
 * @extends models['ProxyResource']
 */
class TrackedResource extends models['ProxyResource'] {
  /**
   * Create a TrackedResource.
   * @member {string} location The location the resource resides in.
   * @member {object} [tags] Application-specific metadata in the form of
   * key-value pairs.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of TrackedResource
   *
   * @returns {object} metadata of TrackedResource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TrackedResource',
      type: {
        name: 'Composite',
        className: 'TrackedResource',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = TrackedResource;
