/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Backup engine type when Azure Backup Server is used to manage the backups.
 *
 * @extends models['BackupEngineBase']
 */
class AzureBackupServerEngine extends models['BackupEngineBase'] {
  /**
   * Create a AzureBackupServerEngine.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureBackupServerEngine
   *
   * @returns {object} metadata of AzureBackupServerEngine
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureBackupServerEngine',
      type: {
        name: 'Composite',
        className: 'AzureBackupServerEngine',
        modelProperties: {
          friendlyName: {
            required: false,
            serializedName: 'friendlyName',
            type: {
              name: 'String'
            }
          },
          backupManagementType: {
            required: false,
            serializedName: 'backupManagementType',
            type: {
              name: 'String'
            }
          },
          registrationStatus: {
            required: false,
            serializedName: 'registrationStatus',
            type: {
              name: 'String'
            }
          },
          backupEngineState: {
            required: false,
            serializedName: 'backupEngineState',
            type: {
              name: 'String'
            }
          },
          healthStatus: {
            required: false,
            serializedName: 'healthStatus',
            type: {
              name: 'String'
            }
          },
          canReRegister: {
            required: false,
            serializedName: 'canReRegister',
            type: {
              name: 'Boolean'
            }
          },
          backupEngineId: {
            required: false,
            serializedName: 'backupEngineId',
            type: {
              name: 'String'
            }
          },
          dpmVersion: {
            required: false,
            serializedName: 'dpmVersion',
            type: {
              name: 'String'
            }
          },
          azureBackupAgentVersion: {
            required: false,
            serializedName: 'azureBackupAgentVersion',
            type: {
              name: 'String'
            }
          },
          isAzureBackupAgentUpgradeAvailable: {
            required: false,
            serializedName: 'isAzureBackupAgentUpgradeAvailable',
            type: {
              name: 'Boolean'
            }
          },
          isDPMUpgradeAvailable: {
            required: false,
            serializedName: 'isDPMUpgradeAvailable',
            type: {
              name: 'Boolean'
            }
          },
          extendedInfo: {
            required: false,
            serializedName: 'extendedInfo',
            type: {
              name: 'Composite',
              className: 'BackupEngineExtendedInfo'
            }
          },
          backupEngineType: {
            required: true,
            serializedName: 'backupEngineType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureBackupServerEngine;
