/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Azure IaaS VM workload-specific additional information for job.
 *
 */
class AzureIaaSVMJobExtendedInfo {
  /**
   * Create a AzureIaaSVMJobExtendedInfo.
   * @member {array} [tasksList] List of tasks associated with this job.
   * @member {object} [propertyBag] Job properties.
   * @member {number} [progressPercentage] Indicates progress of the job. Null
   * if it has not started or completed.
   * @member {string} [dynamicErrorMessage] Non localized error message on job
   * execution.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureIaaSVMJobExtendedInfo
   *
   * @returns {object} metadata of AzureIaaSVMJobExtendedInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureIaaSVMJobExtendedInfo',
      type: {
        name: 'Composite',
        className: 'AzureIaaSVMJobExtendedInfo',
        modelProperties: {
          tasksList: {
            required: false,
            serializedName: 'tasksList',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'AzureIaaSVMJobTaskDetailsElementType',
                  type: {
                    name: 'Composite',
                    className: 'AzureIaaSVMJobTaskDetails'
                  }
              }
            }
          },
          propertyBag: {
            required: false,
            serializedName: 'propertyBag',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          progressPercentage: {
            required: false,
            serializedName: 'progressPercentage',
            type: {
              name: 'Number'
            }
          },
          dynamicErrorMessage: {
            required: false,
            serializedName: 'dynamicErrorMessage',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureIaaSVMJobExtendedInfo;
