/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Azure Sql workload-specific container.
 *
 * @extends models['ProtectionContainer']
 */
class AzureSqlContainer extends models['ProtectionContainer'] {
  /**
   * Create a AzureSqlContainer.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureSqlContainer
   *
   * @returns {object} metadata of AzureSqlContainer
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureSqlContainer',
      type: {
        name: 'Composite',
        className: 'AzureSqlContainer',
        modelProperties: {
          friendlyName: {
            required: false,
            serializedName: 'friendlyName',
            type: {
              name: 'String'
            }
          },
          backupManagementType: {
            required: false,
            serializedName: 'backupManagementType',
            type: {
              name: 'String'
            }
          },
          registrationStatus: {
            required: false,
            serializedName: 'registrationStatus',
            type: {
              name: 'String'
            }
          },
          healthStatus: {
            required: false,
            serializedName: 'healthStatus',
            type: {
              name: 'String'
            }
          },
          containerType: {
            required: false,
            readOnly: true,
            serializedName: 'containerType',
            type: {
              name: 'String'
            }
          },
          protectableObjectType: {
            required: true,
            serializedName: 'protectableObjectType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureSqlContainer;
