/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Azure SQL workload-specific backup policy.
 *
 * @extends models['ProtectionPolicy']
 */
class AzureSqlProtectionPolicy extends models['ProtectionPolicy'] {
  /**
   * Create a AzureSqlProtectionPolicy.
   * @member {object} [retentionPolicy] Retention policy details.
   * @member {string} [retentionPolicy.retentionPolicyType] Polymorphic
   * Discriminator
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureSqlProtectionPolicy
   *
   * @returns {object} metadata of AzureSqlProtectionPolicy
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureSql',
      type: {
        name: 'Composite',
        className: 'AzureSqlProtectionPolicy',
        modelProperties: {
          protectedItemsCount: {
            required: false,
            serializedName: 'protectedItemsCount',
            type: {
              name: 'Number'
            }
          },
          backupManagementType: {
            required: true,
            serializedName: 'backupManagementType',
            type: {
              name: 'String'
            }
          },
          retentionPolicy: {
            required: false,
            serializedName: 'retentionPolicy',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'retentionPolicyType',
                clientName: 'retentionPolicyType'
              },
              uberParent: 'RetentionPolicy',
              className: 'RetentionPolicy'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureSqlProtectionPolicy;
