/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * BEK is bitlocker encrpytion key.
 *
 */
class BEKDetails {
  /**
   * Create a BEKDetails.
   * @member {string} [secretUrl] Secret is BEK.
   * @member {string} [secretVaultId] ID of the Key Vault where this Secret is
   * stored.
   * @member {string} [secretData] BEK data.
   */
  constructor() {
  }

  /**
   * Defines the metadata of BEKDetails
   *
   * @returns {object} metadata of BEKDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BEKDetails',
      type: {
        name: 'Composite',
        className: 'BEKDetails',
        modelProperties: {
          secretUrl: {
            required: false,
            serializedName: 'secretUrl',
            type: {
              name: 'String'
            }
          },
          secretVaultId: {
            required: false,
            serializedName: 'secretVaultId',
            type: {
              name: 'String'
            }
          },
          secretData: {
            required: false,
            serializedName: 'secretData',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = BEKDetails;
