/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Query parameters to fetch list of backup engines.
 *
 */
class BMSBackupEnginesQueryObject {
  /**
   * Create a BMSBackupEnginesQueryObject.
   * @member {string} [backupManagementType] Backup management type for the
   * backup engine. Possible values include: 'Invalid', 'AzureIaasVM', 'MAB',
   * 'DPM', 'AzureBackupServer', 'AzureSql'
   * @member {string} [friendlyName] Friendly name of the backup engine.
   * @member {string} [expand] Attribute to add extended info.
   */
  constructor() {
  }

  /**
   * Defines the metadata of BMSBackupEnginesQueryObject
   *
   * @returns {object} metadata of BMSBackupEnginesQueryObject
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BMSBackupEnginesQueryObject',
      type: {
        name: 'Composite',
        className: 'BMSBackupEnginesQueryObject',
        modelProperties: {
          backupManagementType: {
            required: false,
            serializedName: 'backupManagementType',
            type: {
              name: 'String'
            }
          },
          friendlyName: {
            required: false,
            serializedName: 'friendlyName',
            type: {
              name: 'String'
            }
          },
          expand: {
            required: false,
            serializedName: 'expand',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = BMSBackupEnginesQueryObject;
