/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Filters to list items that can be backed up.
 *
 */
class BMSPOQueryObject {
  /**
   * Create a BMSPOQueryObject.
   * @member {string} [backupManagementType] Backup management type. Possible
   * values include: 'Invalid', 'AzureIaasVM', 'MAB', 'DPM',
   * 'AzureBackupServer', 'AzureSql'
   * @member {string} [status] Backup status query parameter.
   * @member {string} [friendlyName] Friendly name.
   */
  constructor() {
  }

  /**
   * Defines the metadata of BMSPOQueryObject
   *
   * @returns {object} metadata of BMSPOQueryObject
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BMSPOQueryObject',
      type: {
        name: 'Composite',
        className: 'BMSPOQueryObject',
        modelProperties: {
          backupManagementType: {
            required: false,
            serializedName: 'backupManagementType',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          },
          friendlyName: {
            required: false,
            serializedName: 'friendlyName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = BMSPOQueryObject;
