/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Backup management usages of a vault.
 *
 */
class BackupManagementUsage {
  /**
   * Create a BackupManagementUsage.
   * @member {string} [unit] Unit of the usage. Possible values include:
   * 'Count', 'Bytes', 'Seconds', 'Percent', 'CountPerSecond', 'BytesPerSecond'
   * @member {string} [quotaPeriod] Quota period of usage.
   * @member {date} [nextResetTime] Next reset time of usage.
   * @member {number} [currentValue] Current value of usage.
   * @member {number} [limit] Limit of usage.
   * @member {object} [name] Name of usage.
   * @member {string} [name.value] Value of usage.
   * @member {string} [name.localizedValue] Localized value of usage.
   */
  constructor() {
  }

  /**
   * Defines the metadata of BackupManagementUsage
   *
   * @returns {object} metadata of BackupManagementUsage
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BackupManagementUsage',
      type: {
        name: 'Composite',
        className: 'BackupManagementUsage',
        modelProperties: {
          unit: {
            required: false,
            serializedName: 'unit',
            type: {
              name: 'String'
            }
          },
          quotaPeriod: {
            required: false,
            serializedName: 'quotaPeriod',
            type: {
              name: 'String'
            }
          },
          nextResetTime: {
            required: false,
            serializedName: 'nextResetTime',
            type: {
              name: 'DateTime'
            }
          },
          currentValue: {
            required: false,
            serializedName: 'currentValue',
            type: {
              name: 'Number'
            }
          },
          limit: {
            required: false,
            serializedName: 'limit',
            type: {
              name: 'Number'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'Composite',
              className: 'NameInfo'
            }
          }
        }
      }
    };
  }
}

module.exports = BackupManagementUsage;
