/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * This class is used to send blob details after exporting jobs.
 *
 * @extends models['OperationResultInfoBase']
 */
class ExportJobsOperationResultInfo extends models['OperationResultInfoBase'] {
  /**
   * Create a ExportJobsOperationResultInfo.
   * @member {string} [blobUrl] URL of the blob into which the serialized
   * string of list of jobs is exported.
   * @member {string} [blobSasKey] SAS key to access the blob. It expires in 15
   * mins.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ExportJobsOperationResultInfo
   *
   * @returns {object} metadata of ExportJobsOperationResultInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ExportJobsOperationResultInfo',
      type: {
        name: 'Composite',
        className: 'ExportJobsOperationResultInfo',
        modelProperties: {
          objectType: {
            required: true,
            serializedName: 'objectType',
            type: {
              name: 'String'
            }
          },
          blobUrl: {
            required: false,
            serializedName: 'blobUrl',
            type: {
              name: 'String'
            }
          },
          blobSasKey: {
            required: false,
            serializedName: 'blobSasKey',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ExportJobsOperationResultInfo;
