/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Generic backup copy.
 *
 * @extends models['RecoveryPoint']
 */
class GenericRecoveryPoint extends models['RecoveryPoint'] {
  /**
   * Create a GenericRecoveryPoint.
   * @member {string} [friendlyName] Friendly name of the backup copy.
   * @member {string} [recoveryPointType] Type of the backup copy.
   * @member {date} [recoveryPointTime] Time at which this backup copy was
   * created.
   * @member {string} [recoveryPointAdditionalInfo] Additional information
   * associated with this backup copy.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of GenericRecoveryPoint
   *
   * @returns {object} metadata of GenericRecoveryPoint
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GenericRecoveryPoint',
      type: {
        name: 'Composite',
        className: 'GenericRecoveryPoint',
        modelProperties: {
          objectType: {
            required: true,
            serializedName: 'objectType',
            type: {
              name: 'String'
            }
          },
          friendlyName: {
            required: false,
            serializedName: 'friendlyName',
            type: {
              name: 'String'
            }
          },
          recoveryPointType: {
            required: false,
            serializedName: 'recoveryPointType',
            type: {
              name: 'String'
            }
          },
          recoveryPointTime: {
            required: false,
            serializedName: 'recoveryPointTime',
            type: {
              name: 'DateTime'
            }
          },
          recoveryPointAdditionalInfo: {
            required: false,
            serializedName: 'recoveryPointAdditionalInfo',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = GenericRecoveryPoint;
