/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * KEK is encryption key for BEK.
 *
 */
class KEKDetails {
  /**
   * Create a KEKDetails.
   * @member {string} [keyUrl] Key is KEK.
   * @member {string} [keyVaultId] Key Vault ID where this Key is stored.
   * @member {string} [keyBackupData] KEK data.
   */
  constructor() {
  }

  /**
   * Defines the metadata of KEKDetails
   *
   * @returns {object} metadata of KEKDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'KEKDetails',
      type: {
        name: 'Composite',
        className: 'KEKDetails',
        modelProperties: {
          keyUrl: {
            required: false,
            serializedName: 'keyUrl',
            type: {
              name: 'String'
            }
          },
          keyVaultId: {
            required: false,
            serializedName: 'keyVaultId',
            type: {
              name: 'String'
            }
          },
          keyBackupData: {
            required: false,
            serializedName: 'keyBackupData',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = KEKDetails;
