/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Operation result info.
 *
 * @extends models['OperationResultInfoBase']
 */
class OperationResultInfo extends models['OperationResultInfoBase'] {
  /**
   * Create a OperationResultInfo.
   * @member {array} [jobList] List of jobs created by this operation.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of OperationResultInfo
   *
   * @returns {object} metadata of OperationResultInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OperationResultInfo',
      type: {
        name: 'Composite',
        className: 'OperationResultInfo',
        modelProperties: {
          objectType: {
            required: true,
            serializedName: 'objectType',
            type: {
              name: 'String'
            }
          },
          jobList: {
            required: false,
            serializedName: 'jobList',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = OperationResultInfo;
