/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Operation status extended info for list of jobs.
 *
 * @extends models['OperationStatusExtendedInfo']
 */
class OperationStatusJobsExtendedInfo extends models['OperationStatusExtendedInfo'] {
  /**
   * Create a OperationStatusJobsExtendedInfo.
   * @member {array} [jobIds] IDs of the jobs created for the protected item.
   * @member {object} [failedJobsError] Stores all the failed jobs along with
   * the corresponding error codes.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of OperationStatusJobsExtendedInfo
   *
   * @returns {object} metadata of OperationStatusJobsExtendedInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OperationStatusJobsExtendedInfo',
      type: {
        name: 'Composite',
        className: 'OperationStatusJobsExtendedInfo',
        modelProperties: {
          objectType: {
            required: true,
            serializedName: 'objectType',
            type: {
              name: 'String'
            }
          },
          jobIds: {
            required: false,
            serializedName: 'jobIds',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          failedJobsError: {
            required: false,
            serializedName: 'failedJobsError',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = OperationStatusJobsExtendedInfo;
