/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Operation status extended info for ILR provision action.
 *
 * @extends models['OperationStatusExtendedInfo']
 */
class OperationStatusProvisionILRExtendedInfo extends models['OperationStatusExtendedInfo'] {
  /**
   * Create a OperationStatusProvisionILRExtendedInfo.
   * @member {object} [recoveryTarget] Target details for file / folder
   * restore.
   * @member {array} [recoveryTarget.clientScripts] List of client scripts.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of OperationStatusProvisionILRExtendedInfo
   *
   * @returns {object} metadata of OperationStatusProvisionILRExtendedInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OperationStatusProvisionILRExtendedInfo',
      type: {
        name: 'Composite',
        className: 'OperationStatusProvisionILRExtendedInfo',
        modelProperties: {
          objectType: {
            required: true,
            serializedName: 'objectType',
            type: {
              name: 'String'
            }
          },
          recoveryTarget: {
            required: false,
            serializedName: 'recoveryTarget',
            type: {
              name: 'Composite',
              className: 'InstantItemRecoveryTarget'
            }
          }
        }
      }
    };
  }
}

module.exports = OperationStatusProvisionILRExtendedInfo;
