/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Base class for backup policy. Workload-specific backup policies are derived
 * from this class.
 *
 * @extends models['Resource']
 */
class ProtectionPolicyResource extends models['Resource'] {
  /**
   * Create a ProtectionPolicyResource.
   * @member {object} [properties] ProtectionPolicyResource properties
   * @member {number} [properties.protectedItemsCount] Number of items
   * associated with this policy.
   * @member {string} [properties.backupManagementType] Polymorphic
   * Discriminator
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ProtectionPolicyResource
   *
   * @returns {object} metadata of ProtectionPolicyResource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ProtectionPolicyResource',
      type: {
        name: 'Composite',
        className: 'ProtectionPolicyResource',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          eTag: {
            required: false,
            serializedName: 'eTag',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'backupManagementType',
                clientName: 'backupManagementType'
              },
              uberParent: 'ProtectionPolicy',
              className: 'ProtectionPolicy'
            }
          }
        }
      }
    };
  }
}

module.exports = ProtectionPolicyResource;
