/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Base class for restore request. Workload-specific restore requests are
 * derived from this class.
 *
 */
class RestoreRequest {
  /**
   * Create a RestoreRequest.
   * @member {string} objectType Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of RestoreRequest
   *
   * @returns {object} metadata of RestoreRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RestoreRequest',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'objectType',
          clientName: 'objectType'
        },
        uberParent: 'RestoreRequest',
        className: 'RestoreRequest',
        modelProperties: {
          objectType: {
            required: true,
            serializedName: 'objectType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = RestoreRequest;
