/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Retention duration.
 *
 */
class RetentionDuration {
  /**
   * Create a RetentionDuration.
   * @member {number} [count] Count of duration types. Retention duration is
   * obtained by the counting the duration type Count times.
   * For example, when Count = 3 and DurationType = Weeks, retention duration
   * will be three weeks.
   * @member {string} [durationType] Retention duration type of retention
   * policy. Possible values include: 'Invalid', 'Days', 'Weeks', 'Months',
   * 'Years'
   */
  constructor() {
  }

  /**
   * Defines the metadata of RetentionDuration
   *
   * @returns {object} metadata of RetentionDuration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RetentionDuration',
      type: {
        name: 'Composite',
        className: 'RetentionDuration',
        modelProperties: {
          count: {
            required: false,
            serializedName: 'count',
            type: {
              name: 'Number'
            }
          },
          durationType: {
            required: false,
            serializedName: 'durationType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = RetentionDuration;
