/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Certificate details representing the Vault credentials.
 *
 */
class ResourceCertificateDetails {
  /**
   * Create a ResourceCertificateDetails.
   * @member {buffer} [certificate] The base64 encoded certificate raw data
   * string.
   * @member {string} [friendlyName] Certificate friendlyname.
   * @member {string} [issuer] Certificate issuer.
   * @member {number} [resourceId] Resource ID of the vault.
   * @member {string} [subject] Certificate Subject Name.
   * @member {string} [thumbprint] Certificate thumbprint.
   * @member {date} [validFrom] Certificate Validity start Date time.
   * @member {date} [validTo] Certificate Validity End Date time.
   * @member {string} authType Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResourceCertificateDetails
   *
   * @returns {object} metadata of ResourceCertificateDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceCertificateDetails',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'authType',
          clientName: 'authType'
        },
        uberParent: 'ResourceCertificateDetails',
        className: 'ResourceCertificateDetails',
        modelProperties: {
          certificate: {
            required: false,
            serializedName: 'certificate',
            type: {
              name: 'ByteArray'
            }
          },
          friendlyName: {
            required: false,
            serializedName: 'friendlyName',
            type: {
              name: 'String'
            }
          },
          issuer: {
            required: false,
            serializedName: 'issuer',
            type: {
              name: 'String'
            }
          },
          resourceId: {
            required: false,
            serializedName: 'resourceId',
            type: {
              name: 'Number'
            }
          },
          subject: {
            required: false,
            serializedName: 'subject',
            type: {
              name: 'String'
            }
          },
          thumbprint: {
            required: false,
            serializedName: 'thumbprint',
            type: {
              name: 'String'
            }
          },
          validFrom: {
            required: false,
            serializedName: 'validFrom',
            type: {
              name: 'DateTime'
            }
          },
          validTo: {
            required: false,
            serializedName: 'validTo',
            type: {
              name: 'DateTime'
            }
          },
          authType: {
            required: true,
            serializedName: 'authType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceCertificateDetails;
