/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Vault extended information.
 *
 * @extends models['Resource']
 */
class VaultExtendedInfoResource extends models['Resource'] {
  /**
   * Create a VaultExtendedInfoResource.
   * @member {string} [integrityKey] Integrity key.
   * @member {string} [encryptionKey] Encryption key.
   * @member {string} [encryptionKeyThumbprint] Encryption key thumbprint.
   * @member {string} [algorithm] Algorithm.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of VaultExtendedInfoResource
   *
   * @returns {object} metadata of VaultExtendedInfoResource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VaultExtendedInfoResource',
      type: {
        name: 'Composite',
        className: 'VaultExtendedInfoResource',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          eTag: {
            required: false,
            serializedName: 'eTag',
            type: {
              name: 'String'
            }
          },
          integrityKey: {
            required: false,
            serializedName: 'properties.integrityKey',
            type: {
              name: 'String'
            }
          },
          encryptionKey: {
            required: false,
            serializedName: 'properties.encryptionKey',
            type: {
              name: 'String'
            }
          },
          encryptionKeyThumbprint: {
            required: false,
            serializedName: 'properties.encryptionKeyThumbprint',
            type: {
              name: 'String'
            }
          },
          algorithm: {
            required: false,
            serializedName: 'properties.algorithm',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = VaultExtendedInfoResource;
