/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Model class for event details of a A2A event.
 *
 * @extends models['EventProviderSpecificDetails']
 */
class A2AEventDetails extends models['EventProviderSpecificDetails'] {
  /**
   * Create a A2AEventDetails.
   * @member {string} [protectedItemName] The protected item arm name.
   * @member {string} [fabricObjectId] The azure vm arm id.
   * @member {string} [fabricName] Fabric arm name.
   * @member {string} [fabricLocation] The fabric location.
   * @member {string} [remoteFabricName] Remote fabric arm name.
   * @member {string} [remoteFabricLocation] Remote fabric location.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of A2AEventDetails
   *
   * @returns {object} metadata of A2AEventDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'A2A',
      type: {
        name: 'Composite',
        className: 'A2AEventDetails',
        modelProperties: {
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            type: {
              name: 'String'
            }
          },
          protectedItemName: {
            required: false,
            serializedName: 'protectedItemName',
            type: {
              name: 'String'
            }
          },
          fabricObjectId: {
            required: false,
            serializedName: 'fabricObjectId',
            type: {
              name: 'String'
            }
          },
          fabricName: {
            required: false,
            serializedName: 'fabricName',
            type: {
              name: 'String'
            }
          },
          fabricLocation: {
            required: false,
            serializedName: 'fabricLocation',
            type: {
              name: 'String'
            }
          },
          remoteFabricName: {
            required: false,
            serializedName: 'remoteFabricName',
            type: {
              name: 'String'
            }
          },
          remoteFabricLocation: {
            required: false,
            serializedName: 'remoteFabricLocation',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = A2AEventDetails;
