/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A2A protected managed disk details.
 *
 */
class A2AProtectedManagedDiskDetails {
  /**
   * Create a A2AProtectedManagedDiskDetails.
   * @member {string} [diskId] The managed disk Arm id.
   * @member {string} [recoveryAzureResourceGroupId] The recovery disk resource
   * group Arm Id.
   * @member {string} [recoveryDiskId] Recovery disk Arm Id.
   * @member {string} [diskName] The disk name.
   * @member {number} [diskCapacityInBytes] The disk capacity in bytes.
   * @member {string} [primaryStagingAzureStorageAccountId] The primary staging
   * storage account.
   * @member {string} [diskType] The type of disk.
   * @member {boolean} [resyncRequired] A value indicating whether resync is
   * required for this disk.
   * @member {number} [monitoringPercentageCompletion] The percentage of the
   * monitoring job. The type of the monitoring job is defined by
   * MonitoringJobType property.
   * @member {string} [monitoringJobType] The type of the monitoring job. The
   * progress is contained in MonitoringPercentageCompletion property.
   * @member {number} [dataPendingInStagingStorageAccountInMB] The data pending
   * for replication in MB at staging account.
   * @member {number} [dataPendingAtSourceAgentInMB] The data pending at source
   * virtual machine in MB.
   */
  constructor() {
  }

  /**
   * Defines the metadata of A2AProtectedManagedDiskDetails
   *
   * @returns {object} metadata of A2AProtectedManagedDiskDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'A2AProtectedManagedDiskDetails',
      type: {
        name: 'Composite',
        className: 'A2AProtectedManagedDiskDetails',
        modelProperties: {
          diskId: {
            required: false,
            serializedName: 'diskId',
            type: {
              name: 'String'
            }
          },
          recoveryAzureResourceGroupId: {
            required: false,
            serializedName: 'recoveryAzureResourceGroupId',
            type: {
              name: 'String'
            }
          },
          recoveryDiskId: {
            required: false,
            serializedName: 'recoveryDiskId',
            type: {
              name: 'String'
            }
          },
          diskName: {
            required: false,
            serializedName: 'diskName',
            type: {
              name: 'String'
            }
          },
          diskCapacityInBytes: {
            required: false,
            serializedName: 'diskCapacityInBytes',
            type: {
              name: 'Number'
            }
          },
          primaryStagingAzureStorageAccountId: {
            required: false,
            serializedName: 'primaryStagingAzureStorageAccountId',
            type: {
              name: 'String'
            }
          },
          diskType: {
            required: false,
            serializedName: 'diskType',
            type: {
              name: 'String'
            }
          },
          resyncRequired: {
            required: false,
            serializedName: 'resyncRequired',
            type: {
              name: 'Boolean'
            }
          },
          monitoringPercentageCompletion: {
            required: false,
            serializedName: 'monitoringPercentageCompletion',
            type: {
              name: 'Number'
            }
          },
          monitoringJobType: {
            required: false,
            serializedName: 'monitoringJobType',
            type: {
              name: 'String'
            }
          },
          dataPendingInStagingStorageAccountInMB: {
            required: false,
            serializedName: 'dataPendingInStagingStorageAccountInMB',
            type: {
              name: 'Number'
            }
          },
          dataPendingAtSourceAgentInMB: {
            required: false,
            serializedName: 'dataPendingAtSourceAgentInMB',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = A2AProtectedManagedDiskDetails;
