/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Input required to add vCenter.
 *
 */
class AddVCenterRequest {
  /**
   * Create a AddVCenterRequest.
   * @member {object} [properties] The properties of an add vCenter request.
   * @member {string} [properties.friendlyName] The friendly name of the
   * vCenter.
   * @member {string} [properties.ipAddress] The IP address of the vCenter to
   * be discovered.
   * @member {string} [properties.processServerId] The process server Id from
   * where the discovery is orchestrated.
   * @member {string} [properties.port] The port number for discovery.
   * @member {string} [properties.runAsAccountId] The account Id which has
   * privileges to discover the vCenter.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AddVCenterRequest
   *
   * @returns {object} metadata of AddVCenterRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AddVCenterRequest',
      type: {
        name: 'Composite',
        className: 'AddVCenterRequest',
        modelProperties: {
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'AddVCenterRequestProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = AddVCenterRequest;
