/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The properties of an add vCenter request.
 *
 */
class AddVCenterRequestProperties {
  /**
   * Create a AddVCenterRequestProperties.
   * @member {string} [friendlyName] The friendly name of the vCenter.
   * @member {string} [ipAddress] The IP address of the vCenter to be
   * discovered.
   * @member {string} [processServerId] The process server Id from where the
   * discovery is orchestrated.
   * @member {string} [port] The port number for discovery.
   * @member {string} [runAsAccountId] The account Id which has privileges to
   * discover the vCenter.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AddVCenterRequestProperties
   *
   * @returns {object} metadata of AddVCenterRequestProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AddVCenterRequestProperties',
      type: {
        name: 'Composite',
        className: 'AddVCenterRequestProperties',
        modelProperties: {
          friendlyName: {
            required: false,
            serializedName: 'friendlyName',
            type: {
              name: 'String'
            }
          },
          ipAddress: {
            required: false,
            serializedName: 'ipAddress',
            type: {
              name: 'String'
            }
          },
          processServerId: {
            required: false,
            serializedName: 'processServerId',
            type: {
              name: 'String'
            }
          },
          port: {
            required: false,
            serializedName: 'port',
            type: {
              name: 'String'
            }
          },
          runAsAccountId: {
            required: false,
            serializedName: 'runAsAccountId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AddVCenterRequestProperties;
