/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The proprties of an alert.
 *
 */
class AlertProperties {
  /**
   * Create a AlertProperties.
   * @member {string} [sendToOwners] A value indicating whether to send email
   * to subscription administrator.
   * @member {array} [customEmailAddresses] The custom email address for
   * sending emails.
   * @member {string} [locale] The locale for the email notification.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AlertProperties
   *
   * @returns {object} metadata of AlertProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AlertProperties',
      type: {
        name: 'Composite',
        className: 'AlertProperties',
        modelProperties: {
          sendToOwners: {
            required: false,
            serializedName: 'sendToOwners',
            type: {
              name: 'String'
            }
          },
          customEmailAddresses: {
            required: false,
            serializedName: 'customEmailAddresses',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          locale: {
            required: false,
            serializedName: 'locale',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AlertProperties;
