/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Input to apply recovery point.
 *
 */
class ApplyRecoveryPointInput {
  /**
   * Create a ApplyRecoveryPointInput.
   * @member {object} [properties] The input properties to apply recovery
   * point.
   * @member {string} [properties.recoveryPointId] The recovery point Id.
   * @member {object} [properties.providerSpecificDetails] Provider specific
   * input for applying recovery point.
   * @member {string} [properties.providerSpecificDetails.instanceType]
   * Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApplyRecoveryPointInput
   *
   * @returns {object} metadata of ApplyRecoveryPointInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplyRecoveryPointInput',
      type: {
        name: 'Composite',
        className: 'ApplyRecoveryPointInput',
        modelProperties: {
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'ApplyRecoveryPointInputProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = ApplyRecoveryPointInput;
