/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Input properties to apply recovery point.
 *
 */
class ApplyRecoveryPointInputProperties {
  /**
   * Create a ApplyRecoveryPointInputProperties.
   * @member {string} [recoveryPointId] The recovery point Id.
   * @member {object} [providerSpecificDetails] Provider specific input for
   * applying recovery point.
   * @member {string} [providerSpecificDetails.instanceType] Polymorphic
   * Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApplyRecoveryPointInputProperties
   *
   * @returns {object} metadata of ApplyRecoveryPointInputProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplyRecoveryPointInputProperties',
      type: {
        name: 'Composite',
        className: 'ApplyRecoveryPointInputProperties',
        modelProperties: {
          recoveryPointId: {
            required: false,
            serializedName: 'recoveryPointId',
            type: {
              name: 'String'
            }
          },
          providerSpecificDetails: {
            required: false,
            serializedName: 'providerSpecificDetails',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'instanceType',
                clientName: 'instanceType'
              },
              uberParent: 'ApplyRecoveryPointProviderSpecificInput',
              className: 'ApplyRecoveryPointProviderSpecificInput'
            }
          }
        }
      }
    };
  }
}

module.exports = ApplyRecoveryPointInputProperties;
