/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Fabric provider specific settings.
 *
 * @extends models['FabricSpecificCreationInput']
 */
class AzureFabricCreationInput extends models['FabricSpecificCreationInput'] {
  /**
   * Create a AzureFabricCreationInput.
   * @member {string} [location] The Location.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureFabricCreationInput
   *
   * @returns {object} metadata of AzureFabricCreationInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'A2A',
      type: {
        name: 'Composite',
        className: 'AzureFabricCreationInput',
        modelProperties: {
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureFabricCreationInput;
