/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Request to configure alerts for the system.
 *
 */
class ConfigureAlertRequest {
  /**
   * Create a ConfigureAlertRequest.
   * @member {object} [properties] The properties of a configure alert request.
   * @member {string} [properties.sendToOwners] A value indicating whether to
   * send email to subscription administrator.
   * @member {array} [properties.customEmailAddresses] The custom email address
   * for sending emails.
   * @member {string} [properties.locale] The locale for the email
   * notification.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ConfigureAlertRequest
   *
   * @returns {object} metadata of ConfigureAlertRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ConfigureAlertRequest',
      type: {
        name: 'Composite',
        className: 'ConfigureAlertRequest',
        modelProperties: {
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'ConfigureAlertRequestProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = ConfigureAlertRequest;
