/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * This class contains monitoring details of all the inconsistent Protected
 * Entites in Vmm.
 *
 * @extends models['TaskTypeDetails']
 */
class ConsistencyCheckTaskDetails extends models['TaskTypeDetails'] {
  /**
   * Create a ConsistencyCheckTaskDetails.
   * @member {array} [vmDetails] The list of inconsistent Vm details.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ConsistencyCheckTaskDetails
   *
   * @returns {object} metadata of ConsistencyCheckTaskDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ConsistencyCheckTaskDetails',
      type: {
        name: 'Composite',
        className: 'ConsistencyCheckTaskDetails',
        modelProperties: {
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            type: {
              name: 'String'
            }
          },
          vmDetails: {
            required: false,
            serializedName: 'vmDetails',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'InconsistentVmDetailsElementType',
                  type: {
                    name: 'Composite',
                    className: 'InconsistentVmDetails'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ConsistencyCheckTaskDetails;
