/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Configure pairing input.
 *
 */
class CreateProtectionContainerMappingInput {
  /**
   * Create a CreateProtectionContainerMappingInput.
   * @member {object} [properties] Configure protection input properties.
   * @member {string} [properties.targetProtectionContainerId] The target
   * unique protection container name.
   * @member {string} [properties.policyId] Applicable policy.
   * @member {object} [properties.providerSpecificInput] Provider specific
   * input for pairing.
   * @member {string} [properties.providerSpecificInput.instanceType] The class
   * type.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CreateProtectionContainerMappingInput
   *
   * @returns {object} metadata of CreateProtectionContainerMappingInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CreateProtectionContainerMappingInput',
      type: {
        name: 'Composite',
        className: 'CreateProtectionContainerMappingInput',
        modelProperties: {
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'CreateProtectionContainerMappingInputProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = CreateProtectionContainerMappingInput;
