/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Create recovery plan input class.
 *
 */
class CreateRecoveryPlanInput {
  /**
   * Create a CreateRecoveryPlanInput.
   * @member {object} properties Recovery plan creation properties.
   * @member {string} [properties.primaryFabricId] The primary fabric Id.
   * @member {string} [properties.recoveryFabricId] The recovery fabric Id.
   * @member {string} [properties.failoverDeploymentModel] The failover
   * deployment model. Possible values include: 'NotApplicable', 'Classic',
   * 'ResourceManager'
   * @member {array} [properties.groups] The recovery plan groups.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CreateRecoveryPlanInput
   *
   * @returns {object} metadata of CreateRecoveryPlanInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CreateRecoveryPlanInput',
      type: {
        name: 'Composite',
        className: 'CreateRecoveryPlanInput',
        modelProperties: {
          properties: {
            required: true,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'CreateRecoveryPlanInputProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = CreateRecoveryPlanInput;
