/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Recovery plan creation properties.
 *
 */
class CreateRecoveryPlanInputProperties {
  /**
   * Create a CreateRecoveryPlanInputProperties.
   * @member {string} primaryFabricId The primary fabric Id.
   * @member {string} recoveryFabricId The recovery fabric Id.
   * @member {string} [failoverDeploymentModel] The failover deployment model.
   * Possible values include: 'NotApplicable', 'Classic', 'ResourceManager'
   * @member {array} groups The recovery plan groups.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CreateRecoveryPlanInputProperties
   *
   * @returns {object} metadata of CreateRecoveryPlanInputProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CreateRecoveryPlanInputProperties',
      type: {
        name: 'Composite',
        className: 'CreateRecoveryPlanInputProperties',
        modelProperties: {
          primaryFabricId: {
            required: true,
            serializedName: 'primaryFabricId',
            type: {
              name: 'String'
            }
          },
          recoveryFabricId: {
            required: true,
            serializedName: 'recoveryFabricId',
            type: {
              name: 'String'
            }
          },
          failoverDeploymentModel: {
            required: false,
            serializedName: 'failoverDeploymentModel',
            type: {
              name: 'Enum',
              allowedValues: [ 'NotApplicable', 'Classic', 'ResourceManager' ]
            }
          },
          groups: {
            required: true,
            serializedName: 'groups',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'RecoveryPlanGroupElementType',
                  type: {
                    name: 'Composite',
                    className: 'RecoveryPlanGroup'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = CreateRecoveryPlanInputProperties;
