/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Current scenario details of the protected entity.
 *
 */
class CurrentScenarioDetails {
  /**
   * Create a CurrentScenarioDetails.
   * @member {string} [scenarioName] Scenario name.
   * @member {string} [jobId] ARM Id of the job being executed.
   * @member {date} [startTime] Start time of the workflow.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CurrentScenarioDetails
   *
   * @returns {object} metadata of CurrentScenarioDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CurrentScenarioDetails',
      type: {
        name: 'Composite',
        className: 'CurrentScenarioDetails',
        modelProperties: {
          scenarioName: {
            required: false,
            serializedName: 'scenarioName',
            type: {
              name: 'String'
            }
          },
          jobId: {
            required: false,
            serializedName: 'jobId',
            type: {
              name: 'String'
            }
          },
          startTime: {
            required: false,
            serializedName: 'startTime',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = CurrentScenarioDetails;
