/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Disable protection input.
 *
 */
class DisableProtectionInput {
  /**
   * Create a DisableProtectionInput.
   * @member {object} [properties] Disable protection input properties.
   * @member {string} [properties.disableProtectionReason] Disable protection
   * reason. It can have values NotSpecified/MigrationComplete. Possible values
   * include: 'NotSpecified', 'MigrationComplete'
   * @member {object} [properties.replicationProviderInput] Replication
   * provider specific input.
   * @member {string} [properties.replicationProviderInput.instanceType]
   * Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of DisableProtectionInput
   *
   * @returns {object} metadata of DisableProtectionInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DisableProtectionInput',
      type: {
        name: 'Composite',
        className: 'DisableProtectionInput',
        modelProperties: {
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'DisableProtectionInputProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = DisableProtectionInput;
