/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Onprem disk details data.
 *
 */
class DiskDetails {
  /**
   * Create a DiskDetails.
   * @member {number} [maxSizeMB] The hard disk max size in MB.
   * @member {string} [vhdType] The type of the volume.
   * @member {string} [vhdId] The VHD Id.
   * @member {string} [vhdName] The VHD name.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DiskDetails
   *
   * @returns {object} metadata of DiskDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DiskDetails',
      type: {
        name: 'Composite',
        className: 'DiskDetails',
        modelProperties: {
          maxSizeMB: {
            required: false,
            serializedName: 'maxSizeMB',
            type: {
              name: 'Number'
            }
          },
          vhdType: {
            required: false,
            serializedName: 'vhdType',
            type: {
              name: 'String'
            }
          },
          vhdId: {
            required: false,
            serializedName: 'vhdId',
            type: {
              name: 'String'
            }
          },
          vhdName: {
            required: false,
            serializedName: 'vhdName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DiskDetails;
