/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Contains the localized display information for this particular operation /
 * action. These value will be used by several clients for (1) custom role
 * definitions for RBAC; (2) complex query filters for the event service; and
 * (3) audit history / records for management operations.
 *
 */
class Display {
  /**
   * Create a Display.
   * @member {string} [provider] The provider. The localized friendly form of
   * the resource provider name – it is expected to also include the
   * publisher/company responsible. It should use Title Casing and begin with
   * "Microsoft" for 1st party services. e.g. "Microsoft Monitoring Insights"
   * or "Microsoft Compute."
   * @member {string} [resource] The resource. The localized friendly form of
   * the resource related to this action/operation – it should match the public
   * documentation for the resource provider. It should use Title Casing. This
   * value should be unique for a particular URL type (e.g. nested types should
   * *not* reuse their parent’s display.resource field). e.g. "Virtual
   * Machines" or "Scheduler Job Collections", or "Virtual Machine VM Sizes" or
   * "Scheduler Jobs"
   * @member {string} [operation] The operation. The localized friendly name
   * for the operation, as it should be shown to the user. It should be concise
   * (to fit in drop downs) but clear (i.e. self-documenting). It should use
   * Title Casing. Prescriptive guidance: Read Create or Update Delete
   * 'ActionName'
   * @member {string} [description] The description. The localized friendly
   * description for the operation, as it should be shown to the user. It
   * should be thorough, yet concise – it will be used in tool tips and
   * detailed views. Prescriptive guidance for namespaces: Read any
   * 'display.provider' resource Create or Update any 'display.provider'
   * resource Delete any 'display.provider' resource Perform any other action
   * on any 'display.provider' resource Prescriptive guidance for namespaces:
   * Read any 'display.resource' Create or Update any 'display.resource' Delete
   * any 'display.resource' 'ActionName' any 'display.resources'
   */
  constructor() {
  }

  /**
   * Defines the metadata of Display
   *
   * @returns {object} metadata of Display
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Display',
      type: {
        name: 'Composite',
        className: 'Display',
        modelProperties: {
          provider: {
            required: false,
            serializedName: 'provider',
            type: {
              name: 'String'
            }
          },
          resource: {
            required: false,
            serializedName: 'resource',
            type: {
              name: 'String'
            }
          },
          operation: {
            required: false,
            serializedName: 'operation',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Display;
