/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Enable protection input.
 *
 */
class EnableProtectionInput {
  /**
   * Create a EnableProtectionInput.
   * @member {object} [properties] Enable protection input properties.
   * @member {string} [properties.policyId] The Policy Id.
   * @member {string} [properties.protectableItemId] The protectable item Id.
   * @member {object} [properties.providerSpecificDetails] The
   * ReplicationProviderInput. For HyperVReplicaAzure provider, it will be
   * AzureEnableProtectionInput object. For San provider, it will be
   * SanEnableProtectionInput object. For HyperVReplicaAzure provider, it can
   * be null.
   * @member {string} [properties.providerSpecificDetails.instanceType]
   * Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of EnableProtectionInput
   *
   * @returns {object} metadata of EnableProtectionInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EnableProtectionInput',
      type: {
        name: 'Composite',
        className: 'EnableProtectionInput',
        modelProperties: {
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'EnableProtectionInputProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = EnableProtectionInput;
