/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Implements the event query parameter.
 *
 */
class EventQueryParameter {
  /**
   * Create a EventQueryParameter.
   * @member {string} [eventCode] The source id of the events to be queried.
   * @member {string} [severity] The severity of the events to be queried.
   * @member {string} [eventType] The type of the events to be queried.
   * @member {string} [fabricName] The affected object server id of the events
   * to be queried.
   * @member {string} [affectedObjectFriendlyName] The affected object name of
   * the events to be queried.
   * @member {date} [startTime] The start time of the time range within which
   * the events are to be queried.
   * @member {date} [endTime] The end time of the time range within which the
   * events are to be queried.
   */
  constructor() {
  }

  /**
   * Defines the metadata of EventQueryParameter
   *
   * @returns {object} metadata of EventQueryParameter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EventQueryParameter',
      type: {
        name: 'Composite',
        className: 'EventQueryParameter',
        modelProperties: {
          eventCode: {
            required: false,
            serializedName: 'EventCode',
            type: {
              name: 'String'
            }
          },
          severity: {
            required: false,
            serializedName: 'Severity',
            type: {
              name: 'String'
            }
          },
          eventType: {
            required: false,
            serializedName: 'EventType',
            type: {
              name: 'String'
            }
          },
          fabricName: {
            required: false,
            serializedName: 'FabricName',
            type: {
              name: 'String'
            }
          },
          affectedObjectFriendlyName: {
            required: false,
            serializedName: 'AffectedObjectFriendlyName',
            type: {
              name: 'String'
            }
          },
          startTime: {
            required: false,
            serializedName: 'StartTime',
            type: {
              name: 'DateTime'
            }
          },
          endTime: {
            required: false,
            serializedName: 'EndTime',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = EventQueryParameter;
