/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * This class represents the details for a failover job.
 *
 * @extends models['JobDetails']
 */
class FailoverJobDetails extends models['JobDetails'] {
  /**
   * Create a FailoverJobDetails.
   * @member {array} [protectedItemDetails] The test VM details.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of FailoverJobDetails
   *
   * @returns {object} metadata of FailoverJobDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FailoverJobDetails',
      type: {
        name: 'Composite',
        className: 'FailoverJobDetails',
        modelProperties: {
          affectedObjectDetails: {
            required: false,
            serializedName: 'affectedObjectDetails',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            type: {
              name: 'String'
            }
          },
          protectedItemDetails: {
            required: false,
            serializedName: 'protectedItemDetails',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'FailoverReplicationProtectedItemDetailsElementType',
                  type: {
                    name: 'Composite',
                    className: 'FailoverReplicationProtectedItemDetails'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = FailoverJobDetails;
