/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Request to failover a process server.
 *
 */
class FailoverProcessServerRequest {
  /**
   * Create a FailoverProcessServerRequest.
   * @member {object} [properties] The properties of the PS Failover request.
   * @member {string} [properties.containerName] The container identifier.
   * @member {string} [properties.sourceProcessServerId] The source process
   * server.
   * @member {string} [properties.targetProcessServerId] The new process
   * server.
   * @member {array} [properties.vmsToMigrate] The VMS to migrate.
   * @member {string} [properties.updateType] A value for failover type. It can
   * be systemlevel/serverlevel
   */
  constructor() {
  }

  /**
   * Defines the metadata of FailoverProcessServerRequest
   *
   * @returns {object} metadata of FailoverProcessServerRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FailoverProcessServerRequest',
      type: {
        name: 'Composite',
        className: 'FailoverProcessServerRequest',
        modelProperties: {
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'FailoverProcessServerRequestProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = FailoverProcessServerRequest;
