/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The properties of the Failover Process Server request.
 *
 */
class FailoverProcessServerRequestProperties {
  /**
   * Create a FailoverProcessServerRequestProperties.
   * @member {string} [containerName] The container identifier.
   * @member {string} [sourceProcessServerId] The source process server.
   * @member {string} [targetProcessServerId] The new process server.
   * @member {array} [vmsToMigrate] The VMS to migrate.
   * @member {string} [updateType] A value for failover type. It can be
   * systemlevel/serverlevel
   */
  constructor() {
  }

  /**
   * Defines the metadata of FailoverProcessServerRequestProperties
   *
   * @returns {object} metadata of FailoverProcessServerRequestProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FailoverProcessServerRequestProperties',
      type: {
        name: 'Composite',
        className: 'FailoverProcessServerRequestProperties',
        modelProperties: {
          containerName: {
            required: false,
            serializedName: 'containerName',
            type: {
              name: 'String'
            }
          },
          sourceProcessServerId: {
            required: false,
            serializedName: 'sourceProcessServerId',
            type: {
              name: 'String'
            }
          },
          targetProcessServerId: {
            required: false,
            serializedName: 'targetProcessServerId',
            type: {
              name: 'String'
            }
          },
          vmsToMigrate: {
            required: false,
            serializedName: 'vmsToMigrate',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          updateType: {
            required: false,
            serializedName: 'updateType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = FailoverProcessServerRequestProperties;
