/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Health Error
 *
 */
class HealthError {
  /**
   * Create a HealthError.
   * @member {string} [errorSource] Source of error.
   * @member {string} [errorType] Type of error.
   * @member {string} [errorLevel] Level of error.
   * @member {string} [errorCode] Error code.
   * @member {string} [errorMessage] Error message.
   * @member {string} [possibleCauses] Possible causes of error.
   * @member {string} [recommendedAction] Recommended action to resolve error.
   * @member {date} [creationTimeUtc] Error creation time (UTC)
   * @member {string} [recoveryProviderErrorMessage] DRA error message.
   * @member {string} [entityId] ID of the entity.
   * @member {array} [childErrors] The child health errors.
   */
  constructor() {
  }

  /**
   * Defines the metadata of HealthError
   *
   * @returns {object} metadata of HealthError
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HealthError',
      type: {
        name: 'Composite',
        className: 'HealthError',
        modelProperties: {
          errorSource: {
            required: false,
            serializedName: 'errorSource',
            type: {
              name: 'String'
            }
          },
          errorType: {
            required: false,
            serializedName: 'errorType',
            type: {
              name: 'String'
            }
          },
          errorLevel: {
            required: false,
            serializedName: 'errorLevel',
            type: {
              name: 'String'
            }
          },
          errorCode: {
            required: false,
            serializedName: 'errorCode',
            type: {
              name: 'String'
            }
          },
          errorMessage: {
            required: false,
            serializedName: 'errorMessage',
            type: {
              name: 'String'
            }
          },
          possibleCauses: {
            required: false,
            serializedName: 'possibleCauses',
            type: {
              name: 'String'
            }
          },
          recommendedAction: {
            required: false,
            serializedName: 'recommendedAction',
            type: {
              name: 'String'
            }
          },
          creationTimeUtc: {
            required: false,
            serializedName: 'creationTimeUtc',
            type: {
              name: 'DateTime'
            }
          },
          recoveryProviderErrorMessage: {
            required: false,
            serializedName: 'recoveryProviderErrorMessage',
            type: {
              name: 'String'
            }
          },
          entityId: {
            required: false,
            serializedName: 'entityId',
            type: {
              name: 'String'
            }
          },
          childErrors: {
            required: false,
            serializedName: 'childErrors',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'HealthErrorElementType',
                  type: {
                    name: 'Composite',
                    className: 'HealthError'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = HealthError;
