/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * ApplyRecoveryPoint input specific to HyperVReplicaAzure provider.
 *
 * @extends models['ApplyRecoveryPointProviderSpecificInput']
 */
class HyperVReplicaAzureApplyRecoveryPointInput extends models['ApplyRecoveryPointProviderSpecificInput'] {
  /**
   * Create a HyperVReplicaAzureApplyRecoveryPointInput.
   * @member {string} [vaultLocation] The vault location where the recovery Vm
   * resides.
   * @member {string} [primaryKekCertificatePfx] The primary kek certificate
   * pfx.
   * @member {string} [secondaryKekCertificatePfx] The secondary kek
   * certificate pfx.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of HyperVReplicaAzureApplyRecoveryPointInput
   *
   * @returns {object} metadata of HyperVReplicaAzureApplyRecoveryPointInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HyperVReplicaAzure',
      type: {
        name: 'Composite',
        className: 'HyperVReplicaAzureApplyRecoveryPointInput',
        modelProperties: {
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            type: {
              name: 'String'
            }
          },
          vaultLocation: {
            required: false,
            serializedName: 'vaultLocation',
            type: {
              name: 'String'
            }
          },
          primaryKekCertificatePfx: {
            required: false,
            serializedName: 'primaryKekCertificatePfx',
            type: {
              name: 'String'
            }
          },
          secondaryKekCertificatePfx: {
            required: false,
            serializedName: 'secondaryKekCertificatePfx',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = HyperVReplicaAzureApplyRecoveryPointInput;
