/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * HvrA provider specific input for failover.
 *
 * @extends models['ProviderSpecificFailoverInput']
 */
class HyperVReplicaAzureFailoverProviderInput extends models['ProviderSpecificFailoverInput'] {
  /**
   * Create a HyperVReplicaAzureFailoverProviderInput.
   * @member {string} [vaultLocation] Location of the vault.
   * @member {string} [primaryKekCertificatePfx] Primary kek certificate pfx.
   * @member {string} [secondaryKekCertificatePfx] Secondary kek certificate
   * pfx.
   * @member {string} [recoveryPointId] The recovery point id to be passed to
   * failover to a particular recovery point. In case of latest recovery point,
   * null should be passed.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of HyperVReplicaAzureFailoverProviderInput
   *
   * @returns {object} metadata of HyperVReplicaAzureFailoverProviderInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HyperVReplicaAzure',
      type: {
        name: 'Composite',
        className: 'HyperVReplicaAzureFailoverProviderInput',
        modelProperties: {
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            type: {
              name: 'String'
            }
          },
          vaultLocation: {
            required: false,
            serializedName: 'vaultLocation',
            type: {
              name: 'String'
            }
          },
          primaryKekCertificatePfx: {
            required: false,
            serializedName: 'primaryKekCertificatePfx',
            type: {
              name: 'String'
            }
          },
          secondaryKekCertificatePfx: {
            required: false,
            serializedName: 'secondaryKekCertificatePfx',
            type: {
              name: 'String'
            }
          },
          recoveryPointId: {
            required: false,
            serializedName: 'recoveryPointId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = HyperVReplicaAzureFailoverProviderInput;
