/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Identity details.
 *
 */
class IdentityInformation {
  /**
   * Create a IdentityInformation.
   * @member {string} [identityProviderType] The identity provider type. Value
   * is the ToString() of a IdentityProviderType value. Possible values
   * include: 'RecoveryServicesActiveDirectory', 'CustomerActiveDirectory'
   * @member {string} [tenantId] The tenant Id for the service principal with
   * which the on-premise management/data plane components would communicate
   * with our Azure services.
   * @member {string} [applicationId] The application/client Id for the service
   * principal with which the on-premise management/data plane components would
   * communicate with our Azure services.
   * @member {string} [objectId] The object Id of the service principal with
   * which the on-premise management/data plane components would communicate
   * with our Azure services.
   * @member {string} [audience] The intended Audience of the service principal
   * with which the on-premise management/data plane components would
   * communicate with our Azure services.
   * @member {string} [aadAuthority] The base authority for Azure Active
   * Directory authentication.
   * @member {string} [certificateThumbprint] The certificate thumbprint.
   * Applicable only if IdentityProviderType is
   * RecoveryServicesActiveDirectory.
   */
  constructor() {
  }

  /**
   * Defines the metadata of IdentityInformation
   *
   * @returns {object} metadata of IdentityInformation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IdentityInformation',
      type: {
        name: 'Composite',
        className: 'IdentityInformation',
        modelProperties: {
          identityProviderType: {
            required: false,
            serializedName: 'identityProviderType',
            type: {
              name: 'Enum',
              allowedValues: [ 'RecoveryServicesActiveDirectory', 'CustomerActiveDirectory' ]
            }
          },
          tenantId: {
            required: false,
            serializedName: 'tenantId',
            type: {
              name: 'String'
            }
          },
          applicationId: {
            required: false,
            serializedName: 'applicationId',
            type: {
              name: 'String'
            }
          },
          objectId: {
            required: false,
            serializedName: 'objectId',
            type: {
              name: 'String'
            }
          },
          audience: {
            required: false,
            serializedName: 'audience',
            type: {
              name: 'String'
            }
          },
          aadAuthority: {
            required: false,
            serializedName: 'aadAuthority',
            type: {
              name: 'String'
            }
          },
          certificateThumbprint: {
            required: false,
            serializedName: 'certificateThumbprint',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = IdentityInformation;
