/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The details of the InMage agent.
 *
 */
class InMageAgentDetails {
  /**
   * Create a InMageAgentDetails.
   * @member {string} [agentVersion] The agent version.
   * @member {string} [agentUpdateStatus] A value indicating whether installed
   * agent needs to be updated.
   * @member {string} [postUpdateRebootStatus] A value indicating whether
   * reboot is required after update is applied.
   */
  constructor() {
  }

  /**
   * Defines the metadata of InMageAgentDetails
   *
   * @returns {object} metadata of InMageAgentDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'InMageAgentDetails',
      type: {
        name: 'Composite',
        className: 'InMageAgentDetails',
        modelProperties: {
          agentVersion: {
            required: false,
            serializedName: 'agentVersion',
            type: {
              name: 'String'
            }
          },
          agentUpdateStatus: {
            required: false,
            serializedName: 'agentUpdateStatus',
            type: {
              name: 'String'
            }
          },
          postUpdateRebootStatus: {
            required: false,
            serializedName: 'postUpdateRebootStatus',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = InMageAgentDetails;
