/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * ApplyRecoveryPoint input specific to InMageAzureV2 provider.
 *
 * @extends models['ApplyRecoveryPointProviderSpecificInput']
 */
class InMageAzureV2ApplyRecoveryPointInput extends models['ApplyRecoveryPointProviderSpecificInput'] {
  /**
   * Create a InMageAzureV2ApplyRecoveryPointInput.
   * @member {string} [vaultLocation] The vault location where the recovery Vm
   * resides.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of InMageAzureV2ApplyRecoveryPointInput
   *
   * @returns {object} metadata of InMageAzureV2ApplyRecoveryPointInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'InMageAzureV2',
      type: {
        name: 'Composite',
        className: 'InMageAzureV2ApplyRecoveryPointInput',
        modelProperties: {
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            type: {
              name: 'String'
            }
          },
          vaultLocation: {
            required: false,
            serializedName: 'vaultLocation',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = InMageAzureV2ApplyRecoveryPointInput;
