/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * InMageAzureV2 specific provider input.
 *
 * @extends models['ReverseReplicationProviderSpecificInput']
 */
class InMageAzureV2ReprotectInput extends models['ReverseReplicationProviderSpecificInput'] {
  /**
   * Create a InMageAzureV2ReprotectInput.
   * @member {string} [masterTargetId] The Master target Id.
   * @member {string} [processServerId] The Process Server Id.
   * @member {string} [storageAccountId] The storage account id.
   * @member {string} [runAsAccountId] The CS account Id.
   * @member {string} [policyId] The Policy Id.
   * @member {string} [logStorageAccountId] The storage account to be used for
   * logging during replication.
   * @member {array} [disksToInclude] The disks to include list.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of InMageAzureV2ReprotectInput
   *
   * @returns {object} metadata of InMageAzureV2ReprotectInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'InMageAzureV2',
      type: {
        name: 'Composite',
        className: 'InMageAzureV2ReprotectInput',
        modelProperties: {
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            type: {
              name: 'String'
            }
          },
          masterTargetId: {
            required: false,
            serializedName: 'masterTargetId',
            type: {
              name: 'String'
            }
          },
          processServerId: {
            required: false,
            serializedName: 'processServerId',
            type: {
              name: 'String'
            }
          },
          storageAccountId: {
            required: false,
            serializedName: 'storageAccountId',
            type: {
              name: 'String'
            }
          },
          runAsAccountId: {
            required: false,
            serializedName: 'runAsAccountId',
            type: {
              name: 'String'
            }
          },
          policyId: {
            required: false,
            serializedName: 'policyId',
            type: {
              name: 'String'
            }
          },
          logStorageAccountId: {
            required: false,
            serializedName: 'logStorageAccountId',
            type: {
              name: 'String'
            }
          },
          disksToInclude: {
            required: false,
            serializedName: 'disksToInclude',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = InMageAzureV2ReprotectInput;
