/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * VMware/Physical specific Disk Details
 *
 */
class InMageDiskDetails {
  /**
   * Create a InMageDiskDetails.
   * @member {string} [diskId] The disk Id.
   * @member {string} [diskName] The disk name.
   * @member {string} [diskSizeInMB] The disk size in MB.
   * @member {string} [diskType] Whether disk is system disk or data disk.
   * @member {string} [diskConfiguration] Whether disk is dynamic disk or basic
   * disk.
   * @member {array} [volumeList] Volumes of the disk.
   */
  constructor() {
  }

  /**
   * Defines the metadata of InMageDiskDetails
   *
   * @returns {object} metadata of InMageDiskDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'InMageDiskDetails',
      type: {
        name: 'Composite',
        className: 'InMageDiskDetails',
        modelProperties: {
          diskId: {
            required: false,
            serializedName: 'diskId',
            type: {
              name: 'String'
            }
          },
          diskName: {
            required: false,
            serializedName: 'diskName',
            type: {
              name: 'String'
            }
          },
          diskSizeInMB: {
            required: false,
            serializedName: 'diskSizeInMB',
            type: {
              name: 'String'
            }
          },
          diskType: {
            required: false,
            serializedName: 'diskType',
            type: {
              name: 'String'
            }
          },
          diskConfiguration: {
            required: false,
            serializedName: 'diskConfiguration',
            type: {
              name: 'String'
            }
          },
          volumeList: {
            required: false,
            serializedName: 'volumeList',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'DiskVolumeDetailsElementType',
                  type: {
                    name: 'Composite',
                    className: 'DiskVolumeDetails'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = InMageDiskDetails;
