/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * DiskExclusionInput when doing enable protection of virtual machine in InMage
 * provider.
 *
 */
class InMageDiskExclusionInput {
  /**
   * Create a InMageDiskExclusionInput.
   * @member {array} [volumeOptions] The volume label based option for disk
   * exclusion.
   * @member {array} [diskSignatureOptions] The guest disk signature based
   * option for disk exclusion.
   */
  constructor() {
  }

  /**
   * Defines the metadata of InMageDiskExclusionInput
   *
   * @returns {object} metadata of InMageDiskExclusionInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'InMageDiskExclusionInput',
      type: {
        name: 'Composite',
        className: 'InMageDiskExclusionInput',
        modelProperties: {
          volumeOptions: {
            required: false,
            serializedName: 'volumeOptions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'InMageVolumeExclusionOptionsElementType',
                  type: {
                    name: 'Composite',
                    className: 'InMageVolumeExclusionOptions'
                  }
              }
            }
          },
          diskSignatureOptions: {
            required: false,
            serializedName: 'diskSignatureOptions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'InMageDiskSignatureExclusionOptionsElementType',
                  type: {
                    name: 'Composite',
                    className: 'InMageDiskSignatureExclusionOptions'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = InMageDiskExclusionInput;
