/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Azure VM input endpoint details.
 *
 */
class InputEndpoint {
  /**
   * Create a InputEndpoint.
   * @member {string} [endpointName] The input endpoint name.
   * @member {number} [privatePort] The input endpoint private port.
   * @member {number} [publicPort] The input endpoint public port.
   * @member {string} [protocol] The input endpoint protocol.
   */
  constructor() {
  }

  /**
   * Defines the metadata of InputEndpoint
   *
   * @returns {object} metadata of InputEndpoint
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'InputEndpoint',
      type: {
        name: 'Composite',
        className: 'InputEndpoint',
        modelProperties: {
          endpointName: {
            required: false,
            serializedName: 'endpointName',
            type: {
              name: 'String'
            }
          },
          privatePort: {
            required: false,
            serializedName: 'privatePort',
            type: {
              name: 'Number'
            }
          },
          publicPort: {
            required: false,
            serializedName: 'publicPort',
            type: {
              name: 'Number'
            }
          },
          protocol: {
            required: false,
            serializedName: 'protocol',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = InputEndpoint;
