/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * This class contains the minimal job details required to navigate to the
 * desired drill down.
 *
 */
class JobEntity {
  /**
   * Create a JobEntity.
   * @member {string} [jobId] The job id.
   * @member {string} [jobFriendlyName] The job display name.
   * @member {string} [targetObjectId] The object id.
   * @member {string} [targetObjectName] The object name.
   * @member {string} [targetInstanceType] The workflow affected object type.
   * @member {string} [jobScenarioName] The job name. Enum type ScenarioName.
   */
  constructor() {
  }

  /**
   * Defines the metadata of JobEntity
   *
   * @returns {object} metadata of JobEntity
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'JobEntity',
      type: {
        name: 'Composite',
        className: 'JobEntity',
        modelProperties: {
          jobId: {
            required: false,
            serializedName: 'jobId',
            type: {
              name: 'String'
            }
          },
          jobFriendlyName: {
            required: false,
            serializedName: 'jobFriendlyName',
            type: {
              name: 'String'
            }
          },
          targetObjectId: {
            required: false,
            serializedName: 'targetObjectId',
            type: {
              name: 'String'
            }
          },
          targetObjectName: {
            required: false,
            serializedName: 'targetObjectName',
            type: {
              name: 'String'
            }
          },
          targetInstanceType: {
            required: false,
            serializedName: 'targetInstanceType',
            type: {
              name: 'String'
            }
          },
          jobScenarioName: {
            required: false,
            serializedName: 'jobScenarioName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = JobEntity;
