/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Logical Network Properties.
 *
 */
class LogicalNetworkProperties {
  /**
   * Create a LogicalNetworkProperties.
   * @member {string} [friendlyName] The Friendly Name.
   * @member {string} [networkVirtualizationStatus] A value indicating whether
   * Network Virtualization is enabled for the logical network.
   * @member {string} [logicalNetworkUsage] A value indicating whether logical
   * network is used as private test network by test failover.
   * @member {string} [logicalNetworkDefinitionsStatus] A value indicating
   * whether logical network definitions are isolated.
   */
  constructor() {
  }

  /**
   * Defines the metadata of LogicalNetworkProperties
   *
   * @returns {object} metadata of LogicalNetworkProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LogicalNetworkProperties',
      type: {
        name: 'Composite',
        className: 'LogicalNetworkProperties',
        modelProperties: {
          friendlyName: {
            required: false,
            serializedName: 'friendlyName',
            type: {
              name: 'String'
            }
          },
          networkVirtualizationStatus: {
            required: false,
            serializedName: 'networkVirtualizationStatus',
            type: {
              name: 'String'
            }
          },
          logicalNetworkUsage: {
            required: false,
            serializedName: 'logicalNetworkUsage',
            type: {
              name: 'String'
            }
          },
          logicalNetworkDefinitionsStatus: {
            required: false,
            serializedName: 'logicalNetworkDefinitionsStatus',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = LogicalNetworkProperties;
