/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * This class represents the manual action task details.
 *
 * @extends models['TaskTypeDetails']
 */
class ManualActionTaskDetails extends models['TaskTypeDetails'] {
  /**
   * Create a ManualActionTaskDetails.
   * @member {string} [name] The name.
   * @member {string} [instructions] The instructions.
   * @member {string} [observation] The observation.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ManualActionTaskDetails
   *
   * @returns {object} metadata of ManualActionTaskDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ManualActionTaskDetails',
      type: {
        name: 'Composite',
        className: 'ManualActionTaskDetails',
        modelProperties: {
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          instructions: {
            required: false,
            serializedName: 'instructions',
            type: {
              name: 'String'
            }
          },
          observation: {
            required: false,
            serializedName: 'observation',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ManualActionTaskDetails;
