/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Reports method status where exception was raised.
 *
 */
class MethodCallStatus {
  /**
   * Create a MethodCallStatus.
   * @member {string} [isVirtual] Gets a value indicating whether called method
   * was virtual
   * @member {array} [parameters] Gets parameter list passed to method.
   * @member {string} [containsGenericParameters] Gets a value indicating
   * whether method container generic params.
   */
  constructor() {
  }

  /**
   * Defines the metadata of MethodCallStatus
   *
   * @returns {object} metadata of MethodCallStatus
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MethodCallStatus',
      type: {
        name: 'Composite',
        className: 'MethodCallStatus',
        modelProperties: {
          isVirtual: {
            required: false,
            serializedName: 'isVirtual',
            type: {
              name: 'String'
            }
          },
          parameters: {
            required: false,
            serializedName: 'parameters',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          containsGenericParameters: {
            required: false,
            serializedName: 'containsGenericParameters',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = MethodCallStatus;
