/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The Mobility Service update details.
 *
 */
class MobilityServiceUpdate {
  /**
   * Create a MobilityServiceUpdate.
   * @member {string} [version] The version of the latest update.
   * @member {string} [rebootStatus] The reboot status of the update - whether
   * it is required or not.
   * @member {string} [osType] The OS type.
   */
  constructor() {
  }

  /**
   * Defines the metadata of MobilityServiceUpdate
   *
   * @returns {object} metadata of MobilityServiceUpdate
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MobilityServiceUpdate',
      type: {
        name: 'Composite',
        className: 'MobilityServiceUpdate',
        modelProperties: {
          version: {
            required: false,
            serializedName: 'version',
            type: {
              name: 'String'
            }
          },
          rebootStatus: {
            required: false,
            serializedName: 'rebootStatus',
            type: {
              name: 'String'
            }
          },
          osType: {
            required: false,
            serializedName: 'osType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = MobilityServiceUpdate;
