/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Network model.
 *
 * @extends models['Resource']
 */
class Network extends models['Resource'] {
  /**
   * Create a Network.
   * @member {object} [properties] The Network Properties.
   * @member {string} [properties.fabricType] The Fabric Type.
   * @member {array} [properties.subnets] The List of subnets.
   * @member {string} [properties.friendlyName] The Friendly Name.
   * @member {string} [properties.networkType] The Network Type.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of Network
   *
   * @returns {object} metadata of Network
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Network',
      type: {
        name: 'Composite',
        className: 'Network',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'NetworkProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = Network;
