/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * List of network mappings. As with NetworkMapping, it should be possible to
 * reuse a prev version of this class. It doesn't seem likely this class could
 * be anything more than a slightly bespoke collection of NetworkMapping. Hence
 * it makes sense to override Load with Base.NetworkMapping instead of existing
 * CurrentVersion.NetworkMapping.
 */
class NetworkMappingCollection extends Array {
  /**
   * Create a NetworkMappingCollection.
   * @member {string} [nextLink] The value of next link.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of NetworkMappingCollection
   *
   * @returns {object} metadata of NetworkMappingCollection
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NetworkMappingCollection',
      type: {
        name: 'Composite',
        className: 'NetworkMappingCollection',
        modelProperties: {
          value: {
            required: false,
            serializedName: '',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'NetworkMappingElementType',
                  type: {
                    name: 'Composite',
                    className: 'NetworkMapping'
                  }
              }
            }
          },
          nextLink: {
            required: false,
            serializedName: 'nextLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = NetworkMappingCollection;
