/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Network Properties
 *
 */
class NetworkProperties {
  /**
   * Create a NetworkProperties.
   * @member {string} [fabricType] The Fabric Type.
   * @member {array} [subnets] The List of subnets.
   * @member {string} [friendlyName] The Friendly Name.
   * @member {string} [networkType] The Network Type.
   */
  constructor() {
  }

  /**
   * Defines the metadata of NetworkProperties
   *
   * @returns {object} metadata of NetworkProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NetworkProperties',
      type: {
        name: 'Composite',
        className: 'NetworkProperties',
        modelProperties: {
          fabricType: {
            required: false,
            serializedName: 'fabricType',
            type: {
              name: 'String'
            }
          },
          subnets: {
            required: false,
            serializedName: 'subnets',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'SubnetElementType',
                  type: {
                    name: 'Composite',
                    className: 'Subnet'
                  }
              }
            }
          },
          friendlyName: {
            required: false,
            serializedName: 'friendlyName',
            type: {
              name: 'String'
            }
          },
          networkType: {
            required: false,
            serializedName: 'networkType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = NetworkProperties;
