/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Disk Details.
 *
 */
class OSDetails {
  /**
   * Create a OSDetails.
   * @member {string} [osType] VM Disk details.
   * @member {string} [productType] Product type.
   * @member {string} [osEdition] The OSEdition.
   * @member {string} [oSVersion] The OS Version.
   * @member {string} [oSMajorVersion] The OS Major Version.
   * @member {string} [oSMinorVersion] The OS Minor Version.
   */
  constructor() {
  }

  /**
   * Defines the metadata of OSDetails
   *
   * @returns {object} metadata of OSDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OSDetails',
      type: {
        name: 'Composite',
        className: 'OSDetails',
        modelProperties: {
          osType: {
            required: false,
            serializedName: 'osType',
            type: {
              name: 'String'
            }
          },
          productType: {
            required: false,
            serializedName: 'productType',
            type: {
              name: 'String'
            }
          },
          osEdition: {
            required: false,
            serializedName: 'osEdition',
            type: {
              name: 'String'
            }
          },
          oSVersion: {
            required: false,
            serializedName: 'oSVersion',
            type: {
              name: 'String'
            }
          },
          oSMajorVersion: {
            required: false,
            serializedName: 'oSMajorVersion',
            type: {
              name: 'String'
            }
          },
          oSMinorVersion: {
            required: false,
            serializedName: 'oSMinorVersion',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = OSDetails;
