/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Protection profile details.
 *
 * @extends models['Resource']
 */
class Policy extends models['Resource'] {
  /**
   * Create a Policy.
   * @member {object} [properties] The custom data.
   * @member {string} [properties.friendlyName] The FriendlyName.
   * @member {object} [properties.providerSpecificDetails] The
   * ReplicationChannelSetting.
   * @member {string} [properties.providerSpecificDetails.instanceType]
   * Polymorphic Discriminator
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of Policy
   *
   * @returns {object} metadata of Policy
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Policy',
      type: {
        name: 'Composite',
        className: 'Policy',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'PolicyProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = Policy;
