/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Replication protected item
 *
 * @extends models['Resource']
 */
class ProtectableItem extends models['Resource'] {
  /**
   * Create a ProtectableItem.
   * @member {object} [properties] The custom data.
   * @member {string} [properties.friendlyName] The name.
   * @member {string} [properties.protectionStatus] The protection status.
   * @member {string} [properties.replicationProtectedItemId] The ARM resource
   * of protected items.
   * @member {string} [properties.recoveryServicesProviderId] The recovery
   * provider ARM Id.
   * @member {array} [properties.protectionReadinessErrors] The Current
   * protection readiness errors.
   * @member {array} [properties.supportedReplicationProviders] The list of
   * replication providers supported for the protectable item.
   * @member {object} [properties.customDetails] The Replication provider
   * custom settings.
   * @member {string} [properties.customDetails.instanceType] Polymorphic
   * Discriminator
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ProtectableItem
   *
   * @returns {object} metadata of ProtectableItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ProtectableItem',
      type: {
        name: 'Composite',
        className: 'ProtectableItem',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'ProtectableItemProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = ProtectableItem;
