/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Recovery plan InMageAzureV2 failover input.
 *
 * @extends models['RecoveryPlanProviderSpecificFailoverInput']
 */
class RecoveryPlanInMageAzureV2FailoverInput extends models['RecoveryPlanProviderSpecificFailoverInput'] {
  /**
   * Create a RecoveryPlanInMageAzureV2FailoverInput.
   * @member {string} vaultLocation The vault location.
   * @member {string} recoveryPointType The recovery point type. Possible
   * values include: 'Latest', 'LatestApplicationConsistent',
   * 'LatestCrashConsistent', 'LatestProcessed'
   * @member {string} [useMultiVmSyncPoint] A value indicating whether multi VM
   * sync enabled VMs should use multi VM sync points for failover.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of RecoveryPlanInMageAzureV2FailoverInput
   *
   * @returns {object} metadata of RecoveryPlanInMageAzureV2FailoverInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'InMageAzureV2',
      type: {
        name: 'Composite',
        className: 'RecoveryPlanInMageAzureV2FailoverInput',
        modelProperties: {
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            type: {
              name: 'String'
            }
          },
          vaultLocation: {
            required: true,
            serializedName: 'vaultLocation',
            type: {
              name: 'String'
            }
          },
          recoveryPointType: {
            required: true,
            serializedName: 'recoveryPointType',
            type: {
              name: 'Enum',
              allowedValues: [ 'Latest', 'LatestApplicationConsistent', 'LatestCrashConsistent', 'LatestProcessed' ]
            }
          },
          useMultiVmSyncPoint: {
            required: false,
            serializedName: 'useMultiVmSyncPoint',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = RecoveryPlanInMageAzureV2FailoverInput;
