/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Recovery plan manual action details.
 *
 * @extends models['RecoveryPlanActionDetails']
 */
class RecoveryPlanManualActionDetails extends models['RecoveryPlanActionDetails'] {
  /**
   * Create a RecoveryPlanManualActionDetails.
   * @member {string} [description] The manual action description.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of RecoveryPlanManualActionDetails
   *
   * @returns {object} metadata of RecoveryPlanManualActionDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ManualActionDetails',
      type: {
        name: 'Composite',
        className: 'RecoveryPlanManualActionDetails',
        modelProperties: {
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = RecoveryPlanManualActionDetails;
