/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Recovery plan test failover input.
 *
 */
class RecoveryPlanTestFailoverInput {
  /**
   * Create a RecoveryPlanTestFailoverInput.
   * @member {object} properties The recovery plan test failover input
   * properties.
   * @member {string} [properties.failoverDirection] The failover direction.
   * Possible values include: 'PrimaryToRecovery', 'RecoveryToPrimary'
   * @member {string} [properties.networkType] The network type to be used for
   * test failover.
   * @member {string} [properties.networkId] The Id of the network to be used
   * for test failover.
   * @member {string} [properties.skipTestFailoverCleanup] A value indicating
   * whether the test failover cleanup is to be skipped.
   * @member {array} [properties.providerSpecificDetails] The provider specific
   * properties.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RecoveryPlanTestFailoverInput
   *
   * @returns {object} metadata of RecoveryPlanTestFailoverInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RecoveryPlanTestFailoverInput',
      type: {
        name: 'Composite',
        className: 'RecoveryPlanTestFailoverInput',
        modelProperties: {
          properties: {
            required: true,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'RecoveryPlanTestFailoverInputProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = RecoveryPlanTestFailoverInput;
