/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Recovery plan unplanned failover input.
 *
 */
class RecoveryPlanUnplannedFailoverInput {
  /**
   * Create a RecoveryPlanUnplannedFailoverInput.
   * @member {object} properties The recovery plan unplanned failover input
   * properties.
   * @member {string} [properties.failoverDirection] The failover direction.
   * Possible values include: 'PrimaryToRecovery', 'RecoveryToPrimary'
   * @member {string} [properties.sourceSiteOperations] A value indicating
   * whether source site operations are required. Possible values include:
   * 'Required', 'NotRequired'
   * @member {array} [properties.providerSpecificDetails] The provider specific
   * properties.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RecoveryPlanUnplannedFailoverInput
   *
   * @returns {object} metadata of RecoveryPlanUnplannedFailoverInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RecoveryPlanUnplannedFailoverInput',
      type: {
        name: 'Composite',
        className: 'RecoveryPlanUnplannedFailoverInput',
        modelProperties: {
          properties: {
            required: true,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'RecoveryPlanUnplannedFailoverInputProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = RecoveryPlanUnplannedFailoverInput;
