/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Recovery plan unplanned failover input properties.
 *
 */
class RecoveryPlanUnplannedFailoverInputProperties {
  /**
   * Create a RecoveryPlanUnplannedFailoverInputProperties.
   * @member {string} failoverDirection The failover direction. Possible values
   * include: 'PrimaryToRecovery', 'RecoveryToPrimary'
   * @member {string} sourceSiteOperations A value indicating whether source
   * site operations are required. Possible values include: 'Required',
   * 'NotRequired'
   * @member {array} [providerSpecificDetails] The provider specific
   * properties.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RecoveryPlanUnplannedFailoverInputProperties
   *
   * @returns {object} metadata of RecoveryPlanUnplannedFailoverInputProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RecoveryPlanUnplannedFailoverInputProperties',
      type: {
        name: 'Composite',
        className: 'RecoveryPlanUnplannedFailoverInputProperties',
        modelProperties: {
          failoverDirection: {
            required: true,
            serializedName: 'failoverDirection',
            type: {
              name: 'Enum',
              allowedValues: [ 'PrimaryToRecovery', 'RecoveryToPrimary' ]
            }
          },
          sourceSiteOperations: {
            required: true,
            serializedName: 'sourceSiteOperations',
            type: {
              name: 'Enum',
              allowedValues: [ 'Required', 'NotRequired' ]
            }
          },
          providerSpecificDetails: {
            required: false,
            serializedName: 'providerSpecificDetails',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'RecoveryPlanProviderSpecificFailoverInputElementType',
                  type: {
                    name: 'Composite',
                    polymorphicDiscriminator: {
                      serializedName: 'instanceType',
                      clientName: 'instanceType'
                    },
                    uberParent: 'RecoveryPlanProviderSpecificFailoverInput',
                    className: 'RecoveryPlanProviderSpecificFailoverInput'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = RecoveryPlanUnplannedFailoverInputProperties;
