/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Reverse replication input.
 *
 */
class ReverseReplicationInput {
  /**
   * Create a ReverseReplicationInput.
   * @member {object} [properties] Reverse replication properties
   * @member {string} [properties.failoverDirection] Failover direction.
   * @member {object} [properties.providerSpecificDetails] Provider specific
   * reverse replication input.
   * @member {string} [properties.providerSpecificDetails.instanceType]
   * Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of ReverseReplicationInput
   *
   * @returns {object} metadata of ReverseReplicationInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ReverseReplicationInput',
      type: {
        name: 'Composite',
        className: 'ReverseReplicationInput',
        modelProperties: {
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'ReverseReplicationInputProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = ReverseReplicationInput;
