/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * This class represents the script action task details.
 *
 * @extends models['TaskTypeDetails']
 */
class ScriptActionTaskDetails extends models['TaskTypeDetails'] {
  /**
   * Create a ScriptActionTaskDetails.
   * @member {string} [name] The name.
   * @member {string} [path] The path.
   * @member {string} [output] The output.
   * @member {boolean} [isPrimarySideScript] A value indicating whether it is a
   * primary side script or not.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ScriptActionTaskDetails
   *
   * @returns {object} metadata of ScriptActionTaskDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ScriptActionTaskDetails',
      type: {
        name: 'Composite',
        className: 'ScriptActionTaskDetails',
        modelProperties: {
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          path: {
            required: false,
            serializedName: 'path',
            type: {
              name: 'String'
            }
          },
          output: {
            required: false,
            serializedName: 'output',
            type: {
              name: 'String'
            }
          },
          isPrimarySideScript: {
            required: false,
            serializedName: 'isPrimarySideScript',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = ScriptActionTaskDetails;
