/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Storage object definition.
 *
 * @extends models['Resource']
 */
class StorageClassification extends models['Resource'] {
  /**
   * Create a StorageClassification.
   * @member {object} [properties] Proprties of the storage object.
   * @member {string} [properties.friendlyName] Friendly name of the Storage
   * classification.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of StorageClassification
   *
   * @returns {object} metadata of StorageClassification
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'StorageClassification',
      type: {
        name: 'Composite',
        className: 'StorageClassification',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'StorageClassificationProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = StorageClassification;
