/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Subnets of the network.
 *
 */
class Subnet {
  /**
   * Create a Subnet.
   * @member {string} [name] The subnet name.
   * @member {string} [friendlyName] The subnet friendly name.
   * @member {array} [addressList] The list of addresses for the subnet.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Subnet
   *
   * @returns {object} metadata of Subnet
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Subnet',
      type: {
        name: 'Composite',
        className: 'Subnet',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          friendlyName: {
            required: false,
            serializedName: 'friendlyName',
            type: {
              name: 'String'
            }
          },
          addressList: {
            required: false,
            serializedName: 'addressList',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = Subnet;
