/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Update network mapping input.
 *
 */
class UpdateNetworkMappingInput {
  /**
   * Create a UpdateNetworkMappingInput.
   * @member {object} [properties] The input properties needed to update
   * network mapping.
   * @member {string} [properties.recoveryFabricName] Recovery fabric name.
   * @member {string} [properties.recoveryNetworkId] Recovery network Id.
   * @member {object} [properties.fabricSpecificDetails] Fabrics specific input
   * network Id.
   * @member {string} [properties.fabricSpecificDetails.instanceType]
   * Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of UpdateNetworkMappingInput
   *
   * @returns {object} metadata of UpdateNetworkMappingInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UpdateNetworkMappingInput',
      type: {
        name: 'Composite',
        className: 'UpdateNetworkMappingInput',
        modelProperties: {
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'UpdateNetworkMappingInputProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = UpdateNetworkMappingInput;
