/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Common input details for network mapping operation.
 *
 */
class UpdateNetworkMappingInputProperties {
  /**
   * Create a UpdateNetworkMappingInputProperties.
   * @member {string} [recoveryFabricName] Recovery fabric name.
   * @member {string} [recoveryNetworkId] Recovery network Id.
   * @member {object} [fabricSpecificDetails] Fabrics specific input network
   * Id.
   * @member {string} [fabricSpecificDetails.instanceType] Polymorphic
   * Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of UpdateNetworkMappingInputProperties
   *
   * @returns {object} metadata of UpdateNetworkMappingInputProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UpdateNetworkMappingInputProperties',
      type: {
        name: 'Composite',
        className: 'UpdateNetworkMappingInputProperties',
        modelProperties: {
          recoveryFabricName: {
            required: false,
            serializedName: 'recoveryFabricName',
            type: {
              name: 'String'
            }
          },
          recoveryNetworkId: {
            required: false,
            serializedName: 'recoveryNetworkId',
            type: {
              name: 'String'
            }
          },
          fabricSpecificDetails: {
            required: false,
            serializedName: 'fabricSpecificDetails',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'instanceType',
                clientName: 'instanceType'
              },
              uberParent: 'FabricSpecificUpdateNetworkMappingInput',
              className: 'FabricSpecificUpdateNetworkMappingInput'
            }
          }
        }
      }
    };
  }
}

module.exports = UpdateNetworkMappingInputProperties;
