/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Input required to update vCenter.
 *
 */
class UpdateVCenterRequest {
  /**
   * Create a UpdateVCenterRequest.
   * @member {object} [properties] The update VCenter Request Properties.
   * @member {string} [properties.friendlyName] The friendly name of the
   * vCenter.
   * @member {string} [properties.ipAddress] The IP address of the vCenter to
   * be discovered.
   * @member {string} [properties.processServerId] The process server Id from
   * where the update can be orchestrated.
   * @member {string} [properties.port] The port number for discovery.
   * @member {string} [properties.runAsAccountId] The CS account Id which has
   * priviliges to update the vCenter.
   */
  constructor() {
  }

  /**
   * Defines the metadata of UpdateVCenterRequest
   *
   * @returns {object} metadata of UpdateVCenterRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UpdateVCenterRequest',
      type: {
        name: 'Composite',
        className: 'UpdateVCenterRequest',
        modelProperties: {
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'UpdateVCenterRequestProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = UpdateVCenterRequest;
