/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Specifies which Redis node(s) to reboot.
 *
 */
class RedisRebootParameters {
  /**
   * Create a RedisRebootParameters.
   * @member {string} rebootType Which Redis node(s) to reboot. Depending on
   * this value data loss is possible. Possible values include: 'PrimaryNode',
   * 'SecondaryNode', 'AllNodes'
   * @member {number} [shardId] If clustering is enabled, the ID of the shard
   * to be rebooted.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RedisRebootParameters
   *
   * @returns {object} metadata of RedisRebootParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RedisRebootParameters',
      type: {
        name: 'Composite',
        className: 'RedisRebootParameters',
        modelProperties: {
          rebootType: {
            required: true,
            serializedName: 'rebootType',
            type: {
              name: 'String'
            }
          },
          shardId: {
            required: false,
            serializedName: 'shardId',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = RedisRebootParameters;
