/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The response of the list WCF relay operation.
 */
class WcfRelaysListResult extends Array {
  /**
   * Create a WcfRelaysListResult.
   * @member {string} [nextLink] Link to the next set of results. Not empty if
   * value contains incomplete list of WCF relays.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of WcfRelaysListResult
   *
   * @returns {object} metadata of WcfRelaysListResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'WcfRelaysListResult',
      type: {
        name: 'Composite',
        className: 'WcfRelaysListResult',
        modelProperties: {
          value: {
            required: false,
            serializedName: '',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'WcfRelayElementType',
                  type: {
                    name: 'Composite',
                    className: 'WcfRelay'
                  }
              }
            }
          },
          nextLink: {
            required: false,
            serializedName: 'nextLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = WcfRelaysListResult;
