/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

import { BaseResource } from 'ms-rest-azure';
import { CloudError } from 'ms-rest-azure';
import * as moment from 'moment';

export { BaseResource } from 'ms-rest-azure';
export { CloudError } from 'ms-rest-azure';


/**
 * @class
 * Initializes a new instance of the ResourceLinkFilter class.
 * @constructor
 * Resource link filter.
 *
 * @member {string} targetId The ID of the target resource.
 */
export interface ResourceLinkFilter {
  targetId: string;
}

/**
 * @class
 * Initializes a new instance of the ResourceLinkProperties class.
 * @constructor
 * The resource link properties.
 *
 * @member {string} [sourceId] The fully qualified ID of the source resource in
 * the link.
 * @member {string} targetId The fully qualified ID of the target resource in
 * the link.
 * @member {string} [notes] Notes about the resource link.
 */
export interface ResourceLinkProperties {
  readonly sourceId?: string;
  targetId: string;
  notes?: string;
}

/**
 * @class
 * Initializes a new instance of the ResourceLink class.
 * @constructor
 * The resource link.
 *
 * @member {string} [id] The fully qualified ID of the resource link.
 * @member {string} [name] The name of the resource link.
 * @member {object} [properties] Properties for resource link.
 * @member {string} [properties.sourceId] The fully qualified ID of the source
 * resource in the link.
 * @member {string} [properties.targetId] The fully qualified ID of the target
 * resource in the link.
 * @member {string} [properties.notes] Notes about the resource link.
 */
export interface ResourceLink {
  readonly id?: string;
  readonly name?: string;
  properties?: ResourceLinkProperties;
}


/**
 * @class
 * Initializes a new instance of the ResourceLinkResult class.
 * @constructor
 * List of resource links.
 *
 * @member {string} [nextLink] The URL to use for getting the next set of
 * results.
 */
export interface ResourceLinkResult extends Array<ResourceLink> {
  readonly nextLink?: string;
}
