/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The resource link properties.
 *
 */
class ResourceLinkProperties {
  /**
   * Create a ResourceLinkProperties.
   * @member {string} [sourceId] The fully qualified ID of the source resource
   * in the link.
   * @member {string} targetId The fully qualified ID of the target resource in
   * the link.
   * @member {string} [notes] Notes about the resource link.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResourceLinkProperties
   *
   * @returns {object} metadata of ResourceLinkProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceLinkProperties',
      type: {
        name: 'Composite',
        className: 'ResourceLinkProperties',
        modelProperties: {
          sourceId: {
            required: false,
            readOnly: true,
            serializedName: 'sourceId',
            type: {
              name: 'String'
            }
          },
          targetId: {
            required: true,
            serializedName: 'targetId',
            type: {
              name: 'String'
            }
          },
          notes: {
            required: false,
            serializedName: 'notes',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceLinkProperties;
