/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The error object.
 *
 */
class ErrorResponse {
  /**
   * Create a ErrorResponse.
   * @member {object} [error] Error.
   * @member {string} [error.code] One of a server-defined set of error codes.
   * @member {string} [error.message] A human-readable representation of the
   * error.
   * @member {string} [error.target] (Optional) The target of the error.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ErrorResponse
   *
   * @returns {object} metadata of ErrorResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ErrorResponse',
      type: {
        name: 'Composite',
        className: 'ErrorResponse',
        modelProperties: {
          error: {
            required: false,
            serializedName: 'error',
            type: {
              name: 'Composite',
              className: 'ErrorDetails'
            }
          }
        }
      }
    };
  }
}

module.exports = ErrorResponse;
