/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The unique identifier (ID) of a management group.
 *
 */
class ManagementGroupChildInfo {
  /**
   * Create a ManagementGroupChildInfo.
   * @member {string} [childType] Managment Group Child Info. Possible values
   * include: 'Enrollment', 'Department', 'Account', 'Subscription'
   * @member {string} [childId] The ID of the child resource (management group
   * or subscription). E.g.
   * /providers/Microsoft.Management/managementGroups/40000000-0000-0000-0000-000000000000
   * @member {string} [displayName] The friendly name of the child resource.
   * @member {uuid} [tenantId] (Optional) The AAD Tenant ID associated with the
   * child resource.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ManagementGroupChildInfo
   *
   * @returns {object} metadata of ManagementGroupChildInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ManagementGroupChildInfo',
      type: {
        name: 'Composite',
        className: 'ManagementGroupChildInfo',
        modelProperties: {
          childType: {
            required: false,
            serializedName: 'childType',
            type: {
              name: 'String'
            }
          },
          childId: {
            required: false,
            serializedName: 'childId',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            serializedName: 'displayName',
            type: {
              name: 'String'
            }
          },
          tenantId: {
            required: false,
            serializedName: 'tenantId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ManagementGroupChildInfo;
