/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The management group.
 *
 */
class ManagementGroupInfo {
  /**
   * Create a ManagementGroupInfo.
   * @member {string} [id] The ID of the management group. E.g.
   * /providers/Microsoft.Management/managementGroups/20000000-0000-0000-0000-000000000000
   * @member {string} [type] The type of the resource. E.g.
   * /providers/Microsoft.Management/managementGroups
   * @member {uuid} [name] The name of the management group. E.g.
   * 20000000-0000-0000-0000-000000000000
   * @member {uuid} [tenantId] The AAD Tenant ID associated with the management
   * group. E.g. 10000000-0000-0000-0000-000000000000
   * @member {string} [displayName] The friendly name of the management group.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ManagementGroupInfo
   *
   * @returns {object} metadata of ManagementGroupInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ManagementGroupInfo',
      type: {
        name: 'Composite',
        className: 'ManagementGroupInfo',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          tenantId: {
            required: false,
            serializedName: 'properties.tenantId',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            serializedName: 'properties.displayName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ManagementGroupInfo;
