/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * (Optional) The ID of the parent management group.
 *
 */
class ParentGroupInfo {
  /**
   * Create a ParentGroupInfo.
   * @member {string} [parentId] The ID of the parent management group. E.g.
   * /providers/Microsoft.Management/managementGroups/30000000-0000-0000-0000-000000000000
   * @member {string} [displayName] The friendly name of the management group.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ParentGroupInfo
   *
   * @returns {object} metadata of ParentGroupInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ParentGroupInfo',
      type: {
        name: 'Composite',
        className: 'ParentGroupInfo',
        modelProperties: {
          parentId: {
            required: false,
            serializedName: 'parentId',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            serializedName: 'displayName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ParentGroupInfo;
