/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a HttpAuthentication.
 */
class HttpAuthentication {
  /**
   * Create a HttpAuthentication.
   * @member {string} [type] Gets or sets the HTTP authentication type.
   * Possible values include: 'NotSpecified', 'ClientCertificate',
   * 'ActiveDirectoryOAuth', 'Basic'
   */
  constructor() {
  }

  /**
   * Defines the metadata of HttpAuthentication
   *
   * @returns {object} metadata of HttpAuthentication
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HttpAuthentication',
      type: {
        name: 'Composite',
        className: 'HttpAuthentication',
        modelProperties: {
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'Enum',
              allowedValues: [ 'NotSpecified', 'ClientCertificate', 'ActiveDirectoryOAuth', 'Basic' ]
            }
          }
        }
      }
    };
  }
}

module.exports = HttpAuthentication;
