/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Class representing a HttpRequest.
 */
class HttpRequest {
  /**
   * Create a HttpRequest.
   * @member {object} [authentication] Gets or sets the authentication method
   * of the request.
   * @member {string} [authentication.type] Gets or sets the HTTP
   * authentication type. Possible values include: 'NotSpecified',
   * 'ClientCertificate', 'ActiveDirectoryOAuth', 'Basic'
   * @member {string} [uri] Gets or sets the URI of the request.
   * @member {string} [method] Gets or sets the method of the request.
   * @member {string} [body] Gets or sets the request body.
   * @member {object} [headers] Gets or sets the headers.
   */
  constructor() {
  }

  /**
   * Defines the metadata of HttpRequest
   *
   * @returns {object} metadata of HttpRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HttpRequest',
      type: {
        name: 'Composite',
        className: 'HttpRequest',
        modelProperties: {
          authentication: {
            required: false,
            serializedName: 'authentication',
            type: {
              name: 'Composite',
              className: 'HttpAuthentication'
            }
          },
          uri: {
            required: false,
            serializedName: 'uri',
            type: {
              name: 'String'
            }
          },
          method: {
            required: false,
            serializedName: 'method',
            type: {
              name: 'String'
            }
          },
          body: {
            required: false,
            serializedName: 'body',
            type: {
              name: 'String'
            }
          },
          headers: {
            required: false,
            serializedName: 'headers',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = HttpRequest;
