/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Response containing the status of operations for all documents in the
 * indexing request.
 *
 */
class DocumentIndexResult {
  /**
   * Create a DocumentIndexResult.
   * @member {array} [results] The list of status information for each document
   * in the indexing request.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DocumentIndexResult
   *
   * @returns {object} metadata of DocumentIndexResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DocumentIndexResult',
      type: {
        name: 'Composite',
        className: 'DocumentIndexResult',
        modelProperties: {
          results: {
            required: false,
            readOnly: true,
            serializedName: 'value',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'IndexingResultElementType',
                  type: {
                    name: 'Composite',
                    className: 'IndexingResult'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = DocumentIndexResult;
