/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
*/

import { ServiceClientOptions, RequestOptions, ServiceCallback, HttpOperationResponse } from 'ms-rest';
import * as models from '../models';


/**
 * @class
 * DocumentsProxy
 * __NOTE__: An instance of this class is automatically created for an
 * instance of the SearchIndexClient.
 */
export interface DocumentsProxy {


    /**
     * Queries the number of documents in the Azure Search index.
     *
     * @param {object} [options] Optional Parameters.
     *
     * @param {object} [options.searchRequestOptions] Additional parameters for the
     * operation
     *
     * @param {uuid} [options.searchRequestOptions.clientRequestId] The tracking ID
     * sent with the request to help with debugging.
     *
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     *
     * @returns {Promise} A promise is returned
     *
     * @resolve {HttpOperationResponse<Number>} - The deserialized result object.
     *
     * @reject {Error|ServiceError} - The error object.
     */
    countWithHttpOperationResponse(options?: { searchRequestOptions? : models.SearchRequestOptions, customHeaders? : { [headerName: string]: string; } }): Promise<HttpOperationResponse<number>>;

    /**
     * Queries the number of documents in the Azure Search index.
     *
     * @param {object} [options] Optional Parameters.
     *
     * @param {object} [options.searchRequestOptions] Additional parameters for the
     * operation
     *
     * @param {uuid} [options.searchRequestOptions.clientRequestId] The tracking ID
     * sent with the request to help with debugging.
     *
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     *
     * @param {ServiceCallback} [optionalCallback] - The optional callback.
     *
     * @returns {ServiceCallback|Promise} If a callback was passed as the last
     * parameter then it returns the callback else returns a Promise.
     *
     * {Promise} A promise is returned.
     *
     *                      @resolve {Number} - The deserialized result object.
     *
     *                      @reject {Error|ServiceError} - The error object.
     *
     * {ServiceCallback} optionalCallback(err, result, request, response)
     *
     *                      {Error|ServiceError}  err        - The Error object if an error occurred, null otherwise.
     *
     *                      {Number} [result]   - The deserialized result object if an error did not occur.
     *
     *                      {WebResource} [request]  - The HTTP Request object if an error did not occur.
     *
     *                      {http.IncomingMessage} [response] - The HTTP Response stream if an error did not occur.
     */
    count(options?: { searchRequestOptions? : models.SearchRequestOptions, customHeaders? : { [headerName: string]: string; } }): Promise<number>;
    count(callback: ServiceCallback<number>): void;
    count(options: { searchRequestOptions? : models.SearchRequestOptions, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<number>): void;
}
