/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Additional parameters for a set of operations.
 *
 */
class AccessCondition {
  /**
   * Create a AccessCondition.
   * @member {string} [ifMatch] Defines the If-Match condition. The operation
   * will be performed only if the ETag on the server matches this value.
   * @member {string} [ifNoneMatch] Defines the If-None-Match condition. The
   * operation will be performed only if the ETag on the server does not match
   * this value.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AccessCondition
   *
   * @returns {object} metadata of AccessCondition
   *
   */
  mapper() {
    return {
      required: false,
      type: {
        name: 'Composite',
        className: 'AccessCondition',
        modelProperties: {
          ifMatch: {
            required: false,
            type: {
              name: 'String'
            }
          },
          ifNoneMatch: {
            required: false,
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AccessCondition;
