/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The result of testing an analyzer on text.
 *
 */
class AnalyzeResult {
  /**
   * Create a AnalyzeResult.
   * @member {array} [tokens] The list of tokens returned by the analyzer
   * specified in the request.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AnalyzeResult
   *
   * @returns {object} metadata of AnalyzeResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AnalyzeResult',
      type: {
        name: 'Composite',
        className: 'AnalyzeResult',
        modelProperties: {
          tokens: {
            required: false,
            serializedName: 'tokens',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'TokenInfoElementType',
                  type: {
                    name: 'Composite',
                    className: 'TokenInfo'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = AnalyzeResult;
