/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Converts alphabetic, numeric, and symbolic Unicode characters which are not
 * in the first 127 ASCII characters (the "Basic Latin" Unicode block) into
 * their ASCII equivalents, if such equivalents exist. This token filter is
 * implemented using Apache Lucene.
 *
 * @extends models['TokenFilter']
 */
class AsciiFoldingTokenFilter extends models['TokenFilter'] {
  /**
   * Create a AsciiFoldingTokenFilter.
   * @member {boolean} [preserveOriginal] A value indicating whether the
   * original token will be kept. Default is false. Default value: false .
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AsciiFoldingTokenFilter
   *
   * @returns {object} metadata of AsciiFoldingTokenFilter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: '#Microsoft.Azure.Search.AsciiFoldingTokenFilter',
      type: {
        name: 'Composite',
        className: 'AsciiFoldingTokenFilter',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          odatatype: {
            required: true,
            serializedName: '@odata\\.type',
            type: {
              name: 'String'
            }
          },
          preserveOriginal: {
            required: false,
            serializedName: 'preserveOriginal',
            defaultValue: false,
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = AsciiFoldingTokenFilter;
