/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Defines options to control Cross-Origin Resource Sharing (CORS) for an
 * index.
 *
 */
class CorsOptions {
  /**
   * Create a CorsOptions.
   * @member {array} allowedOrigins The list of origins from which JavaScript
   * code will be granted access to your index. Can contain a list of hosts of
   * the form {protocol}://{fully-qualified-domain-name}[:{port#}], or a single
   * '*' to allow all origins (not recommended).
   * @member {number} [maxAgeInSeconds] The duration for which browsers should
   * cache CORS preflight responses. Defaults to 5 mintues.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CorsOptions
   *
   * @returns {object} metadata of CorsOptions
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CorsOptions',
      type: {
        name: 'Composite',
        className: 'CorsOptions',
        modelProperties: {
          allowedOrigins: {
            required: true,
            serializedName: 'allowedOrigins',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          maxAgeInSeconds: {
            required: false,
            serializedName: 'maxAgeInSeconds',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = CorsOptions;
