/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents information about the entity (such as Azure SQL table or
 * DocumentDb collection) that will be indexed.
 *
 */
class DataContainer {
  /**
   * Create a DataContainer.
   * @member {string} name The name of the table or view (for Azure SQL data
   * source) or collection (for DocumentDB data source) that will be indexed.
   * @member {string} [query] A query that is applied to this data container.
   * The syntax and meaning of this parameter is datasource-specific. Not
   * supported by Azure SQL datasources.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DataContainer
   *
   * @returns {object} metadata of DataContainer
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DataContainer',
      type: {
        name: 'Composite',
        className: 'DataContainer',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          query: {
            required: false,
            serializedName: 'query',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DataContainer;
