/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Response from a List Datasources request. If successful, it includes the
 * full definitions of all datasources.
 *
 */
class DataSourceListResult {
  /**
   * Create a DataSourceListResult.
   * @member {array} [dataSources] The datasources in the Search service.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DataSourceListResult
   *
   * @returns {object} metadata of DataSourceListResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DataSourceListResult',
      type: {
        name: 'Composite',
        className: 'DataSourceListResult',
        modelProperties: {
          dataSources: {
            required: false,
            readOnly: true,
            serializedName: 'value',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'DataSourceElementType',
                  type: {
                    name: 'Composite',
                    className: 'DataSource'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = DataSourceListResult;
