/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Defines a function that boosts scores based on distance from a geographic
 * location.
 *
 * @extends models['ScoringFunction']
 */
class DistanceScoringFunction extends models['ScoringFunction'] {
  /**
   * Create a DistanceScoringFunction.
   * @member {object} parameters Parameter values for the distance scoring
   * function.
   * @member {string} [parameters.referencePointParameter] The name of the
   * parameter passed in search queries to specify the reference location.
   * @member {number} [parameters.boostingDistance] The distance in kilometers
   * from the reference location where the boosting range ends.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of DistanceScoringFunction
   *
   * @returns {object} metadata of DistanceScoringFunction
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'distance',
      type: {
        name: 'Composite',
        className: 'DistanceScoringFunction',
        modelProperties: {
          fieldName: {
            required: true,
            serializedName: 'fieldName',
            type: {
              name: 'String'
            }
          },
          boost: {
            required: true,
            serializedName: 'boost',
            type: {
              name: 'Number'
            }
          },
          interpolation: {
            required: false,
            serializedName: 'interpolation',
            type: {
              name: 'Enum',
              allowedValues: [ 'linear', 'constant', 'quadratic', 'logarithmic' ]
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          parameters: {
            required: true,
            serializedName: 'distance',
            type: {
              name: 'Composite',
              className: 'DistanceScoringParameters'
            }
          }
        }
      }
    };
  }
}

module.exports = DistanceScoringFunction;
