/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Provides parameter values to a distance scoring function.
 *
 */
class DistanceScoringParameters {
  /**
   * Create a DistanceScoringParameters.
   * @member {string} referencePointParameter The name of the parameter passed
   * in search queries to specify the reference location.
   * @member {number} boostingDistance The distance in kilometers from the
   * reference location where the boosting range ends.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DistanceScoringParameters
   *
   * @returns {object} metadata of DistanceScoringParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DistanceScoringParameters',
      type: {
        name: 'Composite',
        className: 'DistanceScoringParameters',
        modelProperties: {
          referencePointParameter: {
            required: true,
            serializedName: 'referencePointParameter',
            type: {
              name: 'String'
            }
          },
          boostingDistance: {
            required: true,
            serializedName: 'boostingDistance',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = DistanceScoringParameters;
