/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Removes elisions. For example, "l'avion" (the plane) will be converted to
 * "avion" (plane). This token filter is implemented using Apache Lucene.
 *
 * @extends models['TokenFilter']
 */
class ElisionTokenFilter extends models['TokenFilter'] {
  /**
   * Create a ElisionTokenFilter.
   * @member {array} [articles] The set of articles to remove.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ElisionTokenFilter
   *
   * @returns {object} metadata of ElisionTokenFilter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: '#Microsoft.Azure.Search.ElisionTokenFilter',
      type: {
        name: 'Composite',
        className: 'ElisionTokenFilter',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          odatatype: {
            required: true,
            serializedName: '@odata\\.type',
            type: {
              name: 'String'
            }
          },
          articles: {
            required: false,
            serializedName: 'articles',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ElisionTokenFilter;
