/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents a function that transforms a value from a data source before
 * indexing.
 *
 */
class FieldMappingFunction {
  /**
   * Create a FieldMappingFunction.
   * @member {string} name The name of the field mapping function.
   * @member {object} [parameters] A dictionary of parameter name/value pairs
   * to pass to the function. Each value must be of a primitive type.
   */
  constructor() {
  }

  /**
   * Defines the metadata of FieldMappingFunction
   *
   * @returns {object} metadata of FieldMappingFunction
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FieldMappingFunction',
      type: {
        name: 'Composite',
        className: 'FieldMappingFunction',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          parameters: {
            required: false,
            serializedName: 'parameters',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'ObjectElementType',
                  type: {
                    name: 'Object'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = FieldMappingFunction;
