/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Defines a function that boosts scores based on the value of a date-time
 * field.
 *
 * @extends models['ScoringFunction']
 */
class FreshnessScoringFunction extends models['ScoringFunction'] {
  /**
   * Create a FreshnessScoringFunction.
   * @member {object} parameters Parameter values for the freshness scoring
   * function.
   * @member {moment.duration} [parameters.boostingDuration] The expiration
   * period after which boosting will stop for a particular document.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of FreshnessScoringFunction
   *
   * @returns {object} metadata of FreshnessScoringFunction
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'freshness',
      type: {
        name: 'Composite',
        className: 'FreshnessScoringFunction',
        modelProperties: {
          fieldName: {
            required: true,
            serializedName: 'fieldName',
            type: {
              name: 'String'
            }
          },
          boost: {
            required: true,
            serializedName: 'boost',
            type: {
              name: 'Number'
            }
          },
          interpolation: {
            required: false,
            serializedName: 'interpolation',
            type: {
              name: 'Enum',
              allowedValues: [ 'linear', 'constant', 'quadratic', 'logarithmic' ]
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          parameters: {
            required: true,
            serializedName: 'freshness',
            type: {
              name: 'Composite',
              className: 'FreshnessScoringParameters'
            }
          }
        }
      }
    };
  }
}

module.exports = FreshnessScoringFunction;
