/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Provides parameter values to a freshness scoring function.
 *
 */
class FreshnessScoringParameters {
  /**
   * Create a FreshnessScoringParameters.
   * @member {moment.duration} boostingDuration The expiration period after
   * which boosting will stop for a particular document.
   */
  constructor() {
  }

  /**
   * Defines the metadata of FreshnessScoringParameters
   *
   * @returns {object} metadata of FreshnessScoringParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FreshnessScoringParameters',
      type: {
        name: 'Composite',
        className: 'FreshnessScoringParameters',
        modelProperties: {
          boostingDuration: {
            required: true,
            serializedName: 'boostingDuration',
            type: {
              name: 'TimeSpan'
            }
          }
        }
      }
    };
  }
}

module.exports = FreshnessScoringParameters;
