/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

var msRestAzure = require('ms-rest-azure');

exports.BaseResource = msRestAzure.BaseResource;
exports.CloudError = msRestAzure.CloudError;
exports.AnalyzeRequest = require('./analyzeRequest');
exports.TokenInfo = require('./tokenInfo');
exports.AnalyzeResult = require('./analyzeResult');
exports.Analyzer = require('./analyzer');
exports.CustomAnalyzer = require('./customAnalyzer');
exports.PatternAnalyzer = require('./patternAnalyzer');
exports.StandardAnalyzer = require('./standardAnalyzer');
exports.StopAnalyzer = require('./stopAnalyzer');
exports.Tokenizer = require('./tokenizer');
exports.ClassicTokenizer = require('./classicTokenizer');
exports.KeywordTokenizerV2 = require('./keywordTokenizerV2');
exports.MicrosoftLanguageTokenizer = require('./microsoftLanguageTokenizer');
exports.MicrosoftLanguageStemmingTokenizer = require('./microsoftLanguageStemmingTokenizer');
exports.PatternTokenizer = require('./patternTokenizer');
exports.StandardTokenizerV2 = require('./standardTokenizerV2');
exports.UaxUrlEmailTokenizer = require('./uaxUrlEmailTokenizer');
exports.TokenFilter = require('./tokenFilter');
exports.AsciiFoldingTokenFilter = require('./asciiFoldingTokenFilter');
exports.CommonGramTokenFilter = require('./commonGramTokenFilter');
exports.DictionaryDecompounderTokenFilter = require('./dictionaryDecompounderTokenFilter');
exports.EdgeNGramTokenFilterV2 = require('./edgeNGramTokenFilterV2');
exports.ElisionTokenFilter = require('./elisionTokenFilter');
exports.KeepTokenFilter = require('./keepTokenFilter');
exports.KeywordMarkerTokenFilter = require('./keywordMarkerTokenFilter');
exports.LengthTokenFilter = require('./lengthTokenFilter');
exports.LimitTokenFilter = require('./limitTokenFilter');
exports.NGramTokenFilterV2 = require('./nGramTokenFilterV2');
exports.PatternCaptureTokenFilter = require('./patternCaptureTokenFilter');
exports.PatternReplaceTokenFilter = require('./patternReplaceTokenFilter');
exports.PhoneticTokenFilter = require('./phoneticTokenFilter');
exports.ShingleTokenFilter = require('./shingleTokenFilter');
exports.SnowballTokenFilter = require('./snowballTokenFilter');
exports.StemmerTokenFilter = require('./stemmerTokenFilter');
exports.StemmerOverrideTokenFilter = require('./stemmerOverrideTokenFilter');
exports.StopwordsTokenFilter = require('./stopwordsTokenFilter');
exports.SynonymTokenFilter = require('./synonymTokenFilter');
exports.TruncateTokenFilter = require('./truncateTokenFilter');
exports.UniqueTokenFilter = require('./uniqueTokenFilter');
exports.WordDelimiterTokenFilter = require('./wordDelimiterTokenFilter');
exports.CharFilter = require('./charFilter');
exports.MappingCharFilter = require('./mappingCharFilter');
exports.PatternReplaceCharFilter = require('./patternReplaceCharFilter');
exports.DataSourceCredentials = require('./dataSourceCredentials');
exports.DataContainer = require('./dataContainer');
exports.DataChangeDetectionPolicy = require('./dataChangeDetectionPolicy');
exports.HighWaterMarkChangeDetectionPolicy = require('./highWaterMarkChangeDetectionPolicy');
exports.SqlIntegratedChangeTrackingPolicy = require('./sqlIntegratedChangeTrackingPolicy');
exports.DataDeletionDetectionPolicy = require('./dataDeletionDetectionPolicy');
exports.SoftDeleteColumnDeletionDetectionPolicy = require('./softDeleteColumnDeletionDetectionPolicy');
exports.DataSource = require('./dataSource');
exports.DataSourceListResult = require('./dataSourceListResult');
exports.IndexingSchedule = require('./indexingSchedule');
exports.FieldMappingFunction = require('./fieldMappingFunction');
exports.FieldMapping = require('./fieldMapping');
exports.Indexer = require('./indexer');
exports.IndexerListResult = require('./indexerListResult');
exports.ItemError = require('./itemError');
exports.ScoringFunction = require('./scoringFunction');
exports.DistanceScoringParameters = require('./distanceScoringParameters');
exports.DistanceScoringFunction = require('./distanceScoringFunction');
exports.FreshnessScoringParameters = require('./freshnessScoringParameters');
exports.FreshnessScoringFunction = require('./freshnessScoringFunction');
exports.MagnitudeScoringParameters = require('./magnitudeScoringParameters');
exports.MagnitudeScoringFunction = require('./magnitudeScoringFunction');
exports.TagScoringParameters = require('./tagScoringParameters');
exports.TagScoringFunction = require('./tagScoringFunction');
exports.ScoringProfile = require('./scoringProfile');
exports.CorsOptions = require('./corsOptions');
exports.Suggester = require('./suggester');
exports.Index = require('./indexModelType');
exports.IndexListResult = require('./indexListResult');
exports.SearchRequestOptions = require('./searchRequestOptions');
exports.AccessCondition = require('./accessCondition');
exports.discriminators = {
  'Analyzer' : exports.Analyzer,
  'Analyzer.#Microsoft.Azure.Search.CustomAnalyzer' : exports.CustomAnalyzer,
  'Analyzer.#Microsoft.Azure.Search.PatternAnalyzer' : exports.PatternAnalyzer,
  'Analyzer.#Microsoft.Azure.Search.StandardAnalyzer' : exports.StandardAnalyzer,
  'Analyzer.#Microsoft.Azure.Search.StopAnalyzer' : exports.StopAnalyzer,
  'Tokenizer' : exports.Tokenizer,
  'Tokenizer.#Microsoft.Azure.Search.ClassicTokenizer' : exports.ClassicTokenizer,
  'Tokenizer.#Microsoft.Azure.Search.KeywordTokenizerV2' : exports.KeywordTokenizerV2,
  'Tokenizer.#Microsoft.Azure.Search.MicrosoftLanguageTokenizer' : exports.MicrosoftLanguageTokenizer,
  'Tokenizer.#Microsoft.Azure.Search.MicrosoftLanguageStemmingTokenizer' : exports.MicrosoftLanguageStemmingTokenizer,
  'Tokenizer.#Microsoft.Azure.Search.PatternTokenizer' : exports.PatternTokenizer,
  'Tokenizer.#Microsoft.Azure.Search.StandardTokenizerV2' : exports.StandardTokenizerV2,
  'Tokenizer.#Microsoft.Azure.Search.UaxUrlEmailTokenizer' : exports.UaxUrlEmailTokenizer,
  'TokenFilter' : exports.TokenFilter,
  'TokenFilter.#Microsoft.Azure.Search.AsciiFoldingTokenFilter' : exports.AsciiFoldingTokenFilter,
  'TokenFilter.#Microsoft.Azure.Search.CommonGramTokenFilter' : exports.CommonGramTokenFilter,
  'TokenFilter.#Microsoft.Azure.Search.DictionaryDecompounderTokenFilter' : exports.DictionaryDecompounderTokenFilter,
  'TokenFilter.#Microsoft.Azure.Search.EdgeNGramTokenFilterV2' : exports.EdgeNGramTokenFilterV2,
  'TokenFilter.#Microsoft.Azure.Search.ElisionTokenFilter' : exports.ElisionTokenFilter,
  'TokenFilter.#Microsoft.Azure.Search.KeepTokenFilter' : exports.KeepTokenFilter,
  'TokenFilter.#Microsoft.Azure.Search.KeywordMarkerTokenFilter' : exports.KeywordMarkerTokenFilter,
  'TokenFilter.#Microsoft.Azure.Search.LengthTokenFilter' : exports.LengthTokenFilter,
  'TokenFilter.#Microsoft.Azure.Search.LimitTokenFilter' : exports.LimitTokenFilter,
  'TokenFilter.#Microsoft.Azure.Search.NGramTokenFilterV2' : exports.NGramTokenFilterV2,
  'TokenFilter.#Microsoft.Azure.Search.PatternCaptureTokenFilter' : exports.PatternCaptureTokenFilter,
  'TokenFilter.#Microsoft.Azure.Search.PatternReplaceTokenFilter' : exports.PatternReplaceTokenFilter,
  'TokenFilter.#Microsoft.Azure.Search.PhoneticTokenFilter' : exports.PhoneticTokenFilter,
  'TokenFilter.#Microsoft.Azure.Search.ShingleTokenFilter' : exports.ShingleTokenFilter,
  'TokenFilter.#Microsoft.Azure.Search.SnowballTokenFilter' : exports.SnowballTokenFilter,
  'TokenFilter.#Microsoft.Azure.Search.StemmerTokenFilter' : exports.StemmerTokenFilter,
  'TokenFilter.#Microsoft.Azure.Search.StemmerOverrideTokenFilter' : exports.StemmerOverrideTokenFilter,
  'TokenFilter.#Microsoft.Azure.Search.StopwordsTokenFilter' : exports.StopwordsTokenFilter,
  'TokenFilter.#Microsoft.Azure.Search.SynonymTokenFilter' : exports.SynonymTokenFilter,
  'TokenFilter.#Microsoft.Azure.Search.TruncateTokenFilter' : exports.TruncateTokenFilter,
  'TokenFilter.#Microsoft.Azure.Search.UniqueTokenFilter' : exports.UniqueTokenFilter,
  'TokenFilter.#Microsoft.Azure.Search.WordDelimiterTokenFilter' : exports.WordDelimiterTokenFilter,
  'CharFilter' : exports.CharFilter,
  'CharFilter.#Microsoft.Azure.Search.MappingCharFilter' : exports.MappingCharFilter,
  'CharFilter.#Microsoft.Azure.Search.PatternReplaceCharFilter' : exports.PatternReplaceCharFilter,
  'DataChangeDetectionPolicy' : exports.DataChangeDetectionPolicy,
  'DataChangeDetectionPolicy.#Microsoft.Azure.Search.HighWaterMarkChangeDetectionPolicy' : exports.HighWaterMarkChangeDetectionPolicy,
  'DataChangeDetectionPolicy.#Microsoft.Azure.Search.SqlIntegratedChangeTrackingPolicy' : exports.SqlIntegratedChangeTrackingPolicy,
  'DataDeletionDetectionPolicy' : exports.DataDeletionDetectionPolicy,
  'DataDeletionDetectionPolicy.#Microsoft.Azure.Search.SoftDeleteColumnDeletionDetectionPolicy' : exports.SoftDeleteColumnDeletionDetectionPolicy,
  'ScoringFunction' : exports.ScoringFunction,
  'ScoringFunction.distance' : exports.DistanceScoringFunction,
  'ScoringFunction.freshness' : exports.FreshnessScoringFunction,
  'ScoringFunction.magnitude' : exports.MagnitudeScoringFunction,
  'ScoringFunction.tag' : exports.TagScoringFunction
};
