/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Response from a List Indexes request. If successful, it includes the full
 * definitions of all indexes.
 *
 */
class IndexListResult {
  /**
   * Create a IndexListResult.
   * @member {array} [indexes] The indexes in the Search service.
   */
  constructor() {
  }

  /**
   * Defines the metadata of IndexListResult
   *
   * @returns {object} metadata of IndexListResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IndexListResult',
      type: {
        name: 'Composite',
        className: 'IndexListResult',
        modelProperties: {
          indexes: {
            required: false,
            readOnly: true,
            serializedName: 'value',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'IndexElementType',
                  type: {
                    name: 'Composite',
                    className: 'Index'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = IndexListResult;
