/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents a schedule for indexer execution.
 *
 */
class IndexingSchedule {
  /**
   * Create a IndexingSchedule.
   * @member {moment.duration} interval The interval of time between indexer
   * executions.
   * @member {date} [startTime] The time when an indexer should start running.
   */
  constructor() {
  }

  /**
   * Defines the metadata of IndexingSchedule
   *
   * @returns {object} metadata of IndexingSchedule
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IndexingSchedule',
      type: {
        name: 'Composite',
        className: 'IndexingSchedule',
        modelProperties: {
          interval: {
            required: true,
            serializedName: 'interval',
            type: {
              name: 'TimeSpan'
            }
          },
          startTime: {
            required: false,
            serializedName: 'startTime',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = IndexingSchedule;
