/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents an item- or document-level indexing error.
 *
 */
class ItemError {
  /**
   * Create a ItemError.
   * @member {string} [key] The key of the item for which indexing failed.
   * @member {string} [errorMessage] The message describing the error that
   * occurred while attempting to index the item.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ItemError
   *
   * @returns {object} metadata of ItemError
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ItemError',
      type: {
        name: 'Composite',
        className: 'ItemError',
        modelProperties: {
          key: {
            required: false,
            readOnly: true,
            serializedName: 'key',
            type: {
              name: 'String'
            }
          },
          errorMessage: {
            required: false,
            readOnly: true,
            serializedName: 'errorMessage',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ItemError;
