/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Marks terms as keywords. This token filter is implemented using Apache
 * Lucene.
 *
 * @extends models['TokenFilter']
 */
class KeywordMarkerTokenFilter extends models['TokenFilter'] {
  /**
   * Create a KeywordMarkerTokenFilter.
   * @member {array} keywords A list of words to mark as keywords.
   * @member {boolean} [ignoreCase] A value indicating whether to ignore case.
   * If true, all words are converted to lower case first. Default is false.
   * Default value: false .
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of KeywordMarkerTokenFilter
   *
   * @returns {object} metadata of KeywordMarkerTokenFilter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: '#Microsoft.Azure.Search.KeywordMarkerTokenFilter',
      type: {
        name: 'Composite',
        className: 'KeywordMarkerTokenFilter',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          odatatype: {
            required: true,
            serializedName: '@odata\\.type',
            type: {
              name: 'String'
            }
          },
          keywords: {
            required: true,
            serializedName: 'keywords',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          ignoreCase: {
            required: false,
            serializedName: 'ignoreCase',
            defaultValue: false,
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = KeywordMarkerTokenFilter;
