/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Limits the number of tokens while indexing. This token filter is implemented
 * using Apache Lucene.
 *
 * @extends models['TokenFilter']
 */
class LimitTokenFilter extends models['TokenFilter'] {
  /**
   * Create a LimitTokenFilter.
   * @member {number} [maxTokenCount] The maximum number of tokens to produce.
   * Default is 1. Default value: 1 .
   * @member {boolean} [consumeAllTokens] A value indicating whether all tokens
   * from the input must be consumed even if maxTokenCount is reached. Default
   * is false. Default value: false .
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of LimitTokenFilter
   *
   * @returns {object} metadata of LimitTokenFilter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: '#Microsoft.Azure.Search.LimitTokenFilter',
      type: {
        name: 'Composite',
        className: 'LimitTokenFilter',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          odatatype: {
            required: true,
            serializedName: '@odata\\.type',
            type: {
              name: 'String'
            }
          },
          maxTokenCount: {
            required: false,
            serializedName: 'maxTokenCount',
            defaultValue: 1,
            type: {
              name: 'Number'
            }
          },
          consumeAllTokens: {
            required: false,
            serializedName: 'consumeAllTokens',
            defaultValue: false,
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = LimitTokenFilter;
