/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Defines a function that boosts scores based on the magnitude of a numeric
 * field.
 *
 * @extends models['ScoringFunction']
 */
class MagnitudeScoringFunction extends models['ScoringFunction'] {
  /**
   * Create a MagnitudeScoringFunction.
   * @member {object} parameters Parameter values for the magnitude scoring
   * function.
   * @member {number} [parameters.boostingRangeStart] The field value at which
   * boosting starts.
   * @member {number} [parameters.boostingRangeEnd] The field value at which
   * boosting ends.
   * @member {boolean} [parameters.shouldBoostBeyondRangeByConstant] A value
   * indicating whether to apply a constant boost for field values beyond the
   * range end value; default is false.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of MagnitudeScoringFunction
   *
   * @returns {object} metadata of MagnitudeScoringFunction
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'magnitude',
      type: {
        name: 'Composite',
        className: 'MagnitudeScoringFunction',
        modelProperties: {
          fieldName: {
            required: true,
            serializedName: 'fieldName',
            type: {
              name: 'String'
            }
          },
          boost: {
            required: true,
            serializedName: 'boost',
            type: {
              name: 'Number'
            }
          },
          interpolation: {
            required: false,
            serializedName: 'interpolation',
            type: {
              name: 'Enum',
              allowedValues: [ 'linear', 'constant', 'quadratic', 'logarithmic' ]
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          parameters: {
            required: true,
            serializedName: 'magnitude',
            type: {
              name: 'Composite',
              className: 'MagnitudeScoringParameters'
            }
          }
        }
      }
    };
  }
}

module.exports = MagnitudeScoringFunction;
