/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Provides parameter values to a magnitude scoring function.
 *
 */
class MagnitudeScoringParameters {
  /**
   * Create a MagnitudeScoringParameters.
   * @member {number} boostingRangeStart The field value at which boosting
   * starts.
   * @member {number} boostingRangeEnd The field value at which boosting ends.
   * @member {boolean} [shouldBoostBeyondRangeByConstant] A value indicating
   * whether to apply a constant boost for field values beyond the range end
   * value; default is false.
   */
  constructor() {
  }

  /**
   * Defines the metadata of MagnitudeScoringParameters
   *
   * @returns {object} metadata of MagnitudeScoringParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MagnitudeScoringParameters',
      type: {
        name: 'Composite',
        className: 'MagnitudeScoringParameters',
        modelProperties: {
          boostingRangeStart: {
            required: true,
            serializedName: 'boostingRangeStart',
            type: {
              name: 'Number'
            }
          },
          boostingRangeEnd: {
            required: true,
            serializedName: 'boostingRangeEnd',
            type: {
              name: 'Number'
            }
          },
          shouldBoostBeyondRangeByConstant: {
            required: false,
            serializedName: 'constantBoostBeyondRange',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = MagnitudeScoringParameters;
