/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Uses Java regexes to emit multiple tokens - one for each capture group in
 * one or more patterns. This token filter is implemented using Apache Lucene.
 *
 * @extends models['TokenFilter']
 */
class PatternCaptureTokenFilter extends models['TokenFilter'] {
  /**
   * Create a PatternCaptureTokenFilter.
   * @member {array} patterns A list of patterns to match against each token.
   * @member {boolean} [preserveOriginal] A value indicating whether to return
   * the original token even if one of the patterns matches. Default is true.
   * Default value: true .
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of PatternCaptureTokenFilter
   *
   * @returns {object} metadata of PatternCaptureTokenFilter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: '#Microsoft.Azure.Search.PatternCaptureTokenFilter',
      type: {
        name: 'Composite',
        className: 'PatternCaptureTokenFilter',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          odatatype: {
            required: true,
            serializedName: '@odata\\.type',
            type: {
              name: 'String'
            }
          },
          patterns: {
            required: true,
            serializedName: 'patterns',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          preserveOriginal: {
            required: false,
            serializedName: 'preserveOriginal',
            defaultValue: true,
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = PatternCaptureTokenFilter;
