/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A filter that stems words using a Snowball-generated stemmer. This token
 * filter is implemented using Apache Lucene.
 *
 * @extends models['TokenFilter']
 */
class SnowballTokenFilter extends models['TokenFilter'] {
  /**
   * Create a SnowballTokenFilter.
   * @member {string} language The language to use. Possible values include:
   * 'armenian', 'basque', 'catalan', 'danish', 'dutch', 'english', 'finnish',
   * 'french', 'german', 'german2', 'hungarian', 'italian', 'kp', 'lovins',
   * 'norwegian', 'porter', 'portuguese', 'romanian', 'russian', 'spanish',
   * 'swedish', 'turkish'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SnowballTokenFilter
   *
   * @returns {object} metadata of SnowballTokenFilter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: '#Microsoft.Azure.Search.SnowballTokenFilter',
      type: {
        name: 'Composite',
        className: 'SnowballTokenFilter',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          odatatype: {
            required: true,
            serializedName: '@odata\\.type',
            type: {
              name: 'String'
            }
          },
          language: {
            required: true,
            serializedName: 'language',
            type: {
              name: 'Enum',
              allowedValues: [ 'armenian', 'basque', 'catalan', 'danish', 'dutch', 'english', 'finnish', 'french', 'german', 'german2', 'hungarian', 'italian', 'kp', 'lovins', 'norwegian', 'porter', 'portuguese', 'romanian', 'russian', 'spanish', 'swedish', 'turkish' ]
            }
          }
        }
      }
    };
  }
}

module.exports = SnowballTokenFilter;
