/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Defines a data deletion detection policy that implements a soft-deletion
 * strategy. It determines whether an item should be deleted based on the value
 * of a designated 'soft delete' column.
 *
 * @extends models['DataDeletionDetectionPolicy']
 */
class SoftDeleteColumnDeletionDetectionPolicy extends models['DataDeletionDetectionPolicy'] {
  /**
   * Create a SoftDeleteColumnDeletionDetectionPolicy.
   * @member {string} [softDeleteColumnName] The name of the column to use for
   * soft-deletion detection.
   * @member {string} [softDeleteMarkerValue] The marker value that indentifies
   * an item as deleted.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SoftDeleteColumnDeletionDetectionPolicy
   *
   * @returns {object} metadata of SoftDeleteColumnDeletionDetectionPolicy
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: '#Microsoft.Azure.Search.SoftDeleteColumnDeletionDetectionPolicy',
      type: {
        name: 'Composite',
        className: 'SoftDeleteColumnDeletionDetectionPolicy',
        modelProperties: {
          odatatype: {
            required: true,
            serializedName: '@odata\\.type',
            type: {
              name: 'String'
            }
          },
          softDeleteColumnName: {
            required: false,
            serializedName: 'softDeleteColumnName',
            type: {
              name: 'String'
            }
          },
          softDeleteMarkerValue: {
            required: false,
            serializedName: 'softDeleteMarkerValue',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SoftDeleteColumnDeletionDetectionPolicy;
