/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Defines a data change detection policy that captures changes using the
 * Integrated Change Tracking feature of Azure SQL Database.
 *
 * @extends models['DataChangeDetectionPolicy']
 */
class SqlIntegratedChangeTrackingPolicy extends models['DataChangeDetectionPolicy'] {
  /**
   * Create a SqlIntegratedChangeTrackingPolicy.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SqlIntegratedChangeTrackingPolicy
   *
   * @returns {object} metadata of SqlIntegratedChangeTrackingPolicy
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: '#Microsoft.Azure.Search.SqlIntegratedChangeTrackingPolicy',
      type: {
        name: 'Composite',
        className: 'SqlIntegratedChangeTrackingPolicy',
        modelProperties: {
          odatatype: {
            required: true,
            serializedName: '@odata\\.type',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SqlIntegratedChangeTrackingPolicy;
