/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Language specific stemming filter. This token filter is implemented using
 * Apache Lucene.
 *
 * @extends models['TokenFilter']
 */
class StemmerTokenFilter extends models['TokenFilter'] {
  /**
   * Create a StemmerTokenFilter.
   * @member {string} language The language to use. Possible values include:
   * 'arabic', 'armenian', 'basque', 'brazilian', 'bulgarian', 'catalan',
   * 'czech', 'danish', 'dutch', 'dutchKp', 'english', 'lightEnglish',
   * 'minimalEnglish', 'possessiveEnglish', 'porter2', 'lovins', 'finnish',
   * 'lightFinnish', 'french', 'lightFrench', 'minimalFrench', 'galician',
   * 'minimalGalician', 'german', 'german2', 'lightGerman', 'minimalGerman',
   * 'greek', 'hindi', 'hungarian', 'lightHungarian', 'indonesian', 'irish',
   * 'italian', 'lightItalian', 'sorani', 'latvian', 'norwegian',
   * 'lightNorwegian', 'minimalNorwegian', 'lightNynorsk', 'minimalNynorsk',
   * 'portuguese', 'lightPortuguese', 'minimalPortuguese', 'portugueseRslp',
   * 'romanian', 'russian', 'lightRussian', 'spanish', 'lightSpanish',
   * 'swedish', 'lightSwedish', 'turkish'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of StemmerTokenFilter
   *
   * @returns {object} metadata of StemmerTokenFilter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: '#Microsoft.Azure.Search.StemmerTokenFilter',
      type: {
        name: 'Composite',
        className: 'StemmerTokenFilter',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          odatatype: {
            required: true,
            serializedName: '@odata\\.type',
            type: {
              name: 'String'
            }
          },
          language: {
            required: true,
            serializedName: 'language',
            type: {
              name: 'Enum',
              allowedValues: [ 'arabic', 'armenian', 'basque', 'brazilian', 'bulgarian', 'catalan', 'czech', 'danish', 'dutch', 'dutchKp', 'english', 'lightEnglish', 'minimalEnglish', 'possessiveEnglish', 'porter2', 'lovins', 'finnish', 'lightFinnish', 'french', 'lightFrench', 'minimalFrench', 'galician', 'minimalGalician', 'german', 'german2', 'lightGerman', 'minimalGerman', 'greek', 'hindi', 'hungarian', 'lightHungarian', 'indonesian', 'irish', 'italian', 'lightItalian', 'sorani', 'latvian', 'norwegian', 'lightNorwegian', 'minimalNorwegian', 'lightNynorsk', 'minimalNynorsk', 'portuguese', 'lightPortuguese', 'minimalPortuguese', 'portugueseRslp', 'romanian', 'russian', 'lightRussian', 'spanish', 'lightSpanish', 'swedish', 'lightSwedish', 'turkish' ]
            }
          }
        }
      }
    };
  }
}

module.exports = StemmerTokenFilter;
