/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Divides text at non-letters; Applies the lowercase and stopword token
 * filters. This analyzer is implemented using Apache Lucene.
 *
 * @extends models['Analyzer']
 */
class StopAnalyzer extends models['Analyzer'] {
  /**
   * Create a StopAnalyzer.
   * @member {array} [stopwords] A list of stopwords.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of StopAnalyzer
   *
   * @returns {object} metadata of StopAnalyzer
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: '#Microsoft.Azure.Search.StopAnalyzer',
      type: {
        name: 'Composite',
        className: 'StopAnalyzer',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          odatatype: {
            required: true,
            serializedName: '@odata\\.type',
            type: {
              name: 'String'
            }
          },
          stopwords: {
            required: false,
            serializedName: 'stopwords',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = StopAnalyzer;
