/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Defines a function that boosts scores of documents with string values
 * matching a given list of tags.
 *
 * @extends models['ScoringFunction']
 */
class TagScoringFunction extends models['ScoringFunction'] {
  /**
   * Create a TagScoringFunction.
   * @member {object} parameters Parameter values for the tag scoring function.
   * @member {string} [parameters.tagsParameter] The name of the parameter
   * passed in search queries to specify the list of tags to compare against
   * the target field.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of TagScoringFunction
   *
   * @returns {object} metadata of TagScoringFunction
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'tag',
      type: {
        name: 'Composite',
        className: 'TagScoringFunction',
        modelProperties: {
          fieldName: {
            required: true,
            serializedName: 'fieldName',
            type: {
              name: 'String'
            }
          },
          boost: {
            required: true,
            serializedName: 'boost',
            type: {
              name: 'Number'
            }
          },
          interpolation: {
            required: false,
            serializedName: 'interpolation',
            type: {
              name: 'Enum',
              allowedValues: [ 'linear', 'constant', 'quadratic', 'logarithmic' ]
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          parameters: {
            required: true,
            serializedName: 'tag',
            type: {
              name: 'Composite',
              className: 'TagScoringParameters'
            }
          }
        }
      }
    };
  }
}

module.exports = TagScoringFunction;
