/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Truncates the terms to a specific length. This token filter is implemented
 * using Apache Lucene.
 *
 * @extends models['TokenFilter']
 */
class TruncateTokenFilter extends models['TokenFilter'] {
  /**
   * Create a TruncateTokenFilter.
   * @member {number} [length] The length at which terms will be truncated.
   * Default and maximum is 300. Default value: 300 .
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of TruncateTokenFilter
   *
   * @returns {object} metadata of TruncateTokenFilter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: '#Microsoft.Azure.Search.TruncateTokenFilter',
      type: {
        name: 'Composite',
        className: 'TruncateTokenFilter',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          odatatype: {
            required: true,
            serializedName: '@odata\\.type',
            type: {
              name: 'String'
            }
          },
          length: {
            required: false,
            serializedName: 'length',
            defaultValue: 300,
            constraints: {
              InclusiveMaximum: 300
            },
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = TruncateTokenFilter;
