/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Filters out tokens with same text as the previous token. This token filter
 * is implemented using Apache Lucene.
 *
 * @extends models['TokenFilter']
 */
class UniqueTokenFilter extends models['TokenFilter'] {
  /**
   * Create a UniqueTokenFilter.
   * @member {boolean} [onlyOnSamePosition] A value indicating whether to
   * remove duplicates only at the same position. Default is false. Default
   * value: false .
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of UniqueTokenFilter
   *
   * @returns {object} metadata of UniqueTokenFilter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: '#Microsoft.Azure.Search.UniqueTokenFilter',
      type: {
        name: 'Composite',
        className: 'UniqueTokenFilter',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          odatatype: {
            required: true,
            serializedName: '@odata\\.type',
            type: {
              name: 'String'
            }
          },
          onlyOnSamePosition: {
            required: false,
            serializedName: 'onlyOnSamePosition',
            defaultValue: false,
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = UniqueTokenFilter;
