/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Response containing the primary and secondary admin API keys for a given
 * Azure Search service.
 *
 */
class AdminKeyResult {
  /**
   * Create a AdminKeyResult.
   * @member {string} [primaryKey] The primary admin API key of the Search
   * service.
   * @member {string} [secondaryKey] The secondary admin API key of the Search
   * service.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AdminKeyResult
   *
   * @returns {object} metadata of AdminKeyResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AdminKeyResult',
      type: {
        name: 'Composite',
        className: 'AdminKeyResult',
        modelProperties: {
          primaryKey: {
            required: false,
            readOnly: true,
            serializedName: 'primaryKey',
            type: {
              name: 'String'
            }
          },
          secondaryKey: {
            required: false,
            readOnly: true,
            serializedName: 'secondaryKey',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AdminKeyResult;
