/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes an API key for a given Azure Search service that has permissions
 * for query operations only.
 *
 */
class QueryKey {
  /**
   * Create a QueryKey.
   * @member {string} [name] The name of the query API key; may be empty.
   * @member {string} [key] The value of the query API key.
   */
  constructor() {
  }

  /**
   * Defines the metadata of QueryKey
   *
   * @returns {object} metadata of QueryKey
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'QueryKey',
      type: {
        name: 'Composite',
        className: 'QueryKey',
        modelProperties: {
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          key: {
            required: false,
            readOnly: true,
            serializedName: 'key',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = QueryKey;
