/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A collection of results from a PowerShell command.
 *
 */
class PowerShellCommandResults {
  /**
   * Create a PowerShellCommandResults.
   * @member {array} [results]
   * @member {string} [pssession]
   * @member {string} [command]
   * @member {boolean} [completed]
   */
  constructor() {
  }

  /**
   * Defines the metadata of PowerShellCommandResults
   *
   * @returns {object} metadata of PowerShellCommandResults
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PowerShellCommandResults',
      type: {
        name: 'Composite',
        className: 'PowerShellCommandResults',
        modelProperties: {
          results: {
            required: false,
            serializedName: 'results',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'PowerShellCommandResultElementType',
                  type: {
                    name: 'Composite',
                    className: 'PowerShellCommandResult'
                  }
              }
            }
          },
          pssession: {
            required: false,
            serializedName: 'pssession',
            type: {
              name: 'String'
            }
          },
          command: {
            required: false,
            serializedName: 'command',
            type: {
              name: 'String'
            }
          },
          completed: {
            required: false,
            serializedName: 'completed',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = PowerShellCommandResults;
