/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Description of a namespace resource.
 *
 * @extends models['ResourceNamespacePatch']
 */
class SBNamespaceUpdateParameters extends models['ResourceNamespacePatch'] {
  /**
   * Create a SBNamespaceUpdateParameters.
   * @member {object} [sku] Porperties of Sku
   * @member {string} [sku.name] Name of this SKU. Possible values include:
   * 'Basic', 'Standard', 'Premium'
   * @member {string} [sku.tier] The billing tier of this particular SKU.
   * Possible values include: 'Basic', 'Standard', 'Premium'
   * @member {number} [sku.capacity] The specified messaging units for the
   * tier. For Premium tier, capacity are 1,2 and 4.
   * @member {string} [provisioningState] Provisioning state of the namespace.
   * @member {date} [createdAt] The time the namespace was created.
   * @member {date} [updatedAt] The time the namespace was updated.
   * @member {string} [serviceBusEndpoint] Endpoint you can use to perform
   * Service Bus operations.
   * @member {string} [metricId] Identifier for Azure Insights metrics
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SBNamespaceUpdateParameters
   *
   * @returns {object} metadata of SBNamespaceUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SBNamespaceUpdateParameters',
      type: {
        name: 'Composite',
        className: 'SBNamespaceUpdateParameters',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          sku: {
            required: false,
            serializedName: 'sku',
            type: {
              name: 'Composite',
              className: 'SBSku'
            }
          },
          provisioningState: {
            required: false,
            readOnly: true,
            serializedName: 'properties.provisioningState',
            type: {
              name: 'String'
            }
          },
          createdAt: {
            required: false,
            readOnly: true,
            serializedName: 'properties.createdAt',
            type: {
              name: 'DateTime'
            }
          },
          updatedAt: {
            required: false,
            readOnly: true,
            serializedName: 'properties.updatedAt',
            type: {
              name: 'DateTime'
            }
          },
          serviceBusEndpoint: {
            required: false,
            readOnly: true,
            serializedName: 'properties.serviceBusEndpoint',
            type: {
              name: 'String'
            }
          },
          metricId: {
            required: false,
            readOnly: true,
            serializedName: 'properties.metricId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SBNamespaceUpdateParameters;
