/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * SKU of the namespace.
 *
 */
class SBSku {
  /**
   * Create a SBSku.
   * @member {string} name Name of this SKU. Possible values include: 'Basic',
   * 'Standard', 'Premium'
   * @member {string} [tier] The billing tier of this particular SKU. Possible
   * values include: 'Basic', 'Standard', 'Premium'
   * @member {number} [capacity] The specified messaging units for the tier.
   * For Premium tier, capacity are 1,2 and 4.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SBSku
   *
   * @returns {object} metadata of SBSku
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SBSku',
      type: {
        name: 'Composite',
        className: 'SBSku',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'Enum',
              allowedValues: [ 'Basic', 'Standard', 'Premium' ]
            }
          },
          tier: {
            required: false,
            serializedName: 'tier',
            type: {
              name: 'Enum',
              allowedValues: [ 'Basic', 'Standard', 'Premium' ]
            }
          },
          capacity: {
            required: false,
            serializedName: 'capacity',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = SBSku;
