/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Azure Active Directory metadata object used for secured connection to
 * cluster.
 *
 */
class AadMetadataObject {
  /**
   * Create a AadMetadataObject.
   * @member {string} [type] The client authentication method.
   * @member {object} [metadata]
   * @member {string} [metadata.authority] The AAD authority url.
   * @member {string} [metadata.client] The AAD client application Id.
   * @member {string} [metadata.cluster] The AAD cluster application Id.
   * @member {string} [metadata.login] The AAD login url.
   * @member {string} [metadata.redirect] The client application redirect
   * address.
   * @member {string} [metadata.tenant] The AAD tenant Id.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AadMetadataObject
   *
   * @returns {object} metadata of AadMetadataObject
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AadMetadataObject',
      type: {
        name: 'Composite',
        className: 'AadMetadataObject',
        modelProperties: {
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          metadata: {
            required: false,
            serializedName: 'metadata',
            type: {
              name: 'Composite',
              className: 'AadMetadata'
            }
          }
        }
      }
    };
  }
}

module.exports = AadMetadataObject;
