/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Information about a standalone cluster configuration upgrade status.
 *
 */
class ClusterConfigurationUpgradeStatusInfo {
  /**
   * Create a ClusterConfigurationUpgradeStatusInfo.
   * @member {string} [upgradeState] Possible values include: 'Invalid',
   * 'RollingBackInProgress', 'RollingBackCompleted', 'RollingForwardPending',
   * 'RollingForwardInProgress', 'RollingForwardCompleted', 'Failed'
   * @member {number} [progressStatus] The cluster manifest version.
   * @member {string} [configVersion] The cluster configuration version.
   * @member {string} [details] The cluster upgrade status details.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ClusterConfigurationUpgradeStatusInfo
   *
   * @returns {object} metadata of ClusterConfigurationUpgradeStatusInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ClusterConfigurationUpgradeStatusInfo',
      type: {
        name: 'Composite',
        className: 'ClusterConfigurationUpgradeStatusInfo',
        modelProperties: {
          upgradeState: {
            required: false,
            serializedName: 'UpgradeState',
            type: {
              name: 'String'
            }
          },
          progressStatus: {
            required: false,
            serializedName: 'ProgressStatus',
            type: {
              name: 'Number'
            }
          },
          configVersion: {
            required: false,
            serializedName: 'ConfigVersion',
            type: {
              name: 'String'
            }
          },
          details: {
            required: false,
            serializedName: 'Details',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ClusterConfigurationUpgradeStatusInfo;
