/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the intent or reason for deactivating the node.
 *
 */
class DeactivationIntentDescription {
  /**
   * Create a DeactivationIntentDescription.
   * @member {string} [deactivationIntent] Describes the intent or reason for
   * deactivating the node. The possible values are following.
   * - Pause - Indicates that the node should be paused. The value is 1.
   * - Restart - Indicates that the intent is for the node to be restarted
   * after a short period of time. The value is 2.
   * - RemoveData - Indicates the intent is for the node to remove data. The
   * value is 3.
   * . Possible values include: 'Pause', 'Restart', 'RemoveData'
   */
  constructor() {
  }

  /**
   * Defines the metadata of DeactivationIntentDescription
   *
   * @returns {object} metadata of DeactivationIntentDescription
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DeactivationIntentDescription',
      type: {
        name: 'Composite',
        className: 'DeactivationIntentDescription',
        modelProperties: {
          deactivationIntent: {
            required: false,
            serializedName: 'DeactivationIntent',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DeactivationIntentDescription;
