/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Represents the health state chunk of a deployed service package, which
 * contains the service manifest name and the service package aggregated health
 * state.
 *
 *
 * @extends models['EntityHealthStateChunk']
 */
class DeployedServicePackageHealthStateChunk extends models['EntityHealthStateChunk'] {
  /**
   * Create a DeployedServicePackageHealthStateChunk.
   * @member {string} [serviceManifestName]
   * @member {string} [servicePackageActivationId]
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of DeployedServicePackageHealthStateChunk
   *
   * @returns {object} metadata of DeployedServicePackageHealthStateChunk
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DeployedServicePackageHealthStateChunk',
      type: {
        name: 'Composite',
        className: 'DeployedServicePackageHealthStateChunk',
        modelProperties: {
          healthState: {
            required: false,
            serializedName: 'HealthState',
            type: {
              name: 'String'
            }
          },
          serviceManifestName: {
            required: false,
            serializedName: 'ServiceManifestName',
            type: {
              name: 'String'
            }
          },
          servicePackageActivationId: {
            required: false,
            serializedName: 'ServicePackageActivationId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DeployedServicePackageHealthStateChunk;
