/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Information about service type deployed on a node, information such as the
 * status of the service type registration on a node.
 *
 */
class DeployedServiceTypeInfo {
  /**
   * Create a DeployedServiceTypeInfo.
   * @member {string} [serviceTypeName]
   * @member {string} [serviceManifestName]
   * @member {string} [codePackageName]
   * @member {string} [status] Possible values include: 'Invalid', 'Disabled',
   * 'Enabled', 'Registered'
   * @member {string} [servicePackageActivationId]
   */
  constructor() {
  }

  /**
   * Defines the metadata of DeployedServiceTypeInfo
   *
   * @returns {object} metadata of DeployedServiceTypeInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DeployedServiceTypeInfo',
      type: {
        name: 'Composite',
        className: 'DeployedServiceTypeInfo',
        modelProperties: {
          serviceTypeName: {
            required: false,
            serializedName: 'ServiceTypeName',
            type: {
              name: 'String'
            }
          },
          serviceManifestName: {
            required: false,
            serializedName: 'ServiceManifestName',
            type: {
              name: 'String'
            }
          },
          codePackageName: {
            required: false,
            serializedName: 'CodePackageName',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            serializedName: 'Status',
            type: {
              name: 'String'
            }
          },
          servicePackageActivationId: {
            required: false,
            serializedName: 'ServicePackageActivationId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DeployedServiceTypeInfo;
