/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Safety check that waits to ensure the availability of the partition. It
 * waits until there are replicas available such that bringing down this
 * replica will not cause availability loss for the partition.
 *
 * @extends models['PartitionSafetyCheck']
 */
class EnsureAvailabilitySafetyCheck extends models['PartitionSafetyCheck'] {
  /**
   * Create a EnsureAvailabilitySafetyCheck.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of EnsureAvailabilitySafetyCheck
   *
   * @returns {object} metadata of EnsureAvailabilitySafetyCheck
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EnsureAvailability',
      type: {
        name: 'Composite',
        className: 'EnsureAvailabilitySafetyCheck',
        modelProperties: {
          kind: {
            required: true,
            serializedName: 'Kind',
            type: {
              name: 'String'
            }
          },
          partitionId: {
            required: false,
            serializedName: 'PartitionId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = EnsureAvailabilitySafetyCheck;
