/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An Epoch is a configuration number for the partition as a whole. When the
 * configuration of the replica set changes, for example when the Primary
 * replica changes, the operations that are replicated from the new Primary
 * replica are said to be a new Epoch from the ones which were sent by the old
 * Primary replica.
 *
 *
 */
class Epoch {
  /**
   * Create a Epoch.
   * @member {string} [configurationVersion] The current configuration number
   * of this Epoch. The configuration number is an increasing value that is
   * updated whenever the configuration of this replica set changes.
   * @member {string} [dataLossVersion] The current dataloss number of this
   * Epoch. The data loss number property is an increasing value which is
   * updated whenever data loss is suspected, as when loss of a quorum of
   * replicas in the replica set that includes the Primary replica.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Epoch
   *
   * @returns {object} metadata of Epoch
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Epoch',
      type: {
        name: 'Composite',
        className: 'Epoch',
        modelProperties: {
          configurationVersion: {
            required: false,
            serializedName: 'ConfigurationVersion',
            type: {
              name: 'String'
            }
          },
          dataLossVersion: {
            required: false,
            serializedName: 'DataLossVersion',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Epoch;
