/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Describes a Chaos event that gets generated when Chaos has decided on the
 * faults for an iteration. This Chaos event contains the details of the faults
 * as a list of strings.
 *
 * @extends models['ChaosEvent']
 */
class ExecutingFaultsChaosEvent extends models['ChaosEvent'] {
  /**
   * Create a ExecutingFaultsChaosEvent.
   * @member {array} [faults]
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ExecutingFaultsChaosEvent
   *
   * @returns {object} metadata of ExecutingFaultsChaosEvent
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ExecutingFaults',
      type: {
        name: 'Composite',
        className: 'ExecutingFaultsChaosEvent',
        modelProperties: {
          timeStampUtc: {
            required: true,
            serializedName: 'TimeStampUtc',
            type: {
              name: 'DateTime'
            }
          },
          kind: {
            required: true,
            serializedName: 'Kind',
            type: {
              name: 'String'
            }
          },
          faults: {
            required: false,
            serializedName: 'Faults',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ExecutingFaultsChaosEvent;
