/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Information about the upgrade domain progress at the time of upgrade
 * failure.
 *
 */
class FailureUpgradeDomainProgressInfo {
  /**
   * Create a FailureUpgradeDomainProgressInfo.
   * @member {string} [domainName]
   * @member {array} [nodeUpgradeProgressList]
   */
  constructor() {
  }

  /**
   * Defines the metadata of FailureUpgradeDomainProgressInfo
   *
   * @returns {object} metadata of FailureUpgradeDomainProgressInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FailureUpgradeDomainProgressInfo',
      type: {
        name: 'Composite',
        className: 'FailureUpgradeDomainProgressInfo',
        modelProperties: {
          domainName: {
            required: false,
            serializedName: 'DomainName',
            type: {
              name: 'String'
            }
          },
          nodeUpgradeProgressList: {
            required: false,
            serializedName: 'NodeUpgradeProgressList',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'NodeUpgradeProgressInfoElementType',
                  type: {
                    name: 'Composite',
                    className: 'NodeUpgradeProgressInfo'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = FailureUpgradeDomainProgressInfo;
