/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Describes the partition information for the integer range that is based on
 * partition schemes.
 *
 * @extends models['PartitionInformation']
 */
class Int64RangePartitionInformation extends models['PartitionInformation'] {
  /**
   * Create a Int64RangePartitionInformation.
   * @member {string} [lowKey] Specifies the minimum key value handled by this
   * partition.
   * @member {string} [highKey] Specifies the maximum key value handled by this
   * partition.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of Int64RangePartitionInformation
   *
   * @returns {object} metadata of Int64RangePartitionInformation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Int64Range',
      type: {
        name: 'Composite',
        className: 'Int64RangePartitionInformation',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'Id',
            type: {
              name: 'String'
            }
          },
          servicePartitionKind: {
            required: true,
            serializedName: 'ServicePartitionKind',
            type: {
              name: 'String'
            }
          },
          lowKey: {
            required: false,
            serializedName: 'LowKey',
            type: {
              name: 'String'
            }
          },
          highKey: {
            required: false,
            serializedName: 'HighKey',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Int64RangePartitionInformation;
