/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Describes the list of nodes targeted by a repair action.
 *
 * This type supports the Service Fabric platform; it is not meant to be used
 * directly from your code.
 *
 *
 * @extends models['RepairTargetDescriptionBase']
 */
class NodeRepairTargetDescription extends models['RepairTargetDescriptionBase'] {
  /**
   * Create a NodeRepairTargetDescription.
   * @member {array} [nodeNames] The list of nodes targeted by a repair action.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of NodeRepairTargetDescription
   *
   * @returns {object} metadata of NodeRepairTargetDescription
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Node',
      type: {
        name: 'Composite',
        className: 'NodeRepairTargetDescription',
        modelProperties: {
          kind: {
            required: true,
            serializedName: 'Kind',
            type: {
              name: 'String'
            }
          },
          nodeNames: {
            required: false,
            serializedName: 'NodeNames',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = NodeRepairTargetDescription;
