/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Information about the health of a Service Fabric partition.
 *
 * @extends models['EntityHealth']
 */
class PartitionHealth extends models['EntityHealth'] {
  /**
   * Create a PartitionHealth.
   * @member {uuid} [partitionId]
   * @member {array} [replicaHealthStates] The list of replica health states
   * associated with the partition.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of PartitionHealth
   *
   * @returns {object} metadata of PartitionHealth
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PartitionHealth',
      type: {
        name: 'Composite',
        className: 'PartitionHealth',
        modelProperties: {
          aggregatedHealthState: {
            required: false,
            serializedName: 'AggregatedHealthState',
            type: {
              name: 'String'
            }
          },
          healthEvents: {
            required: false,
            serializedName: 'HealthEvents',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'HealthEventElementType',
                  type: {
                    name: 'Composite',
                    className: 'HealthEvent'
                  }
              }
            }
          },
          unhealthyEvaluations: {
            required: false,
            serializedName: 'UnhealthyEvaluations',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'HealthEvaluationWrapperElementType',
                  type: {
                    name: 'Composite',
                    className: 'HealthEvaluationWrapper'
                  }
              }
            }
          },
          healthStatistics: {
            required: false,
            serializedName: 'HealthStatistics',
            type: {
              name: 'Composite',
              className: 'HealthStatistics'
            }
          },
          partitionId: {
            required: false,
            serializedName: 'PartitionId',
            type: {
              name: 'String'
            }
          },
          replicaHealthStates: {
            required: false,
            serializedName: 'ReplicaHealthStates',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ReplicaHealthStateElementType',
                  type: {
                    name: 'Composite',
                    polymorphicDiscriminator: {
                      serializedName: 'ServiceKind',
                      clientName: 'serviceKind'
                    },
                    uberParent: 'EntityHealthState',
                    className: 'ReplicaHealthState'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = PartitionHealth;
