/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The list of partition health state chunks that respect the input filters in
 * the chunk query description.
 * Returned by get cluster health state chunks query as part of the parent
 * application hierarchy.
 *
 *
 */
class PartitionHealthStateChunkList {
  /**
   * Create a PartitionHealthStateChunkList.
   * @member {array} [items] The list of partition health state chunks that
   * respect the input filters in the chunk query.
   */
  constructor() {
  }

  /**
   * Defines the metadata of PartitionHealthStateChunkList
   *
   * @returns {object} metadata of PartitionHealthStateChunkList
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PartitionHealthStateChunkList',
      type: {
        name: 'Composite',
        className: 'PartitionHealthStateChunkList',
        modelProperties: {
          items: {
            required: false,
            serializedName: 'Items',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'PartitionHealthStateChunkElementType',
                  type: {
                    name: 'Composite',
                    className: 'PartitionHealthStateChunk'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = PartitionHealthStateChunkList;
