/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Provides various statistics of the acknowledgements that are being received
 * from the remote replicator.
 *
 */
class RemoteReplicatorAcknowledgementDetail {
  /**
   * Create a RemoteReplicatorAcknowledgementDetail.
   * @member {string} [averageReceiveDuration] Represents the average duration
   * it takes for the remote replicator to receive an operation.
   * @member {string} [averageApplyDuration] Represents the average duration it
   * takes for the remote replicator to apply an operation. This usually
   * entails writing the operation to disk.
   * @member {string} [notReceivedCount] Represents the number of operations
   * not yet received by a remote replicator.
   * @member {string} [receivedAndNotAppliedCount] Represents the number of
   * operations received and not yet applied by a remote replicator.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RemoteReplicatorAcknowledgementDetail
   *
   * @returns {object} metadata of RemoteReplicatorAcknowledgementDetail
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RemoteReplicatorAcknowledgementDetail',
      type: {
        name: 'Composite',
        className: 'RemoteReplicatorAcknowledgementDetail',
        modelProperties: {
          averageReceiveDuration: {
            required: false,
            serializedName: 'AverageReceiveDuration',
            type: {
              name: 'String'
            }
          },
          averageApplyDuration: {
            required: false,
            serializedName: 'AverageApplyDuration',
            type: {
              name: 'String'
            }
          },
          notReceivedCount: {
            required: false,
            serializedName: 'NotReceivedCount',
            type: {
              name: 'String'
            }
          },
          receivedAndNotAppliedCount: {
            required: false,
            serializedName: 'ReceivedAndNotAppliedCount',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = RemoteReplicatorAcknowledgementDetail;
