/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes a request to cancel a repair task.
 *
 * This type supports the Service Fabric platform; it is not meant to be used
 * directly from your code.
 *
 *
 */
class RepairTaskCancelDescription {
  /**
   * Create a RepairTaskCancelDescription.
   * @member {string} taskId The ID of the repair task.
   * @member {string} [version] The current version number of the repair task.
   * If non-zero, then the request will only succeed if this value matches the
   * actual current version of the repair task. If zero, then no version check
   * is performed.</para>
   * @member {boolean} [requestAbort] _True_ if the repair should be stopped as
   * soon as possible even if it has already started executing. _False_ if the
   * repair should be cancelled only if execution has not yet started.</para>
   */
  constructor() {
  }

  /**
   * Defines the metadata of RepairTaskCancelDescription
   *
   * @returns {object} metadata of RepairTaskCancelDescription
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RepairTaskCancelDescription',
      type: {
        name: 'Composite',
        className: 'RepairTaskCancelDescription',
        modelProperties: {
          taskId: {
            required: true,
            serializedName: 'TaskId',
            type: {
              name: 'String'
            }
          },
          version: {
            required: false,
            serializedName: 'Version',
            type: {
              name: 'String'
            }
          },
          requestAbort: {
            required: false,
            serializedName: 'RequestAbort',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = RepairTaskCancelDescription;
