/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes a request to delete a completed repair task.
 *
 * This type supports the Service Fabric platform; it is not meant to be used
 * directly from your code.
 *
 *
 */
class RepairTaskDeleteDescription {
  /**
   * Create a RepairTaskDeleteDescription.
   * @member {string} taskId The ID of the completed repair task to be deleted.
   * @member {string} [version] The current version number of the repair task.
   * If non-zero, then the request will only succeed if this value matches the
   * actual current version of the repair task. If zero, then no version check
   * is performed.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RepairTaskDeleteDescription
   *
   * @returns {object} metadata of RepairTaskDeleteDescription
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RepairTaskDeleteDescription',
      type: {
        name: 'Composite',
        className: 'RepairTaskDeleteDescription',
        modelProperties: {
          taskId: {
            required: true,
            serializedName: 'TaskId',
            type: {
              name: 'String'
            }
          },
          version: {
            required: false,
            serializedName: 'Version',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = RepairTaskDeleteDescription;
