/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Represents information about an operation in a terminal state (Completed or
 * Faulted).
 *
 */
class RestartPartitionResult {
  /**
   * Create a RestartPartitionResult.
   * @member {number} [errorCode] If OperationState is Completed, this is 0.
   * If OperationState is Faulted, this is an error code indicating the reason.
   * @member {object} [selectedPartition]
   * @member {string} [selectedPartition.serviceName]
   * @member {uuid} [selectedPartition.partitionId]
   */
  constructor() {
  }

  /**
   * Defines the metadata of RestartPartitionResult
   *
   * @returns {object} metadata of RestartPartitionResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RestartPartitionResult',
      type: {
        name: 'Composite',
        className: 'RestartPartitionResult',
        modelProperties: {
          errorCode: {
            required: false,
            serializedName: 'ErrorCode',
            type: {
              name: 'Number'
            }
          },
          selectedPartition: {
            required: false,
            serializedName: 'SelectedPartition',
            type: {
              name: 'Composite',
              className: 'SelectedPartition'
            }
          }
        }
      }
    };
  }
}

module.exports = RestartPartitionResult;
