/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the parameters for updating a rolling upgrade of application or
 * cluster.
 *
 */
class RollingUpgradeUpdateDescription {
  /**
   * Create a RollingUpgradeUpdateDescription.
   * @member {string} rollingUpgradeMode Possible values include: 'Invalid',
   * 'UnmonitoredAuto', 'UnmonitoredManual', 'Monitored'. Default value:
   * 'UnmonitoredAuto' .
   * @member {boolean} [forceRestart]
   * @member {number} [replicaSetCheckTimeoutInMilliseconds]
   * @member {string} [failureAction] Possible values include: 'Invalid',
   * 'Rollback', 'Manual'
   * @member {string} [healthCheckWaitDurationInMilliseconds]
   * @member {string} [healthCheckStableDurationInMilliseconds]
   * @member {string} [healthCheckRetryTimeoutInMilliseconds]
   * @member {string} [upgradeTimeoutInMilliseconds]
   * @member {string} [upgradeDomainTimeoutInMilliseconds]
   */
  constructor() {
  }

  /**
   * Defines the metadata of RollingUpgradeUpdateDescription
   *
   * @returns {object} metadata of RollingUpgradeUpdateDescription
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RollingUpgradeUpdateDescription',
      type: {
        name: 'Composite',
        className: 'RollingUpgradeUpdateDescription',
        modelProperties: {
          rollingUpgradeMode: {
            required: true,
            serializedName: 'RollingUpgradeMode',
            defaultValue: 'UnmonitoredAuto',
            type: {
              name: 'String'
            }
          },
          forceRestart: {
            required: false,
            serializedName: 'ForceRestart',
            type: {
              name: 'Boolean'
            }
          },
          replicaSetCheckTimeoutInMilliseconds: {
            required: false,
            serializedName: 'ReplicaSetCheckTimeoutInMilliseconds',
            type: {
              name: 'Number'
            }
          },
          failureAction: {
            required: false,
            serializedName: 'FailureAction',
            type: {
              name: 'String'
            }
          },
          healthCheckWaitDurationInMilliseconds: {
            required: false,
            serializedName: 'HealthCheckWaitDurationInMilliseconds',
            type: {
              name: 'String'
            }
          },
          healthCheckStableDurationInMilliseconds: {
            required: false,
            serializedName: 'HealthCheckStableDurationInMilliseconds',
            type: {
              name: 'String'
            }
          },
          healthCheckRetryTimeoutInMilliseconds: {
            required: false,
            serializedName: 'HealthCheckRetryTimeoutInMilliseconds',
            type: {
              name: 'String'
            }
          },
          upgradeTimeoutInMilliseconds: {
            required: false,
            serializedName: 'UpgradeTimeoutInMilliseconds',
            type: {
              name: 'String'
            }
          },
          upgradeDomainTimeoutInMilliseconds: {
            required: false,
            serializedName: 'UpgradeDomainTimeoutInMilliseconds',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = RollingUpgradeUpdateDescription;
