/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Describes the policy to be used for placement of a Service Fabric service
 * where a particular fault or upgrade domain should not be used for placement
 * of the instances or replicas of that service.
 *
 * @extends models['ServicePlacementPolicyDescription']
 */
class ServicePlacementInvalidDomainPolicyDescription extends models['ServicePlacementPolicyDescription'] {
  /**
   * Create a ServicePlacementInvalidDomainPolicyDescription.
   * @member {string} [domainName] The name of the domain that should not be
   * used for placement.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ServicePlacementInvalidDomainPolicyDescription
   *
   * @returns {object} metadata of ServicePlacementInvalidDomainPolicyDescription
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'InvalidDomain',
      type: {
        name: 'Composite',
        className: 'ServicePlacementInvalidDomainPolicyDescription',
        modelProperties: {
          type: {
            required: true,
            serializedName: 'Type',
            type: {
              name: 'String'
            }
          },
          domainName: {
            required: false,
            serializedName: 'DomainName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ServicePlacementInvalidDomainPolicyDescription;
