/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Describes the policy to be used for placement of a Service Fabric service
 * where all replicas must be able to be placed in order for any replicas to be
 * created.
 *
 *
 * @extends models['ServicePlacementPolicyDescription']
 */
class ServicePlacementNonPartiallyPlaceServicePolicyDescription extends models['ServicePlacementPolicyDescription'] {
  /**
   * Create a ServicePlacementNonPartiallyPlaceServicePolicyDescription.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ServicePlacementNonPartiallyPlaceServicePolicyDescription
   *
   * @returns {object} metadata of ServicePlacementNonPartiallyPlaceServicePolicyDescription
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NonPartiallyPlaceService',
      type: {
        name: 'Composite',
        className: 'ServicePlacementNonPartiallyPlaceServicePolicyDescription',
        modelProperties: {
          type: {
            required: true,
            serializedName: 'Type',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ServicePlacementNonPartiallyPlaceServicePolicyDescription;
