/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Describes the partition scheme of a singleton-partitioned, or
 * non-partitioned service.
 *
 * @extends models['PartitionSchemeDescription']
 */
class SingletonPartitionSchemeDescription extends models['PartitionSchemeDescription'] {
  /**
   * Create a SingletonPartitionSchemeDescription.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SingletonPartitionSchemeDescription
   *
   * @returns {object} metadata of SingletonPartitionSchemeDescription
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Singleton',
      type: {
        name: 'Composite',
        className: 'SingletonPartitionSchemeDescription',
        modelProperties: {
          partitionScheme: {
            required: true,
            serializedName: 'PartitionScheme',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SingletonPartitionSchemeDescription;
