/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Describes a Chaos event that gets generated when Chaos stops because either
 * the user issued a stop or the time to run was up.
 *
 * @extends models['ChaosEvent']
 */
class StoppedChaosEvent extends models['ChaosEvent'] {
  /**
   * Create a StoppedChaosEvent.
   * @member {string} [reason]
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of StoppedChaosEvent
   *
   * @returns {object} metadata of StoppedChaosEvent
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Stopped',
      type: {
        name: 'Composite',
        className: 'StoppedChaosEvent',
        modelProperties: {
          timeStampUtc: {
            required: true,
            serializedName: 'TimeStampUtc',
            type: {
              name: 'DateTime'
            }
          },
          kind: {
            required: true,
            serializedName: 'Kind',
            type: {
              name: 'String'
            }
          },
          reason: {
            required: false,
            serializedName: 'Reason',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = StoppedChaosEvent;
