/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The settings to enable AAD authentication on the cluster.
 *
 */
class AzureActiveDirectory {
  /**
   * Create a AzureActiveDirectory.
   * @member {string} [tenantId] Azure active directory tenant id.
   * @member {string} [clusterApplication] Azure active directory cluster
   * application id.
   * @member {string} [clientApplication] Azure active directory client
   * application id.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureActiveDirectory
   *
   * @returns {object} metadata of AzureActiveDirectory
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureActiveDirectory',
      type: {
        name: 'Composite',
        className: 'AzureActiveDirectory',
        modelProperties: {
          tenantId: {
            required: false,
            serializedName: 'tenantId',
            type: {
              name: 'String'
            }
          },
          clusterApplication: {
            required: false,
            serializedName: 'clusterApplication',
            type: {
              name: 'String'
            }
          },
          clientApplication: {
            required: false,
            serializedName: 'clientApplication',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureActiveDirectory;
