/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the certificate details.
 *
 */
class CertificateDescription {
  /**
   * Create a CertificateDescription.
   * @member {string} thumbprint Thumbprint of the primary certificate.
   * @member {string} [thumbprintSecondary] Thumbprint of the secondary
   * certificate.
   * @member {string} [x509StoreName] The local certificate store location.
   * Possible values include: 'AddressBook', 'AuthRoot',
   * 'CertificateAuthority', 'Disallowed', 'My', 'Root', 'TrustedPeople',
   * 'TrustedPublisher'
   */
  constructor() {
  }

  /**
   * Defines the metadata of CertificateDescription
   *
   * @returns {object} metadata of CertificateDescription
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CertificateDescription',
      type: {
        name: 'Composite',
        className: 'CertificateDescription',
        modelProperties: {
          thumbprint: {
            required: true,
            serializedName: 'thumbprint',
            type: {
              name: 'String'
            }
          },
          thumbprintSecondary: {
            required: false,
            serializedName: 'thumbprintSecondary',
            type: {
              name: 'String'
            }
          },
          x509StoreName: {
            required: false,
            serializedName: 'x509StoreName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CertificateDescription;
