/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the client certificate details using common name.
 *
 */
class ClientCertificateCommonName {
  /**
   * Create a ClientCertificateCommonName.
   * @member {boolean} isAdmin Indicates if the client certificate has admin
   * access to the cluster. Non admin clients can perform only read only
   * operations on the cluster.
   * @member {string} certificateCommonName The common name of the client
   * certificate.
   * @member {string} certificateIssuerThumbprint The issuer thumbprint of the
   * client certificate.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ClientCertificateCommonName
   *
   * @returns {object} metadata of ClientCertificateCommonName
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ClientCertificateCommonName',
      type: {
        name: 'Composite',
        className: 'ClientCertificateCommonName',
        modelProperties: {
          isAdmin: {
            required: true,
            serializedName: 'isAdmin',
            type: {
              name: 'Boolean'
            }
          },
          certificateCommonName: {
            required: true,
            serializedName: 'certificateCommonName',
            type: {
              name: 'String'
            }
          },
          certificateIssuerThumbprint: {
            required: true,
            serializedName: 'certificateIssuerThumbprint',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ClientCertificateCommonName;
