/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Defines a health policy used to evaluate the health of the cluster or of a
 * cluster node.
 *
 */
class ClusterHealthPolicy {
  /**
   * Create a ClusterHealthPolicy.
   * @member {number} [maxPercentUnhealthyNodes] The maximum allowed percentage
   * of unhealthy nodes before reporting an error. For example, to allow 10% of
   * nodes to be unhealthy, this value would be 10.
   * @member {number} [maxPercentUnhealthyApplications] The maximum allowed
   * percentage of unhealthy applications before reporting an error. For
   * example, to allow 10% of applications to be unhealthy, this value would be
   * 10.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ClusterHealthPolicy
   *
   * @returns {object} metadata of ClusterHealthPolicy
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ClusterHealthPolicy',
      type: {
        name: 'Composite',
        className: 'ClusterHealthPolicy',
        modelProperties: {
          maxPercentUnhealthyNodes: {
            required: false,
            serializedName: 'maxPercentUnhealthyNodes',
            constraints: {
              InclusiveMaximum: 100,
              InclusiveMinimum: 0
            },
            type: {
              name: 'Number'
            }
          },
          maxPercentUnhealthyApplications: {
            required: false,
            serializedName: 'maxPercentUnhealthyApplications',
            constraints: {
              InclusiveMaximum: 100,
              InclusiveMinimum: 0
            },
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = ClusterHealthPolicy;
