/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The storage account information for storing Service Fabric diagnostic logs.
 *
 */
class DiagnosticsStorageAccountConfig {
  /**
   * Create a DiagnosticsStorageAccountConfig.
   * @member {string} storageAccountName The Azure storage account name.
   * @member {string} protectedAccountKeyName The protected diagnostics storage
   * key name.
   * @member {string} blobEndpoint The blob endpoint of the azure storage
   * account.
   * @member {string} queueEndpoint The queue endpoint of the azure storage
   * account.
   * @member {string} tableEndpoint The table endpoint of the azure storage
   * account.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DiagnosticsStorageAccountConfig
   *
   * @returns {object} metadata of DiagnosticsStorageAccountConfig
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DiagnosticsStorageAccountConfig',
      type: {
        name: 'Composite',
        className: 'DiagnosticsStorageAccountConfig',
        modelProperties: {
          storageAccountName: {
            required: true,
            serializedName: 'storageAccountName',
            type: {
              name: 'String'
            }
          },
          protectedAccountKeyName: {
            required: true,
            serializedName: 'protectedAccountKeyName',
            type: {
              name: 'String'
            }
          },
          blobEndpoint: {
            required: true,
            serializedName: 'blobEndpoint',
            type: {
              name: 'String'
            }
          },
          queueEndpoint: {
            required: true,
            serializedName: 'queueEndpoint',
            type: {
              name: 'String'
            }
          },
          tableEndpoint: {
            required: true,
            serializedName: 'tableEndpoint',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DiagnosticsStorageAccountConfig;
