/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

var msRestAzure = require('ms-rest-azure');

exports.BaseResource = msRestAzure.BaseResource;
exports.CloudError = msRestAzure.CloudError;
exports.ServiceTypeHealthPolicy = require('./serviceTypeHealthPolicy');
exports.ServiceTypeHealthPolicyMapItem = require('./serviceTypeHealthPolicyMapItem');
exports.ApplicationHealthPolicy = require('./applicationHealthPolicy');
exports.ApplicationMetricDescription = require('./applicationMetricDescription');
exports.ApplicationParameter = require('./applicationParameter');
exports.ServiceCorrelationDescription = require('./serviceCorrelationDescription');
exports.ServiceLoadMetricDescription = require('./serviceLoadMetricDescription');
exports.ServicePlacementPolicyDescription = require('./servicePlacementPolicyDescription');
exports.PartitionSchemeDescription = require('./partitionSchemeDescription');
exports.NamedPartitionSchemeDescription = require('./namedPartitionSchemeDescription');
exports.SingletonPartitionSchemeDescription = require('./singletonPartitionSchemeDescription');
exports.UniformInt64RangePartitionSchemeDescription = require('./uniformInt64RangePartitionSchemeDescription');
exports.ProxyResource = require('./proxyResource');
exports.ApplicationTypeResource = require('./applicationTypeResource');
exports.ApplicationTypeResourceList = require('./applicationTypeResourceList');
exports.VersionResource = require('./versionResource');
exports.VersionResourceList = require('./versionResourceList');
exports.ApplicationResource = require('./applicationResource');
exports.ApplicationResourceList = require('./applicationResourceList');
exports.RollingUpgradeMonitoringPolicy = require('./rollingUpgradeMonitoringPolicy');
exports.ApplicationUpgradePolicy = require('./applicationUpgradePolicy');
exports.ApplicationResourceUpdate = require('./applicationResourceUpdate');
exports.ServicePropertiesBase = require('./servicePropertiesBase');
exports.ServiceProperties = require('./serviceProperties');
exports.ServiceResource = require('./serviceResource');
exports.ServiceResourceList = require('./serviceResourceList');
exports.ServiceUpdateProperties = require('./serviceUpdateProperties');
exports.ServiceResourceUpdate = require('./serviceResourceUpdate');
exports.StatelessService = require('./statelessService');
exports.StatelessServiceUpdate = require('./statelessServiceUpdate');
exports.StatefulService = require('./statefulService');
exports.StatefulServiceUpdate = require('./statefulServiceUpdate');
exports.AvailableOperationDisplay = require('./availableOperationDisplay');
exports.AzureActiveDirectory = require('./azureActiveDirectory');
exports.CertificateDescription = require('./certificateDescription');
exports.ClientCertificateCommonName = require('./clientCertificateCommonName');
exports.ClientCertificateThumbprint = require('./clientCertificateThumbprint');
exports.ClusterVersionDetails = require('./clusterVersionDetails');
exports.SettingsParameterDescription = require('./settingsParameterDescription');
exports.SettingsSectionDescription = require('./settingsSectionDescription');
exports.EndpointRangeDescription = require('./endpointRangeDescription');
exports.NodeTypeDescription = require('./nodeTypeDescription');
exports.DiagnosticsStorageAccountConfig = require('./diagnosticsStorageAccountConfig');
exports.ClusterHealthPolicy = require('./clusterHealthPolicy');
exports.ClusterUpgradeDeltaHealthPolicy = require('./clusterUpgradeDeltaHealthPolicy');
exports.ClusterUpgradePolicy = require('./clusterUpgradePolicy');
exports.Resource = require('./resource');
exports.Cluster = require('./cluster');
exports.ClusterCodeVersionsResult = require('./clusterCodeVersionsResult');
exports.ClusterCodeVersionsListResult = require('./clusterCodeVersionsListResult');
exports.ClusterListResult = require('./clusterListResult');
exports.ClusterUpdateParameters = require('./clusterUpdateParameters');
exports.ErrorModel = require('./errorModel');
exports.OperationResult = require('./operationResult');
exports.ServiceTypeDeltaHealthPolicy = require('./serviceTypeDeltaHealthPolicy');
exports.OperationListResult = require('./operationListResult');
exports.discriminators = {
  'ServicePlacementPolicyDescription' : exports.ServicePlacementPolicyDescription,
  'PartitionSchemeDescription' : exports.PartitionSchemeDescription,
  'PartitionSchemeDescription.Named' : exports.NamedPartitionSchemeDescription,
  'PartitionSchemeDescription.Singleton' : exports.SingletonPartitionSchemeDescription,
  'PartitionSchemeDescription.UniformInt64Range' : exports.UniformInt64RangePartitionSchemeDescription,
  'ServicePropertiesBase.ServiceProperties' : exports.ServiceProperties,
  'ServicePropertiesBase.ServiceUpdateProperties' : exports.ServiceUpdateProperties,
  'ServicePropertiesBase.StatelessService' : exports.StatelessService,
  'ServicePropertiesBase.StatelessServiceUpdate' : exports.StatelessServiceUpdate,
  'ServicePropertiesBase.StatefulService' : exports.StatefulService,
  'ServicePropertiesBase.StatefulServiceUpdate' : exports.StatefulServiceUpdate
};
