/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The properties of a stateless service resource for patch operations.
 *
 * @extends models['ServiceUpdateProperties']
 */
class StatelessServiceUpdate extends models['ServiceUpdateProperties'] {
  /**
   * Create a StatelessServiceUpdate.
   * @member {number} [instanceCount] The instance count.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of StatelessServiceUpdate
   *
   * @returns {object} metadata of StatelessServiceUpdate
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'StatelessServiceUpdate',
      type: {
        name: 'Composite',
        className: 'StatelessServiceUpdate',
        modelProperties: {
          placementConstraints: {
            required: false,
            serializedName: 'placementConstraints',
            type: {
              name: 'String'
            }
          },
          correlationScheme: {
            required: false,
            serializedName: 'correlationScheme',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ServiceCorrelationDescriptionElementType',
                  type: {
                    name: 'Composite',
                    className: 'ServiceCorrelationDescription'
                  }
              }
            }
          },
          serviceLoadMetrics: {
            required: false,
            serializedName: 'serviceLoadMetrics',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ServiceLoadMetricDescriptionElementType',
                  type: {
                    name: 'Composite',
                    className: 'ServiceLoadMetricDescription'
                  }
              }
            }
          },
          servicePlacementPolicies: {
            required: false,
            serializedName: 'servicePlacementPolicies',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ServicePlacementPolicyDescriptionElementType',
                  type: {
                    name: 'Composite',
                    polymorphicDiscriminator: {
                      serializedName: 'Type',
                      clientName: 'type'
                    },
                    uberParent: 'ServicePlacementPolicyDescription',
                    className: 'ServicePlacementPolicyDescription'
                  }
              }
            }
          },
          defaultMoveCost: {
            required: false,
            serializedName: 'defaultMoveCost',
            type: {
              name: 'String'
            }
          },
          serviceResourceType: {
            required: true,
            serializedName: 'serviceResourceType',
            type: {
              name: 'String'
            }
          },
          instanceCount: {
            required: false,
            serializedName: 'instanceCount',
            constraints: {
              InclusiveMinimum: -1
            },
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = StatelessServiceUpdate;
