/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A version resource for the specified application type name.
 *
 * @extends models['ProxyResource']
 */
class VersionResource extends models['ProxyResource'] {
  /**
   * Create a VersionResource.
   * @member {string} [provisioningState] The current deployment or
   * provisioning state, which only appears in the response
   * @member {string} [appPackageUrl] The URL to the application package
   * @member {array} [defaultParameterList]
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of VersionResource
   *
   * @returns {object} metadata of VersionResource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VersionResource',
      type: {
        name: 'Composite',
        className: 'VersionResource',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          provisioningState: {
            required: false,
            readOnly: true,
            serializedName: 'properties.provisioningState',
            type: {
              name: 'String'
            }
          },
          appPackageUrl: {
            required: false,
            serializedName: 'properties.appPackageUrl',
            type: {
              name: 'String'
            }
          },
          defaultParameterList: {
            required: false,
            readOnly: true,
            serializedName: 'properties.defaultParameterList',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ApplicationParameterElementType',
                  type: {
                    name: 'Composite',
                    className: 'ApplicationParameter'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = VersionResource;
