/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * An error response from the API.
 *
 */
class ErrorResponse {
  /**
   * Create a ErrorResponse.
   * @member {object} error Error information.
   * @member {string} [error.code] Error code identifying the specific error.
   * @member {string} [error.message] Error message in the caller's locale.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ErrorResponse
   *
   * @returns {object} metadata of ErrorResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ErrorResponse',
      type: {
        name: 'Composite',
        className: 'ErrorResponse',
        modelProperties: {
          error: {
            required: true,
            serializedName: 'error',
            type: {
              name: 'Composite',
              className: 'ErrorModel'
            }
          }
        }
      }
    };
  }
}

module.exports = ErrorResponse;
