/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Reference to a machine.
 *
 * @extends models['ResourceReference']
 */
class MachineReference extends models['ResourceReference'] {
  /**
   * Create a MachineReference.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of MachineReference
   *
   * @returns {object} metadata of MachineReference
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ref:machine',
      type: {
        name: 'Composite',
        className: 'MachineReference',
        modelProperties: {
          id: {
            required: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: true,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = MachineReference;
