/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the resources of a machine.
 *
 */
class MachineResourcesConfiguration {
  /**
   * Create a MachineResourcesConfiguration.
   * @member {number} [physicalMemory] Physical memory in megabytes (MB).
   * @member {number} [cpus] Number of CPUs.
   * @member {number} [cpuSpeed] CPU speed in megahertz (Mhz).
   * @member {string} [cpuSpeedAccuracy] Describes the accuracy of the cpuSpeed
   * field. Possible values include: 'actual', 'estimated'
   */
  constructor() {
  }

  /**
   * Defines the metadata of MachineResourcesConfiguration
   *
   * @returns {object} metadata of MachineResourcesConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MachineResourcesConfiguration',
      type: {
        name: 'Composite',
        className: 'MachineResourcesConfiguration',
        modelProperties: {
          physicalMemory: {
            required: false,
            serializedName: 'physicalMemory',
            type: {
              name: 'Number'
            }
          },
          cpus: {
            required: false,
            serializedName: 'cpus',
            type: {
              name: 'Number'
            }
          },
          cpuSpeed: {
            required: false,
            serializedName: 'cpuSpeed',
            type: {
              name: 'Number'
            }
          },
          cpuSpeedAccuracy: {
            required: false,
            serializedName: 'cpuSpeedAccuracy',
            type: {
              name: 'Enum',
              allowedValues: [ 'actual', 'estimated' ]
            }
          }
        }
      }
    };
  }
}

module.exports = MachineResourcesConfiguration;
