/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A map of resources and relationships between them.
 *
 */
class Map {
  /**
   * Create a Map.
   * @member {object} nodes
   * @member {array} [nodes.machines] Machine resources.
   * @member {array} [nodes.processes] Process resources.
   * @member {array} [nodes.ports] Port resources.
   * @member {array} [nodes.clientGroups] Client Group resources.
   * @member {object} edges
   * @member {array} [edges.connections] Network connections.
   * @member {array} [edges.acceptors] Processes accepting on a port.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Map
   *
   * @returns {object} metadata of Map
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Map',
      type: {
        name: 'Composite',
        className: 'Map',
        modelProperties: {
          nodes: {
            required: true,
            serializedName: 'nodes',
            type: {
              name: 'Composite',
              className: 'MapNodes'
            }
          },
          edges: {
            required: true,
            serializedName: 'edges',
            type: {
              name: 'Composite',
              className: 'MapEdges'
            }
          }
        }
      }
    };
  }
}

module.exports = Map;
