/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The edges (relationships) of a map.
 *
 */
class MapEdges {
  /**
   * Create a MapEdges.
   * @member {array} [connections] Network connections.
   * @member {array} [acceptors] Processes accepting on a port.
   */
  constructor() {
  }

  /**
   * Defines the metadata of MapEdges
   *
   * @returns {object} metadata of MapEdges
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MapEdges',
      type: {
        name: 'Composite',
        className: 'MapEdges',
        modelProperties: {
          connections: {
            required: false,
            serializedName: 'connections',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ConnectionElementType',
                  type: {
                    name: 'Composite',
                    className: 'Connection'
                  }
              }
            }
          },
          acceptors: {
            required: false,
            serializedName: 'acceptors',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'AcceptorElementType',
                  type: {
                    name: 'Composite',
                    className: 'Acceptor'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = MapEdges;
