/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Describes the network configuration of a machine.
 *
 */
class NetworkConfiguration {
  /**
   * Create a NetworkConfiguration.
   * @member {array} [ipv4Interfaces] IPv4 interfaces.
   * @member {array} [ipv6Interfaces] IPv6 interfaces.
   * @member {array} [defaultIpv4Gateways] Default IPv4 gateways.
   * @member {array} [macAddresses] MAC addresses of all active network
   * interfaces.
   * @member {array} [dnsNames] DNS names associated with the machine.
   */
  constructor() {
  }

  /**
   * Defines the metadata of NetworkConfiguration
   *
   * @returns {object} metadata of NetworkConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NetworkConfiguration',
      type: {
        name: 'Composite',
        className: 'NetworkConfiguration',
        modelProperties: {
          ipv4Interfaces: {
            required: false,
            serializedName: 'ipv4Interfaces',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'Ipv4NetworkInterfaceElementType',
                  type: {
                    name: 'Composite',
                    className: 'Ipv4NetworkInterface'
                  }
              }
            }
          },
          ipv6Interfaces: {
            required: false,
            serializedName: 'ipv6Interfaces',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'Ipv6NetworkInterfaceElementType',
                  type: {
                    name: 'Composite',
                    className: 'Ipv6NetworkInterface'
                  }
              }
            }
          },
          defaultIpv4Gateways: {
            required: false,
            serializedName: 'defaultIpv4Gateways',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          macAddresses: {
            required: false,
            serializedName: 'macAddresses',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          dnsNames: {
            required: false,
            serializedName: 'dnsNames',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = NetworkConfiguration;
