/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the configuration of the operating system of a machine.
 *
 */
class OperatingSystemConfiguration {
  /**
   * Create a OperatingSystemConfiguration.
   * @member {string} family Windows, Linux, etc. Possible values include:
   * 'unknown', 'windows', 'linux', 'solaris', 'aix'
   * @member {string} fullName Operating system full name.
   * @member {string} bitness Operating system bitness (32-bit or 64-bit).
   * Possible values include: '32bit', '64bit'
   */
  constructor() {
  }

  /**
   * Defines the metadata of OperatingSystemConfiguration
   *
   * @returns {object} metadata of OperatingSystemConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OperatingSystemConfiguration',
      type: {
        name: 'Composite',
        className: 'OperatingSystemConfiguration',
        modelProperties: {
          family: {
            required: true,
            serializedName: 'family',
            type: {
              name: 'Enum',
              allowedValues: [ 'unknown', 'windows', 'linux', 'solaris', 'aix' ]
            }
          },
          fullName: {
            required: true,
            serializedName: 'fullName',
            type: {
              name: 'String'
            }
          },
          bitness: {
            required: true,
            serializedName: 'bitness',
            type: {
              name: 'Enum',
              allowedValues: [ '32bit', '64bit' ]
            }
          }
        }
      }
    };
  }
}

module.exports = OperatingSystemConfiguration;
