/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Relationship properties.
 *
 */
class RelationshipProperties {
  /**
   * Create a RelationshipProperties.
   * @member {object} source Source resource of the relationship.
   * @member {string} [source.id] Resource URI.
   * @member {string} [source.type] Resource type qualifier.
   * @member {string} [source.name] Resource name.
   * @member {string} [source.kind] Polymorphic Discriminator
   * @member {object} destination Destination resource of the relationship.
   * @member {string} [destination.id] Resource URI.
   * @member {string} [destination.type] Resource type qualifier.
   * @member {string} [destination.name] Resource name.
   * @member {string} [destination.kind] Polymorphic Discriminator
   * @member {date} [startTime] Relationship start time.
   * @member {date} [endTime] Relationship end time.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RelationshipProperties
   *
   * @returns {object} metadata of RelationshipProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RelationshipProperties',
      type: {
        name: 'Composite',
        className: 'RelationshipProperties',
        modelProperties: {
          source: {
            required: true,
            serializedName: 'source',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'kind',
                clientName: 'kind'
              },
              uberParent: 'ResourceReference',
              className: 'ResourceReference'
            }
          },
          destination: {
            required: true,
            serializedName: 'destination',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'kind',
                clientName: 'kind'
              },
              uberParent: 'ResourceReference',
              className: 'ResourceReference'
            }
          },
          startTime: {
            required: false,
            serializedName: 'startTime',
            type: {
              name: 'DateTime'
            }
          },
          endTime: {
            required: false,
            serializedName: 'endTime',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = RelationshipProperties;
