/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A backup long term retention policy
 *
 * @extends models['ProxyResource']
 */
class BackupLongTermRetentionPolicy extends models['ProxyResource'] {
  /**
   * Create a BackupLongTermRetentionPolicy.
   * @member {string} [location] The geo-location where the resource lives
   * @member {string} state The status of the backup long term retention
   * policy. Possible values include: 'Disabled', 'Enabled'
   * @member {string} recoveryServicesBackupPolicyResourceId The azure recovery
   * services backup protection policy resource id
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of BackupLongTermRetentionPolicy
   *
   * @returns {object} metadata of BackupLongTermRetentionPolicy
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BackupLongTermRetentionPolicy',
      type: {
        name: 'Composite',
        className: 'BackupLongTermRetentionPolicy',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            readOnly: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          state: {
            required: true,
            serializedName: 'properties.state',
            type: {
              name: 'Enum',
              allowedValues: [ 'Disabled', 'Enabled' ]
            }
          },
          recoveryServicesBackupPolicyResourceId: {
            required: true,
            serializedName: 'properties.recoveryServicesBackupPolicyResourceId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = BackupLongTermRetentionPolicy;
