/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A backup long term retention vault
 *
 * @extends models['ProxyResource']
 */
class BackupLongTermRetentionVault extends models['ProxyResource'] {
  /**
   * Create a BackupLongTermRetentionVault.
   * @member {string} [location] The geo-location where the resource lives
   * @member {string} recoveryServicesVaultResourceId The azure recovery
   * services vault resource id
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of BackupLongTermRetentionVault
   *
   * @returns {object} metadata of BackupLongTermRetentionVault
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BackupLongTermRetentionVault',
      type: {
        name: 'Composite',
        className: 'BackupLongTermRetentionVault',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            readOnly: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          recoveryServicesVaultResourceId: {
            required: true,
            serializedName: 'properties.recoveryServicesVaultResourceId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = BackupLongTermRetentionVault;
