/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A request to check whether the specified name for a resource is available.
 *
 */
class CheckNameAvailabilityRequest {
  /**
   * Create a CheckNameAvailabilityRequest.
   * @member {string} name The name whose availability is to be checked.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CheckNameAvailabilityRequest
   *
   * @returns {object} metadata of CheckNameAvailabilityRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CheckNameAvailabilityRequest',
      type: {
        name: 'Composite',
        className: 'CheckNameAvailabilityRequest',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: true,
            isConstant: true,
            serializedName: 'type',
            defaultValue: 'Microsoft.Sql/servers',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CheckNameAvailabilityRequest;
