/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The database edition capabilities.
 *
 */
class EditionCapability {
  /**
   * Create a EditionCapability.
   * @member {string} [name] The edition name.
   * @member {string} [status] The status of the edition. Possible values
   * include: 'Visible', 'Available', 'Default', 'Disabled'
   * @member {array} [supportedServiceLevelObjectives] The list of supported
   * service objectives for the edition.
   */
  constructor() {
  }

  /**
   * Defines the metadata of EditionCapability
   *
   * @returns {object} metadata of EditionCapability
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EditionCapability',
      type: {
        name: 'Composite',
        className: 'EditionCapability',
        modelProperties: {
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            readOnly: true,
            serializedName: 'status',
            type: {
              name: 'Enum',
              allowedValues: [ 'Visible', 'Available', 'Default', 'Disabled' ]
            }
          },
          supportedServiceLevelObjectives: {
            required: false,
            readOnly: true,
            serializedName: 'supportedServiceLevelObjectives',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ServiceObjectiveCapabilityElementType',
                  type: {
                    name: 'Composite',
                    className: 'ServiceObjectiveCapability'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = EditionCapability;
