/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The max per-database DTU capability.
 *
 */
class ElasticPoolPerDatabaseMaxDtuCapability {
  /**
   * Create a ElasticPoolPerDatabaseMaxDtuCapability.
   * @member {number} [limit] The maximum DTUs per database.
   * @member {string} [status] The status of the capability. Possible values
   * include: 'Visible', 'Available', 'Default', 'Disabled'
   * @member {array} [supportedPerDatabaseMinDtus] The list of supported min
   * database DTUs.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ElasticPoolPerDatabaseMaxDtuCapability
   *
   * @returns {object} metadata of ElasticPoolPerDatabaseMaxDtuCapability
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ElasticPoolPerDatabaseMaxDtuCapability',
      type: {
        name: 'Composite',
        className: 'ElasticPoolPerDatabaseMaxDtuCapability',
        modelProperties: {
          limit: {
            required: false,
            readOnly: true,
            serializedName: 'limit',
            type: {
              name: 'Number'
            }
          },
          status: {
            required: false,
            readOnly: true,
            serializedName: 'status',
            type: {
              name: 'Enum',
              allowedValues: [ 'Visible', 'Available', 'Default', 'Disabled' ]
            }
          },
          supportedPerDatabaseMinDtus: {
            required: false,
            readOnly: true,
            serializedName: 'supportedPerDatabaseMinDtus',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ElasticPoolPerDatabaseMinDtuCapabilityElementType',
                  type: {
                    name: 'Composite',
                    className: 'ElasticPoolPerDatabaseMinDtuCapability'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ElasticPoolPerDatabaseMaxDtuCapability;
