/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A database geo backup policy.
 *
 * @extends models['ProxyResource']
 */
class GeoBackupPolicy extends models['ProxyResource'] {
  /**
   * Create a GeoBackupPolicy.
   * @member {string} state The state of the geo backup policy. Possible values
   * include: 'Disabled', 'Enabled'
   * @member {string} [storageType] The storage type of the geo backup policy.
   * @member {string} [kind] Kind of geo backup policy.  This is metadata used
   * for the Azure portal experience.
   * @member {string} [location] Backup policy location.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of GeoBackupPolicy
   *
   * @returns {object} metadata of GeoBackupPolicy
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GeoBackupPolicy',
      type: {
        name: 'Composite',
        className: 'GeoBackupPolicy',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          state: {
            required: true,
            serializedName: 'properties.state',
            type: {
              name: 'Enum',
              allowedValues: [ 'Disabled', 'Enabled' ]
            }
          },
          storageType: {
            required: false,
            readOnly: true,
            serializedName: 'properties.storageType',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            readOnly: true,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            readOnly: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = GeoBackupPolicy;
