/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

var msRestAzure = require('ms-rest-azure');

exports.BaseResource = msRestAzure.BaseResource;
exports.CloudError = msRestAzure.CloudError;
exports.Resource = require('./resource');
exports.ProxyResource = require('./proxyResource');
exports.BackupLongTermRetentionPolicy = require('./backupLongTermRetentionPolicy');
exports.BackupLongTermRetentionVault = require('./backupLongTermRetentionVault');
exports.TrackedResource = require('./trackedResource');
exports.RestorePoint = require('./restorePoint');
exports.RecoverableDatabase = require('./recoverableDatabase');
exports.RestorableDroppedDatabase = require('./restorableDroppedDatabase');
exports.MaxSizeCapability = require('./maxSizeCapability');
exports.ServiceObjectiveCapability = require('./serviceObjectiveCapability');
exports.EditionCapability = require('./editionCapability');
exports.ElasticPoolPerDatabaseMinDtuCapability = require('./elasticPoolPerDatabaseMinDtuCapability');
exports.ElasticPoolPerDatabaseMaxDtuCapability = require('./elasticPoolPerDatabaseMaxDtuCapability');
exports.ElasticPoolDtuCapability = require('./elasticPoolDtuCapability');
exports.ElasticPoolEditionCapability = require('./elasticPoolEditionCapability');
exports.ServerVersionCapability = require('./serverVersionCapability');
exports.LocationCapabilities = require('./locationCapabilities');
exports.ServerConnectionPolicy = require('./serverConnectionPolicy');
exports.DatabaseSecurityAlertPolicy = require('./databaseSecurityAlertPolicy');
exports.DataMaskingPolicy = require('./dataMaskingPolicy');
exports.DataMaskingRule = require('./dataMaskingRule');
exports.FirewallRule = require('./firewallRule');
exports.GeoBackupPolicy = require('./geoBackupPolicy');
exports.ImportExtensionRequest = require('./importExtensionRequest');
exports.ImportExportResponse = require('./importExportResponse');
exports.ExportRequest = require('./exportRequest');
exports.ImportRequest = require('./importRequest');
exports.MetricValue = require('./metricValue');
exports.MetricName = require('./metricName');
exports.Metric = require('./metric');
exports.MetricAvailability = require('./metricAvailability');
exports.MetricDefinition = require('./metricDefinition');
exports.ReplicationLink = require('./replicationLink');
exports.ServerAzureADAdministrator = require('./serverAzureADAdministrator');
exports.ServerCommunicationLink = require('./serverCommunicationLink');
exports.ServiceObjective = require('./serviceObjective');
exports.CheckNameAvailabilityRequest = require('./checkNameAvailabilityRequest');
exports.CheckNameAvailabilityResponse = require('./checkNameAvailabilityResponse');
exports.RecommendedElasticPoolMetric = require('./recommendedElasticPoolMetric');
exports.SloUsageMetric = require('./sloUsageMetric');
exports.ServiceTierAdvisor = require('./serviceTierAdvisor');
exports.TransparentDataEncryption = require('./transparentDataEncryption');
exports.OperationImpact = require('./operationImpact');
exports.RecommendedIndex = require('./recommendedIndex');
exports.Database = require('./database');
exports.RecommendedElasticPool = require('./recommendedElasticPool');
exports.ElasticPool = require('./elasticPool');
exports.ElasticPoolUpdate = require('./elasticPoolUpdate');
exports.ElasticPoolActivity = require('./elasticPoolActivity');
exports.ElasticPoolDatabaseActivity = require('./elasticPoolDatabaseActivity');
exports.DatabaseUpdate = require('./databaseUpdate');
exports.TransparentDataEncryptionActivity = require('./transparentDataEncryptionActivity');
exports.ServerUsage = require('./serverUsage');
exports.DatabaseUsage = require('./databaseUsage');
exports.DatabaseBlobAuditingPolicy = require('./databaseBlobAuditingPolicy');
exports.EncryptionProtector = require('./encryptionProtector');
exports.FailoverGroupReadWriteEndpoint = require('./failoverGroupReadWriteEndpoint');
exports.FailoverGroupReadOnlyEndpoint = require('./failoverGroupReadOnlyEndpoint');
exports.PartnerInfo = require('./partnerInfo');
exports.FailoverGroup = require('./failoverGroup');
exports.FailoverGroupUpdate = require('./failoverGroupUpdate');
exports.OperationDisplay = require('./operationDisplay');
exports.Operation = require('./operation');
exports.ServerKey = require('./serverKey');
exports.ResourceIdentity = require('./resourceIdentity');
exports.Server = require('./server');
exports.ServerUpdate = require('./serverUpdate');
exports.SyncAgent = require('./syncAgent');
exports.SyncAgentKeyProperties = require('./syncAgentKeyProperties');
exports.SyncAgentLinkedDatabase = require('./syncAgentLinkedDatabase');
exports.SyncDatabaseIdProperties = require('./syncDatabaseIdProperties');
exports.SyncFullSchemaTableColumn = require('./syncFullSchemaTableColumn');
exports.SyncFullSchemaTable = require('./syncFullSchemaTable');
exports.SyncFullSchemaProperties = require('./syncFullSchemaProperties');
exports.SyncGroupLogProperties = require('./syncGroupLogProperties');
exports.SyncGroupSchemaTableColumn = require('./syncGroupSchemaTableColumn');
exports.SyncGroupSchemaTable = require('./syncGroupSchemaTable');
exports.SyncGroupSchema = require('./syncGroupSchema');
exports.SyncGroup = require('./syncGroup');
exports.SyncMember = require('./syncMember');
exports.VirtualNetworkRule = require('./virtualNetworkRule');
exports.DatabaseOperation = require('./databaseOperation');
exports.RestorePointListResult = require('./restorePointListResult');
exports.RecoverableDatabaseListResult = require('./recoverableDatabaseListResult');
exports.RestorableDroppedDatabaseListResult = require('./restorableDroppedDatabaseListResult');
exports.DataMaskingRuleListResult = require('./dataMaskingRuleListResult');
exports.FirewallRuleListResult = require('./firewallRuleListResult');
exports.GeoBackupPolicyListResult = require('./geoBackupPolicyListResult');
exports.MetricListResult = require('./metricListResult');
exports.MetricDefinitionListResult = require('./metricDefinitionListResult');
exports.DatabaseListResult = require('./databaseListResult');
exports.ElasticPoolListResult = require('./elasticPoolListResult');
exports.ReplicationLinkListResult = require('./replicationLinkListResult');
exports.ServerAdministratorListResult = require('./serverAdministratorListResult');
exports.ServerCommunicationLinkListResult = require('./serverCommunicationLinkListResult');
exports.ServiceObjectiveListResult = require('./serviceObjectiveListResult');
exports.ServerListResult = require('./serverListResult');
exports.ElasticPoolActivityListResult = require('./elasticPoolActivityListResult');
exports.ElasticPoolDatabaseActivityListResult = require('./elasticPoolDatabaseActivityListResult');
exports.RecommendedElasticPoolListResult = require('./recommendedElasticPoolListResult');
exports.RecommendedElasticPoolListMetricsResult = require('./recommendedElasticPoolListMetricsResult');
exports.ServiceTierAdvisorListResult = require('./serviceTierAdvisorListResult');
exports.TransparentDataEncryptionActivityListResult = require('./transparentDataEncryptionActivityListResult');
exports.ServerUsageListResult = require('./serverUsageListResult');
exports.DatabaseUsageListResult = require('./databaseUsageListResult');
exports.EncryptionProtectorListResult = require('./encryptionProtectorListResult');
exports.FailoverGroupListResult = require('./failoverGroupListResult');
exports.OperationListResult = require('./operationListResult');
exports.ServerKeyListResult = require('./serverKeyListResult');
exports.SyncAgentListResult = require('./syncAgentListResult');
exports.SyncAgentLinkedDatabaseListResult = require('./syncAgentLinkedDatabaseListResult');
exports.SyncDatabaseIdListResult = require('./syncDatabaseIdListResult');
exports.SyncFullSchemaPropertiesListResult = require('./syncFullSchemaPropertiesListResult');
exports.SyncGroupLogListResult = require('./syncGroupLogListResult');
exports.SyncGroupListResult = require('./syncGroupListResult');
exports.SyncMemberListResult = require('./syncMemberListResult');
exports.VirtualNetworkRuleListResult = require('./virtualNetworkRuleListResult');
exports.DatabaseOperationListResult = require('./databaseOperationListResult');
