/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A metric availability value.
 *
 */
class MetricAvailability {
  /**
   * Create a MetricAvailability.
   * @member {string} [retention] The length of retention for the database
   * metric.
   * @member {string} [timeGrain] The granularity of the database metric.
   */
  constructor() {
  }

  /**
   * Defines the metadata of MetricAvailability
   *
   * @returns {object} metadata of MetricAvailability
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MetricAvailability',
      type: {
        name: 'Composite',
        className: 'MetricAvailability',
        modelProperties: {
          retention: {
            required: false,
            readOnly: true,
            serializedName: 'retention',
            type: {
              name: 'String'
            }
          },
          timeGrain: {
            required: false,
            readOnly: true,
            serializedName: 'timeGrain',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = MetricAvailability;
