/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A restorable dropped database
 *
 * @extends models['ProxyResource']
 */
class RestorableDroppedDatabase extends models['ProxyResource'] {
  /**
   * Create a RestorableDroppedDatabase.
   * @member {string} [location] The geo-location where the resource lives
   * @member {string} [databaseName] The name of the database
   * @member {string} [edition] The edition of the database
   * @member {string} [maxSizeBytes] The max size in bytes of the database
   * @member {string} [serviceLevelObjective] The service level objective name
   * of the database
   * @member {string} [elasticPoolName] The elastic pool name of the database
   * @member {date} [creationDate] The creation date of the database (ISO8601
   * format)
   * @member {date} [deletionDate] The deletion date of the database (ISO8601
   * format)
   * @member {date} [earliestRestoreDate] The earliest restore date of the
   * database (ISO8601 format)
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of RestorableDroppedDatabase
   *
   * @returns {object} metadata of RestorableDroppedDatabase
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RestorableDroppedDatabase',
      type: {
        name: 'Composite',
        className: 'RestorableDroppedDatabase',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            readOnly: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          databaseName: {
            required: false,
            readOnly: true,
            serializedName: 'properties.databaseName',
            type: {
              name: 'String'
            }
          },
          edition: {
            required: false,
            readOnly: true,
            serializedName: 'properties.edition',
            type: {
              name: 'String'
            }
          },
          maxSizeBytes: {
            required: false,
            readOnly: true,
            serializedName: 'properties.maxSizeBytes',
            type: {
              name: 'String'
            }
          },
          serviceLevelObjective: {
            required: false,
            readOnly: true,
            serializedName: 'properties.serviceLevelObjective',
            type: {
              name: 'String'
            }
          },
          elasticPoolName: {
            required: false,
            readOnly: true,
            serializedName: 'properties.elasticPoolName',
            type: {
              name: 'String'
            }
          },
          creationDate: {
            required: false,
            readOnly: true,
            serializedName: 'properties.creationDate',
            type: {
              name: 'DateTime'
            }
          },
          deletionDate: {
            required: false,
            readOnly: true,
            serializedName: 'properties.deletionDate',
            type: {
              name: 'DateTime'
            }
          },
          earliestRestoreDate: {
            required: false,
            readOnly: true,
            serializedName: 'properties.earliestRestoreDate',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = RestorableDroppedDatabase;
