/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * An server Active Directory Administrator.
 *
 * @extends models['ProxyResource']
 */
class ServerAzureADAdministrator extends models['ProxyResource'] {
  /**
   * Create a ServerAzureADAdministrator.
   * @member {string} login The server administrator login value.
   * @member {uuid} sid The server administrator Sid (Secure ID).
   * @member {uuid} tenantId The server Active Directory Administrator tenant
   * id.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ServerAzureADAdministrator
   *
   * @returns {object} metadata of ServerAzureADAdministrator
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ServerAzureADAdministrator',
      type: {
        name: 'Composite',
        className: 'ServerAzureADAdministrator',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          administratorType: {
            required: true,
            isConstant: true,
            serializedName: 'properties.administratorType',
            defaultValue: 'ActiveDirectory',
            type: {
              name: 'String'
            }
          },
          login: {
            required: true,
            serializedName: 'properties.login',
            type: {
              name: 'String'
            }
          },
          sid: {
            required: true,
            serializedName: 'properties.sid',
            type: {
              name: 'String'
            }
          },
          tenantId: {
            required: true,
            serializedName: 'properties.tenantId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ServerAzureADAdministrator;
