/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Server communication link.
 *
 * @extends models['ProxyResource']
 */
class ServerCommunicationLink extends models['ProxyResource'] {
  /**
   * Create a ServerCommunicationLink.
   * @member {string} [state] The state.
   * @member {string} partnerServer The name of the partner server.
   * @member {string} [location] Communication link location.
   * @member {string} [kind] Communication link kind.  This property is used
   * for Azure Portal metadata.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ServerCommunicationLink
   *
   * @returns {object} metadata of ServerCommunicationLink
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ServerCommunicationLink',
      type: {
        name: 'Composite',
        className: 'ServerCommunicationLink',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          state: {
            required: false,
            readOnly: true,
            serializedName: 'properties.state',
            type: {
              name: 'String'
            }
          },
          partnerServer: {
            required: true,
            serializedName: 'properties.partnerServer',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            readOnly: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            readOnly: true,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ServerCommunicationLink;
