/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A server secure connection policy.
 *
 * @extends models['ProxyResource']
 */
class ServerConnectionPolicy extends models['ProxyResource'] {
  /**
   * Create a ServerConnectionPolicy.
   * @member {string} [kind] Metadata used for the Azure portal experience.
   * @member {string} [location] Resource location.
   * @member {string} connectionType The server connection type. Possible
   * values include: 'Default', 'Proxy', 'Redirect'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ServerConnectionPolicy
   *
   * @returns {object} metadata of ServerConnectionPolicy
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ServerConnectionPolicy',
      type: {
        name: 'Composite',
        className: 'ServerConnectionPolicy',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            readOnly: true,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            readOnly: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          connectionType: {
            required: true,
            serializedName: 'properties.connectionType',
            type: {
              name: 'Enum',
              allowedValues: [ 'Default', 'Proxy', 'Redirect' ]
            }
          }
        }
      }
    };
  }
}

module.exports = ServerConnectionPolicy;
