/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An update request for an Azure SQL Database server.
 *
 */
class ServerUpdate {
  /**
   * Create a ServerUpdate.
   * @member {string} [administratorLogin] Administrator username for the
   * server. Once created it cannot be changed.
   * @member {string} [administratorLoginPassword] The administrator login
   * password (required for server creation).
   * @member {string} [version] The version of the server.
   * @member {string} [state] The state of the server.
   * @member {string} [fullyQualifiedDomainName] The fully qualified domain
   * name of the server.
   * @member {object} [tags] Resource tags.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ServerUpdate
   *
   * @returns {object} metadata of ServerUpdate
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ServerUpdate',
      type: {
        name: 'Composite',
        className: 'ServerUpdate',
        modelProperties: {
          administratorLogin: {
            required: false,
            serializedName: 'properties.administratorLogin',
            type: {
              name: 'String'
            }
          },
          administratorLoginPassword: {
            required: false,
            serializedName: 'properties.administratorLoginPassword',
            type: {
              name: 'String'
            }
          },
          version: {
            required: false,
            serializedName: 'properties.version',
            type: {
              name: 'String'
            }
          },
          state: {
            required: false,
            readOnly: true,
            serializedName: 'properties.state',
            type: {
              name: 'String'
            }
          },
          fullyQualifiedDomainName: {
            required: false,
            readOnly: true,
            serializedName: 'properties.fullyQualifiedDomainName',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ServerUpdate;
