/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents server metrics.
 *
 */
class ServerUsage {
  /**
   * Create a ServerUsage.
   * @member {string} [name] Name of the server usage metric.
   * @member {string} [resourceName] The name of the resource.
   * @member {string} [displayName] The metric display name.
   * @member {number} [currentValue] The current value of the metric.
   * @member {number} [limit] The current limit of the metric.
   * @member {string} [unit] The units of the metric.
   * @member {date} [nextResetTime] The next reset time for the metric (ISO8601
   * format).
   */
  constructor() {
  }

  /**
   * Defines the metadata of ServerUsage
   *
   * @returns {object} metadata of ServerUsage
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ServerUsage',
      type: {
        name: 'Composite',
        className: 'ServerUsage',
        modelProperties: {
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          resourceName: {
            required: false,
            readOnly: true,
            serializedName: 'resourceName',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            readOnly: true,
            serializedName: 'displayName',
            type: {
              name: 'String'
            }
          },
          currentValue: {
            required: false,
            readOnly: true,
            serializedName: 'currentValue',
            type: {
              name: 'Number'
            }
          },
          limit: {
            required: false,
            readOnly: true,
            serializedName: 'limit',
            type: {
              name: 'Number'
            }
          },
          unit: {
            required: false,
            readOnly: true,
            serializedName: 'unit',
            type: {
              name: 'String'
            }
          },
          nextResetTime: {
            required: false,
            readOnly: true,
            serializedName: 'nextResetTime',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = ServerUsage;
