/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The server capabilities.
 *
 */
class ServerVersionCapability {
  /**
   * Create a ServerVersionCapability.
   * @member {string} [name] The server version name.
   * @member {string} [status] The status of the server version. Possible
   * values include: 'Visible', 'Available', 'Default', 'Disabled'
   * @member {array} [supportedEditions] The list of supported database
   * editions.
   * @member {array} [supportedElasticPoolEditions] The list of supported
   * elastic pool editions.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ServerVersionCapability
   *
   * @returns {object} metadata of ServerVersionCapability
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ServerVersionCapability',
      type: {
        name: 'Composite',
        className: 'ServerVersionCapability',
        modelProperties: {
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            readOnly: true,
            serializedName: 'status',
            type: {
              name: 'Enum',
              allowedValues: [ 'Visible', 'Available', 'Default', 'Disabled' ]
            }
          },
          supportedEditions: {
            required: false,
            readOnly: true,
            serializedName: 'supportedEditions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'EditionCapabilityElementType',
                  type: {
                    name: 'Composite',
                    className: 'EditionCapability'
                  }
              }
            }
          },
          supportedElasticPoolEditions: {
            required: false,
            readOnly: true,
            serializedName: 'supportedElasticPoolEditions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ElasticPoolEditionCapabilityElementType',
                  type: {
                    name: 'Composite',
                    className: 'ElasticPoolEditionCapability'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ServerVersionCapability;
