/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Represents a database service objective.
 *
 * @extends models['ProxyResource']
 */
class ServiceObjective extends models['ProxyResource'] {
  /**
   * Create a ServiceObjective.
   * @member {string} [serviceObjectiveName] The name for the service
   * objective.
   * @member {boolean} [isDefault] Gets whether the service level objective is
   * the default service objective.
   * @member {boolean} [isSystem] Gets whether the service level objective is a
   * system service objective.
   * @member {string} [description] The description for the service level
   * objective.
   * @member {boolean} [enabled] Gets whether the service level objective is
   * enabled.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ServiceObjective
   *
   * @returns {object} metadata of ServiceObjective
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ServiceObjective',
      type: {
        name: 'Composite',
        className: 'ServiceObjective',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          serviceObjectiveName: {
            required: false,
            readOnly: true,
            serializedName: 'properties.serviceObjectiveName',
            type: {
              name: 'String'
            }
          },
          isDefault: {
            required: false,
            readOnly: true,
            serializedName: 'properties.isDefault',
            type: {
              name: 'Boolean'
            }
          },
          isSystem: {
            required: false,
            readOnly: true,
            serializedName: 'properties.isSystem',
            type: {
              name: 'Boolean'
            }
          },
          description: {
            required: false,
            readOnly: true,
            serializedName: 'properties.description',
            type: {
              name: 'String'
            }
          },
          enabled: {
            required: false,
            readOnly: true,
            serializedName: 'properties.enabled',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = ServiceObjective;
