/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A Slo Usage Metric.
 *
 */
class SloUsageMetric {
  /**
   * Create a SloUsageMetric.
   * @member {string} [serviceLevelObjective] The serviceLevelObjective for SLO
   * usage metric. Possible values include: 'Basic', 'S0', 'S1', 'S2', 'S3',
   * 'P1', 'P2', 'P3', 'P4', 'P6', 'P11', 'P15', 'System', 'System2',
   * 'ElasticPool'
   * @member {uuid} [serviceLevelObjectiveId] The serviceLevelObjectiveId for
   * SLO usage metric.
   * @member {number} [inRangeTimeRatio] Gets or sets inRangeTimeRatio for SLO
   * usage metric.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SloUsageMetric
   *
   * @returns {object} metadata of SloUsageMetric
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SloUsageMetric',
      type: {
        name: 'Composite',
        className: 'SloUsageMetric',
        modelProperties: {
          serviceLevelObjective: {
            required: false,
            readOnly: true,
            serializedName: 'serviceLevelObjective',
            type: {
              name: 'String'
            }
          },
          serviceLevelObjectiveId: {
            required: false,
            readOnly: true,
            serializedName: 'serviceLevelObjectiveId',
            type: {
              name: 'String'
            }
          },
          inRangeTimeRatio: {
            required: false,
            readOnly: true,
            serializedName: 'inRangeTimeRatio',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = SloUsageMetric;
