/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Properties of the database full schema.
 *
 */
class SyncFullSchemaProperties {
  /**
   * Create a SyncFullSchemaProperties.
   * @member {array} [tables] List of tables in the database full schema.
   * @member {date} [lastUpdateTime] Last update time of the database schema.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SyncFullSchemaProperties
   *
   * @returns {object} metadata of SyncFullSchemaProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SyncFullSchemaProperties',
      type: {
        name: 'Composite',
        className: 'SyncFullSchemaProperties',
        modelProperties: {
          tables: {
            required: false,
            readOnly: true,
            serializedName: 'tables',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'SyncFullSchemaTableElementType',
                  type: {
                    name: 'Composite',
                    className: 'SyncFullSchemaTable'
                  }
              }
            }
          },
          lastUpdateTime: {
            required: false,
            readOnly: true,
            serializedName: 'lastUpdateTime',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = SyncFullSchemaProperties;
