/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties of the column in the table of database full schema.
 *
 */
class SyncFullSchemaTableColumn {
  /**
   * Create a SyncFullSchemaTableColumn.
   * @member {string} [dataSize] Data size of the column.
   * @member {string} [dataType] Data type of the column.
   * @member {string} [errorId] Error id of the column.
   * @member {boolean} [hasError] If there is error in the table.
   * @member {boolean} [isPrimaryKey] If it is the primary key of the table.
   * @member {string} [name] Name of the column.
   * @member {string} [quotedName] Quoted name of the column.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SyncFullSchemaTableColumn
   *
   * @returns {object} metadata of SyncFullSchemaTableColumn
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SyncFullSchemaTableColumn',
      type: {
        name: 'Composite',
        className: 'SyncFullSchemaTableColumn',
        modelProperties: {
          dataSize: {
            required: false,
            readOnly: true,
            serializedName: 'dataSize',
            type: {
              name: 'String'
            }
          },
          dataType: {
            required: false,
            readOnly: true,
            serializedName: 'dataType',
            type: {
              name: 'String'
            }
          },
          errorId: {
            required: false,
            readOnly: true,
            serializedName: 'errorId',
            type: {
              name: 'String'
            }
          },
          hasError: {
            required: false,
            readOnly: true,
            serializedName: 'hasError',
            type: {
              name: 'Boolean'
            }
          },
          isPrimaryKey: {
            required: false,
            readOnly: true,
            serializedName: 'isPrimaryKey',
            type: {
              name: 'Boolean'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          quotedName: {
            required: false,
            readOnly: true,
            serializedName: 'quotedName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SyncFullSchemaTableColumn;
