/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Properties of table in sync group schema.
 *
 */
class SyncGroupSchemaTable {
  /**
   * Create a SyncGroupSchemaTable.
   * @member {array} [columns] List of columns in sync group schema.
   * @member {string} [quotedName] Quoted name of sync group schema table.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SyncGroupSchemaTable
   *
   * @returns {object} metadata of SyncGroupSchemaTable
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SyncGroupSchemaTable',
      type: {
        name: 'Composite',
        className: 'SyncGroupSchemaTable',
        modelProperties: {
          columns: {
            required: false,
            serializedName: 'columns',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'SyncGroupSchemaTableColumnElementType',
                  type: {
                    name: 'Composite',
                    className: 'SyncGroupSchemaTableColumn'
                  }
              }
            }
          },
          quotedName: {
            required: false,
            serializedName: 'quotedName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SyncGroupSchemaTable;
