/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Represents a database transparent data encryption Scan.
 *
 * @extends models['ProxyResource']
 */
class TransparentDataEncryptionActivity extends models['ProxyResource'] {
  /**
   * Create a TransparentDataEncryptionActivity.
   * @member {string} [location] Resource location.
   * @member {string} [status] The status of the database. Possible values
   * include: 'Encrypting', 'Decrypting'
   * @member {number} [percentComplete] The percent complete of the transparent
   * data encryption scan for a database.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of TransparentDataEncryptionActivity
   *
   * @returns {object} metadata of TransparentDataEncryptionActivity
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TransparentDataEncryptionActivity',
      type: {
        name: 'Composite',
        className: 'TransparentDataEncryptionActivity',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            readOnly: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            readOnly: true,
            serializedName: 'properties.status',
            type: {
              name: 'String'
            }
          },
          percentComplete: {
            required: false,
            readOnly: true,
            serializedName: 'properties.percentComplete',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = TransparentDataEncryptionActivity;
