/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Defines the parameters that need to be provided for moving an import/export
 * job from one reesource group to another.
 *
 */
class MoveJobParameters {
  /**
   * Create a MoveJobParameters.
   * @member {string} targetResourceGroup Specifies the target resource group
   * ID to move the jobs to.
   * @member {array} resources Specifies the list of jobs to move to the target
   * resource group. The jobs must be from the current resource group from the
   * request URL.
   */
  constructor() {
  }

  /**
   * Defines the metadata of MoveJobParameters
   *
   * @returns {object} metadata of MoveJobParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MoveJobParameters',
      type: {
        name: 'Composite',
        className: 'MoveJobParameters',
        modelProperties: {
          targetResourceGroup: {
            required: true,
            serializedName: 'targetResourceGroup',
            type: {
              name: 'String'
            }
          },
          resources: {
            required: true,
            serializedName: 'resources',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = MoveJobParameters;
