/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes a supported operation by the Storage Import/Export job API.
 *
 */
class Operation {
  /**
   * Create a Operation.
   * @member {string} name Name of the operation.
   * @member {string} [provider] The resource provider name to which the
   * operation belongs.
   * @member {string} [resource] The name of the resource to which the
   * operation belongs.
   * @member {string} [operation] The display name of the operation.
   * @member {string} [description] Short description of the operation.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Operation
   *
   * @returns {object} metadata of Operation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Operation',
      type: {
        name: 'Composite',
        className: 'Operation',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          provider: {
            required: false,
            serializedName: 'display.provider',
            type: {
              name: 'String'
            }
          },
          resource: {
            required: false,
            serializedName: 'display.resource',
            type: {
              name: 'String'
            }
          },
          operation: {
            required: false,
            serializedName: 'display.operation',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'display.description',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Operation;
