/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Specifies the return address information for the job.
 *
 */
class ReturnAddress {
  /**
   * Create a ReturnAddress.
   * @member {string} recipientName The name of the recipient who will receive
   * the hard drives when they are returned.
   * @member {string} streetAddress1 The first line of the street address to
   * use when returning the drives.
   * @member {string} [streetAddress2] The second line of the street address to
   * use when returning the drives.
   * @member {string} city The city name to use when returning the drives.
   * @member {string} [stateOrProvince] The state or province to use when
   * returning the drives.
   * @member {string} postalCode The postal code to use when returning the
   * drives.
   * @member {string} countryOrRegion The country or region to use when
   * returning the drives.
   * @member {string} phone Phone number of the recipient of the returned
   * drives.
   * @member {string} email Email address of the recipient of the returned
   * drives.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ReturnAddress
   *
   * @returns {object} metadata of ReturnAddress
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ReturnAddress',
      type: {
        name: 'Composite',
        className: 'ReturnAddress',
        modelProperties: {
          recipientName: {
            required: true,
            serializedName: 'recipientName',
            type: {
              name: 'String'
            }
          },
          streetAddress1: {
            required: true,
            serializedName: 'streetAddress1',
            type: {
              name: 'String'
            }
          },
          streetAddress2: {
            required: false,
            serializedName: 'streetAddress2',
            type: {
              name: 'String'
            }
          },
          city: {
            required: true,
            serializedName: 'city',
            type: {
              name: 'String'
            }
          },
          stateOrProvince: {
            required: false,
            serializedName: 'stateOrProvince',
            type: {
              name: 'String'
            }
          },
          postalCode: {
            required: true,
            serializedName: 'postalCode',
            type: {
              name: 'String'
            }
          },
          countryOrRegion: {
            required: true,
            serializedName: 'countryOrRegion',
            type: {
              name: 'String'
            }
          },
          phone: {
            required: true,
            serializedName: 'phone',
            type: {
              name: 'String'
            }
          },
          email: {
            required: true,
            serializedName: 'email',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ReturnAddress;
