/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A service that allows server-side encryption to be used.
 *
 */
class EncryptionService {
  /**
   * Create a EncryptionService.
   * @member {boolean} [enabled] A boolean indicating whether or not the
   * service encrypts the data as it is stored.
   * @member {date} [lastEnabledTime] Gets a rough estimate of the date/time
   * when the encryption was last enabled by the user. Only returned when
   * encryption is enabled. There might be some unencrypted blobs which were
   * written after this time, as it is just a rough estimate.
   */
  constructor() {
  }

  /**
   * Defines the metadata of EncryptionService
   *
   * @returns {object} metadata of EncryptionService
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EncryptionService',
      type: {
        name: 'Composite',
        className: 'EncryptionService',
        modelProperties: {
          enabled: {
            required: false,
            serializedName: 'enabled',
            type: {
              name: 'Boolean'
            }
          },
          lastEnabledTime: {
            required: false,
            readOnly: true,
            serializedName: 'lastEnabledTime',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = EncryptionService;
