/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The restriction because of which SKU cannot be used.
 *
 */
class Restriction {
  /**
   * Create a Restriction.
   * @member {string} [type] The type of restrictions. As of now only possible
   * value for this is location.
   * @member {array} [values] The value of restrictions. If the restriction
   * type is set to location. This would be different locations where the SKU
   * is restricted.
   * @member {string} [reasonCode] The reason for the restriction. As of now
   * this can be “QuotaId” or “NotAvailableForSubscription”. Quota Id is set
   * when the SKU has requiredQuotas parameter as the subscription does not
   * belong to that quota. The “NotAvailableForSubscription” is related to
   * capacity at DC. Possible values include: 'QuotaId',
   * 'NotAvailableForSubscription'
   */
  constructor() {
  }

  /**
   * Defines the metadata of Restriction
   *
   * @returns {object} metadata of Restriction
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Restriction',
      type: {
        name: 'Composite',
        className: 'Restriction',
        modelProperties: {
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          values: {
            required: false,
            readOnly: true,
            serializedName: 'values',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          reasonCode: {
            required: false,
            serializedName: 'reasonCode',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Restriction;
