/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The response from the ListKeys operation.
 *
 */
class StorageAccountListKeysResult {
  /**
   * Create a StorageAccountListKeysResult.
   * @member {array} [keys] Gets the list of storage account keys and their
   * properties for the specified storage account.
   */
  constructor() {
  }

  /**
   * Defines the metadata of StorageAccountListKeysResult
   *
   * @returns {object} metadata of StorageAccountListKeysResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'StorageAccountListKeysResult',
      type: {
        name: 'Composite',
        className: 'StorageAccountListKeysResult',
        modelProperties: {
          keys: {
            required: false,
            readOnly: true,
            serializedName: 'keys',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StorageAccountKeyElementType',
                  type: {
                    name: 'Composite',
                    className: 'StorageAccountKey'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = StorageAccountListKeysResult;
