/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The details of the error for which the alert was raised
 *
 */
class AlertErrorDetails {
  /**
   * Create a AlertErrorDetails.
   * @member {string} [errorCode] The error code
   * @member {string} [errorMessage] The error message
   * @member {number} [occurences] The number of occurences
   */
  constructor() {
  }

  /**
   * Defines the metadata of AlertErrorDetails
   *
   * @returns {object} metadata of AlertErrorDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AlertErrorDetails',
      type: {
        name: 'Composite',
        className: 'AlertErrorDetails',
        modelProperties: {
          errorCode: {
            required: false,
            serializedName: 'errorCode',
            type: {
              name: 'String'
            }
          },
          errorMessage: {
            required: false,
            serializedName: 'errorMessage',
            type: {
              name: 'String'
            }
          },
          occurences: {
            required: false,
            serializedName: 'occurences',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = AlertErrorDetails;
