/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents the base class for all other ARM object models
 *
 */
class BaseModel {
  /**
   * Create a BaseModel.
   * @member {string} [id] The path ID that uniquely identifies the object.
   * @member {string} [name] The name of the object.
   * @member {string} [type] The hierarchical type of the object.
   * @member {string} [kind] The Kind of the object. Currently only Series8000
   * is supported. Possible values include: 'Series8000'
   */
  constructor() {
  }

  /**
   * Defines the metadata of BaseModel
   *
   * @returns {object} metadata of BaseModel
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BaseModel',
      type: {
        name: 'Composite',
        className: 'BaseModel',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'Enum',
              allowedValues: [ 'Series8000' ]
            }
          }
        }
      }
    };
  }
}

module.exports = BaseModel;
