/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The additional device details regarding the end point count and volume
 * container count.
 *
 */
class DeviceDetails {
  /**
   * Create a DeviceDetails.
   * @member {number} [endpointCount] The total number of endpoints that are
   * currently on the device ( i.e. number of volumes).
   * @member {number} [volumeContainerCount] The total number of volume
   * containers on the device.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DeviceDetails
   *
   * @returns {object} metadata of DeviceDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DeviceDetails',
      type: {
        name: 'Composite',
        className: 'DeviceDetails',
        modelProperties: {
          endpointCount: {
            required: false,
            serializedName: 'endpointCount',
            type: {
              name: 'Number'
            }
          },
          volumeContainerCount: {
            required: false,
            serializedName: 'volumeContainerCount',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = DeviceDetails;
