/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The dimension filter.
 *
 */
class DimensionFilter {
  /**
   * Create a DimensionFilter.
   * @member {string} [name] Specifies the dimension name. E.g.,
   * NetworkInterface. Valid values are the ones specified in the field
   * "dimensions" in the ListMetricDefinitions call. Only 'Equality' operator
   * is supported for this property.
   * @member {string} [values] Specifies the dimension value. E.g., Data0.
   * Valid values are the ones returned in the field "dimensions" in the
   * ListMetricDefinitions call. Only 'Equality' operator is supported for this
   * property.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DimensionFilter
   *
   * @returns {object} metadata of DimensionFilter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DimensionFilter',
      type: {
        name: 'Composite',
        className: 'DimensionFilter',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          values: {
            required: false,
            serializedName: 'values',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DimensionFilter;
