/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The request object for triggering a failover of volume containers, from a
 * source device to a target device.
 *
 */
class FailoverRequest {
  /**
   * Create a FailoverRequest.
   * @member {string} [targetDeviceId] The ARM path ID of the device which will
   * act as the failover target.
   * @member {array} [volumeContainers] The list of path IDs of the volume
   * containers which needs to be failed-over to the target device.
   */
  constructor() {
  }

  /**
   * Defines the metadata of FailoverRequest
   *
   * @returns {object} metadata of FailoverRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FailoverRequest',
      type: {
        name: 'Composite',
        className: 'FailoverRequest',
        modelProperties: {
          targetDeviceId: {
            required: false,
            serializedName: 'targetDeviceId',
            type: {
              name: 'String'
            }
          },
          volumeContainers: {
            required: false,
            serializedName: 'volumeContainers',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = FailoverRequest;
