/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The eligibility result of failover set, for failover.
 *
 */
class FailoverSetEligibilityResult {
  /**
   * Create a FailoverSetEligibilityResult.
   * @member {boolean} [isEligibleForFailover] Represents if this failover set
   * is eligible for failover or not.
   * @member {string} [errorMessage] The error message, if the failover set is
   * not eligible for failover.
   */
  constructor() {
  }

  /**
   * Defines the metadata of FailoverSetEligibilityResult
   *
   * @returns {object} metadata of FailoverSetEligibilityResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FailoverSetEligibilityResult',
      type: {
        name: 'Composite',
        className: 'FailoverSetEligibilityResult',
        modelProperties: {
          isEligibleForFailover: {
            required: false,
            serializedName: 'isEligibleForFailover',
            type: {
              name: 'Boolean'
            }
          },
          errorMessage: {
            required: false,
            serializedName: 'errorMessage',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = FailoverSetEligibilityResult;
