/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

var msRestAzure = require('ms-rest-azure');

exports.BaseResource = msRestAzure.BaseResource;
exports.CloudError = msRestAzure.CloudError;
exports.BaseModel = require('./baseModel');
exports.AccessControlRecord = require('./accessControlRecord');
exports.AcsConfiguration = require('./acsConfiguration');
exports.AlertSource = require('./alertSource');
exports.AlertErrorDetails = require('./alertErrorDetails');
exports.Alert = require('./alert');
exports.AlertFilter = require('./alertFilter');
exports.AlertSettings = require('./alertSettings');
exports.AsymmetricEncryptedSecret = require('./asymmetricEncryptedSecret');
exports.AvailableProviderOperationDisplay = require('./availableProviderOperationDisplay');
exports.AvailableProviderOperation = require('./availableProviderOperation');
exports.BackupElement = require('./backupElement');
exports.Backup = require('./backup');
exports.BackupFilter = require('./backupFilter');
exports.BackupPolicy = require('./backupPolicy');
exports.ScheduleRecurrence = require('./scheduleRecurrence');
exports.BackupSchedule = require('./backupSchedule');
exports.Time = require('./time');
exports.BandwidthSchedule = require('./bandwidthSchedule');
exports.BandwidthSetting = require('./bandwidthSetting');
exports.ChapSettings = require('./chapSettings');
exports.ClearAlertRequest = require('./clearAlertRequest');
exports.CloneRequest = require('./cloneRequest');
exports.CloudAppliance = require('./cloudAppliance');
exports.VmImage = require('./vmImage');
exports.CloudApplianceConfiguration = require('./cloudApplianceConfiguration');
exports.CloudApplianceSettings = require('./cloudApplianceSettings');
exports.SecondaryDNSSettings = require('./secondaryDNSSettings');
exports.NetworkInterfaceData0Settings = require('./networkInterfaceData0Settings');
exports.ConfigureDeviceRequest = require('./configureDeviceRequest');
exports.ControllerPowerStateChangeRequest = require('./controllerPowerStateChangeRequest');
exports.DataStatistics = require('./dataStatistics');
exports.DeviceDetails = require('./deviceDetails');
exports.DeviceRolloverDetails = require('./deviceRolloverDetails');
exports.Device = require('./device');
exports.DevicePatch = require('./devicePatch');
exports.DimensionFilter = require('./dimensionFilter');
exports.DNSSettings = require('./dNSSettings');
exports.EncryptionSettings = require('./encryptionSettings');
exports.FailoverRequest = require('./failoverRequest');
exports.VolumeFailoverMetadata = require('./volumeFailoverMetadata');
exports.VolumeContainerFailoverMetadata = require('./volumeContainerFailoverMetadata');
exports.FailoverSetEligibilityResult = require('./failoverSetEligibilityResult');
exports.FailoverSet = require('./failoverSet');
exports.TargetEligibilityErrorMessage = require('./targetEligibilityErrorMessage');
exports.TargetEligibilityResult = require('./targetEligibilityResult');
exports.FailoverTarget = require('./failoverTarget');
exports.Feature = require('./feature');
exports.FeatureFilter = require('./featureFilter');
exports.HardwareComponent = require('./hardwareComponent');
exports.HardwareComponentGroup = require('./hardwareComponentGroup');
exports.JobErrorItem = require('./jobErrorItem');
exports.JobErrorDetails = require('./jobErrorDetails');
exports.JobStage = require('./jobStage');
exports.Job = require('./job');
exports.JobFilter = require('./jobFilter');
exports.Key = require('./key');
exports.ListFailoverTargetsRequest = require('./listFailoverTargetsRequest');
exports.ManagerIntrinsicSettings = require('./managerIntrinsicSettings');
exports.ManagerSku = require('./managerSku');
exports.Resource = require('./resource');
exports.Manager = require('./manager');
exports.ManagerExtendedInfo = require('./managerExtendedInfo');
exports.ManagerPatch = require('./managerPatch');
exports.MetricAvailablity = require('./metricAvailablity');
exports.MetricData = require('./metricData');
exports.MetricName = require('./metricName');
exports.MetricDimension = require('./metricDimension');
exports.MetricDefinition = require('./metricDefinition');
exports.MetricNameFilter = require('./metricNameFilter');
exports.MetricFilter = require('./metricFilter');
exports.Metrics = require('./metrics');
exports.NicIPv4 = require('./nicIPv4');
exports.NicIPv6 = require('./nicIPv6');
exports.NetworkAdapters = require('./networkAdapters');
exports.NetworkAdapterList = require('./networkAdapterList');
exports.WebproxySettings = require('./webproxySettings');
exports.NetworkSettings = require('./networkSettings');
exports.NetworkSettingsPatch = require('./networkSettingsPatch');
exports.PublicKey = require('./publicKey');
exports.RemoteManagementSettings = require('./remoteManagementSettings');
exports.RemoteManagementSettingsPatch = require('./remoteManagementSettingsPatch');
exports.SecuritySettings = require('./securitySettings');
exports.SecuritySettingsPatch = require('./securitySettingsPatch');
exports.SendTestAlertEmailRequest = require('./sendTestAlertEmailRequest');
exports.StorageAccountCredential = require('./storageAccountCredential');
exports.SymmetricEncryptedSecret = require('./symmetricEncryptedSecret');
exports.TimeSettings = require('./timeSettings');
exports.Updates = require('./updates');
exports.Volume = require('./volume');
exports.VolumeContainer = require('./volumeContainer');
exports.AvailableProviderOperationList = require('./availableProviderOperationList');
exports.ManagerList = require('./managerList');
exports.FeatureList = require('./featureList');
exports.MetricList = require('./metricList');
exports.MetricDefinitionList = require('./metricDefinitionList');
exports.AccessControlRecordList = require('./accessControlRecordList');
exports.AlertList = require('./alertList');
exports.BandwidthSettingList = require('./bandwidthSettingList');
exports.CloudApplianceConfigurationList = require('./cloudApplianceConfigurationList');
exports.DeviceList = require('./deviceList');
exports.FailoverSetsList = require('./failoverSetsList');
exports.FailoverTargetsList = require('./failoverTargetsList');
exports.BackupPolicyList = require('./backupPolicyList');
exports.BackupScheduleList = require('./backupScheduleList');
exports.BackupList = require('./backupList');
exports.HardwareComponentGroupList = require('./hardwareComponentGroupList');
exports.JobList = require('./jobList');
exports.VolumeContainerList = require('./volumeContainerList');
exports.VolumeList = require('./volumeList');
exports.StorageAccountCredentialList = require('./storageAccountCredentialList');
