/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The job error details. Contains list of job error items.
 *
 */
class JobErrorDetails {
  /**
   * Create a JobErrorDetails.
   * @member {array} [errorDetails] The error details.
   * @member {string} code The error code intended for programmatic access.
   * @member {string} message The error message intended to describe the error
   * in detail.
   */
  constructor() {
  }

  /**
   * Defines the metadata of JobErrorDetails
   *
   * @returns {object} metadata of JobErrorDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'JobErrorDetails',
      type: {
        name: 'Composite',
        className: 'JobErrorDetails',
        modelProperties: {
          errorDetails: {
            required: false,
            serializedName: 'errorDetails',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'JobErrorItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'JobErrorItem'
                  }
              }
            }
          },
          code: {
            required: true,
            serializedName: 'code',
            type: {
              name: 'String'
            }
          },
          message: {
            required: true,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = JobErrorDetails;
