/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The request object for fetching the list of failover targets (eligible
 * devices for failover).
 *
 */
class ListFailoverTargetsRequest {
  /**
   * Create a ListFailoverTargetsRequest.
   * @member {array} [volumeContainers] The list of path IDs of the volume
   * containers that needs to be failed-over, for which we want to fetch the
   * eligible targets.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ListFailoverTargetsRequest
   *
   * @returns {object} metadata of ListFailoverTargetsRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ListFailoverTargetsRequest',
      type: {
        name: 'Composite',
        className: 'ListFailoverTargetsRequest',
        modelProperties: {
          volumeContainers: {
            required: false,
            serializedName: 'volumeContainers',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ListFailoverTargetsRequest;
