/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The metric name filter, specifying the name of the metric to be filtered on.
 *
 */
class MetricNameFilter {
  /**
   * Create a MetricNameFilter.
   * @member {string} [value] Specifies the metric name to be filtered on.
   * E.g., CloudStorageUsed. Valid values are the ones returned in the field
   * "name" in the ListMetricDefinitions call. Only 'Equality' operator is
   * supported for this property.
   */
  constructor() {
  }

  /**
   * Defines the metadata of MetricNameFilter
   *
   * @returns {object} metadata of MetricNameFilter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MetricNameFilter',
      type: {
        name: 'Composite',
        className: 'MetricNameFilter',
        modelProperties: {
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = MetricNameFilter;
