/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The schedule recurrence.
 *
 */
class ScheduleRecurrence {
  /**
   * Create a ScheduleRecurrence.
   * @member {string} recurrenceType The recurrence type. Possible values
   * include: 'Minutes', 'Hourly', 'Daily', 'Weekly'
   * @member {number} recurrenceValue The recurrence value.
   * @member {array} [weeklyDaysList] The week days list. Applicable only for
   * schedules of recurrence type 'weekly'.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ScheduleRecurrence
   *
   * @returns {object} metadata of ScheduleRecurrence
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ScheduleRecurrence',
      type: {
        name: 'Composite',
        className: 'ScheduleRecurrence',
        modelProperties: {
          recurrenceType: {
            required: true,
            serializedName: 'recurrenceType',
            type: {
              name: 'Enum',
              allowedValues: [ 'Minutes', 'Hourly', 'Daily', 'Weekly' ]
            }
          },
          recurrenceValue: {
            required: true,
            serializedName: 'recurrenceValue',
            type: {
              name: 'Number'
            }
          },
          weeklyDaysList: {
            required: false,
            serializedName: 'weeklyDaysList',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'DayOfWeekElementType',
                  type: {
                    name: 'Enum',
                    allowedValues: [ 'Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday' ]
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ScheduleRecurrence;
