/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The virtual machine image.
 *
 */
class VmImage {
  /**
   * Create a VmImage.
   * @member {string} name The name.
   * @member {string} version The version.
   * @member {string} offer The offer.
   * @member {string} publisher The publisher.
   * @member {string} sku The SKU.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VmImage
   *
   * @returns {object} metadata of VmImage
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VmImage',
      type: {
        name: 'Composite',
        className: 'VmImage',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          version: {
            required: true,
            serializedName: 'version',
            type: {
              name: 'String'
            }
          },
          offer: {
            required: true,
            serializedName: 'offer',
            type: {
              name: 'String'
            }
          },
          publisher: {
            required: true,
            serializedName: 'publisher',
            type: {
              name: 'String'
            }
          },
          sku: {
            required: true,
            serializedName: 'sku',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = VmImage;
