/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The parameters needed to retrieve the default function definition for an
 * Azure Machine Learning web service function.
 *
 * @extends models['FunctionRetrieveDefaultDefinitionParameters']
 */
class AzureMachineLearningWebServiceFunctionRetrieveDefaultDefinitionParameters extends models['FunctionRetrieveDefaultDefinitionParameters'] {
  /**
   * Create a AzureMachineLearningWebServiceFunctionRetrieveDefaultDefinitionParameters.
   * @member {string} [executeEndpoint] The Request-Response execute endpoint
   * of the Azure Machine Learning web service. Find out more here:
   * https://docs.microsoft.com/en-us/azure/machine-learning/machine-learning-consume-web-services#request-response-service-rrs
   * @member {string} [udfType] The function type. Possible values include:
   * 'Scalar'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureMachineLearningWebServiceFunctionRetrieveDefaultDefinitionParameters
   *
   * @returns {object} metadata of AzureMachineLearningWebServiceFunctionRetrieveDefaultDefinitionParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Microsoft.MachineLearning/WebService',
      type: {
        name: 'Composite',
        className: 'AzureMachineLearningWebServiceFunctionRetrieveDefaultDefinitionParameters',
        modelProperties: {
          bindingType: {
            required: true,
            serializedName: 'bindingType',
            type: {
              name: 'String'
            }
          },
          executeEndpoint: {
            required: false,
            serializedName: 'bindingRetrievalProperties.executeEndpoint',
            type: {
              name: 'String'
            }
          },
          udfType: {
            required: false,
            serializedName: 'bindingRetrievalProperties.udfType',
            type: {
              name: 'Enum',
              allowedValues: [ 'Scalar' ]
            }
          }
        }
      }
    };
  }
}

module.exports = AzureMachineLearningWebServiceFunctionRetrieveDefaultDefinitionParameters;
