/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes an input column for the Azure Machine Learning web service
 * endpoint.
 *
 */
class AzureMachineLearningWebServiceInputColumn {
  /**
   * Create a AzureMachineLearningWebServiceInputColumn.
   * @member {string} [name] The name of the input column.
   * @member {string} [dataType] The (Azure Machine Learning supported) data
   * type of the input column. A list of valid  Azure Machine Learning data
   * types are described at
   * https://msdn.microsoft.com/en-us/library/azure/dn905923.aspx .
   * @member {number} [mapTo] The zero based index of the function parameter
   * this input maps to.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureMachineLearningWebServiceInputColumn
   *
   * @returns {object} metadata of AzureMachineLearningWebServiceInputColumn
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureMachineLearningWebServiceInputColumn',
      type: {
        name: 'Composite',
        className: 'AzureMachineLearningWebServiceInputColumn',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          dataType: {
            required: false,
            serializedName: 'dataType',
            type: {
              name: 'String'
            }
          },
          mapTo: {
            required: false,
            serializedName: 'mapTo',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureMachineLearningWebServiceInputColumn;
