/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes an output column for the Azure Machine Learning web service
 * endpoint.
 *
 */
class AzureMachineLearningWebServiceOutputColumn {
  /**
   * Create a AzureMachineLearningWebServiceOutputColumn.
   * @member {string} [name] The name of the output column.
   * @member {string} [dataType] The (Azure Machine Learning supported) data
   * type of the output column. A list of valid  Azure Machine Learning data
   * types are described at
   * https://msdn.microsoft.com/en-us/library/azure/dn905923.aspx .
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureMachineLearningWebServiceOutputColumn
   *
   * @returns {object} metadata of AzureMachineLearningWebServiceOutputColumn
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureMachineLearningWebServiceOutputColumn',
      type: {
        name: 'Composite',
        className: 'AzureMachineLearningWebServiceOutputColumn',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          dataType: {
            required: false,
            serializedName: 'dataType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureMachineLearningWebServiceOutputColumn;
