/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The properties that are associated with an Azure SQL database data source.
 *
 */
class AzureSqlDatabaseDataSourceProperties {
  /**
   * Create a AzureSqlDatabaseDataSourceProperties.
   * @member {string} [server] The name of the SQL server containing the Azure
   * SQL database. Required on PUT (CreateOrReplace) requests.
   * @member {string} [database] The name of the Azure SQL database. Required
   * on PUT (CreateOrReplace) requests.
   * @member {string} [user] The user name that will be used to connect to the
   * Azure SQL database. Required on PUT (CreateOrReplace) requests.
   * @member {string} [password] The password that will be used to connect to
   * the Azure SQL database. Required on PUT (CreateOrReplace) requests.
   * @member {string} [table] The name of the table in the Azure SQL database.
   * Required on PUT (CreateOrReplace) requests.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureSqlDatabaseDataSourceProperties
   *
   * @returns {object} metadata of AzureSqlDatabaseDataSourceProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureSqlDatabaseDataSourceProperties',
      type: {
        name: 'Composite',
        className: 'AzureSqlDatabaseDataSourceProperties',
        modelProperties: {
          server: {
            required: false,
            serializedName: 'server',
            type: {
              name: 'String'
            }
          },
          database: {
            required: false,
            serializedName: 'database',
            type: {
              name: 'String'
            }
          },
          user: {
            required: false,
            serializedName: 'user',
            type: {
              name: 'String'
            }
          },
          password: {
            required: false,
            serializedName: 'password',
            type: {
              name: 'String'
            }
          },
          table: {
            required: false,
            serializedName: 'table',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureSqlDatabaseDataSourceProperties;
