/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Object containing a list of functions under a streaming job.
 */
class FunctionListResult extends Array {
  /**
   * Create a FunctionListResult.
   * @member {string} [nextLink] The link (url) to the next page of results.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of FunctionListResult
   *
   * @returns {object} metadata of FunctionListResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FunctionListResult',
      type: {
        name: 'Composite',
        className: 'FunctionListResult',
        modelProperties: {
          value: {
            required: false,
            readOnly: true,
            serializedName: '',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'FunctionModelElementType',
                  type: {
                    name: 'Composite',
                    className: 'FunctionModel'
                  }
              }
            }
          },
          nextLink: {
            required: false,
            readOnly: true,
            serializedName: 'nextLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = FunctionListResult;
