/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A function object, containing all information associated with the named
 * function. All functions are contained under a streaming job.
 *
 * @extends models['SubResource']
 */
class FunctionModel extends models['SubResource'] {
  /**
   * Create a FunctionModel.
   * @member {object} [properties] The properties that are associated with a
   * function.
   * @member {string} [properties.etag] The current entity tag for the
   * function. This is an opaque string. You can use it to detect whether the
   * resource has changed between requests. You can also use it in the If-Match
   * or If-None-Match headers for write operations for optimistic concurrency.
   * @member {string} [properties.type] Polymorphic Discriminator
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of FunctionModel
   *
   * @returns {object} metadata of FunctionModel
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Function',
      type: {
        name: 'Composite',
        className: 'FunctionModel',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'type',
                clientName: 'type'
              },
              uberParent: 'FunctionProperties',
              className: 'FunctionProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = FunctionModel;
