/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The properties that are associated with a function.
 *
 */
class FunctionProperties {
  /**
   * Create a FunctionProperties.
   * @member {string} [etag] The current entity tag for the function. This is
   * an opaque string. You can use it to detect whether the resource has
   * changed between requests. You can also use it in the If-Match or
   * If-None-Match headers for write operations for optimistic concurrency.
   * @member {string} type Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of FunctionProperties
   *
   * @returns {object} metadata of FunctionProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FunctionProperties',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'type',
          clientName: 'type'
        },
        uberParent: 'FunctionProperties',
        className: 'FunctionProperties',
        modelProperties: {
          etag: {
            required: false,
            readOnly: true,
            serializedName: 'etag',
            type: {
              name: 'String'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = FunctionProperties;
