/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The parameters needed to retrieve the default function definition for a
 * JavaScript function.
 *
 * @extends models['FunctionRetrieveDefaultDefinitionParameters']
 */
class JavaScriptFunctionRetrieveDefaultDefinitionParameters extends models['FunctionRetrieveDefaultDefinitionParameters'] {
  /**
   * Create a JavaScriptFunctionRetrieveDefaultDefinitionParameters.
   * @member {string} [script] The JavaScript code containing a single function
   * definition. For example: 'function (x, y) { return x + y; }'.
   * @member {string} [udfType] The function type. Possible values include:
   * 'Scalar'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of JavaScriptFunctionRetrieveDefaultDefinitionParameters
   *
   * @returns {object} metadata of JavaScriptFunctionRetrieveDefaultDefinitionParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Microsoft.StreamAnalytics/JavascriptUdf',
      type: {
        name: 'Composite',
        className: 'JavaScriptFunctionRetrieveDefaultDefinitionParameters',
        modelProperties: {
          bindingType: {
            required: true,
            serializedName: 'bindingType',
            type: {
              name: 'String'
            }
          },
          script: {
            required: false,
            serializedName: 'bindingRetrievalProperties.script',
            type: {
              name: 'String'
            }
          },
          udfType: {
            required: false,
            serializedName: 'bindingRetrievalProperties.udfType',
            type: {
              name: 'Enum',
              allowedValues: [ 'Scalar' ]
            }
          }
        }
      }
    };
  }
}

module.exports = JavaScriptFunctionRetrieveDefaultDefinitionParameters;
