/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The common properties that are associated with Service Bus data sources
 * (Queues, Topics, Event Hubs, etc.).
 *
 */
class ServiceBusDataSourceProperties {
  /**
   * Create a ServiceBusDataSourceProperties.
   * @member {string} [serviceBusNamespace] The namespace that is associated
   * with the desired Event Hub, Service Bus Queue, Service Bus Topic, etc.
   * Required on PUT (CreateOrReplace) requests.
   * @member {string} [sharedAccessPolicyName] The shared access policy name
   * for the Event Hub, Service Bus Queue, Service Bus Topic, etc. Required on
   * PUT (CreateOrReplace) requests.
   * @member {string} [sharedAccessPolicyKey] The shared access policy key for
   * the specified shared access policy. Required on PUT (CreateOrReplace)
   * requests.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ServiceBusDataSourceProperties
   *
   * @returns {object} metadata of ServiceBusDataSourceProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ServiceBusDataSourceProperties',
      type: {
        name: 'Composite',
        className: 'ServiceBusDataSourceProperties',
        modelProperties: {
          serviceBusNamespace: {
            required: false,
            serializedName: 'serviceBusNamespace',
            type: {
              name: 'String'
            }
          },
          sharedAccessPolicyName: {
            required: false,
            serializedName: 'sharedAccessPolicyName',
            type: {
              name: 'String'
            }
          },
          sharedAccessPolicyKey: {
            required: false,
            serializedName: 'sharedAccessPolicyKey',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ServiceBusDataSourceProperties;
