/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Parameters supplied to the Start Streaming Job operation.
 *
 */
class StartStreamingJobParameters {
  /**
   * Create a StartStreamingJobParameters.
   * @member {string} [outputStartMode] Value may be JobStartTime, CustomTime,
   * or LastOutputEventTime to indicate whether the starting point of the
   * output event stream should start whenever the job is started, start at a
   * custom user time stamp specified via the outputStartTime property, or
   * start from the last event output time. Possible values include:
   * 'JobStartTime', 'CustomTime', 'LastOutputEventTime'
   * @member {date} [outputStartTime] Value is either an ISO-8601 formatted
   * time stamp that indicates the starting point of the output event stream,
   * or null to indicate that the output event stream will start whenever the
   * streaming job is started. This property must have a value if
   * outputStartMode is set to CustomTime.
   */
  constructor() {
  }

  /**
   * Defines the metadata of StartStreamingJobParameters
   *
   * @returns {object} metadata of StartStreamingJobParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'StartStreamingJobParameters',
      type: {
        name: 'Composite',
        className: 'StartStreamingJobParameters',
        modelProperties: {
          outputStartMode: {
            required: false,
            serializedName: 'outputStartMode',
            type: {
              name: 'String'
            }
          },
          outputStartTime: {
            required: false,
            serializedName: 'outputStartTime',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = StartStreamingJobParameters;
