/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Result of the GetQuotas operation. It contains a list of quotas for the
 * subscription in a particular region.
 *
 */
class SubscriptionQuotasListResult {
  /**
   * Create a SubscriptionQuotasListResult.
   * @member {array} [value] List of quotas for the subscription in a
   * particular region.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SubscriptionQuotasListResult
   *
   * @returns {object} metadata of SubscriptionQuotasListResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SubscriptionQuotasListResult',
      type: {
        name: 'Composite',
        className: 'SubscriptionQuotasListResult',
        modelProperties: {
          value: {
            required: false,
            readOnly: true,
            serializedName: 'value',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'SubscriptionQuotaElementType',
                  type: {
                    name: 'Composite',
                    className: 'SubscriptionQuota'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = SubscriptionQuotasListResult;
