/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class which is a sparse representation of a Traffic Manager endpoint.
 *
 */
class HeatMapEndpoint {
  /**
   * Create a HeatMapEndpoint.
   * @member {string} [resourceId] The ARM Resource ID of this Traffic Manager
   * endpoint.
   * @member {number} [endpointId] A number uniquely identifying this endpoint
   * in query experiences.
   */
  constructor() {
  }

  /**
   * Defines the metadata of HeatMapEndpoint
   *
   * @returns {object} metadata of HeatMapEndpoint
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HeatMapEndpoint',
      type: {
        name: 'Composite',
        className: 'HeatMapEndpoint',
        modelProperties: {
          resourceId: {
            required: false,
            serializedName: 'resourceId',
            type: {
              name: 'String'
            }
          },
          endpointId: {
            required: false,
            serializedName: 'endpointId',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = HeatMapEndpoint;
