/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a Traffic Manager Name Availability response.
 *
 */
class TrafficManagerNameAvailability {
  /**
   * Create a TrafficManagerNameAvailability.
   * @member {string} [name] The relative name.
   * @member {string} [type] Traffic Manager profile resource type.
   * @member {boolean} [nameAvailable] Describes whether the relative name is
   * available or not.
   * @member {string} [reason] The reason why the name is not available, when
   * applicable.
   * @member {string} [message] Descriptive message that explains why the name
   * is not available, when applicable.
   */
  constructor() {
  }

  /**
   * Defines the metadata of TrafficManagerNameAvailability
   *
   * @returns {object} metadata of TrafficManagerNameAvailability
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TrafficManagerNameAvailability',
      type: {
        name: 'Composite',
        className: 'TrafficManagerNameAvailability',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          nameAvailable: {
            required: false,
            serializedName: 'nameAvailable',
            type: {
              name: 'Boolean'
            }
          },
          reason: {
            required: false,
            serializedName: 'reason',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = TrafficManagerNameAvailability;
