/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The response to an extension resource GET request.
 *
 * @extends models['Resource']
 */
class ExtensionResource extends models['Resource'] {
  /**
   * Create a ExtensionResource.
   * @member {object} [plan] The extension plan that was purchased.
   * @member {string} [plan.name] Name of the plan.
   * @member {string} [plan.product] Product name.
   * @member {string} [plan.promotionCode] Optional: the promotion code
   * associated with the plan.
   * @member {string} [plan.publisher] Name of the extension publisher.
   * @member {string} [plan.version] A string that uniquely identifies the plan
   * version.
   * @member {object} [properties] Resource properties.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ExtensionResource
   *
   * @returns {object} metadata of ExtensionResource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ExtensionResource',
      type: {
        name: 'Composite',
        className: 'ExtensionResource',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          plan: {
            required: false,
            serializedName: 'plan',
            type: {
              name: 'Composite',
              className: 'ExtensionResourcePlan'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ExtensionResource;
