/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties of an operation supported by the resource provider.
 *
 */
class OperationProperties {
  /**
   * Create a OperationProperties.
   * @member {string} [description] The description of the resource operation.
   * @member {string} [operation] The operation name.
   * @member {string} [provider] The provider name.
   * @member {string} [resource] The resource name.
   */
  constructor() {
  }

  /**
   * Defines the metadata of OperationProperties
   *
   * @returns {object} metadata of OperationProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OperationProperties',
      type: {
        name: 'Composite',
        className: 'OperationProperties',
        modelProperties: {
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          operation: {
            required: false,
            serializedName: 'operation',
            type: {
              name: 'String'
            }
          },
          provider: {
            required: false,
            serializedName: 'provider',
            type: {
              name: 'String'
            }
          },
          resource: {
            required: false,
            serializedName: 'resource',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = OperationProperties;
