/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A deleted app.
 *
 */
class DeletedSite {
  /**
   * Create a DeletedSite.
   * @member {number} [id] Numeric id for the deleted site
   * @member {string} [deletedTimestamp] Time in UTC when the app was deleted.
   * @member {string} [subscription] Subscription containing the deleted site
   * @member {string} [resourceGroup] ResourceGroup that contained the deleted
   * site
   * @member {string} [name] Name of the deleted site
   */
  constructor() {
  }

  /**
   * Defines the metadata of DeletedSite
   *
   * @returns {object} metadata of DeletedSite
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DeletedSite',
      type: {
        name: 'Composite',
        className: 'DeletedSite',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'Number'
            }
          },
          deletedTimestamp: {
            required: false,
            readOnly: true,
            serializedName: 'deletedTimestamp',
            type: {
              name: 'String'
            }
          },
          subscription: {
            required: false,
            readOnly: true,
            serializedName: 'subscription',
            type: {
              name: 'String'
            }
          },
          resourceGroup: {
            required: false,
            readOnly: true,
            serializedName: 'resourceGroup',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DeletedSite;
