/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The gateway details.
 *
 */
class GatewayDetails {
  /**
   * Create a GatewayDetails.
   * @member {string} [gatewayResourceId] Gateway resource to be associated
   * with the server.
   * @member {string} [gatewayObjectId] Gateway object id from in the DMTS
   * cluster for the gateway resource.
   * @member {string} [dmtsClusterUri] Uri of the DMTS cluster.
   */
  constructor() {
  }

  /**
   * Defines the metadata of GatewayDetails
   *
   * @returns {object} metadata of GatewayDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GatewayDetails',
      type: {
        name: 'Composite',
        className: 'GatewayDetails',
        modelProperties: {
          gatewayResourceId: {
            required: false,
            serializedName: 'gatewayResourceId',
            type: {
              name: 'String'
            }
          },
          gatewayObjectId: {
            required: false,
            readOnly: true,
            serializedName: 'gatewayObjectId',
            type: {
              name: 'String'
            }
          },
          dmtsClusterUri: {
            required: false,
            readOnly: true,
            serializedName: 'dmtsClusterUri',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = GatewayDetails;
