/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * An array of firewall rules.
 *
 */
class IPv4FirewallSettings {
  /**
   * Create a IPv4FirewallSettings.
   * @member {array} [firewallRules] An array of firewall rules.
   * @member {string} [enablePowerBIService] The indicator of enableing PBI
   * service.
   */
  constructor() {
  }

  /**
   * Defines the metadata of IPv4FirewallSettings
   *
   * @returns {object} metadata of IPv4FirewallSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IPv4FirewallSettings',
      type: {
        name: 'Composite',
        className: 'IPv4FirewallSettings',
        modelProperties: {
          firewallRules: {
            required: false,
            serializedName: 'firewallRules',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'IPv4FirewallRuleElementType',
                  type: {
                    name: 'Composite',
                    className: 'IPv4FirewallRule'
                  }
              }
            }
          },
          enablePowerBIService: {
            required: false,
            serializedName: 'enablePowerBIService',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = IPv4FirewallSettings;
