/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * An object that represents SKU details for existing resources.
 *
 */
class SkuDetailsForExistingResource {
  /**
   * Create a SkuDetailsForExistingResource.
   * @member {object} [sku] The SKU in SKU details for existing resources.
   * @member {string} [sku.name] Name of the SKU level.
   * @member {string} [sku.tier] The name of the Azure pricing tier to which
   * the SKU applies. Possible values include: 'Development', 'Basic',
   * 'Standard'
   * @member {number} [sku.capacity] The number of instances in the read only
   * query pool.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SkuDetailsForExistingResource
   *
   * @returns {object} metadata of SkuDetailsForExistingResource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SkuDetailsForExistingResource',
      type: {
        name: 'Composite',
        className: 'SkuDetailsForExistingResource',
        modelProperties: {
          sku: {
            required: false,
            serializedName: 'sku',
            type: {
              name: 'Composite',
              className: 'ResourceSku'
            }
          }
        }
      }
    };
  }
}

module.exports = SkuDetailsForExistingResource;
