/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Tenant access information contract of the API Management service.
 *
 */
class AccessInformationContract {
  /**
   * Create a AccessInformationContract.
   * @member {string} [id] Identifier.
   * @member {string} [primaryKey] Primary access key.
   * @member {string} [secondaryKey] Secondary access key.
   * @member {boolean} [enabled] Tenant access information of the API
   * Management service.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AccessInformationContract
   *
   * @returns {object} metadata of AccessInformationContract
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AccessInformationContract',
      type: {
        name: 'Composite',
        className: 'AccessInformationContract',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          primaryKey: {
            required: false,
            serializedName: 'primaryKey',
            type: {
              name: 'String'
            }
          },
          secondaryKey: {
            required: false,
            serializedName: 'secondaryKey',
            type: {
              name: 'String'
            }
          },
          enabled: {
            required: false,
            serializedName: 'enabled',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = AccessInformationContract;
