/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * API base contract details.
 *
 */
class ApiEntityBaseContract {
  /**
   * Create a ApiEntityBaseContract.
   * @member {string} [description] Description of the API. May include HTML
   * formatting tags.
   * @member {object} [authenticationSettings] Collection of authentication
   * settings included into this API.
   * @member {object} [authenticationSettings.oAuth2] OAuth2 Authentication
   * settings
   * @member {string} [authenticationSettings.oAuth2.authorizationServerId]
   * OAuth authorization server identifier.
   * @member {string} [authenticationSettings.oAuth2.scope] operations scope.
   * @member {object} [subscriptionKeyParameterNames] Protocols over which API
   * is made available.
   * @member {string} [subscriptionKeyParameterNames.header] Subscription key
   * header name.
   * @member {string} [subscriptionKeyParameterNames.query] Subscription key
   * query string parameter name.
   * @member {string} [apiType] Type of API. Possible values include: 'http',
   * 'soap'
   * @member {string} [apiRevision] Describes the Revision of the Api. If no
   * value is provided, default revision 1 is created
   * @member {boolean} [isCurrent] Indicates if API revision is current api
   * revision.
   * @member {boolean} [isOnline] Indicates if API revision is accessible via
   * the gateway.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApiEntityBaseContract
   *
   * @returns {object} metadata of ApiEntityBaseContract
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApiEntityBaseContract',
      type: {
        name: 'Composite',
        className: 'ApiEntityBaseContract',
        modelProperties: {
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          authenticationSettings: {
            required: false,
            serializedName: 'authenticationSettings',
            type: {
              name: 'Composite',
              className: 'AuthenticationSettingsContract'
            }
          },
          subscriptionKeyParameterNames: {
            required: false,
            serializedName: 'subscriptionKeyParameterNames',
            type: {
              name: 'Composite',
              className: 'SubscriptionKeyParameterNamesContract'
            }
          },
          apiType: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          apiRevision: {
            required: false,
            serializedName: 'apiRevision',
            constraints: {
              MaxLength: 100,
              MinLength: 1
            },
            type: {
              name: 'String'
            }
          },
          isCurrent: {
            required: false,
            serializedName: 'isCurrent',
            type: {
              name: 'Boolean'
            }
          },
          isOnline: {
            required: false,
            serializedName: 'isOnline',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = ApiEntityBaseContract;
