/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The Resource definition.
 *
 * @extends models['BaseResource']
 */
class ApimResource extends models['BaseResource'] {
  /**
   * Create a ApimResource.
   * @member {string} [id] Resource ID.
   * @member {string} [name] Resource name.
   * @member {string} [type] Resource type for API Management resource is set
   * to Microsoft.ApiManagement.
   * @member {object} [tags] Resource tags.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ApimResource
   *
   * @returns {object} metadata of ApimResource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApimResource',
      type: {
        name: 'Composite',
        className: 'ApimResource',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ApimResource;
