/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Certificate details.
 *
 * @extends models['Resource']
 */
class CertificateContract extends models['Resource'] {
  /**
   * Create a CertificateContract.
   * @member {string} subject Subject attribute of the certificate.
   * @member {string} thumbprint Thumbprint of the certificate.
   * @member {date} expirationDate Expiration date of the certificate. The date
   * conforms to the following format: `yyyy-MM-ddTHH:mm:ssZ` as specified by
   * the ISO 8601 standard.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of CertificateContract
   *
   * @returns {object} metadata of CertificateContract
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CertificateContract',
      type: {
        name: 'Composite',
        className: 'CertificateContract',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          subject: {
            required: true,
            serializedName: 'properties.subject',
            type: {
              name: 'String'
            }
          },
          thumbprint: {
            required: true,
            serializedName: 'properties.thumbprint',
            type: {
              name: 'String'
            }
          },
          expirationDate: {
            required: true,
            serializedName: 'properties.expirationDate',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = CertificateContract;
