/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Email Template Parameter contract.
 *
 */
class EmailTemplateParametersContractProperties {
  /**
   * Create a EmailTemplateParametersContractProperties.
   * @member {string} [name] Template parameter name.
   * @member {string} [title] Template parameter title.
   * @member {string} [description] Template parameter description.
   */
  constructor() {
  }

  /**
   * Defines the metadata of EmailTemplateParametersContractProperties
   *
   * @returns {object} metadata of EmailTemplateParametersContractProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EmailTemplateParametersContractProperties',
      type: {
        name: 'Composite',
        className: 'EmailTemplateParametersContractProperties',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            constraints: {
              MaxLength: 256,
              MinLength: 1,
              Pattern: '^[A-Za-z0-9-._]+$'
            },
            type: {
              name: 'String'
            }
          },
          title: {
            required: false,
            serializedName: 'title',
            constraints: {
              MaxLength: 4096,
              MinLength: 1
            },
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            constraints: {
              MaxLength: 256,
              MinLength: 1,
              Pattern: '^[A-Za-z0-9-._]+$'
            },
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = EmailTemplateParametersContractProperties;
