/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * List of all the Identity Providers configured on the service instance.
 *
 */
class IdentityProviderList {
  /**
   * Create a IdentityProviderList.
   * @member {array} [value] Identity Provider configuration values.
   * @member {string} [nextLink] Next page link if any.
   */
  constructor() {
  }

  /**
   * Defines the metadata of IdentityProviderList
   *
   * @returns {object} metadata of IdentityProviderList
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IdentityProviderList',
      type: {
        name: 'Composite',
        className: 'IdentityProviderList',
        modelProperties: {
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'IdentityProviderContractElementType',
                  type: {
                    name: 'Composite',
                    className: 'IdentityProviderContract'
                  }
              }
            }
          },
          nextLink: {
            required: false,
            serializedName: 'nextLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = IdentityProviderList;
