/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Logger update contract.
 *
 */
class LoggerUpdateContract {
  /**
   * Create a LoggerUpdateContract.
   * @member {string} [loggerType] Logger type. Possible values include:
   * 'azureEventHub'
   * @member {string} [description] Logger description.
   * @member {object} [credentials] Logger credentials.
   * @member {boolean} [isBuffered] Whether records are buffered in the logger
   * before publishing. Default is assumed to be true.
   */
  constructor() {
  }

  /**
   * Defines the metadata of LoggerUpdateContract
   *
   * @returns {object} metadata of LoggerUpdateContract
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LoggerUpdateContract',
      type: {
        name: 'Composite',
        className: 'LoggerUpdateContract',
        modelProperties: {
          loggerType: {
            required: false,
            serializedName: 'properties.loggerType',
            type: {
              name: 'Enum',
              allowedValues: [ 'azureEventHub' ]
            }
          },
          description: {
            required: false,
            serializedName: 'properties.description',
            type: {
              name: 'String'
            }
          },
          credentials: {
            required: false,
            serializedName: 'properties.credentials',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          isBuffered: {
            required: false,
            serializedName: 'properties.isBuffered',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = LoggerUpdateContract;
