/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * OpenId Connect Provider details.
 *
 * @extends models['Resource']
 */
class OpenidConnectProviderContract extends models['Resource'] {
  /**
   * Create a OpenidConnectProviderContract.
   * @member {string} displayName User-friendly OpenID Connect Provider name.
   * @member {string} [description] User-friendly description of OpenID Connect
   * Provider.
   * @member {string} metadataEndpoint Metadata endpoint URI.
   * @member {string} clientId Client ID of developer console which is the
   * client application.
   * @member {string} [clientSecret] Client Secret of developer console which
   * is the client application.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of OpenidConnectProviderContract
   *
   * @returns {object} metadata of OpenidConnectProviderContract
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OpenidConnectProviderContract',
      type: {
        name: 'Composite',
        className: 'OpenidConnectProviderContract',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: true,
            serializedName: 'properties.displayName',
            constraints: {
              MaxLength: 50
            },
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'properties.description',
            type: {
              name: 'String'
            }
          },
          metadataEndpoint: {
            required: true,
            serializedName: 'properties.metadataEndpoint',
            type: {
              name: 'String'
            }
          },
          clientId: {
            required: true,
            serializedName: 'properties.clientId',
            type: {
              name: 'String'
            }
          },
          clientSecret: {
            required: false,
            serializedName: 'properties.clientSecret',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = OpenidConnectProviderContract;
