/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Sign-Up settings for a developer portal.
 *
 * @extends models['Resource']
 */
class PortalSignupSettings extends models['Resource'] {
  /**
   * Create a PortalSignupSettings.
   * @member {boolean} [enabled] Allow users to sign up on a developer portal.
   * @member {object} [termsOfService] Terms of service contract properties.
   * @member {string} [termsOfService.text] A terms of service text.
   * @member {boolean} [termsOfService.enabled] Display terms of service during
   * a sign-up process.
   * @member {boolean} [termsOfService.consentRequired] Ask user for concent.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of PortalSignupSettings
   *
   * @returns {object} metadata of PortalSignupSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PortalSignupSettings',
      type: {
        name: 'Composite',
        className: 'PortalSignupSettings',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          enabled: {
            required: false,
            serializedName: 'properties.enabled',
            type: {
              name: 'Boolean'
            }
          },
          termsOfService: {
            required: false,
            serializedName: 'properties.termsOfService',
            type: {
              name: 'Composite',
              className: 'TermsOfServiceProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = PortalSignupSettings;
