/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Operation request details.
 *
 */
class RequestContract {
  /**
   * Create a RequestContract.
   * @member {string} [description] Operation request description.
   * @member {array} [queryParameters] Collection of operation request query
   * parameters.
   * @member {array} [headers] Collection of operation request headers.
   * @member {array} [representations] Collection of operation request
   * representations.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RequestContract
   *
   * @returns {object} metadata of RequestContract
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RequestContract',
      type: {
        name: 'Composite',
        className: 'RequestContract',
        modelProperties: {
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          queryParameters: {
            required: false,
            serializedName: 'queryParameters',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ParameterContractElementType',
                  type: {
                    name: 'Composite',
                    className: 'ParameterContract'
                  }
              }
            }
          },
          headers: {
            required: false,
            serializedName: 'headers',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ParameterContractElementType',
                  type: {
                    name: 'Composite',
                    className: 'ParameterContract'
                  }
              }
            }
          },
          representations: {
            required: false,
            serializedName: 'representations',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'RepresentationContractElementType',
                  type: {
                    name: 'Composite',
                    className: 'RepresentationContract'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = RequestContract;
