/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * User Entity Base Parameters set.
 *
 */
class UserEntityBaseParameters {
  /**
   * Create a UserEntityBaseParameters.
   * @member {string} [state] Account state. Specifies whether the user is
   * active or not. Blocked users are unable to sign into the developer portal
   * or call any APIs of subscribed products. Default state is Active. Possible
   * values include: 'active', 'blocked'. Default value: 'active' .
   * @member {string} [note] Optional note about a user set by the
   * administrator.
   * @member {array} [identities] Collection of user identities.
   */
  constructor() {
  }

  /**
   * Defines the metadata of UserEntityBaseParameters
   *
   * @returns {object} metadata of UserEntityBaseParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UserEntityBaseParameters',
      type: {
        name: 'Composite',
        className: 'UserEntityBaseParameters',
        modelProperties: {
          state: {
            required: false,
            serializedName: 'state',
            defaultValue: 'active',
            type: {
              name: 'Enum',
              allowedValues: [ 'active', 'blocked' ]
            }
          },
          note: {
            required: false,
            serializedName: 'note',
            type: {
              name: 'String'
            }
          },
          identities: {
            required: false,
            readOnly: true,
            serializedName: 'identities',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'UserIdentityContractElementType',
                  type: {
                    name: 'Composite',
                    className: 'UserIdentityContract'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = UserEntityBaseParameters;
