/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties of server X509Names.
 *
 */
class X509CertificateName {
  /**
   * Create a X509CertificateName.
   * @member {string} [name] Common Name of the Certificate.
   * @member {string} [issuerCertificateThumbprint] Thumbprint for the Issuer
   * of the Certificate.
   */
  constructor() {
  }

  /**
   * Defines the metadata of X509CertificateName
   *
   * @returns {object} metadata of X509CertificateName
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'X509CertificateName',
      type: {
        name: 'Composite',
        className: 'X509CertificateName',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          issuerCertificateThumbprint: {
            required: false,
            serializedName: 'issuerCertificateThumbprint',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = X509CertificateName;
