/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A list of 0 or more Application Insights web test definitions.
 */
class WebTestListResult extends Array {
  /**
   * Create a WebTestListResult.
   * @member {string} [nextLink] The link to get the next part of the returned
   * list of web tests, should the return set be too large for a single
   * request. May be null.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of WebTestListResult
   *
   * @returns {object} metadata of WebTestListResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'webTestListResult',
      type: {
        name: 'Composite',
        className: 'WebTestListResult',
        modelProperties: {
          value: {
            required: true,
            serializedName: '',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'WebTestElementType',
                  type: {
                    name: 'Composite',
                    className: 'WebTest'
                  }
              }
            }
          },
          nextLink: {
            required: false,
            serializedName: 'nextLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = WebTestListResult;
