/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Operation
 *
 */
class ProviderOperation {
  /**
   * Create a ProviderOperation.
   * @member {string} [name] The operation name.
   * @member {string} [displayName] The operation display name.
   * @member {string} [description] The operation description.
   * @member {string} [origin] The operation origin.
   * @member {object} [properties] The operation properties.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ProviderOperation
   *
   * @returns {object} metadata of ProviderOperation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ProviderOperation',
      type: {
        name: 'Composite',
        className: 'ProviderOperation',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            serializedName: 'displayName',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          origin: {
            required: false,
            serializedName: 'origin',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = ProviderOperation;
