/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Role assignment create parameters.
 *
 */
class RoleAssignmentCreateParameters {
  /**
   * Create a RoleAssignmentCreateParameters.
   * @member {object} [properties] Role assignment properties.
   * @member {string} [properties.roleDefinitionId] The role definition ID used
   * in the role assignment.
   * @member {string} [properties.principalId] The principal ID assigned to the
   * role. This maps to the ID inside the Active Directory. It can point to a
   * user, service principal, or security group.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RoleAssignmentCreateParameters
   *
   * @returns {object} metadata of RoleAssignmentCreateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RoleAssignmentCreateParameters',
      type: {
        name: 'Composite',
        className: 'RoleAssignmentCreateParameters',
        modelProperties: {
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'RoleAssignmentProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = RoleAssignmentCreateParameters;
