/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Role definition.
 *
 */
class RoleDefinition {
  /**
   * Create a RoleDefinition.
   * @member {string} [id] The role definition ID.
   * @member {string} [name] The role definition name.
   * @member {string} [type] The role definition type.
   * @member {object} [properties] Role definition properties.
   * @member {string} [properties.roleName] The role name.
   * @member {string} [properties.description] The role definition description.
   * @member {string} [properties.type] The role type.
   * @member {array} [properties.permissions] Role definition permissions.
   * @member {array} [properties.assignableScopes] Role definition assignable
   * scopes.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RoleDefinition
   *
   * @returns {object} metadata of RoleDefinition
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RoleDefinition',
      type: {
        name: 'Composite',
        className: 'RoleDefinition',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'RoleDefinitionProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = RoleDefinition;
