/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The properties of the create Advanced Schedule.
 *
 */
class AdvancedSchedule {
  /**
   * Create a AdvancedSchedule.
   * @member {array} [weekDays] Days of the week that the job should execute
   * on.
   * @member {array} [monthDays] Days of the month that the job should execute
   * on. Must be between 1 and 31.
   * @member {array} [monthlyOccurrences] Occurrences of days within a month.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AdvancedSchedule
   *
   * @returns {object} metadata of AdvancedSchedule
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AdvancedSchedule',
      type: {
        name: 'Composite',
        className: 'AdvancedSchedule',
        modelProperties: {
          weekDays: {
            required: false,
            serializedName: 'weekDays',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          monthDays: {
            required: false,
            serializedName: 'monthDays',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'NumberElementType',
                  type: {
                    name: 'Number'
                  }
              }
            }
          },
          monthlyOccurrences: {
            required: false,
            serializedName: 'monthlyOccurrences',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'AdvancedScheduleMonthlyOccurrenceElementType',
                  type: {
                    name: 'Composite',
                    className: 'AdvancedScheduleMonthlyOccurrence'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = AdvancedSchedule;
