/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Definition of the agent registration infomration type.
 *
 */
class AgentRegistration {
  /**
   * Create a AgentRegistration.
   * @member {string} [dscMetaConfiguration] Gets or sets the dsc meta
   * configuration.
   * @member {string} [endpoint] Gets or sets the dsc server endpoint.
   * @member {object} [keys] Gets or sets the agent registration keys.
   * @member {string} [keys.primary] Gets or sets the primary key.
   * @member {string} [keys.secondary] Gets or sets the secondary key.
   * @member {string} [id] Gets or sets the id.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AgentRegistration
   *
   * @returns {object} metadata of AgentRegistration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AgentRegistration',
      type: {
        name: 'Composite',
        className: 'AgentRegistration',
        modelProperties: {
          dscMetaConfiguration: {
            required: false,
            serializedName: 'dscMetaConfiguration',
            type: {
              name: 'String'
            }
          },
          endpoint: {
            required: false,
            serializedName: 'endpoint',
            type: {
              name: 'String'
            }
          },
          keys: {
            required: false,
            serializedName: 'keys',
            type: {
              name: 'Composite',
              className: 'AgentRegistrationKeys'
            }
          },
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AgentRegistration;
