/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The parameters supplied to the regenerate keys operation.
 *
 */
class AgentRegistrationRegenerateKeyParameter {
  /**
   * Create a AgentRegistrationRegenerateKeyParameter.
   * @member {string} keyName Gets or sets the agent registration key name -
   * Primary or Secondary. Possible values include: 'Primary', 'Secondary'
   * @member {string} [name] Gets or sets the name of the resource.
   * @member {string} [location] Gets or sets the location of the resource.
   * @member {object} [tags] Gets or sets the tags attached to the resource.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AgentRegistrationRegenerateKeyParameter
   *
   * @returns {object} metadata of AgentRegistrationRegenerateKeyParameter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AgentRegistrationRegenerateKeyParameter',
      type: {
        name: 'Composite',
        className: 'AgentRegistrationRegenerateKeyParameter',
        modelProperties: {
          keyName: {
            required: true,
            serializedName: 'keyName',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = AgentRegistrationRegenerateKeyParameter;
