/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The parameters supplied to the update connection operation.
 *
 */
class ConnectionUpdateParameters {
  /**
   * Create a ConnectionUpdateParameters.
   * @member {string} [name] Gets or sets the name of the connection.
   * @member {string} [description] Gets or sets the description of the
   * connection.
   * @member {object} [fieldDefinitionValues] Gets or sets the field definition
   * values of the connection.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ConnectionUpdateParameters
   *
   * @returns {object} metadata of ConnectionUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ConnectionUpdateParameters',
      type: {
        name: 'Composite',
        className: 'ConnectionUpdateParameters',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'properties.description',
            type: {
              name: 'String'
            }
          },
          fieldDefinitionValues: {
            required: false,
            serializedName: 'properties.fieldDefinitionValues',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ConnectionUpdateParameters;
