/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The parameters supplied to the create or update credential operation.
 *
 */
class CredentialCreateOrUpdateParameters {
  /**
   * Create a CredentialCreateOrUpdateParameters.
   * @member {string} name Gets or sets the name of the credential.
   * @member {string} userName Gets or sets the user name of the credential.
   * @member {string} password Gets or sets the password of the credential.
   * @member {string} [description] Gets or sets the description of the
   * credential.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CredentialCreateOrUpdateParameters
   *
   * @returns {object} metadata of CredentialCreateOrUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CredentialCreateOrUpdateParameters',
      type: {
        name: 'Composite',
        className: 'CredentialCreateOrUpdateParameters',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          userName: {
            required: true,
            serializedName: 'properties.userName',
            type: {
              name: 'String'
            }
          },
          password: {
            required: true,
            serializedName: 'properties.password',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'properties.description',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CredentialCreateOrUpdateParameters;
