/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The parameters supplied to the create compilation job operation.
 *
 */
class DscCompilationJobCreateParameters {
  /**
   * Create a DscCompilationJobCreateParameters.
   * @member {object} configuration Gets or sets the configuration.
   * @member {string} [configuration.name] Gets or sets the name of the Dsc
   * configuration.
   * @member {object} [parameters] Gets or sets the parameters of the job.
   * @member {string} [name] Gets or sets name of the resource.
   * @member {string} [location] Gets or sets the location of the resource.
   * @member {object} [tags] Gets or sets the tags attached to the resource.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DscCompilationJobCreateParameters
   *
   * @returns {object} metadata of DscCompilationJobCreateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DscCompilationJobCreateParameters',
      type: {
        name: 'Composite',
        className: 'DscCompilationJobCreateParameters',
        modelProperties: {
          configuration: {
            required: true,
            serializedName: 'properties.configuration',
            type: {
              name: 'Composite',
              className: 'DscConfigurationAssociationProperty'
            }
          },
          parameters: {
            required: false,
            serializedName: 'properties.parameters',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = DscCompilationJobCreateParameters;
