/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The parameters supplied to the create or update configuration operation.
 *
 */
class DscConfigurationCreateOrUpdateParameters {
  /**
   * Create a DscConfigurationCreateOrUpdateParameters.
   * @member {boolean} [logVerbose] Gets or sets verbose log option.
   * @member {boolean} [logProgress] Gets or sets progress log option.
   * @member {object} source Gets or sets the source.
   * @member {object} [source.hash] Gets or sets the hash.
   * @member {string} [source.hash.algorithm] Gets or sets the content hash
   * algorithm used to hash the content.
   * @member {string} [source.hash.value] Gets or sets expected hash value of
   * the content.
   * @member {string} [source.type] Gets or sets the content source type.
   * Possible values include: 'embeddedContent', 'uri'
   * @member {string} [source.value] Gets or sets the value of the content.
   * This is based on the content source type.
   * @member {string} [source.version] Gets or sets the version of the content.
   * @member {object} [parameters] Gets or sets the configuration parameters.
   * @member {string} [description] Gets or sets the description of the
   * configuration.
   * @member {string} [name] Gets or sets name of the resource.
   * @member {string} [location] Gets or sets the location of the resource.
   * @member {object} [tags] Gets or sets the tags attached to the resource.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DscConfigurationCreateOrUpdateParameters
   *
   * @returns {object} metadata of DscConfigurationCreateOrUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DscConfigurationCreateOrUpdateParameters',
      type: {
        name: 'Composite',
        className: 'DscConfigurationCreateOrUpdateParameters',
        modelProperties: {
          logVerbose: {
            required: false,
            serializedName: 'properties.logVerbose',
            type: {
              name: 'Boolean'
            }
          },
          logProgress: {
            required: false,
            serializedName: 'properties.logProgress',
            type: {
              name: 'Boolean'
            }
          },
          source: {
            required: true,
            serializedName: 'properties.source',
            type: {
              name: 'Composite',
              className: 'ContentSource'
            }
          },
          parameters: {
            required: false,
            serializedName: 'properties.parameters',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'DscConfigurationParameterElementType',
                  type: {
                    name: 'Composite',
                    className: 'DscConfigurationParameter'
                  }
              }
            }
          },
          description: {
            required: false,
            serializedName: 'properties.description',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = DscConfigurationCreateOrUpdateParameters;
