/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Definition of the dsc node report error type.
 *
 */
class DscReportError {
  /**
   * Create a DscReportError.
   * @member {string} [errorSource] Gets or sets the source of the error.
   * @member {string} [resourceId] Gets or sets the resource ID which generated
   * the error.
   * @member {string} [errorCode] Gets or sets the error code.
   * @member {string} [errorMessage] Gets or sets the error message.
   * @member {string} [locale] Gets or sets the locale of the error.
   * @member {string} [errorDetails] Gets or sets the error details.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DscReportError
   *
   * @returns {object} metadata of DscReportError
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DscReportError',
      type: {
        name: 'Composite',
        className: 'DscReportError',
        modelProperties: {
          errorSource: {
            required: false,
            serializedName: 'errorSource',
            type: {
              name: 'String'
            }
          },
          resourceId: {
            required: false,
            serializedName: 'resourceId',
            type: {
              name: 'String'
            }
          },
          errorCode: {
            required: false,
            serializedName: 'errorCode',
            type: {
              name: 'String'
            }
          },
          errorMessage: {
            required: false,
            serializedName: 'errorMessage',
            type: {
              name: 'String'
            }
          },
          locale: {
            required: false,
            serializedName: 'locale',
            type: {
              name: 'String'
            }
          },
          errorDetails: {
            required: false,
            serializedName: 'errorDetails',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DscReportError;
