/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The parameters supplied to the create job schedule operation.
 *
 */
class JobScheduleCreateParameters {
  /**
   * Create a JobScheduleCreateParameters.
   * @member {object} schedule Gets or sets the schedule.
   * @member {string} [schedule.name] Gets or sets the name of the schedule.
   * @member {object} runbook Gets or sets the runbook.
   * @member {string} [runbook.name] Gets or sets the name of the runbook.
   * @member {string} [runOn] Gets or sets the hybrid worker group that the
   * scheduled job should run on.
   * @member {object} [parameters] Gets or sets a list of job properties.
   */
  constructor() {
  }

  /**
   * Defines the metadata of JobScheduleCreateParameters
   *
   * @returns {object} metadata of JobScheduleCreateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'JobScheduleCreateParameters',
      type: {
        name: 'Composite',
        className: 'JobScheduleCreateParameters',
        modelProperties: {
          schedule: {
            required: true,
            serializedName: 'properties.schedule',
            type: {
              name: 'Composite',
              className: 'ScheduleAssociationProperty'
            }
          },
          runbook: {
            required: true,
            serializedName: 'properties.runbook',
            type: {
              name: 'Composite',
              className: 'RunbookAssociationProperty'
            }
          },
          runOn: {
            required: false,
            serializedName: 'properties.runOn',
            type: {
              name: 'String'
            }
          },
          parameters: {
            required: false,
            serializedName: 'properties.parameters',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = JobScheduleCreateParameters;
