/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Definition of the job stream.
 *
 */
class JobStream {
  /**
   * Create a JobStream.
   * @member {string} [id] Gets or sets the id of the resource.
   * @member {string} [jobStreamId] Gets or sets the id of the job stream.
   * @member {date} [time] Gets or sets the creation time of the job.
   * @member {string} [streamType] Gets or sets the stream type. Possible
   * values include: 'Progress', 'Output', 'Warning', 'Error', 'Debug',
   * 'Verbose', 'Any'
   * @member {string} [streamText] Gets or sets the stream text.
   * @member {string} [summary] Gets or sets the summary.
   * @member {object} [value] Gets or sets the values of the job stream.
   */
  constructor() {
  }

  /**
   * Defines the metadata of JobStream
   *
   * @returns {object} metadata of JobStream
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'JobStream',
      type: {
        name: 'Composite',
        className: 'JobStream',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          jobStreamId: {
            required: false,
            serializedName: 'properties.jobStreamId',
            type: {
              name: 'String'
            }
          },
          time: {
            required: false,
            serializedName: 'properties.time',
            type: {
              name: 'DateTime'
            }
          },
          streamType: {
            required: false,
            serializedName: 'properties.streamType',
            type: {
              name: 'String'
            }
          },
          streamText: {
            required: false,
            serializedName: 'properties.streamText',
            type: {
              name: 'String'
            }
          },
          summary: {
            required: false,
            serializedName: 'properties.summary',
            type: {
              name: 'String'
            }
          },
          value: {
            required: false,
            serializedName: 'properties.value',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'ObjectElementType',
                  type: {
                    name: 'Object'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = JobStream;
