/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The parameters supplied to the create or update dratft runbook properties.
 *
 */
class RunbookCreateOrUpdateDraftProperties {
  /**
   * Create a RunbookCreateOrUpdateDraftProperties.
   * @member {boolean} [logVerbose] Gets or sets verbose log option.
   * @member {boolean} [logProgress] Gets or sets progress log option.
   * @member {string} runbookType Gets or sets the type of the runbook.
   * Possible values include: 'Script', 'Graph', 'PowerShellWorkflow',
   * 'PowerShell', 'GraphPowerShellWorkflow', 'GraphPowerShell'
   * @member {object} draft Gets or sets the draft runbook properties.
   * @member {boolean} [draft.inEdit] Gets or sets whether runbook is in edit
   * mode.
   * @member {object} [draft.draftContentLink] Gets or sets the draft runbook
   * content link.
   * @member {string} [draft.draftContentLink.uri] Gets or sets the uri of the
   * runbook content.
   * @member {object} [draft.draftContentLink.contentHash] Gets or sets the
   * hash.
   * @member {string} [draft.draftContentLink.contentHash.algorithm] Gets or
   * sets the content hash algorithm used to hash the content.
   * @member {string} [draft.draftContentLink.contentHash.value] Gets or sets
   * expected hash value of the content.
   * @member {string} [draft.draftContentLink.version] Gets or sets the version
   * of the content.
   * @member {date} [draft.creationTime] Gets or sets the creation time of the
   * runbook draft.
   * @member {date} [draft.lastModifiedTime] Gets or sets the last modified
   * time of the runbook draft.
   * @member {object} [draft.parameters] Gets or sets the runbook draft
   * parameters.
   * @member {array} [draft.outputTypes] Gets or sets the runbook output types.
   * @member {string} [description] Gets or sets the description of the
   * runbook.
   * @member {number} [logActivityTrace] Gets or sets the activity-level
   * tracing options of the runbook.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RunbookCreateOrUpdateDraftProperties
   *
   * @returns {object} metadata of RunbookCreateOrUpdateDraftProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RunbookCreateOrUpdateDraftProperties',
      type: {
        name: 'Composite',
        className: 'RunbookCreateOrUpdateDraftProperties',
        modelProperties: {
          logVerbose: {
            required: false,
            serializedName: 'logVerbose',
            type: {
              name: 'Boolean'
            }
          },
          logProgress: {
            required: false,
            serializedName: 'logProgress',
            type: {
              name: 'Boolean'
            }
          },
          runbookType: {
            required: true,
            serializedName: 'runbookType',
            type: {
              name: 'String'
            }
          },
          draft: {
            required: true,
            serializedName: 'draft',
            type: {
              name: 'Composite',
              className: 'RunbookDraft'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          logActivityTrace: {
            required: false,
            serializedName: 'logActivityTrace',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = RunbookCreateOrUpdateDraftProperties;
