/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Definition of the runbook parameter type.
 *
 */
class RunbookParameter {
  /**
   * Create a RunbookParameter.
   * @member {string} [type] Gets or sets the type of the parameter.
   * @member {boolean} [isMandatory] Gets or sets a Boolean value to indicate
   * whether the parameter is madatory or not.
   * @member {number} [position] Get or sets the position of the parameter.
   * @member {string} [defaultValue] Gets or sets the default value of
   * parameter.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RunbookParameter
   *
   * @returns {object} metadata of RunbookParameter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RunbookParameter',
      type: {
        name: 'Composite',
        className: 'RunbookParameter',
        modelProperties: {
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          isMandatory: {
            required: false,
            serializedName: 'isMandatory',
            type: {
              name: 'Boolean'
            }
          },
          position: {
            required: false,
            serializedName: 'position',
            type: {
              name: 'Number'
            }
          },
          defaultValue: {
            required: false,
            serializedName: 'defaultValue',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = RunbookParameter;
