/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The parameters supplied to the update runbook operation.
 *
 */
class RunbookUpdateParameters {
  /**
   * Create a RunbookUpdateParameters.
   * @member {string} [description] Gets or sets the description of the
   * runbook.
   * @member {boolean} [logVerbose] Gets or sets verbose log option.
   * @member {boolean} [logProgress] Gets or sets progress log option.
   * @member {number} [logActivityTrace] Gets or sets the activity-level
   * tracing options of the runbook.
   * @member {string} [name] Gets or sets the name of the resource.
   * @member {string} [location] Gets or sets the location of the resource.
   * @member {object} [tags] Gets or sets the tags attached to the resource.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RunbookUpdateParameters
   *
   * @returns {object} metadata of RunbookUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RunbookUpdateParameters',
      type: {
        name: 'Composite',
        className: 'RunbookUpdateParameters',
        modelProperties: {
          description: {
            required: false,
            serializedName: 'properties.description',
            type: {
              name: 'String'
            }
          },
          logVerbose: {
            required: false,
            serializedName: 'properties.logVerbose',
            type: {
              name: 'Boolean'
            }
          },
          logProgress: {
            required: false,
            serializedName: 'properties.logProgress',
            type: {
              name: 'Boolean'
            }
          },
          logActivityTrace: {
            required: false,
            serializedName: 'properties.logActivityTrace',
            type: {
              name: 'Number'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = RunbookUpdateParameters;
