/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Definition of the test job.
 *
 */
class TestJob {
  /**
   * Create a TestJob.
   * @member {date} [creationTime] Gets or sets the creation time of the test
   * job.
   * @member {string} [status] Gets or sets the status of the test job.
   * @member {string} [statusDetails] Gets or sets the status details of the
   * test job.
   * @member {string} [runOn] Gets or sets the runOn which specifies the group
   * name where the job is to be executed.
   * @member {date} [startTime] Gets or sets the start time of the test job.
   * @member {date} [endTime] Gets or sets the end time of the test job.
   * @member {string} [exception] Gets or sets the exception of the test job.
   * @member {date} [lastModifiedTime] Gets or sets the last modified time of
   * the test job.
   * @member {date} [lastStatusModifiedTime] Gets or sets the last status
   * modified time of the test job.
   * @member {object} [parameters] Gets or sets the parameters of the test job.
   */
  constructor() {
  }

  /**
   * Defines the metadata of TestJob
   *
   * @returns {object} metadata of TestJob
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TestJob',
      type: {
        name: 'Composite',
        className: 'TestJob',
        modelProperties: {
          creationTime: {
            required: false,
            serializedName: 'creationTime',
            type: {
              name: 'DateTime'
            }
          },
          status: {
            required: false,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          },
          statusDetails: {
            required: false,
            serializedName: 'statusDetails',
            type: {
              name: 'String'
            }
          },
          runOn: {
            required: false,
            serializedName: 'runOn',
            type: {
              name: 'String'
            }
          },
          startTime: {
            required: false,
            serializedName: 'startTime',
            type: {
              name: 'DateTime'
            }
          },
          endTime: {
            required: false,
            serializedName: 'endTime',
            type: {
              name: 'DateTime'
            }
          },
          exception: {
            required: false,
            serializedName: 'exception',
            type: {
              name: 'String'
            }
          },
          lastModifiedTime: {
            required: false,
            serializedName: 'lastModifiedTime',
            type: {
              name: 'DateTime'
            }
          },
          lastStatusModifiedTime: {
            required: false,
            serializedName: 'lastStatusModifiedTime',
            type: {
              name: 'DateTime'
            }
          },
          parameters: {
            required: false,
            serializedName: 'parameters',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = TestJob;
