/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The parameters supplied to the create or update webhook operation.
 *
 */
class WebhookCreateOrUpdateParameters {
  /**
   * Create a WebhookCreateOrUpdateParameters.
   * @member {string} name Gets or sets the name of the webhook.
   * @member {boolean} [isEnabled] Gets or sets the value of the enabled flag
   * of webhook.
   * @member {string} [uri] Gets or sets the uri.
   * @member {date} [expiryTime] Gets or sets the expiry time.
   * @member {object} [parameters] Gets or sets the parameters of the job.
   * @member {object} [runbook] Gets or sets the runbook.
   * @member {string} [runbook.name] Gets or sets the name of the runbook.
   * @member {string} [runOn] Gets or sets the name of the hybrid worker group
   * the webhook job will run on.
   */
  constructor() {
  }

  /**
   * Defines the metadata of WebhookCreateOrUpdateParameters
   *
   * @returns {object} metadata of WebhookCreateOrUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'WebhookCreateOrUpdateParameters',
      type: {
        name: 'Composite',
        className: 'WebhookCreateOrUpdateParameters',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          isEnabled: {
            required: false,
            serializedName: 'properties.isEnabled',
            type: {
              name: 'Boolean'
            }
          },
          uri: {
            required: false,
            serializedName: 'properties.uri',
            type: {
              name: 'String'
            }
          },
          expiryTime: {
            required: false,
            serializedName: 'properties.expiryTime',
            type: {
              name: 'DateTime'
            }
          },
          parameters: {
            required: false,
            serializedName: 'properties.parameters',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          runbook: {
            required: false,
            serializedName: 'properties.runbook',
            type: {
              name: 'Composite',
              className: 'RunbookAssociationProperty'
            }
          },
          runOn: {
            required: false,
            serializedName: 'properties.runOn',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = WebhookCreateOrUpdateParameters;
