/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The parameters supplied to the update webhook operation.
 *
 */
class WebhookUpdateParameters {
  /**
   * Create a WebhookUpdateParameters.
   * @member {string} name Gets or sets the name of the webhook.
   * @member {boolean} [isEnabled] Gets or sets the value of the enabled flag
   * of webhook.
   * @member {string} [runOn] Gets or sets the name of the hybrid worker group
   * the webhook job will run on.
   * @member {object} [parameters] Gets or sets the parameters of the job.
   * @member {string} [description] Gets or sets the description of the
   * webhook.
   */
  constructor() {
  }

  /**
   * Defines the metadata of WebhookUpdateParameters
   *
   * @returns {object} metadata of WebhookUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'WebhookUpdateParameters',
      type: {
        name: 'Composite',
        className: 'WebhookUpdateParameters',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          isEnabled: {
            required: false,
            serializedName: 'properties.isEnabled',
            type: {
              name: 'Boolean'
            }
          },
          runOn: {
            required: false,
            serializedName: 'properties.runOn',
            type: {
              name: 'String'
            }
          },
          parameters: {
            required: false,
            serializedName: 'properties.parameters',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          description: {
            required: false,
            serializedName: 'properties.description',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = WebhookUpdateParameters;
