/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Contains information about the auto-storage account associated with a Batch
 * account.
 *
 * @extends models['AutoStorageBaseProperties']
 */
class AutoStorageProperties extends models['AutoStorageBaseProperties'] {
  /**
   * Create a AutoStorageProperties.
   * @member {date} lastKeySync The UTC time at which storage keys were last
   * synchronized with the Batch account.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AutoStorageProperties
   *
   * @returns {object} metadata of AutoStorageProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AutoStorageProperties',
      type: {
        name: 'Composite',
        className: 'AutoStorageProperties',
        modelProperties: {
          storageAccountId: {
            required: true,
            serializedName: 'storageAccountId',
            type: {
              name: 'String'
            }
          },
          lastKeySync: {
            required: true,
            serializedName: 'lastKeySync',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = AutoStorageProperties;
