/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Quotas associated with a Batch region for a particular subscription.
 *
 */
class BatchLocationQuota {
  /**
   * Create a BatchLocationQuota.
   * @member {number} [accountQuota] The number of Batch accounts that may be
   * created under the subscription in the specified region.
   */
  constructor() {
  }

  /**
   * Defines the metadata of BatchLocationQuota
   *
   * @returns {object} metadata of BatchLocationQuota
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BatchLocationQuota',
      type: {
        name: 'Composite',
        className: 'BatchLocationQuota',
        modelProperties: {
          accountQuota: {
            required: false,
            readOnly: true,
            serializedName: 'accountQuota',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = BatchLocationQuota;
