/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A secure URL that can be used to download a PDF invoice until the URL
 * expires.
 *
 */
class DownloadUrl {
  /**
   * Create a DownloadUrl.
   * @member {date} [expiryTime] The time in UTC at which this download URL
   * will expire.
   * @member {string} [url] The URL to the PDF file.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DownloadUrl
   *
   * @returns {object} metadata of DownloadUrl
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DownloadUrl',
      type: {
        name: 'Composite',
        className: 'DownloadUrl',
        modelProperties: {
          expiryTime: {
            required: false,
            readOnly: true,
            serializedName: 'expiryTime',
            type: {
              name: 'DateTime'
            }
          },
          url: {
            required: false,
            readOnly: true,
            serializedName: 'url',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DownloadUrl;
