/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Result of listing invoices. It contains a list of available invoices in
 * reverse chronological order.
 */
class InvoicesListResult extends Array {
  /**
   * Create a InvoicesListResult.
   * @member {string} [nextLink] The link (url) to the next page of results.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of InvoicesListResult
   *
   * @returns {object} metadata of InvoicesListResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'InvoicesListResult',
      type: {
        name: 'Composite',
        className: 'InvoicesListResult',
        modelProperties: {
          value: {
            required: false,
            readOnly: true,
            serializedName: '',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'InvoiceElementType',
                  type: {
                    name: 'Composite',
                    className: 'Invoice'
                  }
              }
            }
          },
          nextLink: {
            required: false,
            readOnly: true,
            serializedName: 'nextLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = InvoicesListResult;
