/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Edgenode is a global Point of Presence (POP) location used to deliver CDN
 * content to end users.
 *
 * @extends models['Resource']
 */
class EdgeNode extends models['Resource'] {
  /**
   * Create a EdgeNode.
   * @member {array} ipAddressGroups List of ip address groups.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of EdgeNode
   *
   * @returns {object} metadata of EdgeNode
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EdgeNode',
      type: {
        name: 'Composite',
        className: 'EdgeNode',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          ipAddressGroups: {
            required: true,
            serializedName: 'properties.ipAddressGroups',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'IpAddressGroupElementType',
                  type: {
                    name: 'Composite',
                    className: 'IpAddressGroup'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = EdgeNode;
