/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The operation supported by Cognitive Services.
 *
 */
class OperationDisplayInfo {
  /**
   * Create a OperationDisplayInfo.
   * @member {string} [description] The description of the operation.
   * @member {string} [operation] The action that users can perform, based on
   * their permission level.
   * @member {string} [provider] Service provider: Microsoft Cognitive
   * Services.
   * @member {string} [resource] Resource on which the operation is performed.
   */
  constructor() {
  }

  /**
   * Defines the metadata of OperationDisplayInfo
   *
   * @returns {object} metadata of OperationDisplayInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OperationDisplayInfo',
      type: {
        name: 'Composite',
        className: 'OperationDisplayInfo',
        modelProperties: {
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          operation: {
            required: false,
            serializedName: 'operation',
            type: {
              name: 'String'
            }
          },
          provider: {
            required: false,
            serializedName: 'provider',
            type: {
              name: 'String'
            }
          },
          resource: {
            required: false,
            serializedName: 'resource',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = OperationDisplayInfo;
