/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The SKU of the cognitive services account.
 *
 */
class Sku {
  /**
   * Create a Sku.
   * @member {string} name Gets or sets the sku name. Required for account
   * creation, optional for update. Possible values include: 'F0', 'P0', 'P1',
   * 'P2', 'S0', 'S1', 'S2', 'S3', 'S4', 'S5', 'S6'
   * @member {string} [tier] Gets the sku tier. This is based on the SKU name.
   * Possible values include: 'Free', 'Standard', 'Premium'
   */
  constructor() {
  }

  /**
   * Defines the metadata of Sku
   *
   * @returns {object} metadata of Sku
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Sku',
      type: {
        name: 'Composite',
        className: 'Sku',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          tier: {
            required: false,
            readOnly: true,
            serializedName: 'tier',
            type: {
              name: 'Enum',
              allowedValues: [ 'Free', 'Standard', 'Premium' ]
            }
          }
        }
      }
    };
  }
}

module.exports = Sku;
