/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Indicates that this is a monetary credit offer.
 *
 * @extends models['OfferTermInfo']
 */
class MonetaryCredit extends models['OfferTermInfo'] {
  /**
   * Create a MonetaryCredit.
   * @member {number} [credit] The amount of credit provided under the terms of
   * the given offer level.
   * @member {array} [excludedMeterIds] An array of meter ids that are excluded
   * from the given offer terms.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of MonetaryCredit
   *
   * @returns {object} metadata of MonetaryCredit
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Monetary Credit',
      type: {
        name: 'Composite',
        className: 'MonetaryCredit',
        modelProperties: {
          effectiveDate: {
            required: false,
            serializedName: 'EffectiveDate',
            type: {
              name: 'DateTime'
            }
          },
          name: {
            required: true,
            serializedName: 'Name',
            type: {
              name: 'String'
            }
          },
          credit: {
            required: false,
            serializedName: 'Credit',
            type: {
              name: 'Number'
            }
          },
          excludedMeterIds: {
            required: false,
            serializedName: 'ExcludedMeterIds',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'UuidElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = MonetaryCredit;
