/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The instance view of the container instance. Only valid in response.
 *
 */
class ContainerPropertiesInstanceView {
  /**
   * Create a ContainerPropertiesInstanceView.
   * @member {number} [restartCount] The number of times that the container
   * instance has been restarted.
   * @member {object} [currentState] Current container instance state.
   * @member {string} [currentState.state] The state of the container instance.
   * @member {date} [currentState.startTime] The date-time when the container
   * instance state started.
   * @member {number} [currentState.exitCode] The container instance exit codes
   * correspond to those from the `docker run` command.
   * @member {date} [currentState.finishTime] The date-time when the container
   * instance state finished.
   * @member {string} [currentState.detailStatus] The human-readable status of
   * the container instance state.
   * @member {object} [previousState] Previous container instance state.
   * @member {string} [previousState.state] The state of the container
   * instance.
   * @member {date} [previousState.startTime] The date-time when the container
   * instance state started.
   * @member {number} [previousState.exitCode] The container instance exit
   * codes correspond to those from the `docker run` command.
   * @member {date} [previousState.finishTime] The date-time when the container
   * instance state finished.
   * @member {string} [previousState.detailStatus] The human-readable status of
   * the container instance state.
   * @member {array} [events] The events of the container instance.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ContainerPropertiesInstanceView
   *
   * @returns {object} metadata of ContainerPropertiesInstanceView
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContainerProperties_instanceView',
      type: {
        name: 'Composite',
        className: 'ContainerPropertiesInstanceView',
        modelProperties: {
          restartCount: {
            required: false,
            serializedName: 'restartCount',
            type: {
              name: 'Number'
            }
          },
          currentState: {
            required: false,
            serializedName: 'currentState',
            type: {
              name: 'Composite',
              className: 'ContainerState'
            }
          },
          previousState: {
            required: false,
            serializedName: 'previousState',
            type: {
              name: 'Composite',
              className: 'ContainerState'
            }
          },
          events: {
            required: false,
            serializedName: 'events',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ContainerEventElementType',
                  type: {
                    name: 'Composite',
                    className: 'ContainerEvent'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ContainerPropertiesInstanceView;
