/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The container instance state.
 *
 */
class ContainerState {
  /**
   * Create a ContainerState.
   * @member {string} [state] The state of the container instance.
   * @member {date} [startTime] The date-time when the container instance state
   * started.
   * @member {number} [exitCode] The container instance exit codes correspond
   * to those from the `docker run` command.
   * @member {date} [finishTime] The date-time when the container instance
   * state finished.
   * @member {string} [detailStatus] The human-readable status of the container
   * instance state.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ContainerState
   *
   * @returns {object} metadata of ContainerState
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContainerState',
      type: {
        name: 'Composite',
        className: 'ContainerState',
        modelProperties: {
          state: {
            required: false,
            serializedName: 'state',
            type: {
              name: 'String'
            }
          },
          startTime: {
            required: false,
            serializedName: 'startTime',
            type: {
              name: 'DateTime'
            }
          },
          exitCode: {
            required: false,
            serializedName: 'exitCode',
            type: {
              name: 'Number'
            }
          },
          finishTime: {
            required: false,
            serializedName: 'finishTime',
            type: {
              name: 'DateTime'
            }
          },
          detailStatus: {
            required: false,
            serializedName: 'detailStatus',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ContainerState;
