/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The properties of the volume.
 *
 */
class Volume {
  /**
   * Create a Volume.
   * @member {string} name The name of the volume.
   * @member {object} azureFile The name of the Azure File volume.
   * @member {string} [azureFile.shareName] The name of the Azure File share to
   * be mounted as a volume.
   * @member {boolean} [azureFile.readOnly] The flag indicating whether the
   * Azure File shared mounted as a volume is read-only.
   * @member {string} [azureFile.storageAccountName] The name of the storage
   * account that contains the Azure File share.
   * @member {string} [azureFile.storageAccountKey] The storage account access
   * key used to access the Azure File share.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Volume
   *
   * @returns {object} metadata of Volume
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Volume',
      type: {
        name: 'Composite',
        className: 'Volume',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          azureFile: {
            required: true,
            serializedName: 'azureFile',
            type: {
              name: 'Composite',
              className: 'AzureFileVolume'
            }
          }
        }
      }
    };
  }
}

module.exports = Volume;
