/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The display information for a container registry operation.
 *
 */
class OperationDisplayDefinition {
  /**
   * Create a OperationDisplayDefinition.
   * @member {string} [provider] The resource provider name:
   * Microsoft.ContainerRegistry.
   * @member {string} [resource] The resource on which the operation is
   * performed.
   * @member {string} [operation] The operation that users can perform.
   * @member {string} [description] The description for the operation.
   */
  constructor() {
  }

  /**
   * Defines the metadata of OperationDisplayDefinition
   *
   * @returns {object} metadata of OperationDisplayDefinition
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OperationDisplayDefinition',
      type: {
        name: 'Composite',
        className: 'OperationDisplayDefinition',
        modelProperties: {
          provider: {
            required: false,
            serializedName: 'provider',
            type: {
              name: 'String'
            }
          },
          resource: {
            required: false,
            serializedName: 'resource',
            type: {
              name: 'String'
            }
          },
          operation: {
            required: false,
            serializedName: 'operation',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = OperationDisplayDefinition;
