/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A request to check whether a container registry name is available.
 *
 */
class RegistryNameCheckRequest {
  /**
   * Create a RegistryNameCheckRequest.
   * @member {string} name The name of the container registry.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RegistryNameCheckRequest
   *
   * @returns {object} metadata of RegistryNameCheckRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RegistryNameCheckRequest',
      type: {
        name: 'Composite',
        className: 'RegistryNameCheckRequest',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            constraints: {
              MaxLength: 50,
              MinLength: 5,
              Pattern: '^[a-zA-Z0-9]*$'
            },
            type: {
              name: 'String'
            }
          },
          type: {
            required: true,
            isConstant: true,
            serializedName: 'type',
            defaultValue: 'Microsoft.ContainerRegistry/registries',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = RegistryNameCheckRequest;
