/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The result of a request to check the availability of a container registry
 * name.
 *
 */
class RegistryNameStatus {
  /**
   * Create a RegistryNameStatus.
   * @member {boolean} [nameAvailable] The value that indicates whether the
   * name is available.
   * @member {string} [reason] If any, the reason that the name is not
   * available.
   * @member {string} [message] If any, the error message that provides more
   * detail for the reason that the name is not available.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RegistryNameStatus
   *
   * @returns {object} metadata of RegistryNameStatus
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RegistryNameStatus',
      type: {
        name: 'Composite',
        className: 'RegistryNameStatus',
        modelProperties: {
          nameAvailable: {
            required: false,
            serializedName: 'nameAvailable',
            type: {
              name: 'Boolean'
            }
          },
          reason: {
            required: false,
            serializedName: 'reason',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = RegistryNameStatus;
