/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The request that generated the event.
 *
 */
class Request {
  /**
   * Create a Request.
   * @member {string} [id] The ID of the request that initiated the event.
   * @member {string} [addr] The IP or hostname and possibly port of the client
   * connection that initiated the event. This is the RemoteAddr from the
   * standard http request.
   * @member {string} [host] The externally accessible hostname of the registry
   * instance, as specified by the http host header on incoming requests.
   * @member {string} [method] The request method that generated the event.
   * @member {string} [useragent] The user agent header of the request.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Request
   *
   * @returns {object} metadata of Request
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Request',
      type: {
        name: 'Composite',
        className: 'Request',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          addr: {
            required: false,
            serializedName: 'addr',
            type: {
              name: 'String'
            }
          },
          host: {
            required: false,
            serializedName: 'host',
            type: {
              name: 'String'
            }
          },
          method: {
            required: false,
            serializedName: 'method',
            type: {
              name: 'String'
            }
          },
          useragent: {
            required: false,
            serializedName: 'useragent',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Request;
