/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The status of an Azure resource at the time the operation was called.
 *
 */
class Status {
  /**
   * Create a Status.
   * @member {string} [displayStatus] The short label for the status.
   * @member {string} [message] The detailed message for the status, including
   * alerts and error messages.
   * @member {date} [timestamp] The timestamp when the status was changed to
   * the current value.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Status
   *
   * @returns {object} metadata of Status
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Status',
      type: {
        name: 'Composite',
        className: 'Status',
        modelProperties: {
          displayStatus: {
            required: false,
            readOnly: true,
            serializedName: 'displayStatus',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            readOnly: true,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          },
          timestamp: {
            required: false,
            readOnly: true,
            serializedName: 'timestamp',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = Status;
