/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The parameters for creating a webhook.
 *
 */
class WebhookCreateParameters {
  /**
   * Create a WebhookCreateParameters.
   * @member {object} [tags] The tags for the webhook.
   * @member {string} location The location of the webhook. This cannot be
   * changed after the resource is created.
   * @member {string} serviceUri The service URI for the webhook to post
   * notifications.
   * @member {object} [customHeaders] Custom headers that will be added to the
   * webhook notifications.
   * @member {string} [status] The status of the webhook at the time the
   * operation was called. Possible values include: 'enabled', 'disabled'
   * @member {string} [scope] The scope of repositories where the event can be
   * triggered. For example, 'foo:*' means events for all tags under repository
   * 'foo'. 'foo:bar' means events for 'foo:bar' only. 'foo' is equivalent to
   * 'foo:latest'. Empty means all events.
   * @member {array} actions The list of actions that trigger the webhook to
   * post notifications.
   */
  constructor() {
  }

  /**
   * Defines the metadata of WebhookCreateParameters
   *
   * @returns {object} metadata of WebhookCreateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'WebhookCreateParameters',
      type: {
        name: 'Composite',
        className: 'WebhookCreateParameters',
        modelProperties: {
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          location: {
            required: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          serviceUri: {
            required: true,
            serializedName: 'properties.serviceUri',
            type: {
              name: 'String'
            }
          },
          customHeaders: {
            required: false,
            serializedName: 'properties.customHeaders',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          status: {
            required: false,
            serializedName: 'properties.status',
            type: {
              name: 'String'
            }
          },
          scope: {
            required: false,
            serializedName: 'properties.scope',
            type: {
              name: 'String'
            }
          },
          actions: {
            required: true,
            serializedName: 'properties.actions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = WebhookCreateParameters;
