/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The authorization policy resource format.
 *
 * @extends models['ProxyResource']
 */
class AuthorizationPolicyResourceFormat extends models['ProxyResource'] {
  /**
   * Create a AuthorizationPolicyResourceFormat.
   * @member {string} [policyName] Name of the policy.
   * @member {array} permissions The permissions associated with the policy.
   * @member {string} [primaryKey] Primary key assiciated with the policy.
   * @member {string} [secondaryKey] Secondary key assiciated with the policy.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AuthorizationPolicyResourceFormat
   *
   * @returns {object} metadata of AuthorizationPolicyResourceFormat
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AuthorizationPolicyResourceFormat',
      type: {
        name: 'Composite',
        className: 'AuthorizationPolicyResourceFormat',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          policyName: {
            required: false,
            readOnly: true,
            serializedName: 'properties.policyName',
            type: {
              name: 'String'
            }
          },
          permissions: {
            required: true,
            serializedName: 'properties.permissions',
            constraints: {
              UniqueItems: true
            },
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'PermissionTypesElementType',
                  type: {
                    name: 'Enum',
                    allowedValues: [ 'Read', 'Write', 'Manage' ]
                  }
              }
            }
          },
          primaryKey: {
            required: false,
            serializedName: 'properties.primaryKey',
            type: {
              name: 'String'
            }
          },
          secondaryKey: {
            required: false,
            serializedName: 'properties.secondaryKey',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AuthorizationPolicyResourceFormat;
