/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Connector mapping property availability.
 *
 */
class ConnectorMappingAvailability {
  /**
   * Create a ConnectorMappingAvailability.
   * @member {string} [frequency] The frequency to update. Possible values
   * include: 'Minute', 'Hour', 'Day', 'Week', 'Month'
   * @member {number} interval The interval of the given frequency to use.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ConnectorMappingAvailability
   *
   * @returns {object} metadata of ConnectorMappingAvailability
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ConnectorMappingAvailability',
      type: {
        name: 'Composite',
        className: 'ConnectorMappingAvailability',
        modelProperties: {
          frequency: {
            required: false,
            serializedName: 'frequency',
            type: {
              name: 'Enum',
              allowedValues: [ 'Minute', 'Hour', 'Day', 'Week', 'Month' ]
            }
          },
          interval: {
            required: true,
            serializedName: 'interval',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = ConnectorMappingAvailability;
