/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Hub billing info.
 *
 */
class HubBillingInfoFormat {
  /**
   * Create a HubBillingInfoFormat.
   * @member {string} [skuName] The sku name.
   * @member {number} [minUnits] The minimum number of units will be billed.
   * One unit is 10,000 Profiles and 100,000 Interactions.
   * @member {number} [maxUnits] The maximum number of units can be used.  One
   * unit is 10,000 Profiles and 100,000 Interactions.
   */
  constructor() {
  }

  /**
   * Defines the metadata of HubBillingInfoFormat
   *
   * @returns {object} metadata of HubBillingInfoFormat
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HubBillingInfoFormat',
      type: {
        name: 'Composite',
        className: 'HubBillingInfoFormat',
        modelProperties: {
          skuName: {
            required: false,
            serializedName: 'skuName',
            type: {
              name: 'String'
            }
          },
          minUnits: {
            required: false,
            serializedName: 'minUnits',
            constraints: {
              InclusiveMaximum: 10,
              InclusiveMinimum: 1
            },
            type: {
              name: 'Number'
            }
          },
          maxUnits: {
            required: false,
            serializedName: 'maxUnits',
            constraints: {
              InclusiveMaximum: 10,
              InclusiveMinimum: 1
            },
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = HubBillingInfoFormat;
