/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The image definition.
 *
 */
class ImageDefinition {
  /**
   * Create a ImageDefinition.
   * @member {boolean} [imageExists] Whether image exists already.
   * @member {string} [contentUrl] Content URL for the image blob.
   * @member {string} [relativePath] Relative path of the image.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ImageDefinition
   *
   * @returns {object} metadata of ImageDefinition
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ImageDefinition',
      type: {
        name: 'Composite',
        className: 'ImageDefinition',
        modelProperties: {
          imageExists: {
            required: false,
            serializedName: 'imageExists',
            type: {
              name: 'Boolean'
            }
          },
          contentUrl: {
            required: false,
            serializedName: 'contentUrl',
            type: {
              name: 'String'
            }
          },
          relativePath: {
            required: false,
            serializedName: 'relativePath',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ImageDefinition;
