/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Defines the KPI Threshold limits.
 *
 */
class KpiThresholds {
  /**
   * Create a KpiThresholds.
   * @member {number} lowerLimit The lower threshold limit.
   * @member {number} upperLimit The upper threshold limit.
   * @member {boolean} increasingKpi Whether or not the KPI is an increasing
   * KPI.
   */
  constructor() {
  }

  /**
   * Defines the metadata of KpiThresholds
   *
   * @returns {object} metadata of KpiThresholds
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'KpiThresholds',
      type: {
        name: 'Composite',
        className: 'KpiThresholds',
        modelProperties: {
          lowerLimit: {
            required: true,
            serializedName: 'lowerLimit',
            type: {
              name: 'Number'
            }
          },
          upperLimit: {
            required: true,
            serializedName: 'upperLimit',
            type: {
              name: 'Number'
            }
          },
          increasingKpi: {
            required: true,
            serializedName: 'increasingKpi',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = KpiThresholds;
