/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The definition of suggested relationship for the type.
 *
 */
class RelationshipsLookup {
  /**
   * Create a RelationshipsLookup.
   * @member {string} [profileName] The relationship profile.
   * @member {array} [profilePropertyReferences] The property references for
   * the profile type.
   * @member {string} [relatedProfileName] The related profile.
   * @member {array} [relatedProfilePropertyReferences] The property references
   * for the related profile type.
   * @member {string} [existingRelationshipName] The name of existing
   * Relationship.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RelationshipsLookup
   *
   * @returns {object} metadata of RelationshipsLookup
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RelationshipsLookup',
      type: {
        name: 'Composite',
        className: 'RelationshipsLookup',
        modelProperties: {
          profileName: {
            required: false,
            readOnly: true,
            serializedName: 'profileName',
            type: {
              name: 'String'
            }
          },
          profilePropertyReferences: {
            required: false,
            readOnly: true,
            serializedName: 'profilePropertyReferences',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ParticipantProfilePropertyReferenceElementType',
                  type: {
                    name: 'Composite',
                    className: 'ParticipantProfilePropertyReference'
                  }
              }
            }
          },
          relatedProfileName: {
            required: false,
            readOnly: true,
            serializedName: 'relatedProfileName',
            type: {
              name: 'String'
            }
          },
          relatedProfilePropertyReferences: {
            required: false,
            readOnly: true,
            serializedName: 'relatedProfilePropertyReferences',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ParticipantProfilePropertyReferenceElementType',
                  type: {
                    name: 'Composite',
                    className: 'ParticipantProfilePropertyReference'
                  }
              }
            }
          },
          existingRelationshipName: {
            required: false,
            readOnly: true,
            serializedName: 'existingRelationshipName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = RelationshipsLookup;
