/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Salesforce table.
 *
 */
class SalesforceTable {
  /**
   * Create a SalesforceTable.
   * @member {string} [isProfile] Indicating whether this instance is profile.
   * @member {string} tableCategory The table category.
   * @member {string} tableName The name of the table.
   * @member {string} [tableRemarks] The table remarks.
   * @member {string} tableSchema The table schema.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SalesforceTable
   *
   * @returns {object} metadata of SalesforceTable
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SalesforceTable',
      type: {
        name: 'Composite',
        className: 'SalesforceTable',
        modelProperties: {
          isProfile: {
            required: false,
            serializedName: 'isProfile',
            type: {
              name: 'String'
            }
          },
          tableCategory: {
            required: true,
            serializedName: 'tableCategory',
            type: {
              name: 'String'
            }
          },
          tableName: {
            required: true,
            serializedName: 'tableName',
            type: {
              name: 'String'
            }
          },
          tableRemarks: {
            required: false,
            serializedName: 'tableRemarks',
            type: {
              name: 'String'
            }
          },
          tableSchema: {
            required: true,
            serializedName: 'tableSchema',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SalesforceTable;
