/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Linked service for Amazon Redshift.
 *
 * @extends models['LinkedService']
 */
class AmazonRedshiftLinkedService extends models['LinkedService'] {
  /**
   * Create a AmazonRedshiftLinkedService.
   * @member {object} server The name of the Amazon Redshift server. Type:
   * string (or Expression with resultType string).
   * @member {object} [username] The username of the Amazon Redshift source.
   * Type: string (or Expression with resultType string).
   * @member {object} [password] The password of the Amazon Redshift source.
   * @member {string} [password.value] Value of secure string.
   * @member {object} database The database name of the Amazon Redshift source.
   * Type: string (or Expression with resultType string).
   * @member {object} [port] The TCP port number that the Amazon Redshift
   * server uses to listen for client connections. The default value is 5439.
   * Type: integer (or Expression with resultType integer).
   * @member {object} [encryptedCredential] The encrypted credential used for
   * authentication. Credentials are encrypted using the integration runtime
   * credential manager. Type: string (or Expression with resultType string).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AmazonRedshiftLinkedService
   *
   * @returns {object} metadata of AmazonRedshiftLinkedService
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AmazonRedshift',
      type: {
        name: 'Composite',
        className: 'AmazonRedshiftLinkedService',
        modelProperties: {
          connectVia: {
            required: false,
            serializedName: 'connectVia',
            type: {
              name: 'Composite',
              className: 'IntegrationRuntimeReference'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          server: {
            required: true,
            serializedName: 'typeProperties.server',
            type: {
              name: 'Object'
            }
          },
          username: {
            required: false,
            serializedName: 'typeProperties.username',
            type: {
              name: 'Object'
            }
          },
          password: {
            required: false,
            serializedName: 'typeProperties.password',
            type: {
              name: 'Composite',
              className: 'SecureString'
            }
          },
          database: {
            required: true,
            serializedName: 'typeProperties.database',
            type: {
              name: 'Object'
            }
          },
          port: {
            required: false,
            serializedName: 'typeProperties.port',
            type: {
              name: 'Object'
            }
          },
          encryptedCredential: {
            required: false,
            serializedName: 'typeProperties.encryptedCredential',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = AmazonRedshiftLinkedService;
