/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A copy activity Azure Data Lake source.
 *
 * @extends models['CopySource']
 */
class AzureDataLakeStoreSource extends models['CopySource'] {
  /**
   * Create a AzureDataLakeStoreSource.
   * @member {object} [recursive] If true, files under the folder path will be
   * read recursively. Default is true. Type: boolean (or Expression with
   * resultType boolean).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureDataLakeStoreSource
   *
   * @returns {object} metadata of AzureDataLakeStoreSource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureDataLakeStoreSource',
      type: {
        name: 'Composite',
        className: 'AzureDataLakeStoreSource',
        modelProperties: {
          sourceRetryCount: {
            required: false,
            serializedName: 'sourceRetryCount',
            type: {
              name: 'Object'
            }
          },
          sourceRetryWait: {
            required: false,
            serializedName: 'sourceRetryWait',
            type: {
              name: 'Object'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          recursive: {
            required: false,
            serializedName: 'recursive',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureDataLakeStoreSource;
