/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A reference to an object in Azure Key Vault.
 *
 */
class AzureKeyVaultReference {
  /**
   * Create a AzureKeyVaultReference.
   * @member {object} store The Azure Key Vault LinkedService.
   * @member {string} [store.referenceName] Reference LinkedService name.
   * @member {string} type Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureKeyVaultReference
   *
   * @returns {object} metadata of AzureKeyVaultReference
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureKeyVaultReference',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'type',
          clientName: 'type'
        },
        uberParent: 'AzureKeyVaultReference',
        className: 'AzureKeyVaultReference',
        modelProperties: {
          store: {
            required: true,
            serializedName: 'store',
            defaultValue: {},
            type: {
              name: 'Composite',
              className: 'LinkedServiceReference'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureKeyVaultReference;
