/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Azure ML Update Resource management activity.
 *
 * @extends models['ExecutionActivity']
 */
class AzureMLUpdateResourceActivity extends models['ExecutionActivity'] {
  /**
   * Create a AzureMLUpdateResourceActivity.
   * @member {object} trainedModelName Name of the Trained Model module in the
   * Web Service experiment to be updated. Type: string (or Expression with
   * resultType string).
   * @member {object} trainedModelLinkedServiceName Name of Azure Storage
   * linked service holding the .ilearner file that will be uploaded by the
   * update operation.
   * @member {string} [trainedModelLinkedServiceName.referenceName] Reference
   * LinkedService name.
   * @member {object} trainedModelFilePath The relative file path in
   * trainedModelLinkedService to represent the .ilearner file that will be
   * uploaded by the update operation.  Type: string (or Expression with
   * resultType string).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureMLUpdateResourceActivity
   *
   * @returns {object} metadata of AzureMLUpdateResourceActivity
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureMLUpdateResource',
      type: {
        name: 'Composite',
        className: 'AzureMLUpdateResourceActivity',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          dependsOn: {
            required: false,
            serializedName: 'dependsOn',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ActivityDependencyElementType',
                  type: {
                    name: 'Composite',
                    className: 'ActivityDependency'
                  }
              }
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          linkedServiceName: {
            required: false,
            serializedName: 'linkedServiceName',
            type: {
              name: 'Composite',
              className: 'LinkedServiceReference'
            }
          },
          policy: {
            required: false,
            serializedName: 'policy',
            type: {
              name: 'Composite',
              className: 'ActivityPolicy'
            }
          },
          trainedModelName: {
            required: true,
            serializedName: 'typeProperties.trainedModelName',
            type: {
              name: 'Object'
            }
          },
          trainedModelLinkedServiceName: {
            required: true,
            serializedName: 'typeProperties.trainedModelLinkedServiceName',
            defaultValue: {},
            type: {
              name: 'Composite',
              className: 'LinkedServiceReference'
            }
          },
          trainedModelFilePath: {
            required: true,
            serializedName: 'typeProperties.trainedModelFilePath',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureMLUpdateResourceActivity;
