/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A copy activity Azure Search Index sink.
 *
 * @extends models['CopySink']
 */
class AzureSearchIndexSink extends models['CopySink'] {
  /**
   * Create a AzureSearchIndexSink.
   * @member {string} [writeBehavior] Specify the write behavior when upserting
   * documents into Azure Search Index. Possible values include: 'Merge',
   * 'Upload'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureSearchIndexSink
   *
   * @returns {object} metadata of AzureSearchIndexSink
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureSearchIndexSink',
      type: {
        name: 'Composite',
        className: 'AzureSearchIndexSink',
        modelProperties: {
          writeBatchSize: {
            required: false,
            serializedName: 'writeBatchSize',
            type: {
              name: 'Object'
            }
          },
          writeBatchTimeout: {
            required: false,
            serializedName: 'writeBatchTimeout',
            type: {
              name: 'Object'
            }
          },
          sinkRetryCount: {
            required: false,
            serializedName: 'sinkRetryCount',
            type: {
              name: 'Object'
            }
          },
          sinkRetryWait: {
            required: false,
            serializedName: 'sinkRetryWait',
            type: {
              name: 'Object'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          writeBehavior: {
            required: false,
            serializedName: 'writeBehavior',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureSearchIndexSink;
