/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The storage account linked service.
 *
 * @extends models['LinkedService']
 */
class AzureStorageLinkedService extends models['LinkedService'] {
  /**
   * Create a AzureStorageLinkedService.
   * @member {object} [connectionString] The connection string. It is mutually
   * exclusive with sasUri property.
   * @member {string} [connectionString.value] Value of secure string.
   * @member {object} [sasUri] SAS URI of the Azure Storage resource. It is
   * mutually exclusive with connectionString property.
   * @member {string} [sasUri.value] Value of secure string.
   * @member {object} [encryptedCredential] The encrypted credential used for
   * authentication. Credentials are encrypted using the integration runtime
   * credential manager. Type: string (or Expression with resultType string).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureStorageLinkedService
   *
   * @returns {object} metadata of AzureStorageLinkedService
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureStorage',
      type: {
        name: 'Composite',
        className: 'AzureStorageLinkedService',
        modelProperties: {
          connectVia: {
            required: false,
            serializedName: 'connectVia',
            type: {
              name: 'Composite',
              className: 'IntegrationRuntimeReference'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          connectionString: {
            required: false,
            serializedName: 'typeProperties.connectionString',
            type: {
              name: 'Composite',
              className: 'SecureString'
            }
          },
          sasUri: {
            required: false,
            serializedName: 'typeProperties.sasUri',
            type: {
              name: 'Composite',
              className: 'SecureString'
            }
          },
          encryptedCredential: {
            required: false,
            serializedName: 'typeProperties.encryptedCredential',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureStorageLinkedService;
