/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A copy activity Azure Table sink.
 *
 * @extends models['CopySink']
 */
class AzureTableSink extends models['CopySink'] {
  /**
   * Create a AzureTableSink.
   * @member {object} [azureTableDefaultPartitionKeyValue] Azure Table default
   * partition key value. Type: string (or Expression with resultType string).
   * @member {object} [azureTablePartitionKeyName] Azure Table partition key
   * name. Type: string (or Expression with resultType string).
   * @member {object} [azureTableRowKeyName] Azure Table row key name. Type:
   * string (or Expression with resultType string).
   * @member {object} [azureTableInsertType] Azure Table insert type. Type:
   * string (or Expression with resultType string).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureTableSink
   *
   * @returns {object} metadata of AzureTableSink
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureTableSink',
      type: {
        name: 'Composite',
        className: 'AzureTableSink',
        modelProperties: {
          writeBatchSize: {
            required: false,
            serializedName: 'writeBatchSize',
            type: {
              name: 'Object'
            }
          },
          writeBatchTimeout: {
            required: false,
            serializedName: 'writeBatchTimeout',
            type: {
              name: 'Object'
            }
          },
          sinkRetryCount: {
            required: false,
            serializedName: 'sinkRetryCount',
            type: {
              name: 'Object'
            }
          },
          sinkRetryWait: {
            required: false,
            serializedName: 'sinkRetryWait',
            type: {
              name: 'Object'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          azureTableDefaultPartitionKeyValue: {
            required: false,
            serializedName: 'azureTableDefaultPartitionKeyValue',
            type: {
              name: 'Object'
            }
          },
          azureTablePartitionKeyName: {
            required: false,
            serializedName: 'azureTablePartitionKeyName',
            type: {
              name: 'Object'
            }
          },
          azureTableRowKeyName: {
            required: false,
            serializedName: 'azureTableRowKeyName',
            type: {
              name: 'Object'
            }
          },
          azureTableInsertType: {
            required: false,
            serializedName: 'azureTableInsertType',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureTableSink;
