/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Base class for all control activities like IfCondition, ForEach , Until.
 *
 * @extends models['Activity']
 */
class ControlActivity extends models['Activity'] {
  /**
   * Create a ControlActivity.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ControlActivity
   *
   * @returns {object} metadata of ControlActivity
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Container',
      type: {
        name: 'Composite',
        className: 'ControlActivity',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          dependsOn: {
            required: false,
            serializedName: 'dependsOn',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ActivityDependencyElementType',
                  type: {
                    name: 'Composite',
                    className: 'ActivityDependency'
                  }
              }
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ControlActivity;
