/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Reference objects for custom activity
 *
 */
class CustomActivityReferenceObject {
  /**
   * Create a CustomActivityReferenceObject.
   * @member {array} [linkedServices] Linked service references.
   * @member {array} [datasets] Dataset references.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CustomActivityReferenceObject
   *
   * @returns {object} metadata of CustomActivityReferenceObject
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CustomActivityReferenceObject',
      type: {
        name: 'Composite',
        className: 'CustomActivityReferenceObject',
        modelProperties: {
          linkedServices: {
            required: false,
            serializedName: 'linkedServices',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'LinkedServiceReferenceElementType',
                  type: {
                    name: 'Composite',
                    className: 'LinkedServiceReference'
                  }
              }
            }
          },
          datasets: {
            required: false,
            serializedName: 'datasets',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'DatasetReferenceElementType',
                  type: {
                    name: 'Composite',
                    className: 'DatasetReference'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = CustomActivityReferenceObject;
