/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The Deflate compression method used on a dataset.
 *
 * @extends models['DatasetCompression']
 */
class DatasetDeflateCompression extends models['DatasetCompression'] {
  /**
   * Create a DatasetDeflateCompression.
   * @member {string} [level] The Deflate compression level. Possible values
   * include: 'Optimal', 'Fastest'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of DatasetDeflateCompression
   *
   * @returns {object} metadata of DatasetDeflateCompression
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Deflate',
      type: {
        name: 'Composite',
        className: 'DatasetDeflateCompression',
        modelProperties: {
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          level: {
            required: false,
            serializedName: 'level',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DatasetDeflateCompression;
