/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A copy activity Document Database Collection sink.
 *
 * @extends models['CopySink']
 */
class DocumentDbCollectionSink extends models['CopySink'] {
  /**
   * Create a DocumentDbCollectionSink.
   * @member {object} [nestingSeparator] Nested properties separator. Default
   * is . (dot). Type: string (or Expression with resultType string).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of DocumentDbCollectionSink
   *
   * @returns {object} metadata of DocumentDbCollectionSink
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DocumentDbCollectionSink',
      type: {
        name: 'Composite',
        className: 'DocumentDbCollectionSink',
        modelProperties: {
          writeBatchSize: {
            required: false,
            serializedName: 'writeBatchSize',
            type: {
              name: 'Object'
            }
          },
          writeBatchTimeout: {
            required: false,
            serializedName: 'writeBatchTimeout',
            type: {
              name: 'Object'
            }
          },
          sinkRetryCount: {
            required: false,
            serializedName: 'sinkRetryCount',
            type: {
              name: 'Object'
            }
          },
          sinkRetryWait: {
            required: false,
            serializedName: 'sinkRetryWait',
            type: {
              name: 'Object'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          nestingSeparator: {
            required: false,
            serializedName: 'nestingSeparator',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = DocumentDbCollectionSink;
