/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A copy activity Dynamics entity source.
 *
 * @extends models['CopySource']
 */
class DynamicsSource extends models['CopySource'] {
  /**
   * Create a DynamicsSource.
   * @member {object} [query] FetchXML is a proprietary query language that is
   * used in Microsoft Dynamics (online & on-premises). Type: string (or
   * Expression with resultType string).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of DynamicsSource
   *
   * @returns {object} metadata of DynamicsSource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DynamicsSource',
      type: {
        name: 'Composite',
        className: 'DynamicsSource',
        modelProperties: {
          sourceRetryCount: {
            required: false,
            serializedName: 'sourceRetryCount',
            type: {
              name: 'Object'
            }
          },
          sourceRetryWait: {
            required: false,
            serializedName: 'sourceRetryWait',
            type: {
              name: 'Object'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          query: {
            required: false,
            serializedName: 'query',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = DynamicsSource;
