/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * HDInsight MapReduce activity type.
 *
 * @extends models['ExecutionActivity']
 */
class HDInsightMapReduceActivity extends models['ExecutionActivity'] {
  /**
   * Create a HDInsightMapReduceActivity.
   * @member {array} [storageLinkedServices] Storage linked service references.
   * @member {array} [arguments] User specified arguments to HDInsightActivity.
   * @member {string} [getDebugInfo] Debug info option. Possible values
   * include: 'None', 'Always', 'Failure'
   * @member {object} className Class name. Type: string (or Expression with
   * resultType string).
   * @member {object} jarFilePath Jar path. Type: string (or Expression with
   * resultType string).
   * @member {object} [jarLinkedService] Jar linked service reference.
   * @member {string} [jarLinkedService.referenceName] Reference LinkedService
   * name.
   * @member {array} [jarLibs] Jar libs.
   * @member {object} [defines] Allows user to specify defines for the
   * MapReduce job request.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of HDInsightMapReduceActivity
   *
   * @returns {object} metadata of HDInsightMapReduceActivity
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HDInsightMapReduce',
      type: {
        name: 'Composite',
        className: 'HDInsightMapReduceActivity',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          dependsOn: {
            required: false,
            serializedName: 'dependsOn',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ActivityDependencyElementType',
                  type: {
                    name: 'Composite',
                    className: 'ActivityDependency'
                  }
              }
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          linkedServiceName: {
            required: false,
            serializedName: 'linkedServiceName',
            type: {
              name: 'Composite',
              className: 'LinkedServiceReference'
            }
          },
          policy: {
            required: false,
            serializedName: 'policy',
            type: {
              name: 'Composite',
              className: 'ActivityPolicy'
            }
          },
          storageLinkedServices: {
            required: false,
            serializedName: 'typeProperties.storageLinkedServices',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'LinkedServiceReferenceElementType',
                  type: {
                    name: 'Composite',
                    className: 'LinkedServiceReference'
                  }
              }
            }
          },
          arguments: {
            required: false,
            serializedName: 'typeProperties.arguments',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ObjectElementType',
                  type: {
                    name: 'Object'
                  }
              }
            }
          },
          getDebugInfo: {
            required: false,
            serializedName: 'typeProperties.getDebugInfo',
            type: {
              name: 'String'
            }
          },
          className: {
            required: true,
            serializedName: 'typeProperties.className',
            type: {
              name: 'Object'
            }
          },
          jarFilePath: {
            required: true,
            serializedName: 'typeProperties.jarFilePath',
            type: {
              name: 'Object'
            }
          },
          jarLinkedService: {
            required: false,
            serializedName: 'typeProperties.jarLinkedService',
            type: {
              name: 'Composite',
              className: 'LinkedServiceReference'
            }
          },
          jarLibs: {
            required: false,
            serializedName: 'typeProperties.jarLibs',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ObjectElementType',
                  type: {
                    name: 'Object'
                  }
              }
            }
          },
          defines: {
            required: false,
            serializedName: 'typeProperties.defines',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'ObjectElementType',
                  type: {
                    name: 'Object'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = HDInsightMapReduceActivity;
