/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

var msRestAzure = require('ms-rest-azure');

exports.BaseResource = msRestAzure.BaseResource;
exports.CloudError = msRestAzure.CloudError;
exports.Resource = require('./resource');
exports.SubResource = require('./subResource');
exports.Expression = require('./expression');
exports.SecureString = require('./secureString');
exports.FactoryIdentity = require('./factoryIdentity');
exports.Factory = require('./factory');
exports.IntegrationRuntime = require('./integrationRuntime');
exports.IntegrationRuntimeResource = require('./integrationRuntimeResource');
exports.IntegrationRuntimeReference = require('./integrationRuntimeReference');
exports.IntegrationRuntimeStatus = require('./integrationRuntimeStatus');
exports.IntegrationRuntimeStatusResponse = require('./integrationRuntimeStatusResponse');
exports.IntegrationRuntimeStatusListResponse = require('./integrationRuntimeStatusListResponse');
exports.LinkedService = require('./linkedService');
exports.LinkedServiceResource = require('./linkedServiceResource');
exports.LinkedServiceReference = require('./linkedServiceReference');
exports.ParameterSpecification = require('./parameterSpecification');
exports.Dataset = require('./dataset');
exports.DatasetResource = require('./datasetResource');
exports.ActivityDependency = require('./activityDependency');
exports.Activity = require('./activity');
exports.PipelineResource = require('./pipelineResource');
exports.PipelineReference = require('./pipelineReference');
exports.TriggerPipelineReference = require('./triggerPipelineReference');
exports.Trigger = require('./trigger');
exports.TriggerResource = require('./triggerResource');
exports.CreateRunResponse = require('./createRunResponse');
exports.ErrorResponse = require('./errorResponse');
exports.FactoryUpdateParameters = require('./factoryUpdateParameters');
exports.DatasetReference = require('./datasetReference');
exports.PipelineRunQueryFilter = require('./pipelineRunQueryFilter');
exports.PipelineRunQueryOrderBy = require('./pipelineRunQueryOrderBy');
exports.PipelineRunFilterParameters = require('./pipelineRunFilterParameters');
exports.PipelineRunInvokedBy = require('./pipelineRunInvokedBy');
exports.PipelineRun = require('./pipelineRun');
exports.PipelineRunQueryResponse = require('./pipelineRunQueryResponse');
exports.ActivityRun = require('./activityRun');
exports.TriggerRun = require('./triggerRun');
exports.OperationDisplay = require('./operationDisplay');
exports.OperationLogSpecification = require('./operationLogSpecification');
exports.OperationMetricAvailability = require('./operationMetricAvailability');
exports.OperationMetricSpecification = require('./operationMetricSpecification');
exports.OperationServiceSpecification = require('./operationServiceSpecification');
exports.Operation = require('./operation');
exports.OperationListResponse = require('./operationListResponse');
exports.AzureDataLakeAnalyticsLinkedService = require('./azureDataLakeAnalyticsLinkedService');
exports.HDInsightOnDemandLinkedService = require('./hDInsightOnDemandLinkedService');
exports.SapHanaLinkedService = require('./sapHanaLinkedService');
exports.SapBWLinkedService = require('./sapBWLinkedService');
exports.SftpServerLinkedService = require('./sftpServerLinkedService');
exports.FtpServerLinkedService = require('./ftpServerLinkedService');
exports.HttpLinkedService = require('./httpLinkedService');
exports.AzureSearchLinkedService = require('./azureSearchLinkedService');
exports.CustomDataSourceLinkedService = require('./customDataSourceLinkedService');
exports.AmazonRedshiftLinkedService = require('./amazonRedshiftLinkedService');
exports.AmazonS3LinkedService = require('./amazonS3LinkedService');
exports.SalesforceLinkedService = require('./salesforceLinkedService');
exports.AzureDataLakeStoreLinkedService = require('./azureDataLakeStoreLinkedService');
exports.MongoDbLinkedService = require('./mongoDbLinkedService');
exports.CassandraLinkedService = require('./cassandraLinkedService');
exports.WebLinkedServiceTypeProperties = require('./webLinkedServiceTypeProperties');
exports.WebClientCertificateAuthentication = require('./webClientCertificateAuthentication');
exports.WebBasicAuthentication = require('./webBasicAuthentication');
exports.WebAnonymousAuthentication = require('./webAnonymousAuthentication');
exports.WebLinkedService = require('./webLinkedService');
exports.ODataLinkedService = require('./oDataLinkedService');
exports.HdfsLinkedService = require('./hdfsLinkedService');
exports.OdbcLinkedService = require('./odbcLinkedService');
exports.AzureMLLinkedService = require('./azureMLLinkedService');
exports.TeradataLinkedService = require('./teradataLinkedService');
exports.Db2LinkedService = require('./db2LinkedService');
exports.SybaseLinkedService = require('./sybaseLinkedService');
exports.PostgreSqlLinkedService = require('./postgreSqlLinkedService');
exports.MySqlLinkedService = require('./mySqlLinkedService');
exports.OracleLinkedService = require('./oracleLinkedService');
exports.FileServerLinkedService = require('./fileServerLinkedService');
exports.HDInsightLinkedService = require('./hDInsightLinkedService');
exports.AzureKeyVaultReference = require('./azureKeyVaultReference');
exports.AzureKeyVaultSecretReference = require('./azureKeyVaultSecretReference');
exports.DynamicsLinkedService = require('./dynamicsLinkedService');
exports.CosmosDbLinkedService = require('./cosmosDbLinkedService');
exports.AzureKeyVaultLinkedService = require('./azureKeyVaultLinkedService');
exports.AzureBatchLinkedService = require('./azureBatchLinkedService');
exports.AzureSqlDatabaseLinkedService = require('./azureSqlDatabaseLinkedService');
exports.SqlServerLinkedService = require('./sqlServerLinkedService');
exports.AzureSqlDWLinkedService = require('./azureSqlDWLinkedService');
exports.AzureStorageLinkedService = require('./azureStorageLinkedService');
exports.DatasetCompression = require('./datasetCompression');
exports.DatasetDeflateCompression = require('./datasetDeflateCompression');
exports.DatasetGZipCompression = require('./datasetGZipCompression');
exports.DatasetBZip2Compression = require('./datasetBZip2Compression');
exports.DatasetStorageFormat = require('./datasetStorageFormat');
exports.ParquetFormat = require('./parquetFormat');
exports.OrcFormat = require('./orcFormat');
exports.AvroFormat = require('./avroFormat');
exports.JsonFormat = require('./jsonFormat');
exports.TextFormat = require('./textFormat');
exports.DatasetPartitionValue = require('./datasetPartitionValue');
exports.DatasetDateTimePartitionValue = require('./datasetDateTimePartitionValue');
exports.DatasetPartition = require('./datasetPartition');
exports.HttpDataset = require('./httpDataset');
exports.AzureSearchIndexDataset = require('./azureSearchIndexDataset');
exports.WebTableDataset = require('./webTableDataset');
exports.SqlServerTableDataset = require('./sqlServerTableDataset');
exports.RelationalTableDataset = require('./relationalTableDataset');
exports.OracleTableDataset = require('./oracleTableDataset');
exports.ODataResourceDataset = require('./oDataResourceDataset');
exports.MongoDbCollectionDataset = require('./mongoDbCollectionDataset');
exports.FileShareDataset = require('./fileShareDataset');
exports.AzureDataLakeStoreDataset = require('./azureDataLakeStoreDataset');
exports.DynamicsEntityDataset = require('./dynamicsEntityDataset');
exports.DocumentDbCollectionDataset = require('./documentDbCollectionDataset');
exports.CustomDataset = require('./customDataset');
exports.CassandraTableDataset = require('./cassandraTableDataset');
exports.AzureSqlDWTableDataset = require('./azureSqlDWTableDataset');
exports.AzureSqlTableDataset = require('./azureSqlTableDataset');
exports.AzureTableDataset = require('./azureTableDataset');
exports.AzureBlobDataset = require('./azureBlobDataset');
exports.AmazonS3Dataset = require('./amazonS3Dataset');
exports.BlobTrigger = require('./blobTrigger');
exports.RecurrenceScheduleOccurrence = require('./recurrenceScheduleOccurrence');
exports.RecurrenceSchedule = require('./recurrenceSchedule');
exports.ScheduleTriggerRecurrence = require('./scheduleTriggerRecurrence');
exports.ScheduleTrigger = require('./scheduleTrigger');
exports.ActivityPolicy = require('./activityPolicy');
exports.ExecutionActivity = require('./executionActivity');
exports.DataLakeAnalyticsUSQLActivity = require('./dataLakeAnalyticsUSQLActivity');
exports.AzureMLUpdateResourceActivity = require('./azureMLUpdateResourceActivity');
exports.AzureMLWebServiceFile = require('./azureMLWebServiceFile');
exports.AzureMLBatchExecutionActivity = require('./azureMLBatchExecutionActivity');
exports.GetMetadataActivity = require('./getMetadataActivity');
exports.WebActivityAuthentication = require('./webActivityAuthentication');
exports.WebActivity = require('./webActivity');
exports.RedshiftUnloadSettings = require('./redshiftUnloadSettings');
exports.CopySource = require('./copySource');
exports.AmazonRedshiftSource = require('./amazonRedshiftSource');
exports.HttpSource = require('./httpSource');
exports.AzureDataLakeStoreSource = require('./azureDataLakeStoreSource');
exports.MongoDbSource = require('./mongoDbSource');
exports.CassandraSource = require('./cassandraSource');
exports.WebSource = require('./webSource');
exports.OracleSource = require('./oracleSource');
exports.DistcpSettings = require('./distcpSettings');
exports.HdfsSource = require('./hdfsSource');
exports.FileSystemSource = require('./fileSystemSource');
exports.SqlDWSource = require('./sqlDWSource');
exports.StoredProcedureParameter = require('./storedProcedureParameter');
exports.SqlSource = require('./sqlSource');
exports.RelationalSource = require('./relationalSource');
exports.DynamicsSource = require('./dynamicsSource');
exports.DocumentDbCollectionSource = require('./documentDbCollectionSource');
exports.BlobSource = require('./blobSource');
exports.AzureTableSource = require('./azureTableSource');
exports.LookupActivity = require('./lookupActivity');
exports.SqlServerStoredProcedureActivity = require('./sqlServerStoredProcedureActivity');
exports.CustomActivityReferenceObject = require('./customActivityReferenceObject');
exports.CustomActivity = require('./customActivity');
exports.HDInsightSparkActivity = require('./hDInsightSparkActivity');
exports.HDInsightStreamingActivity = require('./hDInsightStreamingActivity');
exports.HDInsightMapReduceActivity = require('./hDInsightMapReduceActivity');
exports.HDInsightPigActivity = require('./hDInsightPigActivity');
exports.HDInsightHiveActivity = require('./hDInsightHiveActivity');
exports.RedirectIncompatibleRowSettings = require('./redirectIncompatibleRowSettings');
exports.StagingSettings = require('./stagingSettings');
exports.CopyTranslator = require('./copyTranslator');
exports.TabularTranslator = require('./tabularTranslator');
exports.CopySink = require('./copySink');
exports.OdbcSink = require('./odbcSink');
exports.AzureSearchIndexSink = require('./azureSearchIndexSink');
exports.AzureDataLakeStoreSink = require('./azureDataLakeStoreSink');
exports.OracleSink = require('./oracleSink');
exports.PolybaseSettings = require('./polybaseSettings');
exports.SqlDWSink = require('./sqlDWSink');
exports.SqlSink = require('./sqlSink');
exports.DocumentDbCollectionSink = require('./documentDbCollectionSink');
exports.FileSystemSink = require('./fileSystemSink');
exports.BlobSink = require('./blobSink');
exports.AzureTableSink = require('./azureTableSink');
exports.AzureQueueSink = require('./azureQueueSink');
exports.CopyActivity = require('./copyActivity');
exports.ControlActivity = require('./controlActivity');
exports.UntilActivity = require('./untilActivity');
exports.WaitActivity = require('./waitActivity');
exports.ForEachActivity = require('./forEachActivity');
exports.IfConditionActivity = require('./ifConditionActivity');
exports.ExecutePipelineActivity = require('./executePipelineActivity');
exports.SelfHostedIntegrationRuntimeNode = require('./selfHostedIntegrationRuntimeNode');
exports.SelfHostedIntegrationRuntimeStatus = require('./selfHostedIntegrationRuntimeStatus');
exports.ManagedIntegrationRuntimeOperationResult = require('./managedIntegrationRuntimeOperationResult');
exports.ManagedIntegrationRuntimeError = require('./managedIntegrationRuntimeError');
exports.ManagedIntegrationRuntimeNode = require('./managedIntegrationRuntimeNode');
exports.ManagedIntegrationRuntimeStatus = require('./managedIntegrationRuntimeStatus');
exports.SelfHostedIntegrationRuntime = require('./selfHostedIntegrationRuntime');
exports.IntegrationRuntimeSsisCatalogInfo = require('./integrationRuntimeSsisCatalogInfo');
exports.IntegrationRuntimeSsisProperties = require('./integrationRuntimeSsisProperties');
exports.IntegrationRuntimeVNetProperties = require('./integrationRuntimeVNetProperties');
exports.IntegrationRuntimeComputeProperties = require('./integrationRuntimeComputeProperties');
exports.ManagedIntegrationRuntime = require('./managedIntegrationRuntime');
exports.IntegrationRuntimeNodeMonitoringData = require('./integrationRuntimeNodeMonitoringData');
exports.IntegrationRuntimeMonitoringData = require('./integrationRuntimeMonitoringData');
exports.IntegrationRuntimeRemoveNodeRequest = require('./integrationRuntimeRemoveNodeRequest');
exports.IntegrationRuntimeAuthKeys = require('./integrationRuntimeAuthKeys');
exports.IntegrationRuntimeRegenerateKeyParameters = require('./integrationRuntimeRegenerateKeyParameters');
exports.IntegrationRuntimeConnectionInfo = require('./integrationRuntimeConnectionInfo');
exports.FactoryListResponse = require('./factoryListResponse');
exports.IntegrationRuntimeListResponse = require('./integrationRuntimeListResponse');
exports.LinkedServiceListResponse = require('./linkedServiceListResponse');
exports.DatasetListResponse = require('./datasetListResponse');
exports.PipelineListResponse = require('./pipelineListResponse');
exports.ActivityRunsListResponse = require('./activityRunsListResponse');
exports.TriggerListResponse = require('./triggerListResponse');
exports.TriggerRunListResponse = require('./triggerRunListResponse');
exports.discriminators = {
  'IntegrationRuntime' : exports.IntegrationRuntime,
  'IntegrationRuntimeStatus' : exports.IntegrationRuntimeStatus,
  'LinkedService' : exports.LinkedService,
  'Dataset' : exports.Dataset,
  'Activity' : exports.Activity,
  'Trigger' : exports.Trigger,
  'LinkedService.AzureDataLakeAnalytics' : exports.AzureDataLakeAnalyticsLinkedService,
  'LinkedService.HDInsightOnDemand' : exports.HDInsightOnDemandLinkedService,
  'LinkedService.SapHana' : exports.SapHanaLinkedService,
  'LinkedService.SapBW' : exports.SapBWLinkedService,
  'LinkedService.Sftp' : exports.SftpServerLinkedService,
  'LinkedService.FtpServer' : exports.FtpServerLinkedService,
  'LinkedService.HttpServer' : exports.HttpLinkedService,
  'LinkedService.AzureSearch' : exports.AzureSearchLinkedService,
  'LinkedService.CustomDataSource' : exports.CustomDataSourceLinkedService,
  'LinkedService.AmazonRedshift' : exports.AmazonRedshiftLinkedService,
  'LinkedService.AmazonS3' : exports.AmazonS3LinkedService,
  'LinkedService.Salesforce' : exports.SalesforceLinkedService,
  'LinkedService.AzureDataLakeStore' : exports.AzureDataLakeStoreLinkedService,
  'LinkedService.MongoDb' : exports.MongoDbLinkedService,
  'LinkedService.Cassandra' : exports.CassandraLinkedService,
  'WebLinkedServiceTypeProperties.ClientCertificate' : exports.WebClientCertificateAuthentication,
  'WebLinkedServiceTypeProperties.Basic' : exports.WebBasicAuthentication,
  'WebLinkedServiceTypeProperties.Anonymous' : exports.WebAnonymousAuthentication,
  'WebLinkedServiceTypeProperties' : exports.WebLinkedServiceTypeProperties,
  'LinkedService.Web' : exports.WebLinkedService,
  'LinkedService.OData' : exports.ODataLinkedService,
  'LinkedService.Hdfs' : exports.HdfsLinkedService,
  'LinkedService.Odbc' : exports.OdbcLinkedService,
  'LinkedService.AzureML' : exports.AzureMLLinkedService,
  'LinkedService.Teradata' : exports.TeradataLinkedService,
  'LinkedService.Db2' : exports.Db2LinkedService,
  'LinkedService.Sybase' : exports.SybaseLinkedService,
  'LinkedService.PostgreSql' : exports.PostgreSqlLinkedService,
  'LinkedService.MySql' : exports.MySqlLinkedService,
  'LinkedService.Oracle' : exports.OracleLinkedService,
  'LinkedService.FileServer' : exports.FileServerLinkedService,
  'LinkedService.HDInsight' : exports.HDInsightLinkedService,
  'AzureKeyVaultReference.AzureKeyVaultSecret' : exports.AzureKeyVaultSecretReference,
  'AzureKeyVaultReference' : exports.AzureKeyVaultReference,
  'LinkedService.Dynamics' : exports.DynamicsLinkedService,
  'LinkedService.CosmosDb' : exports.CosmosDbLinkedService,
  'LinkedService.AzureKeyVault' : exports.AzureKeyVaultLinkedService,
  'LinkedService.AzureBatch' : exports.AzureBatchLinkedService,
  'LinkedService.AzureSqlDatabase' : exports.AzureSqlDatabaseLinkedService,
  'LinkedService.SqlServer' : exports.SqlServerLinkedService,
  'LinkedService.AzureSqlDW' : exports.AzureSqlDWLinkedService,
  'LinkedService.AzureStorage' : exports.AzureStorageLinkedService,
  'DatasetCompression.Deflate' : exports.DatasetDeflateCompression,
  'DatasetCompression.GZip' : exports.DatasetGZipCompression,
  'DatasetCompression.BZip2' : exports.DatasetBZip2Compression,
  'DatasetCompression' : exports.DatasetCompression,
  'DatasetStorageFormat.ParquetFormat' : exports.ParquetFormat,
  'DatasetStorageFormat.OrcFormat' : exports.OrcFormat,
  'DatasetStorageFormat.AvroFormat' : exports.AvroFormat,
  'DatasetStorageFormat.JsonFormat' : exports.JsonFormat,
  'DatasetStorageFormat.TextFormat' : exports.TextFormat,
  'DatasetStorageFormat' : exports.DatasetStorageFormat,
  'DatasetPartitionValue.DateTime' : exports.DatasetDateTimePartitionValue,
  'DatasetPartitionValue' : exports.DatasetPartitionValue,
  'Dataset.HttpFile' : exports.HttpDataset,
  'Dataset.AzureSearchIndex' : exports.AzureSearchIndexDataset,
  'Dataset.WebTable' : exports.WebTableDataset,
  'Dataset.SqlServerTable' : exports.SqlServerTableDataset,
  'Dataset.RelationalTable' : exports.RelationalTableDataset,
  'Dataset.OracleTable' : exports.OracleTableDataset,
  'Dataset.ODataResource' : exports.ODataResourceDataset,
  'Dataset.MongoDbCollection' : exports.MongoDbCollectionDataset,
  'Dataset.FileShare' : exports.FileShareDataset,
  'Dataset.AzureDataLakeStoreFile' : exports.AzureDataLakeStoreDataset,
  'Dataset.DynamicsEntity' : exports.DynamicsEntityDataset,
  'Dataset.DocumentDbCollection' : exports.DocumentDbCollectionDataset,
  'Dataset.CustomDataset' : exports.CustomDataset,
  'Dataset.CassandraTable' : exports.CassandraTableDataset,
  'Dataset.AzureSqlDWTable' : exports.AzureSqlDWTableDataset,
  'Dataset.AzureSqlTable' : exports.AzureSqlTableDataset,
  'Dataset.AzureTable' : exports.AzureTableDataset,
  'Dataset.AzureBlob' : exports.AzureBlobDataset,
  'Dataset.AmazonS3Object' : exports.AmazonS3Dataset,
  'Trigger.BlobTrigger' : exports.BlobTrigger,
  'Trigger.ScheduleTrigger' : exports.ScheduleTrigger,
  'Activity.DataLakeAnalyticsU-SQL' : exports.DataLakeAnalyticsUSQLActivity,
  'Activity.AzureMLUpdateResource' : exports.AzureMLUpdateResourceActivity,
  'Activity.AzureMLBatchExecution' : exports.AzureMLBatchExecutionActivity,
  'Activity.GetMetadata' : exports.GetMetadataActivity,
  'Activity.WebActivity' : exports.WebActivity,
  'CopySource.AmazonRedshiftSource' : exports.AmazonRedshiftSource,
  'CopySource.HttpSource' : exports.HttpSource,
  'CopySource.AzureDataLakeStoreSource' : exports.AzureDataLakeStoreSource,
  'CopySource.MongoDbSource' : exports.MongoDbSource,
  'CopySource.CassandraSource' : exports.CassandraSource,
  'CopySource.WebSource' : exports.WebSource,
  'CopySource.OracleSource' : exports.OracleSource,
  'CopySource.HdfsSource' : exports.HdfsSource,
  'CopySource.FileSystemSource' : exports.FileSystemSource,
  'CopySource.SqlDWSource' : exports.SqlDWSource,
  'CopySource.SqlSource' : exports.SqlSource,
  'CopySource.RelationalSource' : exports.RelationalSource,
  'CopySource.DynamicsSource' : exports.DynamicsSource,
  'CopySource.DocumentDbCollectionSource' : exports.DocumentDbCollectionSource,
  'CopySource.BlobSource' : exports.BlobSource,
  'CopySource.AzureTableSource' : exports.AzureTableSource,
  'CopySource' : exports.CopySource,
  'Activity.Lookup' : exports.LookupActivity,
  'Activity.SqlServerStoredProcedure' : exports.SqlServerStoredProcedureActivity,
  'Activity.Custom' : exports.CustomActivity,
  'Activity.HDInsightSpark' : exports.HDInsightSparkActivity,
  'Activity.HDInsightStreaming' : exports.HDInsightStreamingActivity,
  'Activity.HDInsightMapReduce' : exports.HDInsightMapReduceActivity,
  'Activity.HDInsightPig' : exports.HDInsightPigActivity,
  'Activity.HDInsightHive' : exports.HDInsightHiveActivity,
  'CopyTranslator.TabularTranslator' : exports.TabularTranslator,
  'CopyTranslator' : exports.CopyTranslator,
  'CopySink.OdbcSink' : exports.OdbcSink,
  'CopySink.AzureSearchIndexSink' : exports.AzureSearchIndexSink,
  'CopySink.AzureDataLakeStoreSink' : exports.AzureDataLakeStoreSink,
  'CopySink.OracleSink' : exports.OracleSink,
  'CopySink.SqlDWSink' : exports.SqlDWSink,
  'CopySink.SqlSink' : exports.SqlSink,
  'CopySink.DocumentDbCollectionSink' : exports.DocumentDbCollectionSink,
  'CopySink.FileSystemSink' : exports.FileSystemSink,
  'CopySink.BlobSink' : exports.BlobSink,
  'CopySink.AzureTableSink' : exports.AzureTableSink,
  'CopySink.AzureQueueSink' : exports.AzureQueueSink,
  'CopySink' : exports.CopySink,
  'Activity.Copy' : exports.CopyActivity,
  'Activity.Execution' : exports.ExecutionActivity,
  'Activity.Until' : exports.UntilActivity,
  'Activity.Wait' : exports.WaitActivity,
  'Activity.ForEach' : exports.ForEachActivity,
  'Activity.IfCondition' : exports.IfConditionActivity,
  'Activity.ExecutePipeline' : exports.ExecutePipelineActivity,
  'Activity.Container' : exports.ControlActivity,
  'IntegrationRuntimeStatus.SelfHosted' : exports.SelfHostedIntegrationRuntimeStatus,
  'IntegrationRuntimeStatus.Managed' : exports.ManagedIntegrationRuntimeStatus,
  'IntegrationRuntime.SelfHosted' : exports.SelfHostedIntegrationRuntime,
  'IntegrationRuntime.Managed' : exports.ManagedIntegrationRuntime
};
