/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Integration runtime reference type.
 *
 */
class IntegrationRuntimeReference {
  /**
   * Create a IntegrationRuntimeReference.
   * @member {string} referenceName Reference integration runtime name.
   * @member {object} [parameters] Arguments for integration runtime.
   */
  constructor() {
  }

  /**
   * Defines the metadata of IntegrationRuntimeReference
   *
   * @returns {object} metadata of IntegrationRuntimeReference
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IntegrationRuntimeReference',
      type: {
        name: 'Composite',
        className: 'IntegrationRuntimeReference',
        modelProperties: {
          type: {
            required: true,
            isConstant: true,
            serializedName: 'type',
            defaultValue: 'IntegrationRuntimeReference',
            type: {
              name: 'String'
            }
          },
          referenceName: {
            required: true,
            serializedName: 'referenceName',
            type: {
              name: 'String'
            }
          },
          parameters: {
            required: false,
            serializedName: 'parameters',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'ObjectElementType',
                  type: {
                    name: 'Object'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = IntegrationRuntimeReference;
