/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Integration runtime resource type.
 *
 * @extends models['SubResource']
 */
class IntegrationRuntimeResource extends models['SubResource'] {
  /**
   * Create a IntegrationRuntimeResource.
   * @member {object} properties Integration runtime properties.
   * @member {string} [properties.description] Integration runtime description.
   * @member {string} [properties.type] Polymorphic Discriminator
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of IntegrationRuntimeResource
   *
   * @returns {object} metadata of IntegrationRuntimeResource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IntegrationRuntimeResource',
      type: {
        name: 'Composite',
        className: 'IntegrationRuntimeResource',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          etag: {
            required: false,
            readOnly: true,
            serializedName: 'etag',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: true,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'type',
                clientName: 'type'
              },
              uberParent: 'IntegrationRuntime',
              className: 'IntegrationRuntime'
            }
          }
        }
      }
    };
  }
}

module.exports = IntegrationRuntimeResource;
