/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Integration runtime status response.
 *
 */
class IntegrationRuntimeStatusResponse {
  /**
   * Create a IntegrationRuntimeStatusResponse.
   * @member {string} [name] The integration runtime name.
   * @member {object} properties Integration runtime properties.
   * @member {string} [properties.state] The state of integration runtime.
   * Possible values include: 'Initial', 'Stopped', 'Started', 'Starting',
   * 'Stopping', 'NeedRegistration', 'Online', 'Limited', 'Offline'
   * @member {string} [properties.type] Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of IntegrationRuntimeStatusResponse
   *
   * @returns {object} metadata of IntegrationRuntimeStatusResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IntegrationRuntimeStatusResponse',
      type: {
        name: 'Composite',
        className: 'IntegrationRuntimeStatusResponse',
        modelProperties: {
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: true,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'type',
                clientName: 'type'
              },
              uberParent: 'IntegrationRuntimeStatus',
              className: 'IntegrationRuntimeStatus'
            }
          }
        }
      }
    };
  }
}

module.exports = IntegrationRuntimeStatusResponse;
