/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Linked service resource type.
 *
 * @extends models['SubResource']
 */
class LinkedServiceResource extends models['SubResource'] {
  /**
   * Create a LinkedServiceResource.
   * @member {object} properties Properties of linked service.
   * @member {object} [properties.connectVia] The integration runtime
   * reference.
   * @member {string} [properties.connectVia.referenceName] Reference
   * integration runtime name.
   * @member {object} [properties.connectVia.parameters] Arguments for
   * integration runtime.
   * @member {string} [properties.description] Linked service description.
   * @member {string} [properties.type] Polymorphic Discriminator
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of LinkedServiceResource
   *
   * @returns {object} metadata of LinkedServiceResource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LinkedServiceResource',
      type: {
        name: 'Composite',
        className: 'LinkedServiceResource',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          etag: {
            required: false,
            readOnly: true,
            serializedName: 'etag',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: true,
            serializedName: 'properties',
            defaultValue: {},
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'type',
                clientName: 'type'
              },
              uberParent: 'LinkedService',
              className: 'LinkedService'
            }
          }
        }
      }
    };
  }
}

module.exports = LinkedServiceResource;
