/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties of managed integration runtime operation result.
 *
 */
class ManagedIntegrationRuntimeOperationResult {
  /**
   * Create a ManagedIntegrationRuntimeOperationResult.
   * @member {string} [type] The operation type. Could be start or stop.
   * @member {date} [startTime] The start time of the operation.
   * @member {string} [result] The operation result.
   * @member {string} [errorCode] The error code.
   * @member {array} [parameters] Managed integration runtime error parameters.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ManagedIntegrationRuntimeOperationResult
   *
   * @returns {object} metadata of ManagedIntegrationRuntimeOperationResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ManagedIntegrationRuntimeOperationResult',
      type: {
        name: 'Composite',
        className: 'ManagedIntegrationRuntimeOperationResult',
        modelProperties: {
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          startTime: {
            required: false,
            readOnly: true,
            serializedName: 'startTime',
            type: {
              name: 'DateTime'
            }
          },
          result: {
            required: false,
            readOnly: true,
            serializedName: 'result',
            type: {
              name: 'String'
            }
          },
          errorCode: {
            required: false,
            readOnly: true,
            serializedName: 'errorCode',
            type: {
              name: 'String'
            }
          },
          parameters: {
            required: false,
            readOnly: true,
            serializedName: 'parameters',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ManagedIntegrationRuntimeOperationResult;
