/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Azure Data Factory API operation definition.
 *
 */
class Operation {
  /**
   * Create a Operation.
   * @member {string} [name] Operation name: {provider}/{resource}/{operation}
   * @member {string} [origin] The intended executor of the operation.
   * @member {object} [display] Metadata associated with the operation.
   * @member {string} [display.description] The description of the operation.
   * @member {string} [display.provider] The name of the provider.
   * @member {string} [display.resource] The name of the resource type on which
   * the operation is performed.
   * @member {string} [display.operation] The type of operation: get, read,
   * delete, etc.
   * @member {object} [serviceSpecification] Details about a service operation.
   * @member {array} [serviceSpecification.logSpecifications] Details about
   * operations related to logs.
   * @member {array} [serviceSpecification.metricSpecifications] Details about
   * operations related to metrics.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Operation
   *
   * @returns {object} metadata of Operation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Operation',
      type: {
        name: 'Composite',
        className: 'Operation',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          origin: {
            required: false,
            serializedName: 'origin',
            type: {
              name: 'String'
            }
          },
          display: {
            required: false,
            serializedName: 'display',
            type: {
              name: 'Composite',
              className: 'OperationDisplay'
            }
          },
          serviceSpecification: {
            required: false,
            serializedName: 'properties.serviceSpecification',
            type: {
              name: 'Composite',
              className: 'OperationServiceSpecification'
            }
          }
        }
      }
    };
  }
}

module.exports = Operation;
