/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Details about an operation related to logs.
 *
 */
class OperationLogSpecification {
  /**
   * Create a OperationLogSpecification.
   * @member {string} [name] The name of the log category.
   * @member {string} [displayName] Localized display name.
   * @member {string} [blobDuration] Blobs created in the customer storage
   * account, per hour.
   */
  constructor() {
  }

  /**
   * Defines the metadata of OperationLogSpecification
   *
   * @returns {object} metadata of OperationLogSpecification
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OperationLogSpecification',
      type: {
        name: 'Composite',
        className: 'OperationLogSpecification',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            serializedName: 'displayName',
            type: {
              name: 'String'
            }
          },
          blobDuration: {
            required: false,
            serializedName: 'blobDuration',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = OperationLogSpecification;
