/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Defines how often data for a metric becomes available.
 *
 */
class OperationMetricAvailability {
  /**
   * Create a OperationMetricAvailability.
   * @member {string} [timeGrain] The granularity for the metric.
   * @member {string} [blobDuration] Blob created in the customer storage
   * account, per hour.
   */
  constructor() {
  }

  /**
   * Defines the metadata of OperationMetricAvailability
   *
   * @returns {object} metadata of OperationMetricAvailability
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OperationMetricAvailability',
      type: {
        name: 'Composite',
        className: 'OperationMetricAvailability',
        modelProperties: {
          timeGrain: {
            required: false,
            serializedName: 'timeGrain',
            type: {
              name: 'String'
            }
          },
          blobDuration: {
            required: false,
            serializedName: 'blobDuration',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = OperationMetricAvailability;
