/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A copy activity Oracle sink.
 *
 * @extends models['CopySink']
 */
class OracleSink extends models['CopySink'] {
  /**
   * Create a OracleSink.
   * @member {object} [preCopyScript] SQL pre-copy script. Type: string (or
   * Expression with resultType string).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of OracleSink
   *
   * @returns {object} metadata of OracleSink
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OracleSink',
      type: {
        name: 'Composite',
        className: 'OracleSink',
        modelProperties: {
          writeBatchSize: {
            required: false,
            serializedName: 'writeBatchSize',
            type: {
              name: 'Object'
            }
          },
          writeBatchTimeout: {
            required: false,
            serializedName: 'writeBatchTimeout',
            type: {
              name: 'Object'
            }
          },
          sinkRetryCount: {
            required: false,
            serializedName: 'sinkRetryCount',
            type: {
              name: 'Object'
            }
          },
          sinkRetryWait: {
            required: false,
            serializedName: 'sinkRetryWait',
            type: {
              name: 'Object'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          preCopyScript: {
            required: false,
            serializedName: 'preCopyScript',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = OracleSink;
