/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The data stored in Parquet format.
 *
 * @extends models['DatasetStorageFormat']
 */
class ParquetFormat extends models['DatasetStorageFormat'] {
  /**
   * Create a ParquetFormat.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ParquetFormat
   *
   * @returns {object} metadata of ParquetFormat
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ParquetFormat',
      type: {
        name: 'Composite',
        className: 'ParquetFormat',
        modelProperties: {
          serializer: {
            required: false,
            serializedName: 'serializer',
            type: {
              name: 'Object'
            }
          },
          deserializer: {
            required: false,
            serializedName: 'deserializer',
            type: {
              name: 'Object'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ParquetFormat;
