/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Provides entity name and id that started the pipeline run.
 *
 */
class PipelineRunInvokedBy {
  /**
   * Create a PipelineRunInvokedBy.
   * @member {string} [name] Name of the entity that started the pipeline run.
   * @member {string} [id] The ID of the entity that started the run.
   */
  constructor() {
  }

  /**
   * Defines the metadata of PipelineRunInvokedBy
   *
   * @returns {object} metadata of PipelineRunInvokedBy
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PipelineRunInvokedBy',
      type: {
        name: 'Composite',
        className: 'PipelineRunInvokedBy',
        modelProperties: {
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = PipelineRunInvokedBy;
