/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Query filter option for listing pipeline runs.
 *
 */
class PipelineRunQueryFilter {
  /**
   * Create a PipelineRunQueryFilter.
   * @member {string} operand Parameter name to be used for filter. Possible
   * values include: 'PipelineName', 'Status', 'RunStart', 'RunEnd'
   * @member {string} operator Operator to be used for filter. Possible values
   * include: 'Equals', 'NotEquals', 'In', 'NotIn'
   * @member {array} values List of filter values.
   */
  constructor() {
  }

  /**
   * Defines the metadata of PipelineRunQueryFilter
   *
   * @returns {object} metadata of PipelineRunQueryFilter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PipelineRunQueryFilter',
      type: {
        name: 'Composite',
        className: 'PipelineRunQueryFilter',
        modelProperties: {
          operand: {
            required: true,
            serializedName: 'operand',
            type: {
              name: 'String'
            }
          },
          operator: {
            required: true,
            serializedName: 'operator',
            type: {
              name: 'String'
            }
          },
          values: {
            required: true,
            serializedName: 'values',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = PipelineRunQueryFilter;
