/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An object to provide order by options for listing pipeline runs.
 *
 */
class PipelineRunQueryOrderBy {
  /**
   * Create a PipelineRunQueryOrderBy.
   * @member {string} orderBy Parameter name to be used for order by. Possible
   * values include: 'RunStart', 'RunEnd'
   * @member {string} order Sorting order of the parameter. Possible values
   * include: 'ASC', 'DESC'
   */
  constructor() {
  }

  /**
   * Defines the metadata of PipelineRunQueryOrderBy
   *
   * @returns {object} metadata of PipelineRunQueryOrderBy
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PipelineRunQueryOrderBy',
      type: {
        name: 'Composite',
        className: 'PipelineRunQueryOrderBy',
        modelProperties: {
          orderBy: {
            required: true,
            serializedName: 'orderBy',
            type: {
              name: 'String'
            }
          },
          order: {
            required: true,
            serializedName: 'order',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = PipelineRunQueryOrderBy;
