/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * PolyBase settings.
 *
 */
class PolybaseSettings {
  /**
   * Create a PolybaseSettings.
   * @member {string} [rejectType] Reject type. Possible values include:
   * 'value', 'percentage'
   * @member {object} [rejectValue] Specifies the value or the percentage of
   * rows that can be rejected before the query fails. Type: number (or
   * Expression with resultType number), minimum: 0.
   * @member {object} [rejectSampleValue] Determines the number of rows to
   * attempt to retrieve before the PolyBase recalculates the percentage of
   * rejected rows. Type: integer (or Expression with resultType integer),
   * minimum: 0.
   * @member {object} [useTypeDefault] Specifies how to handle missing values
   * in delimited text files when PolyBase retrieves data from the text file.
   * Type: boolean (or Expression with resultType boolean).
   */
  constructor() {
  }

  /**
   * Defines the metadata of PolybaseSettings
   *
   * @returns {object} metadata of PolybaseSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PolybaseSettings',
      type: {
        name: 'Composite',
        className: 'PolybaseSettings',
        modelProperties: {
          rejectType: {
            required: false,
            serializedName: 'rejectType',
            type: {
              name: 'String'
            }
          },
          rejectValue: {
            required: false,
            serializedName: 'rejectValue',
            type: {
              name: 'Object'
            }
          },
          rejectSampleValue: {
            required: false,
            serializedName: 'rejectSampleValue',
            type: {
              name: 'Object'
            }
          },
          useTypeDefault: {
            required: false,
            serializedName: 'useTypeDefault',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = PolybaseSettings;
