/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Redirect incompatible row settings
 *
 */
class RedirectIncompatibleRowSettings {
  /**
   * Create a RedirectIncompatibleRowSettings.
   * @member {object} linkedServiceName Name of the Azure Storage or Storage
   * SAS linked service used for redirecting incompatible row. Must be
   * specified if redirectIncompatibleRowSettings is specified. Type: string
   * (or Expression with resultType string).
   * @member {object} [path] The path to storage for storing the redirect
   * incompatible row data Type: string (or Expression with resultType string).
   */
  constructor() {
  }

  /**
   * Defines the metadata of RedirectIncompatibleRowSettings
   *
   * @returns {object} metadata of RedirectIncompatibleRowSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RedirectIncompatibleRowSettings',
      type: {
        name: 'Composite',
        className: 'RedirectIncompatibleRowSettings',
        modelProperties: {
          linkedServiceName: {
            required: true,
            serializedName: 'linkedServiceName',
            type: {
              name: 'Object'
            }
          },
          path: {
            required: false,
            serializedName: 'path',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = RedirectIncompatibleRowSettings;
