/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * SAP Business Warehouse Linked Service.
 *
 * @extends models['LinkedService']
 */
class SapBWLinkedService extends models['LinkedService'] {
  /**
   * Create a SapBWLinkedService.
   * @member {object} server Host name of the SAP BW instance. Type: string (or
   * Expression with resultType string).
   * @member {object} systemNumber System number of the BW system. (Usually a
   * two-digit decimal number represented as a string.) Type: string (or
   * Expression with resultType string).
   * @member {object} clientId Client ID of the client on the BW system.
   * (Usually a three-digit decimal number represented as a string) Type:
   * string (or Expression with resultType string).
   * @member {object} [userName] Username to access the SAP BW server. Type:
   * string (or Expression with resultType string).
   * @member {object} [password] Password to access the SAP BW server.
   * @member {string} [password.value] Value of secure string.
   * @member {object} [encryptedCredential] The encrypted credential used for
   * authentication. Credentials are encrypted using the integration runtime
   * credential manager. Type: string (or Expression with resultType string).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SapBWLinkedService
   *
   * @returns {object} metadata of SapBWLinkedService
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SapBW',
      type: {
        name: 'Composite',
        className: 'SapBWLinkedService',
        modelProperties: {
          connectVia: {
            required: false,
            serializedName: 'connectVia',
            type: {
              name: 'Composite',
              className: 'IntegrationRuntimeReference'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          server: {
            required: true,
            serializedName: 'typeProperties.server',
            type: {
              name: 'Object'
            }
          },
          systemNumber: {
            required: true,
            serializedName: 'typeProperties.systemNumber',
            type: {
              name: 'Object'
            }
          },
          clientId: {
            required: true,
            serializedName: 'typeProperties.clientId',
            type: {
              name: 'Object'
            }
          },
          userName: {
            required: false,
            serializedName: 'typeProperties.userName',
            type: {
              name: 'Object'
            }
          },
          password: {
            required: false,
            serializedName: 'typeProperties.password',
            type: {
              name: 'Composite',
              className: 'SecureString'
            }
          },
          encryptedCredential: {
            required: false,
            serializedName: 'typeProperties.encryptedCredential',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = SapBWLinkedService;
