/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Azure Data Factory secure string definition. The string value will be masked
 * with asterisks '*' during Get or List API calls.
 *
 */
class SecureString {
  /**
   * Create a SecureString.
   * @member {string} value Value of secure string.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SecureString
   *
   * @returns {object} metadata of SecureString
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SecureString',
      type: {
        name: 'Composite',
        className: 'SecureString',
        modelProperties: {
          type: {
            required: true,
            isConstant: true,
            serializedName: 'type',
            defaultValue: 'SecureString',
            type: {
              name: 'String'
            }
          },
          value: {
            required: true,
            serializedName: 'value',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SecureString;
