/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A copy activity SQL Data Warehouse source.
 *
 * @extends models['CopySource']
 */
class SqlDWSource extends models['CopySource'] {
  /**
   * Create a SqlDWSource.
   * @member {object} [sqlReaderQuery] SQL Data Warehouse reader query. Type:
   * string (or Expression with resultType string).
   * @member {object} [sqlReaderStoredProcedureName] Name of the stored
   * procedure for a SQL Data Warehouse source. This cannot be used at the same
   * time as SqlReaderQuery. Type: string (or Expression with resultType
   * string).
   * @member {object} [storedProcedureParameters] Value and type setting for
   * stored procedure parameters. Example: "{Parameter1: {value: "1", type:
   * "int"}}". Type: object (or Expression with resultType object), itemType:
   * StoredProcedureParameter.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SqlDWSource
   *
   * @returns {object} metadata of SqlDWSource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SqlDWSource',
      type: {
        name: 'Composite',
        className: 'SqlDWSource',
        modelProperties: {
          sourceRetryCount: {
            required: false,
            serializedName: 'sourceRetryCount',
            type: {
              name: 'Object'
            }
          },
          sourceRetryWait: {
            required: false,
            serializedName: 'sourceRetryWait',
            type: {
              name: 'Object'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          sqlReaderQuery: {
            required: false,
            serializedName: 'sqlReaderQuery',
            type: {
              name: 'Object'
            }
          },
          sqlReaderStoredProcedureName: {
            required: false,
            serializedName: 'sqlReaderStoredProcedureName',
            type: {
              name: 'Object'
            }
          },
          storedProcedureParameters: {
            required: false,
            serializedName: 'storedProcedureParameters',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = SqlDWSource;
