/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * SQL stored procedure activity type.
 *
 * @extends models['ExecutionActivity']
 */
class SqlServerStoredProcedureActivity extends models['ExecutionActivity'] {
  /**
   * Create a SqlServerStoredProcedureActivity.
   * @member {object} storedProcedureName Stored procedure name. Type: string
   * (or Expression with resultType string).
   * @member {object} [storedProcedureParameters] Value and type setting for
   * stored procedure parameters. Example: "{Parameter1: {value: "1", type:
   * "int"}}".
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SqlServerStoredProcedureActivity
   *
   * @returns {object} metadata of SqlServerStoredProcedureActivity
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SqlServerStoredProcedure',
      type: {
        name: 'Composite',
        className: 'SqlServerStoredProcedureActivity',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          dependsOn: {
            required: false,
            serializedName: 'dependsOn',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ActivityDependencyElementType',
                  type: {
                    name: 'Composite',
                    className: 'ActivityDependency'
                  }
              }
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          linkedServiceName: {
            required: false,
            serializedName: 'linkedServiceName',
            type: {
              name: 'Composite',
              className: 'LinkedServiceReference'
            }
          },
          policy: {
            required: false,
            serializedName: 'policy',
            type: {
              name: 'Composite',
              className: 'ActivityPolicy'
            }
          },
          storedProcedureName: {
            required: true,
            serializedName: 'typeProperties.storedProcedureName',
            type: {
              name: 'Object'
            }
          },
          storedProcedureParameters: {
            required: false,
            serializedName: 'typeProperties.storedProcedureParameters',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StoredProcedureParameterElementType',
                  type: {
                    name: 'Composite',
                    className: 'StoredProcedureParameter'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = SqlServerStoredProcedureActivity;
