/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Pipeline that needs to be triggered with the given parameters.
 *
 */
class TriggerPipelineReference {
  /**
   * Create a TriggerPipelineReference.
   * @member {object} [pipelineReference] Pipeline reference.
   * @member {string} [pipelineReference.referenceName] Reference pipeline
   * name.
   * @member {string} [pipelineReference.name] Reference name.
   * @member {object} [parameters] Pipeline parameters.
   */
  constructor() {
  }

  /**
   * Defines the metadata of TriggerPipelineReference
   *
   * @returns {object} metadata of TriggerPipelineReference
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TriggerPipelineReference',
      type: {
        name: 'Composite',
        className: 'TriggerPipelineReference',
        modelProperties: {
          pipelineReference: {
            required: false,
            serializedName: 'pipelineReference',
            type: {
              name: 'Composite',
              className: 'PipelineReference'
            }
          },
          parameters: {
            required: false,
            serializedName: 'parameters',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'ObjectElementType',
                  type: {
                    name: 'Object'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = TriggerPipelineReference;
