/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The dataset points to a HTML table in the web page.
 *
 * @extends models['Dataset']
 */
class WebTableDataset extends models['Dataset'] {
  /**
   * Create a WebTableDataset.
   * @member {object} index The zero-based index of the table in the web page.
   * Type: integer (or Expression with resultType integer), minimum: 0.
   * @member {object} [path] The relative URL to the web page from the linked
   * service URL. Type: string (or Expression with resultType string).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of WebTableDataset
   *
   * @returns {object} metadata of WebTableDataset
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'WebTable',
      type: {
        name: 'Composite',
        className: 'WebTableDataset',
        modelProperties: {
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          structure: {
            required: false,
            serializedName: 'structure',
            type: {
              name: 'Object'
            }
          },
          linkedServiceName: {
            required: true,
            serializedName: 'linkedServiceName',
            defaultValue: {},
            type: {
              name: 'Composite',
              className: 'LinkedServiceReference'
            }
          },
          parameters: {
            required: false,
            serializedName: 'parameters',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'ParameterSpecificationElementType',
                  type: {
                    name: 'Composite',
                    className: 'ParameterSpecification'
                  }
              }
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          index: {
            required: true,
            serializedName: 'typeProperties.index',
            type: {
              name: 'Object'
            }
          },
          path: {
            required: false,
            serializedName: 'typeProperties.path',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = WebTableDataset;
