/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Storage account parameters for a storage account being added to a Data Lake
 * Analytics account.
 *
 */
class AddStorageAccountParameters {
  /**
   * Create a AddStorageAccountParameters.
   * @member {string} accessKey the access key associated with this Azure
   * Storage account that will be used to connect to it.
   * @member {string} [suffix] the optional suffix for the storage account.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AddStorageAccountParameters
   *
   * @returns {object} metadata of AddStorageAccountParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AddStorageAccountParameters',
      type: {
        name: 'Composite',
        className: 'AddStorageAccountParameters',
        modelProperties: {
          accessKey: {
            required: true,
            serializedName: 'properties.accessKey',
            type: {
              name: 'String'
            }
          },
          suffix: {
            required: false,
            serializedName: 'properties.suffix',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AddStorageAccountParameters;
