/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Data Lake Store account information.
 *
 * @extends models['SubResource']
 */
class DataLakeStoreAccountInfo extends models['SubResource'] {
  /**
   * Create a DataLakeStoreAccountInfo.
   * @member {string} [suffix] the optional suffix for the Data Lake Store
   * account.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of DataLakeStoreAccountInfo
   *
   * @returns {object} metadata of DataLakeStoreAccountInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DataLakeStoreAccountInfo',
      type: {
        name: 'Composite',
        className: 'DataLakeStoreAccountInfo',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          suffix: {
            required: false,
            serializedName: 'properties.suffix',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DataLakeStoreAccountInfo;
