/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A Data Lake Analytics catalog U-SQL procedure item.
 *
 * @extends models['CatalogItem']
 */
class USqlProcedure extends models['CatalogItem'] {
  /**
   * Create a USqlProcedure.
   * @member {string} [databaseName] the name of the database.
   * @member {string} [schemaName] the name of the schema associated with this
   * procedure and database.
   * @member {string} [name] the name of the procedure.
   * @member {string} [definition] the defined query of the procedure.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of USqlProcedure
   *
   * @returns {object} metadata of USqlProcedure
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'USqlProcedure',
      type: {
        name: 'Composite',
        className: 'USqlProcedure',
        modelProperties: {
          computeAccountName: {
            required: false,
            serializedName: 'computeAccountName',
            type: {
              name: 'String'
            }
          },
          version: {
            required: false,
            serializedName: 'version',
            type: {
              name: 'String'
            }
          },
          databaseName: {
            required: false,
            serializedName: 'databaseName',
            type: {
              name: 'String'
            }
          },
          schemaName: {
            required: false,
            serializedName: 'schemaName',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'procName',
            type: {
              name: 'String'
            }
          },
          definition: {
            required: false,
            serializedName: 'definition',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = USqlProcedure;
