/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The encryption identity properties.
 *
 */
class EncryptionIdentity {
  /**
   * Create a EncryptionIdentity.
   * @member {uuid} [principalId] The principal identifier associated with the
   * encryption.
   * @member {uuid} [tenantId] The tenant identifier associated with the
   * encryption.
   */
  constructor() {
  }

  /**
   * Defines the metadata of EncryptionIdentity
   *
   * @returns {object} metadata of EncryptionIdentity
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EncryptionIdentity',
      type: {
        name: 'Composite',
        className: 'EncryptionIdentity',
        modelProperties: {
          type: {
            required: true,
            isConstant: true,
            serializedName: 'type',
            defaultValue: 'SystemAssigned',
            type: {
              name: 'String'
            }
          },
          principalId: {
            required: false,
            readOnly: true,
            serializedName: 'principalId',
            type: {
              name: 'String'
            }
          },
          tenantId: {
            required: false,
            readOnly: true,
            serializedName: 'tenantId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = EncryptionIdentity;
