/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A WebHDFS exception thrown indicating there was an IO (read or write) error.
 * Thrown when a 403 error response code is returned (forbidden).
 *
 * @extends models['AdlsRemoteException']
 */
class AdlsIOException extends models['AdlsRemoteException'] {
  /**
   * Create a AdlsIOException.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AdlsIOException
   *
   * @returns {object} metadata of AdlsIOException
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IOException',
      type: {
        name: 'Composite',
        className: 'AdlsIOException',
        modelProperties: {
          javaClassName: {
            required: false,
            readOnly: true,
            serializedName: 'javaClassName',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            readOnly: true,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          },
          exception: {
            required: true,
            serializedName: 'exception',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AdlsIOException;
