/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Data Lake Store filesystem exception based on the WebHDFS definition for
 * RemoteExceptions. This is a WebHDFS 'catch all' exception
 *
 */
class AdlsRemoteException {
  /**
   * Create a AdlsRemoteException.
   * @member {string} [javaClassName] the full class package name for the
   * exception thrown, such as 'java.lang.IllegalArgumentException'.
   * @member {string} [message] the message associated with the exception that
   * was thrown, such as 'Invalid value for webhdfs parameter
   * "permission":...'.
   * @member {string} exception Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of AdlsRemoteException
   *
   * @returns {object} metadata of AdlsRemoteException
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AdlsRemoteException',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'exception',
          clientName: 'exception'
        },
        uberParent: 'AdlsRemoteException',
        className: 'AdlsRemoteException',
        modelProperties: {
          javaClassName: {
            required: false,
            readOnly: true,
            serializedName: 'javaClassName',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            readOnly: true,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          },
          exception: {
            required: true,
            serializedName: 'exception',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AdlsRemoteException;
