/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Request body for applying artifacts to a virtual machine.
 *
 */
class ApplyArtifactsRequest {
  /**
   * Create a ApplyArtifactsRequest.
   * @member {array} [artifacts] The list of artifacts to apply.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApplyArtifactsRequest
   *
   * @returns {object} metadata of ApplyArtifactsRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplyArtifactsRequest',
      type: {
        name: 'Composite',
        className: 'ApplyArtifactsRequest',
        modelProperties: {
          artifacts: {
            required: false,
            serializedName: 'artifacts',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ArtifactInstallPropertiesElementType',
                  type: {
                    name: 'Composite',
                    className: 'ArtifactInstallProperties'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ApplyArtifactsRequest;
