/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A data disks attached to a virtual machine.
 *
 */
class ComputeDataDisk {
  /**
   * Create a ComputeDataDisk.
   * @member {string} [name] Gets data disk name.
   * @member {string} [diskUri] When backed by a blob, the URI of underlying
   * blob.
   * @member {string} [managedDiskId] When backed by managed disk, this is the
   * ID of the compute disk resource.
   * @member {number} [diskSizeGiB] Gets data disk size in GiB.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ComputeDataDisk
   *
   * @returns {object} metadata of ComputeDataDisk
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ComputeDataDisk',
      type: {
        name: 'Composite',
        className: 'ComputeDataDisk',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          diskUri: {
            required: false,
            serializedName: 'diskUri',
            type: {
              name: 'String'
            }
          },
          managedDiskId: {
            required: false,
            serializedName: 'managedDiskId',
            type: {
              name: 'String'
            }
          },
          diskSizeGiB: {
            required: false,
            serializedName: 'diskSizeGiB',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = ComputeDataDisk;
