/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties for creating a custom image from a VHD.
 *
 */
class CustomImagePropertiesCustom {
  /**
   * Create a CustomImagePropertiesCustom.
   * @member {string} [imageName] The image name.
   * @member {boolean} [sysPrep] Indicates whether sysprep has been run on the
   * VHD.
   * @member {string} osType The OS type of the custom image (i.e. Windows,
   * Linux). Possible values include: 'Windows', 'Linux', 'None'
   */
  constructor() {
  }

  /**
   * Defines the metadata of CustomImagePropertiesCustom
   *
   * @returns {object} metadata of CustomImagePropertiesCustom
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CustomImagePropertiesCustom',
      type: {
        name: 'Composite',
        className: 'CustomImagePropertiesCustom',
        modelProperties: {
          imageName: {
            required: false,
            serializedName: 'imageName',
            type: {
              name: 'String'
            }
          },
          sysPrep: {
            required: false,
            serializedName: 'sysPrep',
            type: {
              name: 'Boolean'
            }
          },
          osType: {
            required: true,
            serializedName: 'osType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CustomImagePropertiesCustom;
