/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Properties of an environment deployment.
 *
 */
class EnvironmentDeploymentProperties {
  /**
   * Create a EnvironmentDeploymentProperties.
   * @member {string} [armTemplateId] The Azure Resource Manager template's
   * identifier.
   * @member {array} [parameters] The parameters of the Azure Resource Manager
   * template.
   */
  constructor() {
  }

  /**
   * Defines the metadata of EnvironmentDeploymentProperties
   *
   * @returns {object} metadata of EnvironmentDeploymentProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EnvironmentDeploymentProperties',
      type: {
        name: 'Composite',
        className: 'EnvironmentDeploymentProperties',
        modelProperties: {
          armTemplateId: {
            required: false,
            serializedName: 'armTemplateId',
            type: {
              name: 'String'
            }
          },
          parameters: {
            required: false,
            serializedName: 'parameters',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ArmTemplateParameterPropertiesElementType',
                  type: {
                    name: 'Composite',
                    className: 'ArmTemplateParameterProperties'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = EnvironmentDeploymentProperties;
