/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The parameters of the export operation.
 *
 */
class ExportResourceUsageParameters {
  /**
   * Create a ExportResourceUsageParameters.
   * @member {string} [blobStorageAbsoluteSasUri] The blob storage absolute sas
   * uri with write permission to the container which the usage data needs to
   * be uploaded to.
   * @member {date} [usageStartDate] The start time of the usage. If not
   * provided, usage will be reported since the beginning of data collection.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ExportResourceUsageParameters
   *
   * @returns {object} metadata of ExportResourceUsageParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ExportResourceUsageParameters',
      type: {
        name: 'Composite',
        className: 'ExportResourceUsageParameters',
        modelProperties: {
          blobStorageAbsoluteSasUri: {
            required: false,
            serializedName: 'blobStorageAbsoluteSasUri',
            type: {
              name: 'String'
            }
          },
          usageStartDate: {
            required: false,
            serializedName: 'usageStartDate',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = ExportResourceUsageParameters;
