/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

var msRestAzure = require('ms-rest-azure');

exports.BaseResource = msRestAzure.BaseResource;
exports.CloudError = msRestAzure.CloudError;
exports.WeekDetails = require('./weekDetails');
exports.DayDetails = require('./dayDetails');
exports.HourDetails = require('./hourDetails');
exports.NotificationSettings = require('./notificationSettings');
exports.Resource = require('./resource');
exports.Schedule = require('./schedule');
exports.ApplicableSchedule = require('./applicableSchedule');
exports.WeekDetailsFragment = require('./weekDetailsFragment');
exports.DayDetailsFragment = require('./dayDetailsFragment');
exports.HourDetailsFragment = require('./hourDetailsFragment');
exports.NotificationSettingsFragment = require('./notificationSettingsFragment');
exports.ScheduleFragment = require('./scheduleFragment');
exports.ApplicableScheduleFragment = require('./applicableScheduleFragment');
exports.ArtifactParameterProperties = require('./artifactParameterProperties');
exports.ArtifactInstallProperties = require('./artifactInstallProperties');
exports.ApplyArtifactsRequest = require('./applyArtifactsRequest');
exports.ParametersValueFileInfo = require('./parametersValueFileInfo');
exports.ArmTemplate = require('./armTemplate');
exports.ArmTemplateInfo = require('./armTemplateInfo');
exports.ArmTemplateParameterProperties = require('./armTemplateParameterProperties');
exports.Artifact = require('./artifact');
exports.ArtifactDeploymentStatusProperties = require('./artifactDeploymentStatusProperties');
exports.ArtifactDeploymentStatusPropertiesFragment = require('./artifactDeploymentStatusPropertiesFragment');
exports.ArtifactParameterPropertiesFragment = require('./artifactParameterPropertiesFragment');
exports.ArtifactInstallPropertiesFragment = require('./artifactInstallPropertiesFragment');
exports.ArtifactSource = require('./artifactSource');
exports.ArtifactSourceFragment = require('./artifactSourceFragment');
exports.AttachDiskProperties = require('./attachDiskProperties');
exports.AttachNewDataDiskOptions = require('./attachNewDataDiskOptions');
exports.BulkCreationParameters = require('./bulkCreationParameters');
exports.ComputeDataDisk = require('./computeDataDisk');
exports.ComputeDataDiskFragment = require('./computeDataDiskFragment');
exports.ComputeVmInstanceViewStatus = require('./computeVmInstanceViewStatus');
exports.ComputeVmInstanceViewStatusFragment = require('./computeVmInstanceViewStatusFragment');
exports.ComputeVmProperties = require('./computeVmProperties');
exports.ComputeVmPropertiesFragment = require('./computeVmPropertiesFragment');
exports.PercentageCostThresholdProperties = require('./percentageCostThresholdProperties');
exports.CostThresholdProperties = require('./costThresholdProperties');
exports.WindowsOsInfo = require('./windowsOsInfo');
exports.LinuxOsInfo = require('./linuxOsInfo');
exports.CustomImagePropertiesFromVm = require('./customImagePropertiesFromVm');
exports.CustomImagePropertiesCustom = require('./customImagePropertiesCustom');
exports.CustomImage = require('./customImage');
exports.DataDiskProperties = require('./dataDiskProperties');
exports.DetachDataDiskProperties = require('./detachDataDiskProperties');
exports.DetachDiskProperties = require('./detachDiskProperties');
exports.Disk = require('./disk');
exports.EnvironmentDeploymentProperties = require('./environmentDeploymentProperties');
exports.DtlEnvironment = require('./dtlEnvironment');
exports.EvaluatePoliciesProperties = require('./evaluatePoliciesProperties');
exports.EvaluatePoliciesRequest = require('./evaluatePoliciesRequest');
exports.PolicyViolation = require('./policyViolation');
exports.PolicySetResult = require('./policySetResult');
exports.EvaluatePoliciesResponse = require('./evaluatePoliciesResponse');
exports.Event = require('./event');
exports.EventFragment = require('./eventFragment');
exports.ExportResourceUsageParameters = require('./exportResourceUsageParameters');
exports.ExternalSubnet = require('./externalSubnet');
exports.ExternalSubnetFragment = require('./externalSubnetFragment');
exports.GalleryImageReference = require('./galleryImageReference');
exports.InboundNatRule = require('./inboundNatRule');
exports.SharedPublicIpAddressConfiguration = require('./sharedPublicIpAddressConfiguration');
exports.NetworkInterfaceProperties = require('./networkInterfaceProperties');
exports.LabVirtualMachineCreationParameter = require('./labVirtualMachineCreationParameter');
exports.FormulaPropertiesFromVm = require('./formulaPropertiesFromVm');
exports.Formula = require('./formula');
exports.GalleryImage = require('./galleryImage');
exports.GalleryImageReferenceFragment = require('./galleryImageReferenceFragment');
exports.ParameterInfo = require('./parameterInfo');
exports.GenerateArmTemplateRequest = require('./generateArmTemplateRequest');
exports.GenerateUploadUriParameter = require('./generateUploadUriParameter');
exports.GenerateUploadUriResponse = require('./generateUploadUriResponse');
exports.IdentityProperties = require('./identityProperties');
exports.InboundNatRuleFragment = require('./inboundNatRuleFragment');
exports.Lab = require('./lab');
exports.TargetCostProperties = require('./targetCostProperties');
exports.LabCostSummaryProperties = require('./labCostSummaryProperties');
exports.LabCostDetailsProperties = require('./labCostDetailsProperties');
exports.LabResourceCostProperties = require('./labResourceCostProperties');
exports.LabCost = require('./labCost');
exports.LabFragment = require('./labFragment');
exports.LabVhd = require('./labVhd');
exports.LabVirtualMachine = require('./labVirtualMachine');
exports.SharedPublicIpAddressConfigurationFragment = require('./sharedPublicIpAddressConfigurationFragment');
exports.NetworkInterfacePropertiesFragment = require('./networkInterfacePropertiesFragment');
exports.LabVirtualMachineFragment = require('./labVirtualMachineFragment');
exports.NotificationChannel = require('./notificationChannel');
exports.NotificationChannelFragment = require('./notificationChannelFragment');
exports.NotifyParameters = require('./notifyParameters');
exports.Policy = require('./policy');
exports.PolicyFragment = require('./policyFragment');
exports.Port = require('./port');
exports.PortFragment = require('./portFragment');
exports.Secret = require('./secret');
exports.ServiceRunner = require('./serviceRunner');
exports.UserIdentity = require('./userIdentity');
exports.UserSecretStore = require('./userSecretStore');
exports.User = require('./user');
exports.Subnet = require('./subnet');
exports.SubnetSharedPublicIpAddressConfiguration = require('./subnetSharedPublicIpAddressConfiguration');
exports.SubnetOverride = require('./subnetOverride');
exports.VirtualNetwork = require('./virtualNetwork');
exports.RetargetScheduleProperties = require('./retargetScheduleProperties');
exports.ShutdownNotificationContent = require('./shutdownNotificationContent');
exports.SubnetFragment = require('./subnetFragment');
exports.SubnetSharedPublicIpAddressConfigurationFragment = require('./subnetSharedPublicIpAddressConfigurationFragment');
exports.SubnetOverrideFragment = require('./subnetOverrideFragment');
exports.UserIdentityFragment = require('./userIdentityFragment');
exports.UserSecretStoreFragment = require('./userSecretStoreFragment');
exports.UserFragment = require('./userFragment');
exports.VirtualNetworkFragment = require('./virtualNetworkFragment');
exports.ResponseWithContinuationLab = require('./responseWithContinuationLab');
exports.ResponseWithContinuationLabVhd = require('./responseWithContinuationLabVhd');
exports.ResponseWithContinuationSchedule = require('./responseWithContinuationSchedule');
exports.ResponseWithContinuationArtifactSource = require('./responseWithContinuationArtifactSource');
exports.ResponseWithContinuationArmTemplate = require('./responseWithContinuationArmTemplate');
exports.ResponseWithContinuationArtifact = require('./responseWithContinuationArtifact');
exports.ResponseWithContinuationCustomImage = require('./responseWithContinuationCustomImage');
exports.ResponseWithContinuationFormula = require('./responseWithContinuationFormula');
exports.ResponseWithContinuationGalleryImage = require('./responseWithContinuationGalleryImage');
exports.ResponseWithContinuationNotificationChannel = require('./responseWithContinuationNotificationChannel');
exports.ResponseWithContinuationPolicy = require('./responseWithContinuationPolicy');
exports.ResponseWithContinuationServiceRunner = require('./responseWithContinuationServiceRunner');
exports.ResponseWithContinuationUser = require('./responseWithContinuationUser');
exports.ResponseWithContinuationDisk = require('./responseWithContinuationDisk');
exports.ResponseWithContinuationDtlEnvironment = require('./responseWithContinuationDtlEnvironment');
exports.ResponseWithContinuationSecret = require('./responseWithContinuationSecret');
exports.ResponseWithContinuationLabVirtualMachine = require('./responseWithContinuationLabVirtualMachine');
exports.ResponseWithContinuationVirtualNetwork = require('./responseWithContinuationVirtualNetwork');
