/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The properties of a lab cost item.
 *
 */
class LabCostDetailsProperties {
  /**
   * Create a LabCostDetailsProperties.
   * @member {date} [date] The date of the cost item.
   * @member {number} [cost] The cost component of the cost item.
   * @member {string} [costType] The type of the cost. Possible values include:
   * 'Unavailable', 'Reported', 'Projected'
   */
  constructor() {
  }

  /**
   * Defines the metadata of LabCostDetailsProperties
   *
   * @returns {object} metadata of LabCostDetailsProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LabCostDetailsProperties',
      type: {
        name: 'Composite',
        className: 'LabCostDetailsProperties',
        modelProperties: {
          date: {
            required: false,
            serializedName: 'date',
            type: {
              name: 'DateTime'
            }
          },
          cost: {
            required: false,
            serializedName: 'cost',
            type: {
              name: 'Number'
            }
          },
          costType: {
            required: false,
            serializedName: 'costType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = LabCostDetailsProperties;
