/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The properties of a resource cost item.
 *
 */
class LabResourceCostProperties {
  /**
   * Create a LabResourceCostProperties.
   * @member {string} [resourcename] The name of the resource.
   * @member {string} [resourceUId] The unique identifier of the resource.
   * @member {number} [resourceCost] The cost component of the resource cost
   * item.
   * @member {string} [resourceType] The logical resource type (ex.
   * virtualmachine, storageaccount)
   * @member {string} [resourceOwner] The owner of the resource (ex.
   * janedoe@microsoft.com)
   * @member {string} [resourcePricingTier] The category of the resource (ex.
   * Premium_LRS, Standard_DS1)
   * @member {string} [resourceStatus] The status of the resource (ex. Active)
   * @member {string} [resourceId] The ID of the resource
   * @member {string} [externalResourceId] The ID of the external resource
   */
  constructor() {
  }

  /**
   * Defines the metadata of LabResourceCostProperties
   *
   * @returns {object} metadata of LabResourceCostProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LabResourceCostProperties',
      type: {
        name: 'Composite',
        className: 'LabResourceCostProperties',
        modelProperties: {
          resourcename: {
            required: false,
            serializedName: 'resourcename',
            type: {
              name: 'String'
            }
          },
          resourceUId: {
            required: false,
            serializedName: 'resourceUId',
            type: {
              name: 'String'
            }
          },
          resourceCost: {
            required: false,
            serializedName: 'resourceCost',
            type: {
              name: 'Number'
            }
          },
          resourceType: {
            required: false,
            serializedName: 'resourceType',
            type: {
              name: 'String'
            }
          },
          resourceOwner: {
            required: false,
            serializedName: 'resourceOwner',
            type: {
              name: 'String'
            }
          },
          resourcePricingTier: {
            required: false,
            serializedName: 'resourcePricingTier',
            type: {
              name: 'String'
            }
          },
          resourceStatus: {
            required: false,
            serializedName: 'resourceStatus',
            type: {
              name: 'String'
            }
          },
          resourceId: {
            required: false,
            serializedName: 'resourceId',
            type: {
              name: 'String'
            }
          },
          externalResourceId: {
            required: false,
            serializedName: 'externalResourceId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = LabResourceCostProperties;
