/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties of a network port.
 *
 */
class Port {
  /**
   * Create a Port.
   * @member {string} [transportProtocol] Protocol type of the port. Possible
   * values include: 'Tcp', 'Udp'
   * @member {number} [backendPort] Backend port of the target virtual machine.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Port
   *
   * @returns {object} metadata of Port
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Port',
      type: {
        name: 'Composite',
        className: 'Port',
        modelProperties: {
          transportProtocol: {
            required: false,
            serializedName: 'transportProtocol',
            type: {
              name: 'String'
            }
          },
          backendPort: {
            required: false,
            serializedName: 'backendPort',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = Port;
