/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Update Properties of the Domain Service.
 *
 */
class DomainServicePatchProperties {
  /**
   * Create a DomainServicePatchProperties.
   * @member {object} [ldapsSettings] Secure LDAP Settings
   * @member {string} [ldapsSettings.ldaps] A flag to determine whether or not
   * Secure LDAP is enabled or disabled. Possible values include: 'Enabled',
   * 'Disabled'
   * @member {string} [ldapsSettings.pfxCertificate] The certificate required
   * to configure Secure LDAP. The parameter passed here should be a
   * base64encoded representation of the certificate pfx file.
   * @member {string} [ldapsSettings.pfxCertificatePassword] The password to
   * decrypt the provided Secure LDAP certificate pfx file.
   * @member {string} [ldapsSettings.publicCertificate] Public certificate used
   * to configure secure ldap.
   * @member {string} [ldapsSettings.certificateThumbprint] Thumbprint of
   * configure ldaps certificate.
   * @member {date} [ldapsSettings.certificateNotAfter] NotAfter DateTime of
   * configure ldaps certificate.
   * @member {string} [ldapsSettings.externalAccess] A flag to determine
   * whether or not Secure LDAP access over the internet is enabled or
   * disabled. Possible values include: 'Enabled', 'Disabled'
   * @member {string} [ldapsSettings.externalAccessIpAddress] External access
   * ip address.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DomainServicePatchProperties
   *
   * @returns {object} metadata of DomainServicePatchProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DomainServicePatchProperties',
      type: {
        name: 'Composite',
        className: 'DomainServicePatchProperties',
        modelProperties: {
          ldapsSettings: {
            required: false,
            serializedName: 'ldapsSettings',
            type: {
              name: 'Composite',
              className: 'LdapsSettings'
            }
          }
        }
      }
    };
  }
}

module.exports = DomainServicePatchProperties;
