/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Information about an operation
 *
 */
class OperationInfo {
  /**
   * Create a OperationInfo.
   * @member {string} [provider] Name of the provider
   * @member {string} [resource] Name of the resource type
   * @member {string} [operation] Name of the operation
   * @member {string} [description] Description of the operation
   */
  constructor() {
  }

  /**
   * Defines the metadata of OperationInfo
   *
   * @returns {object} metadata of OperationInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OperationInfo',
      type: {
        name: 'Composite',
        className: 'OperationInfo',
        modelProperties: {
          provider: {
            required: false,
            serializedName: 'provider',
            type: {
              name: 'String'
            }
          },
          resource: {
            required: false,
            serializedName: 'resource',
            type: {
              name: 'String'
            }
          },
          operation: {
            required: false,
            serializedName: 'operation',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = OperationInfo;
