/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Information about the webhook destination for an event subscription
 *
 * @extends models['EventSubscriptionDestination']
 */
class WebHookEventSubscriptionDestination extends models['EventSubscriptionDestination'] {
  /**
   * Create a WebHookEventSubscriptionDestination.
   * @member {string} [endpointUrl] The URL that represents the endpoint of the
   * destination of an event subscription.
   * @member {string} [endpointBaseUrl] The base URL that represents the
   * endpoint of the destination of an event subscription.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of WebHookEventSubscriptionDestination
   *
   * @returns {object} metadata of WebHookEventSubscriptionDestination
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'WebHook',
      type: {
        name: 'Composite',
        className: 'WebHookEventSubscriptionDestination',
        modelProperties: {
          endpointType: {
            required: true,
            serializedName: 'endpointType',
            type: {
              name: 'String'
            }
          },
          endpointUrl: {
            required: false,
            serializedName: 'properties.endpointUrl',
            type: {
              name: 'String'
            }
          },
          endpointBaseUrl: {
            required: false,
            readOnly: true,
            serializedName: 'properties.endpointBaseUrl',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = WebHookEventSubscriptionDestination;
