/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The properties of the messaging endpoints used by this IoT hub.
 *
 */
class MessagingEndpointProperties {
  /**
   * Create a MessagingEndpointProperties.
   * @member {moment.duration} [lockDurationAsIso8601] The lock duration. See:
   * https://docs.microsoft.com/azure/iot-hub/iot-hub-devguide-file-upload.
   * @member {moment.duration} [ttlAsIso8601] The period of time for which a
   * message is available to consume before it is expired by the IoT hub. See:
   * https://docs.microsoft.com/azure/iot-hub/iot-hub-devguide-file-upload.
   * @member {number} [maxDeliveryCount] The number of times the IoT hub
   * attempts to deliver a message. See:
   * https://docs.microsoft.com/azure/iot-hub/iot-hub-devguide-file-upload.
   */
  constructor() {
  }

  /**
   * Defines the metadata of MessagingEndpointProperties
   *
   * @returns {object} metadata of MessagingEndpointProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MessagingEndpointProperties',
      type: {
        name: 'Composite',
        className: 'MessagingEndpointProperties',
        modelProperties: {
          lockDurationAsIso8601: {
            required: false,
            serializedName: 'lockDurationAsIso8601',
            type: {
              name: 'TimeSpan'
            }
          },
          ttlAsIso8601: {
            required: false,
            serializedName: 'ttlAsIso8601',
            type: {
              name: 'TimeSpan'
            }
          },
          maxDeliveryCount: {
            required: false,
            serializedName: 'maxDeliveryCount',
            constraints: {
              InclusiveMaximum: 100,
              InclusiveMinimum: 1
            },
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = MessagingEndpointProperties;
