/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Identity registry statistics.
 *
 */
class RegistryStatistics {
  /**
   * Create a RegistryStatistics.
   * @member {number} [totalDeviceCount] The total count of devices in the
   * identity registry.
   * @member {number} [enabledDeviceCount] The count of enabled devices in the
   * identity registry.
   * @member {number} [disabledDeviceCount] The count of disabled devices in
   * the identity registry.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RegistryStatistics
   *
   * @returns {object} metadata of RegistryStatistics
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RegistryStatistics',
      type: {
        name: 'Composite',
        className: 'RegistryStatistics',
        modelProperties: {
          totalDeviceCount: {
            required: false,
            readOnly: true,
            serializedName: 'totalDeviceCount',
            type: {
              name: 'Number'
            }
          },
          enabledDeviceCount: {
            required: false,
            readOnly: true,
            serializedName: 'enabledDeviceCount',
            type: {
              name: 'Number'
            }
          },
          disabledDeviceCount: {
            required: false,
            readOnly: true,
            serializedName: 'disabledDeviceCount',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = RegistryStatistics;
