/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The properties related to service bus topic endpoint types.
 *
 */
class RoutingServiceBusTopicEndpointProperties {
  /**
   * Create a RoutingServiceBusTopicEndpointProperties.
   * @member {string} connectionString The connection string of the service bus
   * topic endpoint.
   * @member {string} name The name that identifies this endpoint. The name can
   * only include alphanumeric characters, periods, underscores, hyphens and
   * has a maximum length of 64 characters. The following names are reserved:
   * events, operationsMonitoringEvents, fileNotifications, $default. Endpoint
   * names must be unique across endpoint types.  The name need not be the same
   * as the actual topic name.
   * @member {string} [subscriptionId] The subscription identifier of the
   * service bus topic endpoint.
   * @member {string} [resourceGroup] The name of the resource group of the
   * service bus topic endpoint.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RoutingServiceBusTopicEndpointProperties
   *
   * @returns {object} metadata of RoutingServiceBusTopicEndpointProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RoutingServiceBusTopicEndpointProperties',
      type: {
        name: 'Composite',
        className: 'RoutingServiceBusTopicEndpointProperties',
        modelProperties: {
          connectionString: {
            required: true,
            serializedName: 'connectionString',
            type: {
              name: 'String'
            }
          },
          name: {
            required: true,
            serializedName: 'name',
            constraints: {
              Pattern: '^[A-Za-z0-9-._]{1,64}$'
            },
            type: {
              name: 'String'
            }
          },
          subscriptionId: {
            required: false,
            serializedName: 'subscriptionId',
            type: {
              name: 'String'
            }
          },
          resourceGroup: {
            required: false,
            serializedName: 'resourceGroup',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = RoutingServiceBusTopicEndpointProperties;
