/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * SKU details
 *
 */
class Sku {
  /**
   * Create a Sku.
   * @member {string} name SKU name to specify whether the key vault is a
   * standard vault or a premium vault. Possible values include: 'standard',
   * 'premium'
   */
  constructor() {
  }

  /**
   * Defines the metadata of Sku
   *
   * @returns {object} metadata of Sku
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Sku',
      type: {
        name: 'Composite',
        className: 'Sku',
        modelProperties: {
          family: {
            required: true,
            isConstant: true,
            serializedName: 'family',
            defaultValue: 'A',
            type: {
              name: 'String'
            }
          },
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'Enum',
              allowedValues: [ 'standard', 'premium' ]
            }
          }
        }
      }
    };
  }
}

module.exports = Sku;
