/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The AS2 agreement envelope settings.
 *
 */
class AS2EnvelopeSettings {
  /**
   * Create a AS2EnvelopeSettings.
   * @member {string} messageContentType The message content type.
   * @member {boolean} transmitFileNameInMimeHeader The value indicating
   * whether to transmit file name in mime header.
   * @member {string} fileNameTemplate The template for file name.
   * @member {boolean} suspendMessageOnFileNameGenerationError The value
   * indicating whether to suspend message on file name generation error.
   * @member {boolean} autogenerateFileName The value indicating whether to
   * auto generate file name.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AS2EnvelopeSettings
   *
   * @returns {object} metadata of AS2EnvelopeSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AS2EnvelopeSettings',
      type: {
        name: 'Composite',
        className: 'AS2EnvelopeSettings',
        modelProperties: {
          messageContentType: {
            required: true,
            serializedName: 'messageContentType',
            type: {
              name: 'String'
            }
          },
          transmitFileNameInMimeHeader: {
            required: true,
            serializedName: 'transmitFileNameInMimeHeader',
            type: {
              name: 'Boolean'
            }
          },
          fileNameTemplate: {
            required: true,
            serializedName: 'fileNameTemplate',
            type: {
              name: 'String'
            }
          },
          suspendMessageOnFileNameGenerationError: {
            required: true,
            serializedName: 'suspendMessageOnFileNameGenerationError',
            type: {
              name: 'Boolean'
            }
          },
          autogenerateFileName: {
            required: true,
            serializedName: 'autogenerateFileName',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = AS2EnvelopeSettings;
