/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The integration account partner's business identity.
 *
 */
class BusinessIdentity {
  /**
   * Create a BusinessIdentity.
   * @member {string} qualifier The business identity qualifier e.g.
   * as2identity, ZZ, ZZZ, 31, 32
   * @member {string} value The user defined business identity value.
   */
  constructor() {
  }

  /**
   * Defines the metadata of BusinessIdentity
   *
   * @returns {object} metadata of BusinessIdentity
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BusinessIdentity',
      type: {
        name: 'Composite',
        className: 'BusinessIdentity',
        modelProperties: {
          qualifier: {
            required: true,
            serializedName: 'qualifier',
            type: {
              name: 'String'
            }
          },
          value: {
            required: true,
            serializedName: 'value',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = BusinessIdentity;
