/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The Edifact agreement validation settings.
 *
 */
class EdifactValidationSettings {
  /**
   * Create a EdifactValidationSettings.
   * @member {boolean} validateCharacterSet The value indicating whether to
   * validate character set in the message.
   * @member {boolean} checkDuplicateInterchangeControlNumber The value
   * indicating whether to check for duplicate interchange control number.
   * @member {number} interchangeControlNumberValidityDays The validity period
   * of interchange control number.
   * @member {boolean} checkDuplicateGroupControlNumber The value indicating
   * whether to check for duplicate group control number.
   * @member {boolean} checkDuplicateTransactionSetControlNumber The value
   * indicating whether to check for duplicate transaction set control number.
   * @member {boolean} validateEdiTypes The value indicating whether to Whether
   * to validate EDI types.
   * @member {boolean} validateXsdTypes The value indicating whether to Whether
   * to validate XSD types.
   * @member {boolean} allowLeadingAndTrailingSpacesAndZeroes The value
   * indicating whether to allow leading and trailing spaces and zeroes.
   * @member {boolean} trimLeadingAndTrailingSpacesAndZeroes The value
   * indicating whether to trim leading and trailing spaces and zeroes.
   * @member {string} trailingSeparatorPolicy The trailing separator policy.
   * Possible values include: 'NotSpecified', 'NotAllowed', 'Optional',
   * 'Mandatory'
   */
  constructor() {
  }

  /**
   * Defines the metadata of EdifactValidationSettings
   *
   * @returns {object} metadata of EdifactValidationSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EdifactValidationSettings',
      type: {
        name: 'Composite',
        className: 'EdifactValidationSettings',
        modelProperties: {
          validateCharacterSet: {
            required: true,
            serializedName: 'validateCharacterSet',
            type: {
              name: 'Boolean'
            }
          },
          checkDuplicateInterchangeControlNumber: {
            required: true,
            serializedName: 'checkDuplicateInterchangeControlNumber',
            type: {
              name: 'Boolean'
            }
          },
          interchangeControlNumberValidityDays: {
            required: true,
            serializedName: 'interchangeControlNumberValidityDays',
            type: {
              name: 'Number'
            }
          },
          checkDuplicateGroupControlNumber: {
            required: true,
            serializedName: 'checkDuplicateGroupControlNumber',
            type: {
              name: 'Boolean'
            }
          },
          checkDuplicateTransactionSetControlNumber: {
            required: true,
            serializedName: 'checkDuplicateTransactionSetControlNumber',
            type: {
              name: 'Boolean'
            }
          },
          validateEdiTypes: {
            required: true,
            serializedName: 'validateEdiTypes',
            type: {
              name: 'Boolean'
            }
          },
          validateXsdTypes: {
            required: true,
            serializedName: 'validateXsdTypes',
            type: {
              name: 'Boolean'
            }
          },
          allowLeadingAndTrailingSpacesAndZeroes: {
            required: true,
            serializedName: 'allowLeadingAndTrailingSpacesAndZeroes',
            type: {
              name: 'Boolean'
            }
          },
          trimLeadingAndTrailingSpacesAndZeroes: {
            required: true,
            serializedName: 'trimLeadingAndTrailingSpacesAndZeroes',
            type: {
              name: 'Boolean'
            }
          },
          trailingSeparatorPolicy: {
            required: true,
            serializedName: 'trailingSeparatorPolicy',
            type: {
              name: 'Enum',
              allowedValues: [ 'NotSpecified', 'NotAllowed', 'Optional', 'Mandatory' ]
            }
          }
        }
      }
    };
  }
}

module.exports = EdifactValidationSettings;
