/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The integration account.
 *
 * @extends models['Resource']
 */
class IntegrationAccount extends models['Resource'] {
  /**
   * Create a IntegrationAccount.
   * @member {object} [properties] The integration account properties.
   * @member {object} [sku] The sku.
   * @member {string} [sku.name] The sku name. Possible values include:
   * 'NotSpecified', 'Free', 'Standard'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of IntegrationAccount
   *
   * @returns {object} metadata of IntegrationAccount
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IntegrationAccount',
      type: {
        name: 'Composite',
        className: 'IntegrationAccount',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Object'
            }
          },
          sku: {
            required: false,
            serializedName: 'sku',
            type: {
              name: 'Composite',
              className: 'IntegrationAccountSku'
            }
          }
        }
      }
    };
  }
}

module.exports = IntegrationAccount;
