/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The integration account certificate.
 *
 * @extends models['Resource']
 */
class IntegrationAccountCertificate extends models['Resource'] {
  /**
   * Create a IntegrationAccountCertificate.
   * @member {date} [createdTime] The created time.
   * @member {date} [changedTime] The changed time.
   * @member {object} [metadata] The metadata.
   * @member {object} [key] The key details in the key vault.
   * @member {object} [key.keyVault] The key vault reference.
   * @member {string} [key.keyVault.id] The resource id.
   * @member {string} [key.keyVault.name] The resource name.
   * @member {string} [key.keyVault.type] The resource type.
   * @member {string} [key.keyName] The private key name in key vault.
   * @member {string} [key.keyVersion] The private key version in key vault.
   * @member {string} [publicCertificate] The public certificate.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of IntegrationAccountCertificate
   *
   * @returns {object} metadata of IntegrationAccountCertificate
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IntegrationAccountCertificate',
      type: {
        name: 'Composite',
        className: 'IntegrationAccountCertificate',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          createdTime: {
            required: false,
            readOnly: true,
            serializedName: 'properties.createdTime',
            type: {
              name: 'DateTime'
            }
          },
          changedTime: {
            required: false,
            readOnly: true,
            serializedName: 'properties.changedTime',
            type: {
              name: 'DateTime'
            }
          },
          metadata: {
            required: false,
            serializedName: 'properties.metadata',
            type: {
              name: 'Object'
            }
          },
          key: {
            required: false,
            serializedName: 'properties.key',
            type: {
              name: 'Composite',
              className: 'KeyVaultKeyReference'
            }
          },
          publicCertificate: {
            required: false,
            serializedName: 'properties.publicCertificate',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = IntegrationAccountCertificate;
