/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The integration account partner.
 *
 * @extends models['Resource']
 */
class IntegrationAccountPartner extends models['Resource'] {
  /**
   * Create a IntegrationAccountPartner.
   * @member {string} partnerType The partner type. Possible values include:
   * 'NotSpecified', 'B2B'
   * @member {date} [createdTime] The created time.
   * @member {date} [changedTime] The changed time.
   * @member {object} [metadata] The metadata.
   * @member {object} content The partner content.
   * @member {object} [content.b2b] The B2B partner content.
   * @member {array} [content.b2b.businessIdentities] The list of partner
   * business identities.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of IntegrationAccountPartner
   *
   * @returns {object} metadata of IntegrationAccountPartner
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IntegrationAccountPartner',
      type: {
        name: 'Composite',
        className: 'IntegrationAccountPartner',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          partnerType: {
            required: true,
            serializedName: 'properties.partnerType',
            type: {
              name: 'Enum',
              allowedValues: [ 'NotSpecified', 'B2B' ]
            }
          },
          createdTime: {
            required: false,
            readOnly: true,
            serializedName: 'properties.createdTime',
            type: {
              name: 'DateTime'
            }
          },
          changedTime: {
            required: false,
            readOnly: true,
            serializedName: 'properties.changedTime',
            type: {
              name: 'DateTime'
            }
          },
          metadata: {
            required: false,
            serializedName: 'properties.metadata',
            type: {
              name: 'Object'
            }
          },
          content: {
            required: true,
            serializedName: 'properties.content',
            type: {
              name: 'Composite',
              className: 'PartnerContent'
            }
          }
        }
      }
    };
  }
}

module.exports = IntegrationAccountPartner;
