/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The integration account partner content.
 *
 */
class PartnerContent {
  /**
   * Create a PartnerContent.
   * @member {object} [b2b] The B2B partner content.
   * @member {array} [b2b.businessIdentities] The list of partner business
   * identities.
   */
  constructor() {
  }

  /**
   * Defines the metadata of PartnerContent
   *
   * @returns {object} metadata of PartnerContent
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PartnerContent',
      type: {
        name: 'Composite',
        className: 'PartnerContent',
        modelProperties: {
          b2b: {
            required: false,
            serializedName: 'b2b',
            type: {
              name: 'Composite',
              className: 'B2BPartnerContent'
            }
          }
        }
      }
    };
  }
}

module.exports = PartnerContent;
