/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The retry history.
 *
 */
class RetryHistory {
  /**
   * Create a RetryHistory.
   * @member {date} [startTime] Gets the start time.
   * @member {date} [endTime] Gets the end time.
   * @member {string} [code] Gets the status code.
   * @member {string} [clientRequestId] Gets the client request Id.
   * @member {string} [serviceRequestId] Gets the service request Id.
   * @member {object} [error] Gets the error response.
   * @member {object} [error.error] The error properties.
   * @member {string} [error.error.code] Error code.
   * @member {string} [error.error.message] Error message indicating why the
   * operation failed.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RetryHistory
   *
   * @returns {object} metadata of RetryHistory
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RetryHistory',
      type: {
        name: 'Composite',
        className: 'RetryHistory',
        modelProperties: {
          startTime: {
            required: false,
            serializedName: 'startTime',
            type: {
              name: 'DateTime'
            }
          },
          endTime: {
            required: false,
            serializedName: 'endTime',
            type: {
              name: 'DateTime'
            }
          },
          code: {
            required: false,
            serializedName: 'code',
            type: {
              name: 'String'
            }
          },
          clientRequestId: {
            required: false,
            serializedName: 'clientRequestId',
            type: {
              name: 'String'
            }
          },
          serviceRequestId: {
            required: false,
            serializedName: 'serviceRequestId',
            type: {
              name: 'String'
            }
          },
          error: {
            required: false,
            serializedName: 'error',
            type: {
              name: 'Composite',
              className: 'ErrorResponse'
            }
          }
        }
      }
    };
  }
}

module.exports = RetryHistory;
