/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The workflow trigger callback URL.
 *
 */
class WorkflowTriggerCallbackUrl {
  /**
   * Create a WorkflowTriggerCallbackUrl.
   * @member {string} [value] Gets the workflow trigger callback URL.
   * @member {string} [method] Gets the workflow trigger callback URL HTTP
   * method.
   * @member {string} [basePath] Gets the workflow trigger callback URL base
   * path.
   * @member {string} [relativePath] Gets the workflow trigger callback URL
   * relative path.
   * @member {array} [relativePathParameters] Gets the workflow trigger
   * callback URL relative path parameters.
   * @member {object} [queries] Gets the workflow trigger callback URL query
   * parameters.
   * @member {string} [queries.apiVersion] The api version.
   * @member {string} [queries.sp] The SAS permissions.
   * @member {string} [queries.sv] The SAS version.
   * @member {string} [queries.sig] The SAS signature.
   */
  constructor() {
  }

  /**
   * Defines the metadata of WorkflowTriggerCallbackUrl
   *
   * @returns {object} metadata of WorkflowTriggerCallbackUrl
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'WorkflowTriggerCallbackUrl',
      type: {
        name: 'Composite',
        className: 'WorkflowTriggerCallbackUrl',
        modelProperties: {
          value: {
            required: false,
            readOnly: true,
            serializedName: 'value',
            type: {
              name: 'String'
            }
          },
          method: {
            required: false,
            readOnly: true,
            serializedName: 'method',
            type: {
              name: 'String'
            }
          },
          basePath: {
            required: false,
            readOnly: true,
            serializedName: 'basePath',
            type: {
              name: 'String'
            }
          },
          relativePath: {
            required: false,
            readOnly: true,
            serializedName: 'relativePath',
            type: {
              name: 'String'
            }
          },
          relativePathParameters: {
            required: false,
            serializedName: 'relativePathParameters',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          queries: {
            required: false,
            serializedName: 'queries',
            type: {
              name: 'Composite',
              className: 'WorkflowTriggerListCallbackUrlQueries'
            }
          }
        }
      }
    };
  }
}

module.exports = WorkflowTriggerCallbackUrl;
