/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The workflow trigger history filter.
 *
 */
class WorkflowTriggerHistoryFilter {
  /**
   * Create a WorkflowTriggerHistoryFilter.
   * @member {string} [status] The status of workflow trigger history. Possible
   * values include: 'NotSpecified', 'Paused', 'Running', 'Waiting',
   * 'Succeeded', 'Skipped', 'Suspended', 'Cancelled', 'Failed', 'Faulted',
   * 'TimedOut', 'Aborted', 'Ignored'
   */
  constructor() {
  }

  /**
   * Defines the metadata of WorkflowTriggerHistoryFilter
   *
   * @returns {object} metadata of WorkflowTriggerHistoryFilter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'WorkflowTriggerHistoryFilter',
      type: {
        name: 'Composite',
        className: 'WorkflowTriggerHistoryFilter',
        modelProperties: {
          status: {
            required: false,
            serializedName: 'status',
            type: {
              name: 'Enum',
              allowedValues: [ 'NotSpecified', 'Paused', 'Running', 'Waiting', 'Succeeded', 'Skipped', 'Suspended', 'Cancelled', 'Failed', 'Faulted', 'TimedOut', 'Aborted', 'Ignored' ]
            }
          }
        }
      }
    };
  }
}

module.exports = WorkflowTriggerHistoryFilter;
