/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The X12 schema reference.
 *
 */
class X12SchemaReference {
  /**
   * Create a X12SchemaReference.
   * @member {string} messageId The message id.
   * @member {string} [senderApplicationId] The sender application id.
   * @member {string} schemaVersion The schema version.
   * @member {string} schemaName The schema name.
   */
  constructor() {
  }

  /**
   * Defines the metadata of X12SchemaReference
   *
   * @returns {object} metadata of X12SchemaReference
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'X12SchemaReference',
      type: {
        name: 'Composite',
        className: 'X12SchemaReference',
        modelProperties: {
          messageId: {
            required: true,
            serializedName: 'messageId',
            type: {
              name: 'String'
            }
          },
          senderApplicationId: {
            required: false,
            serializedName: 'senderApplicationId',
            type: {
              name: 'String'
            }
          },
          schemaVersion: {
            required: true,
            serializedName: 'schemaVersion',
            type: {
              name: 'String'
            }
          },
          schemaName: {
            required: true,
            serializedName: 'schemaName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = X12SchemaReference;
