/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Represents the association between a commitment plan and some other
 * resource, such as a Machine Learning web service.
 *
 * @extends models['Resource']
 */
class CommitmentAssociation extends models['Resource'] {
  /**
   * Create a CommitmentAssociation.
   * @member {string} [etag] An entity tag used to enforce optimistic
   * concurrency.
   * @member {object} [properties] The properties of the commitment association
   * resource.
   * @member {string} [properties.associatedResourceId] The ID of the resource
   * this association points to, such as the ARM ID of an Azure ML web service.
   * @member {string} [properties.commitmentPlanId] The ARM ID of the parent
   * Azure ML commitment plan.
   * @member {date} [properties.creationDate] The date at which this commitment
   * association was created, in ISO 8601 format.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of CommitmentAssociation
   *
   * @returns {object} metadata of CommitmentAssociation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CommitmentAssociation',
      type: {
        name: 'Composite',
        className: 'CommitmentAssociation',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          location: {
            required: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          etag: {
            required: false,
            serializedName: 'etag',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'CommitmentAssociationProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = CommitmentAssociation;
