/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Specifies the destination Azure ML commitment plan for a move operation.
 *
 */
class MoveCommitmentAssociationRequest {
  /**
   * Create a MoveCommitmentAssociationRequest.
   * @member {string} [destinationPlanId] The ARM ID of the commitment plan to
   * re-parent the commitment association to.
   */
  constructor() {
  }

  /**
   * Defines the metadata of MoveCommitmentAssociationRequest
   *
   * @returns {object} metadata of MoveCommitmentAssociationRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MoveCommitmentAssociationRequest',
      type: {
        name: 'Composite',
        className: 'MoveCommitmentAssociationRequest',
        modelProperties: {
          destinationPlanId: {
            required: false,
            serializedName: 'destinationPlanId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = MoveCommitmentAssociationRequest;
