/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents the quantity a commitment plan provides of a metered resource.
 *
 */
class PlanQuantity {
  /**
   * Create a PlanQuantity.
   * @member {number} [allowance] The quantity added to the commitment plan at
   * an interval specified by its allowance frequency.
   * @member {number} [amount] The quantity available to the plan the last time
   * usage was calculated.
   * @member {string} [includedQuantityMeter] The Azure meter for usage against
   * included quantities.
   * @member {string} [overageMeter] The Azure meter for usage which exceeds
   * included quantities.
   */
  constructor() {
  }

  /**
   * Defines the metadata of PlanQuantity
   *
   * @returns {object} metadata of PlanQuantity
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PlanQuantity',
      type: {
        name: 'Composite',
        className: 'PlanQuantity',
        modelProperties: {
          allowance: {
            required: false,
            readOnly: true,
            serializedName: 'allowance',
            type: {
              name: 'Number'
            }
          },
          amount: {
            required: false,
            readOnly: true,
            serializedName: 'amount',
            type: {
              name: 'Number'
            }
          },
          includedQuantityMeter: {
            required: false,
            readOnly: true,
            serializedName: 'includedQuantityMeter',
            type: {
              name: 'String'
            }
          },
          overageMeter: {
            required: false,
            readOnly: true,
            serializedName: 'overageMeter',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = PlanQuantity;
