/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The SKU of a resource.
 *
 */
class ResourceSku {
  /**
   * Create a ResourceSku.
   * @member {number} [capacity] The scale-out capacity of the resource. 1 is
   * 1x, 2 is 2x, etc. This impacts the quantities and cost of any commitment
   * plan resource.
   * @member {string} [name] The SKU name. Along with tier, uniquely identifies
   * the SKU.
   * @member {string} [tier] The SKU tier. Along with name, uniquely identifies
   * the SKU.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResourceSku
   *
   * @returns {object} metadata of ResourceSku
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceSku',
      type: {
        name: 'Composite',
        className: 'ResourceSku',
        modelProperties: {
          capacity: {
            required: false,
            serializedName: 'capacity',
            type: {
              name: 'Number'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          tier: {
            required: false,
            serializedName: 'tier',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceSku;
