/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The error detail information for async operation
 *
 */
class AsyncOperationErrorInfo {
  /**
   * Create a AsyncOperationErrorInfo.
   * @member {string} [code] The error code.
   * @member {string} [target] The error target.
   * @member {string} [message] The error message.
   * @member {array} [details] An array containing error information.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AsyncOperationErrorInfo
   *
   * @returns {object} metadata of AsyncOperationErrorInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AsyncOperationErrorInfo',
      type: {
        name: 'Composite',
        className: 'AsyncOperationErrorInfo',
        modelProperties: {
          code: {
            required: false,
            serializedName: 'code',
            type: {
              name: 'String'
            }
          },
          target: {
            required: false,
            serializedName: 'target',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          },
          details: {
            required: false,
            serializedName: 'details',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'AsyncOperationErrorInfoElementType',
                  type: {
                    name: 'Composite',
                    className: 'AsyncOperationErrorInfo'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = AsyncOperationErrorInfo;
