/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Azure async operation status.
 *
 */
class AsyncOperationStatus {
  /**
   * Create a AsyncOperationStatus.
   * @member {string} [id] Async operation id.
   * @member {string} [name] Async operation name.
   * @member {string} [provisioningState] Read Only: The provisioning state of
   * the web service. Valid values are Unknown, Provisioning, Succeeded, and
   * Failed. Possible values include: 'Unknown', 'Provisioning', 'Succeeded',
   * 'Failed'
   * @member {date} [startTime] The date time that the async operation started.
   * @member {date} [endTime] The date time that the async operation finished.
   * @member {number} [percentComplete] Async operation progress.
   * @member {object} [errorInfo] If the async operation fails, this structure
   * contains the error details.
   * @member {string} [errorInfo.code] The error code.
   * @member {string} [errorInfo.target] The error target.
   * @member {string} [errorInfo.message] The error message.
   * @member {array} [errorInfo.details] An array containing error information.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AsyncOperationStatus
   *
   * @returns {object} metadata of AsyncOperationStatus
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AsyncOperationStatus',
      type: {
        name: 'Composite',
        className: 'AsyncOperationStatus',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          provisioningState: {
            required: false,
            readOnly: true,
            serializedName: 'provisioningState',
            type: {
              name: 'String'
            }
          },
          startTime: {
            required: false,
            readOnly: true,
            serializedName: 'startTime',
            type: {
              name: 'DateTime'
            }
          },
          endTime: {
            required: false,
            readOnly: true,
            serializedName: 'endTime',
            type: {
              name: 'DateTime'
            }
          },
          percentComplete: {
            required: false,
            serializedName: 'percentComplete',
            type: {
              name: 'Number'
            }
          },
          errorInfo: {
            required: false,
            serializedName: 'errorInfo',
            type: {
              name: 'Composite',
              className: 'AsyncOperationErrorInfo'
            }
          }
        }
      }
    };
  }
}

module.exports = AsyncOperationStatus;
