/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Parameter definition for a module asset.
 *
 */
class ModuleAssetParameter {
  /**
   * Create a ModuleAssetParameter.
   * @member {string} [name] Parameter name.
   * @member {string} [parameterType] Parameter type.
   * @member {object} [modeValuesInfo] Definitions for nested interface
   * parameters if this is a complex module parameter.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ModuleAssetParameter
   *
   * @returns {object} metadata of ModuleAssetParameter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ModuleAssetParameter',
      type: {
        name: 'Composite',
        className: 'ModuleAssetParameter',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          parameterType: {
            required: false,
            serializedName: 'parameterType',
            type: {
              name: 'String'
            }
          },
          modeValuesInfo: {
            required: false,
            serializedName: 'modeValuesInfo',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'ModeValueInfoElementType',
                  type: {
                    name: 'Composite',
                    className: 'ModeValueInfo'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ModuleAssetParameter;
