/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The swagger 2.0 schema describing the service's inputs or outputs. See
 * Swagger specification: http://swagger.io/specification/
 *
 */
class ServiceInputOutputSpecification {
  /**
   * Create a ServiceInputOutputSpecification.
   * @member {string} [title] The title of your Swagger schema.
   * @member {string} [description] The description of the Swagger schema.
   * @member {string} type The type of the entity described in swagger. Always
   * 'object'. Default value: 'object' .
   * @member {object} properties Specifies a collection that contains the
   * column schema for each input or output of the web service. For more
   * information, see the Swagger specification.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ServiceInputOutputSpecification
   *
   * @returns {object} metadata of ServiceInputOutputSpecification
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ServiceInputOutputSpecification',
      type: {
        name: 'Composite',
        className: 'ServiceInputOutputSpecification',
        modelProperties: {
          title: {
            required: false,
            serializedName: 'title',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            defaultValue: 'object',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: true,
            serializedName: 'properties',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'TableSpecificationElementType',
                  type: {
                    name: 'Composite',
                    className: 'TableSpecification'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ServiceInputOutputSpecification;
