/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Web Service Parameter object for node and global parameter
 *
 */
class WebServiceParameter {
  /**
   * Create a WebServiceParameter.
   * @member {object} [value] The parameter value
   * @member {string} [certificateThumbprint] If the parameter value in 'value'
   * field is encrypted, the thumbprint of the certificate should be put here.
   */
  constructor() {
  }

  /**
   * Defines the metadata of WebServiceParameter
   *
   * @returns {object} metadata of WebServiceParameter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'WebServiceParameter',
      type: {
        name: 'Composite',
        className: 'WebServiceParameter',
        modelProperties: {
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'Object'
            }
          },
          certificateThumbprint: {
            required: false,
            serializedName: 'certificateThumbprint',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = WebServiceParameter;
