/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * AppInsights credentials.
 *
 */
class AppInsightsCredentials {
  /**
   * Create a AppInsightsCredentials.
   * @member {string} [appId] The AppInsights application ID.
   * @member {string} [instrumentationKey] The AppInsights instrumentation key.
   * This is not returned in response of GET/PUT on the resource. To see this
   * please call listKeys API.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AppInsightsCredentials
   *
   * @returns {object} metadata of AppInsightsCredentials
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AppInsightsCredentials',
      type: {
        name: 'Composite',
        className: 'AppInsightsCredentials',
        modelProperties: {
          appId: {
            required: false,
            serializedName: 'appId',
            type: {
              name: 'String'
            }
          },
          instrumentationKey: {
            required: false,
            serializedName: 'instrumentationKey',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AppInsightsCredentials;
