/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Information about the Azure Container Registry which contains the images
 * deployed to the cluster.
 *
 */
class ContainerRegistryCredentials {
  /**
   * Create a ContainerRegistryCredentials.
   * @member {string} [loginServer] The ACR login server name. User name is the
   * first part of the FQDN.
   * @member {string} [password] The ACR primary password.
   * @member {string} [password2] The ACR secondary password.
   * @member {string} [username] The ACR login username.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ContainerRegistryCredentials
   *
   * @returns {object} metadata of ContainerRegistryCredentials
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContainerRegistryCredentials',
      type: {
        name: 'Composite',
        className: 'ContainerRegistryCredentials',
        modelProperties: {
          loginServer: {
            required: false,
            readOnly: true,
            serializedName: 'loginServer',
            type: {
              name: 'String'
            }
          },
          password: {
            required: false,
            readOnly: true,
            serializedName: 'password',
            type: {
              name: 'String'
            }
          },
          password2: {
            required: false,
            readOnly: true,
            serializedName: 'password2',
            type: {
              name: 'String'
            }
          },
          username: {
            required: false,
            readOnly: true,
            serializedName: 'username',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ContainerRegistryCredentials;
