/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Information about the Azure Container Registry which contains the images
 * deployed to the cluster.
 *
 */
class ContainerServiceCredentials {
  /**
   * Create a ContainerServiceCredentials.
   * @member {string} [acsKubeConfig] The ACS kube config file.
   * @member {object} [servicePrincipalConfiguration] Service principal
   * configuration used by Kubernetes.
   * @member {string} [servicePrincipalConfiguration.clientId] The service
   * principal client ID
   * @member {string} [servicePrincipalConfiguration.secret] The service
   * principal secret. This is not returned in response of GET/PUT on the
   * resource. To see this please call listKeys.
   * @member {string} [imagePullSecretName] The ACR image pull secret name
   * which was created in Kubernetes.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ContainerServiceCredentials
   *
   * @returns {object} metadata of ContainerServiceCredentials
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContainerServiceCredentials',
      type: {
        name: 'Composite',
        className: 'ContainerServiceCredentials',
        modelProperties: {
          acsKubeConfig: {
            required: false,
            readOnly: true,
            serializedName: 'acsKubeConfig',
            type: {
              name: 'String'
            }
          },
          servicePrincipalConfiguration: {
            required: false,
            readOnly: true,
            serializedName: 'servicePrincipalConfiguration',
            type: {
              name: 'Composite',
              className: 'ServicePrincipalProperties'
            }
          },
          imagePullSecretName: {
            required: false,
            readOnly: true,
            serializedName: 'imagePullSecretName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ContainerServiceCredentials;
