/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Kubernetes cluster specific properties
 *
 */
class KubernetesClusterProperties {
  /**
   * Create a KubernetesClusterProperties.
   * @member {object} servicePrincipal The Azure Service Principal used by
   * Kubernetes
   * @member {string} [servicePrincipal.clientId] The service principal client
   * ID
   * @member {string} [servicePrincipal.secret] The service principal secret.
   * This is not returned in response of GET/PUT on the resource. To see this
   * please call listKeys.
   */
  constructor() {
  }

  /**
   * Defines the metadata of KubernetesClusterProperties
   *
   * @returns {object} metadata of KubernetesClusterProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Kubernetes',
      type: {
        name: 'Composite',
        className: 'KubernetesClusterProperties',
        modelProperties: {
          servicePrincipal: {
            required: true,
            serializedName: 'servicePrincipal',
            type: {
              name: 'Composite',
              className: 'ServicePrincipalProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = KubernetesClusterProperties;
