/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Parameters for PATCH operation on an operationalization cluster
 *
 */
class OperationalizationClusterUpdateParameters {
  /**
   * Create a OperationalizationClusterUpdateParameters.
   * @member {object} [tags] Gets or sets a list of key value pairs that
   * describe the resource. These tags can be used in viewing and grouping this
   * resource (across resource groups). A maximum of 15 tags can be provided
   * for a resource. Each tag must have a key no greater in length than 128
   * characters and a value no greater in length than 256 characters.
   */
  constructor() {
  }

  /**
   * Defines the metadata of OperationalizationClusterUpdateParameters
   *
   * @returns {object} metadata of OperationalizationClusterUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OperationalizationClusterUpdateParameters',
      type: {
        name: 'Composite',
        className: 'OperationalizationClusterUpdateParameters',
        modelProperties: {
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = OperationalizationClusterUpdateParameters;
