/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Resource operation.
 *
 */
class ResourceOperation {
  /**
   * Create a ResourceOperation.
   * @member {string} [name] Name of this operation.
   * @member {object} [display] Display of the operation.
   * @member {string} [display.provider] The resource provider name.
   * @member {string} [display.resource] The resource name.
   * @member {string} [display.operation] The operation.
   * @member {string} [display.description] The description of the operation.
   * @member {string} [origin] The operation origin.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResourceOperation
   *
   * @returns {object} metadata of ResourceOperation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceOperation',
      type: {
        name: 'Composite',
        className: 'ResourceOperation',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          display: {
            required: false,
            serializedName: 'display',
            type: {
              name: 'Composite',
              className: 'ResourceOperationDisplay'
            }
          },
          origin: {
            required: false,
            serializedName: 'origin',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceOperation;
