/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Display of the operation.
 *
 */
class ResourceOperationDisplay {
  /**
   * Create a ResourceOperationDisplay.
   * @member {string} [provider] The resource provider name.
   * @member {string} [resource] The resource name.
   * @member {string} [operation] The operation.
   * @member {string} [description] The description of the operation.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResourceOperationDisplay
   *
   * @returns {object} metadata of ResourceOperationDisplay
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceOperation_display',
      type: {
        name: 'Composite',
        className: 'ResourceOperationDisplay',
        modelProperties: {
          provider: {
            required: false,
            serializedName: 'provider',
            type: {
              name: 'String'
            }
          },
          resource: {
            required: false,
            serializedName: 'resource',
            type: {
              name: 'String'
            }
          },
          operation: {
            required: false,
            serializedName: 'operation',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceOperationDisplay;
