/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Global service auth configuration properties. These are the data-plane
 * authorization keys and are used if a service doesn't define it's own.
 *
 */
class ServiceAuthConfiguration {
  /**
   * Create a ServiceAuthConfiguration.
   * @member {string} primaryAuthKeyHash The primary auth key hash. This is not
   * returned in response of GET/PUT on the resource.. To see this please call
   * listKeys API.
   * @member {string} secondaryAuthKeyHash The secondary auth key hash. This is
   * not returned in response of GET/PUT on the resource.. To see this please
   * call listKeys API.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ServiceAuthConfiguration
   *
   * @returns {object} metadata of ServiceAuthConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ServiceAuthConfiguration',
      type: {
        name: 'Composite',
        className: 'ServiceAuthConfiguration',
        modelProperties: {
          primaryAuthKeyHash: {
            required: true,
            serializedName: 'primaryAuthKeyHash',
            type: {
              name: 'String'
            }
          },
          secondaryAuthKeyHash: {
            required: true,
            serializedName: 'secondaryAuthKeyHash',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ServiceAuthConfiguration;
