/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The Azure service principal used by Kubernetes for configuring load
 * balancers
 *
 */
class ServicePrincipalProperties {
  /**
   * Create a ServicePrincipalProperties.
   * @member {string} clientId The service principal client ID
   * @member {string} secret The service principal secret. This is not returned
   * in response of GET/PUT on the resource. To see this please call listKeys.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ServicePrincipalProperties
   *
   * @returns {object} metadata of ServicePrincipalProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ServicePrincipalProperties',
      type: {
        name: 'Composite',
        className: 'ServicePrincipalProperties',
        modelProperties: {
          clientId: {
            required: true,
            serializedName: 'clientId',
            type: {
              name: 'String'
            }
          },
          secret: {
            required: true,
            serializedName: 'secret',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ServicePrincipalProperties;
