/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Information about a system service deployed in the cluster
 *
 */
class SystemService {
  /**
   * Create a SystemService.
   * @member {string} systemServiceType The system service type. Possible
   * values include: 'None', 'ScoringFrontEnd', 'BatchFrontEnd'
   * @member {string} [publicIpAddress] The public IP address of the system
   * service
   * @member {string} [version] The state of the system service
   */
  constructor() {
  }

  /**
   * Defines the metadata of SystemService
   *
   * @returns {object} metadata of SystemService
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SystemService',
      type: {
        name: 'Composite',
        className: 'SystemService',
        modelProperties: {
          systemServiceType: {
            required: true,
            serializedName: 'systemServiceType',
            type: {
              name: 'String'
            }
          },
          publicIpAddress: {
            required: false,
            readOnly: true,
            serializedName: 'publicIpAddress',
            type: {
              name: 'String'
            }
          },
          version: {
            required: false,
            readOnly: true,
            serializedName: 'version',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SystemService;
