/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Response of the update system services API
 *
 */
class UpdateSystemServicesResponse {
  /**
   * Create a UpdateSystemServicesResponse.
   * @member {string} [updateStatus] Update status. Possible values include:
   * 'Unknown', 'Updating', 'Creating', 'Deleting', 'Succeeded', 'Failed',
   * 'Canceled'
   * @member {date} [updateStartedOn] The date and time when the last system
   * services update was started.
   * @member {date} [updateCompletedOn] The date and time when the last system
   * services update completed.
   */
  constructor() {
  }

  /**
   * Defines the metadata of UpdateSystemServicesResponse
   *
   * @returns {object} metadata of UpdateSystemServicesResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UpdateSystemServicesResponse',
      type: {
        name: 'Composite',
        className: 'UpdateSystemServicesResponse',
        modelProperties: {
          updateStatus: {
            required: false,
            readOnly: true,
            serializedName: 'updateStatus',
            type: {
              name: 'String'
            }
          },
          updateStartedOn: {
            required: false,
            readOnly: true,
            serializedName: 'updateStartedOn',
            type: {
              name: 'DateTime'
            }
          },
          updateCompletedOn: {
            required: false,
            readOnly: true,
            serializedName: 'updateCompletedOn',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = UpdateSystemServicesResponse;
