/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The request body for CheckNameAvailability API.
 *
 */
class CheckNameAvailabilityInput {
  /**
   * Create a CheckNameAvailabilityInput.
   * @member {string} name The name of the resource. A name must be globally
   * unique.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CheckNameAvailabilityInput
   *
   * @returns {object} metadata of CheckNameAvailabilityInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CheckNameAvailabilityInput',
      type: {
        name: 'Composite',
        className: 'CheckNameAvailabilityInput',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            constraints: {
              MaxLength: 24,
              MinLength: 3,
              Pattern: '^[a-z0-9]{3,24}$'
            },
            type: {
              name: 'String'
            }
          },
          type: {
            required: true,
            isConstant: true,
            serializedName: 'type',
            defaultValue: 'mediaservices',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CheckNameAvailabilityInput;
