/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The AppCollection resource.
 *
 * @extends models['Resource']
 */
class AppCollection extends models['Resource'] {
  /**
   * Create a AppCollection.
   * @member {string} [provisioningState] Mobile Engagement AppCollection
   * Properties. Possible values include: 'Creating', 'Succeeded'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AppCollection
   *
   * @returns {object} metadata of AppCollection
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AppCollection',
      type: {
        name: 'Composite',
        className: 'AppCollection',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          provisioningState: {
            required: false,
            serializedName: 'properties.provisioningState',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AppCollection;
