/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Class representing a CampaignListResult.
 * @extends models['CampaignStateResult']
 */
class CampaignListResult extends models['CampaignStateResult'] {
  /**
   * Create a CampaignListResult.
   * @member {string} [name] Name of the campaign.
   * @member {date} [activatedDate] The date at which the campaign was
   * activated (Not present if not yet activated). The date conforms to the
   * following format: `yyyy-MM-ddTHH:mm:ssZ` as specified by the ISO 8601
   * standard.
   * @member {date} [finishedDate] The date at which the campaign was finished
   * (Not present if not yet finished). The date conforms to the following
   * format: `yyyy-MM-ddTHH:mm:ssZ` as specified by the ISO 8601 standard.
   * @member {date} [startTime] The date at which the campaign should be
   * started if specified. The date conforms to the following format:
   * `yyyy-MM-ddTHH:mm:ssZ` as specified by the ISO 8601 standard. Applicable
   * only to announcements and polls.
   * @member {date} [endTime] The date at which the campaign should be finished
   * if specified. The date conforms to the following format:
   * `yyyy-MM-ddTHH:mm:ssZ` as specified by the ISO 8601 standard. Applicable
   * only to announcements and polls.
   * @member {string} [timezone] The id of the time zone to use for the
   * `startTime` and `endTime` dates. If not provided, the two date attributes
   * are referencing to the device timezone. Applicable only to announcements
   * and polls.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of CampaignListResult
   *
   * @returns {object} metadata of CampaignListResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CampaignListResult',
      type: {
        name: 'Composite',
        className: 'CampaignListResult',
        modelProperties: {
          state: {
            required: false,
            serializedName: 'state',
            type: {
              name: 'String'
            }
          },
          id: {
            required: true,
            serializedName: 'id',
            type: {
              name: 'Number'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          activatedDate: {
            required: false,
            serializedName: 'activatedDate',
            type: {
              name: 'DateTime'
            }
          },
          finishedDate: {
            required: false,
            serializedName: 'finishedDate',
            type: {
              name: 'DateTime'
            }
          },
          startTime: {
            required: false,
            serializedName: 'startTime',
            type: {
              name: 'DateTime'
            }
          },
          endTime: {
            required: false,
            serializedName: 'endTime',
            type: {
              name: 'DateTime'
            }
          },
          timezone: {
            required: false,
            serializedName: 'timezone',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CampaignListResult;
