/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a DateRangeExportTaskParameter.
 */
class DateRangeExportTaskParameter {
  /**
   * Create a DateRangeExportTaskParameter.
   * @member {string} containerUrl
   * @member {string} [description] A description of the export task.
   * @member {date} startDate The RFC3339 full-date of the start of the period
   * for which data is exported.
   * @member {date} endDate The RFC3339 full-date of the end of the period for
   * which data is exported.
   * @member {string} exportFormat The format of the exported data. Possible
   * values include: 'JsonBlob', 'CsvBlob'
   */
  constructor() {
  }

  /**
   * Defines the metadata of DateRangeExportTaskParameter
   *
   * @returns {object} metadata of DateRangeExportTaskParameter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'dateRangeExportTaskParameter',
      type: {
        name: 'Composite',
        className: 'DateRangeExportTaskParameter',
        modelProperties: {
          containerUrl: {
            required: true,
            serializedName: 'containerUrl',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          startDate: {
            required: true,
            serializedName: 'startDate',
            type: {
              name: 'Date'
            }
          },
          endDate: {
            required: true,
            serializedName: 'endDate',
            type: {
              name: 'Date'
            }
          },
          exportFormat: {
            required: true,
            serializedName: 'exportFormat',
            type: {
              name: 'Enum',
              allowedValues: [ 'JsonBlob', 'CsvBlob' ]
            }
          }
        }
      }
    };
  }
}

module.exports = DateRangeExportTaskParameter;
