/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a DeviceLocation.
 */
class DeviceLocation {
  /**
   * Create a DeviceLocation.
   * @member {string} [countrycode] The ISO 3166 two-letter country code.
   * @member {string} [region] An administrative region of the nation, such as
   * a state or province.
   * @member {string} [locality] A locality within the administrative region,
   * such as a town or city.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DeviceLocation
   *
   * @returns {object} metadata of DeviceLocation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DeviceLocation',
      type: {
        name: 'Composite',
        className: 'DeviceLocation',
        modelProperties: {
          countrycode: {
            required: false,
            serializedName: 'countrycode',
            type: {
              name: 'String'
            }
          },
          region: {
            required: false,
            serializedName: 'region',
            type: {
              name: 'String'
            }
          },
          locality: {
            required: false,
            serializedName: 'locality',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DeviceLocation;
