/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Used to target devices based on the device manufacturer.
 *
 * @extends models['Criterion']
 */
class DeviceManufacturerCriterion extends models['Criterion'] {
  /**
   * Create a DeviceManufacturerCriterion.
   * @member {string} [name] The device manufacturer.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of DeviceManufacturerCriterion
   *
   * @returns {object} metadata of DeviceManufacturerCriterion
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'device-manufacturer',
      type: {
        name: 'Composite',
        className: 'DeviceManufacturerCriterion',
        modelProperties: {
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DeviceManufacturerCriterion;
