/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a DeviceMeta.
 */
class DeviceMeta {
  /**
   * Create a DeviceMeta.
   * @member {number} [firstSeen] First time the device used the application in
   * milliseconds since January 1st, 1970 UTC.
   * @member {number} [lastSeen] Last time the device used the application in
   * milliseconds since January 1st, 1970 UTC.
   * @member {number} [lastInfo] Timestamp corresponding to the info object in
   * milliseconds since January 1st, 1970 UTC.
   * @member {number} [lastLocation] Timestamp corresponding to the location
   * object in milliseconds since January 1st, 1970 UTC.
   * @member {boolean} [nativePushEnabled] Boolean indicating if native push
   * notifications (like Android’s GCM or Apple’s APNS) are enabled for the
   * application. This boolean is set to true when the application registers
   * successfully to the native push service, and set to false when the native
   * push service reports to Mobile Engagement that the application can no
   * longer be pushed (which means that it has been uninstalled). This report
   * is performed a few hours after Mobile Engagement has tried to perform a
   * native push to a device on which the application has been uninstalled.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DeviceMeta
   *
   * @returns {object} metadata of DeviceMeta
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DeviceMeta',
      type: {
        name: 'Composite',
        className: 'DeviceMeta',
        modelProperties: {
          firstSeen: {
            required: false,
            serializedName: 'firstSeen',
            type: {
              name: 'Number'
            }
          },
          lastSeen: {
            required: false,
            serializedName: 'lastSeen',
            type: {
              name: 'Number'
            }
          },
          lastInfo: {
            required: false,
            serializedName: 'lastInfo',
            type: {
              name: 'Number'
            }
          },
          lastLocation: {
            required: false,
            serializedName: 'lastLocation',
            type: {
              name: 'Number'
            }
          },
          nativePushEnabled: {
            required: false,
            serializedName: 'nativePushEnabled',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = DeviceMeta;
