/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a DeviceTagsResult.
 */
class DeviceTagsResult {
  /**
   * Create a DeviceTagsResult.
   * @member {array} invalidIds A JSON array containing all identifiers that
   * have been rejected. Please note that if the request parameters are valid
   * but all the specified devices are rejected, the status code is still `200`
   * with a response including all the devices as being rejected.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DeviceTagsResult
   *
   * @returns {object} metadata of DeviceTagsResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DeviceTagsResult',
      type: {
        name: 'Composite',
        className: 'DeviceTagsResult',
        modelProperties: {
          invalidIds: {
            required: true,
            serializedName: 'invalidIds',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = DeviceTagsResult;
