/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Send only to users whose first app use is less than {threshold} days old.
 *
 * @extends models['Filter']
 */
class EngageNewUsersFilter extends models['Filter'] {
  /**
   * Create a EngageNewUsersFilter.
   * @member {number} [threshold] An integer value representing the threshold
   * to apply on this filter.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of EngageNewUsersFilter
   *
   * @returns {object} metadata of EngageNewUsersFilter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'engage-new-users',
      type: {
        name: 'Composite',
        className: 'EngageNewUsersFilter',
        modelProperties: {
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          threshold: {
            required: false,
            serializedName: 'threshold',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = EngageNewUsersFilter;
