/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a FeedbackByCampaignParameter.
 */
class FeedbackByCampaignParameter {
  /**
   * Create a FeedbackByCampaignParameter.
   * @member {string} containerUrl
   * @member {string} [description] A description of the export task.
   * @member {string} campaignType Possible values include: 'Announcement',
   * 'DataPush', 'NativePush', 'Poll'
   * @member {array} campaignIds A list of campaign identifiers.
   * @member {string} exportFormat The format of the exported data. Possible
   * values include: 'JsonBlob', 'CsvBlob'
   */
  constructor() {
  }

  /**
   * Defines the metadata of FeedbackByCampaignParameter
   *
   * @returns {object} metadata of FeedbackByCampaignParameter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'feedbackByCampaignParameter',
      type: {
        name: 'Composite',
        className: 'FeedbackByCampaignParameter',
        modelProperties: {
          containerUrl: {
            required: true,
            serializedName: 'containerUrl',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          campaignType: {
            required: true,
            serializedName: 'campaignType',
            type: {
              name: 'Enum',
              allowedValues: [ 'Announcement', 'DataPush', 'NativePush', 'Poll' ]
            }
          },
          campaignIds: {
            required: true,
            serializedName: 'campaignIds',
            constraints: {
              MinItems: 1
            },
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'NumberElementType',
                  type: {
                    name: 'Number'
                  }
              }
            }
          },
          exportFormat: {
            required: true,
            serializedName: 'exportFormat',
            type: {
              name: 'Enum',
              allowedValues: [ 'JsonBlob', 'CsvBlob' ]
            }
          }
        }
      }
    };
  }
}

module.exports = FeedbackByCampaignParameter;
