/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a FeedbackByDateRangeParameter.
 */
class FeedbackByDateRangeParameter {
  /**
   * Create a FeedbackByDateRangeParameter.
   * @member {string} containerUrl
   * @member {string} [description] A description of the export task.
   * @member {string} campaignType Possible values include: 'Announcement',
   * 'DataPush', 'NativePush', 'Poll'
   * @member {date} campaignWindowStart The RFC3339 date-time start of the
   * period for inclusion of active campaigns.
   * @member {date} campaignWindowEnd The RFC3339 date-time end of the period
   * for inclusion of active campaigns.
   * @member {string} exportFormat The format of the exported data. Possible
   * values include: 'JsonBlob', 'CsvBlob'
   */
  constructor() {
  }

  /**
   * Defines the metadata of FeedbackByDateRangeParameter
   *
   * @returns {object} metadata of FeedbackByDateRangeParameter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'feedbackByDateRangeParameter',
      type: {
        name: 'Composite',
        className: 'FeedbackByDateRangeParameter',
        modelProperties: {
          containerUrl: {
            required: true,
            serializedName: 'containerUrl',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          campaignType: {
            required: true,
            serializedName: 'campaignType',
            type: {
              name: 'Enum',
              allowedValues: [ 'Announcement', 'DataPush', 'NativePush', 'Poll' ]
            }
          },
          campaignWindowStart: {
            required: true,
            serializedName: 'campaignWindowStart',
            type: {
              name: 'DateTime'
            }
          },
          campaignWindowEnd: {
            required: true,
            serializedName: 'campaignWindowEnd',
            type: {
              name: 'DateTime'
            }
          },
          exportFormat: {
            required: true,
            serializedName: 'exportFormat',
            type: {
              name: 'Enum',
              allowedValues: [ 'JsonBlob', 'CsvBlob' ]
            }
          }
        }
      }
    };
  }
}

module.exports = FeedbackByDateRangeParameter;
