/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Used to target devices based on their firmware version.
 *
 * @extends models['Criterion']
 */
class FirmwareVersionCriterion extends models['Criterion'] {
  /**
   * Create a FirmwareVersionCriterion.
   * @member {string} [name] Firmware version.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of FirmwareVersionCriterion
   *
   * @returns {object} metadata of FirmwareVersionCriterion
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'firmware-version',
      type: {
        name: 'Composite',
        className: 'FirmwareVersionCriterion',
        modelProperties: {
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = FirmwareVersionCriterion;
