/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Used to target devices who received a poll.
 *
 * @extends models['Criterion']
 */
class PollFeedbackCriterion extends models['Criterion'] {
  /**
   * Create a PollFeedbackCriterion.
   * @member {number} [contentId] The unique identifier of the poll.
   * @member {string} [action] Action that was performed on the poll. Possible
   * values include: 'pushed', 'replied', 'actioned', 'exited'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of PollFeedbackCriterion
   *
   * @returns {object} metadata of PollFeedbackCriterion
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'poll-feedback',
      type: {
        name: 'Composite',
        className: 'PollFeedbackCriterion',
        modelProperties: {
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          contentId: {
            required: false,
            serializedName: 'content-id',
            type: {
              name: 'Number'
            }
          },
          action: {
            required: false,
            serializedName: 'action',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = PollFeedbackCriterion;
