/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Target devices based on a string tag value.
 *
 * @extends models['Criterion']
 */
class StringTagCriterion extends models['Criterion'] {
  /**
   * Create a StringTagCriterion.
   * @member {string} [name] The name of the custom tag.
   * @member {string} [value] A custom string to match for tag value (? and *
   * characters can be used to perform wildcard matching).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of StringTagCriterion
   *
   * @returns {object} metadata of StringTagCriterion
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'string-tag',
      type: {
        name: 'Composite',
        className: 'StringTagCriterion',
        modelProperties: {
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = StringTagCriterion;
