/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * An Activity Log alert condition that is met when all its member conditions
 * are met.
 *
 */
class ActivityLogAlertAllOfCondition {
  /**
   * Create a ActivityLogAlertAllOfCondition.
   * @member {array} allOf The list of activity log alert conditions.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ActivityLogAlertAllOfCondition
   *
   * @returns {object} metadata of ActivityLogAlertAllOfCondition
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ActivityLogAlertAllOfCondition',
      type: {
        name: 'Composite',
        className: 'ActivityLogAlertAllOfCondition',
        modelProperties: {
          allOf: {
            required: true,
            serializedName: 'allOf',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ActivityLogAlertLeafConditionElementType',
                  type: {
                    name: 'Composite',
                    className: 'ActivityLogAlertLeafCondition'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ActivityLogAlertAllOfCondition;
