/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An Activity Log alert condition that is met by comparing an activity log
 * field and value.
 *
 */
class ActivityLogAlertLeafCondition {
  /**
   * Create a ActivityLogAlertLeafCondition.
   * @member {string} field The name of the field that this condition will
   * examine. The possible values for this field are (case-insensitive):
   * 'resourceId', 'category', 'caller', 'level', 'operationName',
   * 'resourceGroup', 'resourceProvider', 'status', 'subStatus',
   * 'resourceType', or anything beginning with 'properties.'.
   * @member {string} equals The field value will be compared to this value
   * (case-insensitive) to determine if the condition is met.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ActivityLogAlertLeafCondition
   *
   * @returns {object} metadata of ActivityLogAlertLeafCondition
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ActivityLogAlertLeafCondition',
      type: {
        name: 'Composite',
        className: 'ActivityLogAlertLeafCondition',
        modelProperties: {
          field: {
            required: true,
            serializedName: 'field',
            type: {
              name: 'String'
            }
          },
          equals: {
            required: true,
            serializedName: 'equals',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ActivityLogAlertLeafCondition;
