/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Specifies the action to post to service when the rule condition is
 * evaluated. The discriminator is always RuleWebhookAction in this case.
 *
 * @extends models['RuleAction']
 */
class RuleWebhookAction extends models['RuleAction'] {
  /**
   * Create a RuleWebhookAction.
   * @member {string} [serviceUri] the service uri to Post the notification
   * when the alert activates or resolves.
   * @member {object} [properties] the dictionary of custom properties to
   * include with the post operation. These data are appended to the webhook
   * payload.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of RuleWebhookAction
   *
   * @returns {object} metadata of RuleWebhookAction
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Microsoft.Azure.Management.Insights.Models.RuleWebhookAction',
      type: {
        name: 'Composite',
        className: 'RuleWebhookAction',
        modelProperties: {
          odatatype: {
            required: true,
            serializedName: 'odata\\.type',
            type: {
              name: 'String'
            }
          },
          serviceUri: {
            required: false,
            serializedName: 'serviceUri',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = RuleWebhookAction;
