/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Webhook notification of an autoscale event.
 *
 */
class WebhookNotification {
  /**
   * Create a WebhookNotification.
   * @member {string} [serviceUri] the service address to receive the
   * notification.
   * @member {object} [properties] a property bag of settings. This value can
   * be empty.
   */
  constructor() {
  }

  /**
   * Defines the metadata of WebhookNotification
   *
   * @returns {object} metadata of WebhookNotification
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'WebhookNotification',
      type: {
        name: 'Composite',
        className: 'WebhookNotification',
        modelProperties: {
          serviceUri: {
            required: false,
            serializedName: 'serviceUri',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = WebhookNotification;
