/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Performance tier properties
 *
 */
class PerformanceTierProperties {
  /**
   * Create a PerformanceTierProperties.
   * @member {string} [id] ID of the performance tier.
   * @member {number} [backupRetentionDays] Backup retention in days for the
   * performance tier edition
   * @member {array} [serviceLevelObjectives] Service level objectives
   * associated with the performance tier
   */
  constructor() {
  }

  /**
   * Defines the metadata of PerformanceTierProperties
   *
   * @returns {object} metadata of PerformanceTierProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PerformanceTierProperties',
      type: {
        name: 'Composite',
        className: 'PerformanceTierProperties',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          backupRetentionDays: {
            required: false,
            serializedName: 'backupRetentionDays',
            type: {
              name: 'Number'
            }
          },
          serviceLevelObjectives: {
            required: false,
            serializedName: 'serviceLevelObjectives',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'PerformanceTierServiceLevelObjectivesElementType',
                  type: {
                    name: 'Composite',
                    className: 'PerformanceTierServiceLevelObjectives'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = PerformanceTierProperties;
