/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Frontend port of an application gateway.
 *
 * @extends models['SubResource']
 */
class ApplicationGatewayFrontendPort extends models['SubResource'] {
  /**
   * Create a ApplicationGatewayFrontendPort.
   * @member {number} [port] Frontend port
   * @member {string} [provisioningState] Provisioning state of the frontend
   * port resource. Possible values are: 'Updating', 'Deleting', and 'Failed'.
   * @member {string} [name] Name of the resource that is unique within a
   * resource group. This name can be used to access the resource.
   * @member {string} [etag] A unique read-only string that changes whenever
   * the resource is updated.
   * @member {string} [type] Type of the resource.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ApplicationGatewayFrontendPort
   *
   * @returns {object} metadata of ApplicationGatewayFrontendPort
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplicationGatewayFrontendPort',
      type: {
        name: 'Composite',
        className: 'ApplicationGatewayFrontendPort',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          port: {
            required: false,
            serializedName: 'properties.port',
            type: {
              name: 'Number'
            }
          },
          provisioningState: {
            required: false,
            serializedName: 'properties.provisioningState',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          etag: {
            required: false,
            serializedName: 'etag',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ApplicationGatewayFrontendPort;
