/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * State details.
 *
 */
class AvailableProvidersListState {
  /**
   * Create a AvailableProvidersListState.
   * @member {string} [stateName] The state name.
   * @member {array} [providers] A list of Internet service providers.
   * @member {array} [cities] List of available cities or towns in the state.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AvailableProvidersListState
   *
   * @returns {object} metadata of AvailableProvidersListState
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AvailableProvidersListState',
      type: {
        name: 'Composite',
        className: 'AvailableProvidersListState',
        modelProperties: {
          stateName: {
            required: false,
            serializedName: 'stateName',
            type: {
              name: 'String'
            }
          },
          providers: {
            required: false,
            serializedName: 'providers',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          cities: {
            required: false,
            serializedName: 'cities',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'AvailableProvidersListCityElementType',
                  type: {
                    name: 'Composite',
                    className: 'AvailableProvidersListCity'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = AvailableProvidersListState;
