/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Status of packet capture session.
 *
 */
class PacketCaptureQueryStatusResult {
  /**
   * Create a PacketCaptureQueryStatusResult.
   * @member {string} [name] The name of the packet capture resource.
   * @member {string} [id] The ID of the packet capture resource.
   * @member {date} [captureStartTime] The start time of the packet capture
   * session.
   * @member {string} [packetCaptureStatus] The status of the packet capture
   * session. Possible values include: 'NotStarted', 'Running', 'Stopped',
   * 'Error', 'Unknown'
   * @member {string} [stopReason] The reason the current packet capture
   * session was stopped.
   * @member {array} [packetCaptureError] List of errors of packet capture
   * session.
   */
  constructor() {
  }

  /**
   * Defines the metadata of PacketCaptureQueryStatusResult
   *
   * @returns {object} metadata of PacketCaptureQueryStatusResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PacketCaptureQueryStatusResult',
      type: {
        name: 'Composite',
        className: 'PacketCaptureQueryStatusResult',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          captureStartTime: {
            required: false,
            serializedName: 'captureStartTime',
            type: {
              name: 'DateTime'
            }
          },
          packetCaptureStatus: {
            required: false,
            serializedName: 'packetCaptureStatus',
            type: {
              name: 'String'
            }
          },
          stopReason: {
            required: false,
            serializedName: 'stopReason',
            type: {
              name: 'String'
            }
          },
          packetCaptureError: {
            required: false,
            serializedName: 'packetCaptureError',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = PacketCaptureQueryStatusResult;
