/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Topology of the specified resource group.
 *
 */
class Topology {
  /**
   * Create a Topology.
   * @member {string} [id] GUID representing the operation id.
   * @member {date} [createdDateTime] The datetime when the topology was
   * initially created for the resource group.
   * @member {date} [lastModified] The datetime when the topology was last
   * modified.
   * @member {array} [resources]
   */
  constructor() {
  }

  /**
   * Defines the metadata of Topology
   *
   * @returns {object} metadata of Topology
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Topology',
      type: {
        name: 'Composite',
        className: 'Topology',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          createdDateTime: {
            required: false,
            readOnly: true,
            serializedName: 'createdDateTime',
            type: {
              name: 'DateTime'
            }
          },
          lastModified: {
            required: false,
            readOnly: true,
            serializedName: 'lastModified',
            type: {
              name: 'DateTime'
            }
          },
          resources: {
            required: false,
            serializedName: 'resources',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'TopologyResourceElementType',
                  type: {
                    name: 'Composite',
                    className: 'TopologyResource'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = Topology;
