/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Description of a NotificationHub AdmCredential.
 *
 */
class AdmCredential {
  /**
   * Create a AdmCredential.
   * @member {string} [clientId] The client identifier.
   * @member {string} [clientSecret] The credential secret access key.
   * @member {string} [authTokenUrl] The URL of the authorization token.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AdmCredential
   *
   * @returns {object} metadata of AdmCredential
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AdmCredential',
      type: {
        name: 'Composite',
        className: 'AdmCredential',
        modelProperties: {
          clientId: {
            required: false,
            serializedName: 'properties.clientId',
            type: {
              name: 'String'
            }
          },
          clientSecret: {
            required: false,
            serializedName: 'properties.clientSecret',
            type: {
              name: 'String'
            }
          },
          authTokenUrl: {
            required: false,
            serializedName: 'properties.authTokenUrl',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AdmCredential;
