/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Description of a NotificationHub MpnsCredential.
 *
 */
class MpnsCredential {
  /**
   * Create a MpnsCredential.
   * @member {string} [mpnsCertificate] The MPNS certificate.
   * @member {string} [certificateKey] The certificate key for this credential.
   * @member {string} [thumbprint] The Mpns certificate Thumbprint
   */
  constructor() {
  }

  /**
   * Defines the metadata of MpnsCredential
   *
   * @returns {object} metadata of MpnsCredential
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MpnsCredential',
      type: {
        name: 'Composite',
        className: 'MpnsCredential',
        modelProperties: {
          mpnsCertificate: {
            required: false,
            serializedName: 'properties.mpnsCertificate',
            type: {
              name: 'String'
            }
          },
          certificateKey: {
            required: false,
            serializedName: 'properties.certificateKey',
            type: {
              name: 'String'
            }
          },
          thumbprint: {
            required: false,
            serializedName: 'properties.thumbprint',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = MpnsCredential;
