/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Parameters supplied to the Patch Namespace operation.
 *
 */
class NamespacePatchParameters {
  /**
   * Create a NamespacePatchParameters.
   * @member {object} [tags] Resource tags
   * @member {object} [sku] The sku of the created namespace
   * @member {string} [sku.name] Name of the notification hub sku. Possible
   * values include: 'Free', 'Basic', 'Standard'
   * @member {string} [sku.tier] The tier of particular sku
   * @member {string} [sku.size] The Sku size
   * @member {string} [sku.family] The Sku Family
   * @member {number} [sku.capacity] The capacity of the resource
   */
  constructor() {
  }

  /**
   * Defines the metadata of NamespacePatchParameters
   *
   * @returns {object} metadata of NamespacePatchParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NamespacePatchParameters',
      type: {
        name: 'Composite',
        className: 'NamespacePatchParameters',
        modelProperties: {
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          sku: {
            required: false,
            serializedName: 'sku',
            type: {
              name: 'Composite',
              className: 'Sku'
            }
          }
        }
      }
    };
  }
}

module.exports = NamespacePatchParameters;
