/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Parameters supplied to the CreateOrUpdate Namespace AuthorizationRules.
 *
 * @extends models['Resource']
 */
class SharedAccessAuthorizationRuleCreateOrUpdateParameters extends models['Resource'] {
  /**
   * Create a SharedAccessAuthorizationRuleCreateOrUpdateParameters.
   * @member {object} properties Properties of the Namespace
   * AuthorizationRules.
   * @member {array} [properties.rights] The rights associated with the rule.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SharedAccessAuthorizationRuleCreateOrUpdateParameters
   *
   * @returns {object} metadata of SharedAccessAuthorizationRuleCreateOrUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SharedAccessAuthorizationRuleCreateOrUpdateParameters',
      type: {
        name: 'Composite',
        className: 'SharedAccessAuthorizationRuleCreateOrUpdateParameters',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          sku: {
            required: false,
            serializedName: 'sku',
            type: {
              name: 'Composite',
              className: 'Sku'
            }
          },
          properties: {
            required: true,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'SharedAccessAuthorizationRuleProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = SharedAccessAuthorizationRuleCreateOrUpdateParameters;
