/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Description of a NotificationHub WnsCredential.
 *
 */
class WnsCredential {
  /**
   * Create a WnsCredential.
   * @member {string} [packageSid] The package ID for this credential.
   * @member {string} [secretKey] The secret key.
   * @member {string} [windowsLiveEndpoint] The Windows Live endpoint.
   */
  constructor() {
  }

  /**
   * Defines the metadata of WnsCredential
   *
   * @returns {object} metadata of WnsCredential
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'WnsCredential',
      type: {
        name: 'Composite',
        className: 'WnsCredential',
        modelProperties: {
          packageSid: {
            required: false,
            serializedName: 'properties.packageSid',
            type: {
              name: 'String'
            }
          },
          secretKey: {
            required: false,
            serializedName: 'properties.secretKey',
            type: {
              name: 'String'
            }
          },
          windowsLiveEndpoint: {
            required: false,
            serializedName: 'properties.windowsLiveEndpoint',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = WnsCredential;
