/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Metadata for a workspace that isn't linked to an Azure subscription.
 *
 */
class LinkTarget {
  /**
   * Create a LinkTarget.
   * @member {string} [customerId] The GUID that uniquely identifies the
   * workspace.
   * @member {string} [displayName] The display name of the workspace.
   * @member {string} [workspaceName] The DNS valid workspace name.
   * @member {string} [location] The location of the workspace.
   */
  constructor() {
  }

  /**
   * Defines the metadata of LinkTarget
   *
   * @returns {object} metadata of LinkTarget
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LinkTarget',
      type: {
        name: 'Composite',
        className: 'LinkTarget',
        modelProperties: {
          customerId: {
            required: false,
            serializedName: 'customerId',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            serializedName: 'accountName',
            type: {
              name: 'String'
            }
          },
          workspaceName: {
            required: false,
            serializedName: 'workspaceName',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = LinkTarget;
