/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Parameters specifying the search query and range.
 *
 */
class SearchParameters {
  /**
   * Create a SearchParameters.
   * @member {number} [top] The number to get from the top.
   * @member {object} [highlight] The highlight that looks for all occurences
   * of a string.
   * @member {string} [highlight.pre] The string that is put before a matched
   * result.
   * @member {string} [highlight.post] The string that is put after a matched
   * result.
   * @member {string} query The query to search.
   * @member {date} [start] The start date filter, so the only query results
   * returned are after this date.
   * @member {date} [end] The end date filter, so the only query results
   * returned are before this date.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SearchParameters
   *
   * @returns {object} metadata of SearchParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SearchParameters',
      type: {
        name: 'Composite',
        className: 'SearchParameters',
        modelProperties: {
          top: {
            required: false,
            serializedName: 'top',
            type: {
              name: 'Number'
            }
          },
          highlight: {
            required: false,
            serializedName: 'highlight',
            type: {
              name: 'Composite',
              className: 'SearchHighlight'
            }
          },
          query: {
            required: true,
            serializedName: 'query',
            type: {
              name: 'String'
            }
          },
          start: {
            required: false,
            serializedName: 'start',
            type: {
              name: 'DateTime'
            }
          },
          end: {
            required: false,
            serializedName: 'end',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = SearchParameters;
