/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Plan for solution object supported by the OperationsManagement resource
 * provider.
 *
 */
class SolutionPlan {
  /**
   * Create a SolutionPlan.
   * @member {string} [name] name of the solution to be created. For Microsoft
   * published solution it should be in the format of
   * solutionType(workspaceName). SolutionType part is case sensitive. For
   * third party solution, it can be anything.
   * @member {string} [publisher] Publisher name. For gallery solution, it is
   * Microsoft.
   * @member {string} [promotionCode] promotionCode, Not really used now, can
   * you left as empty
   * @member {string} [product] name of the solution to enabled/add. For
   * Microsoft published gallery solution it should be in the format of
   * OMSGallery/<solutionType>. This is case sensitive
   */
  constructor() {
  }

  /**
   * Defines the metadata of SolutionPlan
   *
   * @returns {object} metadata of SolutionPlan
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SolutionPlan',
      type: {
        name: 'Composite',
        className: 'SolutionPlan',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          publisher: {
            required: false,
            serializedName: 'publisher',
            type: {
              name: 'String'
            }
          },
          promotionCode: {
            required: false,
            serializedName: 'promotionCode',
            type: {
              name: 'String'
            }
          },
          product: {
            required: false,
            serializedName: 'product',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SolutionPlan;
