/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A2A provider specific input for failover.
 *
 * @extends models['ProviderSpecificFailoverInput']
 */
class A2AFailoverProviderInput extends models['ProviderSpecificFailoverInput'] {
  /**
   * Create a A2AFailoverProviderInput.
   * @member {string} [recoveryPointId] The recovery point id to be passed to
   * failover to a particular recovery point. In case of latest recovery point,
   * null should be passed.
   * @member {string} [cloudServiceCreationOption] A value indicating whether
   * to use recovery cloud service for TFO or not.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of A2AFailoverProviderInput
   *
   * @returns {object} metadata of A2AFailoverProviderInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'A2A',
      type: {
        name: 'Composite',
        className: 'A2AFailoverProviderInput',
        modelProperties: {
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            type: {
              name: 'String'
            }
          },
          recoveryPointId: {
            required: false,
            serializedName: 'recoveryPointId',
            type: {
              name: 'String'
            }
          },
          cloudServiceCreationOption: {
            required: false,
            serializedName: 'cloudServiceCreationOption',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = A2AFailoverProviderInput;
