/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * InMage Azure V2 input to update replication protected item.
 *
 * @extends models['UpdateReplicationProtectedItemProviderInput']
 */
class A2AUpdateReplicationProtectedItemInput extends models['UpdateReplicationProtectedItemProviderInput'] {
  /**
   * Create a A2AUpdateReplicationProtectedItemInput.
   * @member {string} [recoveryCloudServiceId] The target cloud service ARM Id
   * (for V1).
   * @member {string} [recoveryResourceGroupId] The target resource group ARM
   * Id (for V2).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of A2AUpdateReplicationProtectedItemInput
   *
   * @returns {object} metadata of A2AUpdateReplicationProtectedItemInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'A2A',
      type: {
        name: 'Composite',
        className: 'A2AUpdateReplicationProtectedItemInput',
        modelProperties: {
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            type: {
              name: 'String'
            }
          },
          recoveryCloudServiceId: {
            required: false,
            serializedName: 'recoveryCloudServiceId',
            type: {
              name: 'String'
            }
          },
          recoveryResourceGroupId: {
            required: false,
            serializedName: 'recoveryResourceGroupId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = A2AUpdateReplicationProtectedItemInput;
