/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Service based exception details.
 *
 */
class ARMExceptionDetails {
  /**
   * Create a ARMExceptionDetails.
   * @member {string} [code] Gets service error code.
   * @member {string} [message] Gets error message.
   * @member {string} [possibleCauses] Gets possible cause for error.
   * @member {string} [recommendedAction] Gets recommended action for the
   * error.
   * @member {string} [clientRequestId] Gets the client request Id for the
   * session.
   * @member {string} [activityId] Gets the activity Id for the session.
   * @member {string} [target] Gets exception target.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ARMExceptionDetails
   *
   * @returns {object} metadata of ARMExceptionDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ARMExceptionDetails',
      type: {
        name: 'Composite',
        className: 'ARMExceptionDetails',
        modelProperties: {
          code: {
            required: false,
            serializedName: 'code',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          },
          possibleCauses: {
            required: false,
            serializedName: 'possibleCauses',
            type: {
              name: 'String'
            }
          },
          recommendedAction: {
            required: false,
            serializedName: 'recommendedAction',
            type: {
              name: 'String'
            }
          },
          clientRequestId: {
            required: false,
            serializedName: 'clientRequestId',
            type: {
              name: 'String'
            }
          },
          activityId: {
            required: false,
            serializedName: 'activityId',
            type: {
              name: 'String'
            }
          },
          target: {
            required: false,
            serializedName: 'target',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ARMExceptionDetails;
