/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Azure Fabric Specific Details.
 *
 * @extends models['FabricSpecificDetails']
 */
class AzureFabricSpecificDetails extends models['FabricSpecificDetails'] {
  /**
   * Create a AzureFabricSpecificDetails.
   * @member {string} [location] The Location for the Azure fabric.
   * @member {array} [containerIds] The container Ids for the Azure fabric.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureFabricSpecificDetails
   *
   * @returns {object} metadata of AzureFabricSpecificDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Azure',
      type: {
        name: 'Composite',
        className: 'AzureFabricSpecificDetails',
        modelProperties: {
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          containerIds: {
            required: false,
            serializedName: 'containerIds',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = AzureFabricSpecificDetails;
