/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A2A Network Mapping fabric specific settings.
 *
 * @extends models['NetworkMappingFabricSpecificSettings']
 */
class AzureToAzureNetworkMappingSettings extends models['NetworkMappingFabricSpecificSettings'] {
  /**
   * Create a AzureToAzureNetworkMappingSettings.
   * @member {string} [primaryFabricLocation] The primary fabric location.
   * @member {string} [recoveryFabricLocation] The recovery fabric location.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureToAzureNetworkMappingSettings
   *
   * @returns {object} metadata of AzureToAzureNetworkMappingSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureToAzure',
      type: {
        name: 'Composite',
        className: 'AzureToAzureNetworkMappingSettings',
        modelProperties: {
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            type: {
              name: 'String'
            }
          },
          primaryFabricLocation: {
            required: false,
            serializedName: 'primaryFabricLocation',
            type: {
              name: 'String'
            }
          },
          recoveryFabricLocation: {
            required: false,
            serializedName: 'recoveryFabricLocation',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureToAzureNetworkMappingSettings;
