/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Azure to Azure VM synced configuration details.
 *
 */
class AzureToAzureVmSyncedConfigDetails {
  /**
   * Create a AzureToAzureVmSyncedConfigDetails.
   * @member {object} [tags] The Azure VM tags.
   * @member {array} [roleAssignments] The Azure role assignments.
   * @member {array} [inputEndpoints] The Azure VM input endpoints.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureToAzureVmSyncedConfigDetails
   *
   * @returns {object} metadata of AzureToAzureVmSyncedConfigDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureToAzureVmSyncedConfigDetails',
      type: {
        name: 'Composite',
        className: 'AzureToAzureVmSyncedConfigDetails',
        modelProperties: {
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          roleAssignments: {
            required: false,
            serializedName: 'roleAssignments',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'RoleAssignmentElementType',
                  type: {
                    name: 'Composite',
                    className: 'RoleAssignment'
                  }
              }
            }
          },
          inputEndpoints: {
            required: false,
            serializedName: 'inputEndpoints',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'InputEndpointElementType',
                  type: {
                    name: 'Composite',
                    className: 'InputEndpoint'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = AzureToAzureVmSyncedConfigDetails;
