/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Disk details for E2A provider.
 *
 */
class AzureVmDiskDetails {
  /**
   * Create a AzureVmDiskDetails.
   * @member {string} [vhdType] VHD type.
   * @member {string} [vhdId] The VHD id.
   * @member {string} [vhdName] VHD name.
   * @member {string} [maxSizeMB] Max side in MB.
   * @member {string} [targetDiskLocation] Blob uri of the Azure disk.
   * @member {string} [targetDiskName] The target Azure disk name.
   * @member {string} [lunId] Ordinal\LunId of the disk for the Azure VM.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureVmDiskDetails
   *
   * @returns {object} metadata of AzureVmDiskDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureVmDiskDetails',
      type: {
        name: 'Composite',
        className: 'AzureVmDiskDetails',
        modelProperties: {
          vhdType: {
            required: false,
            serializedName: 'vhdType',
            type: {
              name: 'String'
            }
          },
          vhdId: {
            required: false,
            serializedName: 'vhdId',
            type: {
              name: 'String'
            }
          },
          vhdName: {
            required: false,
            serializedName: 'vhdName',
            type: {
              name: 'String'
            }
          },
          maxSizeMB: {
            required: false,
            serializedName: 'maxSizeMB',
            type: {
              name: 'String'
            }
          },
          targetDiskLocation: {
            required: false,
            serializedName: 'targetDiskLocation',
            type: {
              name: 'String'
            }
          },
          targetDiskName: {
            required: false,
            serializedName: 'targetDiskName',
            type: {
              name: 'String'
            }
          },
          lunId: {
            required: false,
            serializedName: 'lunId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureVmDiskDetails;
