/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Create network mappings input.
 *
 */
class CreateNetworkMappingInput {
  /**
   * Create a CreateNetworkMappingInput.
   * @member {object} [properties] Input properties for creating network
   * mapping.
   * @member {string} [properties.recoveryFabricName] Recovery fabric Name.
   * @member {string} [properties.recoveryNetworkId] Recovery network Id.
   * @member {object} [properties.fabricSpecificDetails] Fabric specific input
   * properties.
   * @member {string} [properties.fabricSpecificDetails.instanceType]
   * Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of CreateNetworkMappingInput
   *
   * @returns {object} metadata of CreateNetworkMappingInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CreateNetworkMappingInput',
      type: {
        name: 'Composite',
        className: 'CreateNetworkMappingInput',
        modelProperties: {
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'CreateNetworkMappingInputProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = CreateNetworkMappingInput;
