/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The datastore details of the MT.
 *
 */
class DataStore {
  /**
   * Create a DataStore.
   * @member {string} [symbolicName] The symbolic name of data store.
   * @member {string} [uuid] The uuid of data store.
   * @member {string} [capacity] The capacity of data store in GBs.
   * @member {string} [freeSpace] The free space of data store in GBs.
   * @member {string} [type] The type of data store.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DataStore
   *
   * @returns {object} metadata of DataStore
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DataStore',
      type: {
        name: 'Composite',
        className: 'DataStore',
        modelProperties: {
          symbolicName: {
            required: false,
            serializedName: 'symbolicName',
            type: {
              name: 'String'
            }
          },
          uuid: {
            required: false,
            serializedName: 'uuid',
            type: {
              name: 'String'
            }
          },
          capacity: {
            required: false,
            serializedName: 'capacity',
            type: {
              name: 'String'
            }
          },
          freeSpace: {
            required: false,
            serializedName: 'freeSpace',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DataStore;
