/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Discover protectable item properties.
 *
 */
class DiscoverProtectableItemRequestProperties {
  /**
   * Create a DiscoverProtectableItemRequestProperties.
   * @member {string} [friendlyName] The friendly name of the physical machine.
   * @member {string} [ipAddress] The IP address of the physical machine to be
   * discovered.
   * @member {string} [osType] The OS type on the physical machine.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DiscoverProtectableItemRequestProperties
   *
   * @returns {object} metadata of DiscoverProtectableItemRequestProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DiscoverProtectableItemRequestProperties',
      type: {
        name: 'Composite',
        className: 'DiscoverProtectableItemRequestProperties',
        modelProperties: {
          friendlyName: {
            required: false,
            serializedName: 'friendlyName',
            type: {
              name: 'String'
            }
          },
          ipAddress: {
            required: false,
            serializedName: 'ipAddress',
            type: {
              name: 'String'
            }
          },
          osType: {
            required: false,
            serializedName: 'osType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DiscoverProtectableItemRequestProperties;
