/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Enable protection input properties.
 *
 */
class EnableProtectionInputProperties {
  /**
   * Create a EnableProtectionInputProperties.
   * @member {string} [policyId] The Policy Id.
   * @member {string} [protectableItemId] The protectable item Id.
   * @member {object} [providerSpecificDetails] The ReplicationProviderInput.
   * For HyperVReplicaAzure provider, it will be AzureEnableProtectionInput
   * object. For San provider, it will be SanEnableProtectionInput object. For
   * HyperVReplicaAzure provider, it can be null.
   * @member {string} [providerSpecificDetails.instanceType] Polymorphic
   * Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of EnableProtectionInputProperties
   *
   * @returns {object} metadata of EnableProtectionInputProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EnableProtectionInputProperties',
      type: {
        name: 'Composite',
        className: 'EnableProtectionInputProperties',
        modelProperties: {
          policyId: {
            required: false,
            serializedName: 'policyId',
            type: {
              name: 'String'
            }
          },
          protectableItemId: {
            required: false,
            serializedName: 'protectableItemId',
            type: {
              name: 'String'
            }
          },
          providerSpecificDetails: {
            required: false,
            serializedName: 'providerSpecificDetails',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'instanceType',
                clientName: 'instanceType'
              },
              uberParent: 'EnableProtectionProviderSpecificInput',
              className: 'EnableProtectionProviderSpecificInput'
            }
          }
        }
      }
    };
  }
}

module.exports = EnableProtectionInputProperties;
