/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Encryption details for the fabric.
 *
 */
class EncryptionDetails {
  /**
   * Create a EncryptionDetails.
   * @member {string} [kekState] The key encryption key state for the Vmm.
   * @member {string} [kekCertThumbprint] The key encryption key certificate
   * thumbprint.
   * @member {date} [kekCertExpiryDate] The key encryption key certificate
   * expiry date.
   */
  constructor() {
  }

  /**
   * Defines the metadata of EncryptionDetails
   *
   * @returns {object} metadata of EncryptionDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EncryptionDetails',
      type: {
        name: 'Composite',
        className: 'EncryptionDetails',
        modelProperties: {
          kekState: {
            required: false,
            serializedName: 'kekState',
            type: {
              name: 'String'
            }
          },
          kekCertThumbprint: {
            required: false,
            serializedName: 'kekCertThumbprint',
            type: {
              name: 'String'
            }
          },
          kekCertExpiryDate: {
            required: false,
            serializedName: 'kekCertExpiryDate',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = EncryptionDetails;
