/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * This class represents details for export jobs workflow.
 *
 * @extends models['JobDetails']
 */
class ExportJobDetails extends models['JobDetails'] {
  /**
   * Create a ExportJobDetails.
   * @member {string} [blobUri] BlobUri of the exported jobs.
   * @member {string} [sasToken] The sas token to access blob.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ExportJobDetails
   *
   * @returns {object} metadata of ExportJobDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ExportJobDetails',
      type: {
        name: 'Composite',
        className: 'ExportJobDetails',
        modelProperties: {
          affectedObjectDetails: {
            required: false,
            serializedName: 'affectedObjectDetails',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            type: {
              name: 'String'
            }
          },
          blobUri: {
            required: false,
            serializedName: 'blobUri',
            type: {
              name: 'String'
            }
          },
          sasToken: {
            required: false,
            serializedName: 'sasToken',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ExportJobDetails;
