/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * This class represents the group task details when parent child relationship
 * exists in the drill down.
 *
 */
class GroupTaskDetails {
  /**
   * Create a GroupTaskDetails.
   * @member {array} [childTasks] The child tasks.
   * @member {string} instanceType Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of GroupTaskDetails
   *
   * @returns {object} metadata of GroupTaskDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GroupTaskDetails',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'instanceType',
          clientName: 'instanceType'
        },
        uberParent: 'GroupTaskDetails',
        className: 'GroupTaskDetails',
        modelProperties: {
          childTasks: {
            required: false,
            serializedName: 'childTasks',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ASRTaskElementType',
                  type: {
                    name: 'Composite',
                    className: 'ASRTask'
                  }
              }
            }
          },
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = GroupTaskDetails;
