/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Azure specific reprotect input.
 *
 * @extends models['ReverseReplicationProviderSpecificInput']
 */
class HyperVReplicaAzureReprotectInput extends models['ReverseReplicationProviderSpecificInput'] {
  /**
   * Create a HyperVReplicaAzureReprotectInput.
   * @member {string} [hvHostVmId] The Hyper-V host Vm Id.
   * @member {string} [vmName] The Vm Name.
   * @member {string} [osType] The OS type associated with vm.
   * @member {string} [vHDId] The OS disk VHD id associated with vm.
   * @member {string} [storageAccountId] The storage account name.
   * @member {string} [logStorageAccountId] The storage account to be used for
   * logging during replication.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of HyperVReplicaAzureReprotectInput
   *
   * @returns {object} metadata of HyperVReplicaAzureReprotectInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HyperVReplicaAzure',
      type: {
        name: 'Composite',
        className: 'HyperVReplicaAzureReprotectInput',
        modelProperties: {
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            type: {
              name: 'String'
            }
          },
          hvHostVmId: {
            required: false,
            serializedName: 'hvHostVmId',
            type: {
              name: 'String'
            }
          },
          vmName: {
            required: false,
            serializedName: 'vmName',
            type: {
              name: 'String'
            }
          },
          osType: {
            required: false,
            serializedName: 'osType',
            type: {
              name: 'String'
            }
          },
          vHDId: {
            required: false,
            serializedName: 'vHDId',
            type: {
              name: 'String'
            }
          },
          storageAccountId: {
            required: false,
            serializedName: 'storageAccountId',
            type: {
              name: 'String'
            }
          },
          logStorageAccountId: {
            required: false,
            serializedName: 'logStorageAccountId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = HyperVReplicaAzureReprotectInput;
