/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Model class for event details of a VMwareAzureV2 event.
 *
 * @extends models['EventProviderSpecificDetails']
 */
class InMageAzureV2EventDetails extends models['EventProviderSpecificDetails'] {
  /**
   * Create a InMageAzureV2EventDetails.
   * @member {string} [eventType] InMage Event type. Takes one of the values of
   * {InMageDataContract.InMageMonitoringEventType}.
   * @member {string} [category] InMage Event Category.
   * @member {string} [component] InMage Event Component.
   * @member {string} [correctiveAction] Corrective Action string for the
   * event.
   * @member {string} [details] InMage Event Details.
   * @member {string} [summary] InMage Event Summary.
   * @member {string} [siteName] VMware Site name.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of InMageAzureV2EventDetails
   *
   * @returns {object} metadata of InMageAzureV2EventDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'InMageAzureV2',
      type: {
        name: 'Composite',
        className: 'InMageAzureV2EventDetails',
        modelProperties: {
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            type: {
              name: 'String'
            }
          },
          eventType: {
            required: false,
            serializedName: 'eventType',
            type: {
              name: 'String'
            }
          },
          category: {
            required: false,
            serializedName: 'category',
            type: {
              name: 'String'
            }
          },
          component: {
            required: false,
            serializedName: 'component',
            type: {
              name: 'String'
            }
          },
          correctiveAction: {
            required: false,
            serializedName: 'correctiveAction',
            type: {
              name: 'String'
            }
          },
          details: {
            required: false,
            serializedName: 'details',
            type: {
              name: 'String'
            }
          },
          summary: {
            required: false,
            serializedName: 'summary',
            type: {
              name: 'String'
            }
          },
          siteName: {
            required: false,
            serializedName: 'siteName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = InMageAzureV2EventDetails;
