/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * InMageAzureV2 protected disk details.
 *
 */
class InMageAzureV2ProtectedDiskDetails {
  /**
   * Create a InMageAzureV2ProtectedDiskDetails.
   * @member {string} [diskId] The disk id.
   * @member {string} [diskName] The disk name.
   * @member {string} [protectionStage] The protection stage.
   * @member {string} [healthErrorCode] The health error code for the disk.
   * @member {number} [rpoInSeconds] The RPO in seconds.
   * @member {string} [resyncRequired] A value indicating whether resync is
   * required for this disk.
   * @member {number} [resyncProgressPercentage] The resync progress
   * percentage.
   * @member {number} [resyncDurationInSeconds] The resync duration in seconds.
   * @member {number} [diskCapacityInBytes] The disk capacity in bytes.
   * @member {number} [fileSystemCapacityInBytes] The disk file system capacity
   * in bytes.
   * @member {number} [sourceDataInMegaBytes] The source data transit in MB.
   * @member {number} [psDataInMegaBytes] The PS data transit in MB.
   * @member {number} [targetDataInMegaBytes] The target data transit in MB.
   * @member {string} [diskResized] A value indicating whether disk is resized.
   * @member {date} [lastRpoCalculatedTime] The last RPO calculated time.
   */
  constructor() {
  }

  /**
   * Defines the metadata of InMageAzureV2ProtectedDiskDetails
   *
   * @returns {object} metadata of InMageAzureV2ProtectedDiskDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'InMageAzureV2ProtectedDiskDetails',
      type: {
        name: 'Composite',
        className: 'InMageAzureV2ProtectedDiskDetails',
        modelProperties: {
          diskId: {
            required: false,
            serializedName: 'diskId',
            type: {
              name: 'String'
            }
          },
          diskName: {
            required: false,
            serializedName: 'diskName',
            type: {
              name: 'String'
            }
          },
          protectionStage: {
            required: false,
            serializedName: 'protectionStage',
            type: {
              name: 'String'
            }
          },
          healthErrorCode: {
            required: false,
            serializedName: 'healthErrorCode',
            type: {
              name: 'String'
            }
          },
          rpoInSeconds: {
            required: false,
            serializedName: 'rpoInSeconds',
            type: {
              name: 'Number'
            }
          },
          resyncRequired: {
            required: false,
            serializedName: 'resyncRequired',
            type: {
              name: 'String'
            }
          },
          resyncProgressPercentage: {
            required: false,
            serializedName: 'resyncProgressPercentage',
            type: {
              name: 'Number'
            }
          },
          resyncDurationInSeconds: {
            required: false,
            serializedName: 'resyncDurationInSeconds',
            type: {
              name: 'Number'
            }
          },
          diskCapacityInBytes: {
            required: false,
            serializedName: 'diskCapacityInBytes',
            type: {
              name: 'Number'
            }
          },
          fileSystemCapacityInBytes: {
            required: false,
            serializedName: 'fileSystemCapacityInBytes',
            type: {
              name: 'Number'
            }
          },
          sourceDataInMegaBytes: {
            required: false,
            serializedName: 'sourceDataInMegaBytes',
            type: {
              name: 'Number'
            }
          },
          psDataInMegaBytes: {
            required: false,
            serializedName: 'psDataInMegaBytes',
            type: {
              name: 'Number'
            }
          },
          targetDataInMegaBytes: {
            required: false,
            serializedName: 'targetDataInMegaBytes',
            type: {
              name: 'Number'
            }
          },
          diskResized: {
            required: false,
            serializedName: 'diskResized',
            type: {
              name: 'String'
            }
          },
          lastRpoCalculatedTime: {
            required: false,
            serializedName: 'lastRpoCalculatedTime',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = InMageAzureV2ProtectedDiskDetails;
