/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * InMage Azure V2 provider specific recovery point details.
 *
 * @extends models['ProviderSpecificRecoveryPointDetails']
 */
class InMageAzureV2RecoveryPointDetails extends models['ProviderSpecificRecoveryPointDetails'] {
  /**
   * Create a InMageAzureV2RecoveryPointDetails.
   * @member {string} [instanceType] Gets the instance type.
   * @member {string} [isMultiVmSyncPoint] A value indicating whether the
   * recovery point is multi VM consistent.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of InMageAzureV2RecoveryPointDetails
   *
   * @returns {object} metadata of InMageAzureV2RecoveryPointDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'InMageAzureV2RecoveryPointDetails',
      type: {
        name: 'Composite',
        className: 'InMageAzureV2RecoveryPointDetails',
        modelProperties: {
          type: {
            required: false,
            readOnly: true,
            serializedName: 'Type',
            type: {
              name: 'String'
            }
          },
          instanceType: {
            required: false,
            readOnly: true,
            serializedName: 'instanceType',
            type: {
              name: 'String'
            }
          },
          isMultiVmSyncPoint: {
            required: false,
            serializedName: 'isMultiVmSyncPoint',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = InMageAzureV2RecoveryPointDetails;
