/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * InMage Azure V2 input to update replication protected item.
 *
 * @extends models['UpdateReplicationProtectedItemProviderInput']
 */
class InMageAzureV2UpdateReplicationProtectedItemInput extends models['UpdateReplicationProtectedItemProviderInput'] {
  /**
   * Create a InMageAzureV2UpdateReplicationProtectedItemInput.
   * @member {string} [recoveryAzureV1ResourceGroupId] The recovery Azure
   * resource group Id for classic deployment.
   * @member {string} [recoveryAzureV2ResourceGroupId] The recovery Azure
   * resource group Id for resource manager deployment.
   * @member {string} [useManagedDisks] A value indicating whether managed
   * disks should be used during failover.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of InMageAzureV2UpdateReplicationProtectedItemInput
   *
   * @returns {object} metadata of InMageAzureV2UpdateReplicationProtectedItemInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'InMageAzureV2',
      type: {
        name: 'Composite',
        className: 'InMageAzureV2UpdateReplicationProtectedItemInput',
        modelProperties: {
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            type: {
              name: 'String'
            }
          },
          recoveryAzureV1ResourceGroupId: {
            required: false,
            serializedName: 'recoveryAzureV1ResourceGroupId',
            type: {
              name: 'String'
            }
          },
          recoveryAzureV2ResourceGroupId: {
            required: false,
            serializedName: 'recoveryAzureV2ResourceGroupId',
            type: {
              name: 'String'
            }
          },
          useManagedDisks: {
            required: false,
            serializedName: 'useManagedDisks',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = InMageAzureV2UpdateReplicationProtectedItemInput;
