/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * InMage disable protection provider specific input.
 *
 * @extends models['DisableProtectionProviderSpecificInput']
 */
class InMageDisableProtectionProviderSpecificInput extends models['DisableProtectionProviderSpecificInput'] {
  /**
   * Create a InMageDisableProtectionProviderSpecificInput.
   * @member {string} [replicaVmDeletionStatus] A value indicating whether the
   * replica VM should be destroyed or retained. Values from Delete and Retain.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of InMageDisableProtectionProviderSpecificInput
   *
   * @returns {object} metadata of InMageDisableProtectionProviderSpecificInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'InMage',
      type: {
        name: 'Composite',
        className: 'InMageDisableProtectionProviderSpecificInput',
        modelProperties: {
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            type: {
              name: 'String'
            }
          },
          replicaVmDeletionStatus: {
            required: false,
            serializedName: 'replicaVmDeletionStatus',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = InMageDisableProtectionProviderSpecificInput;
