/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * VMware Azure specific enable protection input.
 *
 * @extends models['EnableProtectionProviderSpecificInput']
 */
class InMageEnableProtectionInput extends models['EnableProtectionProviderSpecificInput'] {
  /**
   * Create a InMageEnableProtectionInput.
   * @member {string} [vmFriendlyName] The Vm Name.
   * @member {string} masterTargetId The Master Target Id.
   * @member {string} processServerId The Process Server Id.
   * @member {string} retentionDrive The retention drive to use on the MT.
   * @member {string} [runAsAccountId] The CS account Id.
   * @member {string} multiVmGroupId The multi vm group Id.
   * @member {string} multiVmGroupName The multi vm group name.
   * @member {string} [datastoreName] The target datastore name.
   * @member {object} [diskExclusionInput] The enable disk exclusion input.
   * @member {array} [diskExclusionInput.volumeOptions] The volume label based
   * option for disk exclusion.
   * @member {array} [diskExclusionInput.diskSignatureOptions] The guest disk
   * signature based option for disk exclusion.
   * @member {array} [disksToInclude] The disks to include list.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of InMageEnableProtectionInput
   *
   * @returns {object} metadata of InMageEnableProtectionInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'InMage',
      type: {
        name: 'Composite',
        className: 'InMageEnableProtectionInput',
        modelProperties: {
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            type: {
              name: 'String'
            }
          },
          vmFriendlyName: {
            required: false,
            serializedName: 'vmFriendlyName',
            type: {
              name: 'String'
            }
          },
          masterTargetId: {
            required: true,
            serializedName: 'masterTargetId',
            type: {
              name: 'String'
            }
          },
          processServerId: {
            required: true,
            serializedName: 'processServerId',
            type: {
              name: 'String'
            }
          },
          retentionDrive: {
            required: true,
            serializedName: 'retentionDrive',
            type: {
              name: 'String'
            }
          },
          runAsAccountId: {
            required: false,
            serializedName: 'runAsAccountId',
            type: {
              name: 'String'
            }
          },
          multiVmGroupId: {
            required: true,
            serializedName: 'multiVmGroupId',
            type: {
              name: 'String'
            }
          },
          multiVmGroupName: {
            required: true,
            serializedName: 'multiVmGroupName',
            type: {
              name: 'String'
            }
          },
          datastoreName: {
            required: false,
            serializedName: 'datastoreName',
            type: {
              name: 'String'
            }
          },
          diskExclusionInput: {
            required: false,
            serializedName: 'diskExclusionInput',
            type: {
              name: 'Composite',
              className: 'InMageDiskExclusionInput'
            }
          },
          disksToInclude: {
            required: false,
            serializedName: 'disksToInclude',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = InMageEnableProtectionInput;
