/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Guest disk signature based disk exclusion option when doing enable
 * protection of virtual machine in InMage provider.
 *
 */
class InMageVolumeExclusionOptions {
  /**
   * Create a InMageVolumeExclusionOptions.
   * @member {string} [volumeLabel] The volume label. The disk having any
   * volume with this label will be excluded from replication.
   * @member {string} [onlyExcludeIfSingleVolume] The value indicating whether
   * to exclude multi volume disk or not. If a disk has multiple volumes and
   * one of the volume has label matching with VolumeLabel this disk will be
   * excluded from replication if OnlyExcludeIfSingleVolume is false.
   */
  constructor() {
  }

  /**
   * Defines the metadata of InMageVolumeExclusionOptions
   *
   * @returns {object} metadata of InMageVolumeExclusionOptions
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'InMageVolumeExclusionOptions',
      type: {
        name: 'Composite',
        className: 'InMageVolumeExclusionOptions',
        modelProperties: {
          volumeLabel: {
            required: false,
            serializedName: 'volumeLabel',
            type: {
              name: 'String'
            }
          },
          onlyExcludeIfSingleVolume: {
            required: false,
            serializedName: 'OnlyExcludeIfSingleVolume',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = InMageVolumeExclusionOptions;
