/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Query parameter to enumerate jobs.
 *
 */
class JobQueryParameter {
  /**
   * Create a JobQueryParameter.
   * @member {string} [startTime] Date time to get jobs from.
   * @member {string} [endTime] Date time to get jobs upto.
   * @member {string} [fabricId] The Id of the fabric to search jobs under.
   * @member {array} [affectedObjectTypes] The type of objects.
   * @member {array} [jobStatus] The states of the job to be filtered can be
   * in.
   */
  constructor() {
  }

  /**
   * Defines the metadata of JobQueryParameter
   *
   * @returns {object} metadata of JobQueryParameter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'JobQueryParameter',
      type: {
        name: 'Composite',
        className: 'JobQueryParameter',
        modelProperties: {
          startTime: {
            required: false,
            serializedName: 'startTime',
            type: {
              name: 'String'
            }
          },
          endTime: {
            required: false,
            serializedName: 'endTime',
            type: {
              name: 'String'
            }
          },
          fabricId: {
            required: false,
            serializedName: 'fabricId',
            type: {
              name: 'String'
            }
          },
          affectedObjectTypes: {
            required: false,
            serializedName: 'affectedObjectTypes',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          jobStatus: {
            required: false,
            serializedName: 'jobStatus',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = JobQueryParameter;
