/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Model class for event details of a job status event.
 *
 * @extends models['EventSpecificDetails']
 */
class JobStatusEventDetails extends models['EventSpecificDetails'] {
  /**
   * Create a JobStatusEventDetails.
   * @member {string} [jobId] Job arm id for the event.
   * @member {string} [jobFriendlyName] JobName for the Event.
   * @member {string} [jobStatus] JobStatus for the Event.
   * @member {string} [affectedObjectType] AffectedObjectType for the event.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of JobStatusEventDetails
   *
   * @returns {object} metadata of JobStatusEventDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'JobStatus',
      type: {
        name: 'Composite',
        className: 'JobStatusEventDetails',
        modelProperties: {
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            type: {
              name: 'String'
            }
          },
          jobId: {
            required: false,
            serializedName: 'jobId',
            type: {
              name: 'String'
            }
          },
          jobFriendlyName: {
            required: false,
            serializedName: 'jobFriendlyName',
            type: {
              name: 'String'
            }
          },
          jobStatus: {
            required: false,
            serializedName: 'jobStatus',
            type: {
              name: 'String'
            }
          },
          affectedObjectType: {
            required: false,
            serializedName: 'affectedObjectType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = JobStatusEventDetails;
