/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Logical network data model.
 *
 * @extends models['Resource']
 */
class LogicalNetwork extends models['Resource'] {
  /**
   * Create a LogicalNetwork.
   * @member {object} [properties] The Logical Network Properties.
   * @member {string} [properties.friendlyName] The Friendly Name.
   * @member {string} [properties.networkVirtualizationStatus] A value
   * indicating whether Network Virtualization is enabled for the logical
   * network.
   * @member {string} [properties.logicalNetworkUsage] A value indicating
   * whether logical network is used as private test network by test failover.
   * @member {string} [properties.logicalNetworkDefinitionsStatus] A value
   * indicating whether logical network definitions are isolated.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of LogicalNetwork
   *
   * @returns {object} metadata of LogicalNetwork
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LogicalNetwork',
      type: {
        name: 'Composite',
        className: 'LogicalNetwork',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'LogicalNetworkProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = LogicalNetwork;
