/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Details of a Master Target Server.
 *
 */
class MasterTargetServer {
  /**
   * Create a MasterTargetServer.
   * @member {string} [id] The server Id.
   * @member {string} [ipAddress] The IP address of the server.
   * @member {string} [name] The server name.
   * @member {string} [osType] The OS type of the server.
   * @member {string} [agentVersion] The version of the scout component on the
   * server.
   * @member {date} [lastHeartbeat] The last heartbeat received from the
   * server.
   * @member {string} [versionStatus] Version status
   * @member {array} [retentionVolumes] The retention volumes of Master target
   * Server.
   * @member {array} [dataStores] The list of data stores in the fabric.
   * @member {array} [validationErrors] Validation errors.
   * @member {number} [diskCount] Disk count of the master target.
   * @member {string} [osVersion] OS Version of the master target.
   */
  constructor() {
  }

  /**
   * Defines the metadata of MasterTargetServer
   *
   * @returns {object} metadata of MasterTargetServer
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MasterTargetServer',
      type: {
        name: 'Composite',
        className: 'MasterTargetServer',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          ipAddress: {
            required: false,
            serializedName: 'ipAddress',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          osType: {
            required: false,
            serializedName: 'osType',
            type: {
              name: 'String'
            }
          },
          agentVersion: {
            required: false,
            serializedName: 'agentVersion',
            type: {
              name: 'String'
            }
          },
          lastHeartbeat: {
            required: false,
            serializedName: 'lastHeartbeat',
            type: {
              name: 'DateTime'
            }
          },
          versionStatus: {
            required: false,
            serializedName: 'versionStatus',
            type: {
              name: 'String'
            }
          },
          retentionVolumes: {
            required: false,
            serializedName: 'retentionVolumes',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'RetentionVolumeElementType',
                  type: {
                    name: 'Composite',
                    className: 'RetentionVolume'
                  }
              }
            }
          },
          dataStores: {
            required: false,
            serializedName: 'dataStores',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'DataStoreElementType',
                  type: {
                    name: 'Composite',
                    className: 'DataStore'
                  }
              }
            }
          },
          validationErrors: {
            required: false,
            serializedName: 'validationErrors',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'HealthErrorElementType',
                  type: {
                    name: 'Composite',
                    className: 'HealthError'
                  }
              }
            }
          },
          diskCount: {
            required: false,
            serializedName: 'diskCount',
            type: {
              name: 'Number'
            }
          },
          osVersion: {
            required: false,
            serializedName: 'osVersion',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = MasterTargetServer;
