/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Input definition for planned failover input properties.
 *
 */
class PlannedFailoverInputProperties {
  /**
   * Create a PlannedFailoverInputProperties.
   * @member {string} [failoverDirection] Failover direction.
   * @member {object} [providerSpecificDetails] Provider specific settings
   * @member {string} [providerSpecificDetails.instanceType] Polymorphic
   * Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of PlannedFailoverInputProperties
   *
   * @returns {object} metadata of PlannedFailoverInputProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PlannedFailoverInputProperties',
      type: {
        name: 'Composite',
        className: 'PlannedFailoverInputProperties',
        modelProperties: {
          failoverDirection: {
            required: false,
            serializedName: 'failoverDirection',
            type: {
              name: 'String'
            }
          },
          providerSpecificDetails: {
            required: false,
            serializedName: 'providerSpecificDetails',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'instanceType',
                clientName: 'instanceType'
              },
              uberParent: 'ProviderSpecificFailoverInput',
              className: 'ProviderSpecificFailoverInput'
            }
          }
        }
      }
    };
  }
}

module.exports = PlannedFailoverInputProperties;
