/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Protection profile custom data details.
 *
 */
class PolicyProperties {
  /**
   * Create a PolicyProperties.
   * @member {string} [friendlyName] The FriendlyName.
   * @member {object} [providerSpecificDetails] The ReplicationChannelSetting.
   * @member {string} [providerSpecificDetails.instanceType] Polymorphic
   * Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of PolicyProperties
   *
   * @returns {object} metadata of PolicyProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PolicyProperties',
      type: {
        name: 'Composite',
        className: 'PolicyProperties',
        modelProperties: {
          friendlyName: {
            required: false,
            serializedName: 'friendlyName',
            type: {
              name: 'String'
            }
          },
          providerSpecificDetails: {
            required: false,
            serializedName: 'providerSpecificDetails',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'instanceType',
                clientName: 'instanceType'
              },
              uberParent: 'PolicyProviderSpecificDetails',
              className: 'PolicyProviderSpecificDetails'
            }
          }
        }
      }
    };
  }
}

module.exports = PolicyProperties;
