/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Protection container details.
 *
 * @extends models['Resource']
 */
class ProtectionContainer extends models['Resource'] {
  /**
   * Create a ProtectionContainer.
   * @member {object} [properties] The custom data.
   * @member {string} [properties.fabricFriendlyName] Fabric friendly name.
   * @member {string} [properties.friendlyName] The name.
   * @member {string} [properties.fabricType] The fabric type.
   * @member {number} [properties.protectedItemCount] Number of protected PEs
   * @member {string} [properties.pairingStatus] The pairing status of this
   * cloud.
   * @member {string} [properties.role] The role of this cloud.
   * @member {object} [properties.fabricSpecificDetails] Fabric specific
   * details.
   * @member {string} [properties.fabricSpecificDetails.instanceType] Gets the
   * class type. Overriden in derived classes.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ProtectionContainer
   *
   * @returns {object} metadata of ProtectionContainer
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ProtectionContainer',
      type: {
        name: 'Composite',
        className: 'ProtectionContainer',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'ProtectionContainerProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = ProtectionContainer;
