/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Protection container mapping object.
 *
 * @extends models['Resource']
 */
class ProtectionContainerMapping extends models['Resource'] {
  /**
   * Create a ProtectionContainerMapping.
   * @member {object} [properties] The custom data.
   * @member {string} [properties.targetProtectionContainerId] Paired
   * protection container ARM ID.
   * @member {string} [properties.targetProtectionContainerFriendlyName]
   * Friendly name of paired container.
   * @member {object} [properties.providerSpecificDetails] Provider specific
   * provider details.
   * @member {string} [properties.providerSpecificDetails.instanceType] Gets
   * the class type. Overriden in derived classes.
   * @member {string} [properties.health] Health of pairing.
   * @member {array} [properties.healthErrorDetails] Health error.
   * @member {string} [properties.policyId] Policy ARM Id.
   * @member {string} [properties.state] Association Status
   * @member {string} [properties.sourceProtectionContainerFriendlyName]
   * Friendly name of source protection container.
   * @member {string} [properties.sourceFabricFriendlyName] Friendly name of
   * source fabric.
   * @member {string} [properties.targetFabricFriendlyName] Friendly name of
   * target fabric.
   * @member {string} [properties.policyFriendlyName] Friendly name of
   * replication policy.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ProtectionContainerMapping
   *
   * @returns {object} metadata of ProtectionContainerMapping
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ProtectionContainerMapping',
      type: {
        name: 'Composite',
        className: 'ProtectionContainerMapping',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'ProtectionContainerMappingProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = ProtectionContainerMapping;
