/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Protection profile custom data details.
 *
 */
class ProtectionContainerProperties {
  /**
   * Create a ProtectionContainerProperties.
   * @member {string} [fabricFriendlyName] Fabric friendly name.
   * @member {string} [friendlyName] The name.
   * @member {string} [fabricType] The fabric type.
   * @member {number} [protectedItemCount] Number of protected PEs
   * @member {string} [pairingStatus] The pairing status of this cloud.
   * @member {string} [role] The role of this cloud.
   * @member {object} [fabricSpecificDetails] Fabric specific details.
   * @member {string} [fabricSpecificDetails.instanceType] Gets the class type.
   * Overriden in derived classes.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ProtectionContainerProperties
   *
   * @returns {object} metadata of ProtectionContainerProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ProtectionContainerProperties',
      type: {
        name: 'Composite',
        className: 'ProtectionContainerProperties',
        modelProperties: {
          fabricFriendlyName: {
            required: false,
            serializedName: 'fabricFriendlyName',
            type: {
              name: 'String'
            }
          },
          friendlyName: {
            required: false,
            serializedName: 'friendlyName',
            type: {
              name: 'String'
            }
          },
          fabricType: {
            required: false,
            serializedName: 'fabricType',
            type: {
              name: 'String'
            }
          },
          protectedItemCount: {
            required: false,
            serializedName: 'protectedItemCount',
            type: {
              name: 'Number'
            }
          },
          pairingStatus: {
            required: false,
            serializedName: 'pairingStatus',
            type: {
              name: 'String'
            }
          },
          role: {
            required: false,
            serializedName: 'role',
            type: {
              name: 'String'
            }
          },
          fabricSpecificDetails: {
            required: false,
            serializedName: 'fabricSpecificDetails',
            type: {
              name: 'Composite',
              className: 'ProtectionContainerFabricSpecificDetails'
            }
          }
        }
      }
    };
  }
}

module.exports = ProtectionContainerProperties;
