/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * This class contains the error details per object.
 *
 */
class ProviderError {
  /**
   * Create a ProviderError.
   * @member {number} [errorCode] The Error code.
   * @member {string} [errorMessage] The Error message.
   * @member {string} [errorId] The Provider error Id.
   * @member {string} [possibleCauses] The possible causes for the error.
   * @member {string} [recommendedAction] The recommended action to resolve the
   * error.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ProviderError
   *
   * @returns {object} metadata of ProviderError
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ProviderError',
      type: {
        name: 'Composite',
        className: 'ProviderError',
        modelProperties: {
          errorCode: {
            required: false,
            serializedName: 'errorCode',
            type: {
              name: 'Number'
            }
          },
          errorMessage: {
            required: false,
            serializedName: 'errorMessage',
            type: {
              name: 'String'
            }
          },
          errorId: {
            required: false,
            serializedName: 'errorId',
            type: {
              name: 'String'
            }
          },
          possibleCauses: {
            required: false,
            serializedName: 'possibleCauses',
            type: {
              name: 'String'
            }
          },
          recommendedAction: {
            required: false,
            serializedName: 'recommendedAction',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ProviderError;
