/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Recovery plan Automation runbook action details.
 *
 * @extends models['RecoveryPlanActionDetails']
 */
class RecoveryPlanAutomationRunbookActionDetails extends models['RecoveryPlanActionDetails'] {
  /**
   * Create a RecoveryPlanAutomationRunbookActionDetails.
   * @member {string} [runbookId] The runbook ARM Id.
   * @member {string} [timeout] The runbook timeout.
   * @member {string} fabricLocation The fabric location. Possible values
   * include: 'Primary', 'Recovery'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of RecoveryPlanAutomationRunbookActionDetails
   *
   * @returns {object} metadata of RecoveryPlanAutomationRunbookActionDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AutomationRunbookActionDetails',
      type: {
        name: 'Composite',
        className: 'RecoveryPlanAutomationRunbookActionDetails',
        modelProperties: {
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            type: {
              name: 'String'
            }
          },
          runbookId: {
            required: false,
            serializedName: 'runbookId',
            type: {
              name: 'String'
            }
          },
          timeout: {
            required: false,
            serializedName: 'timeout',
            type: {
              name: 'String'
            }
          },
          fabricLocation: {
            required: true,
            serializedName: 'fabricLocation',
            type: {
              name: 'Enum',
              allowedValues: [ 'Primary', 'Recovery' ]
            }
          }
        }
      }
    };
  }
}

module.exports = RecoveryPlanAutomationRunbookActionDetails;
