/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Recovery plan HVR Azure failback input.
 *
 * @extends models['RecoveryPlanProviderSpecificFailoverInput']
 */
class RecoveryPlanHyperVReplicaAzureFailbackInput extends models['RecoveryPlanProviderSpecificFailoverInput'] {
  /**
   * Create a RecoveryPlanHyperVReplicaAzureFailbackInput.
   * @member {string} dataSyncOption The data sync option. Possible values
   * include: 'ForDownTime', 'ForSynchronization'
   * @member {string} recoveryVmCreationOption The ALR option. Possible values
   * include: 'CreateVmIfNotFound', 'NoAction'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of RecoveryPlanHyperVReplicaAzureFailbackInput
   *
   * @returns {object} metadata of RecoveryPlanHyperVReplicaAzureFailbackInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HyperVReplicaAzureFailback',
      type: {
        name: 'Composite',
        className: 'RecoveryPlanHyperVReplicaAzureFailbackInput',
        modelProperties: {
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            type: {
              name: 'String'
            }
          },
          dataSyncOption: {
            required: true,
            serializedName: 'dataSyncOption',
            type: {
              name: 'Enum',
              allowedValues: [ 'ForDownTime', 'ForSynchronization' ]
            }
          },
          recoveryVmCreationOption: {
            required: true,
            serializedName: 'recoveryVmCreationOption',
            type: {
              name: 'Enum',
              allowedValues: [ 'CreateVmIfNotFound', 'NoAction' ]
            }
          }
        }
      }
    };
  }
}

module.exports = RecoveryPlanHyperVReplicaAzureFailbackInput;
