/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Recovery plan HVR Azure failover input.
 *
 * @extends models['RecoveryPlanProviderSpecificFailoverInput']
 */
class RecoveryPlanHyperVReplicaAzureFailoverInput extends models['RecoveryPlanProviderSpecificFailoverInput'] {
  /**
   * Create a RecoveryPlanHyperVReplicaAzureFailoverInput.
   * @member {string} vaultLocation The vault location.
   * @member {string} [primaryKekCertificatePfx] The primary KEK certificate
   * PFX.
   * @member {string} [secondaryKekCertificatePfx] The secondary KEK
   * certificate PFX.
   * @member {string} [recoveryPointType] The recovery point type. Possible
   * values include: 'Latest', 'LatestApplicationConsistent', 'LatestProcessed'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of RecoveryPlanHyperVReplicaAzureFailoverInput
   *
   * @returns {object} metadata of RecoveryPlanHyperVReplicaAzureFailoverInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HyperVReplicaAzure',
      type: {
        name: 'Composite',
        className: 'RecoveryPlanHyperVReplicaAzureFailoverInput',
        modelProperties: {
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            type: {
              name: 'String'
            }
          },
          vaultLocation: {
            required: true,
            serializedName: 'vaultLocation',
            type: {
              name: 'String'
            }
          },
          primaryKekCertificatePfx: {
            required: false,
            serializedName: 'primaryKekCertificatePfx',
            type: {
              name: 'String'
            }
          },
          secondaryKekCertificatePfx: {
            required: false,
            serializedName: 'secondaryKekCertificatePfx',
            type: {
              name: 'String'
            }
          },
          recoveryPointType: {
            required: false,
            serializedName: 'recoveryPointType',
            type: {
              name: 'Enum',
              allowedValues: [ 'Latest', 'LatestApplicationConsistent', 'LatestProcessed' ]
            }
          }
        }
      }
    };
  }
}

module.exports = RecoveryPlanHyperVReplicaAzureFailoverInput;
