/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Recovery plan InMage failover input.
 *
 * @extends models['RecoveryPlanProviderSpecificFailoverInput']
 */
class RecoveryPlanInMageFailoverInput extends models['RecoveryPlanProviderSpecificFailoverInput'] {
  /**
   * Create a RecoveryPlanInMageFailoverInput.
   * @member {string} recoveryPointType The recovery point type. Possible
   * values include: 'LatestTime', 'LatestTag', 'Custom'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of RecoveryPlanInMageFailoverInput
   *
   * @returns {object} metadata of RecoveryPlanInMageFailoverInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'InMage',
      type: {
        name: 'Composite',
        className: 'RecoveryPlanInMageFailoverInput',
        modelProperties: {
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            type: {
              name: 'String'
            }
          },
          recoveryPointType: {
            required: true,
            serializedName: 'recoveryPointType',
            type: {
              name: 'Enum',
              allowedValues: [ 'LatestTime', 'LatestTag', 'Custom' ]
            }
          }
        }
      }
    };
  }
}

module.exports = RecoveryPlanInMageFailoverInput;
