/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Base class to define the health summary of the resources contained under an
 * Arm resource.
 *
 */
class ResourceHealthSummary {
  /**
   * Create a ResourceHealthSummary.
   * @member {number} [resourceCount] The count of total resources umder the
   * container.
   * @member {array} [issues] The list of summary of health errors across the
   * resources under the container.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResourceHealthSummary
   *
   * @returns {object} metadata of ResourceHealthSummary
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceHealthSummary',
      type: {
        name: 'Composite',
        className: 'ResourceHealthSummary',
        modelProperties: {
          resourceCount: {
            required: false,
            serializedName: 'resourceCount',
            type: {
              name: 'Number'
            }
          },
          issues: {
            required: false,
            serializedName: 'issues',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'HealthErrorSummaryElementType',
                  type: {
                    name: 'Composite',
                    className: 'HealthErrorSummary'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceHealthSummary;
