/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Storage mapping object.
 *
 * @extends models['Resource']
 */
class StorageClassificationMapping extends models['Resource'] {
  /**
   * Create a StorageClassificationMapping.
   * @member {object} [properties] Proprties of the storage mappping object.
   * @member {string} [properties.targetStorageClassificationId] Target storage
   * object Id.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of StorageClassificationMapping
   *
   * @returns {object} metadata of StorageClassificationMapping
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'StorageClassificationMapping',
      type: {
        name: 'Composite',
        className: 'StorageClassificationMapping',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'StorageClassificationMappingProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = StorageClassificationMapping;
