/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Switch protection input.
 *
 */
class SwitchProtectionInput {
  /**
   * Create a SwitchProtectionInput.
   * @member {object} [properties] Switch protection properties
   * @member {string} [properties.replicationProtectedItemName] The unique
   * replication protected item name.
   * @member {object} [properties.providerSpecificDetails] Provider specific
   * switch protection input.
   * @member {string} [properties.providerSpecificDetails.instanceType]
   * Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of SwitchProtectionInput
   *
   * @returns {object} metadata of SwitchProtectionInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SwitchProtectionInput',
      type: {
        name: 'Composite',
        className: 'SwitchProtectionInput',
        modelProperties: {
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'SwitchProtectionInputProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = SwitchProtectionInput;
