/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Input definition for planned failover input properties.
 *
 */
class TestFailoverInputProperties {
  /**
   * Create a TestFailoverInputProperties.
   * @member {string} [failoverDirection] Failover direction.
   * @member {string} [networkType] Network type to be used for test failover.
   * @member {string} [networkId] The id of the network to be used for test
   * failover
   * @member {string} [skipTestFailoverCleanup] A value indicating whether the
   * test failover cleanup is to be skipped.
   * @member {object} [providerSpecificDetails] Provider specific settings
   * @member {string} [providerSpecificDetails.instanceType] Polymorphic
   * Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of TestFailoverInputProperties
   *
   * @returns {object} metadata of TestFailoverInputProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TestFailoverInputProperties',
      type: {
        name: 'Composite',
        className: 'TestFailoverInputProperties',
        modelProperties: {
          failoverDirection: {
            required: false,
            serializedName: 'failoverDirection',
            type: {
              name: 'String'
            }
          },
          networkType: {
            required: false,
            serializedName: 'networkType',
            type: {
              name: 'String'
            }
          },
          networkId: {
            required: false,
            serializedName: 'networkId',
            type: {
              name: 'String'
            }
          },
          skipTestFailoverCleanup: {
            required: false,
            serializedName: 'skipTestFailoverCleanup',
            type: {
              name: 'String'
            }
          },
          providerSpecificDetails: {
            required: false,
            serializedName: 'providerSpecificDetails',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'instanceType',
                clientName: 'instanceType'
              },
              uberParent: 'ProviderSpecificFailoverInput',
              className: 'ProviderSpecificFailoverInput'
            }
          }
        }
      }
    };
  }
}

module.exports = TestFailoverInputProperties;
