/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Input definition for planned failover.
 *
 */
class UnplannedFailoverInput {
  /**
   * Create a UnplannedFailoverInput.
   * @member {object} [properties] Planned failover input properties
   * @member {string} [properties.failoverDirection] Failover direction.
   * @member {string} [properties.sourceSiteOperations] Source site operations
   * status
   * @member {object} [properties.providerSpecificDetails] Provider specific
   * settings
   * @member {string} [properties.providerSpecificDetails.instanceType]
   * Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of UnplannedFailoverInput
   *
   * @returns {object} metadata of UnplannedFailoverInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UnplannedFailoverInput',
      type: {
        name: 'Composite',
        className: 'UnplannedFailoverInput',
        modelProperties: {
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'UnplannedFailoverInputProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = UnplannedFailoverInput;
