/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Policy update properties.
 *
 */
class UpdatePolicyInputProperties {
  /**
   * Create a UpdatePolicyInputProperties.
   * @member {object} [replicationProviderSettings] The
   * ReplicationProviderSettings.
   * @member {string} [replicationProviderSettings.instanceType] Polymorphic
   * Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of UpdatePolicyInputProperties
   *
   * @returns {object} metadata of UpdatePolicyInputProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UpdatePolicyInputProperties',
      type: {
        name: 'Composite',
        className: 'UpdatePolicyInputProperties',
        modelProperties: {
          replicationProviderSettings: {
            required: false,
            serializedName: 'replicationProviderSettings',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'instanceType',
                clientName: 'instanceType'
              },
              uberParent: 'PolicyProviderSpecificInput',
              className: 'PolicyProviderSpecificInput'
            }
          }
        }
      }
    };
  }
}

module.exports = UpdatePolicyInputProperties;
