/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Update replication protected item input.
 *
 */
class UpdateReplicationProtectedItemInput {
  /**
   * Create a UpdateReplicationProtectedItemInput.
   * @member {object} [properties] Update replication protected item
   * properties.
   * @member {string} [properties.recoveryAzureVMName] Target azure VM name
   * given by the user.
   * @member {string} [properties.recoveryAzureVMSize] Target Azure Vm size.
   * @member {string} [properties.selectedRecoveryAzureNetworkId] Target Azure
   * Network Id.
   * @member {string} [properties.enableRDPOnTargetOption] The selected option
   * to enable RDP\SSH on target vm after failover. String value of
   * {SrsDataContract.EnableRDPOnTargetOption} enum.
   * @member {array} [properties.vmNics] The list of vm nic details.
   * @member {string} [properties.licenseType] License type. Possible values
   * include: 'NotSpecified', 'NoLicenseType', 'WindowsServer'
   * @member {string} [properties.recoveryAvailabilitySetId] The target
   * availability set id.
   * @member {object} [properties.providerSpecificDetails] The provider
   * specific input to update replication protected item.
   * @member {string} [properties.providerSpecificDetails.instanceType]
   * Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of UpdateReplicationProtectedItemInput
   *
   * @returns {object} metadata of UpdateReplicationProtectedItemInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UpdateReplicationProtectedItemInput',
      type: {
        name: 'Composite',
        className: 'UpdateReplicationProtectedItemInput',
        modelProperties: {
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'UpdateReplicationProtectedItemInputProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = UpdateReplicationProtectedItemInput;
