/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * VMwareV2 fabric Specific Details.
 *
 * @extends models['FabricSpecificDetails']
 */
class VMwareV2FabricSpecificDetails extends models['FabricSpecificDetails'] {
  /**
   * Create a VMwareV2FabricSpecificDetails.
   * @member {string} [srsServiceEndpoint] The endpoint for making requests to
   * the SRS Service.
   * @member {string} [rcmServiceEndpoint] The endpoint for making requests to
   * the RCM Service.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of VMwareV2FabricSpecificDetails
   *
   * @returns {object} metadata of VMwareV2FabricSpecificDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VMwareV2',
      type: {
        name: 'Composite',
        className: 'VMwareV2FabricSpecificDetails',
        modelProperties: {
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            type: {
              name: 'String'
            }
          },
          srsServiceEndpoint: {
            required: false,
            serializedName: 'srsServiceEndpoint',
            type: {
              name: 'String'
            }
          },
          rcmServiceEndpoint: {
            required: false,
            serializedName: 'rcmServiceEndpoint',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = VMwareV2FabricSpecificDetails;
