/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * This class represents the vm NicUpdates task details.
 *
 * @extends models['TaskTypeDetails']
 */
class VmNicUpdatesTaskDetails extends models['TaskTypeDetails'] {
  /**
   * Create a VmNicUpdatesTaskDetails.
   * @member {string} [vmId] Virtual machine Id.
   * @member {string} [nicId] Nic Id.
   * @member {string} [name] Name of the Nic.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of VmNicUpdatesTaskDetails
   *
   * @returns {object} metadata of VmNicUpdatesTaskDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VmNicUpdatesTaskDetails',
      type: {
        name: 'Composite',
        className: 'VmNicUpdatesTaskDetails',
        modelProperties: {
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            type: {
              name: 'String'
            }
          },
          vmId: {
            required: false,
            serializedName: 'vmId',
            type: {
              name: 'String'
            }
          },
          nicId: {
            required: false,
            serializedName: 'nicId',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = VmNicUpdatesTaskDetails;
