/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Details of the certificate to be uploaded to the vault.
 *
 */
class CertificateRequest {
  /**
   * Create a CertificateRequest.
   * @member {object} [properties]
   * @member {string} [properties.authType] Specifies the authentication type.
   * Possible values include: 'Invalid', 'ACS', 'AAD', 'AccessControlService',
   * 'AzureActiveDirectory'
   * @member {buffer} [properties.certificate] The base64 encoded certificate
   * raw data string
   */
  constructor() {
  }

  /**
   * Defines the metadata of CertificateRequest
   *
   * @returns {object} metadata of CertificateRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CertificateRequest',
      type: {
        name: 'Composite',
        className: 'CertificateRequest',
        modelProperties: {
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'RawCertificateData'
            }
          }
        }
      }
    };
  }
}

module.exports = CertificateRequest;
