/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class to represent shoebox log specification in json client discovery.
 *
 */
class ClientDiscoveryForLogSpecification {
  /**
   * Create a ClientDiscoveryForLogSpecification.
   * @member {string} [name] Name of the log.
   * @member {string} [displayName] Localized display name
   * @member {string} [blobDuration] Blobs created in customer storage account
   * per hour
   */
  constructor() {
  }

  /**
   * Defines the metadata of ClientDiscoveryForLogSpecification
   *
   * @returns {object} metadata of ClientDiscoveryForLogSpecification
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ClientDiscoveryForLogSpecification',
      type: {
        name: 'Composite',
        className: 'ClientDiscoveryForLogSpecification',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            serializedName: 'displayName',
            type: {
              name: 'String'
            }
          },
          blobDuration: {
            required: false,
            serializedName: 'blobDuration',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ClientDiscoveryForLogSpecification;
