/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * IaaS VM workload-specific backup item representing the Azure Resource
 * Manager VM.
 *
 * @extends models['IaaSVMProtectableItem']
 */
class AzureIaaSComputeVMProtectableItem extends models['IaaSVMProtectableItem'] {
  /**
   * Create a AzureIaaSComputeVMProtectableItem.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureIaaSComputeVMProtectableItem
   *
   * @returns {object} metadata of AzureIaaSComputeVMProtectableItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Microsoft.Compute/virtualMachines',
      type: {
        name: 'Composite',
        className: 'AzureIaaSComputeVMProtectableItem',
        modelProperties: {
          backupManagementType: {
            required: false,
            serializedName: 'backupManagementType',
            type: {
              name: 'String'
            }
          },
          friendlyName: {
            required: false,
            serializedName: 'friendlyName',
            type: {
              name: 'String'
            }
          },
          protectionState: {
            required: false,
            serializedName: 'protectionState',
            type: {
              name: 'String'
            }
          },
          protectableItemType: {
            required: true,
            serializedName: 'protectableItemType',
            type: {
              name: 'String'
            }
          },
          virtualMachineId: {
            required: false,
            serializedName: 'virtualMachineId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureIaaSComputeVMProtectableItem;
