/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * IaaS VM workload-specific backup item representing the Azure Resource
 * Manager VM.
 *
 * @extends models['AzureIaaSVMProtectedItem']
 */
class AzureIaaSComputeVMProtectedItem extends models['AzureIaaSVMProtectedItem'] {
  /**
   * Create a AzureIaaSComputeVMProtectedItem.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureIaaSComputeVMProtectedItem
   *
   * @returns {object} metadata of AzureIaaSComputeVMProtectedItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Microsoft.Compute/virtualMachines',
      type: {
        name: 'Composite',
        className: 'AzureIaaSComputeVMProtectedItem',
        modelProperties: {
          backupManagementType: {
            required: false,
            serializedName: 'backupManagementType',
            type: {
              name: 'String'
            }
          },
          workloadType: {
            required: false,
            serializedName: 'workloadType',
            type: {
              name: 'String'
            }
          },
          containerName: {
            required: false,
            serializedName: 'containerName',
            type: {
              name: 'String'
            }
          },
          sourceResourceId: {
            required: false,
            serializedName: 'sourceResourceId',
            type: {
              name: 'String'
            }
          },
          policyId: {
            required: false,
            serializedName: 'policyId',
            type: {
              name: 'String'
            }
          },
          lastRecoveryPoint: {
            required: false,
            serializedName: 'lastRecoveryPoint',
            type: {
              name: 'DateTime'
            }
          },
          protectedItemType: {
            required: true,
            serializedName: 'protectedItemType',
            type: {
              name: 'String'
            }
          },
          friendlyName: {
            required: false,
            serializedName: 'friendlyName',
            type: {
              name: 'String'
            }
          },
          virtualMachineId: {
            required: false,
            serializedName: 'virtualMachineId',
            type: {
              name: 'String'
            }
          },
          protectionStatus: {
            required: false,
            serializedName: 'protectionStatus',
            type: {
              name: 'String'
            }
          },
          protectionState: {
            required: false,
            serializedName: 'protectionState',
            type: {
              name: 'String'
            }
          },
          healthStatus: {
            required: false,
            serializedName: 'healthStatus',
            type: {
              name: 'String'
            }
          },
          healthDetails: {
            required: false,
            serializedName: 'healthDetails',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'AzureIaaSVMHealthDetailsElementType',
                  type: {
                    name: 'Composite',
                    className: 'AzureIaaSVMHealthDetails'
                  }
              }
            }
          },
          lastBackupStatus: {
            required: false,
            serializedName: 'lastBackupStatus',
            type: {
              name: 'String'
            }
          },
          lastBackupTime: {
            required: false,
            serializedName: 'lastBackupTime',
            type: {
              name: 'DateTime'
            }
          },
          protectedItemDataId: {
            required: false,
            serializedName: 'protectedItemDataId',
            type: {
              name: 'String'
            }
          },
          extendedInfo: {
            required: false,
            serializedName: 'extendedInfo',
            type: {
              name: 'Composite',
              className: 'AzureIaaSVMProtectedItemExtendedInfo'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureIaaSComputeVMProtectedItem;
