/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Additional information on Azure Sql specific protected item.
 *
 */
class AzureSqlProtectedItemExtendedInfo {
  /**
   * Create a AzureSqlProtectedItemExtendedInfo.
   * @member {date} [oldestRecoveryPoint] The oldest backup copy available for
   * this item in the service.
   * @member {number} [recoveryPointCount] Number of available backup copies
   * associated with this backup item.
   * @member {string} [policyState] State of the backup policy associated with
   * this backup item.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureSqlProtectedItemExtendedInfo
   *
   * @returns {object} metadata of AzureSqlProtectedItemExtendedInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureSqlProtectedItemExtendedInfo',
      type: {
        name: 'Composite',
        className: 'AzureSqlProtectedItemExtendedInfo',
        modelProperties: {
          oldestRecoveryPoint: {
            required: false,
            serializedName: 'oldestRecoveryPoint',
            type: {
              name: 'DateTime'
            }
          },
          recoveryPointCount: {
            required: false,
            serializedName: 'recoveryPointCount',
            type: {
              name: 'Number'
            }
          },
          policyState: {
            required: false,
            serializedName: 'policyState',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureSqlProtectedItemExtendedInfo;
