/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Additional information on backup engine.
 *
 */
class BackupEngineExtendedInfo {
  /**
   * Create a BackupEngineExtendedInfo.
   * @member {string} [databaseName] Database name of backup engine.
   * @member {number} [protectedItemsCount] Number of protected items in the
   * backup engine.
   * @member {number} [protectedServersCount] Number of protected servers in
   * the backup engine.
   * @member {number} [diskCount] Number of disks in the backup engine.
   * @member {number} [usedDiskSpace] Diskspace used in the backup engine.
   * @member {number} [availableDiskSpace] Diskspace currently available in the
   * backup engine.
   * @member {date} [refreshedAt] Last refresh time in the backup engine.
   * @member {number} [azureProtectedInstances] Protected instances in the
   * backup engine.
   */
  constructor() {
  }

  /**
   * Defines the metadata of BackupEngineExtendedInfo
   *
   * @returns {object} metadata of BackupEngineExtendedInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BackupEngineExtendedInfo',
      type: {
        name: 'Composite',
        className: 'BackupEngineExtendedInfo',
        modelProperties: {
          databaseName: {
            required: false,
            serializedName: 'databaseName',
            type: {
              name: 'String'
            }
          },
          protectedItemsCount: {
            required: false,
            serializedName: 'protectedItemsCount',
            type: {
              name: 'Number'
            }
          },
          protectedServersCount: {
            required: false,
            serializedName: 'protectedServersCount',
            type: {
              name: 'Number'
            }
          },
          diskCount: {
            required: false,
            serializedName: 'diskCount',
            type: {
              name: 'Number'
            }
          },
          usedDiskSpace: {
            required: false,
            serializedName: 'usedDiskSpace',
            type: {
              name: 'Number'
            }
          },
          availableDiskSpace: {
            required: false,
            serializedName: 'availableDiskSpace',
            type: {
              name: 'Number'
            }
          },
          refreshedAt: {
            required: false,
            serializedName: 'refreshedAt',
            type: {
              name: 'DateTime'
            }
          },
          azureProtectedInstances: {
            required: false,
            serializedName: 'azureProtectedInstances',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = BackupEngineExtendedInfo;
