/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Base class for backup request. Workload-specific backup requests are derived
 * from this class.
 *
 */
class BackupRequest {
  /**
   * Create a BackupRequest.
   * @member {string} objectType Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of BackupRequest
   *
   * @returns {object} metadata of BackupRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BackupRequest',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'objectType',
          clientName: 'objectType'
        },
        uberParent: 'BackupRequest',
        className: 'BackupRequest',
        modelProperties: {
          objectType: {
            required: true,
            serializedName: 'objectType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = BackupRequest;
