/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The resource storage details.
 *
 * @extends models['Resource']
 */
class BackupResourceConfigResource extends models['Resource'] {
  /**
   * Create a BackupResourceConfigResource.
   * @member {object} [properties] BackupResourceConfigResource properties
   * @member {string} [properties.storageType] Storage type. Possible values
   * include: 'Invalid', 'GeoRedundant', 'LocallyRedundant'
   * @member {string} [properties.storageTypeState] Locked or Unlocked. Once a
   * machine is registered against a resource, the storageTypeState is always
   * Locked. Possible values include: 'Invalid', 'Locked', 'Unlocked'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of BackupResourceConfigResource
   *
   * @returns {object} metadata of BackupResourceConfigResource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BackupResourceConfigResource',
      type: {
        name: 'Composite',
        className: 'BackupResourceConfigResource',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          eTag: {
            required: false,
            serializedName: 'eTag',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'BackupResourceConfig'
            }
          }
        }
      }
    };
  }
}

module.exports = BackupResourceConfigResource;
