/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Client script details for file / folder restore.
 *
 */
class ClientScriptForConnect {
  /**
   * Create a ClientScriptForConnect.
   * @member {string} [scriptContent] File content of the client script for
   * file / folder restore.
   * @member {string} [scriptExtension] File extension of the client script for
   * file / folder restore - .ps1 , .sh , etc.
   * @member {string} [osType] OS type - Windows, Linux etc. for which this
   * file / folder restore client script works.
   * @member {string} [url] URL of Executable from where to source the content.
   * If this is not null then ScriptContent should not be used
   * @member {string} [scriptNameSuffix] Mandator suffix that should be added
   * to the name of script that is given for download to user.
   * If its null or empty then , ignore it.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ClientScriptForConnect
   *
   * @returns {object} metadata of ClientScriptForConnect
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ClientScriptForConnect',
      type: {
        name: 'Composite',
        className: 'ClientScriptForConnect',
        modelProperties: {
          scriptContent: {
            required: false,
            serializedName: 'scriptContent',
            type: {
              name: 'String'
            }
          },
          scriptExtension: {
            required: false,
            serializedName: 'scriptExtension',
            type: {
              name: 'String'
            }
          },
          osType: {
            required: false,
            serializedName: 'osType',
            type: {
              name: 'String'
            }
          },
          url: {
            required: false,
            serializedName: 'url',
            type: {
              name: 'String'
            }
          },
          scriptNameSuffix: {
            required: false,
            serializedName: 'scriptNameSuffix',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ClientScriptForConnect;
