/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * DPM workload-specific error information.
 *
 */
class DpmErrorInfo {
  /**
   * Create a DpmErrorInfo.
   * @member {string} [errorString] Localized error string.
   * @member {array} [recommendations] List of localized recommendations for
   * above error code.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DpmErrorInfo
   *
   * @returns {object} metadata of DpmErrorInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DpmErrorInfo',
      type: {
        name: 'Composite',
        className: 'DpmErrorInfo',
        modelProperties: {
          errorString: {
            required: false,
            serializedName: 'errorString',
            type: {
              name: 'String'
            }
          },
          recommendations: {
            required: false,
            serializedName: 'recommendations',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = DpmErrorInfo;
