/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Additional information on the DPM workload-specific job.
 *
 */
class DpmJobExtendedInfo {
  /**
   * Create a DpmJobExtendedInfo.
   * @member {array} [tasksList] List of tasks associated with this job.
   * @member {object} [propertyBag] The job properties.
   * @member {string} [dynamicErrorMessage] Non localized error message on job
   * execution.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DpmJobExtendedInfo
   *
   * @returns {object} metadata of DpmJobExtendedInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DpmJobExtendedInfo',
      type: {
        name: 'Composite',
        className: 'DpmJobExtendedInfo',
        modelProperties: {
          tasksList: {
            required: false,
            serializedName: 'tasksList',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'DpmJobTaskDetailsElementType',
                  type: {
                    name: 'Composite',
                    className: 'DpmJobTaskDetails'
                  }
              }
            }
          },
          propertyBag: {
            required: false,
            serializedName: 'propertyBag',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          dynamicErrorMessage: {
            required: false,
            serializedName: 'dynamicErrorMessage',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DpmJobExtendedInfo;
