/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * DPM workload-specific job task details.
 *
 */
class DpmJobTaskDetails {
  /**
   * Create a DpmJobTaskDetails.
   * @member {string} [taskId] The task display name.
   * @member {date} [startTime] The start time.
   * @member {date} [endTime] The end time.
   * @member {moment.duration} [duration] Time elapsed for task.
   * @member {string} [status] The status.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DpmJobTaskDetails
   *
   * @returns {object} metadata of DpmJobTaskDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DpmJobTaskDetails',
      type: {
        name: 'Composite',
        className: 'DpmJobTaskDetails',
        modelProperties: {
          taskId: {
            required: false,
            serializedName: 'taskId',
            type: {
              name: 'String'
            }
          },
          startTime: {
            required: false,
            serializedName: 'startTime',
            type: {
              name: 'DateTime'
            }
          },
          endTime: {
            required: false,
            serializedName: 'endTime',
            type: {
              name: 'DateTime'
            }
          },
          duration: {
            required: false,
            serializedName: 'duration',
            type: {
              name: 'TimeSpan'
            }
          },
          status: {
            required: false,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DpmJobTaskDetails;
