/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * IaaS VM workload-specific container.
 *
 * @extends models['ProtectionContainer']
 */
class IaaSVMContainer extends models['ProtectionContainer'] {
  /**
   * Create a IaaSVMContainer.
   * @member {string} [virtualMachineId] Fully qualified ARM url of the virtual
   * machine represented by this Azure IaaS VM container.
   * @member {string} [virtualMachineVersion] Specifies whether the container
   * represents a Classic or an Azure Resource Manager VM.
   * @member {string} [resourceGroup] Resource group name of Recovery Services
   * Vault.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of IaaSVMContainer
   *
   * @returns {object} metadata of IaaSVMContainer
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IaaSVMContainer',
      type: {
        name: 'Composite',
        className: 'IaaSVMContainer',
        modelProperties: {
          friendlyName: {
            required: false,
            serializedName: 'friendlyName',
            type: {
              name: 'String'
            }
          },
          backupManagementType: {
            required: false,
            serializedName: 'backupManagementType',
            type: {
              name: 'String'
            }
          },
          registrationStatus: {
            required: false,
            serializedName: 'registrationStatus',
            type: {
              name: 'String'
            }
          },
          healthStatus: {
            required: false,
            serializedName: 'healthStatus',
            type: {
              name: 'String'
            }
          },
          containerType: {
            required: false,
            readOnly: true,
            serializedName: 'containerType',
            type: {
              name: 'String'
            }
          },
          protectableObjectType: {
            required: true,
            serializedName: 'protectableObjectType',
            type: {
              name: 'String'
            }
          },
          virtualMachineId: {
            required: false,
            serializedName: 'virtualMachineId',
            type: {
              name: 'String'
            }
          },
          virtualMachineVersion: {
            required: false,
            serializedName: 'virtualMachineVersion',
            type: {
              name: 'String'
            }
          },
          resourceGroup: {
            required: false,
            serializedName: 'resourceGroup',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = IaaSVMContainer;
