/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

var msRestAzure = require('ms-rest-azure');

exports.BaseResource = msRestAzure.BaseResource;
exports.CloudError = msRestAzure.CloudError;
exports.AzureIaaSVMErrorInfo = require('./azureIaaSVMErrorInfo');
exports.AzureIaaSVMJobTaskDetails = require('./azureIaaSVMJobTaskDetails');
exports.AzureIaaSVMJobExtendedInfo = require('./azureIaaSVMJobExtendedInfo');
exports.Job = require('./job');
exports.AzureIaaSVMJob = require('./azureIaaSVMJob');
exports.DpmErrorInfo = require('./dpmErrorInfo');
exports.DpmJobTaskDetails = require('./dpmJobTaskDetails');
exports.DpmJobExtendedInfo = require('./dpmJobExtendedInfo');
exports.DpmJob = require('./dpmJob');
exports.JobQueryObject = require('./jobQueryObject');
exports.Resource = require('./resource');
exports.JobResource = require('./jobResource');
exports.MabErrorInfo = require('./mabErrorInfo');
exports.MabJobTaskDetails = require('./mabJobTaskDetails');
exports.MabJobExtendedInfo = require('./mabJobExtendedInfo');
exports.MabJob = require('./mabJob');
exports.ResourceList = require('./resourceList');
exports.DPMContainerExtendedInfo = require('./dPMContainerExtendedInfo');
exports.ProtectionContainer = require('./protectionContainer');
exports.AzureBackupServerContainer = require('./azureBackupServerContainer');
exports.BackupEngineBase = require('./backupEngineBase');
exports.AzureBackupServerEngine = require('./azureBackupServerEngine');
exports.IaaSVMContainer = require('./iaaSVMContainer');
exports.AzureIaaSClassicComputeVMContainer = require('./azureIaaSClassicComputeVMContainer');
exports.WorkloadProtectableItem = require('./workloadProtectableItem');
exports.IaaSVMProtectableItem = require('./iaaSVMProtectableItem');
exports.AzureIaaSClassicComputeVMProtectableItem = require('./azureIaaSClassicComputeVMProtectableItem');
exports.ProtectedItem = require('./protectedItem');
exports.AzureIaaSVMProtectedItem = require('./azureIaaSVMProtectedItem');
exports.AzureIaaSClassicComputeVMProtectedItem = require('./azureIaaSClassicComputeVMProtectedItem');
exports.AzureIaaSComputeVMContainer = require('./azureIaaSComputeVMContainer');
exports.AzureIaaSComputeVMProtectableItem = require('./azureIaaSComputeVMProtectableItem');
exports.AzureIaaSComputeVMProtectedItem = require('./azureIaaSComputeVMProtectedItem');
exports.AzureIaaSVMHealthDetails = require('./azureIaaSVMHealthDetails');
exports.AzureIaaSVMProtectedItemExtendedInfo = require('./azureIaaSVMProtectedItemExtendedInfo');
exports.SchedulePolicy = require('./schedulePolicy');
exports.RetentionPolicy = require('./retentionPolicy');
exports.ProtectionPolicy = require('./protectionPolicy');
exports.AzureIaaSVMProtectionPolicy = require('./azureIaaSVMProtectionPolicy');
exports.AzureSqlContainer = require('./azureSqlContainer');
exports.AzureSqlProtectedItemExtendedInfo = require('./azureSqlProtectedItemExtendedInfo');
exports.AzureSqlProtectedItem = require('./azureSqlProtectedItem');
exports.AzureSqlProtectionPolicy = require('./azureSqlProtectionPolicy');
exports.BackupEngineExtendedInfo = require('./backupEngineExtendedInfo');
exports.BackupEngineBaseResource = require('./backupEngineBaseResource');
exports.NameInfo = require('./nameInfo');
exports.BackupManagementUsage = require('./backupManagementUsage');
exports.BackupRequest = require('./backupRequest');
exports.BackupRequestResource = require('./backupRequestResource');
exports.BackupResourceConfig = require('./backupResourceConfig');
exports.BackupResourceConfigResource = require('./backupResourceConfigResource');
exports.BackupResourceVaultConfig = require('./backupResourceVaultConfig');
exports.BackupResourceVaultConfigResource = require('./backupResourceVaultConfigResource');
exports.BEKDetails = require('./bEKDetails');
exports.BMSBackupEngineQueryObject = require('./bMSBackupEngineQueryObject');
exports.BMSBackupEnginesQueryObject = require('./bMSBackupEnginesQueryObject');
exports.BMSBackupSummariesQueryObject = require('./bMSBackupSummariesQueryObject');
exports.BMSContainerQueryObject = require('./bMSContainerQueryObject');
exports.BMSPOQueryObject = require('./bMSPOQueryObject');
exports.BMSRPQueryObject = require('./bMSRPQueryObject');
exports.ClientScriptForConnect = require('./clientScriptForConnect');
exports.Day = require('./day');
exports.DailyRetentionFormat = require('./dailyRetentionFormat');
exports.RetentionDuration = require('./retentionDuration');
exports.DailyRetentionSchedule = require('./dailyRetentionSchedule');
exports.DpmBackupEngine = require('./dpmBackupEngine');
exports.DpmContainer = require('./dpmContainer');
exports.DPMProtectedItemExtendedInfo = require('./dPMProtectedItemExtendedInfo');
exports.DPMProtectedItem = require('./dPMProtectedItem');
exports.EncryptionDetails = require('./encryptionDetails');
exports.OperationResultInfoBase = require('./operationResultInfoBase');
exports.ExportJobsOperationResultInfo = require('./exportJobsOperationResultInfo');
exports.RecoveryPoint = require('./recoveryPoint');
exports.GenericRecoveryPoint = require('./genericRecoveryPoint');
exports.GetProtectedItemQueryObject = require('./getProtectedItemQueryObject');
exports.IaasVMBackupRequest = require('./iaasVMBackupRequest');
exports.ILRRequest = require('./iLRRequest');
exports.IaasVMILRRegistrationRequest = require('./iaasVMILRRegistrationRequest');
exports.KEKDetails = require('./kEKDetails');
exports.KeyAndSecretDetails = require('./keyAndSecretDetails');
exports.RecoveryPointTierInformation = require('./recoveryPointTierInformation');
exports.IaasVMRecoveryPoint = require('./iaasVMRecoveryPoint');
exports.RestoreRequest = require('./restoreRequest');
exports.IaasVMRestoreRequest = require('./iaasVMRestoreRequest');
exports.ILRRequestResource = require('./iLRRequestResource');
exports.InstantItemRecoveryTarget = require('./instantItemRecoveryTarget');
exports.WeeklyRetentionSchedule = require('./weeklyRetentionSchedule');
exports.WeeklyRetentionFormat = require('./weeklyRetentionFormat');
exports.MonthlyRetentionSchedule = require('./monthlyRetentionSchedule');
exports.YearlyRetentionSchedule = require('./yearlyRetentionSchedule');
exports.LongTermRetentionPolicy = require('./longTermRetentionPolicy');
exports.LongTermSchedulePolicy = require('./longTermSchedulePolicy');
exports.MabContainerExtendedInfo = require('./mabContainerExtendedInfo');
exports.MabContainer = require('./mabContainer');
exports.MabFileFolderProtectedItemExtendedInfo = require('./mabFileFolderProtectedItemExtendedInfo');
exports.MabFileFolderProtectedItem = require('./mabFileFolderProtectedItem');
exports.MabProtectionPolicy = require('./mabProtectionPolicy');
exports.OperationResultInfo = require('./operationResultInfo');
exports.OperationWorkerResponse = require('./operationWorkerResponse');
exports.OperationResultInfoBaseResource = require('./operationResultInfoBaseResource');
exports.OperationStatusError = require('./operationStatusError');
exports.OperationStatusExtendedInfo = require('./operationStatusExtendedInfo');
exports.OperationStatus = require('./operationStatus');
exports.OperationStatusJobExtendedInfo = require('./operationStatusJobExtendedInfo');
exports.OperationStatusJobsExtendedInfo = require('./operationStatusJobsExtendedInfo');
exports.OperationStatusProvisionILRExtendedInfo = require('./operationStatusProvisionILRExtendedInfo');
exports.ProtectedItemQueryObject = require('./protectedItemQueryObject');
exports.ProtectedItemResource = require('./protectedItemResource');
exports.ProtectionContainerResource = require('./protectionContainerResource');
exports.ProtectionPolicyQueryObject = require('./protectionPolicyQueryObject');
exports.ProtectionPolicyResource = require('./protectionPolicyResource');
exports.RecoveryPointResource = require('./recoveryPointResource');
exports.RestoreRequestResource = require('./restoreRequestResource');
exports.SimpleRetentionPolicy = require('./simpleRetentionPolicy');
exports.SimpleSchedulePolicy = require('./simpleSchedulePolicy');
exports.TokenInformation = require('./tokenInformation');
exports.WorkloadProtectableItemResource = require('./workloadProtectableItemResource');
exports.ClientDiscoveryDisplay = require('./clientDiscoveryDisplay');
exports.ClientDiscoveryForLogSpecification = require('./clientDiscoveryForLogSpecification');
exports.ClientDiscoveryForServiceSpecification = require('./clientDiscoveryForServiceSpecification');
exports.ClientDiscoveryForProperties = require('./clientDiscoveryForProperties');
exports.ClientDiscoveryValueForSingleApi = require('./clientDiscoveryValueForSingleApi');
exports.JobResourceList = require('./jobResourceList');
exports.BackupEngineBaseResourceList = require('./backupEngineBaseResourceList');
exports.RecoveryPointResourceList = require('./recoveryPointResourceList');
exports.ProtectionPolicyResourceList = require('./protectionPolicyResourceList');
exports.WorkloadProtectableItemResourceList = require('./workloadProtectableItemResourceList');
exports.ProtectedItemResourceList = require('./protectedItemResourceList');
exports.ProtectionContainerResourceList = require('./protectionContainerResourceList');
exports.BackupManagementUsageList = require('./backupManagementUsageList');
exports.ClientDiscoveryResponse = require('./clientDiscoveryResponse');
exports.discriminators = {
  'Job.AzureIaaSVMJob' : exports.AzureIaaSVMJob,
  'Job.DpmJob' : exports.DpmJob,
  'Job' : exports.Job,
  'Job.MabJob' : exports.MabJob,
  'ProtectionContainer.AzureBackupServerContainer' : exports.AzureBackupServerContainer,
  'BackupEngineBase.AzureBackupServerEngine' : exports.AzureBackupServerEngine,
  'ProtectionContainer.Microsoft.ClassicCompute/virtualMachines' : exports.AzureIaaSClassicComputeVMContainer,
  'WorkloadProtectableItem.Microsoft.ClassicCompute/virtualMachines' : exports.AzureIaaSClassicComputeVMProtectableItem,
  'ProtectedItem.Microsoft.ClassicCompute/virtualMachines' : exports.AzureIaaSClassicComputeVMProtectedItem,
  'ProtectionContainer.Microsoft.Compute/virtualMachines' : exports.AzureIaaSComputeVMContainer,
  'WorkloadProtectableItem.Microsoft.Compute/virtualMachines' : exports.AzureIaaSComputeVMProtectableItem,
  'ProtectedItem.Microsoft.Compute/virtualMachines' : exports.AzureIaaSComputeVMProtectedItem,
  'ProtectedItem.AzureIaaSVMProtectedItem' : exports.AzureIaaSVMProtectedItem,
  'SchedulePolicy' : exports.SchedulePolicy,
  'RetentionPolicy' : exports.RetentionPolicy,
  'ProtectionPolicy.AzureIaasVM' : exports.AzureIaaSVMProtectionPolicy,
  'ProtectionContainer.AzureSqlContainer' : exports.AzureSqlContainer,
  'ProtectedItem.Microsoft.Sql/servers/databases' : exports.AzureSqlProtectedItem,
  'ProtectionPolicy.AzureSql' : exports.AzureSqlProtectionPolicy,
  'BackupEngineBase' : exports.BackupEngineBase,
  'BackupRequest' : exports.BackupRequest,
  'BackupEngineBase.DpmBackupEngine' : exports.DpmBackupEngine,
  'ProtectionContainer.DPMContainer' : exports.DpmContainer,
  'ProtectedItem.DPMProtectedItem' : exports.DPMProtectedItem,
  'OperationResultInfoBase.ExportJobsOperationResultInfo' : exports.ExportJobsOperationResultInfo,
  'RecoveryPoint.GenericRecoveryPoint' : exports.GenericRecoveryPoint,
  'BackupRequest.IaasVMBackupRequest' : exports.IaasVMBackupRequest,
  'ProtectionContainer.IaaSVMContainer' : exports.IaaSVMContainer,
  'ILRRequest.IaasVMILRRegistrationRequest' : exports.IaasVMILRRegistrationRequest,
  'WorkloadProtectableItem.IaaSVMProtectableItem' : exports.IaaSVMProtectableItem,
  'RecoveryPoint.IaasVMRecoveryPoint' : exports.IaasVMRecoveryPoint,
  'RestoreRequest.IaasVMRestoreRequest' : exports.IaasVMRestoreRequest,
  'ILRRequest' : exports.ILRRequest,
  'RetentionPolicy.LongTermRetentionPolicy' : exports.LongTermRetentionPolicy,
  'SchedulePolicy.LongTermSchedulePolicy' : exports.LongTermSchedulePolicy,
  'ProtectionContainer.MABWindowsContainer' : exports.MabContainer,
  'ProtectedItem.MabFileFolderProtectedItem' : exports.MabFileFolderProtectedItem,
  'ProtectionPolicy.MAB' : exports.MabProtectionPolicy,
  'OperationResultInfoBase.OperationResultInfo' : exports.OperationResultInfo,
  'OperationResultInfoBase' : exports.OperationResultInfoBase,
  'OperationStatusExtendedInfo' : exports.OperationStatusExtendedInfo,
  'OperationStatusExtendedInfo.OperationStatusJobExtendedInfo' : exports.OperationStatusJobExtendedInfo,
  'OperationStatusExtendedInfo.OperationStatusJobsExtendedInfo' : exports.OperationStatusJobsExtendedInfo,
  'OperationStatusExtendedInfo.OperationStatusProvisionILRExtendedInfo' : exports.OperationStatusProvisionILRExtendedInfo,
  'ProtectedItem' : exports.ProtectedItem,
  'ProtectionContainer' : exports.ProtectionContainer,
  'ProtectionPolicy' : exports.ProtectionPolicy,
  'RecoveryPoint' : exports.RecoveryPoint,
  'RestoreRequest' : exports.RestoreRequest,
  'RetentionPolicy.SimpleRetentionPolicy' : exports.SimpleRetentionPolicy,
  'SchedulePolicy.SimpleSchedulePolicy' : exports.SimpleSchedulePolicy,
  'WorkloadProtectableItem' : exports.WorkloadProtectableItem
};
