/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Additional information of the container.
 *
 */
class MabContainerExtendedInfo {
  /**
   * Create a MabContainerExtendedInfo.
   * @member {date} [lastRefreshedAt] Time stamp when this container was
   * refreshed.
   * @member {string} [backupItemType] Type of backup items associated with
   * this container. Possible values include: 'Invalid', 'VM', 'FileFolder',
   * 'AzureSqlDb', 'SQLDB', 'Exchange', 'Sharepoint', 'VMwareVM',
   * 'SystemState', 'Client', 'GenericDataSource'
   * @member {array} [backupItems] List of backup items associated with this
   * container.
   * @member {string} [policyName] Backup policy associated with this
   * container.
   * @member {string} [lastBackupStatus] Latest backup status of this
   * container.
   */
  constructor() {
  }

  /**
   * Defines the metadata of MabContainerExtendedInfo
   *
   * @returns {object} metadata of MabContainerExtendedInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MabContainerExtendedInfo',
      type: {
        name: 'Composite',
        className: 'MabContainerExtendedInfo',
        modelProperties: {
          lastRefreshedAt: {
            required: false,
            serializedName: 'lastRefreshedAt',
            type: {
              name: 'DateTime'
            }
          },
          backupItemType: {
            required: false,
            serializedName: 'backupItemType',
            type: {
              name: 'String'
            }
          },
          backupItems: {
            required: false,
            serializedName: 'backupItems',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          policyName: {
            required: false,
            serializedName: 'policyName',
            type: {
              name: 'String'
            }
          },
          lastBackupStatus: {
            required: false,
            serializedName: 'lastBackupStatus',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = MabContainerExtendedInfo;
