/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Monthly retention schedule.
 *
 */
class MonthlyRetentionSchedule {
  /**
   * Create a MonthlyRetentionSchedule.
   * @member {string} [retentionScheduleFormatType] Retention schedule format
   * type for monthly retention policy. Possible values include: 'Invalid',
   * 'Daily', 'Weekly'
   * @member {object} [retentionScheduleDaily] Daily retention format for
   * monthly retention policy.
   * @member {array} [retentionScheduleDaily.daysOfTheMonth] List of days of
   * the month.
   * @member {object} [retentionScheduleWeekly] Weekly retention format for
   * monthly retention policy.
   * @member {array} [retentionScheduleWeekly.daysOfTheWeek] List of days of
   * the week.
   * @member {array} [retentionScheduleWeekly.weeksOfTheMonth] List of weeks of
   * month.
   * @member {array} [retentionTimes] Retention times of retention policy.
   * @member {object} [retentionDuration] Retention duration of retention
   * Policy.
   * @member {number} [retentionDuration.count] Count of duration types.
   * Retention duration is obtained by the counting the duration type Count
   * times.
   * For example, when Count = 3 and DurationType = Weeks, retention duration
   * will be three weeks.
   * @member {string} [retentionDuration.durationType] Retention duration type
   * of retention policy. Possible values include: 'Invalid', 'Days', 'Weeks',
   * 'Months', 'Years'
   */
  constructor() {
  }

  /**
   * Defines the metadata of MonthlyRetentionSchedule
   *
   * @returns {object} metadata of MonthlyRetentionSchedule
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MonthlyRetentionSchedule',
      type: {
        name: 'Composite',
        className: 'MonthlyRetentionSchedule',
        modelProperties: {
          retentionScheduleFormatType: {
            required: false,
            serializedName: 'retentionScheduleFormatType',
            type: {
              name: 'String'
            }
          },
          retentionScheduleDaily: {
            required: false,
            serializedName: 'retentionScheduleDaily',
            type: {
              name: 'Composite',
              className: 'DailyRetentionFormat'
            }
          },
          retentionScheduleWeekly: {
            required: false,
            serializedName: 'retentionScheduleWeekly',
            type: {
              name: 'Composite',
              className: 'WeeklyRetentionFormat'
            }
          },
          retentionTimes: {
            required: false,
            serializedName: 'retentionTimes',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'DateElementType',
                  type: {
                    name: 'DateTime'
                  }
              }
            }
          },
          retentionDuration: {
            required: false,
            serializedName: 'retentionDuration',
            type: {
              name: 'Composite',
              className: 'RetentionDuration'
            }
          }
        }
      }
    };
  }
}

module.exports = MonthlyRetentionSchedule;
