/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Recovery point tier information.
 *
 */
class RecoveryPointTierInformation {
  /**
   * Create a RecoveryPointTierInformation.
   * @member {string} [type] Recovery point tier type. Possible values include:
   * 'Invalid', 'InstantRP', 'HardenedRP'
   * @member {string} [status] Recovery point tier status. Possible values
   * include: 'Invalid', 'Valid', 'Disabled', 'Deleted'
   */
  constructor() {
  }

  /**
   * Defines the metadata of RecoveryPointTierInformation
   *
   * @returns {object} metadata of RecoveryPointTierInformation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RecoveryPointTierInformation',
      type: {
        name: 'Composite',
        className: 'RecoveryPointTierInformation',
        modelProperties: {
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'Enum',
              allowedValues: [ 'Invalid', 'InstantRP', 'HardenedRP' ]
            }
          },
          status: {
            required: false,
            serializedName: 'status',
            type: {
              name: 'Enum',
              allowedValues: [ 'Invalid', 'Valid', 'Disabled', 'Deleted' ]
            }
          }
        }
      }
    };
  }
}

module.exports = RecoveryPointTierInformation;
