/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Weekly retention schedule.
 *
 */
class WeeklyRetentionSchedule {
  /**
   * Create a WeeklyRetentionSchedule.
   * @member {array} [daysOfTheWeek] List of days of week for weekly retention
   * policy.
   * @member {array} [retentionTimes] Retention times of retention policy.
   * @member {object} [retentionDuration] Retention duration of retention
   * Policy.
   * @member {number} [retentionDuration.count] Count of duration types.
   * Retention duration is obtained by the counting the duration type Count
   * times.
   * For example, when Count = 3 and DurationType = Weeks, retention duration
   * will be three weeks.
   * @member {string} [retentionDuration.durationType] Retention duration type
   * of retention policy. Possible values include: 'Invalid', 'Days', 'Weeks',
   * 'Months', 'Years'
   */
  constructor() {
  }

  /**
   * Defines the metadata of WeeklyRetentionSchedule
   *
   * @returns {object} metadata of WeeklyRetentionSchedule
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'WeeklyRetentionSchedule',
      type: {
        name: 'Composite',
        className: 'WeeklyRetentionSchedule',
        modelProperties: {
          daysOfTheWeek: {
            required: false,
            serializedName: 'daysOfTheWeek',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'DayOfWeekElementType',
                  type: {
                    name: 'Enum',
                    allowedValues: [ 'Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday' ]
                  }
              }
            }
          },
          retentionTimes: {
            required: false,
            serializedName: 'retentionTimes',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'DateElementType',
                  type: {
                    name: 'DateTime'
                  }
              }
            }
          },
          retentionDuration: {
            required: false,
            serializedName: 'retentionDuration',
            type: {
              name: 'Composite',
              className: 'RetentionDuration'
            }
          }
        }
      }
    };
  }
}

module.exports = WeeklyRetentionSchedule;
