/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Base class for backup item. Workload-specific backup items are derived from
 * this class.
 *
 */
class WorkloadProtectableItem {
  /**
   * Create a WorkloadProtectableItem.
   * @member {string} [backupManagementType] Type of backup managemenent to
   * backup an item.
   * @member {string} [friendlyName] Friendly name of the backup item.
   * @member {string} [protectionState] State of the back up item. Possible
   * values include: 'Invalid', 'NotProtected', 'Protecting', 'Protected'
   * @member {string} protectableItemType Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of WorkloadProtectableItem
   *
   * @returns {object} metadata of WorkloadProtectableItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'WorkloadProtectableItem',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'protectableItemType',
          clientName: 'protectableItemType'
        },
        uberParent: 'WorkloadProtectableItem',
        className: 'WorkloadProtectableItem',
        modelProperties: {
          backupManagementType: {
            required: false,
            serializedName: 'backupManagementType',
            type: {
              name: 'String'
            }
          },
          friendlyName: {
            required: false,
            serializedName: 'friendlyName',
            type: {
              name: 'String'
            }
          },
          protectionState: {
            required: false,
            serializedName: 'protectionState',
            type: {
              name: 'String'
            }
          },
          protectableItemType: {
            required: true,
            serializedName: 'protectableItemType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = WorkloadProtectableItem;
