/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Parameters for Redis export operation.
 *
 */
class ExportRDBParameters {
  /**
   * Create a ExportRDBParameters.
   * @member {string} [format] File format.
   * @member {string} prefix Prefix to use for exported files.
   * @member {string} container Container name to export to.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ExportRDBParameters
   *
   * @returns {object} metadata of ExportRDBParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ExportRDBParameters',
      type: {
        name: 'Composite',
        className: 'ExportRDBParameters',
        modelProperties: {
          format: {
            required: false,
            serializedName: 'format',
            type: {
              name: 'String'
            }
          },
          prefix: {
            required: true,
            serializedName: 'prefix',
            type: {
              name: 'String'
            }
          },
          container: {
            required: true,
            serializedName: 'container',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ExportRDBParameters;
