/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Redis cache access keys.
 *
 */
class RedisAccessKeys {
  /**
   * Create a RedisAccessKeys.
   * @member {string} [primaryKey] The current primary key that clients can use
   * to authenticate with Redis cache.
   * @member {string} [secondaryKey] The current secondary key that clients can
   * use to authenticate with Redis cache.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RedisAccessKeys
   *
   * @returns {object} metadata of RedisAccessKeys
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RedisAccessKeys',
      type: {
        name: 'Composite',
        className: 'RedisAccessKeys',
        modelProperties: {
          primaryKey: {
            required: false,
            readOnly: true,
            serializedName: 'primaryKey',
            type: {
              name: 'String'
            }
          },
          secondaryKey: {
            required: false,
            readOnly: true,
            serializedName: 'secondaryKey',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = RedisAccessKeys;
