/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * SKU parameters supplied to the create Redis operation.
 *
 */
class Sku {
  /**
   * Create a Sku.
   * @member {string} name The type of Redis cache to deploy. Valid values:
   * (Basic, Standard, Premium). Possible values include: 'Basic', 'Standard',
   * 'Premium'
   * @member {string} family The SKU family to use. Valid values: (C, P). (C =
   * Basic/Standard, P = Premium). Possible values include: 'C', 'P'
   * @member {number} capacity The size of the Redis cache to deploy. Valid
   * values: for C (Basic/Standard) family (0, 1, 2, 3, 4, 5, 6), for P
   * (Premium) family (1, 2, 3, 4).
   */
  constructor() {
  }

  /**
   * Defines the metadata of Sku
   *
   * @returns {object} metadata of Sku
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Sku',
      type: {
        name: 'Composite',
        className: 'Sku',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          family: {
            required: true,
            serializedName: 'family',
            type: {
              name: 'String'
            }
          },
          capacity: {
            required: true,
            serializedName: 'capacity',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = Sku;
