/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Previewed feature information.
 *
 */
class FeatureResult {
  /**
   * Create a FeatureResult.
   * @member {string} [name] The name of the feature.
   * @member {object} [properties] Properties of the previewed feature.
   * @member {string} [properties.state] The registration state of the feature
   * for the subscription.
   * @member {string} [id] The resource ID of the feature.
   * @member {string} [type] The resource type of the feature.
   */
  constructor() {
  }

  /**
   * Defines the metadata of FeatureResult
   *
   * @returns {object} metadata of FeatureResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FeatureResult',
      type: {
        name: 'Composite',
        className: 'FeatureResult',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'FeatureProperties'
            }
          },
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = FeatureResult;
