/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

import { BaseResource } from 'ms-rest-azure';
import { CloudError } from 'ms-rest-azure';
import * as moment from 'moment';

export { BaseResource } from 'ms-rest-azure';
export { CloudError } from 'ms-rest-azure';


/**
 * @class
 * Initializes a new instance of the ManagementLockOwner class.
 * @constructor
 * Lock owner properties.
 *
 * @member {string} [applicationId] The application ID of the lock owner.
 */
export interface ManagementLockOwner {
  applicationId?: string;
}

/**
 * @class
 * Initializes a new instance of the ManagementLockObject class.
 * @constructor
 * The lock information.
 *
 * @member {string} level The level of the lock. Possible values are:
 * NotSpecified, CanNotDelete, ReadOnly. CanNotDelete means authorized users
 * are able to read and modify the resources, but not delete. ReadOnly means
 * authorized users can only read from a resource, but they can't modify or
 * delete it. Possible values include: 'NotSpecified', 'CanNotDelete',
 * 'ReadOnly'
 * @member {string} [notes] Notes about the lock. Maximum of 512 characters.
 * @member {array} [owners] The owners of the lock.
 * @member {string} [id] The resource ID of the lock.
 * @member {string} [type] The resource type of the lock -
 * Microsoft.Authorization/locks.
 * @member {string} [name] The name of the lock.
 */
export interface ManagementLockObject extends BaseResource {
  level: string;
  notes?: string;
  owners?: ManagementLockOwner[];
  readonly id?: string;
  readonly type?: string;
  name?: string;
}


/**
 * @class
 * Initializes a new instance of the ManagementLockListResult class.
 * @constructor
 * The list of locks.
 *
 * @member {string} [nextLink] The URL to use for getting the next set of
 * results.
 */
export interface ManagementLockListResult extends Array<ManagementLockObject> {
  nextLink?: string;
}
