/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The details properties of a management group.
 *
 */
class ManagementGroupDetailsProperties {
  /**
   * Create a ManagementGroupDetailsProperties.
   * @member {number} [version] The version number of the object.
   * @member {date} [updatedTime] The date and time when this object was last
   * updated.
   * @member {string} [updatedBy] The identity of the principal or process that
   * updated the object.
   * @member {object} [parent] Parent.
   * @member {string} [parent.parentId] The ID of the parent management group.
   * E.g.
   * /providers/Microsoft.Management/managementGroups/30000000-0000-0000-0000-000000000000
   * @member {string} [parent.displayName] The friendly name of the management
   * group.
   * @member {string} [managementGroupType] Management Group Type. Possible
   * values include: 'Enrollment', 'Department', 'Account', 'Subscription'
   */
  constructor() {
  }

  /**
   * Defines the metadata of ManagementGroupDetailsProperties
   *
   * @returns {object} metadata of ManagementGroupDetailsProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ManagementGroupDetailsProperties',
      type: {
        name: 'Composite',
        className: 'ManagementGroupDetailsProperties',
        modelProperties: {
          version: {
            required: false,
            serializedName: 'version',
            type: {
              name: 'Number'
            }
          },
          updatedTime: {
            required: false,
            serializedName: 'updatedTime',
            type: {
              name: 'DateTime'
            }
          },
          updatedBy: {
            required: false,
            serializedName: 'updatedBy',
            type: {
              name: 'String'
            }
          },
          parent: {
            required: false,
            serializedName: 'parent',
            type: {
              name: 'Composite',
              className: 'ParentGroupInfo'
            }
          },
          managementGroupType: {
            required: false,
            serializedName: 'managementGroupType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ManagementGroupDetailsProperties;
