/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The unique identifier (ID) of a management group.
 *
 */
class ManagementGroupRecursiveChildInfo {
  /**
   * Create a ManagementGroupRecursiveChildInfo.
   * @member {string} [childType] Managment Group Recursive Child Info.
   * Possible values include: 'Enrollment', 'Department', 'Account',
   * 'Subscription'
   * @member {string} [childId] The ID of the child resource (management group
   * or subscription). E.g.
   * /providers/Microsoft.Management/managementGroups/40000000-0000-0000-0000-000000000000
   * @member {string} [displayName] The friendly name of the child resource.
   * @member {uuid} [tenantId] (Optional) The AAD Tenant ID associated with the
   * child resource.
   * @member {array} [children] The list of children.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ManagementGroupRecursiveChildInfo
   *
   * @returns {object} metadata of ManagementGroupRecursiveChildInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ManagementGroupRecursiveChildInfo',
      type: {
        name: 'Composite',
        className: 'ManagementGroupRecursiveChildInfo',
        modelProperties: {
          childType: {
            required: false,
            serializedName: 'childType',
            type: {
              name: 'String'
            }
          },
          childId: {
            required: false,
            serializedName: 'childId',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            serializedName: 'displayName',
            type: {
              name: 'String'
            }
          },
          tenantId: {
            required: false,
            serializedName: 'tenantId',
            type: {
              name: 'String'
            }
          },
          children: {
            required: false,
            serializedName: 'children',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ManagementGroupRecursiveChildInfoElementType',
                  type: {
                    name: 'Composite',
                    className: 'ManagementGroupRecursiveChildInfo'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ManagementGroupRecursiveChildInfo;
