/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a DebugSetting.
 */
class DebugSetting {
  /**
   * Create a DebugSetting.
   * @member {string} [detailLevel] Specifies the type of information to log
   * for debugging. The permitted values are none, requestContent,
   * responseContent, or both requestContent and responseContent separated by a
   * comma. The default is none. When setting this value, carefully consider
   * the type of information you are passing in during deployment. By logging
   * information about the request or response, you could potentially expose
   * sensitive data that is retrieved through the deployment operations.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DebugSetting
   *
   * @returns {object} metadata of DebugSetting
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DebugSetting',
      type: {
        name: 'Composite',
        className: 'DebugSetting',
        modelProperties: {
          detailLevel: {
            required: false,
            serializedName: 'detailLevel',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DebugSetting;
