/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Resource provider information.
 *
 */
class Provider {
  /**
   * Create a Provider.
   * @member {string} [id] The provider ID.
   * @member {string} [namespace] The namespace of the resource provider.
   * @member {string} [registrationState] The registration state of the
   * provider.
   * @member {array} [resourceTypes] The collection of provider resource types.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Provider
   *
   * @returns {object} metadata of Provider
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Provider',
      type: {
        name: 'Composite',
        className: 'Provider',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          namespace: {
            required: false,
            serializedName: 'namespace',
            type: {
              name: 'String'
            }
          },
          registrationState: {
            required: false,
            readOnly: true,
            serializedName: 'registrationState',
            type: {
              name: 'String'
            }
          },
          resourceTypes: {
            required: false,
            readOnly: true,
            serializedName: 'resourceTypes',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ProviderResourceTypeElementType',
                  type: {
                    name: 'Composite',
                    className: 'ProviderResourceType'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = Provider;
