/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Entity representing the reference to the template.
 *
 */
class TemplateLink {
  /**
   * Create a TemplateLink.
   * @member {string} uri The URI of the template to deploy.
   * @member {string} [contentVersion] If included, must match the
   * ContentVersion in the template.
   */
  constructor() {
  }

  /**
   * Defines the metadata of TemplateLink
   *
   * @returns {object} metadata of TemplateLink
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TemplateLink',
      type: {
        name: 'Composite',
        className: 'TemplateLink',
        modelProperties: {
          uri: {
            required: true,
            serializedName: 'uri',
            type: {
              name: 'String'
            }
          },
          contentVersion: {
            required: false,
            serializedName: 'contentVersion',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = TemplateLink;
