/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties of the service impacting event.
 *
 */
class ServiceImpactingEventIncidentProperties {
  /**
   * Create a ServiceImpactingEventIncidentProperties.
   * @member {string} [title] Title of the incident.
   * @member {string} [service] Service impacted by the event.
   * @member {string} [region] Region impacted by the event.
   * @member {string} [incidentType] Type of Event.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ServiceImpactingEventIncidentProperties
   *
   * @returns {object} metadata of ServiceImpactingEventIncidentProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'serviceImpactingEvent_incidentProperties',
      type: {
        name: 'Composite',
        className: 'ServiceImpactingEventIncidentProperties',
        modelProperties: {
          title: {
            required: false,
            serializedName: 'title',
            type: {
              name: 'String'
            }
          },
          service: {
            required: false,
            serializedName: 'service',
            type: {
              name: 'String'
            }
          },
          region: {
            required: false,
            serializedName: 'region',
            type: {
              name: 'String'
            }
          },
          incidentType: {
            required: false,
            serializedName: 'incidentType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ServiceImpactingEventIncidentProperties;
