/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Description of a namespace authorization rule.
 *
 * @extends models['Resource']
 */
class SBAuthorizationRule extends models['Resource'] {
  /**
   * Create a SBAuthorizationRule.
   * @member {array} [rights] The rights associated with the rule.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SBAuthorizationRule
   *
   * @returns {object} metadata of SBAuthorizationRule
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SBAuthorizationRule',
      type: {
        name: 'Composite',
        className: 'SBAuthorizationRule',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          rights: {
            required: false,
            serializedName: 'properties.rights',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'AccessRightsElementType',
                  type: {
                    name: 'Enum',
                    allowedValues: [ 'Manage', 'Send', 'Listen' ]
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = SBAuthorizationRule;
