/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Represents set of actions written in SQL language-based syntax that is
 * performed against a ServiceBus.Messaging.BrokeredMessage
 *
 * @extends models['Action']
 */
class SqlRuleAction extends models['Action'] {
  /**
   * Create a SqlRuleAction.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SqlRuleAction
   *
   * @returns {object} metadata of SqlRuleAction
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SqlRuleAction',
      type: {
        name: 'Composite',
        className: 'SqlRuleAction',
        modelProperties: {
          sqlExpression: {
            required: false,
            serializedName: 'sqlExpression',
            type: {
              name: 'String'
            }
          },
          compatibilityLevel: {
            required: false,
            serializedName: 'compatibilityLevel',
            type: {
              name: 'Number'
            }
          },
          requiresPreprocessing: {
            required: false,
            serializedName: 'requiresPreprocessing',
            defaultValue: true,
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = SqlRuleAction;
