/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a JobHistoryDefinitionProperties.
 */
class JobHistoryDefinitionProperties {
  /**
   * Create a JobHistoryDefinitionProperties.
   * @member {date} [startTime] Gets the start time for this job.
   * @member {date} [endTime] Gets the end time for this job.
   * @member {date} [expectedExecutionTime] Gets the expected execution time
   * for this job.
   * @member {string} [actionName] Gets the job history action name. Possible
   * values include: 'MainAction', 'ErrorAction'
   * @member {string} [status] Gets the job history status. Possible values
   * include: 'Completed', 'Failed', 'Postponed'
   * @member {string} [message] Gets the message for the job history.
   * @member {number} [retryCount] Gets the retry count for job.
   * @member {number} [repeatCount] Gets the repeat count for the job.
   */
  constructor() {
  }

  /**
   * Defines the metadata of JobHistoryDefinitionProperties
   *
   * @returns {object} metadata of JobHistoryDefinitionProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'JobHistoryDefinitionProperties',
      type: {
        name: 'Composite',
        className: 'JobHistoryDefinitionProperties',
        modelProperties: {
          startTime: {
            required: false,
            readOnly: true,
            serializedName: 'startTime',
            type: {
              name: 'DateTime'
            }
          },
          endTime: {
            required: false,
            readOnly: true,
            serializedName: 'endTime',
            type: {
              name: 'DateTime'
            }
          },
          expectedExecutionTime: {
            required: false,
            readOnly: true,
            serializedName: 'expectedExecutionTime',
            type: {
              name: 'DateTime'
            }
          },
          actionName: {
            required: false,
            readOnly: true,
            serializedName: 'actionName',
            type: {
              name: 'Enum',
              allowedValues: [ 'MainAction', 'ErrorAction' ]
            }
          },
          status: {
            required: false,
            readOnly: true,
            serializedName: 'status',
            type: {
              name: 'Enum',
              allowedValues: [ 'Completed', 'Failed', 'Postponed' ]
            }
          },
          message: {
            required: false,
            readOnly: true,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          },
          retryCount: {
            required: false,
            readOnly: true,
            serializedName: 'retryCount',
            type: {
              name: 'Number'
            }
          },
          repeatCount: {
            required: false,
            readOnly: true,
            serializedName: 'repeatCount',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = JobHistoryDefinitionProperties;
