/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Class representing a JobRecurrenceSchedule.
 */
class JobRecurrenceSchedule {
  /**
   * Create a JobRecurrenceSchedule.
   * @member {array} [weekDays] Gets or sets the days of the week that the job
   * should execute on.
   * @member {array} [hours] Gets or sets the hours of the day that the job
   * should execute at.
   * @member {array} [minutes] Gets or sets the minutes of the hour that the
   * job should execute at.
   * @member {array} [monthDays] Gets or sets the days of the month that the
   * job should execute on. Must be between 1 and 31.
   * @member {array} [monthlyOccurrences] Gets or sets the occurrences of days
   * within a month.
   */
  constructor() {
  }

  /**
   * Defines the metadata of JobRecurrenceSchedule
   *
   * @returns {object} metadata of JobRecurrenceSchedule
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'JobRecurrenceSchedule',
      type: {
        name: 'Composite',
        className: 'JobRecurrenceSchedule',
        modelProperties: {
          weekDays: {
            required: false,
            serializedName: 'weekDays',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'DayOfWeekElementType',
                  type: {
                    name: 'Enum',
                    allowedValues: [ 'Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday' ]
                  }
              }
            }
          },
          hours: {
            required: false,
            serializedName: 'hours',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'NumberElementType',
                  type: {
                    name: 'Number'
                  }
              }
            }
          },
          minutes: {
            required: false,
            serializedName: 'minutes',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'NumberElementType',
                  type: {
                    name: 'Number'
                  }
              }
            }
          },
          monthDays: {
            required: false,
            serializedName: 'monthDays',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'NumberElementType',
                  type: {
                    name: 'Number'
                  }
              }
            }
          },
          monthlyOccurrences: {
            required: false,
            serializedName: 'monthlyOccurrences',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'JobRecurrenceScheduleMonthlyOccurrenceElementType',
                  type: {
                    name: 'Composite',
                    className: 'JobRecurrenceScheduleMonthlyOccurrence'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = JobRecurrenceSchedule;
