/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Class representing a OAuthAuthentication.
 * @extends models['HttpAuthentication']
 */
class OAuthAuthentication extends models['HttpAuthentication'] {
  /**
   * Create a OAuthAuthentication.
   * @member {string} [secret] Gets or sets the secret, return value will
   * always be empty.
   * @member {string} [tenant] Gets or sets the tenant.
   * @member {string} [audience] Gets or sets the audience.
   * @member {string} [clientId] Gets or sets the client identifier.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of OAuthAuthentication
   *
   * @returns {object} metadata of OAuthAuthentication
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OAuthAuthentication',
      type: {
        name: 'Composite',
        className: 'OAuthAuthentication',
        modelProperties: {
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'Enum',
              allowedValues: [ 'NotSpecified', 'ClientCertificate', 'ActiveDirectoryOAuth', 'Basic' ]
            }
          },
          secret: {
            required: false,
            serializedName: 'secret',
            type: {
              name: 'String'
            }
          },
          tenant: {
            required: false,
            serializedName: 'tenant',
            type: {
              name: 'String'
            }
          },
          audience: {
            required: false,
            serializedName: 'audience',
            type: {
              name: 'String'
            }
          },
          clientId: {
            required: false,
            serializedName: 'clientId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = OAuthAuthentication;
