/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a RetryPolicy.
 */
class RetryPolicy {
  /**
   * Create a RetryPolicy.
   * @member {string} [retryType] Gets or sets the retry strategy to be used.
   * Possible values include: 'None', 'Fixed'
   * @member {moment.duration} [retryInterval] Gets or sets the retry interval
   * between retries, specify duration in ISO 8601 format.
   * @member {number} [retryCount] Gets or sets the number of times a retry
   * should be attempted.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RetryPolicy
   *
   * @returns {object} metadata of RetryPolicy
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RetryPolicy',
      type: {
        name: 'Composite',
        className: 'RetryPolicy',
        modelProperties: {
          retryType: {
            required: false,
            serializedName: 'retryType',
            type: {
              name: 'Enum',
              allowedValues: [ 'None', 'Fixed' ]
            }
          },
          retryInterval: {
            required: false,
            serializedName: 'retryInterval',
            type: {
              name: 'TimeSpan'
            }
          },
          retryCount: {
            required: false,
            serializedName: 'retryCount',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = RetryPolicy;
