/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a ServiceBusAuthentication.
 */
class ServiceBusAuthentication {
  /**
   * Create a ServiceBusAuthentication.
   * @member {string} [sasKey] Gets or sets the SAS key.
   * @member {string} [sasKeyName] Gets or sets the SAS key name.
   * @member {string} [type] Gets or sets the authentication type. Possible
   * values include: 'NotSpecified', 'SharedAccessKey'
   */
  constructor() {
  }

  /**
   * Defines the metadata of ServiceBusAuthentication
   *
   * @returns {object} metadata of ServiceBusAuthentication
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ServiceBusAuthentication',
      type: {
        name: 'Composite',
        className: 'ServiceBusAuthentication',
        modelProperties: {
          sasKey: {
            required: false,
            serializedName: 'sasKey',
            type: {
              name: 'String'
            }
          },
          sasKeyName: {
            required: false,
            serializedName: 'sasKeyName',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'Enum',
              allowedValues: [ 'NotSpecified', 'SharedAccessKey' ]
            }
          }
        }
      }
    };
  }
}

module.exports = ServiceBusAuthentication;
