/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a Sku.
 */
class Sku {
  /**
   * Create a Sku.
   * @member {string} [name] Gets or set the SKU. Possible values include:
   * 'Standard', 'Free', 'P10Premium', 'P20Premium'
   */
  constructor() {
  }

  /**
   * Defines the metadata of Sku
   *
   * @returns {object} metadata of Sku
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Sku',
      type: {
        name: 'Composite',
        className: 'Sku',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'Enum',
              allowedValues: [ 'Standard', 'Free', 'P10Premium', 'P20Premium' ]
            }
          }
        }
      }
    };
  }
}

module.exports = Sku;
