/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a StorageQueueMessage.
 */
class StorageQueueMessage {
  /**
   * Create a StorageQueueMessage.
   * @member {string} [storageAccount] Gets or sets the storage account name.
   * @member {string} [queueName] Gets or sets the queue name.
   * @member {string} [sasToken] Gets or sets the SAS key.
   * @member {string} [message] Gets or sets the message.
   */
  constructor() {
  }

  /**
   * Defines the metadata of StorageQueueMessage
   *
   * @returns {object} metadata of StorageQueueMessage
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'StorageQueueMessage',
      type: {
        name: 'Composite',
        className: 'StorageQueueMessage',
        modelProperties: {
          storageAccount: {
            required: false,
            serializedName: 'storageAccount',
            type: {
              name: 'String'
            }
          },
          queueName: {
            required: false,
            serializedName: 'queueName',
            type: {
              name: 'String'
            }
          },
          sasToken: {
            required: false,
            serializedName: 'sasToken',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = StorageQueueMessage;
