/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Input of check name availability API.
 *
 */
class CheckNameAvailabilityInput {
  /**
   * Create a CheckNameAvailabilityInput.
   * @member {string} name The Search service name to validate. Search service
   * names must only contain lowercase letters, digits or dashes, cannot use
   * dash as the first two or last one characters, cannot contain consecutive
   * dashes, and must be between 2 and 60 characters in length.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CheckNameAvailabilityInput
   *
   * @returns {object} metadata of CheckNameAvailabilityInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CheckNameAvailabilityInput',
      type: {
        name: 'Composite',
        className: 'CheckNameAvailabilityInput',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: true,
            isConstant: true,
            serializedName: 'type',
            defaultValue: 'searchServices',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CheckNameAvailabilityInput;
