/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Collection of parameters for operations on a gateway resource.
 *
 */
class GatewayParameters {
  /**
   * Create a GatewayParameters.
   * @member {string} [location] Location of the resource.
   * @member {object} [tags] Resource tags.
   * @member {string} [upgradeMode] The upgradeMode property gives the
   * flexibility to gateway to auto upgrade itself. If properties value not
   * specified, then we assume upgradeMode = Automatic. Possible values
   * include: 'Manual', 'Automatic'
   */
  constructor() {
  }

  /**
   * Defines the metadata of GatewayParameters
   *
   * @returns {object} metadata of GatewayParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GatewayParameters',
      type: {
        name: 'Composite',
        className: 'GatewayParameters',
        modelProperties: {
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Object'
            }
          },
          upgradeMode: {
            required: false,
            serializedName: 'properties.upgradeMode',
            type: {
              name: 'Enum',
              allowedValues: [ 'Manual', 'Automatic' ]
            }
          }
        }
      }
    };
  }
}

module.exports = GatewayParameters;
