/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A multipart-numeric version number.
 *
 */
class Version {
  /**
   * Create a Version.
   * @member {number} [major] The leftmost number of the version.
   * @member {number} [minor] The second leftmost number of the version.
   * @member {number} [build] The third number of the version.
   * @member {number} [revision] The fourth number of the version.
   * @member {number} [majorRevision] The MSW of the fourth part.
   * @member {number} [minorRevision] The LSW of the fourth part.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Version
   *
   * @returns {object} metadata of Version
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Version',
      type: {
        name: 'Composite',
        className: 'Version',
        modelProperties: {
          major: {
            required: false,
            serializedName: 'major',
            type: {
              name: 'Number'
            }
          },
          minor: {
            required: false,
            serializedName: 'minor',
            type: {
              name: 'Number'
            }
          },
          build: {
            required: false,
            serializedName: 'build',
            type: {
              name: 'Number'
            }
          },
          revision: {
            required: false,
            serializedName: 'revision',
            type: {
              name: 'Number'
            }
          },
          majorRevision: {
            required: false,
            serializedName: 'majorRevision',
            type: {
              name: 'Number'
            }
          },
          minorRevision: {
            required: false,
            serializedName: 'minorRevision',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = Version;
