/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The application type name resource
 *
 * @extends models['ProxyResource']
 */
class ApplicationTypeResource extends models['ProxyResource'] {
  /**
   * Create a ApplicationTypeResource.
   * @member {string} [provisioningState] The current deployment or
   * provisioning state, which only appears in the response.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ApplicationTypeResource
   *
   * @returns {object} metadata of ApplicationTypeResource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplicationTypeResource',
      type: {
        name: 'Composite',
        className: 'ApplicationTypeResource',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          provisioningState: {
            required: false,
            readOnly: true,
            serializedName: 'properties.provisioningState',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ApplicationTypeResource;
