/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the client certificate details using thumbprint.
 *
 */
class ClientCertificateThumbprint {
  /**
   * Create a ClientCertificateThumbprint.
   * @member {boolean} isAdmin Indicates if the client certificate has admin
   * access to the cluster. Non admin clients can perform only read only
   * operations on the cluster.
   * @member {string} certificateThumbprint The thumbprint of the client
   * certificate.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ClientCertificateThumbprint
   *
   * @returns {object} metadata of ClientCertificateThumbprint
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ClientCertificateThumbprint',
      type: {
        name: 'Composite',
        className: 'ClientCertificateThumbprint',
        modelProperties: {
          isAdmin: {
            required: true,
            serializedName: 'isAdmin',
            type: {
              name: 'Boolean'
            }
          },
          certificateThumbprint: {
            required: true,
            serializedName: 'certificateThumbprint',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ClientCertificateThumbprint;
