/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The result of the ServiceFabric runtime versions
 *
 */
class ClusterCodeVersionsResult {
  /**
   * Create a ClusterCodeVersionsResult.
   * @member {string} [id] The identification of the result
   * @member {string} [name] The name of the result
   * @member {string} [type] The result resource type
   * @member {string} [codeVersion] The Service Fabric runtime version of the
   * cluster.
   * @member {string} [supportExpiryUtc] The date of expiry of support of the
   * version.
   * @member {string} [environment] Indicates if this version is for Windows or
   * Linux operating system. Possible values include: 'Windows', 'Linux'
   */
  constructor() {
  }

  /**
   * Defines the metadata of ClusterCodeVersionsResult
   *
   * @returns {object} metadata of ClusterCodeVersionsResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ClusterCodeVersionsResult',
      type: {
        name: 'Composite',
        className: 'ClusterCodeVersionsResult',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          codeVersion: {
            required: false,
            serializedName: 'properties.codeVersion',
            type: {
              name: 'String'
            }
          },
          supportExpiryUtc: {
            required: false,
            serializedName: 'properties.supportExpiryUtc',
            type: {
              name: 'String'
            }
          },
          environment: {
            required: false,
            serializedName: 'properties.environment',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ClusterCodeVersionsResult;
