/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The detail of the Service Fabric runtime version result
 *
 */
class ClusterVersionDetails {
  /**
   * Create a ClusterVersionDetails.
   * @member {string} [codeVersion] The Service Fabric runtime version of the
   * cluster.
   * @member {string} [supportExpiryUtc] The date of expiry of support of the
   * version.
   * @member {string} [environment] Indicates if this version is for Windows or
   * Linux operating system. Possible values include: 'Windows', 'Linux'
   */
  constructor() {
  }

  /**
   * Defines the metadata of ClusterVersionDetails
   *
   * @returns {object} metadata of ClusterVersionDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ClusterVersionDetails',
      type: {
        name: 'Composite',
        className: 'ClusterVersionDetails',
        modelProperties: {
          codeVersion: {
            required: false,
            serializedName: 'codeVersion',
            type: {
              name: 'String'
            }
          },
          supportExpiryUtc: {
            required: false,
            serializedName: 'supportExpiryUtc',
            type: {
              name: 'String'
            }
          },
          environment: {
            required: false,
            serializedName: 'environment',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ClusterVersionDetails;
