/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Available operation list result
 *
 */
class OperationResult {
  /**
   * Create a OperationResult.
   * @member {string} [name] The name of the operation.
   * @member {object} [display] The object that represents the operation.
   * @member {string} [display.provider] The name of the provider.
   * @member {string} [display.resource] The resource on which the operation is
   * performed
   * @member {string} [display.operation] The operation that can be performed.
   * @member {string} [display.description] Operation description
   * @member {string} [origin] Origin result
   * @member {string} [nextLink] The URL to use for getting the next set of
   * results.
   */
  constructor() {
  }

  /**
   * Defines the metadata of OperationResult
   *
   * @returns {object} metadata of OperationResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OperationResult',
      type: {
        name: 'Composite',
        className: 'OperationResult',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          display: {
            required: false,
            serializedName: 'display',
            type: {
              name: 'Composite',
              className: 'AvailableOperationDisplay'
            }
          },
          origin: {
            required: false,
            serializedName: 'origin',
            type: {
              name: 'String'
            }
          },
          nextLink: {
            required: false,
            serializedName: 'nextLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = OperationResult;
