/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The service resource properties for patch operations.
 *
 * @extends models['ServicePropertiesBase']
 */
class ServiceUpdateProperties extends models['ServicePropertiesBase'] {
  /**
   * Create a ServiceUpdateProperties.
   * @member {string} serviceResourceType Polymorphic Discriminator
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ServiceUpdateProperties
   *
   * @returns {object} metadata of ServiceUpdateProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ServiceUpdateProperties',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'serviceResourceType',
          clientName: 'serviceResourceType'
        },
        uberParent: 'ServicePropertiesBase',
        className: 'ServiceUpdateProperties',
        modelProperties: {
          placementConstraints: {
            required: false,
            serializedName: 'placementConstraints',
            type: {
              name: 'String'
            }
          },
          correlationScheme: {
            required: false,
            serializedName: 'correlationScheme',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ServiceCorrelationDescriptionElementType',
                  type: {
                    name: 'Composite',
                    className: 'ServiceCorrelationDescription'
                  }
              }
            }
          },
          serviceLoadMetrics: {
            required: false,
            serializedName: 'serviceLoadMetrics',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ServiceLoadMetricDescriptionElementType',
                  type: {
                    name: 'Composite',
                    className: 'ServiceLoadMetricDescription'
                  }
              }
            }
          },
          servicePlacementPolicies: {
            required: false,
            serializedName: 'servicePlacementPolicies',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ServicePlacementPolicyDescriptionElementType',
                  type: {
                    name: 'Composite',
                    polymorphicDiscriminator: {
                      serializedName: 'Type',
                      clientName: 'type'
                    },
                    uberParent: 'ServicePlacementPolicyDescription',
                    className: 'ServicePlacementPolicyDescription'
                  }
              }
            }
          },
          defaultMoveCost: {
            required: false,
            serializedName: 'defaultMoveCost',
            type: {
              name: 'String'
            }
          },
          serviceResourceType: {
            required: true,
            serializedName: 'serviceResourceType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ServiceUpdateProperties;
