/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Describes a section in the fabric settings of the cluster.
 *
 */
class SettingsSectionDescription {
  /**
   * Create a SettingsSectionDescription.
   * @member {string} name The section name of the fabric settings.
   * @member {array} parameters The collection of parameters in the section.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SettingsSectionDescription
   *
   * @returns {object} metadata of SettingsSectionDescription
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SettingsSectionDescription',
      type: {
        name: 'Composite',
        className: 'SettingsSectionDescription',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          parameters: {
            required: true,
            serializedName: 'parameters',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'SettingsParameterDescriptionElementType',
                  type: {
                    name: 'Composite',
                    className: 'SettingsParameterDescription'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = SettingsSectionDescription;
