/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A process accepting on a port.
 *
 * @extends models['Relationship']
 */
class Acceptor extends models['Relationship'] {
  /**
   * Create a Acceptor.
   * @member {object} source Port being accepted.
   * @member {object} [source.machine] Machine hosting the port.
   * @member {string} [source.ipAddress] IP address of the port.
   * @member {number} [source.portNumber] Port number.
   * @member {object} destination Accepting process.
   * @member {object} [destination.machine] Machine hosting the process.
   * @member {date} [startTime] Relationship start time.
   * @member {date} [endTime] Relationship end time.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of Acceptor
   *
   * @returns {object} metadata of Acceptor
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'rel:acceptor',
      type: {
        name: 'Composite',
        className: 'Acceptor',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: true,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          source: {
            required: true,
            serializedName: 'properties.source',
            type: {
              name: 'Composite',
              className: 'PortReference'
            }
          },
          destination: {
            required: true,
            serializedName: 'properties.destination',
            type: {
              name: 'Composite',
              className: 'ProcessReference'
            }
          },
          startTime: {
            required: false,
            serializedName: 'properties.startTime',
            type: {
              name: 'DateTime'
            }
          },
          endTime: {
            required: false,
            serializedName: 'properties.endTime',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = Acceptor;
