/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Specifies the number of members in a client group.
 *
 */
class ClientGroupMembersCount {
  /**
   * Create a ClientGroupMembersCount.
   * @member {date} startTime Membership interval start time.
   * @member {date} endTime Membership interval start time.
   * @member {string} groupId Client Group URI.
   * @member {number} count Number of members in the client group. Use this
   * value together with the value of ```accuracy```. If accuracy is `exact`
   * then the value represents the actual number of members in the cloud. When
   * accuracy is `estimated`, the actual number of members is larger than the
   * value of ```count```.
   * @member {string} accuracy Accuracy of the reported count. Possible values
   * include: 'actual', 'estimated'
   */
  constructor() {
  }

  /**
   * Defines the metadata of ClientGroupMembersCount
   *
   * @returns {object} metadata of ClientGroupMembersCount
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ClientGroupMembersCount',
      type: {
        name: 'Composite',
        className: 'ClientGroupMembersCount',
        modelProperties: {
          startTime: {
            required: true,
            serializedName: 'startTime',
            type: {
              name: 'DateTime'
            }
          },
          endTime: {
            required: true,
            serializedName: 'endTime',
            type: {
              name: 'DateTime'
            }
          },
          groupId: {
            required: true,
            serializedName: 'groupId',
            type: {
              name: 'String'
            }
          },
          count: {
            required: true,
            serializedName: 'count',
            type: {
              name: 'Number'
            }
          },
          accuracy: {
            required: true,
            serializedName: 'accuracy',
            type: {
              name: 'Enum',
              allowedValues: [ 'actual', 'estimated' ]
            }
          }
        }
      }
    };
  }
}

module.exports = ClientGroupMembersCount;
