/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the hypervisor configuration of a machine.
 *
 */
class HypervisorConfiguration {
  /**
   * Create a HypervisorConfiguration.
   * @member {string} [hypervisorType] Specifies the virtualization technology
   * used by the hypervisor (hyperv, vmware, etc.). Possible values include:
   * 'unknown', 'hyperv'
   * @member {string} [nativeHostMachineId] The unique identifier of the
   * hypervisor machine as reported by the underlying virtualization system.
   */
  constructor() {
  }

  /**
   * Defines the metadata of HypervisorConfiguration
   *
   * @returns {object} metadata of HypervisorConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HypervisorConfiguration',
      type: {
        name: 'Composite',
        className: 'HypervisorConfiguration',
        modelProperties: {
          hypervisorType: {
            required: false,
            serializedName: 'hypervisorType',
            type: {
              name: 'Enum',
              allowedValues: [ 'unknown', 'hyperv' ]
            }
          },
          nativeHostMachineId: {
            required: false,
            serializedName: 'nativeHostMachineId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = HypervisorConfiguration;
