/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Specifies the contents of a check liveness response.
 *
 */
class Liveness {
  /**
   * Create a Liveness.
   * @member {date} startTime Liveness interval start time.
   * @member {date} endTime Liveness interval end time.
   * @member {boolean} live `true` if the resource is live during [startTime,
   * endTime], `false` otherwise
   */
  constructor() {
  }

  /**
   * Defines the metadata of Liveness
   *
   * @returns {object} metadata of Liveness
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Liveness',
      type: {
        name: 'Composite',
        className: 'Liveness',
        modelProperties: {
          startTime: {
            required: true,
            serializedName: 'startTime',
            type: {
              name: 'DateTime'
            }
          },
          endTime: {
            required: true,
            serializedName: 'endTime',
            type: {
              name: 'DateTime'
            }
          },
          live: {
            required: true,
            serializedName: 'live',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = Liveness;
