/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Specifies the computation of a machine group dependency map. A machine group
 * dependency map includes all direct dependencies of a group of machines.
 *
 * @extends models['MapRequest']
 */
class MachineGroupMapRequest extends models['MapRequest'] {
  /**
   * Create a MachineGroupMapRequest.
   * @member {string} machineGroupId URI of machine group resource for which to
   * generate the map.
   * @member {boolean} [filterProcesses] If true, only processes between
   * grouped machines will be included. Any connections in or out of those
   * processes will be included.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of MachineGroupMapRequest
   *
   * @returns {object} metadata of MachineGroupMapRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'map:machine-group-dependency',
      type: {
        name: 'Composite',
        className: 'MachineGroupMapRequest',
        modelProperties: {
          startTime: {
            required: false,
            serializedName: 'startTime',
            type: {
              name: 'DateTime'
            }
          },
          endTime: {
            required: false,
            serializedName: 'endTime',
            type: {
              name: 'DateTime'
            }
          },
          kind: {
            required: true,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          machineGroupId: {
            required: true,
            serializedName: 'machineGroupId',
            type: {
              name: 'String'
            }
          },
          filterProcesses: {
            required: false,
            serializedName: 'filterProcesses',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = MachineGroupMapRequest;
