/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A machine reference with a hint of the machine's name and operating system.
 *
 * @extends models['ResourceReference']
 */
class MachineReferenceWithHints extends models['ResourceReference'] {
  /**
   * Create a MachineReferenceWithHints.
   * @member {string} [displayNameHint] Last known display name.
   * @member {string} [osFamilyHint] Last known operating system family.
   * Possible values include: 'unknown', 'windows', 'linux', 'solaris', 'aix'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of MachineReferenceWithHints
   *
   * @returns {object} metadata of MachineReferenceWithHints
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ref:machinewithhints',
      type: {
        name: 'Composite',
        className: 'MachineReferenceWithHints',
        modelProperties: {
          id: {
            required: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: true,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          displayNameHint: {
            required: false,
            readOnly: true,
            serializedName: 'properties.displayNameHint',
            type: {
              name: 'String'
            }
          },
          osFamilyHint: {
            required: false,
            readOnly: true,
            serializedName: 'properties.osFamilyHint',
            type: {
              name: 'Enum',
              allowedValues: [ 'unknown', 'windows', 'linux', 'solaris', 'aix' ]
            }
          }
        }
      }
    };
  }
}

module.exports = MachineReferenceWithHints;
