/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Specified the contents of a map response.
 *
 */
class MapResponse {
  /**
   * Create a MapResponse.
   * @member {date} startTime Map interval start time.
   * @member {date} endTime Map interval end time.
   * @member {object} map The generated map.
   * @member {object} [map.nodes]
   * @member {array} [map.nodes.machines] Machine resources.
   * @member {array} [map.nodes.processes] Process resources.
   * @member {array} [map.nodes.ports] Port resources.
   * @member {array} [map.nodes.clientGroups] Client Group resources.
   * @member {object} [map.edges]
   * @member {array} [map.edges.connections] Network connections.
   * @member {array} [map.edges.acceptors] Processes accepting on a port.
   */
  constructor() {
  }

  /**
   * Defines the metadata of MapResponse
   *
   * @returns {object} metadata of MapResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MapResponse',
      type: {
        name: 'Composite',
        className: 'MapResponse',
        modelProperties: {
          startTime: {
            required: true,
            serializedName: 'startTime',
            type: {
              name: 'DateTime'
            }
          },
          endTime: {
            required: true,
            serializedName: 'endTime',
            type: {
              name: 'DateTime'
            }
          },
          map: {
            required: true,
            serializedName: 'map',
            type: {
              name: 'Composite',
              className: 'Map'
            }
          }
        }
      }
    };
  }
}

module.exports = MapResponse;
