/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Specifies the computation of a single server dependency map. A single server
 * dependency map includes all direct dependencies of a given machine.
 *
 * @extends models['MapRequest']
 */
class SingleMachineDependencyMapRequest extends models['MapRequest'] {
  /**
   * Create a SingleMachineDependencyMapRequest.
   * @member {string} machineId URI of machine resource for which to generate
   * the map.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SingleMachineDependencyMapRequest
   *
   * @returns {object} metadata of SingleMachineDependencyMapRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'map:single-machine-dependency',
      type: {
        name: 'Composite',
        className: 'SingleMachineDependencyMapRequest',
        modelProperties: {
          startTime: {
            required: false,
            serializedName: 'startTime',
            type: {
              name: 'DateTime'
            }
          },
          endTime: {
            required: false,
            serializedName: 'endTime',
            type: {
              name: 'DateTime'
            }
          },
          kind: {
            required: true,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          machineId: {
            required: true,
            serializedName: 'machineId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SingleMachineDependencyMapRequest;
