/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A response indicating whether the specified name for a resource is
 * available.
 *
 */
class CheckNameAvailabilityResponse {
  /**
   * Create a CheckNameAvailabilityResponse.
   * @member {boolean} [available] True if the name is available, otherwise
   * false.
   * @member {string} [message] A message explaining why the name is
   * unavailable. Will be null if the name is available.
   * @member {string} [name] The name whose availability was checked.
   * @member {string} [reason] The reason code explaining why the name is
   * unavailable. Will be null if the name is available. Possible values
   * include: 'Invalid', 'AlreadyExists'
   */
  constructor() {
  }

  /**
   * Defines the metadata of CheckNameAvailabilityResponse
   *
   * @returns {object} metadata of CheckNameAvailabilityResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CheckNameAvailabilityResponse',
      type: {
        name: 'Composite',
        className: 'CheckNameAvailabilityResponse',
        modelProperties: {
          available: {
            required: false,
            readOnly: true,
            serializedName: 'available',
            type: {
              name: 'Boolean'
            }
          },
          message: {
            required: false,
            readOnly: true,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          reason: {
            required: false,
            readOnly: true,
            serializedName: 'reason',
            type: {
              name: 'Enum',
              allowedValues: [ 'Invalid', 'AlreadyExists' ]
            }
          }
        }
      }
    };
  }
}

module.exports = CheckNameAvailabilityResponse;
