/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The elastic pool edition capabilities.
 *
 */
class ElasticPoolEditionCapability {
  /**
   * Create a ElasticPoolEditionCapability.
   * @member {string} [name] The elastic pool edition name.
   * @member {string} [status] The status of the elastic pool edition. Possible
   * values include: 'Visible', 'Available', 'Default', 'Disabled'
   * @member {array} [supportedElasticPoolDtus] The list of supported elastic
   * pool DTU levels for the edition.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ElasticPoolEditionCapability
   *
   * @returns {object} metadata of ElasticPoolEditionCapability
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ElasticPoolEditionCapability',
      type: {
        name: 'Composite',
        className: 'ElasticPoolEditionCapability',
        modelProperties: {
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            readOnly: true,
            serializedName: 'status',
            type: {
              name: 'Enum',
              allowedValues: [ 'Visible', 'Available', 'Default', 'Disabled' ]
            }
          },
          supportedElasticPoolDtus: {
            required: false,
            readOnly: true,
            serializedName: 'supportedElasticPoolDtus',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ElasticPoolDtuCapabilityElementType',
                  type: {
                    name: 'Composite',
                    className: 'ElasticPoolDtuCapability'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ElasticPoolEditionCapability;
