/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The server encryption protector.
 *
 * @extends models['ProxyResource']
 */
class EncryptionProtector extends models['ProxyResource'] {
  /**
   * Create a EncryptionProtector.
   * @member {string} [kind] Kind of encryption protector. This is metadata
   * used for the Azure portal experience.
   * @member {string} [location] Resource location.
   * @member {string} [subregion] Subregion of the encryption protector.
   * @member {string} [serverKeyName] The name of the server key.
   * @member {string} serverKeyType The encryption protector type like
   * 'ServiceManaged', 'AzureKeyVault'. Possible values include:
   * 'ServiceManaged', 'AzureKeyVault'
   * @member {string} [uri] The URI of the server key.
   * @member {string} [thumbprint] Thumbprint of the server key.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of EncryptionProtector
   *
   * @returns {object} metadata of EncryptionProtector
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EncryptionProtector',
      type: {
        name: 'Composite',
        className: 'EncryptionProtector',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            readOnly: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          subregion: {
            required: false,
            readOnly: true,
            serializedName: 'properties.subregion',
            type: {
              name: 'String'
            }
          },
          serverKeyName: {
            required: false,
            serializedName: 'properties.serverKeyName',
            type: {
              name: 'String'
            }
          },
          serverKeyType: {
            required: true,
            serializedName: 'properties.serverKeyType',
            type: {
              name: 'String'
            }
          },
          uri: {
            required: false,
            readOnly: true,
            serializedName: 'properties.uri',
            type: {
              name: 'String'
            }
          },
          thumbprint: {
            required: false,
            readOnly: true,
            serializedName: 'properties.thumbprint',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = EncryptionProtector;
