/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Export database parameters.
 *
 */
class ExportRequest {
  /**
   * Create a ExportRequest.
   * @member {string} storageKeyType The type of the storage key to use.
   * Possible values include: 'StorageAccessKey', 'SharedAccessKey'
   * @member {string} storageKey The storage key to use.  If storage key type
   * is SharedAccessKey, it must be preceded with a "?."
   * @member {string} storageUri The storage uri to use.
   * @member {string} administratorLogin The name of the SQL administrator.
   * @member {string} administratorLoginPassword The password of the SQL
   * administrator.
   * @member {string} [authenticationType] The authentication type. Possible
   * values include: 'SQL', 'ADPassword'. Default value: 'SQL' .
   */
  constructor() {
  }

  /**
   * Defines the metadata of ExportRequest
   *
   * @returns {object} metadata of ExportRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ExportRequest',
      type: {
        name: 'Composite',
        className: 'ExportRequest',
        modelProperties: {
          storageKeyType: {
            required: true,
            serializedName: 'storageKeyType',
            type: {
              name: 'Enum',
              allowedValues: [ 'StorageAccessKey', 'SharedAccessKey' ]
            }
          },
          storageKey: {
            required: true,
            serializedName: 'storageKey',
            type: {
              name: 'String'
            }
          },
          storageUri: {
            required: true,
            serializedName: 'storageUri',
            type: {
              name: 'String'
            }
          },
          administratorLogin: {
            required: true,
            serializedName: 'administratorLogin',
            type: {
              name: 'String'
            }
          },
          administratorLoginPassword: {
            required: true,
            serializedName: 'administratorLoginPassword',
            type: {
              name: 'String'
            }
          },
          authenticationType: {
            required: false,
            serializedName: 'authenticationType',
            defaultValue: 'SQL',
            type: {
              name: 'Enum',
              allowedValues: [ 'SQL', 'ADPassword' ]
            }
          }
        }
      }
    };
  }
}

module.exports = ExportRequest;
