/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The capabilities for a location.
 *
 */
class LocationCapabilities {
  /**
   * Create a LocationCapabilities.
   * @member {string} [name] The location name.
   * @member {string} [status] Azure SQL Database's status for the location.
   * Possible values include: 'Visible', 'Available', 'Default', 'Disabled'
   * @member {array} [supportedServerVersions] The list of supported server
   * versions.
   */
  constructor() {
  }

  /**
   * Defines the metadata of LocationCapabilities
   *
   * @returns {object} metadata of LocationCapabilities
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LocationCapabilities',
      type: {
        name: 'Composite',
        className: 'LocationCapabilities',
        modelProperties: {
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            readOnly: true,
            serializedName: 'status',
            type: {
              name: 'Enum',
              allowedValues: [ 'Visible', 'Available', 'Default', 'Disabled' ]
            }
          },
          supportedServerVersions: {
            required: false,
            readOnly: true,
            serializedName: 'supportedServerVersions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ServerVersionCapabilityElementType',
                  type: {
                    name: 'Composite',
                    className: 'ServerVersionCapability'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = LocationCapabilities;
