/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * SQL REST API operation definition.
 *
 */
class Operation {
  /**
   * Create a Operation.
   * @member {string} [name] The name of the operation being performed on this
   * particular object.
   * @member {object} [display] The localized display information for this
   * particular operation / action.
   * @member {string} [display.provider] The localized friendly form of the
   * resource provider name.
   * @member {string} [display.resource] The localized friendly form of the
   * resource type related to this action/operation.
   * @member {string} [display.operation] The localized friendly name for the
   * operation.
   * @member {string} [display.description] The localized friendly description
   * for the operation.
   * @member {string} [origin] The intended executor of the operation. Possible
   * values include: 'user', 'system'
   * @member {object} [properties] Additional descriptions for the operation.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Operation
   *
   * @returns {object} metadata of Operation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Operation',
      type: {
        name: 'Composite',
        className: 'Operation',
        modelProperties: {
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          display: {
            required: false,
            readOnly: true,
            serializedName: 'display',
            type: {
              name: 'Composite',
              className: 'OperationDisplay'
            }
          },
          origin: {
            required: false,
            readOnly: true,
            serializedName: 'origin',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            readOnly: true,
            serializedName: 'properties',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'ObjectElementType',
                  type: {
                    name: 'Object'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = Operation;
