/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The impact of an operation, both in absolute and relative terms.
 *
 */
class OperationImpact {
  /**
   * Create a OperationImpact.
   * @member {string} [name] The name of the impact dimension.
   * @member {string} [unit] The unit in which estimated impact to dimension is
   * measured.
   * @member {number} [changeValueAbsolute] The absolute impact to dimension.
   * @member {number} [changeValueRelative] The relative impact to dimension
   * (null if not applicable)
   */
  constructor() {
  }

  /**
   * Defines the metadata of OperationImpact
   *
   * @returns {object} metadata of OperationImpact
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OperationImpact',
      type: {
        name: 'Composite',
        className: 'OperationImpact',
        modelProperties: {
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          unit: {
            required: false,
            readOnly: true,
            serializedName: 'unit',
            type: {
              name: 'String'
            }
          },
          changeValueAbsolute: {
            required: false,
            readOnly: true,
            serializedName: 'changeValueAbsolute',
            type: {
              name: 'Number'
            }
          },
          changeValueRelative: {
            required: false,
            readOnly: true,
            serializedName: 'changeValueRelative',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = OperationImpact;
