/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Partner server information for the failover group.
 *
 */
class PartnerInfo {
  /**
   * Create a PartnerInfo.
   * @member {string} id Resource identifier of the partner server.
   * @member {string} [location] Geo location of the partner server.
   * @member {string} [replicationRole] Replication role of the partner server.
   * Possible values include: 'Primary', 'Secondary'
   */
  constructor() {
  }

  /**
   * Defines the metadata of PartnerInfo
   *
   * @returns {object} metadata of PartnerInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PartnerInfo',
      type: {
        name: 'Composite',
        className: 'PartnerInfo',
        modelProperties: {
          id: {
            required: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            readOnly: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          replicationRole: {
            required: false,
            readOnly: true,
            serializedName: 'replicationRole',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = PartnerInfo;
