/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents recommended elastic pool metric.
 *
 */
class RecommendedElasticPoolMetric {
  /**
   * Create a RecommendedElasticPoolMetric.
   * @member {date} [dateTime] The time of metric (ISO8601 format).
   * @member {number} [dtu] Gets or sets the DTUs (Database Transaction Units).
   * See
   * https://azure.microsoft.com/documentation/articles/sql-database-what-is-a-dtu/
   * @member {number} [sizeGB] Gets or sets size in gigabytes.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RecommendedElasticPoolMetric
   *
   * @returns {object} metadata of RecommendedElasticPoolMetric
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RecommendedElasticPoolMetric',
      type: {
        name: 'Composite',
        className: 'RecommendedElasticPoolMetric',
        modelProperties: {
          dateTime: {
            required: false,
            serializedName: 'dateTime',
            type: {
              name: 'DateTime'
            }
          },
          dtu: {
            required: false,
            serializedName: 'dtu',
            type: {
              name: 'Number'
            }
          },
          sizeGB: {
            required: false,
            serializedName: 'sizeGB',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = RecommendedElasticPoolMetric;
