/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Properties of sync group schema.
 *
 */
class SyncGroupSchema {
  /**
   * Create a SyncGroupSchema.
   * @member {array} [tables] List of tables in sync group schema.
   * @member {string} [masterSyncMemberName] Name of master sync member where
   * the schema is from.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SyncGroupSchema
   *
   * @returns {object} metadata of SyncGroupSchema
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SyncGroupSchema',
      type: {
        name: 'Composite',
        className: 'SyncGroupSchema',
        modelProperties: {
          tables: {
            required: false,
            serializedName: 'tables',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'SyncGroupSchemaTableElementType',
                  type: {
                    name: 'Composite',
                    className: 'SyncGroupSchemaTable'
                  }
              }
            }
          },
          masterSyncMemberName: {
            required: false,
            serializedName: 'masterSyncMemberName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SyncGroupSchema;
