/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties of key vault.
 *
 */
class KeyVaultProperties {
  /**
   * Create a KeyVaultProperties.
   * @member {string} [keyName] The name of KeyVault key.
   * @member {string} [keyVersion] The version of KeyVault key.
   * @member {string} [keyVaultUri] The Uri of KeyVault.
   */
  constructor() {
  }

  /**
   * Defines the metadata of KeyVaultProperties
   *
   * @returns {object} metadata of KeyVaultProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'KeyVaultProperties',
      type: {
        name: 'Composite',
        className: 'KeyVaultProperties',
        modelProperties: {
          keyName: {
            required: false,
            serializedName: 'keyname',
            type: {
              name: 'String'
            }
          },
          keyVersion: {
            required: false,
            serializedName: 'keyversion',
            type: {
              name: 'String'
            }
          },
          keyVaultUri: {
            required: false,
            serializedName: 'keyvaulturi',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = KeyVaultProperties;
