/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The capability information in the specified sku, including file encryption,
 * network acls, change notification, etc.
 *
 */
class SKUCapability {
  /**
   * Create a SKUCapability.
   * @member {string} [name] The name of capability, The capability information
   * in the specified sku, including file encryption, network acls, change
   * notification, etc.
   * @member {string} [value] A string value to indicate states of given
   * capability. Possibly 'true' or 'false'.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SKUCapability
   *
   * @returns {object} metadata of SKUCapability
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SKUCapability',
      type: {
        name: 'Composite',
        className: 'SKUCapability',
        modelProperties: {
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          value: {
            required: false,
            readOnly: true,
            serializedName: 'value',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SKUCapability;
