/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Describes the error information.
 *
 * @extends models['ErrorBase']
 */
class ErrorInfo extends models['ErrorBase'] {
  /**
   * Create a ErrorInfo.
   * @member {array} [details] Describes the error details if present.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ErrorInfo
   *
   * @returns {object} metadata of ErrorInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ErrorInfo',
      type: {
        name: 'Composite',
        className: 'ErrorInfo',
        modelProperties: {
          code: {
            required: false,
            serializedName: 'code',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          },
          target: {
            required: false,
            serializedName: 'target',
            type: {
              name: 'String'
            }
          },
          details: {
            required: false,
            serializedName: 'details',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ErrorBaseElementType',
                  type: {
                    name: 'Composite',
                    className: 'ErrorBase'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ErrorInfo;
