/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Provides information about the Microsoft datacenter to which the drives
 * should be shipped.
 *
 */
class ShippingInformation {
  /**
   * Create a ShippingInformation.
   * @member {string} name The name of the recipient at the datacenter.
   * @member {string} address The address of the datacenter.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ShippingInformation
   *
   * @returns {object} metadata of ShippingInformation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ShippingInformation',
      type: {
        name: 'Composite',
        className: 'ShippingInformation',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          address: {
            required: true,
            serializedName: 'address',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ShippingInformation;
