/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The access control record.
 *
 * @extends models['BaseModel']
 */
class AccessControlRecord extends models['BaseModel'] {
  /**
   * Create a AccessControlRecord.
   * @member {string} initiatorName The iSCSI initiator name (IQN).
   * @member {number} [volumeCount] The number of volumes using the access
   * control record.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AccessControlRecord
   *
   * @returns {object} metadata of AccessControlRecord
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AccessControlRecord',
      type: {
        name: 'Composite',
        className: 'AccessControlRecord',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'Enum',
              allowedValues: [ 'Series8000' ]
            }
          },
          initiatorName: {
            required: true,
            serializedName: 'properties.initiatorName',
            type: {
              name: 'String'
            }
          },
          volumeCount: {
            required: false,
            readOnly: true,
            serializedName: 'properties.volumeCount',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = AccessControlRecord;
