/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The OData filters to be used for backups.
 *
 */
class BackupFilter {
  /**
   * Create a BackupFilter.
   * @member {string} [backupPolicyId] Specifies the backupPolicyId of the
   * backups to be filtered. Only 'Equality' operator is supported for this
   * property.
   * @member {string} [volumeId] Specifies the volumeId of the backups to be
   * filtered. Only 'Equality' operator is supported for this property.
   * @member {date} [createdTime] Specifies the creation time of the backups to
   * be filtered. Only 'Greater Than or Equal To' and 'Lesser Than or Equal To'
   * operators are supported for this property.
   */
  constructor() {
  }

  /**
   * Defines the metadata of BackupFilter
   *
   * @returns {object} metadata of BackupFilter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BackupFilter',
      type: {
        name: 'Composite',
        className: 'BackupFilter',
        modelProperties: {
          backupPolicyId: {
            required: false,
            serializedName: 'backupPolicyId',
            type: {
              name: 'String'
            }
          },
          volumeId: {
            required: false,
            serializedName: 'volumeId',
            type: {
              name: 'String'
            }
          },
          createdTime: {
            required: false,
            serializedName: 'createdTime',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = BackupFilter;
