/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The bandwidth setting.
 *
 * @extends models['BaseModel']
 */
class BandwidthSetting extends models['BaseModel'] {
  /**
   * Create a BandwidthSetting.
   * @member {array} schedules The schedules.
   * @member {number} [volumeCount] The number of volumes that uses the
   * bandwidth setting.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of BandwidthSetting
   *
   * @returns {object} metadata of BandwidthSetting
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BandwidthSetting',
      type: {
        name: 'Composite',
        className: 'BandwidthSetting',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'Enum',
              allowedValues: [ 'Series8000' ]
            }
          },
          schedules: {
            required: true,
            serializedName: 'properties.schedules',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'BandwidthScheduleElementType',
                  type: {
                    name: 'Composite',
                    className: 'BandwidthSchedule'
                  }
              }
            }
          },
          volumeCount: {
            required: false,
            readOnly: true,
            serializedName: 'properties.volumeCount',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = BandwidthSetting;
