/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The request for clearing the alert
 *
 */
class ClearAlertRequest {
  /**
   * Create a ClearAlertRequest.
   * @member {string} [resolutionMessage] The resolution message while clearing
   * the alert
   * @member {array} alerts The list of alert IDs to be cleared
   */
  constructor() {
  }

  /**
   * Defines the metadata of ClearAlertRequest
   *
   * @returns {object} metadata of ClearAlertRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ClearAlertRequest',
      type: {
        name: 'Composite',
        className: 'ClearAlertRequest',
        modelProperties: {
          resolutionMessage: {
            required: false,
            serializedName: 'resolutionMessage',
            type: {
              name: 'String'
            }
          },
          alerts: {
            required: true,
            serializedName: 'alerts',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ClearAlertRequest;
