/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The cloud appliance configuration
 *
 * @extends models['BaseModel']
 */
class CloudApplianceConfiguration extends models['BaseModel'] {
  /**
   * Create a CloudApplianceConfiguration.
   * @member {string} modelNumber The model number.
   * @member {string} cloudPlatform The cloud platform.
   * @member {object} acsConfiguration The ACS configuration.
   * @member {string} [acsConfiguration.namespace] The namespace.
   * @member {string} [acsConfiguration.realm] The realm.
   * @member {string} [acsConfiguration.serviceUrl] The service URL.
   * @member {array} supportedStorageAccountTypes The supported storage account
   * types.
   * @member {array} supportedRegions The supported regions.
   * @member {array} supportedVmTypes The supported virtual machine types.
   * @member {array} supportedVmImages The supported virtual machine images.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of CloudApplianceConfiguration
   *
   * @returns {object} metadata of CloudApplianceConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CloudApplianceConfiguration',
      type: {
        name: 'Composite',
        className: 'CloudApplianceConfiguration',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'Enum',
              allowedValues: [ 'Series8000' ]
            }
          },
          modelNumber: {
            required: true,
            serializedName: 'properties.modelNumber',
            type: {
              name: 'String'
            }
          },
          cloudPlatform: {
            required: true,
            serializedName: 'properties.cloudPlatform',
            type: {
              name: 'String'
            }
          },
          acsConfiguration: {
            required: true,
            serializedName: 'properties.acsConfiguration',
            type: {
              name: 'Composite',
              className: 'AcsConfiguration'
            }
          },
          supportedStorageAccountTypes: {
            required: true,
            serializedName: 'properties.supportedStorageAccountTypes',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          supportedRegions: {
            required: true,
            serializedName: 'properties.supportedRegions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          supportedVmTypes: {
            required: true,
            serializedName: 'properties.supportedVmTypes',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          supportedVmImages: {
            required: true,
            serializedName: 'properties.supportedVmImages',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'VmImageElementType',
                  type: {
                    name: 'Composite',
                    className: 'VmImage'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = CloudApplianceConfiguration;
