/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The cloud appliance settings.
 *
 */
class CloudApplianceSettings {
  /**
   * Create a CloudApplianceSettings.
   * @member {object} [serviceDataEncryptionKey] The service data encryption
   * key (encrypted with DAK).
   * @member {string} [serviceDataEncryptionKey.value] The value of the secret.
   * @member {string} [serviceDataEncryptionKey.encryptionCertThumbprint]
   * Thumbprint certificate that was used to encrypt "Value". If the value in
   * unencrypted, it will be null.
   * @member {string} [serviceDataEncryptionKey.encryptionAlgorithm] The
   * algorithm used to encrypt "Value". Possible values include: 'None',
   * 'AES256', 'RSAES_PKCS1_v_1_5'
   * @member {object} [channelIntegrityKey] The channel integrity key
   * (encrypted with DAK).
   * @member {string} [channelIntegrityKey.value] The value of the secret.
   * @member {string} [channelIntegrityKey.encryptionCertThumbprint] Thumbprint
   * certificate that was used to encrypt "Value". If the value in unencrypted,
   * it will be null.
   * @member {string} [channelIntegrityKey.encryptionAlgorithm] The algorithm
   * used to encrypt "Value". Possible values include: 'None', 'AES256',
   * 'RSAES_PKCS1_v_1_5'
   */
  constructor() {
  }

  /**
   * Defines the metadata of CloudApplianceSettings
   *
   * @returns {object} metadata of CloudApplianceSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CloudApplianceSettings',
      type: {
        name: 'Composite',
        className: 'CloudApplianceSettings',
        modelProperties: {
          serviceDataEncryptionKey: {
            required: false,
            serializedName: 'serviceDataEncryptionKey',
            type: {
              name: 'Composite',
              className: 'AsymmetricEncryptedSecret'
            }
          },
          channelIntegrityKey: {
            required: false,
            serializedName: 'channelIntegrityKey',
            type: {
              name: 'Composite',
              className: 'AsymmetricEncryptedSecret'
            }
          }
        }
      }
    };
  }
}

module.exports = CloudApplianceSettings;
