/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The DNS(Domain Name Server) settings of a device.
 *
 */
class DNSSettings {
  /**
   * Create a DNSSettings.
   * @member {string} [primaryDnsServer] The primary IPv4 DNS server for the
   * device
   * @member {string} [primaryIpv6DnsServer] The primary IPv6 DNS server for
   * the device
   * @member {array} [secondaryDnsServers] The secondary IPv4 DNS server for
   * the device
   * @member {array} [secondaryIpv6DnsServers] The secondary IPv6 DNS server
   * for the device
   */
  constructor() {
  }

  /**
   * Defines the metadata of DNSSettings
   *
   * @returns {object} metadata of DNSSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DNSSettings',
      type: {
        name: 'Composite',
        className: 'DNSSettings',
        modelProperties: {
          primaryDnsServer: {
            required: false,
            serializedName: 'primaryDnsServer',
            type: {
              name: 'String'
            }
          },
          primaryIpv6DnsServer: {
            required: false,
            serializedName: 'primaryIpv6DnsServer',
            type: {
              name: 'String'
            }
          },
          secondaryDnsServers: {
            required: false,
            serializedName: 'secondaryDnsServers',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          secondaryIpv6DnsServers: {
            required: false,
            serializedName: 'secondaryIpv6DnsServers',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = DNSSettings;
