/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The additional details related to the data related statistics of a job.
 * Currently applicable only for Backup, Clone and Restore jobs.
 *
 */
class DataStatistics {
  /**
   * Create a DataStatistics.
   * @member {number} [totalData] The total bytes of data to be processed, as
   * part of the job.
   * @member {number} [processedData] The number of bytes of data processed
   * till now, as part of the job.
   * @member {number} [cloudData] The number of bytes of data written to cloud,
   * as part of the job.
   * @member {number} [throughput] The average throughput of data
   * processed(bytes/sec), as part of the job.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DataStatistics
   *
   * @returns {object} metadata of DataStatistics
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DataStatistics',
      type: {
        name: 'Composite',
        className: 'DataStatistics',
        modelProperties: {
          totalData: {
            required: false,
            serializedName: 'totalData',
            type: {
              name: 'Number'
            }
          },
          processedData: {
            required: false,
            serializedName: 'processedData',
            type: {
              name: 'Number'
            }
          },
          cloudData: {
            required: false,
            serializedName: 'cloudData',
            type: {
              name: 'Number'
            }
          },
          throughput: {
            required: false,
            serializedName: 'throughput',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = DataStatistics;
