/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The feature.
 *
 */
class Feature {
  /**
   * Create a Feature.
   * @member {string} name The name of the feature.
   * @member {string} status The feature support status. Possible values
   * include: 'NotAvailable', 'UnsupportedDeviceVersion', 'Supported'
   */
  constructor() {
  }

  /**
   * Defines the metadata of Feature
   *
   * @returns {object} metadata of Feature
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Feature',
      type: {
        name: 'Composite',
        className: 'Feature',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          status: {
            required: true,
            serializedName: 'status',
            type: {
              name: 'Enum',
              allowedValues: [ 'NotAvailable', 'UnsupportedDeviceVersion', 'Supported' ]
            }
          }
        }
      }
    };
  }
}

module.exports = Feature;
