/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The job error items.
 *
 */
class JobErrorItem {
  /**
   * Create a JobErrorItem.
   * @member {array} [recommendations] The recommended actions.
   * @member {string} code The error code intended for programmatic access.
   * @member {string} message The error message intended to describe the error
   * in detail.
   */
  constructor() {
  }

  /**
   * Defines the metadata of JobErrorItem
   *
   * @returns {object} metadata of JobErrorItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'JobErrorItem',
      type: {
        name: 'Composite',
        className: 'JobErrorItem',
        modelProperties: {
          recommendations: {
            required: false,
            serializedName: 'recommendations',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          code: {
            required: true,
            serializedName: 'code',
            type: {
              name: 'String'
            }
          },
          message: {
            required: true,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = JobErrorItem;
