/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The OData filter to be used for jobs.
 *
 */
class JobFilter {
  /**
   * Create a JobFilter.
   * @member {string} [status] Specifies the status of the jobs to be filtered.
   * For e.g., "Running", "Succeeded", "Failed" or "Canceled". Only 'Equality'
   * operator is supported for this property.
   * @member {string} [jobType] Specifies the type of the jobs to be filtered.
   * For e.g., "ScheduledBackup", "ManualBackup", "RestoreBackup",
   * "CloneVolume", "FailoverVolumeContainers", "CreateLocallyPinnedVolume",
   * "ModifyVolume", "InstallUpdates", "SupportPackageLogs", or
   * "CreateCloudAppliance". Only 'Equality' operator can be used for this
   * property.
   * @member {date} [startTime] Specifies the start time of the jobs to be
   * filtered.  Only 'Greater Than or Equal To' and 'Lesser Than or Equal To'
   * operators are supported for this property.
   */
  constructor() {
  }

  /**
   * Defines the metadata of JobFilter
   *
   * @returns {object} metadata of JobFilter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'JobFilter',
      type: {
        name: 'Composite',
        className: 'JobFilter',
        modelProperties: {
          status: {
            required: false,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          },
          jobType: {
            required: false,
            serializedName: 'jobType',
            type: {
              name: 'String'
            }
          },
          startTime: {
            required: false,
            serializedName: 'startTime',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = JobFilter;
