/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Intrinsic settings which refers to the type of the Storsimple Manager.
 *
 */
class ManagerIntrinsicSettings {
  /**
   * Create a ManagerIntrinsicSettings.
   * @member {string} type The type of StorSimple Manager. Possible values
   * include: 'GardaV1', 'HelsinkiV1'
   */
  constructor() {
  }

  /**
   * Defines the metadata of ManagerIntrinsicSettings
   *
   * @returns {object} metadata of ManagerIntrinsicSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ManagerIntrinsicSettings',
      type: {
        name: 'Composite',
        className: 'ManagerIntrinsicSettings',
        modelProperties: {
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'Enum',
              allowedValues: [ 'GardaV1', 'HelsinkiV1' ]
            }
          }
        }
      }
    };
  }
}

module.exports = ManagerIntrinsicSettings;
