/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The metric data.
 *
 */
class MetricData {
  /**
   * Create a MetricData.
   * @member {date} [timeStamp] The time stamp of the metric data.
   * @member {number} [sum] The sum of all samples at the time stamp.
   * @member {number} [count] The count of all samples at the time stamp.
   * @member {number} [average] The average of all samples at the time stamp.
   * @member {number} [minimum] The minimum of all samples at the time stamp.
   * @member {number} [maximum] The maximum of all samples at the time stamp.
   */
  constructor() {
  }

  /**
   * Defines the metadata of MetricData
   *
   * @returns {object} metadata of MetricData
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MetricData',
      type: {
        name: 'Composite',
        className: 'MetricData',
        modelProperties: {
          timeStamp: {
            required: false,
            serializedName: 'timeStamp',
            type: {
              name: 'DateTime'
            }
          },
          sum: {
            required: false,
            serializedName: 'sum',
            type: {
              name: 'Number'
            }
          },
          count: {
            required: false,
            serializedName: 'count',
            type: {
              name: 'Number'
            }
          },
          average: {
            required: false,
            serializedName: 'average',
            type: {
              name: 'Number'
            }
          },
          minimum: {
            required: false,
            serializedName: 'minimum',
            type: {
              name: 'Number'
            }
          },
          maximum: {
            required: false,
            serializedName: 'maximum',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = MetricData;
