/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The settings for updating remote management mode of the device.
 *
 */
class RemoteManagementSettingsPatch {
  /**
   * Create a RemoteManagementSettingsPatch.
   * @member {string} remoteManagementMode The remote management mode. Possible
   * values include: 'Unknown', 'Disabled', 'HttpsEnabled',
   * 'HttpsAndHttpEnabled'
   */
  constructor() {
  }

  /**
   * Defines the metadata of RemoteManagementSettingsPatch
   *
   * @returns {object} metadata of RemoteManagementSettingsPatch
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RemoteManagementSettingsPatch',
      type: {
        name: 'Composite',
        className: 'RemoteManagementSettingsPatch',
        modelProperties: {
          remoteManagementMode: {
            required: true,
            serializedName: 'remoteManagementMode',
            type: {
              name: 'Enum',
              allowedValues: [ 'Unknown', 'Disabled', 'HttpsEnabled', 'HttpsAndHttpEnabled' ]
            }
          }
        }
      }
    };
  }
}

module.exports = RemoteManagementSettingsPatch;
