/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents the secrets encrypted using Symmetric Encryption Key.
 *
 */
class SymmetricEncryptedSecret {
  /**
   * Create a SymmetricEncryptedSecret.
   * @member {string} value The value of the secret itself. If the secret is in
   * plaintext or null then EncryptionAlgorithm will be none.
   * @member {string} [valueCertificateThumbprint] The thumbprint of the cert
   * that was used to encrypt "Value".
   * @member {string} encryptionAlgorithm The algorithm used to encrypt the
   * "Value". Possible values include: 'None', 'AES256', 'RSAES_PKCS1_v_1_5'
   */
  constructor() {
  }

  /**
   * Defines the metadata of SymmetricEncryptedSecret
   *
   * @returns {object} metadata of SymmetricEncryptedSecret
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SymmetricEncryptedSecret',
      type: {
        name: 'Composite',
        className: 'SymmetricEncryptedSecret',
        modelProperties: {
          value: {
            required: true,
            serializedName: 'value',
            type: {
              name: 'String'
            }
          },
          valueCertificateThumbprint: {
            required: false,
            serializedName: 'valueCertificateThumbprint',
            type: {
              name: 'String'
            }
          },
          encryptionAlgorithm: {
            required: true,
            serializedName: 'encryptionAlgorithm',
            type: {
              name: 'Enum',
              allowedValues: [ 'None', 'AES256', 'RSAES_PKCS1_v_1_5' ]
            }
          }
        }
      }
    };
  }
}

module.exports = SymmetricEncryptedSecret;
