/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The web proxy settings on the device.
 *
 */
class WebproxySettings {
  /**
   * Create a WebproxySettings.
   * @member {string} [connectionUri] The connection URI.
   * @member {string} authentication The authentication type. Possible values
   * include: 'Invalid', 'None', 'Basic', 'NTLM'
   * @member {string} username The webproxy username.
   */
  constructor() {
  }

  /**
   * Defines the metadata of WebproxySettings
   *
   * @returns {object} metadata of WebproxySettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'WebproxySettings',
      type: {
        name: 'Composite',
        className: 'WebproxySettings',
        modelProperties: {
          connectionUri: {
            required: false,
            serializedName: 'connectionUri',
            type: {
              name: 'String'
            }
          },
          authentication: {
            required: true,
            serializedName: 'authentication',
            type: {
              name: 'Enum',
              allowedValues: [ 'Invalid', 'None', 'Basic', 'NTLM' ]
            }
          },
          username: {
            required: true,
            serializedName: 'username',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = WebproxySettings;
