/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Describes how data from an input is serialized or how data is serialized
 * when written to an output in Avro format.
 *
 * @extends models['Serialization']
 */
class AvroSerialization extends models['Serialization'] {
  /**
   * Create a AvroSerialization.
   * @member {object} [properties] The properties that are associated with the
   * Avro serialization type. Required on PUT (CreateOrReplace) requests.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AvroSerialization
   *
   * @returns {object} metadata of AvroSerialization
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Avro',
      type: {
        name: 'Composite',
        className: 'AvroSerialization',
        modelProperties: {
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = AvroSerialization;
