/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The inputs for the Azure Machine Learning web service endpoint.
 *
 */
class AzureMachineLearningWebServiceInputs {
  /**
   * Create a AzureMachineLearningWebServiceInputs.
   * @member {string} [name] The name of the input. This is the name provided
   * while authoring the endpoint.
   * @member {array} [columnNames] A list of input columns for the Azure
   * Machine Learning web service endpoint.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureMachineLearningWebServiceInputs
   *
   * @returns {object} metadata of AzureMachineLearningWebServiceInputs
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureMachineLearningWebServiceInputs',
      type: {
        name: 'Composite',
        className: 'AzureMachineLearningWebServiceInputs',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          columnNames: {
            required: false,
            serializedName: 'columnNames',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'AzureMachineLearningWebServiceInputColumnElementType',
                  type: {
                    name: 'Composite',
                    className: 'AzureMachineLearningWebServiceInputColumn'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = AzureMachineLearningWebServiceInputs;
