/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Describes conditions applicable to the Input, Output, or the job overall,
 * that warrant customer attention.
 *
 */
class Diagnostics {
  /**
   * Create a Diagnostics.
   * @member {array} [conditions] A collection of zero or more conditions
   * applicable to the resource, or to the job overall, that warrant customer
   * attention.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Diagnostics
   *
   * @returns {object} metadata of Diagnostics
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Diagnostics',
      type: {
        name: 'Composite',
        className: 'Diagnostics',
        modelProperties: {
          conditions: {
            required: false,
            readOnly: true,
            serializedName: 'conditions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'DiagnosticConditionElementType',
                  type: {
                    name: 'Composite',
                    className: 'DiagnosticCondition'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = Diagnostics;
