/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes one input parameter of a function.
 *
 */
class FunctionInput {
  /**
   * Create a FunctionInput.
   * @member {string} [dataType] The (Azure Stream Analytics supported) data
   * type of the function input parameter. A list of valid Azure Stream
   * Analytics data types are described at
   * https://msdn.microsoft.com/en-us/library/azure/dn835065.aspx
   * @member {boolean} [isConfigurationParameter] A flag indicating if the
   * parameter is a configuration parameter. True if this input parameter is
   * expected to be a constant. Default is false.
   */
  constructor() {
  }

  /**
   * Defines the metadata of FunctionInput
   *
   * @returns {object} metadata of FunctionInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FunctionInput',
      type: {
        name: 'Composite',
        className: 'FunctionInput',
        modelProperties: {
          dataType: {
            required: false,
            serializedName: 'dataType',
            type: {
              name: 'String'
            }
          },
          isConfigurationParameter: {
            required: false,
            serializedName: 'isConfigurationParameter',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = FunctionInput;
