/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

var msRestAzure = require('ms-rest-azure');

exports.BaseResource = msRestAzure.BaseResource;
exports.CloudError = msRestAzure.CloudError;
exports.OperationDisplay = require('./operationDisplay');
exports.Operation = require('./operation');
exports.Sku = require('./sku');
exports.Serialization = require('./serialization');
exports.DiagnosticCondition = require('./diagnosticCondition');
exports.Diagnostics = require('./diagnostics');
exports.InputProperties = require('./inputProperties');
exports.SubResource = require('./subResource');
exports.Input = require('./input');
exports.Transformation = require('./transformation');
exports.OutputDataSource = require('./outputDataSource');
exports.Output = require('./output');
exports.FunctionProperties = require('./functionProperties');
exports.FunctionModel = require('./functionModel');
exports.Resource = require('./resource');
exports.StreamingJob = require('./streamingJob');
exports.StartStreamingJobParameters = require('./startStreamingJobParameters');
exports.FunctionBinding = require('./functionBinding');
exports.JavaScriptFunctionBinding = require('./javaScriptFunctionBinding');
exports.AzureMachineLearningWebServiceOutputColumn = require('./azureMachineLearningWebServiceOutputColumn');
exports.AzureMachineLearningWebServiceInputColumn = require('./azureMachineLearningWebServiceInputColumn');
exports.AzureMachineLearningWebServiceInputs = require('./azureMachineLearningWebServiceInputs');
exports.AzureMachineLearningWebServiceFunctionBinding = require('./azureMachineLearningWebServiceFunctionBinding');
exports.FunctionOutput = require('./functionOutput');
exports.FunctionInput = require('./functionInput');
exports.ScalarFunctionProperties = require('./scalarFunctionProperties');
exports.FunctionRetrieveDefaultDefinitionParameters = require('./functionRetrieveDefaultDefinitionParameters');
exports.JavaScriptFunctionRetrieveDefaultDefinitionParameters = require('./javaScriptFunctionRetrieveDefaultDefinitionParameters');
exports.AzureMachineLearningWebServiceFunctionRetrieveDefaultDefinitionParameters = require('./azureMachineLearningWebServiceFunctionRetrieveDefaultDefinitionParameters');
exports.AvroSerialization = require('./avroSerialization');
exports.JsonSerialization = require('./jsonSerialization');
exports.CsvSerialization = require('./csvSerialization');
exports.OAuthBasedDataSourceProperties = require('./oAuthBasedDataSourceProperties');
exports.AzureDataLakeStoreOutputDataSource = require('./azureDataLakeStoreOutputDataSource');
exports.PowerBIOutputDataSource = require('./powerBIOutputDataSource');
exports.ServiceBusDataSourceProperties = require('./serviceBusDataSourceProperties');
exports.EventHubDataSourceProperties = require('./eventHubDataSourceProperties');
exports.ServiceBusTopicOutputDataSource = require('./serviceBusTopicOutputDataSource');
exports.ServiceBusQueueOutputDataSource = require('./serviceBusQueueOutputDataSource');
exports.DocumentDbOutputDataSource = require('./documentDbOutputDataSource');
exports.AzureSqlDatabaseDataSourceProperties = require('./azureSqlDatabaseDataSourceProperties');
exports.AzureSqlDatabaseOutputDataSource = require('./azureSqlDatabaseOutputDataSource');
exports.EventHubOutputDataSource = require('./eventHubOutputDataSource');
exports.AzureTableOutputDataSource = require('./azureTableOutputDataSource');
exports.StorageAccount = require('./storageAccount');
exports.BlobDataSourceProperties = require('./blobDataSourceProperties');
exports.BlobOutputDataSource = require('./blobOutputDataSource');
exports.ReferenceInputDataSource = require('./referenceInputDataSource');
exports.BlobReferenceInputDataSource = require('./blobReferenceInputDataSource');
exports.ReferenceInputProperties = require('./referenceInputProperties');
exports.StreamInputDataSource = require('./streamInputDataSource');
exports.IoTHubStreamInputDataSource = require('./ioTHubStreamInputDataSource');
exports.EventHubStreamInputDataSource = require('./eventHubStreamInputDataSource');
exports.BlobStreamInputDataSource = require('./blobStreamInputDataSource');
exports.StreamInputProperties = require('./streamInputProperties');
exports.ErrorResponse = require('./errorResponse');
exports.ResourceTestStatus = require('./resourceTestStatus');
exports.SubscriptionQuota = require('./subscriptionQuota');
exports.SubscriptionQuotasListResult = require('./subscriptionQuotasListResult');
exports.OperationListResult = require('./operationListResult');
exports.StreamingJobListResult = require('./streamingJobListResult');
exports.InputListResult = require('./inputListResult');
exports.OutputListResult = require('./outputListResult');
exports.FunctionListResult = require('./functionListResult');
exports.discriminators = {
  'Serialization' : exports.Serialization,
  'InputProperties' : exports.InputProperties,
  'OutputDataSource' : exports.OutputDataSource,
  'FunctionProperties' : exports.FunctionProperties,
  'FunctionBinding.Microsoft.StreamAnalytics/JavascriptUdf' : exports.JavaScriptFunctionBinding,
  'FunctionBinding.Microsoft.MachineLearning/WebService' : exports.AzureMachineLearningWebServiceFunctionBinding,
  'FunctionBinding' : exports.FunctionBinding,
  'FunctionProperties.Scalar' : exports.ScalarFunctionProperties,
  'FunctionRetrieveDefaultDefinitionParameters.Microsoft.StreamAnalytics/JavascriptUdf' : exports.JavaScriptFunctionRetrieveDefaultDefinitionParameters,
  'FunctionRetrieveDefaultDefinitionParameters.Microsoft.MachineLearning/WebService' : exports.AzureMachineLearningWebServiceFunctionRetrieveDefaultDefinitionParameters,
  'FunctionRetrieveDefaultDefinitionParameters' : exports.FunctionRetrieveDefaultDefinitionParameters,
  'Serialization.Avro' : exports.AvroSerialization,
  'Serialization.Json' : exports.JsonSerialization,
  'Serialization.Csv' : exports.CsvSerialization,
  'OutputDataSource.Microsoft.DataLake/Accounts' : exports.AzureDataLakeStoreOutputDataSource,
  'OutputDataSource.PowerBI' : exports.PowerBIOutputDataSource,
  'OutputDataSource.Microsoft.ServiceBus/Topic' : exports.ServiceBusTopicOutputDataSource,
  'OutputDataSource.Microsoft.ServiceBus/Queue' : exports.ServiceBusQueueOutputDataSource,
  'OutputDataSource.Microsoft.Storage/DocumentDB' : exports.DocumentDbOutputDataSource,
  'OutputDataSource.Microsoft.Sql/Server/Database' : exports.AzureSqlDatabaseOutputDataSource,
  'OutputDataSource.Microsoft.ServiceBus/EventHub' : exports.EventHubOutputDataSource,
  'OutputDataSource.Microsoft.Storage/Table' : exports.AzureTableOutputDataSource,
  'OutputDataSource.Microsoft.Storage/Blob' : exports.BlobOutputDataSource,
  'ReferenceInputDataSource.Microsoft.Storage/Blob' : exports.BlobReferenceInputDataSource,
  'ReferenceInputDataSource' : exports.ReferenceInputDataSource,
  'InputProperties.Reference' : exports.ReferenceInputProperties,
  'StreamInputDataSource.Microsoft.Devices/IotHubs' : exports.IoTHubStreamInputDataSource,
  'StreamInputDataSource.Microsoft.ServiceBus/EventHub' : exports.EventHubStreamInputDataSource,
  'StreamInputDataSource.Microsoft.Storage/Blob' : exports.BlobStreamInputDataSource,
  'StreamInputDataSource' : exports.StreamInputDataSource,
  'InputProperties.Stream' : exports.StreamInputProperties
};
