/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The properties that are associated with an input.
 *
 */
class InputProperties {
  /**
   * Create a InputProperties.
   * @member {object} [serialization] Describes how data from an input is
   * serialized or how data is serialized when written to an output. Required
   * on PUT (CreateOrReplace) requests.
   * @member {string} [serialization.type] Polymorphic Discriminator
   * @member {object} [diagnostics] Describes conditions applicable to the
   * Input, Output, or the job overall, that warrant customer attention.
   * @member {array} [diagnostics.conditions] A collection of zero or more
   * conditions applicable to the resource, or to the job overall, that warrant
   * customer attention.
   * @member {string} [etag] The current entity tag for the input. This is an
   * opaque string. You can use it to detect whether the resource has changed
   * between requests. You can also use it in the If-Match or If-None-Match
   * headers for write operations for optimistic concurrency.
   * @member {string} type Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of InputProperties
   *
   * @returns {object} metadata of InputProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'InputProperties',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'type',
          clientName: 'type'
        },
        uberParent: 'InputProperties',
        className: 'InputProperties',
        modelProperties: {
          serialization: {
            required: false,
            serializedName: 'serialization',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'type',
                clientName: 'type'
              },
              uberParent: 'Serialization',
              className: 'Serialization'
            }
          },
          diagnostics: {
            required: false,
            readOnly: true,
            serializedName: 'diagnostics',
            type: {
              name: 'Composite',
              className: 'Diagnostics'
            }
          },
          etag: {
            required: false,
            readOnly: true,
            serializedName: 'etag',
            type: {
              name: 'String'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = InputProperties;
