/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Describes how data from an input is serialized or how data is serialized
 * when written to an output in JSON format.
 *
 * @extends models['Serialization']
 */
class JsonSerialization extends models['Serialization'] {
  /**
   * Create a JsonSerialization.
   * @member {string} [encoding] Specifies the encoding of the incoming data in
   * the case of input and the encoding of outgoing data in the case of output.
   * Required on PUT (CreateOrReplace) requests. Possible values include:
   * 'UTF8'
   * @member {string} [format] This property only applies to JSON serialization
   * of outputs only. It is not applicable to inputs. This property specifies
   * the format of the JSON the output will be written in. The currently
   * supported values are 'lineSeparated' indicating the output will be
   * formatted by having each JSON object separated by a new line and 'array'
   * indicating the output will be formatted as an array of JSON objects.
   * Default value is 'lineSeparated' if left null. Possible values include:
   * 'LineSeparated', 'Array'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of JsonSerialization
   *
   * @returns {object} metadata of JsonSerialization
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Json',
      type: {
        name: 'Composite',
        className: 'JsonSerialization',
        modelProperties: {
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          encoding: {
            required: false,
            serializedName: 'properties.encoding',
            type: {
              name: 'String'
            }
          },
          format: {
            required: false,
            serializedName: 'properties.format',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = JsonSerialization;
