/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The properties that are associated with data sources that use OAuth as their
 * authentication model.
 *
 */
class OAuthBasedDataSourceProperties {
  /**
   * Create a OAuthBasedDataSourceProperties.
   * @member {string} [refreshToken] A refresh token that can be used to obtain
   * a valid access token that can then be used to authenticate with the data
   * source. A valid refresh token is currently only obtainable via the Azure
   * Portal. It is recommended to put a dummy string value here when creating
   * the data source and then going to the Azure Portal to authenticate the
   * data source which will update this property with a valid refresh token.
   * Required on PUT (CreateOrReplace) requests.
   * @member {string} [tokenUserPrincipalName] The user principal name (UPN) of
   * the user that was used to obtain the refresh token. Use this property to
   * help remember which user was used to obtain the refresh token.
   * @member {string} [tokenUserDisplayName] The user display name of the user
   * that was used to obtain the refresh token. Use this property to help
   * remember which user was used to obtain the refresh token.
   */
  constructor() {
  }

  /**
   * Defines the metadata of OAuthBasedDataSourceProperties
   *
   * @returns {object} metadata of OAuthBasedDataSourceProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OAuthBasedDataSourceProperties',
      type: {
        name: 'Composite',
        className: 'OAuthBasedDataSourceProperties',
        modelProperties: {
          refreshToken: {
            required: false,
            serializedName: 'refreshToken',
            type: {
              name: 'String'
            }
          },
          tokenUserPrincipalName: {
            required: false,
            serializedName: 'tokenUserPrincipalName',
            type: {
              name: 'String'
            }
          },
          tokenUserDisplayName: {
            required: false,
            serializedName: 'tokenUserDisplayName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = OAuthBasedDataSourceProperties;
