/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Describes the status of the test operation along with error information, if
 * applicable.
 *
 */
class ResourceTestStatus {
  /**
   * Create a ResourceTestStatus.
   * @member {string} [status] The status of the test operation.
   * @member {object} [error] Describes the error that occurred.
   * @member {string} [error.code] Error code associated with the error that
   * occurred.
   * @member {string} [error.message] Describes the error in detail.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResourceTestStatus
   *
   * @returns {object} metadata of ResourceTestStatus
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceTestStatus',
      type: {
        name: 'Composite',
        className: 'ResourceTestStatus',
        modelProperties: {
          status: {
            required: false,
            readOnly: true,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          },
          error: {
            required: false,
            readOnly: true,
            serializedName: 'error',
            type: {
              name: 'Composite',
              className: 'ErrorResponse'
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceTestStatus;
