/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The properties that are associated with an Azure Storage account
 *
 */
class StorageAccount {
  /**
   * Create a StorageAccount.
   * @member {string} [accountName] The name of the Azure Storage account.
   * Required on PUT (CreateOrReplace) requests.
   * @member {string} [accountKey] The account key for the Azure Storage
   * account. Required on PUT (CreateOrReplace) requests.
   */
  constructor() {
  }

  /**
   * Defines the metadata of StorageAccount
   *
   * @returns {object} metadata of StorageAccount
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'StorageAccount',
      type: {
        name: 'Composite',
        className: 'StorageAccount',
        modelProperties: {
          accountName: {
            required: false,
            serializedName: 'accountName',
            type: {
              name: 'String'
            }
          },
          accountKey: {
            required: false,
            serializedName: 'accountKey',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = StorageAccount;
