/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Describes the current quota for the subscription.
 *
 * @extends models['SubResource']
 */
class SubscriptionQuota extends models['SubResource'] {
  /**
   * Create a SubscriptionQuota.
   * @member {number} [maxCount] The max permitted usage of this resource.
   * @member {number} [currentCount] The current usage of this resource.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SubscriptionQuota
   *
   * @returns {object} metadata of SubscriptionQuota
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SubscriptionQuota',
      type: {
        name: 'Composite',
        className: 'SubscriptionQuota',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          maxCount: {
            required: false,
            readOnly: true,
            serializedName: 'properties.maxCount',
            type: {
              name: 'Number'
            }
          },
          currentCount: {
            required: false,
            readOnly: true,
            serializedName: 'properties.currentCount',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = SubscriptionQuota;
