/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Class representing a region in the Geographic hierarchy used with the
 * Geographic traffic routing method.
 *
 */
class Region {
  /**
   * Create a Region.
   * @member {string} [code] The code of the region
   * @member {string} [name] The name of the region
   * @member {array} [regions] The list of Regions grouped under this Region in
   * the Geographic Hierarchy.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Region
   *
   * @returns {object} metadata of Region
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Region',
      type: {
        name: 'Composite',
        className: 'Region',
        modelProperties: {
          code: {
            required: false,
            serializedName: 'code',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          regions: {
            required: false,
            serializedName: 'regions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'RegionElementType',
                  type: {
                    name: 'Composite',
                    className: 'Region'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = Region;
