/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The body of a PUT request to modify a Visual Studio account resource.
 *
 */
class AccountResourceRequest {
  /**
   * Create a AccountResourceRequest.
   * @member {string} [accountName] The account name.
   * @member {string} [location] The Azure instance location.
   * @member {object} [operationType] The type of the operation.
   * @member {object} [properties] The custom properties of the resource.
   * @member {object} [tags] The custom tags of the resource.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AccountResourceRequest
   *
   * @returns {object} metadata of AccountResourceRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AccountResourceRequest',
      type: {
        name: 'Composite',
        className: 'AccountResourceRequest',
        modelProperties: {
          accountName: {
            required: false,
            serializedName: 'accountName',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          operationType: {
            required: false,
            serializedName: 'operationType',
            type: {
              name: 'Object'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = AccountResourceRequest;
