/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Plan data for an extension resource.
 *
 */
class ExtensionResourcePlan {
  /**
   * Create a ExtensionResourcePlan.
   * @member {string} [name] Name of the plan.
   * @member {string} [product] Product name.
   * @member {string} [promotionCode] Optional: the promotion code associated
   * with the plan.
   * @member {string} [publisher] Name of the extension publisher.
   * @member {string} [version] A string that uniquely identifies the plan
   * version.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ExtensionResourcePlan
   *
   * @returns {object} metadata of ExtensionResourcePlan
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ExtensionResourcePlan',
      type: {
        name: 'Composite',
        className: 'ExtensionResourcePlan',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          product: {
            required: false,
            serializedName: 'product',
            type: {
              name: 'String'
            }
          },
          promotionCode: {
            required: false,
            serializedName: 'promotionCode',
            type: {
              name: 'String'
            }
          },
          publisher: {
            required: false,
            serializedName: 'publisher',
            type: {
              name: 'String'
            }
          },
          version: {
            required: false,
            serializedName: 'version',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ExtensionResourcePlan;
