/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The body of an extension resource PUT request.
 *
 */
class ExtensionResourceRequest {
  /**
   * Create a ExtensionResourceRequest.
   * @member {string} [location] The Azure region of the Visual Studio account
   * associated with this request (i.e 'southcentralus'.)
   * @member {object} [plan] Extended information about the plan being
   * purchased for this extension resource.
   * @member {string} [plan.name] Name of the plan.
   * @member {string} [plan.product] Product name.
   * @member {string} [plan.promotionCode] Optional: the promotion code
   * associated with the plan.
   * @member {string} [plan.publisher] Name of the extension publisher.
   * @member {string} [plan.version] A string that uniquely identifies the plan
   * version.
   * @member {object} [properties] A dictionary of extended properties. This
   * property is currently unused.
   * @member {object} [tags] A dictionary of user-defined tags to be stored
   * with the extension resource.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ExtensionResourceRequest
   *
   * @returns {object} metadata of ExtensionResourceRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ExtensionResourceRequest',
      type: {
        name: 'Composite',
        className: 'ExtensionResourceRequest',
        modelProperties: {
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          plan: {
            required: false,
            serializedName: 'plan',
            type: {
              name: 'Composite',
              className: 'ExtensionResourcePlan'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ExtensionResourceRequest;
