/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Specifies the web app that snapshot contents will be written to.
 *
 */
class SnapshotRecoveryTarget {
  /**
   * Create a SnapshotRecoveryTarget.
   * @member {string} [location] Geographical location of the target web app,
   * e.g. SouthEastAsia, SouthCentralUS
   * @member {string} [id] ARM resource ID of the target app.
   * /subscriptions/{subId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Web/sites/{siteName}
   * for production slots and
   * /subscriptions/{subId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Web/sites/{siteName}/slots/{slotName}
   * for other slots.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SnapshotRecoveryTarget
   *
   * @returns {object} metadata of SnapshotRecoveryTarget
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SnapshotRecoveryTarget',
      type: {
        name: 'Composite',
        className: 'SnapshotRecoveryTarget',
        modelProperties: {
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SnapshotRecoveryTarget;
