/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary A locality hint that can be used by the Batch service to select a
 * compute node on which to start a task.
  *
 */
class AffinityInformation {
  /**
   * Create a AffinityInformation.
   * @member {string} affinityId An opaque string representing the location of
   * a compute node or a task that has run previously. You can pass the
   * affinityId of a compute node to indicate that this task needs to run on
   * that compute node. Note that this is just a soft affinity. If the target
   * node is busy or unavailable at the time the task is scheduled, then the
   * task will be scheduled elsewhere.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AffinityInformation
   *
   * @returns {object} metadata of AffinityInformation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AffinityInformation',
      type: {
        name: 'Composite',
        className: 'AffinityInformation',
        modelProperties: {
          affinityId: {
            required: true,
            serializedName: 'affinityId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AffinityInformation;
