/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary Specifies the parameters for the auto user that runs a task on the
 * Batch service.
  *
 */
class AutoUserSpecification {
  /**
   * Create a AutoUserSpecification.
   * @member {string} [scope] The scope for the auto user. Values are:
   *
   * pool - specifies that the task runs as the common auto user account which
   * is created on every node in a pool.
   * task - specifies that the service should create a new user for the task.
   * The default value is task. Possible values include: 'task', 'pool'
   * @member {string} [elevationLevel] The elevation level of the auto user.
   * nonAdmin - The auto user is a standard user without elevated access. admin
   * - The auto user is a user with elevated access and operates with full
   * Administrator permissions. The default value is nonAdmin. Possible values
   * include: 'nonAdmin', 'admin'
   */
  constructor() {
  }

  /**
   * Defines the metadata of AutoUserSpecification
   *
   * @returns {object} metadata of AutoUserSpecification
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AutoUserSpecification',
      type: {
        name: 'Composite',
        className: 'AutoUserSpecification',
        modelProperties: {
          scope: {
            required: false,
            serializedName: 'scope',
            type: {
              name: 'Enum',
              allowedValues: [ 'task', 'pool' ]
            }
          },
          elevationLevel: {
            required: false,
            serializedName: 'elevationLevel',
            type: {
              name: 'Enum',
              allowedValues: [ 'nonAdmin', 'admin' ]
            }
          }
        }
      }
    };
  }
}

module.exports = AutoUserSpecification;
