/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary A private container registry.
  *
 */
class ContainerRegistry {
  /**
   * Create a ContainerRegistry.
   * @member {string} [registryServer] The registry URL. If omitted, the
   * default is "docker.io".
   * @member {string} userName The user name to log into the registry server.
   * @member {string} password The password to log into the registry server.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ContainerRegistry
   *
   * @returns {object} metadata of ContainerRegistry
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContainerRegistry',
      type: {
        name: 'Composite',
        className: 'ContainerRegistry',
        modelProperties: {
          registryServer: {
            required: false,
            serializedName: 'registryServer',
            type: {
              name: 'String'
            }
          },
          userName: {
            required: true,
            serializedName: 'username',
            type: {
              name: 'String'
            }
          },
          password: {
            required: true,
            serializedName: 'password',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ContainerRegistry;
