/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary An environment variable to be set on a task process.
  *
 */
class EnvironmentSetting {
  /**
   * Create a EnvironmentSetting.
   * @member {string} name The name of the environment variable.
   * @member {string} [value] The value of the environment variable.
   */
  constructor() {
  }

  /**
   * Defines the metadata of EnvironmentSetting
   *
   * @returns {object} metadata of EnvironmentSetting
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EnvironmentSetting',
      type: {
        name: 'Composite',
        className: 'EnvironmentSetting',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = EnvironmentSetting;
