/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary The properties of a file on a compute node.
  *
 */
class FileProperties {
  /**
   * Create a FileProperties.
   * @member {date} [creationTime] The file creation time. The creation time is
   * not returned for files on Linux compute nodes.
   * @member {date} lastModified The time at which the file was last modified.
   * @member {number} contentLength The length of the file.
   * @member {string} [contentType] The content type of the file.
   * @member {string} [fileMode] The file mode attribute in octal format. The
   * file mode is returned only for files on Linux compute nodes.
   */
  constructor() {
  }

  /**
   * Defines the metadata of FileProperties
   *
   * @returns {object} metadata of FileProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FileProperties',
      type: {
        name: 'Composite',
        className: 'FileProperties',
        modelProperties: {
          creationTime: {
            required: false,
            serializedName: 'creationTime',
            type: {
              name: 'DateTime'
            }
          },
          lastModified: {
            required: true,
            serializedName: 'lastModified',
            type: {
              name: 'DateTime'
            }
          },
          contentLength: {
            required: true,
            serializedName: 'contentLength',
            type: {
              name: 'Number'
            }
          },
          contentType: {
            required: false,
            serializedName: 'contentType',
            type: {
              name: 'String'
            }
          },
          fileMode: {
            required: false,
            serializedName: 'fileMode',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = FileProperties;
