/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

var msRestAzure = require('ms-rest-azure');

exports.BaseResource = msRestAzure.BaseResource;
exports.CloudError = msRestAzure.CloudError;
exports.PoolUsageMetrics = require('./poolUsageMetrics');
exports.ImageReference = require('./imageReference');
exports.NodeAgentSku = require('./nodeAgentSku');
exports.AuthenticationTokenSettings = require('./authenticationTokenSettings');
exports.UsageStatistics = require('./usageStatistics');
exports.ResourceStatistics = require('./resourceStatistics');
exports.PoolStatistics = require('./poolStatistics');
exports.JobStatistics = require('./jobStatistics');
exports.NameValuePair = require('./nameValuePair');
exports.DeleteCertificateError = require('./deleteCertificateError');
exports.Certificate = require('./certificate');
exports.ApplicationPackageReference = require('./applicationPackageReference');
exports.ApplicationSummary = require('./applicationSummary');
exports.CertificateAddParameter = require('./certificateAddParameter');
exports.FileProperties = require('./fileProperties');
exports.NodeFile = require('./nodeFile');
exports.Schedule = require('./schedule');
exports.JobConstraints = require('./jobConstraints');
exports.ContainerRegistry = require('./containerRegistry');
exports.TaskContainerSettings = require('./taskContainerSettings');
exports.ResourceFile = require('./resourceFile');
exports.EnvironmentSetting = require('./environmentSetting');
exports.ExitOptions = require('./exitOptions');
exports.ExitCodeMapping = require('./exitCodeMapping');
exports.ExitCodeRangeMapping = require('./exitCodeRangeMapping');
exports.ExitConditions = require('./exitConditions');
exports.AutoUserSpecification = require('./autoUserSpecification');
exports.UserIdentity = require('./userIdentity');
exports.LinuxUserConfiguration = require('./linuxUserConfiguration');
exports.UserAccount = require('./userAccount');
exports.TaskConstraints = require('./taskConstraints');
exports.OutputFileBlobContainerDestination = require('./outputFileBlobContainerDestination');
exports.OutputFileDestination = require('./outputFileDestination');
exports.OutputFileUploadOptions = require('./outputFileUploadOptions');
exports.OutputFile = require('./outputFile');
exports.JobManagerTask = require('./jobManagerTask');
exports.JobPreparationTask = require('./jobPreparationTask');
exports.JobReleaseTask = require('./jobReleaseTask');
exports.TaskSchedulingPolicy = require('./taskSchedulingPolicy');
exports.StartTask = require('./startTask');
exports.CertificateReference = require('./certificateReference');
exports.MetadataItem = require('./metadataItem');
exports.CloudServiceConfiguration = require('./cloudServiceConfiguration');
exports.OSDisk = require('./oSDisk');
exports.WindowsConfiguration = require('./windowsConfiguration');
exports.DataDisk = require('./dataDisk');
exports.ContainerConfiguration = require('./containerConfiguration');
exports.VirtualMachineConfiguration = require('./virtualMachineConfiguration');
exports.NetworkSecurityGroupRule = require('./networkSecurityGroupRule');
exports.InboundNATPool = require('./inboundNATPool');
exports.PoolEndpointConfiguration = require('./poolEndpointConfiguration');
exports.NetworkConfiguration = require('./networkConfiguration');
exports.PoolSpecification = require('./poolSpecification');
exports.AutoPoolSpecification = require('./autoPoolSpecification');
exports.PoolInformation = require('./poolInformation');
exports.JobSpecification = require('./jobSpecification');
exports.RecentJob = require('./recentJob');
exports.JobScheduleExecutionInformation = require('./jobScheduleExecutionInformation');
exports.JobScheduleStatistics = require('./jobScheduleStatistics');
exports.CloudJobSchedule = require('./cloudJobSchedule');
exports.JobScheduleAddParameter = require('./jobScheduleAddParameter');
exports.JobSchedulingError = require('./jobSchedulingError');
exports.JobExecutionInformation = require('./jobExecutionInformation');
exports.CloudJob = require('./cloudJob');
exports.JobAddParameter = require('./jobAddParameter');
exports.TaskContainerExecutionInformation = require('./taskContainerExecutionInformation');
exports.TaskFailureInformation = require('./taskFailureInformation');
exports.JobPreparationTaskExecutionInformation = require('./jobPreparationTaskExecutionInformation');
exports.JobReleaseTaskExecutionInformation = require('./jobReleaseTaskExecutionInformation');
exports.JobPreparationAndReleaseTaskExecutionInformation = require('./jobPreparationAndReleaseTaskExecutionInformation');
exports.TaskCounts = require('./taskCounts');
exports.AutoScaleRunError = require('./autoScaleRunError');
exports.AutoScaleRun = require('./autoScaleRun');
exports.ResizeError = require('./resizeError');
exports.CloudPool = require('./cloudPool');
exports.PoolAddParameter = require('./poolAddParameter');
exports.AffinityInformation = require('./affinityInformation');
exports.TaskExecutionInformation = require('./taskExecutionInformation');
exports.ComputeNodeInformation = require('./computeNodeInformation');
exports.MultiInstanceSettings = require('./multiInstanceSettings');
exports.TaskStatistics = require('./taskStatistics');
exports.TaskIdRange = require('./taskIdRange');
exports.TaskDependencies = require('./taskDependencies');
exports.CloudTask = require('./cloudTask');
exports.TaskAddParameter = require('./taskAddParameter');
exports.TaskAddCollectionParameter = require('./taskAddCollectionParameter');
exports.ErrorMessage = require('./errorMessage');
exports.BatchErrorDetail = require('./batchErrorDetail');
exports.BatchError = require('./batchError');
exports.TaskAddResult = require('./taskAddResult');
exports.TaskAddCollectionResult = require('./taskAddCollectionResult');
exports.SubtaskInformation = require('./subtaskInformation');
exports.CloudTaskListSubtasksResult = require('./cloudTaskListSubtasksResult');
exports.TaskInformation = require('./taskInformation');
exports.StartTaskInformation = require('./startTaskInformation');
exports.ComputeNodeError = require('./computeNodeError');
exports.InboundEndpoint = require('./inboundEndpoint');
exports.ComputeNodeEndpointConfiguration = require('./computeNodeEndpointConfiguration');
exports.ComputeNode = require('./computeNode');
exports.ComputeNodeUser = require('./computeNodeUser');
exports.ComputeNodeGetRemoteLoginSettingsResult = require('./computeNodeGetRemoteLoginSettingsResult');
exports.JobSchedulePatchParameter = require('./jobSchedulePatchParameter');
exports.JobScheduleUpdateParameter = require('./jobScheduleUpdateParameter');
exports.JobDisableParameter = require('./jobDisableParameter');
exports.JobTerminateParameter = require('./jobTerminateParameter');
exports.JobPatchParameter = require('./jobPatchParameter');
exports.JobUpdateParameter = require('./jobUpdateParameter');
exports.PoolEnableAutoScaleParameter = require('./poolEnableAutoScaleParameter');
exports.PoolEvaluateAutoScaleParameter = require('./poolEvaluateAutoScaleParameter');
exports.PoolResizeParameter = require('./poolResizeParameter');
exports.PoolUpdatePropertiesParameter = require('./poolUpdatePropertiesParameter');
exports.PoolUpgradeOSParameter = require('./poolUpgradeOSParameter');
exports.PoolPatchParameter = require('./poolPatchParameter');
exports.TaskUpdateParameter = require('./taskUpdateParameter');
exports.NodeUpdateUserParameter = require('./nodeUpdateUserParameter');
exports.NodeRebootParameter = require('./nodeRebootParameter');
exports.NodeReimageParameter = require('./nodeReimageParameter');
exports.NodeDisableSchedulingParameter = require('./nodeDisableSchedulingParameter');
exports.NodeRemoveParameter = require('./nodeRemoveParameter');
exports.ApplicationListOptions = require('./applicationListOptions');
exports.ApplicationGetOptions = require('./applicationGetOptions');
exports.PoolListUsageMetricsOptions = require('./poolListUsageMetricsOptions');
exports.PoolGetAllLifetimeStatisticsOptions = require('./poolGetAllLifetimeStatisticsOptions');
exports.PoolAddOptions = require('./poolAddOptions');
exports.PoolListOptions = require('./poolListOptions');
exports.PoolDeleteMethodOptions = require('./poolDeleteMethodOptions');
exports.PoolExistsOptions = require('./poolExistsOptions');
exports.PoolGetOptions = require('./poolGetOptions');
exports.PoolPatchOptions = require('./poolPatchOptions');
exports.PoolDisableAutoScaleOptions = require('./poolDisableAutoScaleOptions');
exports.PoolEnableAutoScaleOptions = require('./poolEnableAutoScaleOptions');
exports.PoolEvaluateAutoScaleOptions = require('./poolEvaluateAutoScaleOptions');
exports.PoolResizeOptions = require('./poolResizeOptions');
exports.PoolStopResizeOptions = require('./poolStopResizeOptions');
exports.PoolUpdatePropertiesOptions = require('./poolUpdatePropertiesOptions');
exports.PoolUpgradeOSOptions = require('./poolUpgradeOSOptions');
exports.PoolRemoveNodesOptions = require('./poolRemoveNodesOptions');
exports.AccountListNodeAgentSkusOptions = require('./accountListNodeAgentSkusOptions');
exports.JobGetAllLifetimeStatisticsOptions = require('./jobGetAllLifetimeStatisticsOptions');
exports.JobDeleteMethodOptions = require('./jobDeleteMethodOptions');
exports.JobGetOptions = require('./jobGetOptions');
exports.JobPatchOptions = require('./jobPatchOptions');
exports.JobUpdateOptions = require('./jobUpdateOptions');
exports.JobDisableOptions = require('./jobDisableOptions');
exports.JobEnableOptions = require('./jobEnableOptions');
exports.JobTerminateOptions = require('./jobTerminateOptions');
exports.JobAddOptions = require('./jobAddOptions');
exports.JobListOptions = require('./jobListOptions');
exports.JobListFromJobScheduleOptions = require('./jobListFromJobScheduleOptions');
exports.JobListPreparationAndReleaseTaskStatusOptions = require('./jobListPreparationAndReleaseTaskStatusOptions');
exports.JobGetTaskCountsOptions = require('./jobGetTaskCountsOptions');
exports.CertificateAddOptions = require('./certificateAddOptions');
exports.CertificateListOptions = require('./certificateListOptions');
exports.CertificateCancelDeletionOptions = require('./certificateCancelDeletionOptions');
exports.CertificateDeleteMethodOptions = require('./certificateDeleteMethodOptions');
exports.CertificateGetOptions = require('./certificateGetOptions');
exports.FileDeleteFromTaskOptions = require('./fileDeleteFromTaskOptions');
exports.FileGetFromTaskOptions = require('./fileGetFromTaskOptions');
exports.FileGetPropertiesFromTaskOptions = require('./fileGetPropertiesFromTaskOptions');
exports.FileDeleteFromComputeNodeOptions = require('./fileDeleteFromComputeNodeOptions');
exports.FileGetFromComputeNodeOptions = require('./fileGetFromComputeNodeOptions');
exports.FileGetPropertiesFromComputeNodeOptions = require('./fileGetPropertiesFromComputeNodeOptions');
exports.FileListFromTaskOptions = require('./fileListFromTaskOptions');
exports.FileListFromComputeNodeOptions = require('./fileListFromComputeNodeOptions');
exports.JobScheduleExistsOptions = require('./jobScheduleExistsOptions');
exports.JobScheduleDeleteMethodOptions = require('./jobScheduleDeleteMethodOptions');
exports.JobScheduleGetOptions = require('./jobScheduleGetOptions');
exports.JobSchedulePatchOptions = require('./jobSchedulePatchOptions');
exports.JobScheduleUpdateOptions = require('./jobScheduleUpdateOptions');
exports.JobScheduleDisableOptions = require('./jobScheduleDisableOptions');
exports.JobScheduleEnableOptions = require('./jobScheduleEnableOptions');
exports.JobScheduleTerminateOptions = require('./jobScheduleTerminateOptions');
exports.JobScheduleAddOptions = require('./jobScheduleAddOptions');
exports.JobScheduleListOptions = require('./jobScheduleListOptions');
exports.TaskAddOptions = require('./taskAddOptions');
exports.TaskListOptions = require('./taskListOptions');
exports.TaskAddCollectionOptions = require('./taskAddCollectionOptions');
exports.TaskDeleteMethodOptions = require('./taskDeleteMethodOptions');
exports.TaskGetOptions = require('./taskGetOptions');
exports.TaskUpdateOptions = require('./taskUpdateOptions');
exports.TaskListSubtasksOptions = require('./taskListSubtasksOptions');
exports.TaskTerminateOptions = require('./taskTerminateOptions');
exports.TaskReactivateOptions = require('./taskReactivateOptions');
exports.ComputeNodeAddUserOptions = require('./computeNodeAddUserOptions');
exports.ComputeNodeDeleteUserOptions = require('./computeNodeDeleteUserOptions');
exports.ComputeNodeUpdateUserOptions = require('./computeNodeUpdateUserOptions');
exports.ComputeNodeGetOptions = require('./computeNodeGetOptions');
exports.ComputeNodeRebootOptions = require('./computeNodeRebootOptions');
exports.ComputeNodeReimageOptions = require('./computeNodeReimageOptions');
exports.ComputeNodeDisableSchedulingOptions = require('./computeNodeDisableSchedulingOptions');
exports.ComputeNodeEnableSchedulingOptions = require('./computeNodeEnableSchedulingOptions');
exports.ComputeNodeGetRemoteLoginSettingsOptions = require('./computeNodeGetRemoteLoginSettingsOptions');
exports.ComputeNodeGetRemoteDesktopOptions = require('./computeNodeGetRemoteDesktopOptions');
exports.ComputeNodeListOptions = require('./computeNodeListOptions');
exports.ApplicationListNextOptions = require('./applicationListNextOptions');
exports.PoolListUsageMetricsNextOptions = require('./poolListUsageMetricsNextOptions');
exports.PoolListNextOptions = require('./poolListNextOptions');
exports.AccountListNodeAgentSkusNextOptions = require('./accountListNodeAgentSkusNextOptions');
exports.JobListNextOptions = require('./jobListNextOptions');
exports.JobListFromJobScheduleNextOptions = require('./jobListFromJobScheduleNextOptions');
exports.JobListPreparationAndReleaseTaskStatusNextOptions = require('./jobListPreparationAndReleaseTaskStatusNextOptions');
exports.CertificateListNextOptions = require('./certificateListNextOptions');
exports.FileListFromTaskNextOptions = require('./fileListFromTaskNextOptions');
exports.FileListFromComputeNodeNextOptions = require('./fileListFromComputeNodeNextOptions');
exports.JobScheduleListNextOptions = require('./jobScheduleListNextOptions');
exports.TaskListNextOptions = require('./taskListNextOptions');
exports.ComputeNodeListNextOptions = require('./computeNodeListNextOptions');
exports.ApplicationListResult = require('./applicationListResult');
exports.PoolListUsageMetricsResult = require('./poolListUsageMetricsResult');
exports.CloudPoolListResult = require('./cloudPoolListResult');
exports.AccountListNodeAgentSkusResult = require('./accountListNodeAgentSkusResult');
exports.CloudJobListResult = require('./cloudJobListResult');
exports.CloudJobListPreparationAndReleaseTaskStatusResult = require('./cloudJobListPreparationAndReleaseTaskStatusResult');
exports.CertificateListResult = require('./certificateListResult');
exports.NodeFileListResult = require('./nodeFileListResult');
exports.CloudJobScheduleListResult = require('./cloudJobScheduleListResult');
exports.CloudTaskListResult = require('./cloudTaskListResult');
exports.ComputeNodeListResult = require('./computeNodeListResult');
