/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Additional parameters for update operation.
 *
 */
class JobUpdateOptions {
  /**
   * Create a JobUpdateOptions.
   * @member {number} [timeout] The maximum time that the server can spend
   * processing the request, in seconds. The default is 30 seconds. Default
   * value: 30 .
   * @member {uuid} [clientRequestId] The caller-generated request identity, in
   * the form of a GUID with no decoration such as curly braces, e.g.
   * 9C4D50EE-2D56-4CD3-8152-34347DC9F2B0.
   * @member {boolean} [returnClientRequestId] Whether the server should return
   * the client-request-id in the response. Default value: false .
   * @member {date} [ocpDate] The time the request was issued. Client libraries
   * typically set this to the current system clock time; set it explicitly if
   * you are calling the REST API directly.
   * @member {string} [ifMatch] An ETag value associated with the version of
   * the resource known to the client. The operation will be performed only if
   * the resource's current ETag on the service exactly matches the value
   * specified by the client.
   * @member {string} [ifNoneMatch] An ETag value associated with the version
   * of the resource known to the client. The operation will be performed only
   * if the resource's current ETag on the service does not match the value
   * specified by the client.
   * @member {date} [ifModifiedSince] A timestamp indicating the last modified
   * time of the resource known to the client. The operation will be performed
   * only if the resource on the service has been modified since the specified
   * time.
   * @member {date} [ifUnmodifiedSince] A timestamp indicating the last
   * modified time of the resource known to the client. The operation will be
   * performed only if the resource on the service has not been modified since
   * the specified time.
   */
  constructor() {
  }

  /**
   * Defines the metadata of JobUpdateOptions
   *
   * @returns {object} metadata of JobUpdateOptions
   *
   */
  mapper() {
    return {
      required: false,
      type: {
        name: 'Composite',
        className: 'JobUpdateOptions',
        modelProperties: {
          timeout: {
            required: false,
            defaultValue: 30,
            type: {
              name: 'Number'
            }
          },
          clientRequestId: {
            required: false,
            type: {
              name: 'String'
            }
          },
          returnClientRequestId: {
            required: false,
            defaultValue: false,
            type: {
              name: 'Boolean'
            }
          },
          ocpDate: {
            required: false,
            type: {
              name: 'DateTimeRfc1123'
            }
          },
          ifMatch: {
            required: false,
            type: {
              name: 'String'
            }
          },
          ifNoneMatch: {
            required: false,
            type: {
              name: 'String'
            }
          },
          ifModifiedSince: {
            required: false,
            type: {
              name: 'DateTimeRfc1123'
            }
          },
          ifUnmodifiedSince: {
            required: false,
            type: {
              name: 'DateTimeRfc1123'
            }
          }
        }
      }
    };
  }
}

module.exports = JobUpdateOptions;
