/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary Specifies a file upload destination within an Azure blob storage
 * container.
  *
 */
class OutputFileBlobContainerDestination {
  /**
   * Create a OutputFileBlobContainerDestination.
   * @member {string} [path] The destination blob or virtual directory within
   * the Azure Storage container. If filePattern refers to a specific file
   * (i.e. contains no wildcards), then path is the name of the blob to which
   * to upload that file. If filePattern contains one or more wildcards (and
   * therefore may match multiple files), then path is the name of the blob
   * virtual directory (which is prepended to each blob name) to which to
   * upload the file(s). If omitted, file(s) are uploaded to the root of the
   * container with a blob name matching their file name.
   * @member {string} containerUrl The URL of the container within Azure Blob
   * Storage to which to upload the file(s). The URL must include a Shared
   * Access Signature (SAS) granting write permissions to the container.
   */
  constructor() {
  }

  /**
   * Defines the metadata of OutputFileBlobContainerDestination
   *
   * @returns {object} metadata of OutputFileBlobContainerDestination
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OutputFileBlobContainerDestination',
      type: {
        name: 'Composite',
        className: 'OutputFileBlobContainerDestination',
        modelProperties: {
          path: {
            required: false,
            serializedName: 'path',
            type: {
              name: 'String'
            }
          },
          containerUrl: {
            required: true,
            serializedName: 'containerUrl',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = OutputFileBlobContainerDestination;
