/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * @summary The destination to which a file should be uploaded.
  *
 */
class OutputFileDestination {
  /**
   * Create a OutputFileDestination.
   * @member {object} [container] A location in Azure blob storage to which
   * files are uploaded.
   * @member {string} [container.path] If filePattern refers to a specific file
   * (i.e. contains no wildcards), then path is the name of the blob to which
   * to upload that file. If filePattern contains one or more wildcards (and
   * therefore may match multiple files), then path is the name of the blob
   * virtual directory (which is prepended to each blob name) to which to
   * upload the file(s). If omitted, file(s) are uploaded to the root of the
   * container with a blob name matching their file name.
   * @member {string} [container.containerUrl] The URL must include a Shared
   * Access Signature (SAS) granting write permissions to the container.
   */
  constructor() {
  }

  /**
   * Defines the metadata of OutputFileDestination
   *
   * @returns {object} metadata of OutputFileDestination
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OutputFileDestination',
      type: {
        name: 'Composite',
        className: 'OutputFileDestination',
        modelProperties: {
          container: {
            required: false,
            serializedName: 'container',
            type: {
              name: 'Composite',
              className: 'OutputFileBlobContainerDestination'
            }
          }
        }
      }
    };
  }
}

module.exports = OutputFileDestination;
