/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * @summary Information about a task failure.
  *
 */
class TaskFailureInformation {
  /**
   * Create a TaskFailureInformation.
   * @member {string} category The category of the task error. Possible values
   * include: 'userError', 'serverError'
   * @member {string} [code] An identifier for the task error. Codes are
   * invariant and are intended to be consumed programmatically.
   * @member {string} [message] A message describing the task error, intended
   * to be suitable for display in a user interface.
   * @member {array} [details] A list of additional details related to the
   * error.
   */
  constructor() {
  }

  /**
   * Defines the metadata of TaskFailureInformation
   *
   * @returns {object} metadata of TaskFailureInformation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TaskFailureInformation',
      type: {
        name: 'Composite',
        className: 'TaskFailureInformation',
        modelProperties: {
          category: {
            required: true,
            serializedName: 'category',
            type: {
              name: 'Enum',
              allowedValues: [ 'userError', 'serverError' ]
            }
          },
          code: {
            required: false,
            serializedName: 'code',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          },
          details: {
            required: false,
            serializedName: 'details',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'NameValuePairElementType',
                  type: {
                    name: 'Composite',
                    className: 'NameValuePair'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = TaskFailureInformation;
