/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary Specifies how tasks should be distributed across compute nodes.
  *
 */
class TaskSchedulingPolicy {
  /**
   * Create a TaskSchedulingPolicy.
   * @member {string} nodeFillType How tasks are distributed across compute
   * nodes in a pool. Values are:
   *
   * pack - As many tasks as possible (maxTasksPerNode) should be assigned to
   * each node in the pool before any tasks are assigned to the next node in
   * the pool.
   * spread - Tasks should be assigned evenly across all nodes in the pool.
   * Possible values include: 'spread', 'pack'
   */
  constructor() {
  }

  /**
   * Defines the metadata of TaskSchedulingPolicy
   *
   * @returns {object} metadata of TaskSchedulingPolicy
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TaskSchedulingPolicy',
      type: {
        name: 'Composite',
        className: 'TaskSchedulingPolicy',
        modelProperties: {
          nodeFillType: {
            required: true,
            serializedName: 'nodeFillType',
            type: {
              name: 'Enum',
              allowedValues: [ 'spread', 'pack' ]
            }
          }
        }
      }
    };
  }
}

module.exports = TaskSchedulingPolicy;
