/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * @summary The set of changes to be made to a task.
  *
 */
class TaskUpdateParameter {
  /**
   * Create a TaskUpdateParameter.
   * @member {object} [constraints] Constraints that apply to this task. If
   * omitted, the task is given the default constraints. For multi-instance
   * tasks, updating the retention time applies only to the primary task and
   * not subtasks.
   * @member {moment.duration} [constraints.maxWallClockTime] If this is not
   * specified, there is no time limit on how long the task may run.
   * @member {moment.duration} [constraints.retentionTime] The default is
   * infinite, i.e. the task directory will be retained until the compute node
   * is removed or reimaged.
   * @member {number} [constraints.maxTaskRetryCount] Note that this value
   * specifically controls the number of retries. The Batch service will try
   * the task once, and may then retry up to this limit. For example, if the
   * maximum retry count is 3, Batch tries the task up to 4 times (one initial
   * try and 3 retries). If the maximum retry count is 0, the Batch service
   * does not retry the task. If the maximum retry count is -1, the Batch
   * service retries the task without limit.
   */
  constructor() {
  }

  /**
   * Defines the metadata of TaskUpdateParameter
   *
   * @returns {object} metadata of TaskUpdateParameter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TaskUpdateParameter',
      type: {
        name: 'Composite',
        className: 'TaskUpdateParameter',
        modelProperties: {
          constraints: {
            required: false,
            serializedName: 'constraints',
            type: {
              name: 'Composite',
              className: 'TaskConstraints'
            }
          }
        }
      }
    };
  }
}

module.exports = TaskUpdateParameter;
