/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The response to an Active Directory object inquiry API request.
 */
class GetObjectsResult extends Array {
  /**
   * Create a GetObjectsResult.
   * @member {string} [odatanextLink] The URL to get the next set of results.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of GetObjectsResult
   *
   * @returns {object} metadata of GetObjectsResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GetObjectsResult',
      type: {
        name: 'Composite',
        className: 'GetObjectsResult',
        modelProperties: {
          value: {
            required: false,
            serializedName: '',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'AADObjectElementType',
                  type: {
                    name: 'Composite',
                    className: 'AADObject'
                  }
              }
            }
          },
          odatanextLink: {
            required: false,
            serializedName: 'odata\\.nextLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = GetObjectsResult;
