/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Active Directory Password Credential information.
 *
 */
class PasswordCredential {
  /**
   * Create a PasswordCredential.
   * @member {date} [startDate] Start date.
   * @member {date} [endDate] End date.
   * @member {string} [keyId] Key ID.
   * @member {string} [value] Key value.
   */
  constructor() {
  }

  /**
   * Defines the metadata of PasswordCredential
   *
   * @returns {object} metadata of PasswordCredential
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PasswordCredential',
      type: {
        name: 'Composite',
        className: 'PasswordCredential',
        modelProperties: {
          startDate: {
            required: false,
            serializedName: 'startDate',
            type: {
              name: 'DateTime'
            }
          },
          endDate: {
            required: false,
            serializedName: 'endDate',
            type: {
              name: 'DateTime'
            }
          },
          keyId: {
            required: false,
            serializedName: 'keyId',
            type: {
              name: 'String'
            }
          },
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = PasswordCredential;
