/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Contains information about a sign-in name of a local account user in an
 * Azure Active Directory B2C tenant.
 *
 */
class SignInName {
  /**
   * Create a SignInName.
   * @member {string} [type] A string value that can be used to classify user
   * sign-in types in your directory, such as 'emailAddress' or 'userName'.
   * @member {string} [value] The sign-in used by the local account. Must be
   * unique across the company/tenant. For example, 'johnc@example.com'.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SignInName
   *
   * @returns {object} metadata of SignInName
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SignInName',
      type: {
        name: 'Composite',
        className: 'SignInName',
        modelProperties: {
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SignInName;
