/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Active Directory user information.
 *
 * @extends models['UserBase']
 */
class User extends models['UserBase'] {
  /**
   * Create a User.
   * @member {boolean} [accountEnabled] Whether the account is enabled.
   * @member {string} [displayName] The display name of the user.
   * @member {string} [userPrincipalName] The principal name of the user.
   * @member {string} [mailNickname] The mail alias for the user.
   * @member {string} [mail] The primary email address of the user.
   * @member {string} [objectId] The object ID.
   * @member {string} [objectType] The object type.
   * @member {array} [signInNames] The sign-in names of the user.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of User
   *
   * @returns {object} metadata of User
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'User',
      type: {
        name: 'Composite',
        className: 'User',
        modelProperties: {
          immutableId: {
            required: false,
            serializedName: 'immutableId',
            type: {
              name: 'String'
            }
          },
          usageLocation: {
            required: false,
            serializedName: 'usageLocation',
            type: {
              name: 'String'
            }
          },
          givenName: {
            required: false,
            serializedName: 'givenName',
            type: {
              name: 'String'
            }
          },
          surname: {
            required: false,
            serializedName: 'surname',
            type: {
              name: 'String'
            }
          },
          userType: {
            required: false,
            serializedName: 'userType',
            type: {
              name: 'String'
            }
          },
          accountEnabled: {
            required: false,
            serializedName: 'accountEnabled',
            type: {
              name: 'Boolean'
            }
          },
          displayName: {
            required: false,
            serializedName: 'displayName',
            type: {
              name: 'String'
            }
          },
          userPrincipalName: {
            required: false,
            serializedName: 'userPrincipalName',
            type: {
              name: 'String'
            }
          },
          mailNickname: {
            required: false,
            serializedName: 'mailNickname',
            type: {
              name: 'String'
            }
          },
          mail: {
            required: false,
            serializedName: 'mail',
            type: {
              name: 'String'
            }
          },
          objectId: {
            required: false,
            serializedName: 'objectId',
            type: {
              name: 'String'
            }
          },
          objectType: {
            required: false,
            serializedName: 'objectType',
            type: {
              name: 'String'
            }
          },
          signInNames: {
            required: false,
            serializedName: 'signInNames',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'SignInNameElementType',
                  type: {
                    name: 'Composite',
                    className: 'SignInName'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = User;
