/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the Action class.
 * @constructor
 * The action that will be executed.
 *
 * @member {string} [actionType] The type of the action. Possible values
 * include: 'EmailContacts', 'AutoRenew'
 *
 */
class Action {
  constructor() {
  }

  /**
   * Defines the metadata of Action
   *
   * @returns {object} metadata of Action
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Action',
      type: {
        name: 'Composite',
        className: 'Action',
        modelProperties: {
          actionType: {
            required: false,
            serializedName: 'action_type',
            type: {
              name: 'Enum',
              allowedValues: [ 'EmailContacts', 'AutoRenew' ]
            }
          }
        }
      }
    };
  }
}

module.exports = Action;
