/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

var msRestAzure = require('ms-rest-azure');

exports.BaseResource = msRestAzure.BaseResource;
exports.CloudError = msRestAzure.CloudError;
exports.Attributes = require('./attributes');
exports.JsonWebKey = require('./jsonWebKey');
exports.KeyAttributes = require('./keyAttributes');
exports.KeyBundle = require('./keyBundle');
exports.KeyItem = require('./keyItem');
exports.SecretAttributes = require('./secretAttributes');
exports.SecretBundle = require('./secretBundle');
exports.SecretItem = require('./secretItem');
exports.CertificateAttributes = require('./certificateAttributes');
exports.CertificateItem = require('./certificateItem');
exports.CertificateIssuerItem = require('./certificateIssuerItem');
exports.KeyProperties = require('./keyProperties');
exports.SecretProperties = require('./secretProperties');
exports.SubjectAlternativeNames = require('./subjectAlternativeNames');
exports.X509CertificateProperties = require('./x509CertificateProperties');
exports.Trigger = require('./trigger');
exports.Action = require('./action');
exports.LifetimeAction = require('./lifetimeAction');
exports.IssuerParameters = require('./issuerParameters');
exports.CertificatePolicy = require('./certificatePolicy');
exports.CertificateBundle = require('./certificateBundle');
exports.ErrorModel = require('./errorModel');
exports.CertificateOperation = require('./certificateOperation');
exports.IssuerCredentials = require('./issuerCredentials');
exports.AdministratorDetails = require('./administratorDetails');
exports.OrganizationDetails = require('./organizationDetails');
exports.IssuerAttributes = require('./issuerAttributes');
exports.IssuerBundle = require('./issuerBundle');
exports.Contact = require('./contact');
exports.Contacts = require('./contacts');
exports.KeyCreateParameters = require('./keyCreateParameters');
exports.KeyImportParameters = require('./keyImportParameters');
exports.KeyOperationsParameters = require('./keyOperationsParameters');
exports.KeySignParameters = require('./keySignParameters');
exports.KeyVerifyParameters = require('./keyVerifyParameters');
exports.KeyUpdateParameters = require('./keyUpdateParameters');
exports.KeyRestoreParameters = require('./keyRestoreParameters');
exports.SecretSetParameters = require('./secretSetParameters');
exports.SecretUpdateParameters = require('./secretUpdateParameters');
exports.CertificateCreateParameters = require('./certificateCreateParameters');
exports.CertificateImportParameters = require('./certificateImportParameters');
exports.CertificateUpdateParameters = require('./certificateUpdateParameters');
exports.CertificateMergeParameters = require('./certificateMergeParameters');
exports.CertificateIssuerSetParameters = require('./certificateIssuerSetParameters');
exports.CertificateIssuerUpdateParameters = require('./certificateIssuerUpdateParameters');
exports.CertificateOperationUpdateParameter = require('./certificateOperationUpdateParameter');
exports.KeyOperationResult = require('./keyOperationResult');
exports.KeyVerifyResult = require('./keyVerifyResult');
exports.KeyListResult = require('./keyListResult');
exports.SecretListResult = require('./secretListResult');
exports.CertificateListResult = require('./certificateListResult');
exports.CertificateIssuerListResult = require('./certificateIssuerListResult');
exports.BackupKeyResult = require('./backupKeyResult');
exports.PendingCertificateSigningRequestResult = require('./pendingCertificateSigningRequestResult');
exports.KeyVaultError = require('./keyVaultError');
exports.KeyListResult = require('./keyListResult');
exports.SecretListResult = require('./secretListResult');
exports.CertificateListResult = require('./certificateListResult');
exports.CertificateIssuerListResult = require('./certificateIssuerListResult');
