/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the IssuerParameters class.
 * @constructor
 * Parameters for the issuer of the X509 component of a certificate.
 *
 * @member {string} [name] Name of the referenced issuer object or reserved
 * names; for example, 'Self' or 'Unknown'.
 *
 * @member {string} [certificateType] Type of certificate to be requested from
 * the issuer provider.
 *
 */
class IssuerParameters {
  constructor() {
  }

  /**
   * Defines the metadata of IssuerParameters
   *
   * @returns {object} metadata of IssuerParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IssuerParameters',
      type: {
        name: 'Composite',
        className: 'IssuerParameters',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          certificateType: {
            required: false,
            serializedName: 'cty',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = IssuerParameters;
