/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * @class
 * Initializes a new instance of the KeyAttributes class.
 * @constructor
 * The attributes of a key managed by the key vault service.
 *
 */
class KeyAttributes extends models['Attributes'] {
  constructor() {
    super();
  }

  /**
   * Defines the metadata of KeyAttributes
   *
   * @returns {object} metadata of KeyAttributes
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'KeyAttributes',
      type: {
        name: 'Composite',
        className: 'KeyAttributes',
        modelProperties: {
          enabled: {
            required: false,
            serializedName: 'enabled',
            type: {
              name: 'Boolean'
            }
          },
          notBefore: {
            required: false,
            serializedName: 'nbf',
            type: {
              name: 'UnixTime'
            }
          },
          expires: {
            required: false,
            serializedName: 'exp',
            type: {
              name: 'UnixTime'
            }
          },
          created: {
            required: false,
            readOnly: true,
            serializedName: 'created',
            type: {
              name: 'UnixTime'
            }
          },
          updated: {
            required: false,
            readOnly: true,
            serializedName: 'updated',
            type: {
              name: 'UnixTime'
            }
          }
        }
      }
    };
  }
}

module.exports = KeyAttributes;
