/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * @class
 * Initializes a new instance of the KeyCreateParameters class.
 * @constructor
 * The key create parameters.
 *
 * @member {string} kty The type of key to create. For valid key types, see
 * JsonWebKeyType. Supported JsonWebKey key types (kty) for Elliptic Curve,
 * RSA, HSM, Octet. Possible values include: 'EC', 'RSA', 'RSA-HSM', 'oct'
 *
 * @member {number} [keySize] The key size in bytes. For example, 1024 or 2048.
 *
 * @member {array} [keyOps]
 *
 * @member {object} [keyAttributes]
 *
 * @member {object} [tags] Application specific metadata in the form of
 * key-value pairs.
 *
 */
class KeyCreateParameters {
  constructor() {
  }

  /**
   * Defines the metadata of KeyCreateParameters
   *
   * @returns {object} metadata of KeyCreateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'KeyCreateParameters',
      type: {
        name: 'Composite',
        className: 'KeyCreateParameters',
        modelProperties: {
          kty: {
            required: true,
            serializedName: 'kty',
            constraints: {
              MinLength: 1
            },
            type: {
              name: 'String'
            }
          },
          keySize: {
            required: false,
            serializedName: 'key_size',
            type: {
              name: 'Number'
            }
          },
          keyOps: {
            required: false,
            serializedName: 'key_ops',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          keyAttributes: {
            required: false,
            serializedName: 'attributes',
            type: {
              name: 'Composite',
              className: 'KeyAttributes'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = KeyCreateParameters;
