/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * @class
 * Initializes a new instance of the OrganizationDetails class.
 * @constructor
 * Details of the organization of the certificate issuer.
 *
 * @member {string} [id] Id of the organization.
 *
 * @member {array} [adminDetails] Details of the organization administrator.
 *
 */
class OrganizationDetails {
  constructor() {
  }

  /**
   * Defines the metadata of OrganizationDetails
   *
   * @returns {object} metadata of OrganizationDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OrganizationDetails',
      type: {
        name: 'Composite',
        className: 'OrganizationDetails',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          adminDetails: {
            required: false,
            serializedName: 'admin_details',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'AdministratorDetailsElementType',
                  type: {
                    name: 'Composite',
                    className: 'AdministratorDetails'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = OrganizationDetails;
