/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * @class
 * Initializes a new instance of the SecretSetParameters class.
 * @constructor
 * The secret set parameters.
 *
 * @member {string} value The value of the secret.
 *
 * @member {object} [tags] Application specific metadata in the form of
 * key-value pairs.
 *
 * @member {string} [contentType] Type of the secret value such as a password.
 *
 * @member {object} [secretAttributes] The secret management attributes.
 *
 */
class SecretSetParameters {
  constructor() {
  }

  /**
   * Defines the metadata of SecretSetParameters
   *
   * @returns {object} metadata of SecretSetParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SecretSetParameters',
      type: {
        name: 'Composite',
        className: 'SecretSetParameters',
        modelProperties: {
          value: {
            required: true,
            serializedName: 'value',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          contentType: {
            required: false,
            serializedName: 'contentType',
            type: {
              name: 'String'
            }
          },
          secretAttributes: {
            required: false,
            serializedName: 'attributes',
            type: {
              name: 'Composite',
              className: 'SecretAttributes'
            }
          }
        }
      }
    };
  }
}

module.exports = SecretSetParameters;
