/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * @class
 * Initializes a new instance of the SecretUpdateParameters class.
 * @constructor
 * The secret update parameters.
 *
 * @member {string} [contentType] Type of the secret value such as a password.
 *
 * @member {object} [secretAttributes] The secret management attributes.
 *
 * @member {object} [tags] Application specific metadata in the form of
 * key-value pairs.
 *
 */
class SecretUpdateParameters {
  constructor() {
  }

  /**
   * Defines the metadata of SecretUpdateParameters
   *
   * @returns {object} metadata of SecretUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SecretUpdateParameters',
      type: {
        name: 'Composite',
        className: 'SecretUpdateParameters',
        modelProperties: {
          contentType: {
            required: false,
            serializedName: 'contentType',
            type: {
              name: 'String'
            }
          },
          secretAttributes: {
            required: false,
            serializedName: 'attributes',
            type: {
              name: 'Composite',
              className: 'SecretAttributes'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = SecretUpdateParameters;
