/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Azure Active Directory metadata used for secured connection to cluster.
 *
 */
class AadMetadata {
  /**
   * Create a AadMetadata.
   * @member {string} [authority] The AAD authority url.
   * @member {string} [client] The AAD client application Id.
   * @member {string} [cluster] The AAD cluster application Id.
   * @member {string} [login] The AAD login url.
   * @member {string} [redirect] The client application redirect address.
   * @member {string} [tenant] The AAD tenant Id.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AadMetadata
   *
   * @returns {object} metadata of AadMetadata
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AadMetadata',
      type: {
        name: 'Composite',
        className: 'AadMetadata',
        modelProperties: {
          authority: {
            required: false,
            serializedName: 'authority',
            type: {
              name: 'String'
            }
          },
          client: {
            required: false,
            serializedName: 'client',
            type: {
              name: 'String'
            }
          },
          cluster: {
            required: false,
            serializedName: 'cluster',
            type: {
              name: 'String'
            }
          },
          login: {
            required: false,
            serializedName: 'login',
            type: {
              name: 'String'
            }
          },
          redirect: {
            required: false,
            serializedName: 'redirect',
            type: {
              name: 'String'
            }
          },
          tenant: {
            required: false,
            serializedName: 'tenant',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AadMetadata;
