/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Represents the health state of an application, which contains the
 * application identifier and the aggregated health state.
 *
 *
 * @extends models['EntityHealthState']
 */
class ApplicationHealthState extends models['EntityHealthState'] {
  /**
   * Create a ApplicationHealthState.
   * @member {string} [name]
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ApplicationHealthState
   *
   * @returns {object} metadata of ApplicationHealthState
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplicationHealthState',
      type: {
        name: 'Composite',
        className: 'ApplicationHealthState',
        modelProperties: {
          aggregatedHealthState: {
            required: false,
            serializedName: 'AggregatedHealthState',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'Name',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ApplicationHealthState;
