/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Defines an item in ApplicationTypeHealthPolicyMap.
 *
 *
 */
class ApplicationTypeHealthPolicyMapItem {
  /**
   * Create a ApplicationTypeHealthPolicyMapItem.
   * @member {string} key The key of the application type health policy map
   * item. This is the name of the application type.
   * @member {number} value The value of the application type health policy map
   * item.
   * The max percent unhealthy applications allowed for the application type.
   * Must be between zero and 100.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApplicationTypeHealthPolicyMapItem
   *
   * @returns {object} metadata of ApplicationTypeHealthPolicyMapItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplicationTypeHealthPolicyMapItem',
      type: {
        name: 'Composite',
        className: 'ApplicationTypeHealthPolicyMapItem',
        modelProperties: {
          key: {
            required: true,
            serializedName: 'Key',
            type: {
              name: 'String'
            }
          },
          value: {
            required: true,
            serializedName: 'Value',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = ApplicationTypeHealthPolicyMapItem;
