/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes a map, which is a collection of (string, string) type key-value
 * pairs. The map can be used to record information about
 * the Chaos run. There cannot be more than 100 such pairs and each string (key
 * or value) can be at most 4095 characters long.
 * This map is set by the starter of the Chaos run to optionally store the
 * context about the specific run.
 *
 *
 */
class ChaosContext {
  /**
   * Create a ChaosContext.
   * @member {object} [map]
   */
  constructor() {
  }

  /**
   * Defines the metadata of ChaosContext
   *
   * @returns {object} metadata of ChaosContext
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ChaosContext',
      type: {
        name: 'Composite',
        className: 'ChaosContext',
        modelProperties: {
          map: {
            required: false,
            serializedName: 'Map',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = ChaosContext;
