/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Information about a Service Fabric compose deployment.
 *
 */
class ComposeDeploymentStatusInfo {
  /**
   * Create a ComposeDeploymentStatusInfo.
   * @member {string} [name]
   * @member {string} [applicationName]
   * @member {string} [status] Possible values include: 'Invalid',
   * 'Provisioning', 'Creating', 'Ready', 'Unprovisioning', 'Deleting',
   * 'Failed', 'Upgrading'
   * @member {string} [statusDetails] The status details of compose deployment
   * including failure message.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ComposeDeploymentStatusInfo
   *
   * @returns {object} metadata of ComposeDeploymentStatusInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ComposeDeploymentStatusInfo',
      type: {
        name: 'Composite',
        className: 'ComposeDeploymentStatusInfo',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'Name',
            type: {
              name: 'String'
            }
          },
          applicationName: {
            required: false,
            serializedName: 'ApplicationName',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            serializedName: 'Status',
            type: {
              name: 'String'
            }
          },
          statusDetails: {
            required: false,
            serializedName: 'StatusDetails',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ComposeDeploymentStatusInfo;
