/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Represents the health state of a deployed application, which contains the
 * entity identifier and the aggregated health state.
 *
 * @extends models['EntityHealthState']
 */
class DeployedApplicationHealthState extends models['EntityHealthState'] {
  /**
   * Create a DeployedApplicationHealthState.
   * @member {string} [nodeName]
   * @member {string} [applicationName]
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of DeployedApplicationHealthState
   *
   * @returns {object} metadata of DeployedApplicationHealthState
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DeployedApplicationHealthState',
      type: {
        name: 'Composite',
        className: 'DeployedApplicationHealthState',
        modelProperties: {
          aggregatedHealthState: {
            required: false,
            serializedName: 'AggregatedHealthState',
            type: {
              name: 'String'
            }
          },
          nodeName: {
            required: false,
            serializedName: 'NodeName',
            type: {
              name: 'String'
            }
          },
          applicationName: {
            required: false,
            serializedName: 'ApplicationName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DeployedApplicationHealthState;
