/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The list of deployed application health state chunks that respect the input
 * filters in the chunk query. Returned by get cluster health state chunks
 * query.
 *
 *
 */
class DeployedApplicationHealthStateChunkList {
  /**
   * Create a DeployedApplicationHealthStateChunkList.
   * @member {array} [items] The list of deployed application health state
   * chunks that respect the input filters in the chunk query.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DeployedApplicationHealthStateChunkList
   *
   * @returns {object} metadata of DeployedApplicationHealthStateChunkList
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DeployedApplicationHealthStateChunkList',
      type: {
        name: 'Composite',
        className: 'DeployedApplicationHealthStateChunkList',
        modelProperties: {
          items: {
            required: false,
            serializedName: 'Items',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'DeployedApplicationHealthStateChunkElementType',
                  type: {
                    name: 'Composite',
                    className: 'DeployedApplicationHealthStateChunk'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = DeployedApplicationHealthStateChunkList;
