/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The list of deployed service package health state chunks that respect the
 * input filters in the chunk query. Returned by get cluster health state
 * chunks query.
 *
 *
 */
class DeployedServicePackageHealthStateChunkList {
  /**
   * Create a DeployedServicePackageHealthStateChunkList.
   * @member {array} [items] The list of deployed service package health state
   * chunks that respect the input filters in the chunk query.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DeployedServicePackageHealthStateChunkList
   *
   * @returns {object} metadata of DeployedServicePackageHealthStateChunkList
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DeployedServicePackageHealthStateChunkList',
      type: {
        name: 'Composite',
        className: 'DeployedServicePackageHealthStateChunkList',
        modelProperties: {
          items: {
            required: false,
            serializedName: 'Items',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'DeployedServicePackageHealthStateChunkElementType',
                  type: {
                    name: 'Composite',
                    className: 'DeployedServicePackageHealthStateChunk'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = DeployedServicePackageHealthStateChunkList;
