/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Safety check that ensures that a quorum of replicas are not lost for a
 * partition.
 *
 * @extends models['PartitionSafetyCheck']
 */
class EnsurePartitionQurumSafetyCheck extends models['PartitionSafetyCheck'] {
  /**
   * Create a EnsurePartitionQurumSafetyCheck.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of EnsurePartitionQurumSafetyCheck
   *
   * @returns {object} metadata of EnsurePartitionQurumSafetyCheck
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EnsurePartitionQuorum',
      type: {
        name: 'Composite',
        className: 'EnsurePartitionQurumSafetyCheck',
        modelProperties: {
          kind: {
            required: true,
            serializedName: 'Kind',
            type: {
              name: 'String'
            }
          },
          partitionId: {
            required: false,
            serializedName: 'PartitionId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = EnsurePartitionQurumSafetyCheck;
