/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A base type for the health state chunk of various entities in the cluster.
 * It contains the aggregated health state.
 *
 */
class EntityHealthStateChunk {
  /**
   * Create a EntityHealthStateChunk.
   * @member {string} [healthState] Possible values include: 'Invalid', 'Ok',
   * 'Warning', 'Error', 'Unknown'
   */
  constructor() {
  }

  /**
   * Defines the metadata of EntityHealthStateChunk
   *
   * @returns {object} metadata of EntityHealthStateChunk
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EntityHealthStateChunk',
      type: {
        name: 'Composite',
        className: 'EntityHealthStateChunk',
        modelProperties: {
          healthState: {
            required: false,
            serializedName: 'HealthState',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = EntityHealthStateChunk;
