/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A base type for the list of health state chunks found in the cluster. It
 * contains the total number of health states that match the input filters.
 *
 */
class EntityHealthStateChunkList {
  /**
   * Create a EntityHealthStateChunkList.
   * @member {number} [totalCount] Total number of entity health state objects
   * that match the specified filters from the cluster health chunk query
   * description.
   */
  constructor() {
  }

  /**
   * Defines the metadata of EntityHealthStateChunkList
   *
   * @returns {object} metadata of EntityHealthStateChunkList
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EntityHealthStateChunkList',
      type: {
        name: 'Composite',
        className: 'EntityHealthStateChunkList',
        modelProperties: {
          totalCount: {
            required: false,
            serializedName: 'TotalCount',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = EntityHealthStateChunkList;
