/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Represents health state count for entities of the specified entity kind.
 *
 */
class EntityKindHealthStateCount {
  /**
   * Create a EntityKindHealthStateCount.
   * @member {string} [entityKind] Possible values include: 'Invalid', 'Node',
   * 'Partition', 'Service', 'Application', 'Replica', 'DeployedApplication',
   * 'DeployedServicePackage', 'Cluster'
   * @member {object} [healthStateCount]
   * @member {number} [healthStateCount.okCount] The number of health entities
   * with aggregated health state Ok.
   * @member {number} [healthStateCount.warningCount] The number of health
   * entities with aggregated health state Warning.
   * @member {number} [healthStateCount.errorCount] The number of health
   * entities with aggregated health state Error.
   */
  constructor() {
  }

  /**
   * Defines the metadata of EntityKindHealthStateCount
   *
   * @returns {object} metadata of EntityKindHealthStateCount
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EntityKindHealthStateCount',
      type: {
        name: 'Composite',
        className: 'EntityKindHealthStateCount',
        modelProperties: {
          entityKind: {
            required: false,
            serializedName: 'EntityKind',
            type: {
              name: 'String'
            }
          },
          healthStateCount: {
            required: false,
            serializedName: 'HealthStateCount',
            type: {
              name: 'Composite',
              className: 'HealthStateCount'
            }
          }
        }
      }
    };
  }
}

module.exports = EntityKindHealthStateCount;
