/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Information about the version of image store file.
 *
 */
class FileVersion {
  /**
   * Create a FileVersion.
   * @member {string} [versionNumber] The current iamge store version number
   * for the file is used in image store for checking whether it need to be
   * updated.
   * @member {string} [epochDataLossNumber] The epoch data loss number of image
   * store file is used to indicate the status of data loss.
   */
  constructor() {
  }

  /**
   * Defines the metadata of FileVersion
   *
   * @returns {object} metadata of FileVersion
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FileVersion',
      type: {
        name: 'Composite',
        className: 'FileVersion',
        modelProperties: {
          versionNumber: {
            required: false,
            serializedName: 'VersionNumber',
            type: {
              name: 'String'
            }
          },
          epochDataLossNumber: {
            required: false,
            serializedName: 'EpochDataLossNumber',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = FileVersion;
