/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Wrapper object for health evaluation.
 *
 */
class HealthEvaluationWrapper {
  /**
   * Create a HealthEvaluationWrapper.
   * @member {object} [healthEvaluation]
   * @member {string} [healthEvaluation.aggregatedHealthState] Possible values
   * include: 'Invalid', 'Ok', 'Warning', 'Error', 'Unknown'
   * @member {string} [healthEvaluation.description] Description of the health
   * evaluation, which represents a summary of the evaluation process.
   * @member {string} [healthEvaluation.kind] Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of HealthEvaluationWrapper
   *
   * @returns {object} metadata of HealthEvaluationWrapper
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HealthEvaluationWrapper',
      type: {
        name: 'Composite',
        className: 'HealthEvaluationWrapper',
        modelProperties: {
          healthEvaluation: {
            required: false,
            serializedName: 'HealthEvaluation',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'Kind',
                clientName: 'kind'
              },
              uberParent: 'HealthEvaluation',
              className: 'HealthEvaluation'
            }
          }
        }
      }
    };
  }
}

module.exports = HealthEvaluationWrapper;
