/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents information about how many health entities are in Ok, Warning and
 * Error health state.
 *
 *
 */
class HealthStateCount {
  /**
   * Create a HealthStateCount.
   * @member {number} [okCount] The number of health entities with aggregated
   * health state Ok.
   * @member {number} [warningCount] The number of health entities with
   * aggregated health state Warning.
   * @member {number} [errorCount] The number of health entities with
   * aggregated health state Error.
   */
  constructor() {
  }

  /**
   * Defines the metadata of HealthStateCount
   *
   * @returns {object} metadata of HealthStateCount
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HealthStateCount',
      type: {
        name: 'Composite',
        className: 'HealthStateCount',
        modelProperties: {
          okCount: {
            required: false,
            serializedName: 'OkCount',
            constraints: {
              InclusiveMinimum: 0
            },
            type: {
              name: 'Number'
            }
          },
          warningCount: {
            required: false,
            serializedName: 'WarningCount',
            constraints: {
              InclusiveMinimum: 0
            },
            type: {
              name: 'Number'
            }
          },
          errorCount: {
            required: false,
            serializedName: 'ErrorCount',
            constraints: {
              InclusiveMinimum: 0
            },
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = HealthStateCount;
