/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents the load metric report which contains the time metric was
 * reported, its name and value.
 *
 */
class LoadMetricReport {
  /**
   * Create a LoadMetricReport.
   * @member {date} [lastReportedUtc] Gets the UTC time when the load was
   * reported.
   * @member {string} [name] The name of the load metric.
   * @member {string} [value] The value of the load metric.
   */
  constructor() {
  }

  /**
   * Defines the metadata of LoadMetricReport
   *
   * @returns {object} metadata of LoadMetricReport
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LoadMetricReport',
      type: {
        name: 'Composite',
        className: 'LoadMetricReport',
        modelProperties: {
          lastReportedUtc: {
            required: false,
            serializedName: 'LastReportedUtc',
            type: {
              name: 'DateTime'
            }
          },
          name: {
            required: false,
            serializedName: 'Name',
            type: {
              name: 'String'
            }
          },
          value: {
            required: false,
            serializedName: 'Value',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = LoadMetricReport;
