/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the expected impact of a repair to a particular node.
 *
 * This type supports the Service Fabric platform; it is not meant to be used
 * directly from your code.
 *
 *
 */
class NodeImpact {
  /**
   * Create a NodeImpact.
   * @member {string} nodeName The name of the impacted node.
   * @member {string} [impactLevel] The level of impact expected. Possible
   * values include: 'Invalid', 'None', 'Restart', 'RemoveData', 'RemoveNode'
   */
  constructor() {
  }

  /**
   * Defines the metadata of NodeImpact
   *
   * @returns {object} metadata of NodeImpact
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NodeImpact',
      type: {
        name: 'Composite',
        className: 'NodeImpact',
        modelProperties: {
          nodeName: {
            required: true,
            serializedName: 'NodeName',
            type: {
              name: 'String'
            }
          },
          impactLevel: {
            required: false,
            serializedName: 'ImpactLevel',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = NodeImpact;
