/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Information about load on a Service Fabric node. It holds a summary of all
 * metrics and their load on a node.
 *
 */
class NodeLoadInfo {
  /**
   * Create a NodeLoadInfo.
   * @member {string} [nodeName]
   * @member {array} [nodeLoadMetricInformation] List that contains metrics and
   * their load information on this node.
   */
  constructor() {
  }

  /**
   * Defines the metadata of NodeLoadInfo
   *
   * @returns {object} metadata of NodeLoadInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NodeLoadInfo',
      type: {
        name: 'Composite',
        className: 'NodeLoadInfo',
        modelProperties: {
          nodeName: {
            required: false,
            serializedName: 'NodeName',
            type: {
              name: 'String'
            }
          },
          nodeLoadMetricInformation: {
            required: false,
            serializedName: 'NodeLoadMetricInformation',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'NodeLoadMetricInformationElementType',
                  type: {
                    name: 'Composite',
                    className: 'NodeLoadMetricInformation'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = NodeLoadInfo;
