/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents a policy for the package sharing.
 *
 */
class PackageSharingPolicyInfo {
  /**
   * Create a PackageSharingPolicyInfo.
   * @member {string} [sharedPackageName] The name of code, configuration or
   * data package that should be shared.
   * @member {string} [packageSharingScope] Possible values include: 'None',
   * 'All', 'Code', 'Config', 'Data'
   */
  constructor() {
  }

  /**
   * Defines the metadata of PackageSharingPolicyInfo
   *
   * @returns {object} metadata of PackageSharingPolicyInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PackageSharingPolicyInfo',
      type: {
        name: 'Composite',
        className: 'PackageSharingPolicyInfo',
        modelProperties: {
          sharedPackageName: {
            required: false,
            serializedName: 'SharedPackageName',
            type: {
              name: 'String'
            }
          },
          packageSharingScope: {
            required: false,
            serializedName: 'PackageSharingScope',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = PackageSharingPolicyInfo;
