/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The list of partition in the cluster for a service. The list is paged when
 * all of the results cannot fit in a single message. The next set of results
 * can be obtained by executing the same query with the continuation token
 * provided in this list.
 *
 */
class PagedServicePartitionInfoList {
  /**
   * Create a PagedServicePartitionInfoList.
   * @member {string} [continuationToken]
   * @member {array} [items]
   */
  constructor() {
  }

  /**
   * Defines the metadata of PagedServicePartitionInfoList
   *
   * @returns {object} metadata of PagedServicePartitionInfoList
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PagedServicePartitionInfoList',
      type: {
        name: 'Composite',
        className: 'PagedServicePartitionInfoList',
        modelProperties: {
          continuationToken: {
            required: false,
            serializedName: 'ContinuationToken',
            type: {
              name: 'String'
            }
          },
          items: {
            required: false,
            serializedName: 'Items',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ServicePartitionInfoElementType',
                  type: {
                    name: 'Composite',
                    polymorphicDiscriminator: {
                      serializedName: 'ServiceKind',
                      clientName: 'serviceKind'
                    },
                    uberParent: 'ServicePartitionInfo',
                    className: 'ServicePartitionInfo'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = PagedServicePartitionInfoList;
