/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Information about a partition restart user-induced operation.
 *
 */
class PartitionRestartProgress {
  /**
   * Create a PartitionRestartProgress.
   * @member {string} [state] Possible values include: 'Invalid', 'Running',
   * 'RollingBack', 'Completed', 'Faulted', 'Cancelled', 'ForceCancelled'
   * @member {object} [restartPartitionResult]
   * @member {number} [restartPartitionResult.errorCode] If OperationState is
   * Completed, this is 0.  If OperationState is Faulted, this is an error code
   * indicating the reason.
   * @member {object} [restartPartitionResult.selectedPartition]
   * @member {string} [restartPartitionResult.selectedPartition.serviceName]
   * @member {uuid} [restartPartitionResult.selectedPartition.partitionId]
   */
  constructor() {
  }

  /**
   * Defines the metadata of PartitionRestartProgress
   *
   * @returns {object} metadata of PartitionRestartProgress
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PartitionRestartProgress',
      type: {
        name: 'Composite',
        className: 'PartitionRestartProgress',
        modelProperties: {
          state: {
            required: false,
            serializedName: 'State',
            type: {
              name: 'String'
            }
          },
          restartPartitionResult: {
            required: false,
            serializedName: 'RestartPartitionResult',
            type: {
              name: 'Composite',
              className: 'RestartPartitionResult'
            }
          }
        }
      }
    };
  }
}

module.exports = PartitionRestartProgress;
