/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Represents a safety check for the service partition being performed by
 * service fabric before continuing with operations.
 *
 * @extends models['SafetyCheck']
 */
class PartitionSafetyCheck extends models['SafetyCheck'] {
  /**
   * Create a PartitionSafetyCheck.
   * @member {uuid} [partitionId]
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of PartitionSafetyCheck
   *
   * @returns {object} metadata of PartitionSafetyCheck
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PartitionSafetyCheck',
      type: {
        name: 'Composite',
        className: 'PartitionSafetyCheck',
        modelProperties: {
          kind: {
            required: true,
            serializedName: 'Kind',
            type: {
              name: 'String'
            }
          },
          partitionId: {
            required: false,
            serializedName: 'PartitionId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = PartitionSafetyCheck;
