/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Credential information to connect to container registry.
 *
 */
class RegistryCredential {
  /**
   * Create a RegistryCredential.
   * @member {string} [registryUserName] The user name to connect to container
   * registry.
   * @member {string} [registryPassword] The password for supplied username to
   * connect to container registry.
   * @member {boolean} [passwordEncrypted] Indicates that supplied container
   * registry password is encrypted.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RegistryCredential
   *
   * @returns {object} metadata of RegistryCredential
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RegistryCredential',
      type: {
        name: 'Composite',
        className: 'RegistryCredential',
        modelProperties: {
          registryUserName: {
            required: false,
            serializedName: 'RegistryUserName',
            type: {
              name: 'String'
            }
          },
          registryPassword: {
            required: false,
            serializedName: 'RegistryPassword',
            type: {
              name: 'String'
            }
          },
          passwordEncrypted: {
            required: false,
            serializedName: 'PasswordEncrypted',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = RegistryCredential;
