/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A record of the times when the repair task entered each state.
 *
 * This type supports the Service Fabric platform; it is not meant to be used
 * directly from your code.
 *
 *
 */
class RepairTaskHistory {
  /**
   * Create a RepairTaskHistory.
   * @member {date} [createdUtcTimestamp] The time when the repair task entered
   * the Created state.
   * @member {date} [claimedUtcTimestamp] The time when the repair task entered
   * the Claimed state.
   * @member {date} [preparingUtcTimestamp] The time when the repair task
   * entered the Preparing state.
   * @member {date} [approvedUtcTimestamp] The time when the repair task
   * entered the Approved state
   * @member {date} [executingUtcTimestamp] The time when the repair task
   * entered the Executing state
   * @member {date} [restoringUtcTimestamp] The time when the repair task
   * entered the Restoring state
   * @member {date} [completedUtcTimestamp] The time when the repair task
   * entered the Completed state
   * @member {date} [preparingHealthCheckStartUtcTimestamp] The time when the
   * repair task started the health check in the Preparing state.
   * @member {date} [preparingHealthCheckEndUtcTimestamp] The time when the
   * repair task completed the health check in the Preparing state.
   * @member {date} [restoringHealthCheckStartUtcTimestamp] The time when the
   * repair task started the health check in the Restoring state.
   * @member {date} [restoringHealthCheckEndUtcTimestamp] The time when the
   * repair task completed the health check in the Restoring state.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RepairTaskHistory
   *
   * @returns {object} metadata of RepairTaskHistory
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RepairTaskHistory',
      type: {
        name: 'Composite',
        className: 'RepairTaskHistory',
        modelProperties: {
          createdUtcTimestamp: {
            required: false,
            serializedName: 'CreatedUtcTimestamp',
            type: {
              name: 'DateTime'
            }
          },
          claimedUtcTimestamp: {
            required: false,
            serializedName: 'ClaimedUtcTimestamp',
            type: {
              name: 'DateTime'
            }
          },
          preparingUtcTimestamp: {
            required: false,
            serializedName: 'PreparingUtcTimestamp',
            type: {
              name: 'DateTime'
            }
          },
          approvedUtcTimestamp: {
            required: false,
            serializedName: 'ApprovedUtcTimestamp',
            type: {
              name: 'DateTime'
            }
          },
          executingUtcTimestamp: {
            required: false,
            serializedName: 'ExecutingUtcTimestamp',
            type: {
              name: 'DateTime'
            }
          },
          restoringUtcTimestamp: {
            required: false,
            serializedName: 'RestoringUtcTimestamp',
            type: {
              name: 'DateTime'
            }
          },
          completedUtcTimestamp: {
            required: false,
            serializedName: 'CompletedUtcTimestamp',
            type: {
              name: 'DateTime'
            }
          },
          preparingHealthCheckStartUtcTimestamp: {
            required: false,
            serializedName: 'PreparingHealthCheckStartUtcTimestamp',
            type: {
              name: 'DateTime'
            }
          },
          preparingHealthCheckEndUtcTimestamp: {
            required: false,
            serializedName: 'PreparingHealthCheckEndUtcTimestamp',
            type: {
              name: 'DateTime'
            }
          },
          restoringHealthCheckStartUtcTimestamp: {
            required: false,
            serializedName: 'RestoringHealthCheckStartUtcTimestamp',
            type: {
              name: 'DateTime'
            }
          },
          restoringHealthCheckEndUtcTimestamp: {
            required: false,
            serializedName: 'RestoringHealthCheckEndUtcTimestamp',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = RepairTaskHistory;
