/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Represents a base class for stateful service replica or stateless service
 * instance health state.
 *
 * @extends models['EntityHealthState']
 */
class ReplicaHealthState extends models['EntityHealthState'] {
  /**
   * Create a ReplicaHealthState.
   * @member {uuid} [partitionId]
   * @member {string} serviceKind Polymorphic Discriminator
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ReplicaHealthState
   *
   * @returns {object} metadata of ReplicaHealthState
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ReplicaHealthState',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'ServiceKind',
          clientName: 'serviceKind'
        },
        uberParent: 'EntityHealthState',
        className: 'ReplicaHealthState',
        modelProperties: {
          aggregatedHealthState: {
            required: false,
            serializedName: 'AggregatedHealthState',
            type: {
              name: 'String'
            }
          },
          partitionId: {
            required: false,
            serializedName: 'PartitionId',
            type: {
              name: 'String'
            }
          },
          serviceKind: {
            required: true,
            serializedName: 'ServiceKind',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ReplicaHealthState;
