/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Represents the health state chunk of a stateful service replica or a
 * stateless service instance.
 * The replica health state contains the replica ID and its aggregated health
 * state.
 *
 *
 * @extends models['EntityHealthStateChunk']
 */
class ReplicaHealthStateChunk extends models['EntityHealthStateChunk'] {
  /**
   * Create a ReplicaHealthStateChunk.
   * @member {string} [replicaOrInstanceId]
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ReplicaHealthStateChunk
   *
   * @returns {object} metadata of ReplicaHealthStateChunk
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ReplicaHealthStateChunk',
      type: {
        name: 'Composite',
        className: 'ReplicaHealthStateChunk',
        modelProperties: {
          healthState: {
            required: false,
            serializedName: 'HealthState',
            type: {
              name: 'String'
            }
          },
          replicaOrInstanceId: {
            required: false,
            serializedName: 'ReplicaOrInstanceId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ReplicaHealthStateChunk;
