/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The list of replica health state chunks that respect the input filters in
 * the chunk query. Returned by get cluster health state chunks query.
 *
 *
 */
class ReplicaHealthStateChunkList {
  /**
   * Create a ReplicaHealthStateChunkList.
   * @member {array} [items] The list of replica health state chunks that
   * respect the input filters in the chunk query.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ReplicaHealthStateChunkList
   *
   * @returns {object} metadata of ReplicaHealthStateChunkList
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ReplicaHealthStateChunkList',
      type: {
        name: 'Composite',
        className: 'ReplicaHealthStateChunkList',
        modelProperties: {
          items: {
            required: false,
            serializedName: 'Items',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ReplicaHealthStateChunkElementType',
                  type: {
                    name: 'Composite',
                    className: 'ReplicaHealthStateChunk'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ReplicaHealthStateChunkList;
