/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Information about the identity, status, health, node name, uptime, and other
 * details about the replica.
 *
 */
class ReplicaInfo {
  /**
   * Create a ReplicaInfo.
   * @member {string} [replicaStatus] Possible values include: 'Invalid',
   * 'InBuild', 'Standby', 'Ready', 'Down', 'Dropped'
   * @member {string} [healthState] Possible values include: 'Invalid', 'Ok',
   * 'Warning', 'Error', 'Unknown'
   * @member {string} [nodeName]
   * @member {string} [address] The address the replica is listening on.
   * @member {string} [lastInBuildDurationInSeconds] The last in build duration
   * of the replica in seconds.
   * @member {string} serviceKind Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of ReplicaInfo
   *
   * @returns {object} metadata of ReplicaInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ReplicaInfo',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'ServiceKind',
          clientName: 'serviceKind'
        },
        uberParent: 'ReplicaInfo',
        className: 'ReplicaInfo',
        modelProperties: {
          replicaStatus: {
            required: false,
            serializedName: 'ReplicaStatus',
            type: {
              name: 'String'
            }
          },
          healthState: {
            required: false,
            serializedName: 'HealthState',
            type: {
              name: 'String'
            }
          },
          nodeName: {
            required: false,
            serializedName: 'NodeName',
            type: {
              name: 'String'
            }
          },
          address: {
            required: false,
            serializedName: 'Address',
            type: {
              name: 'String'
            }
          },
          lastInBuildDurationInSeconds: {
            required: false,
            serializedName: 'LastInBuildDurationInSeconds',
            type: {
              name: 'String'
            }
          },
          serviceKind: {
            required: true,
            serializedName: 'ServiceKind',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ReplicaInfo;
