/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Endpoint of a resolved service partition.
 *
 */
class ResolvedServiceEndpoint {
  /**
   * Create a ResolvedServiceEndpoint.
   * @member {string} [kind] Possible values include: 'Invalid', 'Stateless',
   * 'StatefulPrimary', 'StatefulSecondary'
   * @member {string} [address] The address of the endpoint. If the endpoint
   * has multiple listeners the address is a JSON object with one property per
   * listener with the value as the address of that listener.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResolvedServiceEndpoint
   *
   * @returns {object} metadata of ResolvedServiceEndpoint
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResolvedServiceEndpoint',
      type: {
        name: 'Composite',
        className: 'ResolvedServiceEndpoint',
        modelProperties: {
          kind: {
            required: false,
            serializedName: 'Kind',
            type: {
              name: 'String'
            }
          },
          address: {
            required: false,
            serializedName: 'Address',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ResolvedServiceEndpoint;
