/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the parameters to restart a Service Fabric node.
 *
 */
class RestartNodeDescription {
  /**
   * Create a RestartNodeDescription.
   * @member {string} nodeInstanceId The instance id of the target node. If
   * instance id is specified the node is restarted only if it matches with the
   * current instance of the node. A default value of "0" would match any
   * instance id. The instance id can be obtained using get node query. Default
   * value: '0' .
   * @member {string} [createFabricDump] Specify True to create a dump of the
   * fabric node process. This is case sensitive. Possible values include:
   * 'False', 'True'. Default value: 'False' .
   */
  constructor() {
  }

  /**
   * Defines the metadata of RestartNodeDescription
   *
   * @returns {object} metadata of RestartNodeDescription
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RestartNodeDescription',
      type: {
        name: 'Composite',
        className: 'RestartNodeDescription',
        modelProperties: {
          nodeInstanceId: {
            required: true,
            serializedName: 'NodeInstanceId',
            defaultValue: '0',
            type: {
              name: 'String'
            }
          },
          createFabricDump: {
            required: false,
            serializedName: 'CreateFabricDump',
            defaultValue: 'False',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = RestartNodeDescription;
