/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents a safety check performed by service fabric before continuing with
 * the operations. These checks ensure the availability of the service and the
 * reliability of the state.
 *
 */
class SafetyCheck {
  /**
   * Create a SafetyCheck.
   * @member {string} kind Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of SafetyCheck
   *
   * @returns {object} metadata of SafetyCheck
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SafetyCheck',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'Kind',
          clientName: 'kind'
        },
        uberParent: 'SafetyCheck',
        className: 'SafetyCheck',
        modelProperties: {
          kind: {
            required: true,
            serializedName: 'Kind',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SafetyCheck;
