/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A wrapper for the safety check object. Safety checks are performed by
 * service fabric before continuing with the operations. These checks ensure
 * the availability of the service and the reliability of the state.
 *
 */
class SafetyCheckWrapper {
  /**
   * Create a SafetyCheckWrapper.
   * @member {object} [safetyCheck]
   * @member {string} [safetyCheck.kind] Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of SafetyCheckWrapper
   *
   * @returns {object} metadata of SafetyCheckWrapper
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SafetyCheckWrapper',
      type: {
        name: 'Composite',
        className: 'SafetyCheckWrapper',
        modelProperties: {
          safetyCheck: {
            required: false,
            serializedName: 'SafetyCheck',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'Kind',
                clientName: 'kind'
              },
              uberParent: 'SafetyCheck',
              className: 'SafetyCheck'
            }
          }
        }
      }
    };
  }
}

module.exports = SafetyCheckWrapper;
