/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Represents the health state of a service, which contains the service
 * identifier and its aggregated health state.
 *
 * @extends models['EntityHealthState']
 */
class ServiceHealthState extends models['EntityHealthState'] {
  /**
   * Create a ServiceHealthState.
   * @member {string} [serviceName]
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ServiceHealthState
   *
   * @returns {object} metadata of ServiceHealthState
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ServiceHealthState',
      type: {
        name: 'Composite',
        className: 'ServiceHealthState',
        modelProperties: {
          aggregatedHealthState: {
            required: false,
            serializedName: 'AggregatedHealthState',
            type: {
              name: 'String'
            }
          },
          serviceName: {
            required: false,
            serializedName: 'ServiceName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ServiceHealthState;
