/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Information about a stateful Service Fabric service.
 *
 * @extends models['ServiceInfo']
 */
class StatefulServiceInfo extends models['ServiceInfo'] {
  /**
   * Create a StatefulServiceInfo.
   * @member {boolean} [hasPersistedState] Whether the service has persisted
   * state.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of StatefulServiceInfo
   *
   * @returns {object} metadata of StatefulServiceInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Stateful',
      type: {
        name: 'Composite',
        className: 'StatefulServiceInfo',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'Id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'Name',
            type: {
              name: 'String'
            }
          },
          typeName: {
            required: false,
            serializedName: 'TypeName',
            type: {
              name: 'String'
            }
          },
          manifestVersion: {
            required: false,
            serializedName: 'ManifestVersion',
            type: {
              name: 'String'
            }
          },
          healthState: {
            required: false,
            serializedName: 'HealthState',
            type: {
              name: 'String'
            }
          },
          serviceStatus: {
            required: false,
            serializedName: 'ServiceStatus',
            type: {
              name: 'String'
            }
          },
          isServiceGroup: {
            required: false,
            serializedName: 'IsServiceGroup',
            type: {
              name: 'Boolean'
            }
          },
          serviceKind: {
            required: true,
            serializedName: 'ServiceKind',
            type: {
              name: 'String'
            }
          },
          hasPersistedState: {
            required: false,
            serializedName: 'HasPersistedState',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = StatefulServiceInfo;
