/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Describes a Chaos event that gets generated when an unexpected event occurs
 * in the Chaos engine.
 * For example, due to the cluster snapshot being inconsistent, while faulting
 * a faultable entity, Chaos found that the entity was alreay faulted -- which
 * would be an unexpected event.
 *
 *
 * @extends models['ChaosEvent']
 */
class TestErrorChaosEvent extends models['ChaosEvent'] {
  /**
   * Create a TestErrorChaosEvent.
   * @member {string} [reason]
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of TestErrorChaosEvent
   *
   * @returns {object} metadata of TestErrorChaosEvent
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TestError',
      type: {
        name: 'Composite',
        className: 'TestErrorChaosEvent',
        modelProperties: {
          timeStampUtc: {
            required: true,
            serializedName: 'TimeStampUtc',
            type: {
              name: 'DateTime'
            }
          },
          kind: {
            required: true,
            serializedName: 'Kind',
            type: {
              name: 'String'
            }
          },
          reason: {
            required: false,
            serializedName: 'Reason',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = TestErrorChaosEvent;
