/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Safety check that waits for the primary replica that was moved out of the
 * node due to upgrade to be placed back again on that node.
 *
 * @extends models['PartitionSafetyCheck']
 */
class WaitForPrimaryPlacementSafetyCheck extends models['PartitionSafetyCheck'] {
  /**
   * Create a WaitForPrimaryPlacementSafetyCheck.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of WaitForPrimaryPlacementSafetyCheck
   *
   * @returns {object} metadata of WaitForPrimaryPlacementSafetyCheck
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'WaitForPrimaryPlacement',
      type: {
        name: 'Composite',
        className: 'WaitForPrimaryPlacementSafetyCheck',
        modelProperties: {
          kind: {
            required: true,
            serializedName: 'Kind',
            type: {
              name: 'String'
            }
          },
          partitionId: {
            required: false,
            serializedName: 'PartitionId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = WaitForPrimaryPlacementSafetyCheck;
