/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Safety check that waits for the primary replica to be moved out of the node
 * before starting an upgrade to ensure the availability of the primary replica
 * for the partition.
 *
 * @extends models['PartitionSafetyCheck']
 */
class WaitForPrimarySwapSafetyCheck extends models['PartitionSafetyCheck'] {
  /**
   * Create a WaitForPrimarySwapSafetyCheck.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of WaitForPrimarySwapSafetyCheck
   *
   * @returns {object} metadata of WaitForPrimarySwapSafetyCheck
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'WaitForPrimarySwap',
      type: {
        name: 'Composite',
        className: 'WaitForPrimarySwapSafetyCheck',
        modelProperties: {
          kind: {
            required: true,
            serializedName: 'Kind',
            type: {
              name: 'String'
            }
          },
          partitionId: {
            required: false,
            serializedName: 'PartitionId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = WaitForPrimarySwapSafetyCheck;
