/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the Fish class.
 * @constructor
 * @member {string} [species]
 * 
 * @member {number} length
 * 
 * @member {array} [siblings]
 * 
 * @member {string} fishtype Polymorhpic Discriminator
 * 
 */
class Fish {
  constructor() { }

  /**
   * Defines the metadata of Fish
   *
   * @returns {object} metadata of Fish
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Fish',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'fish.type',
          clientName: 'fishtype'
        },
        uberParent: 'Fish',
        className: 'Fish',
        modelProperties: {
          species: {
            required: false,
            serializedName: 'species',
            type: {
              name: 'String'
            }
          },
          length: {
            required: true,
            serializedName: 'length',
            type: {
              name: 'Number'
            }
          },
          siblings: {
            required: false,
            serializedName: 'siblings',
            type: {
              name: 'Sequence',
              element: {
                required: false,
                serializedName: 'FishElementType',
                type: {
                  name: 'Composite',
                  polymorphicDiscriminator: {
                    serializedName: 'fish.type',
                    clientName: 'fishtype'
                  },
                  uberParent: 'Fish',
                  className: 'Fish'
                }
              }
            }
          },
          fishtype: {
            required: true,
            serializedName: 'fish\\.type',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Fish;
