/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the Sawshark class.
 * @constructor
 * @member {buffer} [picture]
 * 
 */
class Sawshark extends models['Shark'] {
  constructor() {
    super();
  }

  /**
   * Defines the metadata of Sawshark
   *
   * @returns {object} metadata of Sawshark
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'sawshark',
      type: {
        name: 'Composite',
        className: 'Sawshark',
        modelProperties: {
          species: {
            required: false,
            serializedName: 'species',
            type: {
              name: 'String'
            }
          },
          length: {
            required: true,
            serializedName: 'length',
            type: {
              name: 'Number'
            }
          },
          siblings: {
            required: false,
            serializedName: 'siblings',
            type: {
              name: 'Sequence',
              element: {
                required: false,
                serializedName: 'FishElementType',
                type: {
                  name: 'Composite',
                  polymorphicDiscriminator: {
                    serializedName: 'fish.type',
                    clientName: 'fishtype'
                  },
                  uberParent: 'Fish',
                  className: 'Fish'
                }
              }
            }
          },
          fishtype: {
            required: true,
            serializedName: 'fish\\.type',
            type: {
              name: 'String'
            }
          },
          age: {
            required: false,
            serializedName: 'age',
            type: {
              name: 'Number'
            }
          },
          birthday: {
            required: true,
            serializedName: 'birthday',
            type: {
              name: 'DateTime'
            }
          },
          picture: {
            required: false,
            serializedName: 'picture',
            type: {
              name: 'ByteArray'
            }
          }
        }
      }
    };
  }
}

module.exports = Sawshark;
